webpackJsonp([30],{

/***/ 1004:
/***/ (function(module, exports, __webpack_require__) {

var castPath = __webpack_require__(986),
    isArguments = __webpack_require__(223),
    isArray = __webpack_require__(51),
    isIndex = __webpack_require__(279),
    isLength = __webpack_require__(194),
    toKey = __webpack_require__(539);

/**
 * Checks if `path` exists on `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Array|string} path The path to check.
 * @param {Function} hasFunc The function to check properties.
 * @returns {boolean} Returns `true` if `path` exists, else `false`.
 */
function hasPath(object, path, hasFunc) {
  path = castPath(path, object);

  var index = -1,
      length = path.length,
      result = false;

  while (++index < length) {
    var key = toKey(path[index]);
    if (!(result = object != null && hasFunc(object, key))) {
      break;
    }
    object = object[key];
  }
  if (result || ++index != length) {
    return result;
  }
  length = object == null ? 0 : object.length;
  return !!length && isLength(length) && isIndex(key, length) &&
    (isArray(object) || isArguments(object));
}

module.exports = hasPath;


/***/ }),

/***/ 1005:
/***/ (function(module, exports, __webpack_require__) {

var isObject = __webpack_require__(98);

/** Built-in value references. */
var objectCreate = Object.create;

/**
 * The base implementation of `_.create` without support for assigning
 * properties to the created object.
 *
 * @private
 * @param {Object} proto The object to inherit from.
 * @returns {Object} Returns the new object.
 */
var baseCreate = (function() {
  function object() {}
  return function(proto) {
    if (!isObject(proto)) {
      return {};
    }
    if (objectCreate) {
      return objectCreate(proto);
    }
    object.prototype = proto;
    var result = new object;
    object.prototype = undefined;
    return result;
  };
}());

module.exports = baseCreate;


/***/ }),

/***/ 1497:
/***/ (function(module, exports, __webpack_require__) {

var baseGet = __webpack_require__(985);

/**
 * Gets the value at `path` of `object`. If the resolved value is
 * `undefined`, the `defaultValue` is returned in its place.
 *
 * @static
 * @memberOf _
 * @since 3.7.0
 * @category Object
 * @param {Object} object The object to query.
 * @param {Array|string} path The path of the property to get.
 * @param {*} [defaultValue] The value returned for `undefined` resolved values.
 * @returns {*} Returns the resolved value.
 * @example
 *
 * var object = { 'a': [{ 'b': { 'c': 3 } }] };
 *
 * _.get(object, 'a[0].b.c');
 * // => 3
 *
 * _.get(object, ['a', '0', 'b', 'c']);
 * // => 3
 *
 * _.get(object, 'a.b.c', 'default');
 * // => 'default'
 */
function get(object, path, defaultValue) {
  var result = object == null ? undefined : baseGet(object, path);
  return result === undefined ? defaultValue : result;
}

module.exports = get;


/***/ }),

/***/ 1505:
/***/ (function(module, exports, __webpack_require__) {

var arrayMap = __webpack_require__(316),
    baseIteratee = __webpack_require__(537),
    baseMap = __webpack_require__(1580),
    isArray = __webpack_require__(51);

/**
 * Creates an array of values by running each element in `collection` thru
 * `iteratee`. The iteratee is invoked with three arguments:
 * (value, index|key, collection).
 *
 * Many lodash methods are guarded to work as iteratees for methods like
 * `_.every`, `_.filter`, `_.map`, `_.mapValues`, `_.reject`, and `_.some`.
 *
 * The guarded methods are:
 * `ary`, `chunk`, `curry`, `curryRight`, `drop`, `dropRight`, `every`,
 * `fill`, `invert`, `parseInt`, `random`, `range`, `rangeRight`, `repeat`,
 * `sampleSize`, `slice`, `some`, `sortBy`, `split`, `take`, `takeRight`,
 * `template`, `trim`, `trimEnd`, `trimStart`, and `words`
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Collection
 * @param {Array|Object} collection The collection to iterate over.
 * @param {Function} [iteratee=_.identity] The function invoked per iteration.
 * @returns {Array} Returns the new mapped array.
 * @example
 *
 * function square(n) {
 *   return n * n;
 * }
 *
 * _.map([4, 8], square);
 * // => [16, 64]
 *
 * _.map({ 'a': 4, 'b': 8 }, square);
 * // => [16, 64] (iteration order is not guaranteed)
 *
 * var users = [
 *   { 'user': 'barney' },
 *   { 'user': 'fred' }
 * ];
 *
 * // The `_.property` iteratee shorthand.
 * _.map(users, 'user');
 * // => ['barney', 'fred']
 */
function map(collection, iteratee) {
  var func = isArray(collection) ? arrayMap : baseMap;
  return func(collection, baseIteratee(iteratee, 3));
}

module.exports = map;


/***/ }),

/***/ 1506:
/***/ (function(module, exports, __webpack_require__) {

var identity = __webpack_require__(546);

/**
 * Casts `value` to `identity` if it's not a function.
 *
 * @private
 * @param {*} value The value to inspect.
 * @returns {Function} Returns cast function.
 */
function castFunction(value) {
  return typeof value == 'function' ? value : identity;
}

module.exports = castFunction;


/***/ }),

/***/ 1517:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return flattenCollection; });
/* unused harmony export flattenCollections */
/* unused harmony export computeVisibility */
/* unused harmony export getParents */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return getNodePath; });
/* unused harmony export getAllToggleableNodes */
/**
 * Denormalize folder children
 * @param  {string} folderId          folder id
 * @param  {Array} options.requests   all requests in collection
 * @param  {Array} options.folders    all folders in collection
 * @return {Object}                   denormalized folder object
 */

/**
     * Denormalize request children
     * @param  {string} requestId         request id
     * @param  {Array} options.requests   all requests in collection
     * @return {Object}                   denormalized folder object
     */

/**
         * Denormalize node children
         * @param  {string} folderId          folder id
         * @param  {Array} options.requests   all requests in collection
         * @param  {Array} options.folders    all folders in collection
         * @return {Object}                   denormalized folder object
         */

/**
             * Denormalize collection children
             * @param  {object} collection collection in v1 format
             * @return {object}            denormalized collection
             */

/** =========================================================================**/
/*
                                                                                   FLATTENING UTILS
                                                                                  */

/**
                                                                                      * Deep flatten a node in denormalized collection
                                                                                      * @param  {Object} node node in denormalized collection tree
                                                                                      * @param  {number} depth depth of node (default: 0)
                                                                                      * @return {Array}       deep flattened node
                                                                                      */
// function flattenNode (node, depth) {
function flattenNode(flattened, node, depth, map) {
  // let flattenedNode = _.omit(node, ['children']),
  //     nodeDepth = depth || 0,
  //     flattenedChildren = _.flatMap(node.children, (childNode) => {
  //       return flattenNode(childNode, nodeDepth + 1);
  //     });

  // flattenedNode.endOffset = _.size(flattenedChildren);
  // flattenedNode.depth = nodeDepth;

  // // TODO: add parent and child offsets

  // return _.concat(flattenedNode, flattenedChildren);

  // console.log('flattening', node)

  if (!node) {
    return flattened;
  }

  // node.endOffset = _.size(node.folders_order) + _.size(node.order)
  flattened.push(node);

  _.each(node.folders_order, folderId => {
    let folder = _.find(map.folders, ['id', folderId]);
    if (folder) {
      folder.type = 'folder';
      folder.depth = depth + 1;
      flattenNode(flattened, folder, depth + 1, map);
    }
  });

  _.each(node.order, requestId => {
    let request = _.find(map.requests, ['id', requestId]);
    if (request) {
      request.type = 'request';
      request.depth = depth + 1;
      flattened.push(request);
    }
  });

  return flattened;
}

/**
   * marks all children as (in)visible
   * @param  {Array}  visibilityMap visibilityMap
   * @param  {Array}  flatTree      flattened tree
   * @param  {Array}  openNodes     ids of open items
   * @param  {number}  nodeIdx      index of node in flattened tree
   * @param  {Boolean} isVisible    boolean for flagging (in)visible
   * @param  {Boolean} deep         deep
   * @return {undefined}            no return value. visibilityMap is mutated
   */
function _markChildrenVisibility(visibilityMap, flatTree, openNodes, nodeIdx, isVisible, deep) {
  let node = flatTree[nodeIdx],
  idx = nodeIdx + 1,
  endIdx = _.findIndex(flatTree, n => {return n.depth <= node.depth;}, idx + 1); // nodeIdx + node.endOffset + 1;

  if (endIdx === -1) {
    endIdx = _.size(flatTree);
  }

  // if deep, mark the whole subtree
  if (deep) {
    while (idx < endIdx) {
      let itemNode = flatTree[idx];

      visibilityMap[idx] = isVisible;

      // fast forward to next subtree
      if (_isNodeToggleable(itemNode) && !_isNodeOpen(itemNode, openNodes)) {
        let endOffset = _.findIndex(flatTree, n => {return n.depth <= itemNode.depth;}, idx + 1);
        if (endOffset === -1) {
          endOffset = _.size(flatTree) - idx;
        }
        idx += endOffset; // itemNode.endOffset;
      }

      ++idx;
    }

    return;
  }

  let nodeDepth = node.depth,
  immediateChildDepth = nodeDepth + 1;

  // loop from immediate child to start of next subtree
  while (idx < endIdx) {
    let itemNode = flatTree[idx],
    itemNodeDepth = itemNode.depth;

    if (itemNodeDepth <= nodeDepth) {
      break;
    }

    if (itemNodeDepth === immediateChildDepth) {
      visibilityMap[idx] = isVisible;
    }

    ++idx;
  }

  return;
}

/**
  * marks all parents as (in)visible
  * @param  {Array}  visibilityMap visibilityMap
  * @param  {Array}  flatTree      flattened tree
  * @param  {number}  nodeIdx      index of node in flattened tree
  * @param  {Boolean} isVisible    boolean for flagging (in)visible
  * @return {undefined}            no return value. visibilityMap is mutated
   */
function _markParentVisibility(visibilityMap, flatTree, nodeIdx, isVisible) {
  let node = flatTree[nodeIdx],
  nodeDepth = node.depth,
  idx = nodeIdx - 1,
  parentDepth = nodeDepth - 1;

  while (idx > -1) {
    let tmpNode = flatTree[idx],
    tmpNodeDepth = tmpNode.depth;
    if (tmpNodeDepth <= parentDepth) {
      visibilityMap[idx] = isVisible;
      --parentDepth;
    }
    --idx;
  }
}

/**
   * get parent items
   * @param  {Array} flatTree flattened tree
   * @param  {Object} nodeIdx index in flattened tree
   * @return {Array}          array of parent nodes
   */
function getParents(flatTree, nodeIdx) {
  let node = flatTree[nodeIdx],
  nodeDepth = node.depth,
  parents = [],
  idx = nodeIdx - 1,
  parentDepth = nodeDepth - 1;

  while (idx > -1) {
    let tmpNode = flatTree[idx],
    tmpNodeDepth = tmpNode.depth;
    if (tmpNodeDepth <= parentDepth) {
      parents.push(flatTree[idx]);
      --parentDepth;
    }
    --idx;
  }

  return parents;
}

/**
   * Get path for the item
   * @param  {Array} flatTree flattened tree
   * @param  {Object} node    node
   * @return {string}         path
   */
function getNodePath(flatTree, node) {

  let nodeIdx = _.findIndex(flatTree, ['id', node.id]);

  if (nodeIdx === -1) {
    return '';
  }

  let parents = getParents(flatTree, nodeIdx),
  pathItems = _.concat([node], parents);


  return _.chain(pathItems).
  reverse().
  map('name').
  join(' / ').
  value();
}

/**
   * check if the node is open
   * @param  {Object}  node      node in flattened tree
   * @param  {Array}  openNodes  ids of open nodes
   * @return {Boolean}           whether node is open
   */
function _isNodeOpen(node, openNodes) {
  return openNodes.get(node.id);

  // return _.includes(openNodes, node.id);
}

/**
   * check if node is toggled
   * @param  {Object}  node node in flattened tree
   * @return {Boolean}      whether node is toggleable
   */
function _isNodeToggleable(node) {
  return _.includes(['collection', 'folder'], node.type);
}

/**
   * returns id of all toggleable nodes
   * @param  {Array} flatTree flattened tree
   * @return {Array}          ids of toggleable nodes
   */
function getAllToggleableNodes(flatTree) {
  return _.chain(flatTree).
  filter(_isNodeToggleable).
  map('id').
  value();
}

/**
   * computes visibility map
   * @param  {Array} flatCollection flattened collection
   * @param  {Array} openNodes      array of open node ids
   * @param  {string} filterQuery    search filter
   * @return {Array}                visibility map
   */
function computeVisibility(flatCollection, openNodes, filterQuery) {
  let visibilityMap = new Array(_.size(flatCollection));
  _.fill(visibilityMap, false);
  visibilityMap[0] = true;

  _.each(flatCollection, (node, index) => {
    if (_isNodeToggleable(node) && _isNodeOpen(node, openNodes)) {
      // find the next sibling
      let endIndex = _.findIndex(flatCollection, n => n.depth <= node.depth, index + 1);
      if (endIndex === -1) {
        endIndex = _.size(flatCollection);
      }

      visibilityMap[index] = true;
      _.each(new Array(endIndex - index), (n, i) => {
        if (flatCollection[index + i].depth === node.depth + 1) {
          visibilityMap[index + i] = true;
        }
      });
    }
  });

  return visibilityMap;
}

/**
   * computes visibility map
   * @param  {Array} flatCollection flattened collection
   * @param  {Array} openNodes      array of open node ids
   * @param  {string} filterQuery    search filter
   * @return {Array}                visibility map
   */
function _computeVisibilityQuery(flatCollection, openNodes, filterQuery) {
  let lowerFilterQuery = _.toLower(filterQuery),
  matchingNodes = new Array(_.size(flatCollection)),
  visibilityMap = new Array(_.size(flatCollection));

  _.fill(matchingNodes, false);
  _.fill(visibilityMap, false);

  _.forEach(flatCollection, (flatNode, itemIdx) => {
    let lowerItemName = _.toLower(flatNode.name);

    // if not matching, flag as not visible
    if (!_.includes(lowerItemName, lowerFilterQuery)) {
      return;
    }

    matchingNodes[itemIdx] = true;
  });

  let matchIdx = 0,
  endMatchIdx = matchingNodes.length;

  while (matchIdx < endMatchIdx) {
    if (!matchingNodes[matchIdx]) {
      ++matchIdx;
      continue; // eslint-disable-line no-continue
    }

    let matchNode = flatCollection[matchIdx];

    // mark node as visible
    visibilityMap[matchIdx] = true;

    // if toggleable node, deep mark subtree and fast forward
    if (_isNodeToggleable(matchNode) && _isNodeOpen(matchNode, openNodes)) {
      _markChildrenVisibility(visibilityMap, flatCollection, openNodes, matchIdx, true, true);
      matchIdx += matchNode.endOffset;
    }

    // mark parent chain
    _markParentVisibility(visibilityMap, flatCollection, matchIdx, true);

    ++matchIdx;
  }

  let idx = 0,
  length = flatCollection.length;

  while (idx < length) {
    let node = flatCollection[idx];

    if (_isNodeToggleable(node)) {
      // if toggleable node, and is not open, deep mark subtree and fast forward
      if (visibilityMap[idx] && !_isNodeOpen(node, openNodes)) {
        _markChildrenVisibility(visibilityMap, flatCollection, openNodes, idx, false, true);
        let endIdx = _.findIndex(flatCollection, n => {return n.depth <= node.depth;}, idx + 1);
        if (endIdx === -1) {
          endIdx = _.size(flatCollection) - idx;
        }
        idx += endIdx;
      }
    }

    ++idx;
  }

  return visibilityMap;
}

/**
   * Deep flattens a collection
   * @param  {Object} collection collection in v1 format
   * @return {Array}             flattened collection
   */
function flattenCollection(collection, folders = [], requests = []) {
  // let denormalized = denormalizeCollection(collection);
  // return flattenNode(denormalized);
  collection.type = 'collection';
  collection.depth = 0;
  return flattenNode([], collection, 0, { folders, requests });
}

/**
   * Flattens list of collections
   * @param  {Array} collections              Array of v1 collections
   * @param  {Array} options.openCollections  Array of ids of open collections
   * @param  {Array} options.openFolders      Array of ids of open folders
   * @return {Array}                          Flattened collections
   */
function flattenCollections(collections) {
  return _.chain(collections).
  sortBy(collection => {
    return collection.get('name');
  }).
  map(collection => {
    return flattenCollection(collection.toJSON());
  }).
  value();
}


/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 1518:
/***/ (function(module, exports, __webpack_require__) {

var arrayReduce = __webpack_require__(1584),
    baseEach = __webpack_require__(540),
    baseIteratee = __webpack_require__(537),
    baseReduce = __webpack_require__(1585),
    isArray = __webpack_require__(51);

/**
 * Reduces `collection` to a value which is the accumulated result of running
 * each element in `collection` thru `iteratee`, where each successive
 * invocation is supplied the return value of the previous. If `accumulator`
 * is not given, the first element of `collection` is used as the initial
 * value. The iteratee is invoked with four arguments:
 * (accumulator, value, index|key, collection).
 *
 * Many lodash methods are guarded to work as iteratees for methods like
 * `_.reduce`, `_.reduceRight`, and `_.transform`.
 *
 * The guarded methods are:
 * `assign`, `defaults`, `defaultsDeep`, `includes`, `merge`, `orderBy`,
 * and `sortBy`
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Collection
 * @param {Array|Object} collection The collection to iterate over.
 * @param {Function} [iteratee=_.identity] The function invoked per iteration.
 * @param {*} [accumulator] The initial value.
 * @returns {*} Returns the accumulated value.
 * @see _.reduceRight
 * @example
 *
 * _.reduce([1, 2], function(sum, n) {
 *   return sum + n;
 * }, 0);
 * // => 3
 *
 * _.reduce({ 'a': 1, 'b': 2, 'c': 1 }, function(result, value, key) {
 *   (result[value] || (result[value] = [])).push(key);
 *   return result;
 * }, {});
 * // => { '1': ['a', 'c'], '2': ['b'] } (iteration order is not guaranteed)
 */
function reduce(collection, iteratee, accumulator) {
  var func = isArray(collection) ? arrayReduce : baseReduce,
      initAccum = arguments.length < 3;

  return func(collection, baseIteratee(iteratee, 4), accumulator, initAccum, baseEach);
}

module.exports = reduce;


/***/ }),

/***/ 1519:
/***/ (function(module, exports, __webpack_require__) {

var baseGetTag = __webpack_require__(105),
    isArray = __webpack_require__(51),
    isObjectLike = __webpack_require__(84);

/** `Object#toString` result references. */
var stringTag = '[object String]';

/**
 * Checks if `value` is classified as a `String` primitive or object.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a string, else `false`.
 * @example
 *
 * _.isString('abc');
 * // => true
 *
 * _.isString(1);
 * // => false
 */
function isString(value) {
  return typeof value == 'string' ||
    (!isArray(value) && isObjectLike(value) && baseGetTag(value) == stringTag);
}

module.exports = isString;


/***/ }),

/***/ 1520:
/***/ (function(module, exports, __webpack_require__) {

var arrayEach = __webpack_require__(672),
    baseEach = __webpack_require__(540),
    castFunction = __webpack_require__(1506),
    isArray = __webpack_require__(51);

/**
 * Iterates over elements of `collection` and invokes `iteratee` for each element.
 * The iteratee is invoked with three arguments: (value, index|key, collection).
 * Iteratee functions may exit iteration early by explicitly returning `false`.
 *
 * **Note:** As with other "Collections" methods, objects with a "length"
 * property are iterated like arrays. To avoid this behavior use `_.forIn`
 * or `_.forOwn` for object iteration.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @alias each
 * @category Collection
 * @param {Array|Object} collection The collection to iterate over.
 * @param {Function} [iteratee=_.identity] The function invoked per iteration.
 * @returns {Array|Object} Returns `collection`.
 * @see _.forEachRight
 * @example
 *
 * _.forEach([1, 2], function(value) {
 *   console.log(value);
 * });
 * // => Logs `1` then `2`.
 *
 * _.forEach({ 'a': 1, 'b': 2 }, function(value, key) {
 *   console.log(key);
 * });
 * // => Logs 'a' then 'b' (iteration order is not guaranteed).
 */
function forEach(collection, iteratee) {
  var func = isArray(collection) ? arrayEach : baseEach;
  return func(collection, castFunction(iteratee));
}

module.exports = forEach;


/***/ }),

/***/ 1521:
/***/ (function(module, exports) {

/**
 * Copies the values of `source` to `array`.
 *
 * @private
 * @param {Array} source The array to copy values from.
 * @param {Array} [array=[]] The array to copy values to.
 * @returns {Array} Returns `array`.
 */
function copyArray(source, array) {
  var index = -1,
      length = source.length;

  array || (array = Array(length));
  while (++index < length) {
    array[index] = source[index];
  }
  return array;
}

module.exports = copyArray;


/***/ }),

/***/ 1522:
/***/ (function(module, exports, __webpack_require__) {

var baseEach = __webpack_require__(540);

/**
 * The base implementation of `_.filter` without support for iteratee shorthands.
 *
 * @private
 * @param {Array|Object} collection The collection to iterate over.
 * @param {Function} predicate The function invoked per iteration.
 * @returns {Array} Returns the new filtered array.
 */
function baseFilter(collection, predicate) {
  var result = [];
  baseEach(collection, function(value, index, collection) {
    if (predicate(value, index, collection)) {
      result.push(value);
    }
  });
  return result;
}

module.exports = baseFilter;


/***/ }),

/***/ 1549:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return Explorer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ExplorerRow__ = __webpack_require__(1550);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ExplorerSearch__ = __webpack_require__(1551);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ExplorerResults__ = __webpack_require__(1552);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__ExplorerCreateRow__ = __webpack_require__(1553);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_Icons_LeftSolidIcon__ = __webpack_require__(367);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__collections_CollectionForkLabel__ = __webpack_require__(656);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8_prop_types__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8_prop_types___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_8_prop_types__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__base_LoadingIndicator__ = __webpack_require__(71);
var _class;










let defaultSelection = {
  id: null,
  depth: -1 };let



Explorer = Object(__WEBPACK_IMPORTED_MODULE_5_mobx_react__["a" /* observer */])(_class = class Explorer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      targets: [],
      selected: defaultSelection,
      filter: '',
      isCreating: false };


    this.setTargets = this.setTargets.bind(this);
    this.setTargetsDebounced = _.debounce(this.setTargets, 300);
    this.isLeaf = this.isLeaf.bind(this);
    this.getNextTargets = this.getNextTargets.bind(this);
    this.setNextTargets = this.setNextTargets.bind(this);
    this.handleSelect = this.handleSelect.bind(this);
    this.handleBack = this.handleBack.bind(this);
    this.handleSearch = this.handleSearch.bind(this);
    this.handleCreate = this.handleCreate.bind(this);
    this.handleStartCreate = this.handleStartCreate.bind(this);
    this.handleCancelCreate = this.handleCancelCreate.bind(this);
  }

  componentWillMount() {
    this.setTargets();
  }

  componentWillReceiveProps(nextProps) {
    if (_.isEqual(this.props.targets, nextProps.targets)) {
      return;
    }

    // hackk implementation for new collection/folder added
    if (nextProps.newTargetId && this.props.newTargetId === undefined) {
      let selected = _.find(nextProps.targets, target => {
        return _.isEqual(target.id, nextProps.newTargetId);
      });

      this.props.onSelect && this.props.onSelect(selected);
      this.setState({ selected: selected });
      return this.setNextTargets(nextProps.targets, selected);
    }

    this.setNextTargets(nextProps.targets, this.state.selected);
  }

  /**
     * find parent of the currently selected parent when going back
     */
  getSelectionParent() {
    let selected = this.state.selected,
    targets = this.props.targets,
    selectedIndex = _.findIndex(targets, ['id', selected.id]);

    if (selectedIndex === -1) {
      return this.state.selected;
    }

    let parentIndex = _.chain(targets).
    slice(0, selectedIndex).
    findLastIndex(['depth', selected.depth - 1]).
    value();

    if (parentIndex === -1) {
      return defaultSelection;
    }

    return this.props.targets[parentIndex];
  }

  setTargets(targets = this.props.targets) {
    this.setNextTargets(targets);
  }

  isLeaf(targets, node) {
    if (this.props.isLeaf) {
      return this.props.isLeaf(node);
    } else
    {
      let nextTargets = this.getNextTargets(targets, node);
      return !_.size(nextTargets);
    }
  }

  /**
     * get the next list of collections/folders as per the selected collection/folder
     * @param {Array} currentTargets - list of flattened collections and folders
     * @param {Object} selectedTarget - selected collection/folder
     */
  getNextTargets(currentTargets, selectedTarget) {
    // find index of the selected target from the array of currentTargets
    let selectedTargetIndex = _.findIndex(currentTargets, ['id', selectedTarget.id]);

    // handle in case there is no selected collection(when we initially open the modal to save request)
    if (selectedTargetIndex === -1) {
      this.setState({ selected: defaultSelection });
      return currentTargets;
    }

    // find index of the next collection/folder at same depth as the selectedTarget
    let endIndex = _.findIndex(currentTargets, n => {return n.depth <= currentTargets[selectedTargetIndex].depth;}, selectedTargetIndex + 1);

    // handle in case there is no next collection/folder having same depth in the currentTargets
    if (endIndex === -1) {
      endIndex = _.size(currentTargets);
    }

    // return the list of selected target tree
    return _.slice(currentTargets, selectedTargetIndex + 1, endIndex);
  }

  /**
     * set the next list of collections/folders as per the selected collection/folder
     * @param {Array} currentTargets - list of flattened collections and folders
     * @param {Object} selectedTarget - selected collection/folder
     */
  setNextTargets(currentTargets, selectedTarget = defaultSelection) {
    let nextTargets = this.getNextTargets(currentTargets, selectedTarget);
    this.setState({ targets: nextTargets });
  }

  /**
     * get the next targets on select of any collection/folder
     * @param {Object} target
     * @param {*} isLeaf
     */

  handleSelect(target, isLeaf = false) {
    if (this.props.disableLeaves && isLeaf) {
      return;
    }
    let nextTargets = this.getNextTargets(this.props.targets, target);
    this.setState({
      selected: target,
      filter: '',
      targets: nextTargets });

    this.handleCancelCreate && this.handleCancelCreate();
    this.props.onSelect && this.props.onSelect(target);
  }

  /**
     * go back one level up in the directory tree,fetch the parent of the selected target along with the next targets
     */
  handleBack() {
    let selected = this.getSelectionParent(),
    nextTargets = this.getNextTargets(this.props.targets, selected);

    this.setState({
      selected,
      targets: nextTargets });

    this.handleCancelCreate && this.handleCancelCreate();
    _.invoke(this, 'props.onBack', selected);
  }

  /**
     * search results based on the filter value
     * @param  {string} filter - collection/folder searched
     */
  handleSearch(filter) {
    this.setState({ filter }, () => {
      this.props.onFilter && this.props.onFilter(filter);
    });
  }

  /**
     * start creating collection/folder
     */
  handleStartCreate() {
    // create new collection/folder if the searched filter named collection/folder does not exist
    if (!_.isEmpty(this.state.filter)) {
      this.handleCreate(this.state.filter);
      return;
    }
    this.setState({ isCreating: true });
  }

  handleCancelCreate() {
    this.setState({ isCreating: false });
  }

  /**
     * to create new collection/folder
     * @param {string} name - name of collection or folder created
     */
  handleCreate(name) {
    if (!_.isEmpty(name)) {
      this.setState({ isCreating: false, filter: '' });
      _.invoke(this.props, 'onCreate', name, this.state.selected);
    }
  }

  render() {
    const showLoadingIndicator = this.props.loading,
    showRows = !this.props.loading && _.isEmpty(this.state.filter);

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'explorer' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'explorer__header-wrapper' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__ExplorerSearch__["a" /* default */], {
            disabled: this.props.loading,
            filter: this.state.filter,
            onSearch: this.handleSearch }),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'explorer__header__create-wrapper' },

            _.isEqual(this.state.selected, defaultSelection) ?
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'explorer__header-title' },
              _.isEmpty(this.state.filter) ? 'All Collections' : 'Search Results') :

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
                className: 'explorer-pop-btn',
                onClick: this.handleBack },

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Icons_LeftSolidIcon__["a" /* default */], { className: 'explorer-pop-btn__icon' }),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'explorer-pop-btn__text' },
                this.state.selected.name),

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'explorer-pop-btn__meta' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__collections_CollectionForkLabel__["a" /* default */], { forkInfo: _.get(this.state.selected, 'forkInfo') }))),




            !this.props.disableCreate &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
                className: 'explorer__header-create-btn',
                onClick: this.handleStartCreate },

              this.props.createText && this.props.createText(this.state.selected)))),





        this.state.isCreating &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__ExplorerCreateRow__["a" /* default */], {
          placeholder: _.invoke(this.props, 'createPlaceholder', this.state.selected),
          onCancel: this.handleCancelCreate,
          onCreate: this.handleCreate }),



        showLoadingIndicator &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_9__base_LoadingIndicator__["a" /* default */], null),


        showRows &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'explorer-rows' },

          _.map(this.state.targets, (target, index) => {
            let isLeaf = this.isLeaf(this.state.targets, target);

            return target.depth === this.state.selected.depth + 1 && (
            !this.props.hideLeaves || !isLeaf) &&
            !(this.props.hideNodes && this.props.hideNodes(target)) &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__ExplorerRow__["a" /* default */], {
              disableLeaves: this.props.disableLeaves,
              filter: this.state.filter,
              isLeaf: isLeaf,
              key: index,
              leafIcon: this.props.leafIcon,
              target: target,
              onSelect: this.handleSelect });


          })),




        !_.isEmpty(this.state.filter) &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__ExplorerResults__["a" /* default */], {
          filter: this.state.filter,
          allTargets: this.props.targets,
          isLeaf: this.props.isLeaf,
          onSelect: this.handleSelect })));




  }}) || _class;


Explorer.propTypes = {
  createPlaceholder: __WEBPACK_IMPORTED_MODULE_8_prop_types___default.a.func,
  createText: __WEBPACK_IMPORTED_MODULE_8_prop_types___default.a.func, // The callback function that will be called to render the first row in every view
  disableCreate: __WEBPACK_IMPORTED_MODULE_8_prop_types___default.a.bool,
  disableLeaves: __WEBPACK_IMPORTED_MODULE_8_prop_types___default.a.bool, // Indicates if leaves will be shown
  hideLeaves: __WEBPACK_IMPORTED_MODULE_8_prop_types___default.a.bool,
  hideNodes: __WEBPACK_IMPORTED_MODULE_8_prop_types___default.a.func, // The callback function that will be called so you can hide specific nodes if needed
  isLeaf: __WEBPACK_IMPORTED_MODULE_8_prop_types___default.a.func, // The callback function that will be called to check if a node is a leaf
  leafIcon: __WEBPACK_IMPORTED_MODULE_8_prop_types___default.a.func, // The callback called to render the leaf icon
  onBack: __WEBPACK_IMPORTED_MODULE_8_prop_types___default.a.func,
  onCreate: __WEBPACK_IMPORTED_MODULE_8_prop_types___default.a.func,
  onFilter: __WEBPACK_IMPORTED_MODULE_8_prop_types___default.a.func,
  onSelect: __WEBPACK_IMPORTED_MODULE_8_prop_types___default.a.func,
  targets: __WEBPACK_IMPORTED_MODULE_8_prop_types___default.a.array,
  loading: __WEBPACK_IMPORTED_MODULE_8_prop_types___default.a.bool };


Explorer.defaultProps = {
  disableLeaves: false,
  loading: false };
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 1550:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ExplorerRow; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Icons_CollectionIcon__ = __webpack_require__(958);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Icons_RightSolidIcon__ = __webpack_require__(175);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_prop_types__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_prop_types___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_prop_types__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__collections_CollectionMetaIcons__ = __webpack_require__(1492);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__collections_CollectionForkLabel__ = __webpack_require__(656);






let

ExplorerRow = class ExplorerRow extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.getClasses = this.getClasses.bind(this);
    this.handleSelect = this.handleSelect.bind(this);
  }

  getClasses(target) {
    return __WEBPACK_IMPORTED_MODULE_1_classnames___default()({
      'explorer-row': true,
      'is-selected': target.id === _.get(this, 'props.selected.id'),
      'is-disabled': this.props.leafIcon && this.props.isLeaf },
    this.props.className);
  }

  /**
     * select a collection/folder
     * @param {Object} target
     */
  handleSelect(target, e) {
    e && e.stopPropagation();
    e && e.preventDefault();

    !this.props.isLeaf && _.invoke(this, 'props.onSelect', target, this.props.isLeaf);
  }

  render() {
    let { target } = this.props;

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
          className: this.getClasses(target),
          onClick: this.handleSelect.bind(this, target) },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'explorer-row__icon' },

          this.props.isLeaf && _.isFunction(this.props.leafIcon) ?
          this.props.leafIcon(target) :
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Icons_CollectionIcon__["a" /* default */], { className: 'explorer-row__icon-icon' })),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'explorer-row__name' },
          target.name),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'explorer-row__icons' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__collections_CollectionMetaIcons__["a" /* default */], { collection: target })),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'explorer-row__meta' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__collections_CollectionForkLabel__["a" /* default */], { forkInfo: _.get(target, 'forkInfo') })),


        !this.props.isLeaf &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Icons_RightSolidIcon__["a" /* default */], { className: 'explorer-row__forward' })));



  }};


ExplorerRow.propTypes = {
  depth: __WEBPACK_IMPORTED_MODULE_4_prop_types___default.a.number,
  filter: __WEBPACK_IMPORTED_MODULE_4_prop_types___default.a.string,
  isLeaf: __WEBPACK_IMPORTED_MODULE_4_prop_types___default.a.bool,
  onSelect: __WEBPACK_IMPORTED_MODULE_4_prop_types___default.a.func,
  selected: __WEBPACK_IMPORTED_MODULE_4_prop_types___default.a.object,
  target: __WEBPACK_IMPORTED_MODULE_4_prop_types___default.a.object };
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 1551:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ExplorerSearch; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_prop_types__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_prop_types___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_prop_types__);


let

ExplorerSearch = class ExplorerSearch extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'explorer-search' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Inputs__["b" /* Input */], {
          disabled: this.props.disabled,
          inputStyle: 'search',
          placeholder: 'Search for a collection or folder',
          query: this.props.filter,
          onChange: this.props.onSearch })));



  }};


ExplorerSearch.defaultProps = {
  disabled: false };


ExplorerSearch.propTypes = {
  filter: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.string.isRequired,
  onSearch: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.func.isRequired,
  disabled: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.bool };

/***/ }),

/***/ 1552:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ExplorerResults; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_prop_types__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_prop_types___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_prop_types__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_SearchHighlighter__ = __webpack_require__(541);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__utils_CollectionTreeUtil__ = __webpack_require__(1517);




let

ExplorerResults = class ExplorerResults extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = { filteredItems: this.filterTargets(props.allTargets, props.filter) };

    this.filterTargets = this.filterTargets.bind(this);
    this.getPath = this.getPath.bind(this);
    this.handleSelect = this.handleSelect.bind(this);
    this.setFilteredItems = this.setFilteredItems.bind(this);
    this.setFilteredItemsDebounced = _.debounce(this.setFilteredItems, 300, {
      leading: false,
      trailing: true });

  }

  componentWillReceiveProps(nextProps) {
    this.setFilteredItemsDebounced(nextProps);
  }

  getHighlightClasses(text) {
    return __WEBPACK_IMPORTED_MODULE_2_classnames___default()({ 'highlight': text.isHighlight });
  }

  filterTargets(targets = this.props.allTargets, filter = this.props.filter) {
    return _.filter(targets, target => {
      if (_.isFunction(this.props.isLeaf)) {
        return !this.props.isLeaf(target) && _.includes(_.toLower(target.name), _.toLower(filter));
      }
      return _.includes(_.toLower(target.name), _.toLower(filter));
    });
  }

  setFilteredItems(nextProps) {
    this.setState({ filteredItems: this.filterTargets(nextProps.allTargets, nextProps.filter) });
  }

  getPath(target, itemToFind) {
    return Object(__WEBPACK_IMPORTED_MODULE_4__utils_CollectionTreeUtil__["b" /* getNodePath */])(target, itemToFind);
  }

  handleSelect(item) {
    _.invoke(this, 'props.onSelect', item);
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'explorer-results' },

        _.map(this.state.filteredItems, (target, index) => {
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
                className: 'explorer-row explorer-result',
                key: index,
                onClick: this.handleSelect.bind(this, target) },

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'explorer-row__icon' }),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'explorer-row__content' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'explorer-row__name' },
                  target.name),

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'explorer-result__path' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_SearchHighlighter__["a" /* default */], {
                    source: this.getPath(this.props.allTargets, target),
                    query: this.props.filter })))));





        })));



  }};



ExplorerResults.propTypes = {
  filter: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.string,
  onSelect: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.func,
  targets: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.array };
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 1553:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ExplorerCreateRow; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_prop_types__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_prop_types___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_prop_types__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Icons_SuccessIcon__ = __webpack_require__(312);



let

ExplorerCreateRow = class ExplorerCreateRow extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = { name: '' };

    this.handleCreate = this.handleCreate.bind(this);
    this.handleCancel = this.handleCancel.bind(this);
    this.handleChange = this.handleChange.bind(this);
  }

  componentDidMount() {
    this.refs.input && this.refs.input.focus();
  }

  handleCreate(e) {
    e && e.preventDefault();
    e && e.stopPropagation();
    this.props.onCreate(this.state.name);
  }

  handleCancel(e) {
    this.setState({ name: '' });
    this.props.onCancel && this.props.onCancel();
  }

  handleChange(value) {
    this.setState({ name: value });
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
          className: 'explorer-create-row' },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'explorer-row__icon' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'explorer-row__icon-icon' })),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Inputs__["b" /* Input */], {
          className: 'explorer-row__create',
          inputStyle: 'search',
          hideSearchGlass: true,
          placeholder: this.props.placeholder,
          ref: 'input',
          query: this.state.name,
          onCancel: this.handleCancel,
          onChange: this.handleChange,
          onSubmit: this.handleCreate,
          onEnter: this.handleCreate }),

        !_.isEmpty(_.isString(this.state.name) && this.state.name.trim()) &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
            className: 'explorer-row__save',
            onClick: this.handleCreate },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Icons_SuccessIcon__["a" /* default */], {
            className: 'explorer-row__save-icon',
            style: 'primary' }))));





  }};


ExplorerCreateRow.propTypes = {
  onCancel: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.func,
  onCreate: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.func.isRequired,
  placeholder: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.string.isRequired };
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 1554:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__util__ = __webpack_require__(19);
let

SyncIssueHelper = class SyncIssueHelper {
  sanitizedChangeSet(reason, changeset) {
    var dataSize = __WEBPACK_IMPORTED_MODULE_0__util__["a" /* default */].lengthInUtf8Bytes(changeset.data),
    res = _.get(changeset, 'res', {});

    if (reason === 'timeout') {
      res.error = { name: 'timeout' };
    } else
    if (!_.get(res, 'error')) {
      res.error = { name: reason };
    }

    return _.assign({}, changeset, {
      dataSize: __WEBPACK_IMPORTED_MODULE_0__util__["a" /* default */].formatSize(dataSize),
      res: res });

  }

  constructLogToAnalytics(changeset) {
    let log = {
      entity: changeset.entity,
      entity_id: _.get(changeset, 'res.model_id') || _.get(changeset, 'res.data.id'),
      timestamp: new Date().toISOString(),
      action: changeset.verb,
      error: changeset.res.error,
      requestSize: changeset.dataSize };


    // special handling for unnamed errors
    if (_.get(log, 'error.name') === 'error') {
      log.response = changeset.res;
    }

    return log;
  }};


/* harmony default export */ __webpack_exports__["a"] = (new SyncIssueHelper());
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 1555:
/***/ (function(module, exports, __webpack_require__) {

var memoizeCapped = __webpack_require__(1556);

/** Used to match property names within property paths. */
var rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;

/** Used to match backslashes in property paths. */
var reEscapeChar = /\\(\\)?/g;

/**
 * Converts `string` to a property path array.
 *
 * @private
 * @param {string} string The string to convert.
 * @returns {Array} Returns the property path array.
 */
var stringToPath = memoizeCapped(function(string) {
  var result = [];
  if (string.charCodeAt(0) === 46 /* . */) {
    result.push('');
  }
  string.replace(rePropName, function(match, number, quote, subString) {
    result.push(quote ? subString.replace(reEscapeChar, '$1') : (number || match));
  });
  return result;
});

module.exports = stringToPath;


/***/ }),

/***/ 1556:
/***/ (function(module, exports, __webpack_require__) {

var memoize = __webpack_require__(1017);

/** Used as the maximum memoize cache size. */
var MAX_MEMOIZE_SIZE = 500;

/**
 * A specialized version of `_.memoize` which clears the memoized function's
 * cache when it exceeds `MAX_MEMOIZE_SIZE`.
 *
 * @private
 * @param {Function} func The function to have its output memoized.
 * @returns {Function} Returns the new memoized function.
 */
function memoizeCapped(func) {
  var result = memoize(func, function(key) {
    if (cache.size === MAX_MEMOIZE_SIZE) {
      cache.clear();
    }
    return key;
  });

  var cache = result.cache;
  return result;
}

module.exports = memoizeCapped;


/***/ }),

/***/ 1557:
/***/ (function(module, exports, __webpack_require__) {

var baseToString = __webpack_require__(1558);

/**
 * Converts `value` to a string. An empty string is returned for `null`
 * and `undefined` values. The sign of `-0` is preserved.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to convert.
 * @returns {string} Returns the converted string.
 * @example
 *
 * _.toString(null);
 * // => ''
 *
 * _.toString(-0);
 * // => '-0'
 *
 * _.toString([1, 2, 3]);
 * // => '1,2,3'
 */
function toString(value) {
  return value == null ? '' : baseToString(value);
}

module.exports = toString;


/***/ }),

/***/ 1558:
/***/ (function(module, exports, __webpack_require__) {

var Symbol = __webpack_require__(138),
    arrayMap = __webpack_require__(316),
    isArray = __webpack_require__(51),
    isSymbol = __webpack_require__(660);

/** Used as references for various `Number` constants. */
var INFINITY = 1 / 0;

/** Used to convert symbols to primitives and strings. */
var symbolProto = Symbol ? Symbol.prototype : undefined,
    symbolToString = symbolProto ? symbolProto.toString : undefined;

/**
 * The base implementation of `_.toString` which doesn't convert nullish
 * values to empty strings.
 *
 * @private
 * @param {*} value The value to process.
 * @returns {string} Returns the string.
 */
function baseToString(value) {
  // Exit early for strings to avoid a performance hit in some environments.
  if (typeof value == 'string') {
    return value;
  }
  if (isArray(value)) {
    // Recursively convert values (susceptible to call stack limits).
    return arrayMap(value, baseToString) + '';
  }
  if (isSymbol(value)) {
    return symbolToString ? symbolToString.call(value) : '';
  }
  var result = (value + '');
  return (result == '0' && (1 / value) == -INFINITY) ? '-0' : result;
}

module.exports = baseToString;


/***/ }),

/***/ 1559:
/***/ (function(module, exports, __webpack_require__) {

var baseIsMatch = __webpack_require__(1560),
    getMatchData = __webpack_require__(1574),
    matchesStrictComparable = __webpack_require__(993);

/**
 * The base implementation of `_.matches` which doesn't clone `source`.
 *
 * @private
 * @param {Object} source The object of property values to match.
 * @returns {Function} Returns the new spec function.
 */
function baseMatches(source) {
  var matchData = getMatchData(source);
  if (matchData.length == 1 && matchData[0][2]) {
    return matchesStrictComparable(matchData[0][0], matchData[0][1]);
  }
  return function(object) {
    return object === source || baseIsMatch(object, source, matchData);
  };
}

module.exports = baseMatches;


/***/ }),

/***/ 1560:
/***/ (function(module, exports, __webpack_require__) {

var Stack = __webpack_require__(665),
    baseIsEqual = __webpack_require__(976);

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG = 1,
    COMPARE_UNORDERED_FLAG = 2;

/**
 * The base implementation of `_.isMatch` without support for iteratee shorthands.
 *
 * @private
 * @param {Object} object The object to inspect.
 * @param {Object} source The object of property values to match.
 * @param {Array} matchData The property names, values, and compare flags to match.
 * @param {Function} [customizer] The function to customize comparisons.
 * @returns {boolean} Returns `true` if `object` is a match, else `false`.
 */
function baseIsMatch(object, source, matchData, customizer) {
  var index = matchData.length,
      length = index,
      noCustomizer = !customizer;

  if (object == null) {
    return !length;
  }
  object = Object(object);
  while (index--) {
    var data = matchData[index];
    if ((noCustomizer && data[2])
          ? data[1] !== object[data[0]]
          : !(data[0] in object)
        ) {
      return false;
    }
  }
  while (++index < length) {
    data = matchData[index];
    var key = data[0],
        objValue = object[key],
        srcValue = data[1];

    if (noCustomizer && data[2]) {
      if (objValue === undefined && !(key in object)) {
        return false;
      }
    } else {
      var stack = new Stack;
      if (customizer) {
        var result = customizer(objValue, srcValue, key, object, source, stack);
      }
      if (!(result === undefined
            ? baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG, customizer, stack)
            : result
          )) {
        return false;
      }
    }
  }
  return true;
}

module.exports = baseIsMatch;


/***/ }),

/***/ 1561:
/***/ (function(module, exports, __webpack_require__) {

var ListCache = __webpack_require__(542);

/**
 * Removes all key-value entries from the stack.
 *
 * @private
 * @name clear
 * @memberOf Stack
 */
function stackClear() {
  this.__data__ = new ListCache;
  this.size = 0;
}

module.exports = stackClear;


/***/ }),

/***/ 1562:
/***/ (function(module, exports) {

/**
 * Removes `key` and its value from the stack.
 *
 * @private
 * @name delete
 * @memberOf Stack
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function stackDelete(key) {
  var data = this.__data__,
      result = data['delete'](key);

  this.size = data.size;
  return result;
}

module.exports = stackDelete;


/***/ }),

/***/ 1563:
/***/ (function(module, exports) {

/**
 * Gets the stack value for `key`.
 *
 * @private
 * @name get
 * @memberOf Stack
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function stackGet(key) {
  return this.__data__.get(key);
}

module.exports = stackGet;


/***/ }),

/***/ 1564:
/***/ (function(module, exports) {

/**
 * Checks if a stack value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf Stack
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function stackHas(key) {
  return this.__data__.has(key);
}

module.exports = stackHas;


/***/ }),

/***/ 1565:
/***/ (function(module, exports, __webpack_require__) {

var ListCache = __webpack_require__(542),
    Map = __webpack_require__(675),
    MapCache = __webpack_require__(691);

/** Used as the size to enable large array optimizations. */
var LARGE_ARRAY_SIZE = 200;

/**
 * Sets the stack `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf Stack
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the stack cache instance.
 */
function stackSet(key, value) {
  var data = this.__data__;
  if (data instanceof ListCache) {
    var pairs = data.__data__;
    if (!Map || (pairs.length < LARGE_ARRAY_SIZE - 1)) {
      pairs.push([key, value]);
      this.size = ++data.size;
      return this;
    }
    data = this.__data__ = new MapCache(pairs);
  }
  data.set(key, value);
  this.size = data.size;
  return this;
}

module.exports = stackSet;


/***/ }),

/***/ 1566:
/***/ (function(module, exports, __webpack_require__) {

var Stack = __webpack_require__(665),
    equalArrays = __webpack_require__(987),
    equalByTag = __webpack_require__(1568),
    equalObjects = __webpack_require__(1570),
    getTag = __webpack_require__(313),
    isArray = __webpack_require__(51),
    isBuffer = __webpack_require__(190),
    isTypedArray = __webpack_require__(224);

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG = 1;

/** `Object#toString` result references. */
var argsTag = '[object Arguments]',
    arrayTag = '[object Array]',
    objectTag = '[object Object]';

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * A specialized version of `baseIsEqual` for arrays and objects which performs
 * deep comparisons and tracks traversed objects enabling objects with circular
 * references to be compared.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} [stack] Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 */
function baseIsEqualDeep(object, other, bitmask, customizer, equalFunc, stack) {
  var objIsArr = isArray(object),
      othIsArr = isArray(other),
      objTag = objIsArr ? arrayTag : getTag(object),
      othTag = othIsArr ? arrayTag : getTag(other);

  objTag = objTag == argsTag ? objectTag : objTag;
  othTag = othTag == argsTag ? objectTag : othTag;

  var objIsObj = objTag == objectTag,
      othIsObj = othTag == objectTag,
      isSameTag = objTag == othTag;

  if (isSameTag && isBuffer(object)) {
    if (!isBuffer(other)) {
      return false;
    }
    objIsArr = true;
    objIsObj = false;
  }
  if (isSameTag && !objIsObj) {
    stack || (stack = new Stack);
    return (objIsArr || isTypedArray(object))
      ? equalArrays(object, other, bitmask, customizer, equalFunc, stack)
      : equalByTag(object, other, objTag, bitmask, customizer, equalFunc, stack);
  }
  if (!(bitmask & COMPARE_PARTIAL_FLAG)) {
    var objIsWrapped = objIsObj && hasOwnProperty.call(object, '__wrapped__'),
        othIsWrapped = othIsObj && hasOwnProperty.call(other, '__wrapped__');

    if (objIsWrapped || othIsWrapped) {
      var objUnwrapped = objIsWrapped ? object.value() : object,
          othUnwrapped = othIsWrapped ? other.value() : other;

      stack || (stack = new Stack);
      return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
    }
  }
  if (!isSameTag) {
    return false;
  }
  stack || (stack = new Stack);
  return equalObjects(object, other, bitmask, customizer, equalFunc, stack);
}

module.exports = baseIsEqualDeep;


/***/ }),

/***/ 1567:
/***/ (function(module, exports) {

/**
 * A specialized version of `_.some` for arrays without support for iteratee
 * shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} predicate The function invoked per iteration.
 * @returns {boolean} Returns `true` if any element passes the predicate check,
 *  else `false`.
 */
function arraySome(array, predicate) {
  var index = -1,
      length = array == null ? 0 : array.length;

  while (++index < length) {
    if (predicate(array[index], index, array)) {
      return true;
    }
  }
  return false;
}

module.exports = arraySome;


/***/ }),

/***/ 1568:
/***/ (function(module, exports, __webpack_require__) {

var Symbol = __webpack_require__(138),
    Uint8Array = __webpack_require__(988),
    eq = __webpack_require__(368),
    equalArrays = __webpack_require__(987),
    mapToArray = __webpack_require__(1569),
    setToArray = __webpack_require__(692);

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG = 1,
    COMPARE_UNORDERED_FLAG = 2;

/** `Object#toString` result references. */
var boolTag = '[object Boolean]',
    dateTag = '[object Date]',
    errorTag = '[object Error]',
    mapTag = '[object Map]',
    numberTag = '[object Number]',
    regexpTag = '[object RegExp]',
    setTag = '[object Set]',
    stringTag = '[object String]',
    symbolTag = '[object Symbol]';

var arrayBufferTag = '[object ArrayBuffer]',
    dataViewTag = '[object DataView]';

/** Used to convert symbols to primitives and strings. */
var symbolProto = Symbol ? Symbol.prototype : undefined,
    symbolValueOf = symbolProto ? symbolProto.valueOf : undefined;

/**
 * A specialized version of `baseIsEqualDeep` for comparing objects of
 * the same `toStringTag`.
 *
 * **Note:** This function only supports comparing values with tags of
 * `Boolean`, `Date`, `Error`, `Number`, `RegExp`, or `String`.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {string} tag The `toStringTag` of the objects to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} stack Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 */
function equalByTag(object, other, tag, bitmask, customizer, equalFunc, stack) {
  switch (tag) {
    case dataViewTag:
      if ((object.byteLength != other.byteLength) ||
          (object.byteOffset != other.byteOffset)) {
        return false;
      }
      object = object.buffer;
      other = other.buffer;

    case arrayBufferTag:
      if ((object.byteLength != other.byteLength) ||
          !equalFunc(new Uint8Array(object), new Uint8Array(other))) {
        return false;
      }
      return true;

    case boolTag:
    case dateTag:
    case numberTag:
      // Coerce booleans to `1` or `0` and dates to milliseconds.
      // Invalid dates are coerced to `NaN`.
      return eq(+object, +other);

    case errorTag:
      return object.name == other.name && object.message == other.message;

    case regexpTag:
    case stringTag:
      // Coerce regexes to strings and treat strings, primitives and objects,
      // as equal. See http://www.ecma-international.org/ecma-262/7.0/#sec-regexp.prototype.tostring
      // for more details.
      return object == (other + '');

    case mapTag:
      var convert = mapToArray;

    case setTag:
      var isPartial = bitmask & COMPARE_PARTIAL_FLAG;
      convert || (convert = setToArray);

      if (object.size != other.size && !isPartial) {
        return false;
      }
      // Assume cyclic values are equal.
      var stacked = stack.get(object);
      if (stacked) {
        return stacked == other;
      }
      bitmask |= COMPARE_UNORDERED_FLAG;

      // Recursively compare objects (susceptible to call stack limits).
      stack.set(object, other);
      var result = equalArrays(convert(object), convert(other), bitmask, customizer, equalFunc, stack);
      stack['delete'](object);
      return result;

    case symbolTag:
      if (symbolValueOf) {
        return symbolValueOf.call(object) == symbolValueOf.call(other);
      }
  }
  return false;
}

module.exports = equalByTag;


/***/ }),

/***/ 1569:
/***/ (function(module, exports) {

/**
 * Converts `map` to its key-value pairs.
 *
 * @private
 * @param {Object} map The map to convert.
 * @returns {Array} Returns the key-value pairs.
 */
function mapToArray(map) {
  var index = -1,
      result = Array(map.size);

  map.forEach(function(value, key) {
    result[++index] = [key, value];
  });
  return result;
}

module.exports = mapToArray;


/***/ }),

/***/ 1570:
/***/ (function(module, exports, __webpack_require__) {

var getAllKeys = __webpack_require__(989);

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG = 1;

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * A specialized version of `baseIsEqualDeep` for objects with support for
 * partial deep comparisons.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} stack Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 */
function equalObjects(object, other, bitmask, customizer, equalFunc, stack) {
  var isPartial = bitmask & COMPARE_PARTIAL_FLAG,
      objProps = getAllKeys(object),
      objLength = objProps.length,
      othProps = getAllKeys(other),
      othLength = othProps.length;

  if (objLength != othLength && !isPartial) {
    return false;
  }
  var index = objLength;
  while (index--) {
    var key = objProps[index];
    if (!(isPartial ? key in other : hasOwnProperty.call(other, key))) {
      return false;
    }
  }
  // Assume cyclic values are equal.
  var stacked = stack.get(object);
  if (stacked && stack.get(other)) {
    return stacked == other;
  }
  var result = true;
  stack.set(object, other);
  stack.set(other, object);

  var skipCtor = isPartial;
  while (++index < objLength) {
    key = objProps[index];
    var objValue = object[key],
        othValue = other[key];

    if (customizer) {
      var compared = isPartial
        ? customizer(othValue, objValue, key, other, object, stack)
        : customizer(objValue, othValue, key, object, other, stack);
    }
    // Recursively compare objects (susceptible to call stack limits).
    if (!(compared === undefined
          ? (objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack))
          : compared
        )) {
      result = false;
      break;
    }
    skipCtor || (skipCtor = key == 'constructor');
  }
  if (result && !skipCtor) {
    var objCtor = object.constructor,
        othCtor = other.constructor;

    // Non `Object` object instances with different constructors are not equal.
    if (objCtor != othCtor &&
        ('constructor' in object && 'constructor' in other) &&
        !(typeof objCtor == 'function' && objCtor instanceof objCtor &&
          typeof othCtor == 'function' && othCtor instanceof othCtor)) {
      result = false;
    }
  }
  stack['delete'](object);
  stack['delete'](other);
  return result;
}

module.exports = equalObjects;


/***/ }),

/***/ 1571:
/***/ (function(module, exports, __webpack_require__) {

var getNative = __webpack_require__(274),
    root = __webpack_require__(97);

/* Built-in method references that are verified to be native. */
var DataView = getNative(root, 'DataView');

module.exports = DataView;


/***/ }),

/***/ 1572:
/***/ (function(module, exports, __webpack_require__) {

var getNative = __webpack_require__(274),
    root = __webpack_require__(97);

/* Built-in method references that are verified to be native. */
var Promise = getNative(root, 'Promise');

module.exports = Promise;


/***/ }),

/***/ 1573:
/***/ (function(module, exports, __webpack_require__) {

var getNative = __webpack_require__(274),
    root = __webpack_require__(97);

/* Built-in method references that are verified to be native. */
var WeakMap = getNative(root, 'WeakMap');

module.exports = WeakMap;


/***/ }),

/***/ 1574:
/***/ (function(module, exports, __webpack_require__) {

var isStrictComparable = __webpack_require__(992),
    keys = __webpack_require__(135);

/**
 * Gets the property names, values, and compare flags of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the match data of `object`.
 */
function getMatchData(object) {
  var result = keys(object),
      length = result.length;

  while (length--) {
    var key = result[length],
        value = object[key];

    result[length] = [key, value, isStrictComparable(value)];
  }
  return result;
}

module.exports = getMatchData;


/***/ }),

/***/ 1575:
/***/ (function(module, exports, __webpack_require__) {

var baseIsEqual = __webpack_require__(976),
    get = __webpack_require__(1497),
    hasIn = __webpack_require__(1576),
    isKey = __webpack_require__(664),
    isStrictComparable = __webpack_require__(992),
    matchesStrictComparable = __webpack_require__(993),
    toKey = __webpack_require__(539);

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG = 1,
    COMPARE_UNORDERED_FLAG = 2;

/**
 * The base implementation of `_.matchesProperty` which doesn't clone `srcValue`.
 *
 * @private
 * @param {string} path The path of the property to get.
 * @param {*} srcValue The value to match.
 * @returns {Function} Returns the new spec function.
 */
function baseMatchesProperty(path, srcValue) {
  if (isKey(path) && isStrictComparable(srcValue)) {
    return matchesStrictComparable(toKey(path), srcValue);
  }
  return function(object) {
    var objValue = get(object, path);
    return (objValue === undefined && objValue === srcValue)
      ? hasIn(object, path)
      : baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG);
  };
}

module.exports = baseMatchesProperty;


/***/ }),

/***/ 1576:
/***/ (function(module, exports, __webpack_require__) {

var baseHasIn = __webpack_require__(1577),
    hasPath = __webpack_require__(1004);

/**
 * Checks if `path` is a direct or inherited property of `object`.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Object
 * @param {Object} object The object to query.
 * @param {Array|string} path The path to check.
 * @returns {boolean} Returns `true` if `path` exists, else `false`.
 * @example
 *
 * var object = _.create({ 'a': _.create({ 'b': 2 }) });
 *
 * _.hasIn(object, 'a');
 * // => true
 *
 * _.hasIn(object, 'a.b');
 * // => true
 *
 * _.hasIn(object, ['a', 'b']);
 * // => true
 *
 * _.hasIn(object, 'b');
 * // => false
 */
function hasIn(object, path) {
  return object != null && hasPath(object, path, baseHasIn);
}

module.exports = hasIn;


/***/ }),

/***/ 1577:
/***/ (function(module, exports) {

/**
 * The base implementation of `_.hasIn` without support for deep paths.
 *
 * @private
 * @param {Object} [object] The object to query.
 * @param {Array|string} key The key to check.
 * @returns {boolean} Returns `true` if `key` exists, else `false`.
 */
function baseHasIn(object, key) {
  return object != null && key in Object(object);
}

module.exports = baseHasIn;


/***/ }),

/***/ 1578:
/***/ (function(module, exports, __webpack_require__) {

var baseProperty = __webpack_require__(994),
    basePropertyDeep = __webpack_require__(1579),
    isKey = __webpack_require__(664),
    toKey = __webpack_require__(539);

/**
 * Creates a function that returns the value at `path` of a given object.
 *
 * @static
 * @memberOf _
 * @since 2.4.0
 * @category Util
 * @param {Array|string} path The path of the property to get.
 * @returns {Function} Returns the new accessor function.
 * @example
 *
 * var objects = [
 *   { 'a': { 'b': 2 } },
 *   { 'a': { 'b': 1 } }
 * ];
 *
 * _.map(objects, _.property('a.b'));
 * // => [2, 1]
 *
 * _.map(_.sortBy(objects, _.property(['a', 'b'])), 'a.b');
 * // => [1, 2]
 */
function property(path) {
  return isKey(path) ? baseProperty(toKey(path)) : basePropertyDeep(path);
}

module.exports = property;


/***/ }),

/***/ 1579:
/***/ (function(module, exports, __webpack_require__) {

var baseGet = __webpack_require__(985);

/**
 * A specialized version of `baseProperty` which supports deep paths.
 *
 * @private
 * @param {Array|string} path The path of the property to get.
 * @returns {Function} Returns the new accessor function.
 */
function basePropertyDeep(path) {
  return function(object) {
    return baseGet(object, path);
  };
}

module.exports = basePropertyDeep;


/***/ }),

/***/ 1580:
/***/ (function(module, exports, __webpack_require__) {

var baseEach = __webpack_require__(540),
    isArrayLike = __webpack_require__(67);

/**
 * The base implementation of `_.map` without support for iteratee shorthands.
 *
 * @private
 * @param {Array|Object} collection The collection to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns the new mapped array.
 */
function baseMap(collection, iteratee) {
  var index = -1,
      result = isArrayLike(collection) ? Array(collection.length) : [];

  baseEach(collection, function(value, key, collection) {
    result[++index] = iteratee(value, key, collection);
  });
  return result;
}

module.exports = baseMap;


/***/ }),

/***/ 1581:
/***/ (function(module, exports, __webpack_require__) {

var createBaseFor = __webpack_require__(1582);

/**
 * The base implementation of `baseForOwn` which iterates over `object`
 * properties returned by `keysFunc` and invokes `iteratee` for each property.
 * Iteratee functions may exit iteration early by explicitly returning `false`.
 *
 * @private
 * @param {Object} object The object to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @param {Function} keysFunc The function to get the keys of `object`.
 * @returns {Object} Returns `object`.
 */
var baseFor = createBaseFor();

module.exports = baseFor;


/***/ }),

/***/ 1582:
/***/ (function(module, exports) {

/**
 * Creates a base function for methods like `_.forIn` and `_.forOwn`.
 *
 * @private
 * @param {boolean} [fromRight] Specify iterating from right to left.
 * @returns {Function} Returns the new base function.
 */
function createBaseFor(fromRight) {
  return function(object, iteratee, keysFunc) {
    var index = -1,
        iterable = Object(object),
        props = keysFunc(object),
        length = props.length;

    while (length--) {
      var key = props[fromRight ? length : ++index];
      if (iteratee(iterable[key], key, iterable) === false) {
        break;
      }
    }
    return object;
  };
}

module.exports = createBaseFor;


/***/ }),

/***/ 1583:
/***/ (function(module, exports, __webpack_require__) {

var isArrayLike = __webpack_require__(67);

/**
 * Creates a `baseEach` or `baseEachRight` function.
 *
 * @private
 * @param {Function} eachFunc The function to iterate over a collection.
 * @param {boolean} [fromRight] Specify iterating from right to left.
 * @returns {Function} Returns the new base function.
 */
function createBaseEach(eachFunc, fromRight) {
  return function(collection, iteratee) {
    if (collection == null) {
      return collection;
    }
    if (!isArrayLike(collection)) {
      return eachFunc(collection, iteratee);
    }
    var length = collection.length,
        index = fromRight ? length : -1,
        iterable = Object(collection);

    while ((fromRight ? index-- : ++index < length)) {
      if (iteratee(iterable[index], index, iterable) === false) {
        break;
      }
    }
    return collection;
  };
}

module.exports = createBaseEach;


/***/ }),

/***/ 1584:
/***/ (function(module, exports) {

/**
 * A specialized version of `_.reduce` for arrays without support for
 * iteratee shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @param {*} [accumulator] The initial value.
 * @param {boolean} [initAccum] Specify using the first element of `array` as
 *  the initial value.
 * @returns {*} Returns the accumulated value.
 */
function arrayReduce(array, iteratee, accumulator, initAccum) {
  var index = -1,
      length = array == null ? 0 : array.length;

  if (initAccum && length) {
    accumulator = array[++index];
  }
  while (++index < length) {
    accumulator = iteratee(accumulator, array[index], index, array);
  }
  return accumulator;
}

module.exports = arrayReduce;


/***/ }),

/***/ 1585:
/***/ (function(module, exports) {

/**
 * The base implementation of `_.reduce` and `_.reduceRight`, without support
 * for iteratee shorthands, which iterates over `collection` using `eachFunc`.
 *
 * @private
 * @param {Array|Object} collection The collection to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @param {*} accumulator The initial value.
 * @param {boolean} initAccum Specify using the first or last element of
 *  `collection` as the initial value.
 * @param {Function} eachFunc The function to iterate over `collection`.
 * @returns {*} Returns the accumulated value.
 */
function baseReduce(collection, iteratee, accumulator, initAccum, eachFunc) {
  eachFunc(collection, function(value, index, collection) {
    accumulator = initAccum
      ? (initAccum = false, value)
      : iteratee(accumulator, value, index, collection);
  });
  return accumulator;
}

module.exports = baseReduce;


/***/ }),

/***/ 1586:
/***/ (function(module, exports, __webpack_require__) {

var baseKeys = __webpack_require__(276),
    getTag = __webpack_require__(313),
    isArrayLike = __webpack_require__(67),
    isString = __webpack_require__(1519),
    stringSize = __webpack_require__(1587);

/** `Object#toString` result references. */
var mapTag = '[object Map]',
    setTag = '[object Set]';

/**
 * Gets the size of `collection` by returning its length for array-like
 * values or the number of own enumerable string keyed properties for objects.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Collection
 * @param {Array|Object|string} collection The collection to inspect.
 * @returns {number} Returns the collection size.
 * @example
 *
 * _.size([1, 2, 3]);
 * // => 3
 *
 * _.size({ 'a': 1, 'b': 2 });
 * // => 2
 *
 * _.size('pebbles');
 * // => 7
 */
function size(collection) {
  if (collection == null) {
    return 0;
  }
  if (isArrayLike(collection)) {
    return isString(collection) ? stringSize(collection) : collection.length;
  }
  var tag = getTag(collection);
  if (tag == mapTag || tag == setTag) {
    return collection.size;
  }
  return baseKeys(collection).length;
}

module.exports = size;


/***/ }),

/***/ 1587:
/***/ (function(module, exports, __webpack_require__) {

var asciiSize = __webpack_require__(1588),
    hasUnicode = __webpack_require__(1589),
    unicodeSize = __webpack_require__(1590);

/**
 * Gets the number of symbols in `string`.
 *
 * @private
 * @param {string} string The string to inspect.
 * @returns {number} Returns the string size.
 */
function stringSize(string) {
  return hasUnicode(string)
    ? unicodeSize(string)
    : asciiSize(string);
}

module.exports = stringSize;


/***/ }),

/***/ 1588:
/***/ (function(module, exports, __webpack_require__) {

var baseProperty = __webpack_require__(994);

/**
 * Gets the size of an ASCII `string`.
 *
 * @private
 * @param {string} string The string inspect.
 * @returns {number} Returns the string size.
 */
var asciiSize = baseProperty('length');

module.exports = asciiSize;


/***/ }),

/***/ 1589:
/***/ (function(module, exports) {

/** Used to compose unicode character classes. */
var rsAstralRange = '\\ud800-\\udfff',
    rsComboMarksRange = '\\u0300-\\u036f',
    reComboHalfMarksRange = '\\ufe20-\\ufe2f',
    rsComboSymbolsRange = '\\u20d0-\\u20ff',
    rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange,
    rsVarRange = '\\ufe0e\\ufe0f';

/** Used to compose unicode capture groups. */
var rsZWJ = '\\u200d';

/** Used to detect strings with [zero-width joiners or code points from the astral planes](http://eev.ee/blog/2015/09/12/dark-corners-of-unicode/). */
var reHasUnicode = RegExp('[' + rsZWJ + rsAstralRange  + rsComboRange + rsVarRange + ']');

/**
 * Checks if `string` contains Unicode symbols.
 *
 * @private
 * @param {string} string The string to inspect.
 * @returns {boolean} Returns `true` if a symbol is found, else `false`.
 */
function hasUnicode(string) {
  return reHasUnicode.test(string);
}

module.exports = hasUnicode;


/***/ }),

/***/ 1590:
/***/ (function(module, exports) {

/** Used to compose unicode character classes. */
var rsAstralRange = '\\ud800-\\udfff',
    rsComboMarksRange = '\\u0300-\\u036f',
    reComboHalfMarksRange = '\\ufe20-\\ufe2f',
    rsComboSymbolsRange = '\\u20d0-\\u20ff',
    rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange,
    rsVarRange = '\\ufe0e\\ufe0f';

/** Used to compose unicode capture groups. */
var rsAstral = '[' + rsAstralRange + ']',
    rsCombo = '[' + rsComboRange + ']',
    rsFitz = '\\ud83c[\\udffb-\\udfff]',
    rsModifier = '(?:' + rsCombo + '|' + rsFitz + ')',
    rsNonAstral = '[^' + rsAstralRange + ']',
    rsRegional = '(?:\\ud83c[\\udde6-\\uddff]){2}',
    rsSurrPair = '[\\ud800-\\udbff][\\udc00-\\udfff]',
    rsZWJ = '\\u200d';

/** Used to compose unicode regexes. */
var reOptMod = rsModifier + '?',
    rsOptVar = '[' + rsVarRange + ']?',
    rsOptJoin = '(?:' + rsZWJ + '(?:' + [rsNonAstral, rsRegional, rsSurrPair].join('|') + ')' + rsOptVar + reOptMod + ')*',
    rsSeq = rsOptVar + reOptMod + rsOptJoin,
    rsSymbol = '(?:' + [rsNonAstral + rsCombo + '?', rsCombo, rsRegional, rsSurrPair, rsAstral].join('|') + ')';

/** Used to match [string symbols](https://mathiasbynens.be/notes/javascript-unicode). */
var reUnicode = RegExp(rsFitz + '(?=' + rsFitz + ')|' + rsSymbol + rsSeq, 'g');

/**
 * Gets the size of a Unicode `string`.
 *
 * @private
 * @param {string} string The string inspect.
 * @returns {number} Returns the string size.
 */
function unicodeSize(string) {
  var result = reUnicode.lastIndex = 0;
  while (reUnicode.test(string)) {
    ++result;
  }
  return result;
}

module.exports = unicodeSize;


/***/ }),

/***/ 1591:
/***/ (function(module, exports, __webpack_require__) {

var baseClone = __webpack_require__(1592);

/** Used to compose bitmasks for cloning. */
var CLONE_SYMBOLS_FLAG = 4;

/**
 * Creates a shallow clone of `value`.
 *
 * **Note:** This method is loosely based on the
 * [structured clone algorithm](https://mdn.io/Structured_clone_algorithm)
 * and supports cloning arrays, array buffers, booleans, date objects, maps,
 * numbers, `Object` objects, regexes, sets, strings, symbols, and typed
 * arrays. The own enumerable properties of `arguments` objects are cloned
 * as plain objects. An empty object is returned for uncloneable values such
 * as error objects, functions, DOM nodes, and WeakMaps.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to clone.
 * @returns {*} Returns the cloned value.
 * @see _.cloneDeep
 * @example
 *
 * var objects = [{ 'a': 1 }, { 'b': 2 }];
 *
 * var shallow = _.clone(objects);
 * console.log(shallow[0] === objects[0]);
 * // => true
 */
function clone(value) {
  return baseClone(value, CLONE_SYMBOLS_FLAG);
}

module.exports = clone;


/***/ }),

/***/ 1592:
/***/ (function(module, exports, __webpack_require__) {

var Stack = __webpack_require__(665),
    arrayEach = __webpack_require__(672),
    assignValue = __webpack_require__(977),
    baseAssign = __webpack_require__(1593),
    baseAssignIn = __webpack_require__(1594),
    cloneBuffer = __webpack_require__(1595),
    copyArray = __webpack_require__(1521),
    copySymbols = __webpack_require__(1596),
    copySymbolsIn = __webpack_require__(1597),
    getAllKeys = __webpack_require__(989),
    getAllKeysIn = __webpack_require__(1598),
    getTag = __webpack_require__(313),
    initCloneArray = __webpack_require__(1599),
    initCloneByTag = __webpack_require__(1600),
    initCloneObject = __webpack_require__(1605),
    isArray = __webpack_require__(51),
    isBuffer = __webpack_require__(190),
    isMap = __webpack_require__(1606),
    isObject = __webpack_require__(98),
    isSet = __webpack_require__(1608),
    keys = __webpack_require__(135);

/** Used to compose bitmasks for cloning. */
var CLONE_DEEP_FLAG = 1,
    CLONE_FLAT_FLAG = 2,
    CLONE_SYMBOLS_FLAG = 4;

/** `Object#toString` result references. */
var argsTag = '[object Arguments]',
    arrayTag = '[object Array]',
    boolTag = '[object Boolean]',
    dateTag = '[object Date]',
    errorTag = '[object Error]',
    funcTag = '[object Function]',
    genTag = '[object GeneratorFunction]',
    mapTag = '[object Map]',
    numberTag = '[object Number]',
    objectTag = '[object Object]',
    regexpTag = '[object RegExp]',
    setTag = '[object Set]',
    stringTag = '[object String]',
    symbolTag = '[object Symbol]',
    weakMapTag = '[object WeakMap]';

var arrayBufferTag = '[object ArrayBuffer]',
    dataViewTag = '[object DataView]',
    float32Tag = '[object Float32Array]',
    float64Tag = '[object Float64Array]',
    int8Tag = '[object Int8Array]',
    int16Tag = '[object Int16Array]',
    int32Tag = '[object Int32Array]',
    uint8Tag = '[object Uint8Array]',
    uint8ClampedTag = '[object Uint8ClampedArray]',
    uint16Tag = '[object Uint16Array]',
    uint32Tag = '[object Uint32Array]';

/** Used to identify `toStringTag` values supported by `_.clone`. */
var cloneableTags = {};
cloneableTags[argsTag] = cloneableTags[arrayTag] =
cloneableTags[arrayBufferTag] = cloneableTags[dataViewTag] =
cloneableTags[boolTag] = cloneableTags[dateTag] =
cloneableTags[float32Tag] = cloneableTags[float64Tag] =
cloneableTags[int8Tag] = cloneableTags[int16Tag] =
cloneableTags[int32Tag] = cloneableTags[mapTag] =
cloneableTags[numberTag] = cloneableTags[objectTag] =
cloneableTags[regexpTag] = cloneableTags[setTag] =
cloneableTags[stringTag] = cloneableTags[symbolTag] =
cloneableTags[uint8Tag] = cloneableTags[uint8ClampedTag] =
cloneableTags[uint16Tag] = cloneableTags[uint32Tag] = true;
cloneableTags[errorTag] = cloneableTags[funcTag] =
cloneableTags[weakMapTag] = false;

/**
 * The base implementation of `_.clone` and `_.cloneDeep` which tracks
 * traversed objects.
 *
 * @private
 * @param {*} value The value to clone.
 * @param {boolean} bitmask The bitmask flags.
 *  1 - Deep clone
 *  2 - Flatten inherited properties
 *  4 - Clone symbols
 * @param {Function} [customizer] The function to customize cloning.
 * @param {string} [key] The key of `value`.
 * @param {Object} [object] The parent object of `value`.
 * @param {Object} [stack] Tracks traversed objects and their clone counterparts.
 * @returns {*} Returns the cloned value.
 */
function baseClone(value, bitmask, customizer, key, object, stack) {
  var result,
      isDeep = bitmask & CLONE_DEEP_FLAG,
      isFlat = bitmask & CLONE_FLAT_FLAG,
      isFull = bitmask & CLONE_SYMBOLS_FLAG;

  if (customizer) {
    result = object ? customizer(value, key, object, stack) : customizer(value);
  }
  if (result !== undefined) {
    return result;
  }
  if (!isObject(value)) {
    return value;
  }
  var isArr = isArray(value);
  if (isArr) {
    result = initCloneArray(value);
    if (!isDeep) {
      return copyArray(value, result);
    }
  } else {
    var tag = getTag(value),
        isFunc = tag == funcTag || tag == genTag;

    if (isBuffer(value)) {
      return cloneBuffer(value, isDeep);
    }
    if (tag == objectTag || tag == argsTag || (isFunc && !object)) {
      result = (isFlat || isFunc) ? {} : initCloneObject(value);
      if (!isDeep) {
        return isFlat
          ? copySymbolsIn(value, baseAssignIn(result, value))
          : copySymbols(value, baseAssign(result, value));
      }
    } else {
      if (!cloneableTags[tag]) {
        return object ? value : {};
      }
      result = initCloneByTag(value, tag, isDeep);
    }
  }
  // Check for circular references and return its corresponding clone.
  stack || (stack = new Stack);
  var stacked = stack.get(value);
  if (stacked) {
    return stacked;
  }
  stack.set(value, result);

  if (isSet(value)) {
    value.forEach(function(subValue) {
      result.add(baseClone(subValue, bitmask, customizer, subValue, value, stack));
    });

    return result;
  }

  if (isMap(value)) {
    value.forEach(function(subValue, key) {
      result.set(key, baseClone(subValue, bitmask, customizer, key, value, stack));
    });

    return result;
  }

  var keysFunc = isFull
    ? (isFlat ? getAllKeysIn : getAllKeys)
    : (isFlat ? keysIn : keys);

  var props = isArr ? undefined : keysFunc(value);
  arrayEach(props || value, function(subValue, key) {
    if (props) {
      key = subValue;
      subValue = value[key];
    }
    // Recursively populate clone (susceptible to call stack limits).
    assignValue(result, key, baseClone(subValue, bitmask, customizer, key, value, stack));
  });
  return result;
}

module.exports = baseClone;


/***/ }),

/***/ 1593:
/***/ (function(module, exports, __webpack_require__) {

var copyObject = __webpack_require__(538),
    keys = __webpack_require__(135);

/**
 * The base implementation of `_.assign` without support for multiple sources
 * or `customizer` functions.
 *
 * @private
 * @param {Object} object The destination object.
 * @param {Object} source The source object.
 * @returns {Object} Returns `object`.
 */
function baseAssign(object, source) {
  return object && copyObject(source, keys(source), object);
}

module.exports = baseAssign;


/***/ }),

/***/ 1594:
/***/ (function(module, exports, __webpack_require__) {

var copyObject = __webpack_require__(538),
    keysIn = __webpack_require__(678);

/**
 * The base implementation of `_.assignIn` without support for multiple sources
 * or `customizer` functions.
 *
 * @private
 * @param {Object} object The destination object.
 * @param {Object} source The source object.
 * @returns {Object} Returns `object`.
 */
function baseAssignIn(object, source) {
  return object && copyObject(source, keysIn(source), object);
}

module.exports = baseAssignIn;


/***/ }),

/***/ 1595:
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(module) {var root = __webpack_require__(97);

/** Detect free variable `exports`. */
var freeExports = typeof exports == 'object' && exports && !exports.nodeType && exports;

/** Detect free variable `module`. */
var freeModule = freeExports && typeof module == 'object' && module && !module.nodeType && module;

/** Detect the popular CommonJS extension `module.exports`. */
var moduleExports = freeModule && freeModule.exports === freeExports;

/** Built-in value references. */
var Buffer = moduleExports ? root.Buffer : undefined,
    allocUnsafe = Buffer ? Buffer.allocUnsafe : undefined;

/**
 * Creates a clone of  `buffer`.
 *
 * @private
 * @param {Buffer} buffer The buffer to clone.
 * @param {boolean} [isDeep] Specify a deep clone.
 * @returns {Buffer} Returns the cloned buffer.
 */
function cloneBuffer(buffer, isDeep) {
  if (isDeep) {
    return buffer.slice();
  }
  var length = buffer.length,
      result = allocUnsafe ? allocUnsafe(length) : new buffer.constructor(length);

  buffer.copy(result);
  return result;
}

module.exports = cloneBuffer;

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(41)(module)))

/***/ }),

/***/ 1596:
/***/ (function(module, exports, __webpack_require__) {

var copyObject = __webpack_require__(538),
    getSymbols = __webpack_require__(666);

/**
 * Copies own symbols of `source` to `object`.
 *
 * @private
 * @param {Object} source The object to copy symbols from.
 * @param {Object} [object={}] The object to copy symbols to.
 * @returns {Object} Returns `object`.
 */
function copySymbols(source, object) {
  return copyObject(source, getSymbols(source), object);
}

module.exports = copySymbols;


/***/ }),

/***/ 1597:
/***/ (function(module, exports, __webpack_require__) {

var copyObject = __webpack_require__(538),
    getSymbolsIn = __webpack_require__(997);

/**
 * Copies own and inherited symbols of `source` to `object`.
 *
 * @private
 * @param {Object} source The object to copy symbols from.
 * @param {Object} [object={}] The object to copy symbols to.
 * @returns {Object} Returns `object`.
 */
function copySymbolsIn(source, object) {
  return copyObject(source, getSymbolsIn(source), object);
}

module.exports = copySymbolsIn;


/***/ }),

/***/ 1598:
/***/ (function(module, exports, __webpack_require__) {

var baseGetAllKeys = __webpack_require__(990),
    getSymbolsIn = __webpack_require__(997),
    keysIn = __webpack_require__(678);

/**
 * Creates an array of own and inherited enumerable property names and
 * symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names and symbols.
 */
function getAllKeysIn(object) {
  return baseGetAllKeys(object, keysIn, getSymbolsIn);
}

module.exports = getAllKeysIn;


/***/ }),

/***/ 1599:
/***/ (function(module, exports) {

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Initializes an array clone.
 *
 * @private
 * @param {Array} array The array to clone.
 * @returns {Array} Returns the initialized clone.
 */
function initCloneArray(array) {
  var length = array.length,
      result = new array.constructor(length);

  // Add properties assigned by `RegExp#exec`.
  if (length && typeof array[0] == 'string' && hasOwnProperty.call(array, 'index')) {
    result.index = array.index;
    result.input = array.input;
  }
  return result;
}

module.exports = initCloneArray;


/***/ }),

/***/ 1600:
/***/ (function(module, exports, __webpack_require__) {

var cloneArrayBuffer = __webpack_require__(667),
    cloneDataView = __webpack_require__(1601),
    cloneRegExp = __webpack_require__(1602),
    cloneSymbol = __webpack_require__(1603),
    cloneTypedArray = __webpack_require__(1604);

/** `Object#toString` result references. */
var boolTag = '[object Boolean]',
    dateTag = '[object Date]',
    mapTag = '[object Map]',
    numberTag = '[object Number]',
    regexpTag = '[object RegExp]',
    setTag = '[object Set]',
    stringTag = '[object String]',
    symbolTag = '[object Symbol]';

var arrayBufferTag = '[object ArrayBuffer]',
    dataViewTag = '[object DataView]',
    float32Tag = '[object Float32Array]',
    float64Tag = '[object Float64Array]',
    int8Tag = '[object Int8Array]',
    int16Tag = '[object Int16Array]',
    int32Tag = '[object Int32Array]',
    uint8Tag = '[object Uint8Array]',
    uint8ClampedTag = '[object Uint8ClampedArray]',
    uint16Tag = '[object Uint16Array]',
    uint32Tag = '[object Uint32Array]';

/**
 * Initializes an object clone based on its `toStringTag`.
 *
 * **Note:** This function only supports cloning values with tags of
 * `Boolean`, `Date`, `Error`, `Map`, `Number`, `RegExp`, `Set`, or `String`.
 *
 * @private
 * @param {Object} object The object to clone.
 * @param {string} tag The `toStringTag` of the object to clone.
 * @param {boolean} [isDeep] Specify a deep clone.
 * @returns {Object} Returns the initialized clone.
 */
function initCloneByTag(object, tag, isDeep) {
  var Ctor = object.constructor;
  switch (tag) {
    case arrayBufferTag:
      return cloneArrayBuffer(object);

    case boolTag:
    case dateTag:
      return new Ctor(+object);

    case dataViewTag:
      return cloneDataView(object, isDeep);

    case float32Tag: case float64Tag:
    case int8Tag: case int16Tag: case int32Tag:
    case uint8Tag: case uint8ClampedTag: case uint16Tag: case uint32Tag:
      return cloneTypedArray(object, isDeep);

    case mapTag:
      return new Ctor;

    case numberTag:
    case stringTag:
      return new Ctor(object);

    case regexpTag:
      return cloneRegExp(object);

    case setTag:
      return new Ctor;

    case symbolTag:
      return cloneSymbol(object);
  }
}

module.exports = initCloneByTag;


/***/ }),

/***/ 1601:
/***/ (function(module, exports, __webpack_require__) {

var cloneArrayBuffer = __webpack_require__(667);

/**
 * Creates a clone of `dataView`.
 *
 * @private
 * @param {Object} dataView The data view to clone.
 * @param {boolean} [isDeep] Specify a deep clone.
 * @returns {Object} Returns the cloned data view.
 */
function cloneDataView(dataView, isDeep) {
  var buffer = isDeep ? cloneArrayBuffer(dataView.buffer) : dataView.buffer;
  return new dataView.constructor(buffer, dataView.byteOffset, dataView.byteLength);
}

module.exports = cloneDataView;


/***/ }),

/***/ 1602:
/***/ (function(module, exports) {

/** Used to match `RegExp` flags from their coerced string values. */
var reFlags = /\w*$/;

/**
 * Creates a clone of `regexp`.
 *
 * @private
 * @param {Object} regexp The regexp to clone.
 * @returns {Object} Returns the cloned regexp.
 */
function cloneRegExp(regexp) {
  var result = new regexp.constructor(regexp.source, reFlags.exec(regexp));
  result.lastIndex = regexp.lastIndex;
  return result;
}

module.exports = cloneRegExp;


/***/ }),

/***/ 1603:
/***/ (function(module, exports, __webpack_require__) {

var Symbol = __webpack_require__(138);

/** Used to convert symbols to primitives and strings. */
var symbolProto = Symbol ? Symbol.prototype : undefined,
    symbolValueOf = symbolProto ? symbolProto.valueOf : undefined;

/**
 * Creates a clone of the `symbol` object.
 *
 * @private
 * @param {Object} symbol The symbol object to clone.
 * @returns {Object} Returns the cloned symbol object.
 */
function cloneSymbol(symbol) {
  return symbolValueOf ? Object(symbolValueOf.call(symbol)) : {};
}

module.exports = cloneSymbol;


/***/ }),

/***/ 1604:
/***/ (function(module, exports, __webpack_require__) {

var cloneArrayBuffer = __webpack_require__(667);

/**
 * Creates a clone of `typedArray`.
 *
 * @private
 * @param {Object} typedArray The typed array to clone.
 * @param {boolean} [isDeep] Specify a deep clone.
 * @returns {Object} Returns the cloned typed array.
 */
function cloneTypedArray(typedArray, isDeep) {
  var buffer = isDeep ? cloneArrayBuffer(typedArray.buffer) : typedArray.buffer;
  return new typedArray.constructor(buffer, typedArray.byteOffset, typedArray.length);
}

module.exports = cloneTypedArray;


/***/ }),

/***/ 1605:
/***/ (function(module, exports, __webpack_require__) {

var baseCreate = __webpack_require__(1005),
    getPrototype = __webpack_require__(545),
    isPrototype = __webpack_require__(221);

/**
 * Initializes an object clone.
 *
 * @private
 * @param {Object} object The object to clone.
 * @returns {Object} Returns the initialized clone.
 */
function initCloneObject(object) {
  return (typeof object.constructor == 'function' && !isPrototype(object))
    ? baseCreate(getPrototype(object))
    : {};
}

module.exports = initCloneObject;


/***/ }),

/***/ 1606:
/***/ (function(module, exports, __webpack_require__) {

var baseIsMap = __webpack_require__(1607),
    baseUnary = __webpack_require__(191),
    nodeUtil = __webpack_require__(275);

/* Node.js helper references. */
var nodeIsMap = nodeUtil && nodeUtil.isMap;

/**
 * Checks if `value` is classified as a `Map` object.
 *
 * @static
 * @memberOf _
 * @since 4.3.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a map, else `false`.
 * @example
 *
 * _.isMap(new Map);
 * // => true
 *
 * _.isMap(new WeakMap);
 * // => false
 */
var isMap = nodeIsMap ? baseUnary(nodeIsMap) : baseIsMap;

module.exports = isMap;


/***/ }),

/***/ 1607:
/***/ (function(module, exports, __webpack_require__) {

var getTag = __webpack_require__(313),
    isObjectLike = __webpack_require__(84);

/** `Object#toString` result references. */
var mapTag = '[object Map]';

/**
 * The base implementation of `_.isMap` without Node.js optimizations.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a map, else `false`.
 */
function baseIsMap(value) {
  return isObjectLike(value) && getTag(value) == mapTag;
}

module.exports = baseIsMap;


/***/ }),

/***/ 1608:
/***/ (function(module, exports, __webpack_require__) {

var baseIsSet = __webpack_require__(1609),
    baseUnary = __webpack_require__(191),
    nodeUtil = __webpack_require__(275);

/* Node.js helper references. */
var nodeIsSet = nodeUtil && nodeUtil.isSet;

/**
 * Checks if `value` is classified as a `Set` object.
 *
 * @static
 * @memberOf _
 * @since 4.3.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a set, else `false`.
 * @example
 *
 * _.isSet(new Set);
 * // => true
 *
 * _.isSet(new WeakSet);
 * // => false
 */
var isSet = nodeIsSet ? baseUnary(nodeIsSet) : baseIsSet;

module.exports = isSet;


/***/ }),

/***/ 1609:
/***/ (function(module, exports, __webpack_require__) {

var getTag = __webpack_require__(313),
    isObjectLike = __webpack_require__(84);

/** `Object#toString` result references. */
var setTag = '[object Set]';

/**
 * The base implementation of `_.isSet` without Node.js optimizations.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a set, else `false`.
 */
function baseIsSet(value) {
  return isObjectLike(value) && getTag(value) == setTag;
}

module.exports = baseIsSet;


/***/ }),

/***/ 1610:
/***/ (function(module, exports, __webpack_require__) {

var baseKeys = __webpack_require__(276),
    getTag = __webpack_require__(313),
    isArguments = __webpack_require__(223),
    isArray = __webpack_require__(51),
    isArrayLike = __webpack_require__(67),
    isBuffer = __webpack_require__(190),
    isPrototype = __webpack_require__(221),
    isTypedArray = __webpack_require__(224);

/** `Object#toString` result references. */
var mapTag = '[object Map]',
    setTag = '[object Set]';

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Checks if `value` is an empty object, collection, map, or set.
 *
 * Objects are considered empty if they have no own enumerable string keyed
 * properties.
 *
 * Array-like values such as `arguments` objects, arrays, buffers, strings, or
 * jQuery-like collections are considered empty if they have a `length` of `0`.
 * Similarly, maps and sets are considered empty if they have a `size` of `0`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is empty, else `false`.
 * @example
 *
 * _.isEmpty(null);
 * // => true
 *
 * _.isEmpty(true);
 * // => true
 *
 * _.isEmpty(1);
 * // => true
 *
 * _.isEmpty([1, 2, 3]);
 * // => false
 *
 * _.isEmpty({ 'a': 1 });
 * // => false
 */
function isEmpty(value) {
  if (value == null) {
    return true;
  }
  if (isArrayLike(value) &&
      (isArray(value) || typeof value == 'string' || typeof value.splice == 'function' ||
        isBuffer(value) || isTypedArray(value) || isArguments(value))) {
    return !value.length;
  }
  var tag = getTag(value);
  if (tag == mapTag || tag == setTag) {
    return !value.size;
  }
  if (isPrototype(value)) {
    return !baseKeys(value).length;
  }
  for (var key in value) {
    if (hasOwnProperty.call(value, key)) {
      return false;
    }
  }
  return true;
}

module.exports = isEmpty;


/***/ }),

/***/ 1611:
/***/ (function(module, exports, __webpack_require__) {

var arrayFilter = __webpack_require__(668),
    baseFilter = __webpack_require__(1522),
    baseIteratee = __webpack_require__(537),
    isArray = __webpack_require__(51);

/**
 * Iterates over elements of `collection`, returning an array of all elements
 * `predicate` returns truthy for. The predicate is invoked with three
 * arguments: (value, index|key, collection).
 *
 * **Note:** Unlike `_.remove`, this method returns a new array.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Collection
 * @param {Array|Object} collection The collection to iterate over.
 * @param {Function} [predicate=_.identity] The function invoked per iteration.
 * @returns {Array} Returns the new filtered array.
 * @see _.reject
 * @example
 *
 * var users = [
 *   { 'user': 'barney', 'age': 36, 'active': true },
 *   { 'user': 'fred',   'age': 40, 'active': false }
 * ];
 *
 * _.filter(users, function(o) { return !o.active; });
 * // => objects for ['fred']
 *
 * // The `_.matches` iteratee shorthand.
 * _.filter(users, { 'age': 36, 'active': true });
 * // => objects for ['barney']
 *
 * // The `_.matchesProperty` iteratee shorthand.
 * _.filter(users, ['active', false]);
 * // => objects for ['fred']
 *
 * // The `_.property` iteratee shorthand.
 * _.filter(users, 'active');
 * // => objects for ['barney']
 */
function filter(collection, predicate) {
  var func = isArray(collection) ? arrayFilter : baseFilter;
  return func(collection, baseIteratee(predicate, 3));
}

module.exports = filter;


/***/ }),

/***/ 1612:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return MissingCurrentWorkspaceModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_workspaces_MissingCurrentWorkspaceModal__ = __webpack_require__(1613);



const defaultState = { isOpen: false };let

MissingCurrentWorkspaceModalContainer = class MissingCurrentWorkspaceModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = defaultState;

    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('missingCurrentWorkspace', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('missingCurrentWorkspace', this.handleOpen);
  }

  handleOpen(workspace) {
    this.setState({
      isOpen: true,
      workspaceName: workspace.name });

  }

  handleClose() {
    this.setState(defaultState);
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_workspaces_MissingCurrentWorkspaceModal__["a" /* default */], {
        isOpen: this.state.isOpen,
        workspaceName: this.state.workspaceName,
        onRequestClose: this.handleClose }));


  }};

/***/ }),

/***/ 1613:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Buttons__ = __webpack_require__(13);


let

MissingCurrentWorkspaceModal = class MissingCurrentWorkspaceModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["a" /* Modal */], {
          className: 'missing-current-workspace-modal',
          isOpen: this.props.isOpen,
          onRequestClose: this.props.onRequestClose },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'missing-current-workspace-modal__wrapper' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'modal-header-close-button', onClick: this.props.onRequestClose }),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'missing-current-workspace-thumbnail__container' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'missing-current-workspace-thumbnail' })),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'missing-current-workspace-modal__content' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'missing-current-workspace-modal__header' }, 'We can\'t seem to find the ',
                this.props.workspaceName, ' workspace'),

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'missing-current-workspace-modal__subtext' }, 'The workspace might have been deleted by another user in your team. You have been switched to one of your personal workspaces.'),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'missing-current-workspace-modal__action' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
                    type: 'primary',
                    onClick: this.props.onRequestClose }, 'Okay')))))));









  }};


/* harmony default export */ __webpack_exports__["a"] = (MissingCurrentWorkspaceModal);

/***/ }),

/***/ 313:
/***/ (function(module, exports, __webpack_require__) {

var DataView = __webpack_require__(1571),
    Map = __webpack_require__(675),
    Promise = __webpack_require__(1572),
    Set = __webpack_require__(1013),
    WeakMap = __webpack_require__(1573),
    baseGetTag = __webpack_require__(105),
    toSource = __webpack_require__(1010);

/** `Object#toString` result references. */
var mapTag = '[object Map]',
    objectTag = '[object Object]',
    promiseTag = '[object Promise]',
    setTag = '[object Set]',
    weakMapTag = '[object WeakMap]';

var dataViewTag = '[object DataView]';

/** Used to detect maps, sets, and weakmaps. */
var dataViewCtorString = toSource(DataView),
    mapCtorString = toSource(Map),
    promiseCtorString = toSource(Promise),
    setCtorString = toSource(Set),
    weakMapCtorString = toSource(WeakMap);

/**
 * Gets the `toStringTag` of `value`.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the `toStringTag`.
 */
var getTag = baseGetTag;

// Fallback for data views, maps, sets, and weak maps in IE 11 and promises in Node.js < 6.
if ((DataView && getTag(new DataView(new ArrayBuffer(1))) != dataViewTag) ||
    (Map && getTag(new Map) != mapTag) ||
    (Promise && getTag(Promise.resolve()) != promiseTag) ||
    (Set && getTag(new Set) != setTag) ||
    (WeakMap && getTag(new WeakMap) != weakMapTag)) {
  getTag = function(value) {
    var result = baseGetTag(value),
        Ctor = result == objectTag ? value.constructor : undefined,
        ctorString = Ctor ? toSource(Ctor) : '';

    if (ctorString) {
      switch (ctorString) {
        case dataViewCtorString: return dataViewTag;
        case mapCtorString: return mapTag;
        case promiseCtorString: return promiseTag;
        case setCtorString: return setTag;
        case weakMapCtorString: return weakMapTag;
      }
    }
    return result;
  };
}

module.exports = getTag;


/***/ }),

/***/ 3517:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return DeleteConfirmationModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__utils_PluralizeHelper__ = __webpack_require__(533);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_keymaps_KeyMaps__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__models_services_DashboardService__ = __webpack_require__(309);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__base_LoadingIndicator__ = __webpack_require__(71);







let

DeleteConfirmationModal = class DeleteConfirmationModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.state = { isDeleteFocused: true };
    this.handleSubmit = this.handleSubmit.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleFocusClick = this.handleFocusClick.bind(this);
    this.handleFocusSwitch = this.handleFocusSwitch.bind(this);
  }

  getKeyMapHandlers() {
    return {
      quit: pm.shortcuts.handle('quit', this.handleClose), // discard and close
      select: pm.shortcuts.handle('select', this.handleFocusClick), // save and close
      submit: pm.shortcuts.handle('submit', this.handleFocusClick), // save and close
      space: pm.shortcuts.handle('space', this.handleFocusClick), // submit based on what is in focus
      focusNext: pm.shortcuts.handle('focusNext', this.handleFocusSwitch) // switch to next button
    };
  }

  handleClose() {
    this.props.onRequestClose && this.props.onRequestClose();
    this.setState({ isDeleteFocused: true });
  }

  handleSubmit() {
    this.props.onConfirm && this.props.onConfirm();
  }

  handleFocusSwitch() {
    this.setState({ isDeleteFocused: !this.state.isDeleteFocused });
  }

  handleFocusClick() {
    this.state.isDeleteFocused ? this.handleSubmit() : this.handleClose();
  }

  getCustomStyles() {
    return { marginTop: '35vh' };
  }

  getClasses() {
    return __WEBPACK_IMPORTED_MODULE_1_classnames___default()({ 'delete-confirmation-modal': true }, this.props.className);
  }

  renderCollectionMessage() {
    let name = _.get(this.props.meta, 'name');

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'delete-confirmation-modal__message' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'delete-confirmation-modal-message' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, 'Are you sure you want to delete this collection from all workspaces?'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'helptext' }, 'Deleting it will also delete any monitors, mock servers and integrations created on it from all workspaces. Your team will no longer be able to access it.'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'helptext' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'The collection might be accessible from the owner\'s '),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
                type: 'text',
                className: 'learn-more-link',
                onClick: __WEBPACK_IMPORTED_MODULE_6__models_services_DashboardService__["v" /* openTrash */] }, 'Trash'),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, ' for some time depending on your plan.')))));




  }

  renderTabMessage() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'delete-confirmation-modal-message' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null,
          _.get(this.props, 'meta.count'),

          __WEBPACK_IMPORTED_MODULE_2__utils_PluralizeHelper__["a" /* default */].pluralize({
            count: this.props.meta.count,
            singular: ' tab has ',
            plural: ' tabs have ' }), 'unsaved changes. Your changes will be lost if you force close',




          __WEBPACK_IMPORTED_MODULE_2__utils_PluralizeHelper__["a" /* default */].pluralize({
            count: this.props.meta.count,
            singular: ' this tab',
            plural: ' these tabs' }), '. Are you sure you want to force close?')));






  }

  renderDefaultMessage() {
    if (this.props.message) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'delete-confirmation-modal-message' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, this.props.message)));


    } else
    {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'delete-confirmation-modal-message' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Are you sure you want to delete '),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'delete-confirmation-modal-entity-name' }, _.get(this.props, 'meta.name'), '?')));


    }
  }

  renderMessage() {
    if (this.props.entity === 'COLLECTION') {
      return this.renderCollectionMessage();
    }

    if (this.props.entity === 'TAB') {
      return this.renderTabMessage();
    }

    return this.renderDefaultMessage();
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Modals__["a" /* Modal */], {
          isOpen: this.props.isOpen,
          onRequestClose: this.handleClose,
          className: this.getClasses(),
          customStyles: this.getCustomStyles() },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Modals__["d" /* ModalHeader */], null,

          this.props.title || (
          this.props.entity === 'TAB' ?
          'CONFIRM FORCE CLOSE' :
          `DELETE ${this.props.entity}`)),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_keymaps_KeyMaps__["a" /* default */], {
              keyMap: pm.shortcuts.getShortcuts(),
              handlers: this.getKeyMapHandlers(),
              ref: this.props.keymapRef },

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
              this.renderMessage(),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'delete-confirmation-modal-controls' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
                    type: 'primary',
                    onClick: this.handleSubmit,
                    disabled: this.props.isDisabled || this.props.isDeleting,
                    className: 'delete-confirmation-modal-delete-button',
                    focused: this.state.isDeleteFocused },

                  this.props.isDeleting ? __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_LoadingIndicator__["a" /* default */], { className: 'loading-indicator-size' }) : _.get(this.props, 'primaryAction', 'Delete')),

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
                    className: 'delete-confirmation-modal-cancel-button',
                    type: 'secondary',
                    onClick: this.handleClose,
                    focused: !this.state.isDeleteFocused }, 'Cancel')))))));







  }};


DeleteConfirmationModal.defaultProps = { isDeleting: false };
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 3537:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _isString = __webpack_require__(1519);

var _isString2 = _interopRequireDefault(_isString);

var _isNumber = __webpack_require__(5015);

var _isNumber2 = _interopRequireDefault(_isNumber);

var _isBoolean = __webpack_require__(5016);

var _isBoolean2 = _interopRequireDefault(_isBoolean);

var _isArray = __webpack_require__(51);

var _isArray2 = _interopRequireDefault(_isArray);

var _isObject = __webpack_require__(98);

var _isObject2 = _interopRequireDefault(_isObject);

var _forEach = __webpack_require__(1520);

var _forEach2 = _interopRequireDefault(_forEach);

var _forOwn = __webpack_require__(5017);

var _forOwn2 = _interopRequireDefault(_forOwn);

var _concat = __webpack_require__(5018);

var _concat2 = _interopRequireDefault(_concat);

var _reject = __webpack_require__(5019);

var _reject2 = _interopRequireDefault(_reject);

var _size = __webpack_require__(1586);

var _size2 = _interopRequireDefault(_size);

var _assign = __webpack_require__(4020);

var _assign2 = _interopRequireDefault(_assign);

var _get = __webpack_require__(1497);

var _get2 = _interopRequireDefault(_get);

var _immutable = __webpack_require__(32);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var utils = function () {
  function utils() {
    _classCallCheck(this, utils);

    this.counter = 0;
  }

  _createClass(utils, [{
    key: 'getId',
    value: function getId() {
      return this.counter++;
    }
  }, {
    key: '_getType',
    value: function _getType(item) {
      if ((0, _isString2.default)(item)) return 'string';
      if ((0, _isNumber2.default)(item)) return 'number';
      if ((0, _isBoolean2.default)(item)) return 'boolean';
      if ((0, _isArray2.default)(item)) return 'array';
      if ((0, _isObject2.default)(item)) return 'object';
    }

    /**
     * Recursively flattens a node
     *
     * @param  {?Number} nodeId     - The current node's ID. If not provided, an ID will be generated
     * @param  {String} columnName  - This is the name of the column, as per the config
     * @param  {*}      columnValue - Value of the node we are currently flattening
     * @param  {Number} depth       - Depth of the node we are currently flattening
     * @param  {?String} columnKey   - Optional name of the node we are currently flattening
     * 
     * @return {undefined}
     */

  }, {
    key: 'flattenNode',
    value: function flattenNode(nodeId, columnName, columnValue) {
      var depth = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 0;
      var columnKey = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : '';

      var _this = this;

      var autogen = arguments[5];
      var parent = arguments[6];

      var columnType = this._getType(columnValue),
          id = nodeId,
          allChildren = [],
          children = [];

      if (id === null || typeof id === 'undefined') {
        id = this.getId();
        this.flattened.order = (0, _concat2.default)(this.flattened.order, id);
      }

      if (this.maxDepth < depth) {
        this.maxDepth = depth;
      }

      switch (columnType) {
        case 'string':
        case 'number':
        case 'boolean':
          this.flattened.rows[id] = Object.assign({}, this.flattened.rows[id], {
            id: id,
            depth: depth,
            parent: parent,
            columns: Object.assign({}, (0, _get2.default)(this.flattened.rows[id], 'columns', []), _defineProperty({}, '' + columnName, {
              type: columnType,
              meta: {
                value: columnValue
              }
            }))

            // children.push(id);
          });allChildren.push(id);
          break;

        case 'array':
          children.push(id);
          allChildren.push(id);
          (0, _forEach2.default)(columnValue, function (colVal, colIndex) {
            if ((0, _isString2.default)(colVal) || (0, _isNumber2.default)(colVal) || (0, _isBoolean2.default)(colVal)) {
              // Value is a simple object
              var newId = _this.getId();
              _this.flattened.rows[newId] = Object.assign({}, _this.flattened.rows[newId], {
                id: newId,
                depth: depth + 1,
                parent: id,
                columns: Object.assign({}, (0, _get2.default)(_this.flattened.rows[newId], 'columns', []), _defineProperty({}, '' + columnName, {
                  type: 'object',
                  meta: {
                    key: columnKey + '[' + colIndex + ']',
                    value: colVal,
                    type: _this._getType(colVal)
                  }
                }))
              });

              _this.flattened.order = (0, _concat2.default)(_this.flattened.order, newId);
              children.push(newId);
              allChildren.push(newId);
            } else {
              var flatChildren = _this.flattenNode(null, columnName, colVal, depth + 1, columnKey + '[' + colIndex + ']', true, id);
              allChildren = (0, _concat2.default)(allChildren, flatChildren.allChildren);
              var directChildren = (0, _reject2.default)(flatChildren.children, function (child) {
                return _this.flattened.rows[child].depth !== depth + 1;
              });
              children = (0, _concat2.default)(children, directChildren);
            }
          });

          this.flattened.rows[id] = Object.assign({}, this.flattened.rows[id], {
            id: id,
            depth: depth,
            parent: parent,
            children: (0, _reject2.default)(children, function (child) {
              return '' + child === '' + id;
            }),
            allChildren: (0, _reject2.default)(allChildren, function (child) {
              return '' + child === '' + id;
            }),
            columns: Object.assign({}, (0, _get2.default)(this.flattened.rows[id], 'columns', []), _defineProperty({}, '' + columnName, {
              type: 'arraymeta',
              meta: {
                name: columnKey,
                childrenCount: (0, _size2.default)(columnValue),
                type: this._getType(columnValue)
              }
            }))
          });
          break;

        case 'object':
          children.push(id);
          allChildren.push(id);
          (0, _forOwn2.default)(columnValue, function (colVal, colKey) {
            if ((0, _isString2.default)(colVal) || (0, _isNumber2.default)(colVal) || (0, _isBoolean2.default)(colVal)) {
              // Value is a simple object
              var newId = _this.getId();
              _this.flattened.rows[newId] = Object.assign({}, _this.flattened.rows[newId], {
                id: newId,
                depth: depth + 1,
                parent: id,
                columns: Object.assign({}, (0, _get2.default)(_this.flattened.rows[newId], 'columns', []), _defineProperty({}, '' + columnName, {
                  type: 'object',
                  meta: {
                    key: '' + colKey,
                    value: colVal,
                    type: _this._getType(colVal)
                  }
                }))
              });

              _this.flattened.order = (0, _concat2.default)(_this.flattened.order, newId);
              children.push(newId);
              allChildren.push(newId);
            } else {
              var flatChildren = _this.flattenNode(null, columnName, colVal, depth + 1, colKey, false, id);
              allChildren = (0, _concat2.default)(allChildren, flatChildren.allChildren);
              var directChildren = (0, _reject2.default)(flatChildren.children, function (child) {
                return _this.flattened.rows[child].depth !== depth + 1;
              });
              children = (0, _concat2.default)(children, directChildren);
            }
          });

          this.flattened.rows[id] = Object.assign({}, this.flattened.rows[id], {
            id: id,
            depth: depth,
            parent: parent,
            children: (0, _reject2.default)(children, function (child) {
              return '' + child === '' + id;
            }),
            allChildren: (0, _reject2.default)(allChildren, function (child) {
              return '' + child === '' + id;
            }),
            columns: Object.assign({}, (0, _get2.default)(this.flattened.rows[id], 'columns', []), _defineProperty({}, '' + columnName, {
              type: 'objectmeta',
              meta: {
                name: columnKey,
                autogen: autogen,
                childrenCount: (0, _size2.default)(columnValue),
                type: this._getType(columnValue)
              }
            }))
          });
          break;

        default:
          break;
      }

      return {
        children: children,
        allChildren: allChildren
      };
    }
  }, {
    key: 'flattenNodes',
    value: function flattenNodes(config, input) {
      var _this2 = this;

      delete this.flattened;
      this.flattened = {
        rows: {},
        order: [],
        collapsedRows: {}
      };
      this.maxDepth = 0;

      (0, _forEach2.default)(input, function (datum) {
        var id = _this2.getId();
        _this2.flattened.order = (0, _concat2.default)(_this2.flattened.order, id);

        (0, _forEach2.default)(config.columns, function (column) {
          switch (column.type) {
            case 'string':
            case 'number':
            case 'boolean':
              _this2.flattened.rows[id] = Object.assign({}, _this2.flattened.rows[id], {
                id: id,
                depth: 0,
                columns: Object.assign({}, (0, _get2.default)(_this2.flattened.rows[id], 'columns', []), _defineProperty({}, '' + column.name, {
                  type: column.type,
                  meta: {
                    value: datum[column.name]
                  }
                }))
              });
              break;
            case 'object':
            case 'array':
              var value = datum[column.name];
              var colKey = value.key;
              var colVal = value.value;
              if ((0, _isString2.default)(colVal) || (0, _isNumber2.default)(colVal) || (0, _isBoolean2.default)(colVal)) {
                _this2.flattened.rows[id] = Object.assign({}, _this2.flattened.rows[id], {
                  id: id,
                  depth: 0,
                  columns: Object.assign({}, (0, _get2.default)(_this2.flattened.rows[id], 'columns', []), _defineProperty({}, '' + column.name, {
                    type: 'object',
                    meta: {
                      key: '' + colKey,
                      value: colVal,
                      type: 'string'
                    }
                  }))
                });
              } else {
                _this2.flattenNode(id, column.name, colVal, 0, colKey);
              }
              break;
            default:
              break;
          }
        });
      });

      return {
        state: (0, _immutable.fromJS)(this.flattened),
        maxDepth: this.maxDepth
      };
    }
  }, {
    key: 'unflattenChildren',
    value: function unflattenChildren(state, columnName, children) {
      var _this3 = this;

      var startingValue = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

      var value = startingValue;

      (0, _forEach2.default)(children, function (childId) {
        var child = state.rows['' + childId];

        if (child.columns[columnName].type === 'object') {
          // console.log('object', this._getType(value))
          _this3._getType(value) === 'object' && (value = Object.assign({}, value, _defineProperty({}, child.columns[columnName].meta.key, child.columns[columnName].meta.value)));

          _this3._getType(value) === 'array' && (value = [].concat(_toConsumableArray(value), [_defineProperty({}, child.columns[columnName].meta.key, child.columns[columnName].meta.value)]));

          // console.log(JSON.stringify(value))
        } else if (child.columns[columnName].type === 'objectmeta') {
          // console.log('objectmeta', this._getType(value))
          _this3._getType(value) === 'object' && (value = _defineProperty({}, child.columns[columnName].meta.name, _this3.unflattenChildren(state, columnName, child.children, {})));

          // console.log(child.columns[columnName].meta.name, this._getType(value) === 'array' && !child.columns[columnName].meta.autogen)

          // children[0]
          _this3._getType(value) === 'array' && !child.columns[columnName].meta.autogen && (value = [_assign2.default.apply(undefined, [{}].concat(_toConsumableArray(value), [_defineProperty({}, child.columns[columnName].meta.name, _this3.unflattenChildren(state, columnName, child.children, {}))]))]);

          // other objects
          _this3._getType(value) === 'array' && child.columns[columnName].meta.autogen && (value = _this3.unflattenChildren(state, columnName, child.children, value));
        } else if (child.columns[columnName].type === 'arraymeta') {
          // console.log('arraymeta', this._getType(value))
          _this3._getType(value) === 'object' && (value = _defineProperty({}, child.columns[columnName].meta.name, _this3.unflattenChildren(state, columnName, child.children, [])));

          _this3._getType(value) === 'array' && (value = _this3.unflattenChildren(state, columnName, child.children, []));
        }

        // console.log('value', JSON.stringify(value))
      });

      return value;
    }
  }, {
    key: 'unflattenNodes',
    value: function unflattenNodes(is) {
      var _this4 = this;

      var state = is.toJS();
      var input = [],
          inputValueIndex = 0; // This is the index of the input we're generating

      var order = state.order;

      (0, _forEach2.default)(order, function (nodeId) {
        var node = state.rows[nodeId],
            depth = node.depth;

        (0, _forOwn2.default)(node.columns, function (column, columnName) {
          if (depth !== 0) {
            // console.log(node)
            // input = this.unflattenChildren({ input, inputValueIndex, columnName }, node.allChildren, state)
            return false;
          }

          if (column.type === 'string' || column.type === 'number' || column.type === 'boolean') {
            input[inputValueIndex] = Object.assign({}, input[inputValueIndex], _defineProperty({}, columnName, column.meta.value));
          } else if (column.type === 'object') {
            input[inputValueIndex] = Object.assign({}, input[inputValueIndex], _defineProperty({}, columnName, Object.assign({}, (0, _get2.default)(input, '[' + inputValueIndex + '][' + columnName + ']', {}), {
              key: column.meta.key,
              value: column.meta.value
            })));
          } else if (column.type === 'objectmeta') {
            input[inputValueIndex] = Object.assign({}, input[inputValueIndex], _defineProperty({}, columnName, Object.assign({}, (0, _get2.default)(input, '[' + inputValueIndex + '][' + columnName + ']', {}), {
              key: column.meta.name,
              value: _this4.unflattenChildren(state, columnName, node.children, {})
            })));
          } else if (column.type === 'arraymeta') {
            input[inputValueIndex] = Object.assign({}, input[inputValueIndex], _defineProperty({}, columnName, Object.assign({}, (0, _get2.default)(input, '[' + inputValueIndex + '][' + columnName + ']', {}), {
              key: column.meta.name,
              value: _this4.unflattenChildren(state, columnName, node.children, [])
            })));
          }
        });

        depth === 0 && inputValueIndex++;
      });

      return input;
    }
  }, {
    key: 'getImmutablePathValue',
    value: function getImmutablePathValue(node, path) {
      if (!node) {
        return;
      }
      return node.getIn(path);
    }
  }, {
    key: 'createAction',
    value: function createAction(source, type, payload) {
      switch (type) {
        case 'create':
          return {
            source: source,
            type: type,
            payload: payload
          };
        case 'edit':
          return {
            source: source,
            type: type,
            payload: {
              meta: payload
            }
          };
        case 'move':
          return {
            source: source,
            type: type,
            payload: payload
          };
        case 'delete':
          return {
            source: source,
            type: type,
            payload: payload
          };
        case 'expand':
          return {
            source: source,
            type: type
          };
        case 'collapse':
          return {
            source: source,
            type: type
          };
        default:
          return {
            source: source,
            type: type,
            payload: payload
          };
      }
    }
  }, {
    key: 'getEmptyRow',
    value: function getEmptyRow(config) {
      var id = this.getId();
      var values = {
        id: id,
        depth: 0,
        columns: {}
      };

      (0, _forEach2.default)(config.columns, function (column) {
        switch (column.type) {
          case 'string':
          case 'number':
          case 'boolean':
            values.columns = Object.assign({}, values.columns, _defineProperty({}, '' + column.name, {
              type: column.type,
              meta: {
                value: ''
              }
            }));
            break;
          case 'object':
            values.columns = Object.assign({}, values.columns, _defineProperty({}, '' + column.name, {
              type: column.type,
              meta: {
                key: '',
                value: ''
              }
            }));
            break;
          default:
            break;
        }
      });

      return values;
    }
  }, {
    key: 'findIndexInOrder',
    value: function findIndexInOrder(order, nodeId) {
      return order.findIndex(function (id) {
        return '' + id === '' + nodeId;
      });
    }
  }, {
    key: 'getLastInList',
    value: function getLastInList(list) {
      return list.last();
    }
  }, {
    key: 'isMap',
    value: function isMap(maybeMap) {
      return _immutable.Map.isMap(maybeMap);
    }
  }, {
    key: 'getMaxDepth',
    value: function getMaxDepth(state) {
      var maxDepth = 0;

      (0, _forEach2.default)(state.rows, function (row) {
        row.depth > maxDepth && (maxDepth = row.depth);
      });

      return maxDepth;
    }
  }]);

  return utils;
}();

exports.default = new utils();

/***/ }),

/***/ 3575:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


module.exports = {
  ShortcutManager: __webpack_require__(4980),
  Shortcuts: __webpack_require__(4984)
};

/***/ }),

/***/ 3593:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (immutable) */ __webpack_exports__["b"] = getRolesData;
/* harmony export (immutable) */ __webpack_exports__["e"] = updateEntityRoles;
/* harmony export (immutable) */ __webpack_exports__["a"] = fetchEntityRoles;
/* harmony export (immutable) */ __webpack_exports__["d"] = shouldOverrideRole;
/* harmony export (immutable) */ __webpack_exports__["c"] = getTeamDefaultRole;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__SyncRemoteFetcherService__ = __webpack_require__(139);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__constants_ShareFlowConstants__ = __webpack_require__(3625);




const ROLES = 'roles',
COLLECTION_MODEL = 'collection',
API_MODEL = 'apis',

/*
                      This map is used to fetch roles for individual entities
                    */
ENTITY_TYPE_HANDLER_MAP = {
  /**
                             * Fetches associated roles of a collection
                             *
                             * @param { String } collectionUID
                             */
  collection: collectionUID => {
    return _fetchAssociatedRoles(__WEBPACK_IMPORTED_MODULE_2__constants_ShareFlowConstants__["f" /* COLLECTION_ENTITY_TYPE */], collectionUID);
  },

  /**
      * Fetches associated roles of an API
      *
      * @param { String } apiId
      */
  api: apiId => {
    return _fetchAssociatedRoles(__WEBPACK_IMPORTED_MODULE_2__constants_ShareFlowConstants__["a" /* API_ENTITY_TYPE */], apiId);
  },

  /**
      * Fetches roles or associated roles of a workspace
      *
      * @param { String } workspaceId
      */
  workspace: workspaceId => {
    if (!workspaceId) {
      return _fetchRoles(__WEBPACK_IMPORTED_MODULE_2__constants_ShareFlowConstants__["C" /* WORKSPACE_ENTITY_TYPE */]);
    }

    return _fetchAssociatedRoles(__WEBPACK_IMPORTED_MODULE_2__constants_ShareFlowConstants__["C" /* WORKSPACE_ENTITY_TYPE */], workspaceId);
  } };


/**
        * Extracts out the default roles and generates the map
        * @param {Object} objectType
        * @param {Object} defaultRoles
        */
function _getDefaultRolesMap(objectType, defaultRoles) {
  return _.reduce(defaultRoles, (acc, role, key) => {
    acc[key] = _.head(_.get(role, `${objectType}.roles`), []);
    return acc;
  }, {});
}

/**
   * Generates the subsets for each role in the list,
   * i.e. checks for the permissions of each role
   * and if a given role has permissions which are a complete subset of the target (super) role
   * we're aiming to diff with, then it adds it to the subset of the target (super) role.
   *
   * @param {Object} roles - The roles list
   * @returns {Object} superRoles
   *
   * Following is the return format:
   * {
   *   "COLLECTION_EDITOR": ["COLLECTION_VIEWER"],
   *   "COLLECTION_VIEWER": []
   * }
   */
function _getSuperRoles(roles) {
  if (_.isEmpty(roles)) {
    return {};
  }

  // Transforms the roles to a new object containing all permissions
  // against each role:
  //
  // {
  //   role1: ['permission-1', 'permissions-2'],
  //   role2: ['permission-1']
  // }
  let permissionsPerRole = _.transform(roles, (acc, value, key) => {
    acc[key] = _.map(_.get(value, 'permissions', {}), 'name');
  }, {}),

  // Compares the permissions (diff) of each role in the permissionsPerRole
  // along with every other role present in the permissionsPerRole object
  superRoles = _.transform(permissionsPerRole, (superRolesAcc, superPermissions, superRole) => {
    superRolesAcc[superRole] = _.transform(permissionsPerRole, (subRoles, permissions, roleKey) => {
      // Do not include the same role as a subset
      if (roleKey === superRole) {
        return subRoles;
      }

      // If there's no difference between the permissions of the current role
      // and the super role's permissions then the current role will be basically
      // overridden by the super role
      _.isEmpty(_.difference(permissions, superPermissions)) && subRoles.push(roleKey);
    }, []);
  }, {});

  return superRoles;
}

/**
   * Generates a role object
   *
   * @private
   */
function _generateRoleObject(role, objectType, objectId) {
  let {
    type: entityType,
    id: entityId,
    name } =
  role;

  if (!entityType || !entityId || !name) {
    pm.logger.error(`RolesService~_generateRoleObject: Role has information missing - Type: ${entityType} Id: ${entityId} Name: ${name}`);
    return null;
  }

  return {
    entityType,
    entityId,
    roles: {
      [name]: {
        objects: [{
          objectType,
          objectId }] } } };




}

/**
   * Fetches the roles for a given object
   *
   * @private
   */
function _fetchObjectRoles(objectType, objectId) {
  if (!objectType) {
    pm.logger.error('RolesService~fetchObjectRoles: No object type provided');
    return;
  }

  if (!objectId) {
    pm.logger.error('RolesService~fetchObjectRoles: No object ID provided');
    return;
  }

  return __WEBPACK_IMPORTED_MODULE_0__SyncRemoteFetcherService__["a" /* default */].
  remoteFetch(ROLES, 'object', { objectType, objectId }).
  then(response => ({ roles: _.get(response, 'listing', {}) }));
}

/**
   * Fetches the roles for a given object type
   * @param {*} objectType
   *
   * @private
   */
function _fetchObjectTypeRoles(objectType) {
  if (!objectType) {
    pm.logger.error('RolesService~fetchObjectTypeRoles: No object type provided');
    return;
  }

  return __WEBPACK_IMPORTED_MODULE_0__SyncRemoteFetcherService__["a" /* default */].
  remoteFetch(ROLES, 'objectType', { objects: [objectType] }).
  then(response => ({ roles: _.get(response, 'objects', {}) }));
}

/**
   * Fetches the roles for a given object type
   * @param {*} objectType
   *
   * @private
   */
function _fetchObjectTypeDefaultRoles(objectType) {
  if (!objectType) {
    pm.logger.error('RolesService~fetchObjectRoles: No object type provided');
    return;
  }

  return __WEBPACK_IMPORTED_MODULE_0__SyncRemoteFetcherService__["a" /* default */].
  remoteFetch(ROLES, 'default', { objectType }).
  then(response => ({ roles: _.get(response, 'data.listing', {}) }));
}

/**
   * Fetches default and all roles for an object type
   *
   * @private
   */
async function _fetchRoles(objectType) {
  if (!objectType) {
    pm.logger.error('RolesService~fetchRoles: No object type specified to fetch roles');
    return;
  }
  let data = await Promise.all([
  _fetchObjectTypeDefaultRoles(objectType),
  _fetchObjectTypeRoles(objectType)]),

  defaultRolesData = _.get(data, '[0].roles'),
  rolesList = _.get(data, `[1].roles.${objectType}`),
  defaultRoles = _getDefaultRolesMap(objectType, defaultRolesData),
  superRoles = _getSuperRoles(rolesList),
  currentUser = Object(__WEBPACK_IMPORTED_MODULE_1__stores_get_store__["getStore"])('CurrentUserStore'),
  userId = _.get(currentUser, 'id'),
  teamId = _.get(currentUser, 'team.id'),
  userCurrentRoles = {
    [userId]: {
      type: 'user',
      id: userId,
      name: _.get(defaultRoles, 'user') } },


  teamCurrentRole = {
    [teamId]: {
      type: 'team',
      id: teamId,
      name: _.get(defaultRoles, 'team') } };



  return { rolesList, defaultRoles, superRoles, userCurrentRoles, teamCurrentRole };
}

/**
   * Fetches the roles for the given object
   */
async function _fetchAssociatedRoles(objectType, objectId) {
  if (!objectType || !objectId) {
    pm.logger.error('RolesService~fetchAssociatedRoles: No object type or id specified to fetch roles');
    return;
  }
  let data = await Promise.all([
  _fetchRoles(objectType),
  _fetchObjectRoles(objectType, objectId)]);


  let rolesList = _.get(data, '0.rolesList', {}),
  currentRoles = _.get(data, '1.roles', {}),
  defaultRoles = _.get(data, '0.defaultRoles'),
  superRoles = _.get(data, '0.superRoles'),
  userCurrentRoles = _.reduce(_.get(currentRoles, 'user'), (acc, userCurrentRole, userId) => {
    acc[userId] = {
      type: 'user',
      id: userId,
      name: _.get(userCurrentRole, 'roles.0') };


    return acc;
  }, {}),
  teamCurrentRole = _.reduce(_.get(currentRoles, 'team'), (acc, teamCurrentRole, teamId) => {
    acc[teamId] = {
      type: 'team',
      id: teamId,
      name: _.get(teamCurrentRole, 'roles.0') };


    return acc;
  }, {});

  return { defaultRoles, rolesList, userCurrentRoles, teamCurrentRole, superRoles };
}

/**
   * Updates the roles for the given collection
   *
   * @private
   */
async function _updateCollectionRoles(roles, teamRole, collectionUID) {
  let rolesData = await getRolesData(roles, teamRole, COLLECTION_MODEL, collectionUID),
  updateCollectionRolesData = {
    id: collectionUID,
    data: rolesData,
    model: COLLECTION_MODEL };


  return __WEBPACK_IMPORTED_MODULE_0__SyncRemoteFetcherService__["a" /* default */].
  remoteFetch(ROLES, 'collection', updateCollectionRolesData);
}

/**
   * Updates the roles for the given API
   *
   * @private
   */
async function _updateAPIRoles(roles, teamRole, apiId) {
  let rolesData = await getRolesData(roles, teamRole, 'api', apiId),
  updateAPIRolesData = {
    id: apiId,
    data: rolesData,
    model: API_MODEL };


  return __WEBPACK_IMPORTED_MODULE_0__SyncRemoteFetcherService__["a" /* default */].
  remoteFetch(ROLES, 'api', updateAPIRolesData);
}

/**
   * Helper function to return role data to be used to assign/updates roles of entities
   *
   * @param { Object } roles
   * @param { Object } teamRole
   * @param { String } entityType
   * @param { String } entityId
   */
async function getRolesData(roles, teamRole, entityType, entityId) {
  let rolesData = {
    roles: _.chain(roles).
    map(role => {
      return _generateRoleObject(role, entityType, entityId);
    }).
    compact().
    value() };


  if (!_.isEmpty(teamRole)) {
    let teamRoleData = _generateRoleObject(teamRole, entityType, entityId);
    !_.isEmpty(teamRoleData) && rolesData.roles.push(teamRoleData);
  }

  return rolesData;
}

/**
   * Updates the roles for the given entity
   *
   * @param {String} entityType Type of the entity
   * @param {String} entityId UID of the entity
   * @param {Array<Object>} roles user roles to be applied to the entity
   * @param {*} teamRole team role to be assigned to the entity
   */
async function updateEntityRoles(entityType, entityId, userRoles, teamRole) {
  switch (entityType) {
    case 'collection':return _updateCollectionRoles(userRoles, teamRole, entityId);
    case 'api':return _updateAPIRoles(userRoles, teamRole, entityId);
    default:return Promise.reject(new Error(`RolesService~updateEntityRoles: Unsupported entity provided of type ${entityType}`));}

}

/**
   * Fetches entity roles
   */
async function fetchEntityRoles(entityType, entityId) {

  if (!ENTITY_TYPE_HANDLER_MAP[entityType]) {
    return Promise.reject(new Error(`RolesService~updateEntityRoles: Unsupported entity provided of type ${entityType}`));
  }

  let { defaultRoles, userCurrentRoles, teamCurrentRole, rolesList, superRoles } = await ENTITY_TYPE_HANDLER_MAP[entityType](entityId);

  return {
    rolesList,
    userCurrentRoles,
    teamCurrentRole,
    superRoles,
    defaultRoles };

}

/**
   * Checks if the selected role can be overridden by the super role
   * or not
   *
   * @param {Object} superRolesList
   * @param {String} superRole
   * @param {String} selectedRole
   */
function shouldOverrideRole(superRolesList, superRole, selectedRole) {
  if (_.isEmpty(superRolesList) || !superRole || !selectedRole) {
    return false;
  }

  return _.includes(superRolesList[superRole], selectedRole);
}

/**
   * Returns team default role payload
   * @param defaultRoles List of default roles
   */
function getTeamDefaultRole(defaultRoles) {
  let teamId = _.get(Object(__WEBPACK_IMPORTED_MODULE_1__stores_get_store__["getStore"])('CurrentUserStore'), 'team.id'),
  teamDefaultRole = _.get(defaultRoles, 'team', {});

  if (!teamId || _.isEmpty(defaultRoles) || _.isEmpty(teamDefaultRole)) {
    return {};
  }

  return {
    [teamId]: {
      id: teamId,
      name: _.get(defaultRoles, 'team', ''),
      type: 'team' } };


}
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 3594:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (immutable) */ __webpack_exports__["e"] = fetchEntityMeta;
/* harmony export (immutable) */ __webpack_exports__["c"] = createTeamAndShareCollection;
/* harmony export (immutable) */ __webpack_exports__["d"] = createTeamAndShareEnvironment;
/* harmony export (immutable) */ __webpack_exports__["g"] = shareEntities;
/* harmony export (immutable) */ __webpack_exports__["h"] = shareEntity;
/* harmony export (immutable) */ __webpack_exports__["f"] = isEntityShared;
/* harmony export (immutable) */ __webpack_exports__["a"] = canEntityBeShared;
/* harmony export (immutable) */ __webpack_exports__["b"] = canManageRolesOnEntity;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__model_event__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__controllers_UserController__ = __webpack_require__(39);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__UserInvitationService__ = __webpack_require__(3626);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__SyncRemoteFetcherService__ = __webpack_require__(139);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__PermissionRemoteFetchService__ = __webpack_require__(3775);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__RemoteSyncRequestService__ = __webpack_require__(371);








/**
                                                                     * Controller map for the an entity
                                                                     * which is used for fetching and returning the correct
                                                                     * modelId based on the model of the entity
                                                                     */

/**
                                                                         * Starts a team and shares the entities with the team
                                                                         *
                                                                         * @private
                                                                         * @param {Object} data
                                                                         * @returns {Promise} resolves with response data
                                                                         */
async function _createTeamAndShareEntities(data) {
  return new Promise((resolve, reject) => {
    Object(__WEBPACK_IMPORTED_MODULE_3__UserInvitationService__["d" /* shareEntitiesToStartTeam */])(data, (err, response) => {
      if (err) {
        reject(err);
        return;
      }

      resolve(response);
    });
  });
}

/**
  * Checks if the collection has already been shared previously
  * or not
  *
  * @private
  * @param {String} collectionUID
  * @returns {Boolean} isShared
  */
async function isCollectionShared(collectionUID) {
  let user = await __WEBPACK_IMPORTED_MODULE_2__controllers_UserController__["a" /* default */].get(),
  currentTeamId = _.get(user, 'organizations[0].id');

  if (!currentTeamId) {
    return false;
  }

  return __WEBPACK_IMPORTED_MODULE_4__SyncRemoteFetcherService__["a" /* default */].
  remoteFetch('share', 'collection', { model: 'collection', id: collectionUID }).
  then(response => {
    let teamId = _.get(response, 'data.team');
    return teamId === currentTeamId;
  });
}

/**
  * Checks if the api has already been shared previously
  * or not
  *
  * @private
  * @param {String} apiId
  * @returns {Boolean} isShared
  */
async function isAPIShared(apiId) {
  let user = await __WEBPACK_IMPORTED_MODULE_2__controllers_UserController__["a" /* default */].get(),
  currentTeamId = _.get(user, 'organizations[0].id');

  if (!currentTeamId) {
    return false;
  }

  return __WEBPACK_IMPORTED_MODULE_4__SyncRemoteFetcherService__["a" /* default */].
  remoteFetch('share', 'api', { model: 'apis', id: apiId }).
  then(response => {
    let teamId = _.get(response, 'data.team');
    return teamId === currentTeamId;
  });
}


/**
  * Fetches the meta for entity
  *
  * @private
  * @param {String} entityType
  * @param {String} entityId
  * @returns {Promise}
  */
async function _fetchEntityMeta(entityType, entityId) {
  let url = `/${entityType}/${entityId}?meta=true`;

  return __WEBPACK_IMPORTED_MODULE_6__RemoteSyncRequestService__["a" /* default */].request(url, { method: 'get' }).
  then(({ body }) => {
    return body.data;
  }).
  catch(error => {
    return Promise.reject(error);
  });
}

/**
   * Fetches the entity meta
   *
   * @param {String} entityType - The entity type
   * @param {String} entityId - The id of the entity - could be uid / id - depends on the model
   * @returns {Object} fetchedEntity - The fetched meta of the entity
   */
async function fetchEntityMeta(entityType, entityId) {
  switch (entityType) {
    case 'environment':
    case 'collection':
      return _fetchEntityMeta(entityType, entityId);

    case 'api':
      return _fetchEntityMeta('apis', entityId);}

}

/**
   * Creates a team and shares the collection with the new team
   *
   * @param {String} collectionUID
   * @param {Object[]} invitations
   * @returns {Promise} _createTeamAndShareEntities - resolves with response data
   */
async function createTeamAndShareCollection(collectionUID, invitations) {
  let data = {
    dependencies: {
      collections: {
        $diff: true,
        $add: [collectionUID] } },


    invitations };


  return _createTeamAndShareEntities(data);
}

/**
   * Creates a team and shares the environment
   *
   * @param {String} environmentUID
   * @param {Object[]} invitations
   * @returns {Promise} _createTeamAndShareEntities - resolves with response data
   */
async function createTeamAndShareEnvironment(environmentUID, invitations) {
  let data = {
    dependencies: {
      environments: {
        $diff: true,
        $add: [environmentUID] } },


    invitations };


  return _createTeamAndShareEntities(data);
}

/**
   * Share multiple entities with the team
   *
   * @param {Object[]} modelIdMap
   * @param {String} modelIdMap[].model - The model of the entity
   * @param {String} modelIdMap[].modelId - The modelId of the entity (UID)
   * @param {String} workspaceId - The workspaceId where the entities will be shared into
   * @param {Object} [opts] - Additional options
   * @returns {Promise} dispatchEvents - Resolves with the data from multiple dispatch events
   */
async function shareEntities(modelIdMap, workspaceId, opts = {}) {
  if (_.isEmpty(modelIdMap) || !_.isArray(modelIdMap)) {
    return Promise.reject('ShareEntityService~shareEntities: Please provide an entity to share.');
  }

  if (!workspaceId) {
    return Promise.reject('ShareEntityService~shareEntities: Please provide a workspace to share the entity.');
  }

  let eventData = {
    dependencies: modelIdMap,
    model: 'workspace',
    workspace: { id: workspaceId } },

  origin = _.get(opts, 'origin', '');

  return Object(__WEBPACK_IMPORTED_MODULE_0__pipelines_user_action__["a" /* default */])(Object(__WEBPACK_IMPORTED_MODULE_1__model_event__["a" /* createEvent */])('shareDependencies', 'workspace', eventData, [], { origin }));
}

/**
   * Shares the entity with the team
   *
   * @param {Object} entity - The entity to be shared
   * @param {String} entity.model - The model of the entity
   * @param {String} entity.modelId - The modelId of the entity (UID)
   * @param {String} workspaceId - The workspaceId in which the entity will be shared
   * @param {Object} [opts] - Additional options
   */
async function shareEntity(entity, workspaceId, opts = {}) {
  if (_.isEmpty(entity)) {
    return Promise.reject('ShareEntitiesService~shareEntity: No entity provided.');
  }

  if (!workspaceId) {
    return Promise.reject('ShareEntitiesService~shareEntity: No workspace provided.');
  }

  let eventData = {
    dependencies: [entity],
    model: 'workspace',
    workspace: { id: workspaceId } },

  dependencyAddEvent = Object(__WEBPACK_IMPORTED_MODULE_1__model_event__["a" /* createEvent */])('shareDependencies', 'workspace', eventData, []);

  // Dispatch event for updating the entity
  return Object(__WEBPACK_IMPORTED_MODULE_0__pipelines_user_action__["a" /* default */])(dependencyAddEvent);
}

/**
   * Checks if the entity is shared with the team or not
   *
   * @param {String} entityType
   * @param {String} entityId
   */
async function isEntityShared(entityType, entityId) {
  if (!entityType || !entityId) {
    return Promise.reject(new Error(`ShareEntitiesService~isEntityShared: Unsupported entity of type ${entityType} provided with ID: ${entityId}`));
  }

  switch (entityType) {
    case 'collection':
      return isCollectionShared(entityId);
    case 'api':
      return isAPIShared(entityId);
    default:
      return Promise.reject(new Error(`ShareEntitiesService~isEntityShared: Unsupported entity of type ${entityType} provided with ID: ${entityId}`));}

}

/**
   * Checks if the entity can be shared or not
   *
   * @param {String} entityType
   * @param {String} entityId
   */
async function canEntityBeShared(entityType, entityId) {
  if (!entityType || !entityId) {
    return Promise.reject(new Error(`ShareEntitiesService~canEntityBeShared: Unsupported entity of type ${entityType} provided with ID: ${entityId}`));
  }

  switch (entityType) {
    case 'collection':
      return _.get((await Object(__WEBPACK_IMPORTED_MODULE_5__PermissionRemoteFetchService__["g" /* fetchCollectionShare */])(entityId)), `${entityId}.allowed`, false);
    case 'api':
      return _.get((await Object(__WEBPACK_IMPORTED_MODULE_5__PermissionRemoteFetchService__["b" /* fetchAPIShare */])(entityId)), `${entityId}.allowed`, false);
    default:
      return Promise.reject(new Error(`ShareEntitiesService~canEntityBeShared: Unsupported entity of type ${entityType} provided with ID: ${entityId}`));}

}

/**
   * Checks if the user can manage roles on a given entity
   *
   * @param {String} entityType
   * @param {String} entityId
   */
async function canManageRolesOnEntity(entityType, entityId) {
  if (!entityType || !entityId) {
    return Promise.reject(new Error(`ShareEntitiesService~canManageRolesOnEntity: Unsupported entity of type ${entityType} provided with ID: ${entityId}`));
  }

  switch (entityType) {
    case 'collection':
      return _.get((await Object(__WEBPACK_IMPORTED_MODULE_5__PermissionRemoteFetchService__["f" /* fetchCollectionManageRole */])(entityId)), `${entityId}.allowed`, false);
    case 'api':
      return _.get((await Object(__WEBPACK_IMPORTED_MODULE_5__PermissionRemoteFetchService__["a" /* fetchAPIManageRole */])(entityId)), `${entityId}.allowed`, false);
    default:
      return Promise.reject(new Error(`ShareEntitiesService~canManageRolesOnEntity: Unsupported entity of type ${entityType} provided with ID: ${entityId}`));}

}
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 3623:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.utils = exports.DataEditor = undefined;

var _DataEditor = __webpack_require__(4971);

var _DataEditor2 = _interopRequireDefault(_DataEditor);

var _utils = __webpack_require__(3537);

var _utils2 = _interopRequireDefault(_utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.DataEditor = _DataEditor2.default;
exports.utils = _utils2.default;

/***/ }),

/***/ 3624:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return InviteUser; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__utils_util__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__Icons_CloseIcon__ = __webpack_require__(90);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__Icons_ProfileIcon__ = __webpack_require__(3742);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__XPaths_XPath__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__constants_ShareFlowConstants__ = __webpack_require__(3625);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__permissions_RolesList__ = __webpack_require__(4023);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__DropZone__ = __webpack_require__(1513);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__LoadingIndicator__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__workspaces_BulkInvite_BulkInvite__ = __webpack_require__(5058);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__Avatar__ = __webpack_require__(651);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__Icons_MailIcon__ = __webpack_require__(5059);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__Icons_AddIcon__ = __webpack_require__(957);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__Icons_UploadIcon__ = __webpack_require__(5060);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__Dropdowns__ = __webpack_require__(31);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__modules_services_AnalyticsService__ = __webpack_require__(16);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _class;





















const EMAIL_REGEX = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/,
EMAIL_SEPARATOR_REGEX = /[\n\t ,]+/,
ACCEPTED_FILE_TYPES = ['text/plain', 'text/csv'],
MAXIMUM_FILE_SIZE = 1; // in MB


const EmptyState = props => {
  return (
    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_0_react__["Fragment"], null,
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', {
          onClick: props.onUploadClick,
          className: 'upload' }, 'Upload\xA0'), 'or drag and drop a .csv or .txt file to bulk invite people'));






};let


InviteUser = Object(__WEBPACK_IMPORTED_MODULE_6_mobx_react__["a" /* observer */])(_class = class InviteUser extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      users: props.users || {},
      teamMembers: [],
      inputError: false,
      userEmails: props.userEmails || [],
      invalidEmails: [],
      warningText: '',
      uploading: false,
      tags: [] };


    this.handleTeamMembersChange = this.handleTeamMembersChange.bind(this);
    this.addUser = this.addUser.bind(this);
    this.removeUser = this.removeUser.bind(this);
    this.getUserSuggestions = this.getUserSuggestions.bind(this);
    this.handleEmailError = this.handleEmailError.bind(this);

    this.handleChangeUserRole = this.handleChangeUserRole.bind(this);
    this.handleChangeTeamRole = this.handleChangeTeamRole.bind(this);
    this.handleTagsChange = this.handleTagsChange.bind(this);

    this.handleUploadClick = this.handleUploadClick.bind(this);
    this.handleDropFile = this.handleDropFile.bind(this);

    this.renderAddOptions = this.renderAddOptions.bind(this);
    this.handleDropdownSelect = this.handleDropdownSelect.bind(this);
  }

  componentDidMount() {
    this.handleTeamMembersChange();
  }

  handleTagsChange(tags) {
    this.setState({ tags });
  }

  handleTeamMembersChange() {
    let currentUser = Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('CurrentUserStore'),
    orgs = currentUser.organizations,
    teamMembers = [];

    if (!_.isEmpty(orgs) && currentUser.teamSyncEnabled) {
      teamMembers = orgs[0].team_users;
    }

    this.setState({ teamMembers });
  }

  handleChangeTeamRole(teamId, role) {
    let teamRole = {
      [teamId]: {
        id: teamId,
        type: 'team',
        name: role } };



    this.props.onChange && this.props.onChange('teamCurrentRole', teamRole);
  }

  handleChangeUserRole(userId, type, role) {
    let userRoles = _extends({},
    this.props.userCurrentRoles, {
      [userId]: {
        type,
        id: userId,
        name: role } });



    this.props.onChange && this.props.onChange('userCurrentRoles', userRoles);
  }

  handleEmailError() {
    this.props.handleEmailError &&
    this.props.handleEmailError({ showInviteDeniedError: true });
  }

  canAddMember() {
    return this.props.canAddMember;
  }

  canRemoveMember(userId) {
    return this.props.canRemoveMember || _.get(this.state, `users.${userId}.canRemove`);
  }

  /**
     * Splits and trims the input based on a regex pattern if file is being uploaded
     *
     * If not uploading, returns an object of valid and invalid emails
     *
     * @param {String} invitees Emails
     *
     * @returns {Object} Object containing array of valid and invalid emails
     */
  bulkInvite(invitees) {
    let validEmails = [],
    invalidEmails = this.state.invalidEmails;

    _.map(invitees, invitee => {
      if (invitee.type === 'error') {
        invalidEmails.push(invitee.value);

        return;
      }

      validEmails.push(invitee.value);
    });

    return {
      validEmails: _.uniq(validEmails),
      invalidEmails: _.uniq(invalidEmails) };

  }

  addUser(invitees) {
    if (!this.canAddMember()) {
      pm.toasts.error(__WEBPACK_IMPORTED_MODULE_9__constants_ShareFlowConstants__["u" /* PERMISSION_DENIED_ERROR */]);

      return;
    }

    if (_.isEmpty(invitees)) {
      pm.toasts.error('Please enter an email');

      return;
    }

    this.setState({ uploading: true });

    const { validEmails, invalidEmails } = this.bulkInvite(invitees),
    currentUser = Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('CurrentUserStore');

    __WEBPACK_IMPORTED_MODULE_19__modules_services_AnalyticsService__["a" /* default */].addEvent('app', 'bulk_invite', 'user_invite', validEmails.length, null, { noActiveWorkspace: true });

    let users = this.state.users,
    userRoles = this.props.userCurrentRoles,
    userEmails = this.state.userEmails;

    validEmails.map(email => {
      const user = __WEBPACK_IMPORTED_MODULE_2__utils_util__["a" /* default */].findUserInTeam({ email }, currentUser);

      if (!user && userEmails.includes(email)) {
        pm.toasts.error(`${email} is already added.`, { persist: true });
      } else
      if (!user) {
        userEmails.push(email);
      } else
      if (!users[user.id]) {
        users = _extends({},
        users, {
          [user.id]: _extends({}, user, { teamPermissions: this.props.teamPermissions, canRemove: true }) });

        userRoles = _extends({},
        userRoles, {
          [user.id]: {
            type: 'user',
            id: user.id,
            name: this.props.canUpdateRoles ? _.get(this.props.defaultRoles, __WEBPACK_IMPORTED_MODULE_9__constants_ShareFlowConstants__["B" /* USER_ENTITY_TYPE */]) : '' } });


      } else
      {
        pm.toasts.error(`${user.name} is already added.`, { persist: true });
      }
    });

    // Reset tags if not uploading
    this.setState({ users, userEmails, uploading: false, invalidEmails, tags: [] });

    this.props.onChange && this.props.onChange('invalidEmails', invalidEmails);
    this.props.onChange && this.props.onChange('userEmails', userEmails);
    this.props.onAddMember && this.props.onAddMember({ members: users, userCurrentRoles: userRoles });
  }

  removeUser(userId) {
    if (!this.canRemoveMember(userId)) {
      pm.toasts.error(__WEBPACK_IMPORTED_MODULE_9__constants_ShareFlowConstants__["u" /* PERMISSION_DENIED_ERROR */]);
      return;
    }

    let users = _.omit(this.state.users, userId),
    userRoles = _.omit(this.props.userCurrentRoles, userId);

    this.setState({ users });
    this.props.onRemoveMember && this.props.onRemoveMember({ members: users, userCurrentRoles: userRoles });
  }

  removeEmail(email) {
    const isEmailValid = this.isValidEmail(email);

    if (!isEmailValid) {
      let invalidEmails = _.filter(this.state.invalidEmails, invalidEmail => {
        return invalidEmail !== email;
      });

      this.setState({ invalidEmails });

      this.props.onChange && this.props.onChange('invalidEmails', invalidEmails);

      return;
    }

    let userEmails = _.filter(this.state.userEmails, userEmail => {
      return userEmail !== email;
    });
    this.setState({ userEmails });

    this.props.onChange && this.props.onChange('userEmails', userEmails);
  }

  isValidEmail(email) {
    return EMAIL_REGEX.test(email);
  }

  getUserSuggestions() {
    return _.map(this.state.teamMembers, user => {
      return {
        email: user.email,
        name: user.username,
        id: user.id };

    });
  }

  getClasses() {
    return __WEBPACK_IMPORTED_MODULE_1_classnames___default()({
      'add-user__list': true,
      'show-roles': !this.props.hideRoles });

  }

  getEmailItemClasses(isEmailValid) {
    return __WEBPACK_IMPORTED_MODULE_1_classnames___default()({
      'add-user__item': true,
      'invalid-email': !isEmailValid });

  }

  getInviteStatus(canManageTeamInvites) {
    if (canManageTeamInvites) {
      return 'Invite Pending';
    }

    return 'Pending Approval';
  }

  readFile(file, callback) {
    if (!file) {
      return;
    }

    const reader = new FileReader();

    reader.onloadstart = () => {
      this.setState({ uploading: true });
    };

    reader.onload = () => {
      this.setState({ uploading: false });

      let invitees = [];

      _.map(_.split(reader.result, EMAIL_SEPARATOR_REGEX), invitee => {
        let email = invitee.trim();

        if (EMAIL_REGEX.test(email)) {
          invitees.push({ value: email, type: 'regular' });

          return;
        }

        invitees.push({ value: email, type: 'error' });
      });

      callback(invitees);
    };

    reader.onerror = () => {
      reader.abort();

      this.setState({ uploading: false });

      pm.toasts.error('There was an error uploading your file. Please try again');
    };

    reader.readAsText(file);
  }

  handleDropFile(files) {
    if (!_.includes(ACCEPTED_FILE_TYPES, _.get(files, '0.type'))) {
      pm.toasts.error('Only CSV and txt files can be uploaded');

      return;
    }

    // Converting from bytes to MB. File size is always a number, hence so safe-check needed
    if (_.get(files, '0.size') / 1024 / 1024 > MAXIMUM_FILE_SIZE) {
      pm.toasts.error(`File size is larger than ${MAXIMUM_FILE_SIZE}MB,
        only files less than ${MAXIMUM_FILE_SIZE}MB are supported.`);

      return;
    }

    _.size(files) && this.readFile(files[0], this.addUser);
  }

  handleUploadClick() {
    // https://github.com/react-dnd/react-dnd/issues/378
    let inviteFileInstance = _.invoke(this.refs, 'inviteFileUpload.getDecoratedComponentInstance');

    _.invoke(inviteFileInstance, 'open');
  }

  renderTagContent(tagProps) {
    const currentUser = Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('CurrentUserStore'),
    user = __WEBPACK_IMPORTED_MODULE_2__utils_util__["a" /* default */].findUserInTeam({ email: tagProps.value }, currentUser),
    tagValue = user ? user.username : tagProps.value;

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'invite-user-tag' },

        user ?
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_14__Avatar__["a" /* default */], {
          size: 'small',
          userId: user.id }) :


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_15__Icons_MailIcon__["a" /* default */], null),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { title: tagValue, className: 'user-email' }, tagValue)));


  }

  renderEmail(email) {
    const isEmailValid = this.isValidEmail(email);

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
          className: this.getEmailItemClasses(isEmailValid),
          key: email },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-user__item__label' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-user__item__anonymous-icon-container' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__Icons_ProfileIcon__["a" /* default */], null)),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'add-user__avatar-name' }, email),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'add-user__invite-pending' },
            isEmailValid ? this.getInviteStatus(this.props.canManageTeamInvites) : 'Invalid Email')),



        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__Icons_CloseIcon__["a" /* default */], {
          className: 'add-user__delete-icon',
          onClick: this.removeEmail.bind(this, email) })));




  }

  handleDropdownSelect(type) {
    switch (type) {
      case 'upload':
        this.handleUploadClick();
        break;}

  }

  renderAddOptions() {
    const options = [
    {
      type: 'upload',
      label: 'Upload .csv or .txt',
      icon: __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_17__Icons_UploadIcon__["a" /* default */], { size: 'xs' }) }];



    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_18__Dropdowns__["c" /* DropdownMenu */], {
          fluid: true,
          targetRef: this.refs.addUserOptions },


        _.map(options, option => {
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_18__Dropdowns__["d" /* MenuItem */], { key: option.type, refKey: option.type },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-user__option' },
                option.icon,
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, option.label))));



        })));



  }

  render() {
    const currentUserStore = Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('CurrentUserStore'),
    teamId = _.get(currentUserStore, 'team.id'),
    emails = [...this.state.invalidEmails, ...this.state.userEmails],
    showEmptyState = _.isEmpty(emails) && _.isEmpty(this.state.users);

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__XPaths_XPath__["a" /* default */], { identifier: 'inviteUsers' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_11__DropZone__["a" /* DropZone */], {
            disableFileInput: true,
            className: 'invite-users-file-drop',
            multiple: false,
            ref: 'inviteFileUpload',
            type: 'file',
            onDropFile: this.handleDropFile },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: this.getClasses() },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { ref: 'inviteRef', className: 'add-user__item add-user__input' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_18__Dropdowns__["a" /* Dropdown */], { onSelect: this.handleDropdownSelect },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_18__Dropdowns__["b" /* DropdownButton */], {
                    dropdownStyle: 'nocaret',
                    size: 'small' },

                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__Buttons__["a" /* Button */], null,
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_16__Icons_AddIcon__["a" /* default */], {
                      size: 'xs' }))),



                this.renderAddOptions()),

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__XPaths_XPath__["a" /* default */], { identifier: 'emailInput' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_13__workspaces_BulkInvite_BulkInvite__["a" /* default */], {
                  inviteRef: this.refs.inviteRef,
                  disableTeamSuggestions: this.props.disableTeamSuggestions,
                  suggestions: this.getUserSuggestions(),
                  tags: this.state.tags,
                  onTagsChange: this.handleTagsChange,
                  renderTagContent: this.renderTagContent,
                  tagValidator: this.isValidEmail })),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__XPaths_XPath__["a" /* default */], { identifier: 'add' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__Buttons__["a" /* Button */], {
                    className: 'add-user__button',
                    type: 'text',
                    onClick: () => this.addUser(this.state.tags) }, 'Add'))),






            showEmptyState ?
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'empty-state--no-users' },

              this.state.uploading ?
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_12__LoadingIndicator__["a" /* default */], null) :
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(EmptyState, {
                onUploadClick: this.handleUploadClick })) :




            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'item-roles__container' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-user-list-container' },

                _.map(emails, this.renderEmail.bind(this)),

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__permissions_RolesList__["a" /* default */], {
                  hideRoles: this.props.hideRoles,
                  members: this.state.users,
                  rolesList: this.props.allRoles,
                  selectedUserRoles: this.props.userCurrentRoles,
                  teamRole: _.get(this.props.teamCurrentRole, teamId),
                  superRoles: this.props.superRoles,
                  canModifyMembers: this.props.canRemoveMember,
                  fallbackRole: 'Select Role',
                  showOverrideWarning: !this.props.limitVisibility,
                  onChange: this.handleChangeUserRole,
                  onRemoveMember: this.removeUser,
                  canUpdateRoles: this.props.canUpdateRoles })))))));








  }}) || _class;


InviteUser.defaultProps = {
  isDeleteActionEnabled() {
    return true;
  },
  canAddMember: true,
  canRemoveMember: true,
  canUpdateRoles: true };
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 3625:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
const WORKSPACE_ENTITY_TYPE = 'workspace',
USER_ENTITY_TYPE = 'user',
TEAM_ENTITY_TYPE = 'team',
API_ENTITY_TYPE = 'api',
COLLECTION_ENTITY_TYPE = 'collection',
NOT_SHARED = 'notShared',
NO_PERMISSION = 'noPermission',
NO_TEAM = 'noTeam',
NO_MANAGE_PERMISSION = 'noManagePermission',
SYNC_OFFLINE_MESSAGE_SHARE = 'Make sure you\’re online if you want to share',
SYNC_OFFLINE_MESSAGE_MANAGE = 'Make sure you\’re online if you want to manage roles',
FETCH_ROLES_FAILED_COLLECTION = 'Something went wrong while fetching roles for this collection',
FETCH_ROLES_FAILED_API = 'Something went wrong while fetching roles for this API',
FETCH_FAILED_WORKSPACES = 'Something went wrong while fetching the workspaces.',
UPDATE_ROLES_FAILED_COLLECTION = 'Something went wrong while updating roles for this collection',
UPDATE_ROLES_FAILED_API = 'Something went wrong while updating roles for this API',
SHARE_FAILED_COLLECTION = 'Something went wrong while sharing this collection',
SHARE_FAILED_API = 'Something went wrong while sharing this API',
COLLECTION_SHARE_SUCCESS = 'Collection shared successfully',
API_SHARE_SUCCESS = 'API shared successfully',
COLLECTION_NOT_SHARED_ERROR = 'Share this collection to a team workspace to manage the roles',
API_NOT_SHARED_ERROR = 'Share this API to a team workspace to manage the roles',
COLLECTION_MANAGE_ROLES_ERROR = 'You don’t have permission to manage the roles and permissions on this collection. ',
API_MANAGE_ROLES_ERROR = 'You don’t have permission to manage the roles and permissions on this API.',
COLLECTION_NO_PERMISSION_ERROR = 'You do not have permission to share this collection',
API_NO_PERMISSION_ERROR = 'You do not have permission to share this API',
PERMISSION_DENIED_ERROR = 'You don’t have permission to perform this action',
NO_ROLES_TO_MANAGE = 'No roles to manage',
NO_TEAM_FOUND_TITLE = 'API is not shared yet',
NO_TEAM_FOUND_BODY = 'Share this API to a team workspace to manage the roles';
/* harmony export (immutable) */ __webpack_exports__["C"] = WORKSPACE_ENTITY_TYPE;

/* harmony export (immutable) */ __webpack_exports__["B"] = USER_ENTITY_TYPE;

/* unused harmony export TEAM_ENTITY_TYPE */

/* harmony export (immutable) */ __webpack_exports__["a"] = API_ENTITY_TYPE;

/* harmony export (immutable) */ __webpack_exports__["f"] = COLLECTION_ENTITY_TYPE;

/* harmony export (immutable) */ __webpack_exports__["n"] = NOT_SHARED;

/* harmony export (immutable) */ __webpack_exports__["p"] = NO_PERMISSION;

/* harmony export (immutable) */ __webpack_exports__["r"] = NO_TEAM;

/* harmony export (immutable) */ __webpack_exports__["o"] = NO_MANAGE_PERMISSION;

/* harmony export (immutable) */ __webpack_exports__["y"] = SYNC_OFFLINE_MESSAGE_SHARE;

/* harmony export (immutable) */ __webpack_exports__["x"] = SYNC_OFFLINE_MESSAGE_MANAGE;

/* harmony export (immutable) */ __webpack_exports__["m"] = FETCH_ROLES_FAILED_COLLECTION;

/* harmony export (immutable) */ __webpack_exports__["l"] = FETCH_ROLES_FAILED_API;

/* harmony export (immutable) */ __webpack_exports__["k"] = FETCH_FAILED_WORKSPACES;

/* harmony export (immutable) */ __webpack_exports__["A"] = UPDATE_ROLES_FAILED_COLLECTION;

/* harmony export (immutable) */ __webpack_exports__["z"] = UPDATE_ROLES_FAILED_API;

/* harmony export (immutable) */ __webpack_exports__["w"] = SHARE_FAILED_COLLECTION;

/* harmony export (immutable) */ __webpack_exports__["v"] = SHARE_FAILED_API;

/* harmony export (immutable) */ __webpack_exports__["j"] = COLLECTION_SHARE_SUCCESS;

/* harmony export (immutable) */ __webpack_exports__["e"] = API_SHARE_SUCCESS;

/* harmony export (immutable) */ __webpack_exports__["h"] = COLLECTION_NOT_SHARED_ERROR;

/* harmony export (immutable) */ __webpack_exports__["c"] = API_NOT_SHARED_ERROR;

/* harmony export (immutable) */ __webpack_exports__["g"] = COLLECTION_MANAGE_ROLES_ERROR;

/* harmony export (immutable) */ __webpack_exports__["b"] = API_MANAGE_ROLES_ERROR;

/* harmony export (immutable) */ __webpack_exports__["i"] = COLLECTION_NO_PERMISSION_ERROR;

/* harmony export (immutable) */ __webpack_exports__["d"] = API_NO_PERMISSION_ERROR;

/* harmony export (immutable) */ __webpack_exports__["u"] = PERMISSION_DENIED_ERROR;

/* harmony export (immutable) */ __webpack_exports__["q"] = NO_ROLES_TO_MANAGE;

/* harmony export (immutable) */ __webpack_exports__["t"] = NO_TEAM_FOUND_TITLE;

/* harmony export (immutable) */ __webpack_exports__["s"] = NO_TEAM_FOUND_BODY;


/***/ }),

/***/ 3626:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (immutable) */ __webpack_exports__["c"] = inviteUsers;
/* harmony export (immutable) */ __webpack_exports__["e"] = startTeamWithUsers;
/* harmony export (immutable) */ __webpack_exports__["d"] = shareEntitiesToStartTeam;
/* harmony export (immutable) */ __webpack_exports__["a"] = activateTrialAndInviteUsers;
/* harmony export (immutable) */ __webpack_exports__["b"] = getTeamInviteLink;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__modules_services_APIService__ = __webpack_require__(174);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__modules_controllers_UserController__ = __webpack_require__(39);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__utils_util__ = __webpack_require__(19);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};




/**
                                      * Extracts the team invite link from response
                                      */
function extractInviteLink(response) {
  let { link } = _.head(_.get(response, 'multiuse_invitations', {}));
  return link || '';
}

/**
   *
   * @param {Array[String]} emails
   * @param {String} workspaceId
   * @param {String} teamId
   * @param {Function} cb
   */
function inviteUsers({ workspaceId, emails, teamId }, cb) {
  if (!workspaceId || !emails || !teamId) {
    return cb(new Error('Error in sending invites'), null);
  }

  __WEBPACK_IMPORTED_MODULE_1__modules_controllers_UserController__["a" /* default */].
  get().
  then(user => {
    let users = _.map(emails, email => {
      return {
        email,
        meta: { 'add-to-ws': workspaceId } };

    }),
    options = { user, users, teamId };

    Object(__WEBPACK_IMPORTED_MODULE_0__modules_services_APIService__["k" /* InviteUsers */])(options, (err, response) => {
      if (err || _.isEmpty(response)) {
        pm.logger.error('Error in sending invites', err);
        cb(err, null);
        return;
      }
      cb(null, response);
    });
  }).
  catch(err => {
    pm.logger.error(err);
    cb(err, null);
  });
}

/**
   *
   * @param {Array[String]} emails
   * @param {String} workspaceId
   * @param {String} teamId
   * @param {Function} cb
   */
function startTeamWithUsers(data, cb) {
  __WEBPACK_IMPORTED_MODULE_1__modules_controllers_UserController__["a" /* default */].
  get().
  then(user => {
    Object(__WEBPACK_IMPORTED_MODULE_0__modules_services_APIService__["y" /* startTeam */])({ data, user }, (err, response) => {
      if (err) {
        return cb(err);
      }

      cb(null, _extends({}, response, { inviteLink: extractInviteLink(response) }));
    });
  }).
  catch(err => {
    cb(err, null);
  });
}

/**
   * @method shareEntitiesToStartTeam
   * @param {Object} data
   * @param {Function} cb
   */
function shareEntitiesToStartTeam(data, cb) {
  __WEBPACK_IMPORTED_MODULE_1__modules_controllers_UserController__["a" /* default */].
  get().
  then(user => {
    Object(__WEBPACK_IMPORTED_MODULE_0__modules_services_APIService__["x" /* shareEntities */])({ data, user }, (err, response) => {
      if (err) {
        return cb(err);
      }

      cb(null, _extends({}, response, { inviteLink: extractInviteLink(response) }));
    });
  });
}

/**
   *
   * @param {Array[String]} emails
   * @param {String} workspaceId
   * @param {String} teamId
   * @param {Function} cb
   */
function activateTrialAndInviteUsers({ workspace, emails }, origin, cb) {
  if (!workspace || !emails) {
    return cb(new Error('Error in sending invites'), null);
  }

  __WEBPACK_IMPORTED_MODULE_1__modules_controllers_UserController__["a" /* default */].
  get().
  then(user => {
    let invitations = null;
    if (!_.isEmpty(emails)) {
      invitations = _.map(emails, email => {
        return { email };
      });
    }

    let data = { user, workspace, invitations },
    handlers = {
      'createWS': __WEBPACK_IMPORTED_MODULE_0__modules_services_APIService__["a" /* CreateWSAndInviteUsers */],
      'shareWS': __WEBPACK_IMPORTED_MODULE_0__modules_services_APIService__["p" /* ShareWSAndInviteUsers */] };


    handlers[origin](data, (err, response) => {
      if (err || _.isEmpty(response)) {
        cb(err, response);
        return;
      }
      cb(err, _extends({}, response, { inviteLink: extractInviteLink(response) }));
    });
  }).
  catch(err => {
    cb(err, null);
  });
}

/**
   * Fetches the invite link for a team
   */
function getTeamInviteLink(cb) {
  let fallbackError = {
    message: 'Failed to fetch invite link. Please try again.',
    result: 'error' };


  __WEBPACK_IMPORTED_MODULE_1__modules_controllers_UserController__["a" /* default */].
  get().
  then(user => {
    let organizationId = _.get(user, 'organizations[0].id', null);
    if (!organizationId) {
      return cb(new Error());
    }

    Object(__WEBPACK_IMPORTED_MODULE_0__modules_services_APIService__["s" /* fetchTeamInviteLink */])({ organizationId, user }, (err, response) => {
      if (err || _.isEmpty(response) || _.isEmpty(response.multiuse_invitations)) {
        return cb(err || fallbackError);
      }

      let link = extractInviteLink(response);

      link ? cb(null, link) : cb(fallbackError);
    });
  });
}
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 3675:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return DisabledOperationModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__modules_services_AuthHandlerService__ = __webpack_require__(532);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__external_navigation_ExternalNavigationService__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__constants_AppUrlConstants__ = __webpack_require__(64);




let

DisabledOperationModal = class DisabledOperationModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.handleEnableSync = this.handleEnableSync.bind(this);
  }

  handleEnableSync() {
    // open docs for sync disabled
    Object(__WEBPACK_IMPORTED_MODULE_3__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_4__constants_AppUrlConstants__["A" /* ENABLE_SYNC_DOCS_URL */]);
  }

  handleSignIn() {
    __WEBPACK_IMPORTED_MODULE_2__modules_services_AuthHandlerService__["a" /* default */].login();
  }

  handleSignUp() {
    __WEBPACK_IMPORTED_MODULE_2__modules_services_AuthHandlerService__["a" /* default */].login({ isSignup: true });
  }

  render() {
    let isLoggedIn = this.props.isLoggedIn,
    isSyncEnabled = this.props.isSyncEnabled;

    if (!isLoggedIn) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'disabled-operation-modal' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'disabled-operation-modal__icon' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'disabled-operation-modal__icon__icon' })),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'disabled-operation-modal__title' },

            this.props.entity === 'monitor' &&
            'Sign in to create a monitor',


            this.props.entity === 'mock' &&
            'Sign in to create a mock server',


            this.props.entity === 'documentation' &&
            'Sign in to create documentation',


            this.props.entity === 'template' &&
            'Sign in to use this template',


            this.props.entity === 'apiNetwork' &&
            'Sign in to import this collection',


            this.props.entity === 'workspace' &&
            'Sign in to create a workspace',


            this.props.entity === 'lesson' &&
            'Learn how to utilise Postman to its fullest'),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'disabled-operation-modal__subtitle' },

            this.props.entity === 'monitor' &&
            'You need to be signed in to be able to monitor your APIs. A Postman account also gives you access to other free services like Syncing, Mock servers & Public API Documentation.',


            this.props.entity === 'mock' &&
            'You need to be signed in to be able to create a mock server. A Postman account also gives you access to other free services like Syncing, Monitors & Public API Documentation.',


            this.props.entity === 'documentation' &&
            'You need to be signed in to be able to document your APIs. A Postman account also gives you access to other free services like Syncing, Mock servers & Monitoring.',


            this.props.entity === 'template' &&
            'You need to be signed in to be able to import templates. A Postman account also gives you access to other free services like Syncing, Mock servers, Public API Documentation & Monitoring.',


            this.props.entity === 'workspace' &&
            'You need to be signed in to be able to create workspaces. A Postman account also gives you access to other free services like Syncing, Mock servers, Public API Documentation & Monitoring.',


            this.props.entity === 'lesson' &&
            'You can learn about different features inside Postman by an interactive tutorial. Please create an account to continue.'),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'disabled-operation-modal__actions' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                type: 'primary',
                onClick: this.handleSignIn }, 'I have an account'),



            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                type: 'primary',
                onClick: this.handleSignUp }, 'Sign me up'))));






    }

    if (!isSyncEnabled) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'disabled-operation-modal' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'disabled-operation-modal__icon' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'disabled-operation-modal__icon__icon' })),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'disabled-operation-modal__title' },

            this.props.entity === 'monitor' &&
            'Enable Sync to create a monitor.',


            this.props.entity === 'mock' &&
            'Enable Sync to create a mock server.',


            this.props.entity === 'documentation' &&
            'Enable Sync to create documentation.',


            this.props.entity === 'template' &&
            'Enable Sync to use this template.',


            this.props.entity === 'workspace' &&
            'Enable Sync to create a workspace.'),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'disabled-operation-modal__subtitle' },

            this.props.entity === 'monitor' &&
            'You need to have Sync enabled in order to create a monitor. This allows the monitor to have access to your collection.',


            this.props.entity === 'mock' &&
            'You need to have Sync enabled in order to create a mock server. This allows the mock server to have access to your collection.',


            this.props.entity === 'documentation' &&
            'You need to have Sync enabled in order to create documentation. This allows the documentation to have access to your collection.',


            this.props.entity === 'template' &&
            'You need to have Sync enabled in order to use this template. This allows the template to have access to your collection.',


            this.props.entity === 'workspace' &&
            'You need to have Sync enabled in order to create a workspace.'),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'disabled-operation-modal__actions' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                type: 'primary',
                onClick: this.handleEnableSync }, 'Enable Sync'))));






    }
  }};

/***/ }),

/***/ 3676:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (immutable) */ __webpack_exports__["a"] = fetchPermissions;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__PermissionRemoteFetchService__ = __webpack_require__(3775);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__utils_util__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__controllers_WorkspaceController__ = __webpack_require__(56);





const PERMISSION_HANDLER_MAP = {

  /**
                                  * Checks if user has permission to add member to the workspace
                                  *
                                  * @param { String } workspaceId
                                  *
                                  * @returns { Boolean }
                                  */
  addMemberToWorkspace: async workspaceId => {
    let { type } = await __WEBPACK_IMPORTED_MODULE_3__controllers_WorkspaceController__["a" /* default */].get({ id: workspaceId });

    if (!Object(__WEBPACK_IMPORTED_MODULE_1__stores_get_store__["getStore"])('CurrentUserStore').team || type === 'personal') {
      return true;
    }

    try {
      return _.get((await Object(__WEBPACK_IMPORTED_MODULE_0__PermissionRemoteFetchService__["e" /* fetchAddMemberToWorkspaces */])([workspaceId])), `${workspaceId}.allowed`, true);
    }
    catch (e) {
      console.warn(e);

      return true;
    }
  },

  /**
      * Checks if user has permission to remove member to the workspace
      *
      * @param { String } workspaceId
      *
      * @returns { Boolean }
      */
  removeMemberFromWorkspace: async workspaceId => {
    let { type } = await __WEBPACK_IMPORTED_MODULE_3__controllers_WorkspaceController__["a" /* default */].get({ id: workspaceId });

    if (!Object(__WEBPACK_IMPORTED_MODULE_1__stores_get_store__["getStore"])('CurrentUserStore').team || type === 'personal') {
      return true;
    }

    try {
      return _.get((await Object(__WEBPACK_IMPORTED_MODULE_0__PermissionRemoteFetchService__["i" /* fetchRemoveMemberFromWorkspaces */])([workspaceId])), `${workspaceId}.allowed`, true);
    }
    catch (e) {
      console.warn(e);

      return true;
    }
  },

  /**
      * Checks if user has permission to update roles in the workspace
      *
      * @param { String } workspaceId
      *
      * @returns { Boolean }
      */
  updateWorkspaceRoles: async workspaceId => {
    let { type } = await __WEBPACK_IMPORTED_MODULE_3__controllers_WorkspaceController__["a" /* default */].get({ id: workspaceId });

    if (!Object(__WEBPACK_IMPORTED_MODULE_1__stores_get_store__["getStore"])('CurrentUserStore').team || type === 'personal') {
      return true;
    }

    try {
      return _.get((await Object(__WEBPACK_IMPORTED_MODULE_0__PermissionRemoteFetchService__["l" /* fetchUpdateWorkspacesRoles */])([workspaceId])), `${workspaceId}.allowed`, true);
    }
    catch (e) {
      console.warn(e);

      return true;
    }
  },

  /**
      * Checks if user has permission to update workspace meta
      *
      * @param { String } workspaceId
      *
      * @returns { Boolean }
      */
  updateWorkspaceMeta: async workspaceId => {
    let { type } = await __WEBPACK_IMPORTED_MODULE_3__controllers_WorkspaceController__["a" /* default */].get({ id: workspaceId });

    if (!Object(__WEBPACK_IMPORTED_MODULE_1__stores_get_store__["getStore"])('CurrentUserStore').team || type === 'personal') {
      return true;
    }

    try {
      return _.get((await Object(__WEBPACK_IMPORTED_MODULE_0__PermissionRemoteFetchService__["k" /* fetchUpdateWorkspacesMeta */])([workspaceId])), `${workspaceId}.allowed`, true);
    }
    catch (e) {
      console.warn(e);

      return true;
    }
  },

  /**
      * Checks if user has permission to send preapproved invites in a team
      *
      * @returns { Boolean }
      */
  manageTeamInvites: async () => {
    const user = Object(__WEBPACK_IMPORTED_MODULE_1__stores_get_store__["getStore"])('CurrentUserStore'),
    teamId = _.get(user, 'team.id');

    // A free user or the one for which the trial has been activated
    // can invite users outside the team.
    if (__WEBPACK_IMPORTED_MODULE_2__utils_util__["a" /* default */].isFreeUser(user) || __WEBPACK_IMPORTED_MODULE_2__utils_util__["a" /* default */].isTrialActive(user)) {
      return true;
    }

    try {
      return _.get((await Object(__WEBPACK_IMPORTED_MODULE_0__PermissionRemoteFetchService__["h" /* fetchManageTeamInvites */])(teamId)), `${teamId}.allowed`, true);
    }
    catch (e) {
      console.warn(e);

      return true;
    }
  },

  /**
      * Checks if user has permission to send unapproved invites in a team
      *
      * @returns { Boolean }
      */
  sendUnapprovedInvites: async () => {
    const user = Object(__WEBPACK_IMPORTED_MODULE_1__stores_get_store__["getStore"])('CurrentUserStore'),
    teamId = _.get(user, 'team.id');

    try {
      return _.get((await Object(__WEBPACK_IMPORTED_MODULE_0__PermissionRemoteFetchService__["j" /* fetchSendUnapprovedInvites */])(teamId)), `${teamId}.allowed`, false);
    }
    catch (e) {
      console.warn(e);

      return true;
    }
  } };


/**
        * Fetches permission status for an array of permissions
        * Check individual handlers for function definition
        *
        * @param { String[] } permissions
        * @param { String } entityId
        */
async function fetchPermissions(permissions = [], entityId) {
  let permissionStatus = {};

  permissionStatus = await Promise.all(
  _.map(permissions, async permission => {
    if (!PERMISSION_HANDLER_MAP[permission]) {
      console.warn(`${permission} permission does not exist`);

      return {
        name: permission,
        allowed: false };

    }

    return {
      name: permission,
      allowed: await PERMISSION_HANDLER_MAP[permission](entityId) };

  }));


  return _.reduce(permissionStatus, (acc, permission) => {
    acc[permission.name] = permission.allowed;

    return acc;
  }, {});
}
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 3746:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (immutable) */ __webpack_exports__["b"] = getFolderInheritedState;
/* harmony export (immutable) */ __webpack_exports__["a"] = getCollectionInheritedState;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__constants_ConfigurationConstants__ = __webpack_require__(978);


/**
                                                                                                                           * Function to get parent from where the configurations is being inherited for Folders
                                                                                                                           * This is used in Add and Edit Folder Modal
                                                                                                                           *
                                                                                                                           * @param {Object} collection the collection to which the folder belongs
                                                                                                                           * @param {String} id the uuid of the sub-entity, this will be folder in this case (in case of the add folder action, this will be the id of the parent)
                                                                                                                           * @param {String} action the action when this function is called (while adding or editing the folder)
                                                                                                                           *
                                                                                                                           * @returns {Object} Return an object with each configuration id as key and info object about its parent as value.
                                                                                                                           * For example
                                                                                                                           * {
                                                                                                                           *  strictSSL: {
                                                                                                                           *    parent: {
                                                                                                                           *      id: 'parentId',
                                                                                                                           *      type: 'parentType(folder, collection, global)',
                                                                                                                           *      name: 'parentName'
                                                                                                                           *    },
                                                                                                                           *    value: 'inherited value'
                                                                                                                           *  }, ...
                                                                                                                           * }
                                                                                                                           */
function getFolderInheritedState(collection, id, action) {
  if (_.isEmpty(collection) || _.isEmpty(id)) {
    return null;
  }

  let folders = _.get(collection, 'folders', []),
  folder = {},
  result = {};

  _.forEach(__WEBPACK_IMPORTED_MODULE_0__constants_ConfigurationConstants__["b" /* CONFIGURATIONS */], configuration => {
    let folderId,
    inheritedState = null;

    /**
                            * start looking from one level up if the folder is being edited
                            * otherwise, if a new folder is being added, the `id` in argument is parent's id for the new folder,
                            * so start from that level itself
                            */
    if (action === 'edit') {
      folderId = _.get(_.find(folders, ['id', id]), 'folder');
    } else
    if (action === 'add') {
      folderId = id;
    }

    while (folderId) {
      folder = _.find(folders, ['id', folderId]);
      let protocolProfileBehavior = _.get(folder, 'protocolProfileBehavior');

      if (_.has(protocolProfileBehavior, [configuration.id])) {
        inheritedState = {
          parent: {
            id: folder.id,
            type: 'folder',
            name: folder.name },

          value: _.get(protocolProfileBehavior, [configuration.id]) };

        break;
      }
      folderId = _.get(folder, 'folder');
    }

    /**
       * if inheritedState still does not have parent, it means no parent folder of this folder has this particular configuration
       * so now look for the configuration in the parent collection
       */
    if (!_.has(inheritedState, 'parent') && _.has(collection, ['protocolProfileBehavior', [configuration.id]])) {
      inheritedState = {
        parent: {
          id: collection.id,
          type: 'collection',
          name: collection.name },

        value: _.get(collection, ['protocolProfileBehavior', [configuration.id]]) };

    }

    /**
       * if inheritedState still does not have parent, it means that no parent of this folder has this particular configuration
       * so look for the base layer where of this configuration
       */
    if (!_.has(inheritedState, 'parent')) {
      if (configuration.base === __WEBPACK_IMPORTED_MODULE_0__constants_ConfigurationConstants__["a" /* BASE */].COLLECTION) {
        inheritedState = {
          parent: {
            id: collection.id,
            type: 'collection',
            name: collection.name },

          value: configuration.defaultValue };

      } else
      if (configuration.base === __WEBPACK_IMPORTED_MODULE_0__constants_ConfigurationConstants__["a" /* BASE */].GLOBAL) {
        inheritedState = {
          parent: {
            type: 'global',
            name: 'Settings' },

          value: pm.settings.getSetting(__WEBPACK_IMPORTED_MODULE_0__constants_ConfigurationConstants__["c" /* CONFIGURATION_MAP */][configuration.id]) };

      }
    }

    _.set(result, [configuration.id], inheritedState);
  });

  return result;
}

/**
   * Function to get parent from where the configurations is being inherited for collections
   * For now collection can only inherit from global settings
   * For all settings which are not at global level, collection is considered as base for them and thus `null` is returned for such settings
   *
   * @return {Object} Returns object with each settings id as key and info object about its parent as value.
   */
function getCollectionInheritedState() {
  return _.reduce(__WEBPACK_IMPORTED_MODULE_0__constants_ConfigurationConstants__["b" /* CONFIGURATIONS */], (result, configuration) => {
    let inheritedState = null;
    if (configuration.base === __WEBPACK_IMPORTED_MODULE_0__constants_ConfigurationConstants__["a" /* BASE */].GLOBAL) {
      inheritedState = {
        parent: {
          type: 'global',
          name: 'Settings' },

        value: pm.settings.getSetting(__WEBPACK_IMPORTED_MODULE_0__constants_ConfigurationConstants__["c" /* CONFIGURATION_MAP */][configuration.id]) };

    }
    _.set(result, [configuration.id], inheritedState);
    return result;
  }, {});
}
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 3747:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return PasswordInput; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_prop_types__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_prop_types___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_prop_types__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__Icons_HideIcon__ = __webpack_require__(4767);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__Icons_PreviewIcon__ = __webpack_require__(3929);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};function _objectWithoutProperties(obj, keys) {var target = {};for (var i in obj) {if (keys.indexOf(i) >= 0) continue;if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;target[i] = obj[i];}return target;}




let

PasswordInput = class PasswordInput extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      masked: true };

    this.handleToggle = this.handleToggle.bind(this);
  }

  handleToggle() {
    this.setState({ masked: !this.state.masked });
  }

  render() {
    let _props = this.props,{ className } = _props,inputProps = _objectWithoutProperties(_props, ['className']),
    iconSize = this.props.size === 'huge' ? 'md' : 'sm';

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: __WEBPACK_IMPORTED_MODULE_1_classnames___default()('password-input', className) },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__Inputs__["b" /* Input */], _extends({},
        inputProps, {
          type: this.state.masked ? 'password' : 'text' })),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
            className: 'password-input__toggle',
            onClick: this.handleToggle },


          this.state.masked ?
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__Icons_HideIcon__["a" /* default */], { title: 'Show', size: iconSize }) :
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__Icons_PreviewIcon__["a" /* default */], { title: 'Hide', size: iconSize }))));




  }};


PasswordInput.propTypes = {
  className: __WEBPACK_IMPORTED_MODULE_3_prop_types___default.a.string,
  inputStyle: __WEBPACK_IMPORTED_MODULE_3_prop_types___default.a.oneOf(['box', 'line']),
  size: __WEBPACK_IMPORTED_MODULE_3_prop_types___default.a.oneOf(['huge']) };

/***/ }),

/***/ 3748:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
const SNIPPET_TYPE_HTTP = 'HTTP',
SNIPPET_TYPE_C = 'C-LibCurl',
SNIPPET_TYPE_CURL = 'cURL',
SNIPPET_TYPE_C_SHARP = 'C-Sharp-RestSharp',
SNIPPET_TYPE_GO = 'Go',
SNIPPET_TYPE_JAVA = 'Java',
SNIPPET_TYPE_JAVA_OK_HTTP = 'OK-HTTP',
SNIPPET_TYPE_JAVA_UNIREST = 'Unirest',
SNIPPET_TYPE_JAVASCRIPT = 'JavaScript',
SNIPPET_TYPE_JAVASCRIPT_JQUERY_AJAX = 'Jquery-AJAX',
SNIPPET_TYPE_JAVASCRIPT_XHR = 'XHR',
SNIPPET_TYPE_NODEJS = 'NodeJS',
SNIPPET_TYPE_NODEJS_NATIVE = 'Native',
SNIPPET_TYPE_NODEJS_REQUEST = 'Request',
SNIPPET_TYPE_NODEJS_UNIREST = 'Unirest',
SNIPPET_TYPE_OBJECTIVE_C = 'Objective-C-NSURL',
SNIPPET_TYPE_O_CAML = 'OCaml-CoHttp',
SNIPPET_TYPE_PHP = 'PHP',
SNIPPET_TYPE_PHP_HTTP_V1 = 'HTTP-V1',
SNIPPET_TYPE_PHP_HTTP_V2 = 'HTTP-V2',
SNIPPET_TYPE_PHP_CURL = 'Curl',
SNIPPET_TYPE_PYTHON = 'Python',
SNIPPET_TYPE_PYTHON_3 = 'Python-3',
SNIPPET_TYPE_PYTHON_REQUESTS = 'Requests',
SNIPPET_TYPE_RUBY = 'Ruby',
SNIPPET_TYPE_SHELL = 'Shell',
SNIPPET_TYPE_SHELL_WGET = 'wget',
SNIPPET_TYPE_SHELL_HTTPIE = 'Httpie',
SNIPPET_TYPE_SHELL_CURL = 'cURI',
SNIPPET_TYPE_SWIFT = 'Swift';
/* harmony export (immutable) */ __webpack_exports__["e"] = SNIPPET_TYPE_HTTP;

/* harmony export (immutable) */ __webpack_exports__["a"] = SNIPPET_TYPE_C;

/* harmony export (immutable) */ __webpack_exports__["b"] = SNIPPET_TYPE_CURL;

/* harmony export (immutable) */ __webpack_exports__["c"] = SNIPPET_TYPE_C_SHARP;

/* harmony export (immutable) */ __webpack_exports__["d"] = SNIPPET_TYPE_GO;

/* harmony export (immutable) */ __webpack_exports__["f"] = SNIPPET_TYPE_JAVA;

/* harmony export (immutable) */ __webpack_exports__["j"] = SNIPPET_TYPE_JAVA_OK_HTTP;

/* harmony export (immutable) */ __webpack_exports__["k"] = SNIPPET_TYPE_JAVA_UNIREST;

/* harmony export (immutable) */ __webpack_exports__["g"] = SNIPPET_TYPE_JAVASCRIPT;

/* harmony export (immutable) */ __webpack_exports__["h"] = SNIPPET_TYPE_JAVASCRIPT_JQUERY_AJAX;

/* harmony export (immutable) */ __webpack_exports__["i"] = SNIPPET_TYPE_JAVASCRIPT_XHR;

/* harmony export (immutable) */ __webpack_exports__["l"] = SNIPPET_TYPE_NODEJS;

/* harmony export (immutable) */ __webpack_exports__["m"] = SNIPPET_TYPE_NODEJS_NATIVE;

/* harmony export (immutable) */ __webpack_exports__["n"] = SNIPPET_TYPE_NODEJS_REQUEST;

/* harmony export (immutable) */ __webpack_exports__["o"] = SNIPPET_TYPE_NODEJS_UNIREST;

/* harmony export (immutable) */ __webpack_exports__["p"] = SNIPPET_TYPE_OBJECTIVE_C;

/* harmony export (immutable) */ __webpack_exports__["q"] = SNIPPET_TYPE_O_CAML;

/* harmony export (immutable) */ __webpack_exports__["r"] = SNIPPET_TYPE_PHP;

/* harmony export (immutable) */ __webpack_exports__["t"] = SNIPPET_TYPE_PHP_HTTP_V1;

/* harmony export (immutable) */ __webpack_exports__["u"] = SNIPPET_TYPE_PHP_HTTP_V2;

/* harmony export (immutable) */ __webpack_exports__["s"] = SNIPPET_TYPE_PHP_CURL;

/* harmony export (immutable) */ __webpack_exports__["v"] = SNIPPET_TYPE_PYTHON;

/* harmony export (immutable) */ __webpack_exports__["w"] = SNIPPET_TYPE_PYTHON_3;

/* harmony export (immutable) */ __webpack_exports__["x"] = SNIPPET_TYPE_PYTHON_REQUESTS;

/* harmony export (immutable) */ __webpack_exports__["y"] = SNIPPET_TYPE_RUBY;

/* harmony export (immutable) */ __webpack_exports__["z"] = SNIPPET_TYPE_SHELL;

/* harmony export (immutable) */ __webpack_exports__["C"] = SNIPPET_TYPE_SHELL_WGET;

/* harmony export (immutable) */ __webpack_exports__["B"] = SNIPPET_TYPE_SHELL_HTTPIE;

/* harmony export (immutable) */ __webpack_exports__["A"] = SNIPPET_TYPE_SHELL_CURL;

/* harmony export (immutable) */ __webpack_exports__["D"] = SNIPPET_TYPE_SWIFT;


/***/ }),

/***/ 3768:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return MultiSelectEntity; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__Inputs__ = __webpack_require__(55);

let

MultiSelectEntity = class MultiSelectEntity extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.handleEntitySelect = this.handleEntitySelect.bind(this);
  }

  handleEntitySelect(id) {
    let selectedEntities = [];
    if (id === 'all' && _.size(this.props.selectedEntities) !== _.size(this.props.items)) {
      selectedEntities = _.map(this.props.items, 'id');
    } else
    if (id !== 'all') {
      if (_.includes(this.props.selectedEntities, id)) {
        selectedEntities = _.filter(this.props.selectedEntities, entityId => {return entityId !== id;});
      } else
      {
        selectedEntities = _.concat(this.props.selectedEntities, id);
      }
    }

    this.props.onSelectEntity(selectedEntities);
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'multi-select-entity__list' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'multi-select-entity__item',
            onClick: this.handleEntitySelect.bind(this, 'all') },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__Inputs__["a" /* Checkbox */], {
            checked: _.size(this.props.selectedEntities) === _.size(this.props.items) }),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, `All your ${this.props.type}`)),


        _.map(this.props.items, item => {
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
                className: 'multi-select-entity__item',
                key: item.id,
                onClick: this.handleEntitySelect.bind(this, item.id) },

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__Inputs__["a" /* Checkbox */], { checked: _.includes(this.props.selectedEntities, item.id) }),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'multi-select-entity__item--name' }, item.name)));


        })));



  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 3769:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-env node, browser */


/**
 * determines if the keycode specified is a modifier key or not
 *
 * @param {string} key
 * @returns {boolean}
 */
module.exports = function (key) {
  return key === 'shift' || key === 'ctrl' || key === 'alt' || key === 'meta'
}


/***/ }),

/***/ 3770:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_react_dnd__ = __webpack_require__(361);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_react_dnd___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_react_dnd__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_react_dom__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_react_dom___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_react_dom__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__Icons_CloseIcon__ = __webpack_require__(90);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__Icons_MenuIcon__ = __webpack_require__(693);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_prop_types__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_prop_types___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_6_prop_types__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__XPaths_XPath__ = __webpack_require__(24);









const rowSource = {
  beginDrag(props) {
    return { index: props.index };
  } };


const getMiddleY = component => {
  const elementRect = Object(__WEBPACK_IMPORTED_MODULE_2_react_dom__["findDOMNode"])(component).getBoundingClientRect();
  return elementRect.top + elementRect.height / 2;
};

const rowTarget = {
  hover(props, monitor, component) {
    const dragIndex = monitor.getItem().index;
    const hoverIndex = props.index;

    if (dragIndex === hoverIndex) {
      return;
    }
    if (monitor.getClientOffset().y > getMiddleY(component)) {
      component.setDropHoverBottom();
    } else
    {
      component.setDropHoverTop();
    }
  },

  drop(props, monitor, component) {
    const dragIndex = monitor.getItem().index;
    const hoverIndex = props.index;

    if (dragIndex === hoverIndex) {
      return;
    }

    if (monitor.getClientOffset().y > getMiddleY(component)) {
      component.handleReorder && component.handleReorder(dragIndex, hoverIndex, 'after');
    } else
    {
      component.handleReorder && component.handleReorder(dragIndex, hoverIndex, 'before');
    }
  } };let


RowRenderer = class RowRenderer extends __WEBPACK_IMPORTED_MODULE_0_react__["PureComponent"] {
  constructor(props) {
    super(props);
    this.state = {
      dropHoverBottom: false,
      dropHoverTop: false,
      isFocused: false };


    this.handleFocus = this.handleFocus.bind(this);
    this.handleReorder = this.handleReorder.bind(this);
    this.handleDelete = this.handleDelete.bind(this);
  }

  componentDidMount() {
    this.subscription = this.context.events.addListener('focusCell', this.handleFocus);
  }

  componentWillUnmount() {
    this.subscription.remove();
  }

  getClasses() {
    // use classnames
    return __WEBPACK_IMPORTED_MODULE_3_classnames___default()({
      'data-editor__custom-row': true,
      'is-focused': this.state.isFocused,
      'hover-top': this.state.dropHoverTop && this.props.isDragOver,
      'hover-bottom': this.state.dropHoverBottom && this.props.isDragOver });

  }

  handleFocus({ node }) {
    if (node === this.props.nodeId && !this.state.isFocused) {
      this.setState({ isFocused: true });
    } else
    if (this.state.isFocused && node !== this.props.nodeId) {
      this.setState({ isFocused: false });
    }
  }

  setDropHoverTop() {
    this.setState({
      dropHoverBottom: false,
      dropHoverTop: true });

  }

  setDropHoverBottom() {
    this.setState({
      dropHoverBottom: true,
      dropHoverTop: false });

  }

  handleReorder(sourceIndex, destinationIndex, position) {
    this.props.onAction && this.props.onAction(
    'move',
    { sourceIndex, destinationIndex, position });

  }

  handleDelete() {
    this.props.onAction && this.props.onAction('delete');
  }

  render() {
    const {
      connectDragSource,
      connectDropTarget,
      connectDragPreview } =
    this.props;

    return connectDragPreview(connectDropTarget(
    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
        className: this.getClasses(),
        'data-index': this.props.index,
        style: this.props.style },


      connectDragSource(
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'data-editor__reorder' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__Icons_MenuIcon__["a" /* default */], { className: 'data-editor__reorder__icon', size: 'xs' }))),



      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__XPaths_XPath__["a" /* default */], { identifier: this.props.index },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'data-editor__cells' },
          this.props.children)),


      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'data-editor__row__actions' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__Icons_CloseIcon__["a" /* default */], {
          className: 'data-editor__row__action--delete',
          onClick: this.handleDelete,
          size: 'xs' })))));



  }};


RowRenderer.contextTypes = { events: __WEBPACK_IMPORTED_MODULE_6_prop_types___default.a.object };

/* harmony default export */ __webpack_exports__["a"] = (_.flow(Object(__WEBPACK_IMPORTED_MODULE_1_react_dnd__["DropTarget"])('grid-renderer-row', rowTarget, (connect, monitor) => {
  return {
    connectDropTarget: connect.dropTarget(),
    isDragOver: monitor.isOver({ shallow: true }) };

}),
Object(__WEBPACK_IMPORTED_MODULE_1_react_dnd__["DragSource"])('grid-renderer-row', rowSource, (connect, monitor) => {
  return {
    connectDragSource: connect.dragSource(),
    connectDragPreview: connect.dragPreview(),
    isDragging: monitor.isDragging() };

}))(
RowRenderer));
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 3771:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return DEInputs; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_react_dom__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_react_dom___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_react_dom__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__keymaps_KeyMaps__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__AutoSuggest_AutoSuggestInput__ = __webpack_require__(141);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__postman_data_editor__ = __webpack_require__(3623);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__postman_data_editor___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5__postman_data_editor__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_prop_types__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_prop_types___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_6_prop_types__);






let

DEInputs = class DEInputs extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.handleFocus = this.handleFocus.bind(this);
    this.handleLeft = this.handleLeft.bind(this);
    this.handleRight = this.handleRight.bind(this);
    this.handleUp = this.handleUp.bind(this);
    this.handleDown = this.handleDown.bind(this);
    this.handleTab = this.handleTab.bind(this);
    this.handleShiftTab = this.handleShiftTab.bind(this);
  }

  componentDidMount() {
    this.subscription = this.context.events.addListener('focusCell', this.handleFocus);
  }

  componentWillUnmount() {
    this.subscription.remove();
  }

  shallowCompare(a, b) {
    for (let key in a) {
      if (a[key] !== b[key]) {
        return false;
      }
    }
    return true;
  }

  shouldComponentUpdate(nextProps, nextState) {
    if (this.props.value === nextProps.value && this.shallowCompare(this.props.cellInfo, nextProps.cellInfo)) {
      return false;
    }

    return true;
  }

  getKeyMapHandlers() {
    return {
      left: pm.shortcuts.handle('left', this.handleLeft),
      right: pm.shortcuts.handle('right', this.handleRight),
      up: pm.shortcuts.handle('up', this.handleUp),
      down: pm.shortcuts.handle('down', this.handleDown),
      tab: pm.shortcuts.handle('tab', this.handleTab),
      shiftTabCell: pm.shortcuts.handle('shiftTabCell', this.handleShiftTab) };

  }

  handleFocus({ node, column, direction }) {
    if (node !== this.props.cellInfo.node || column !== this.props.cellInfo.column) {
      // This is not meant for me
      return;
    }

    this.refs.input && this.refs.input.focus();

    if (direction === 'left') {
      this.setCursorPosition(1, 1);
    } else
    if (direction === 'right') {
      this.setCursorPosition(0, 0);
    } else
    if (direction === 'tab' || direction === 'shiftTab') {
      this.setCursorPosition(0, 1);
    }
  }

  getCursorPosition(element, isReverse) {
    // TODO:: Clean this function
    let selection = _.isFunction(window.getSelection) && window.getSelection(),
    range = null,
    preCaretRange = null,
    start,
    end;
    if (selection && selection.rangeCount > 0) {
      range = selection.rangeCount && selection.getRangeAt(0);
    } else
    {
      return 0;
    }
    preCaretRange = range && range.cloneRange();
    preCaretRange.selectNodeContents(element);
    preCaretRange.setEnd(range.startContainer, range.startOffset);
    start = preCaretRange.toString().length;
    preCaretRange.setEnd(range.endContainer, range.endOffset);
    end = preCaretRange.toString().length;

    return isReverse ? start : end;
  }

  setCursorPosition(start, end) {
    try {
      let target = Object(__WEBPACK_IMPORTED_MODULE_1_react_dom__["findDOMNode"])(this),
      el = target.getElementsByClassName('public-DraftEditor-content')[0],
      range = document.createRange(),
      sel = window.getSelection();

      sel.removeAllRanges();
      range.setStart(el, start);
      range.setEnd(el, end);
      sel.addRange(range);
    }
    catch (e) {

    }
  }

  handleLeft(e) {
    let cursorPosition = this.getCursorPosition(e.target, 'start');

    if (cursorPosition === 0 && window.getSelection().isCollapsed) {
      e && e.preventDefault();
      e && e.stopPropagation();

      this.context.events.emit('moveToCell', {
        node: this.props.cellInfo.node,
        column: this.props.cellInfo.column,
        direction: 'left' });

    }
  }

  handleRight(e) {
    let cursorPosition = this.getCursorPosition(e.target, 'end'),
    textLength = e.target.textContent.length;

    if (textLength === cursorPosition && window.getSelection().isCollapsed) {
      e && e.preventDefault();
      e && e.stopPropagation();

      this.context.events.emit('moveToCell', {
        node: this.props.cellInfo.node,
        column: this.props.cellInfo.column,
        direction: 'right' });

    }
  }

  handleUp(e) {
    if (this.props.suggestions && !_.isEmpty(e.target.closest('.suggestions-expanded'))) {
      return;
    }
    let cursorPosition = this.getCursorPosition(e.target, 'start');

    let textLength = e.target.textContent.length;
    if (e.target.offsetHeight < 20 || cursorPosition === 0) {
      e.preventDefault();

      this.context.events.emit('moveToCell', {
        node: this.props.cellInfo.node,
        column: this.props.cellInfo.column,
        direction: 'up' });

    }
  }

  handleDown(e) {
    if (this.props.suggestions && !_.isEmpty(e.target.closest('.suggestions-expanded'))) {
      return;
    }

    let cursorPosition = this.getCursorPosition(e.target, 'end');

    let textLength = e.target.textContent.length;
    if (e.target.offsetHeight < 20 || textLength === cursorPosition) {
      e.preventDefault();

      this.context.events.emit('moveToCell', {
        node: this.props.cellInfo.node,
        column: this.props.cellInfo.column,
        direction: 'down' });

    }
  }

  handleTab(e) {
    e && e.preventDefault();
    e && e.stopPropagation();

    this.context.events.emit('moveToCell', {
      node: this.props.cellInfo.node,
      column: this.props.cellInfo.column,
      direction: 'tab' });

  }

  handleShiftTab(e) {
    e && e.preventDefault();
    e && e.stopPropagation();

    this.context.events.emit('moveToCell', {
      node: this.props.cellInfo.node,
      column: this.props.cellInfo.column,
      direction: 'shiftTab' });

  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__keymaps_KeyMaps__["a" /* default */], {
          keyMap: pm.shortcuts.getShortcuts(),
          handlers: this.getKeyMapHandlers() },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'data-editor__cell__content' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__AutoSuggest_AutoSuggestInput__["a" /* AutoSuggestInput */], {
            type: this.props.type,
            ref: 'input',
            inputStyle: 'cell',
            value: __WEBPACK_IMPORTED_MODULE_5__postman_data_editor__["utils"].getImmutablePathValue(this.props.value, ['value']),
            onChange: this.props.onAction,
            placeholder: this.props.placeholder,
            suggestions: this.props.suggestions }))));




  }};


DEInputs.contextTypes = { events: __WEBPACK_IMPORTED_MODULE_6_prop_types___default.a.object };
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 3772:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ColumnToggle; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__postman_react_click_outside__ = __webpack_require__(216);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__postman_react_click_outside___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1__postman_react_click_outside__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__Icons_MoreIcon__ = __webpack_require__(215);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__constants_MoreButtonTooltipConstant__ = __webpack_require__(310);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _class;





let


ColumnToggle = __WEBPACK_IMPORTED_MODULE_1__postman_react_click_outside___default()(_class = class ColumnToggle extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = { isOpen: false };

    this.toggleColumn = this.toggleColumn.bind(this);
    this.handleToggle = this.handleToggle.bind(this);
    this.handleClickOutside = this.handleClickOutside.bind(this);
  }

  toggleColumn(column, shouldHide) {
    let changedColumnIndex = _.findIndex(this.props.config.columns, c => c.name === column);
    let visibleColumns = _.filter(this.props.config.columns, col => {
      return !col.hidden;
    });
    if (_.size(visibleColumns) === 1 && shouldHide) {
      return;
    }
    let editedColumnConfig = _.find(this.props.config.columns, c => c.name === column);
    let extraWidth = editedColumnConfig ? editedColumnConfig.width : 0;
    let newConfig = _extends({},
    this.props.config, {
      columns: _.map(this.props.config.columns, columnConfig => {
        if (shouldHide) {
          return _extends({},
          columnConfig, {
            hidden: columnConfig.name === column ? true : columnConfig.hidden,
            width: columnConfig.width + extraWidth / (_.size(visibleColumns) - 1) });

        } else
        {
          return _extends({},
          columnConfig, {
            hidden: columnConfig.name === column ? false : columnConfig.hidden,
            width: columnConfig.width - extraWidth / (_.size(visibleColumns) + 1) });

        }
      }) });

    this.handleToggle();
    this.props.onColumnToggle && this.props.onColumnToggle(newConfig);
  }

  handleToggle() {
    this.setState({ isOpen: !this.state.isOpen });
  }

  handleClickOutside() {
    this.state.isOpen && this.setState({ isOpen: false });
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'data-editor-column-toggle' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__Buttons__["a" /* Button */], {
            className: 'data-editor-column-toggle__button',
            type: 'text',
            onClick: this.handleToggle,
            tooltip: __WEBPACK_IMPORTED_MODULE_5__constants_MoreButtonTooltipConstant__["a" /* ACTION_TYPE_VIEW_MORE_ACTIONS_TOOLTIP */] }, ' ',

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__Icons_MoreIcon__["a" /* default */], { className: 'data-editor-column-toggle__button__icon' })),


        this.state.isOpen &&
        !this.props.columnGroups &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'data-editor-column-toggle__menu' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'data-editor-column-toggle__header' }, 'Show columns'),



          _.map(this.props.config.columns, (column, index) => {
            return (
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
                  key: index,
                  className: `data-editor-column-toggle__column data-editor-column-toggle__column--${column.name}`,
                  onClick: this.toggleColumn.bind(this, column.name, !column.hidden) },

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__Inputs__["a" /* Checkbox */], {
                  checked: !column.hidden }),

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, column.label || _.capitalize(column.name))));


          })),




        this.state.isOpen &&
        this.props.columnGroups &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'data-editor-column-toggle__menu' },

          _.map(this.props.columnGroups, (group, index) => {
            return (
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'data-editor-column-toggle__group', key: index },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'data-editor-column-toggle__header' },
                  group.label),


                _.map(group.columns, (columnName, columnIndex) => {
                  let column = _.find(this.props.config.columns, c => c.name === columnName);
                  return (
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
                        key: columnIndex,
                        className: `data-editor-column-toggle__column data-editor-column-toggle__column--${column.name}`,
                        onClick: this.toggleColumn.bind(this, column.name, !column.hidden) },

                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__Inputs__["a" /* Checkbox */], {
                        checked: !column.hidden }),

                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, column.label || _.capitalize(column.name))));


                })));



          }))));





  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 3773:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return DataEditorRequestMethods; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__postman_data_editor__ = __webpack_require__(3623);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__postman_data_editor___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2__postman_data_editor__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_XPaths_XPath__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_Dropdowns__ = __webpack_require__(31);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_Buttons__ = __webpack_require__(13);
var _class;






let


DataEditorRequestMethods = Object(__WEBPACK_IMPORTED_MODULE_1_mobx_react__["a" /* observer */])(_class = class DataEditorRequestMethods extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.handleChange = this.handleChange.bind(this);
  }

  handleChange(value) {
    this.props.onChange && this.props.onChange(value);
  }

  render() {
    let requestMethods = Object(__WEBPACK_IMPORTED_MODULE_3__stores_get_store__["getStore"])('RequestMethodsStore').methods;

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_XPaths_XPath__["a" /* default */], { identifier: 'method', key: 'method' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Dropdowns__["a" /* Dropdown */], {
            allowScroll: true,
            fullWidth: true,
            onSelect: this.handleChange },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Dropdowns__["b" /* DropdownButton */], {
              size: 'small',
              type: 'secondary' },

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Buttons__["a" /* Button */], null, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, __WEBPACK_IMPORTED_MODULE_2__postman_data_editor__["utils"].getImmutablePathValue(this.props.value, ['value'])))),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Dropdowns__["c" /* DropdownMenu */], { fluid: true },

            _.map(requestMethods, method => {
              return (
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Dropdowns__["d" /* MenuItem */], {
                    key: method,
                    refKey: method },

                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, method)));


            })))));





  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 3774:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_Tooltips__ = __webpack_require__(80);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__permissions_TeamRoleItem__ = __webpack_require__(5061);
var _class;






let


WorkspaceVisibility = Object(__WEBPACK_IMPORTED_MODULE_2_mobx_react__["a" /* observer */])(_class = class WorkspaceVisibility extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor() {
    super();

    this.handleChangeTeamRole = this.handleChangeTeamRole.bind(this);
  }

  getVisibilityClassName() {
    return __WEBPACK_IMPORTED_MODULE_1_classnames___default()({
      'workspace__enterprise_visibility': this.props.isLimitingVisibilityEnabled,
      'workspace__enterprise_visibility--disabled': !this.props.isLimitingVisibilityEnabled });

  }

  handleChangeTeamRole(teamId, role) {
    let teamRole = {
      [teamId]: {
        id: teamId,
        type: 'team',
        name: role } };



    this.props.onChange && this.props.onChange('teamCurrentRole', teamRole);
  }

  render() {
    const currentUser = Object(__WEBPACK_IMPORTED_MODULE_3__stores_get_store__["getStore"])('CurrentUserStore'),
    teamId = _.get(currentUser, 'team.id'),
    teamLogo = _.get(currentUser, 'team.logo_url'),
    showTeamRole = teamId && !this.props.hideRoles && !this.props.limitVisibility;

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_0_react__["Fragment"], null,
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('h2', { className: 'workspace-visibility--title' }, 'Workspace visibility'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
            className: this.getVisibilityClassName(),
            ref: 'tooltipTarget',
            onMouseEnter: !this.props.isLimitingVisibilityEnabled && this.props.showTooltip || _.noop,
            onMouseLeave: !this.props.isLimitingVisibilityEnabled && this.props.hideTooltip || _.noop },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Inputs__["a" /* Checkbox */], {
            disabled: !this.props.isLimitingVisibilityEnabled,
            checked: this.props.limitVisibility,
            onChange: this.props.onVisibilityChange }),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'workspace__enterprise_info' }, 'Make workspace private'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Tooltips__["a" /* Tooltip */], {
                show: this.props.isTooltipVisible,
                target: this.refs.tooltipTarget,
                placement: 'right',
                className: 'workspace__enterprise-tooltip',
                immediate: true },

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Tooltips__["b" /* TooltipBody */], null,

                this.props.canUpdateRoles ?
                `All users in your team can find and join this workspace
                    by default. Upgrade to Enterprise to limit visibility
                    for this workspace.` :

                'You do not have the permission to update the visibility of this workspace.')))),






        showTeamRole &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__permissions_TeamRoleItem__["a" /* default */], {
          canUpdateRoles: this.props.canUpdateRoles,
          rolesList: this.props.allRoles,
          selectedRole: this.props.teamCurrentRole,
          teamId: teamId,
          teamLogo: teamLogo,
          onChange: role => this.handleChangeTeamRole(teamId, role) })));




  }}) || _class;


WorkspaceVisibility.defaultProps = {
  canUpdateRoles: true };


/* harmony default export */ __webpack_exports__["a"] = (WorkspaceVisibility);
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 3775:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (immutable) */ __webpack_exports__["d"] = fetchAddCollectionToWorkspaces;
/* harmony export (immutable) */ __webpack_exports__["e"] = fetchAddMemberToWorkspaces;
/* harmony export (immutable) */ __webpack_exports__["i"] = fetchRemoveMemberFromWorkspaces;
/* harmony export (immutable) */ __webpack_exports__["k"] = fetchUpdateWorkspacesMeta;
/* harmony export (immutable) */ __webpack_exports__["l"] = fetchUpdateWorkspacesRoles;
/* harmony export (immutable) */ __webpack_exports__["f"] = fetchCollectionManageRole;
/* harmony export (immutable) */ __webpack_exports__["g"] = fetchCollectionShare;
/* harmony export (immutable) */ __webpack_exports__["c"] = fetchAddAPIToWorkspaces;
/* harmony export (immutable) */ __webpack_exports__["a"] = fetchAPIManageRole;
/* harmony export (immutable) */ __webpack_exports__["b"] = fetchAPIShare;
/* harmony export (immutable) */ __webpack_exports__["j"] = fetchSendUnapprovedInvites;
/* harmony export (immutable) */ __webpack_exports__["h"] = fetchManageTeamInvites;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__constants_ACConstants__ = __webpack_require__(551);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__controllers_UserController__ = __webpack_require__(39);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__SyncRemoteFetcherService__ = __webpack_require__(139);




const {
  ADD_COLLECTION_TO_WORKSPACE,
  ADD_MEMBER_TO_WORKSPACE,
  REMOVE_MEMBER_FROM_WORKSPACE,
  UPDATE_WORKSPACE_META,
  UPDATE_WORKSPACE_ROLES,
  UPDATE_COLLECTION_ROLES,
  SHARE_COLLECTION } =
__WEBPACK_IMPORTED_MODULE_0__constants_ACConstants__["a" /* default */],

// @todo: Move these permissions as imports from ACConstants once the file is updated
// by @product-core
ADD_API_TO_WORKSPACE = 'ADD_API_TO_WORKSPACE',
SHARE_API = 'SHARE_API',
UPDATE_API_ROLES = 'UPDATE_API_ROLES',
WORKSPACE = 'workspace',
COLLECTION = 'collection',
API = 'api',
USER = 'user',
TEAM = 'team',
MANAGE_TEAM_INVITES = 'MANAGE_TEAM_INVITES',
SEND_UNAPPROVED_INVITES = 'SEND_UNAPPROVED_INVITES';

/**
                                                      * Fetches the permission for a list of models
                                                      *
                                                      * @private
                                                      * @param {String} permission
                                                      * @param {Object} options
                                                      * @param {Array<Object>} options.modelIds
                                                      * @param {String} options.modelType
                                                      * @returns Promise<{ permissions: object[] }>
                                                      */
async function _fetchPerObject(permission, options) {
  let { modelIds, modelType } = options,
  { id: userId } = await __WEBPACK_IMPORTED_MODULE_1__controllers_UserController__["a" /* default */].get(),
  criteria = _.transform(modelIds, (acc, modelId) => {
    acc[modelId] = {
      entityType: USER,
      entityId: userId,
      permission,
      objectType: modelType,
      objectId: modelId };

  }, {});

  return __WEBPACK_IMPORTED_MODULE_2__SyncRemoteFetcherService__["a" /* default */].
  remoteFetch('permission', 'fetchPerObject', criteria);
}

/**
   * Fetches the permission status for adding a collection to a workspaces
   * for a given list of workspaces
   *
   * @param {Array<String>} workspaceIds
   * @returns Promise<{ results: object[] }>
   */
function fetchAddCollectionToWorkspaces(workspaceIds) {
  if (_.isEmpty(workspaceIds)) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchAddCollectionToWorkspace: No workspace Ids provided'));
  }

  let options = { modelIds: workspaceIds, modelType: WORKSPACE };

  return _fetchPerObject(ADD_COLLECTION_TO_WORKSPACE, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
   * Fetches the permission status for adding a member to the workspace
   *
   * @param {Array<String>} workspaceIds
   * @returns Promise<{ results: object[] }>
   */
function fetchAddMemberToWorkspaces(workspaceIds) {
  if (_.isEmpty(workspaceIds)) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchAddMemberToWorkspaces: No workspace Ids provided'));
  }

  let options = { modelIds: workspaceIds, modelType: WORKSPACE };

  return _fetchPerObject(ADD_MEMBER_TO_WORKSPACE, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
   * Fetches the permission status for removing a member from the workspace
   *
   * @param {Array<String>} workspaceIds
   * @returns Promise<{ results: object[] }>
   */
function fetchRemoveMemberFromWorkspaces(workspaceIds) {
  if (_.isEmpty(workspaceIds)) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchRemoveMemberFromWorkspaces: No workspace Ids provided'));
  }

  let options = { modelIds: workspaceIds, modelType: WORKSPACE };

  return _fetchPerObject(REMOVE_MEMBER_FROM_WORKSPACE, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
   * Fetches the permission status for updating workspace meta
   *
   * @param {Array<String>} workspaceIds
   * @returns Promise<{ results: object[] }>
   */
function fetchUpdateWorkspacesMeta(workspaceIds) {
  if (_.isEmpty(workspaceIds)) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchUpdateWorkspacesMeta: No workspace Ids provided'));
  }

  let options = { modelIds: workspaceIds, modelType: WORKSPACE };

  return _fetchPerObject(UPDATE_WORKSPACE_META, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
   * Fetches the permission status for updating workspace roles
   *
   * @param {Array<String>} workspaceIds
   * @returns Promise<{ results: object[] }>
   */
function fetchUpdateWorkspacesRoles(workspaceIds) {
  if (_.isEmpty(workspaceIds)) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchUpdateWorkspacesRoles: No workspace Ids provided'));
  }

  let options = { modelIds: workspaceIds, modelType: WORKSPACE };

  return _fetchPerObject(UPDATE_WORKSPACE_ROLES, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}


/**
   * Fetches the permission status for managing roles on a collection
   *
   * @param {String} collectionUID
   * @returns Promise<{ results: object[] }>
   */
function fetchCollectionManageRole(collectionUID) {
  if (!collectionUID) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchUpdateWorkspacesRoles: No collection UID provided'));
  }

  let options = { modelIds: [collectionUID], modelType: COLLECTION };

  return _fetchPerObject(UPDATE_COLLECTION_ROLES, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
   * Fetches the permission status for sharing a collection
   *
   * @param {String} collectionUID
   * @returns Promise<{ results: object[] }>
   */
function fetchCollectionShare(collectionUID) {
  if (!collectionUID) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchUpdateWorkspacesRoles: No collection UID provided'));
  }

  let options = { modelIds: [collectionUID], modelType: COLLECTION };

  return _fetchPerObject(SHARE_COLLECTION, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
   * Fetches the permission status for adding an API to a workspaces
   * for a given list of workspaces
   *
   * @param {Array<String>} workspaceIds
   * @returns Promise<{ results: object[] }>
   */
function fetchAddAPIToWorkspaces(workspaceIds) {
  if (_.isEmpty(workspaceIds)) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchAddAPIToWorkspaces: No workspace Ids provided'));
  }

  let options = { modelIds: workspaceIds, modelType: WORKSPACE };

  return _fetchPerObject(ADD_API_TO_WORKSPACE, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}


/**
   * Fetches the permission status for managing roles on an API
   *
   * @param {String} apiId
   * @returns Promise<{ results: object[] }>
   */
function fetchAPIManageRole(apiId) {
  if (!apiId) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchAPIManageRole: No API ID provided'));
  }

  let options = { modelIds: [apiId], modelType: API };

  return _fetchPerObject(UPDATE_API_ROLES, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
   * Fetches the permission status for sharing an API
   *
   * @param {String} apiId
   * @returns Promise<{ results: object[] }>
   */
function fetchAPIShare(apiId) {
  if (!apiId) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchAPIShare: No API ID provided'));
  }

  let options = { modelIds: [apiId], modelType: API };

  return _fetchPerObject(SHARE_API, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
  * Fetches permission status for send unapproved invites
  * @param { String } teamId
  * @returns Promise<{ results: object[] }>
  */
function fetchSendUnapprovedInvites(teamId) {
  if (!teamId) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchSendUnapprovedInvites: No team id provided'));
  }

  let options = { modelIds: [teamId], modelType: TEAM };

  return _fetchPerObject(SEND_UNAPPROVED_INVITES, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}

/**
  * Fetches permission status for send preapproved invites
  * @param { String } teamId
  * @returns Promise<{ results: object[] }>
  */
function fetchManageTeamInvites(teamId) {
  if (!teamId) {
    return Promise.reject(new Error('PermissionRemoteFetchService~fetchManageTeamInvites: No team id provided'));
  }

  let options = { modelIds: [teamId], modelType: TEAM };

  return _fetchPerObject(MANAGE_TEAM_INVITES, options).
  then((permissionsData = {}) => {
    return permissionsData.results;
  });
}
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 3776:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
const GENERATED = 'generated',
LOADING = 'loading',
EMPTY = 'empty',
ERROR = 'error',
FREE_COLLAB_STARTED = 'free_collab_started';
/* harmony export (immutable) */ __webpack_exports__["d"] = GENERATED;

/* harmony export (immutable) */ __webpack_exports__["e"] = LOADING;

/* harmony export (immutable) */ __webpack_exports__["a"] = EMPTY;

/* harmony export (immutable) */ __webpack_exports__["b"] = ERROR;

/* harmony export (immutable) */ __webpack_exports__["c"] = FREE_COLLAB_STARTED;


/***/ }),

/***/ 3934:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CollectionExplorer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_prop_types__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_prop_types___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_prop_types__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__Explorer__ = __webpack_require__(1549);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__utils_CollectionTreeUtil__ = __webpack_require__(1517);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__utils_util__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__stores_get_store__ = __webpack_require__(5);
var _class;






let


CollectionExplorer = Object(__WEBPACK_IMPORTED_MODULE_1_mobx_react__["a" /* observer */])(_class = class CollectionExplorer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      selectedTarget: {},
      filter: '' };


    this.setInitialTargets = this.setInitialTargets.bind(this);
    this.handleSelect = this.handleSelect.bind(this);
    this.handleCreate = this.handleCreate.bind(this);
    this.handleFilter = this.handleFilter.bind(this);
    this.handleBack = this.handleBack.bind(this);
    this.getCreateRowText = this.getCreateRowText.bind(this);

    /**
                                                               * hackkkkkk
                                                               * Reason - In CollectionExplorer, the target list is fetched from the props asynchronously
                                                               * due to which we do not know the exact point when we get the targets in this component,hence can't figure out the new target added
                                                               * this.newTargetId - holds the id of new collection/folder created
                                                               * newTargetId is passed down to the Explorer to set the created collection/folder as selected
                                                               */
    this.newTargetId = undefined;
  }

  componentDidMount() {
    this.setInitialTargets();
  }

  componentDidUpdate() {
    // unset the target id after the child component has updated
    this.newTargetId = undefined;
  }
  setInitialTargets(initialSelection = this.props.initialSelection) {
    if (!initialSelection) {
      return;
    }

    let item = null;
    if (_.get(initialSelection, 'folder')) {
      item = _.get(initialSelection, 'folder');
    } else
    if (_.get(initialSelection, 'collection')) {
      item = _.get(initialSelection, 'collection');
    }

    item && this.refs.explorer && this.refs.explorer.handleSelect(item);
  }

  handleSelect(target) {
    this.setState({
      selectedTarget: target,
      filter: '' });

    _.invoke(this.props, 'onSelect', target);
  }

  handleCreate(name, selectedTarget) {
    this.setState({ filter: '' });
    if (!selectedTarget) {
      return;
    }

    // This means it is the collection create
    if (_.isNull(selectedTarget.id) || !_.isEmpty(this.state.filter)) {
      let currentUser = Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('CurrentUserStore'),
      workspaceId = Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('ActiveWorkspaceStore').id;

      if (!Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('PermissionStore').can('addcollection', 'workspace', workspaceId)) {
        return pm.toasts.error('You do not have permissions required to add this collection.');
      }
      let collection = {
        id: __WEBPACK_IMPORTED_MODULE_5__utils_util__["a" /* default */].guid(),
        name: name,
        owner: currentUser.id },

      collectionAddEvent = {
        name: 'create_deep',
        namespace: 'collection',
        data: { collection },
        meta: { origin: this.props.origin } };


      Object(__WEBPACK_IMPORTED_MODULE_6__modules_pipelines_user_action__["a" /* default */])(collectionAddEvent).
      then(response => {
        this.newTargetId = _.get(response, 'response.data.collection.id');
        if (!_.isEmpty(_.get(response, 'error'))) {
          pm.logger.error('Error in creating collection', response.error);
          return;
        }
      }).
      catch(err => {
        pm.logger.error('Error in pipeline while creating collection', err);
      });
    }

    // Here it may be inside a collection or a folder selected
    else {
        let folder,
        collection,
        canEdit,
        folderCollectionId;

        if (selectedTarget.type === 'collection') {
          collection = _.find(this.props.collections, ['id', selectedTarget.id]);

          if (!collection) {
            return pm.toasts.error('We can\'t seem to find the collection.');
          }
          if (!Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('PermissionStore').can('addFolder', 'collection', selectedTarget.id)) {
            return pm.toasts.error('You do not have permissions required to edit this collection.');
          }

          let folderAddEvent = {
            name: 'create_deep',
            namespace: 'folder',
            data: {
              folder: {
                id: __WEBPACK_IMPORTED_MODULE_5__utils_util__["a" /* default */].guid(),
                name: name,
                collection: collection.id },

              target: {
                model: 'collection',
                modelId: collection.id } } };




          Object(__WEBPACK_IMPORTED_MODULE_6__modules_pipelines_user_action__["a" /* default */])(folderAddEvent).
          then(response => {
            this.newTargetId = _.get(response, 'response.data.folder.id');
            if (!_.isEmpty(_.get(response, 'error'))) {
              pm.logger.error('Error in creating folder', response.error);
              return;
            }
          }).
          catch(err => {
            pm.logger.error('Error in pipeline while creating folder', err);
          });
        } else
        if (selectedTarget.type === 'folder') {
          folder = _.find(this.props.folders, ['id', selectedTarget.id]);
          folderCollectionId = folder && folder.collection;
          collection = _.find(this.props.collections, ['id', folderCollectionId]);

          if (!collection) {
            return pm.toasts.error('We can\'t seem to find the collection.');
          }
          if (!Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('PermissionStore').can('addFolder', 'folder', selectedTarget.id)) {
            return pm.toasts.error('You do not have permissions required to edit this collection.');
          }

          let folderAddEvent = {
            name: 'create_deep',
            namespace: 'folder',
            data: {
              folder: {
                id: __WEBPACK_IMPORTED_MODULE_5__utils_util__["a" /* default */].guid(),
                name: name,
                collection: collection.id },

              target: {
                model: 'folder',
                modelId: selectedTarget.id } } };




          Object(__WEBPACK_IMPORTED_MODULE_6__modules_pipelines_user_action__["a" /* default */])(folderAddEvent).
          then(response => {
            this.newTargetId = _.get(response, 'response.data.folder.id');
            if (!_.isEmpty(_.get(response, 'error'))) {
              pm.logger.error('Error in creating folder', response.error);
              return;
            }
          }).
          catch(err => {
            pm.logger.error('Error in pipeline while creating folder', err);
          });
        }
      }
  }

  handleFilter(filter) {
    this.setState({ filter: filter });
    _.invoke(this.props, 'onFilter', filter);
  }

  handleBack(newTarget) {
    _.invoke(this.props, 'onSelect', newTarget);
  }

  getCreateRowText(selectedTarget) {
    return selectedTarget.depth === -1 || !_.isEmpty(this.state.filter) ?
    '+ Create Collection ' + (this.state.filter && `"${this.state.filter}"`) :
    '+ Create Folder ' + (this.state.filter && `"${this.state.filter}"`);
  }

  getCreateRowPlaceholder(selectedTarget) {
    return selectedTarget.depth === -1 ?
    'Name your collection' :
    'Name your folder';
  }

  getLeafIcon(node) {
    let method = node.method ? node.method.toUpperCase() : 'GET';
    let classes = `explorer-row__icon-leaf-icon request-method--${method}`;
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: classes },
        node.method));


  }

  render() {
    let collections = _.map(this.props.collections, collection => {
      return Object(__WEBPACK_IMPORTED_MODULE_4__utils_CollectionTreeUtil__["a" /* flattenCollection */])(collection, this.props.folders, this.props.requests);
    });
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-explorer' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__Explorer__["a" /* default */], {
          createPlaceholder: this.getCreateRowPlaceholder,
          createText: this.getCreateRowText,
          disableCreate: this.props.disableCreate,
          isLeaf: target => {return target.type === 'request';},
          leafIcon: this.getLeafIcon,
          ref: 'explorer',
          targets: _.flatten(collections),
          onBack: this.handleBack,
          onCreate: this.handleCreate,
          onFilter: this.handleFilter,
          onSelect: this.handleSelect,
          newTargetId: this.newTargetId,
          loading: this.props.loadingCollections })));



  }}) || _class;


CollectionExplorer.defaultProps = {
  loadingCollections: false };


CollectionExplorer.propTypes = {
  disableCreate: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.bool,
  initialSelection: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.object,
  onCreate: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.func,
  onFilter: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.func,
  onSelect: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.func,
  loadingCollections: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.bool };
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 3935:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CollectionModalTabs; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Tabs__ = __webpack_require__(103);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__constants_CollectionModalTabsConstants__ = __webpack_require__(983);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_XPaths_XPath__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__stores_get_store__ = __webpack_require__(5);





let

CollectionModalTabs = class CollectionModalTabs extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  render() {
    /**
             * @todo: Remove usage of feature flag - COLLECTION_CONFIGURATIONS_ENABLED,
             *        once sync supports protocolProfileBehavior for collection and folders
             */
    const COLLECTION_CONFIGURATIONS_ENABLED = Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('FeatureFlagsStore').isEnabled('collectionAndFolderConfigurations');

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-tabs' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Tabs__["b" /* Tabs */], {
            type: 'primary',
            defaultActive: __WEBPACK_IMPORTED_MODULE_2__constants_CollectionModalTabsConstants__["c" /* COLLECTION_DESCRIPTION */],
            activeRef: this.props.activeTab,
            onChange: this.props.onSelect },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_XPaths_XPath__["a" /* default */], { identifier: 'descriptionTab' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Tabs__["a" /* Tab */], { refKey: __WEBPACK_IMPORTED_MODULE_2__constants_CollectionModalTabsConstants__["c" /* COLLECTION_DESCRIPTION */] },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Description'))),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_XPaths_XPath__["a" /* default */], { identifier: 'authorizationTab' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Tabs__["a" /* Tab */], { refKey: __WEBPACK_IMPORTED_MODULE_2__constants_CollectionModalTabsConstants__["a" /* COLLECTION_AUTHORIZATION */] },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Authorization'),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null,

                this.props.isAuthSelected &&
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-tabs-badge' })))),




          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_XPaths_XPath__["a" /* default */], { identifier: 'preRequestTab' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Tabs__["a" /* Tab */], { refKey: __WEBPACK_IMPORTED_MODULE_2__constants_CollectionModalTabsConstants__["d" /* COLLECTION_PRE_REQUEST_SCRIPTS */] },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Pre-request Scripts'),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null,

                this.props.isPreRequestScriptAvailable &&
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-tabs-badge' })))),




          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_XPaths_XPath__["a" /* default */], { identifier: 'testsTab' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Tabs__["a" /* Tab */], { refKey: __WEBPACK_IMPORTED_MODULE_2__constants_CollectionModalTabsConstants__["e" /* COLLECTION_TESTS */] },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Tests'),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null,

                this.props.isTestsAvailable &&
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-tabs-badge' })))),




          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_XPaths_XPath__["a" /* default */], { identifier: 'variablesTab' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Tabs__["a" /* Tab */], { refKey: __WEBPACK_IMPORTED_MODULE_2__constants_CollectionModalTabsConstants__["f" /* COLLECTION_VARIABLES */] },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Variables'),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null,

                this.props.hasVariables &&
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-tabs-badge' })))),





          COLLECTION_CONFIGURATIONS_ENABLED &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Tabs__["a" /* Tab */], { refKey: __WEBPACK_IMPORTED_MODULE_2__constants_CollectionModalTabsConstants__["b" /* COLLECTION_CONFIGURATIONS */] },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Settings')))));





  }};


CollectionModalTabs.defaultProps = {
  isAuthSelected: false,
  isPreRequestScriptAvailable: false,
  isTestsAvailable: false,
  hasVariables: false };

/***/ }),

/***/ 3936:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CollectionModalTabContents; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
let

CollectionModalTabContents = class CollectionModalTabContents extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  render() {

    let children = __WEBPACK_IMPORTED_MODULE_0_react___default.a.Children.map(this.props.children, child => {
      return __WEBPACK_IMPORTED_MODULE_0_react___default.a.cloneElement(child, { active: this.props.activeKey === child.key });
    });
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-tab-contents' },
        children));


  }};

/***/ }),

/***/ 3937:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CollectionModalTabContent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_classnames__);

let

CollectionModalTabContent = class CollectionModalTabContent extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  getClasses() {
    return __WEBPACK_IMPORTED_MODULE_1_classnames___default()({
      'collection-modal-tab-content': true,
      'is-hidden': !this.props.active },
    this.props.className);
  }

  render() {

    let classes = this.getClasses();
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: classes },
        this.props.children));


  }};

/***/ }),

/***/ 3938:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CollectionDescription; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_TextEditor__ = __webpack_require__(311);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__constants_AppUrlConstants__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__external_navigation_ExternalNavigationService__ = __webpack_require__(59);
var _class;



let


CollectionDescription = __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default()(_class = class CollectionDescription extends __WEBPACK_IMPORTED_MODULE_0_react___default.a.Component {
  constructor(props) {
    super(props);
  }

  handleLinkClick() {
    Object(__WEBPACK_IMPORTED_MODULE_4__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_3__constants_AppUrlConstants__["Q" /* MARKDOWN_DOCS */]);
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-tab-content-container' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-tab-content-description' }, 'This description will show in your collection\u2019s documentation, along with the descriptions of its folders and requests.'),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_TextEditor__["a" /* default */], {
          hideGutter: true,
          showScrollMargin: true,
          className: 'collection-modal-editor',
          mode: 'markdown',
          placeholder: 'Make things easier for your teammates with a complete request description.',
          value: this.props.description,
          onChange: this.props.onChange,
          height: '100%' }),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'addnew-description-help-text' }, 'Descriptions support',

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', {
              className: 'btn btn-text inline-editor__markdown-link',
              onClick: this.handleLinkClick }, 'Markdown'))));






  }}) || _class;

/***/ }),

/***/ 3939:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CollectionPreRequestScripts; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_TextEditor__ = __webpack_require__(311);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_base_keymaps_KeyMaps__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__external_navigation_ExternalNavigationService__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__constants_AppUrlConstants__ = __webpack_require__(64);







const keyMap = { beautifyCollectionPRScript: 'mod+b' };let

CollectionPreRequestScripts = class CollectionPreRequestScripts extends __WEBPACK_IMPORTED_MODULE_0_react___default.a.Component {
  constructor(props) {
    super(props);
    this.handleBeautify = this.handleBeautify.bind(this);
  }

  focus() {
    this.refs.editor.focus();
  }

  refresh() {
    this.refs.editor.refresh();
  }

  handleBeautify() {
    this.props.onBeautify && this.props.onBeautify();
  }

  getKeyMapHandlers() {
    return { 'beautifyCollectionPRScript': this.handleBeautify };
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_keymaps_KeyMaps__["a" /* default */], { keyMap: keyMap, handlers: this.getKeyMapHandlers() },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-tab-content-container' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-tab-content-description' }, 'This script will execute before every request in this collection.\xA0',

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', {
                className: 'external-link',
                onClick: () => {Object(__WEBPACK_IMPORTED_MODULE_4__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_5__constants_AppUrlConstants__["Y" /* PRE_REQUEST_SCRIPT_DOCS */]);} }, 'Learn more about Postman\u2019s execution order.')),




          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_TextEditor__["a" /* default */], {
            enableVariableSuggestions: true,
            value: this.props.value,
            fontSize: this.props.fontSize,
            mode: 'javascript',
            onChange: this.props.onChange,
            ref: 'editor',
            softTabs: true,
            enableAutocomplete: true,
            showScrollMargin: true,
            className: 'collection-modal-editor',
            height: '95%' }))));




  }};

/***/ }),

/***/ 3940:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CollectionVariables; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__keyvalue_editor_KeyValueEditor__ = __webpack_require__(362);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__constants_AppUrlConstants__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__variables_VariableAlertWrapper__ = __webpack_require__(3620);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__external_navigation_ExternalNavigationService__ = __webpack_require__(59);
var _class;





let

CollectionVariables = __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default()(_class = class CollectionVariables extends __WEBPACK_IMPORTED_MODULE_0_react___default.a.Component {
  constructor(props) {
    super(props);
    this.handleVariablesChange = this.handleVariablesChange.bind(this);
  }

  handleVariablesChange(values) {
    this.props.onChange && this.props.onChange(values);
  }

  handleAnalyticsEvent(eventName) {
    switch (eventName) {
      case 'persist_all':
      case 'persist_single':
      case 'reset_all':
      case 'reset_single':
        __WEBPACK_IMPORTED_MODULE_5__modules_services_AnalyticsService__["a" /* default */].addEvent('session', eventName, 'collection');
        break;}

  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-tab-content-container' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-tab-content-description' }, 'These variables are specific to this collection and its requests.\xA0',

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', {
              className: 'external-link',
              onClick: () => {Object(__WEBPACK_IMPORTED_MODULE_6__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_3__constants_AppUrlConstants__["_16" /* VARIABLE_DOCS */]);} }, 'Learn more about collection variables.')),




        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-variables-container' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__keyvalue_editor_KeyValueEditor__["a" /* default */], {
            disallowDuplicates: true,
            values: this.props.values,
            keyHeading: 'VARIABLE',
            valueHeading: 'INITIAL VALUE',
            sessionHeading: 'CURRENT VALUE',
            keyPlaceholder: 'Add a new variable',
            valuePlaceholder: '',
            onChange: this.handleVariablesChange,
            onAnalyticsEvent: this.handleAnalyticsEvent,
            onColumnToggle: this.props.onColumnToggle,
            showColumns: this.props.showColumns,
            allowedColumns: ['key', 'value', 'sessionValue'] })),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__variables_VariableAlertWrapper__["a" /* default */], { className: 'collection-modal-variables-alert' })));


  }}) || _class;

/***/ }),

/***/ 3941:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CollectionConfigurationList; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__configuration_list_item_ConfigurationListItem__ = __webpack_require__(1534);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__utils_configurationsUtil__ = __webpack_require__(3746);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__constants_ConfigurationConstants__ = __webpack_require__(978);





/**
                                                                          * This is the list container for configuration list items in collection modal
                                                                          * `AddCollectionModalContainer` and `EditCollectionModalContainer` uses this component
                                                                          *
                                                                          * This component uses `getCollectionInheritedState` function from `configurationsUtil` to pass on the inherited state to each configuration list item
                                                                          */let
CollectionConfigurationList = class CollectionConfigurationList extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  handleFieldChange(key, value) {
    /**
                                  * key in protocolProfileBehavior of collection will only be added in db when user explicitly changes the value of that specific settings
                                  */
    this.props.updateProtocolProfileBehavior && this.props.updateProtocolProfileBehavior(key, value);
  }

  handleRestoreDefault(key) {
    /**
                              * key in protocolProfileBehavior of collection will only be removed from db when user explicitly clicks `Restore Default` action
                              */
    this.props.removeKeyFromProtocolProfileBehavior && this.props.removeKeyFromProtocolProfileBehavior(key);
  }

  render() {
    let inheritedState = Object(__WEBPACK_IMPORTED_MODULE_2__utils_configurationsUtil__["a" /* getCollectionInheritedState */])();
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-configuration-list' },

        _.map(__WEBPACK_IMPORTED_MODULE_3__constants_ConfigurationConstants__["b" /* CONFIGURATIONS */], configuration => {
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__configuration_list_item_ConfigurationListItem__["a" /* default */], {
              key: configuration.id,
              title: configuration.title,
              description: configuration.description,
              value: _.get(this.props.configuration, [configuration.id]),
              inheritedState: _.get(inheritedState, [configuration.id]),
              defaultValue: configuration.defaultValue,
              inputFieldType: configuration.inputFieldType,
              inputType: configuration.inputType,
              handleFieldChange: this.handleFieldChange.bind(this, configuration.id),
              handleRestoreDefault: this.handleRestoreDefault.bind(this, configuration.id),
              menuOptions: configuration.menuOptions,
              menuLabels: configuration.menuLabels }));


        })));



  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 3942:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CollectionTests; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_TextEditor__ = __webpack_require__(311);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_keymaps_KeyMaps__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__external_navigation_ExternalNavigationService__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__constants_AppUrlConstants__ = __webpack_require__(64);
var _class;






const keyMap = { beautifyCollectionTests: 'mod+b' };let


CollectionTests = __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default()(_class = class CollectionTests extends __WEBPACK_IMPORTED_MODULE_0_react___default.a.Component {
  constructor(props) {
    super(props);
    this.handleBeautify = this.handleBeautify.bind(this);
  }

  focus() {
    this.refs.editor.focus();
  }

  refresh() {
    this.refs.editor.refresh();
  }

  handleBeautify() {
    _.invoke(this, 'props.onBeautify');
  }

  getKeyMapHandlers() {
    return { 'beautifyCollectionTests': this.handleBeautify };
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_keymaps_KeyMaps__["a" /* default */], { keyMap: keyMap, handlers: this.getKeyMapHandlers() },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-tab-content-container' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-tab-content-description' }, 'These tests will execute after every request in this collection.\xA0',

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', {
                className: 'external-link',
                onClick: () => {Object(__WEBPACK_IMPORTED_MODULE_4__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_5__constants_AppUrlConstants__["_13" /* TEST_SCRIPT_DOCS */]);} }, 'Learn more about Postman\u2019s execution order.')),




          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_TextEditor__["a" /* default */], {
            debug: true,
            enableVariableSuggestions: true,
            value: this.props.value,
            fontSize: this.props.fontSize,
            mode: 'javascript',
            onChange: this.props.onChange,
            ref: 'editor',
            softTabs: true,
            enableAutocomplete: true,
            showScrollMargin: true,
            className: 'collection-modal-editor',
            height: '95%' }))));




  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 3943:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CollectionAuthEditorContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_auth_AuthEditor__ = __webpack_require__(1533);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__constants_AppUrlConstants__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__external_navigation_ExternalNavigationService__ = __webpack_require__(59);



let
CollectionAuthEditorContainer = class CollectionAuthEditorContainer extends __WEBPACK_IMPORTED_MODULE_0_react___default.a.Component {
  constructor(props) {
    super(props);
    this.state = {
      showPassword: false,
      showAuthVariablesAlert: pm.settings.getSetting('showAuthVariablesAlert'),
      showAuthAdvancedFields: pm.settings.getSetting('showAuthAdvancedFields') };

    this.handleShowPassword = this.handleShowPassword.bind(this);
    this.handleVariablesLearnMore = this.handleVariablesLearnMore.bind(this);
    this.handleDismissVariablesAlert = this.handleDismissVariablesAlert.bind(this);
    this.toggleAdvancedFields = this.toggleAdvancedFields.bind(this);
    this.handleAuthorizationLearnMore = this.handleAuthorizationLearnMore.bind(this);
  }

  handleShowPassword() {
    this.setState({ showPassword: !this.state.showPassword });
  }

  handleVariablesLearnMore() {
    Object(__WEBPACK_IMPORTED_MODULE_3__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_2__constants_AppUrlConstants__["_16" /* VARIABLE_DOCS */]);
  }

  handleDismissVariablesAlert() {
    this.setState({ showAuthVariablesAlert: false }, () => {
      pm.settings.setSetting('showAuthVariablesAlert', false);
    });
  }

  toggleAdvancedFields() {
    const showAuthAdvancedFields = !this.state.showAuthAdvancedFields;

    this.setState({ showAuthAdvancedFields }, () => {
      pm.settings.setSetting('showAuthAdvancedFields', showAuthAdvancedFields);
    });
  }

  handleAuthorizationLearnMore() {
    Object(__WEBPACK_IMPORTED_MODULE_3__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_2__constants_AppUrlConstants__["m" /* AUTH_DOCS */]);
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-tab-content-container' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-tab-content-description' }, 'This authorization method will be used for every request in this collection. You can override this by specifying one in the request.'),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_auth_AuthEditor__["a" /* default */], {
          auth: this.props.auth,
          showPreviewButton: false,
          type: 'collection',
          collectionId: this.props.collectionId,
          showAuthVariablesAlert: this.state.showAuthVariablesAlert,
          showAuthAdvancedFields: this.state.showAuthAdvancedFields,
          showPassword: this.state.showPassword,
          onShowPasswordToggle: this.handleShowPassword,
          onAuthTypeSelect: this.props.handleAuthTypeSelect,
          onVariablesLearnMore: this.handleVariablesLearnMore,
          onDismissVariablesAlert: this.handleDismissVariablesAlert,
          onToggleAdvancedFields: this.toggleAdvancedFields,
          onAuthorizationLearnMore: this.handleAuthorizationLearnMore,
          onFieldChange: this.props.handleFieldChange,
          onUseToken: this.props.onUseToken,
          layout: this.props.layout,
          handleAuthAnalytics: this.props.handleAuthAnalytics })));



  }};

/***/ }),

/***/ 3944:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return FolderModalTabs; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Tabs__ = __webpack_require__(103);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_keymaps_KeyMaps__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__utils_util__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__constants_FolderConstants__ = __webpack_require__(982);










let

FolderModalTabs = class FolderModalTabs extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  render() {
    /**
             * @todo: Remove usage of feature flag - FOLDER_CONFIGURATIONS_ENABLED,
             *        once sync supports protocolProfileBehavior for collection and folders
             */
    const FOLDER_CONFIGURATIONS_ENABLED = Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('FeatureFlagsStore').isEnabled('collectionAndFolderConfigurations');

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-tabs' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Tabs__["b" /* Tabs */], {
            type: 'primary',
            defaultActive: __WEBPACK_IMPORTED_MODULE_7__constants_FolderConstants__["c" /* FOLDER_DESCRIPTION */],
            activeRef: this.props.activeTab,
            onChange: this.props.onSelect },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Tabs__["a" /* Tab */], { refKey: __WEBPACK_IMPORTED_MODULE_7__constants_FolderConstants__["c" /* FOLDER_DESCRIPTION */] },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Description')),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Tabs__["a" /* Tab */], { refKey: __WEBPACK_IMPORTED_MODULE_7__constants_FolderConstants__["a" /* FOLDER_AUTHORIZATION */] },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Authorization'),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null,

              this.props.isAuthSelected &&
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-tabs-badge' }))),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Tabs__["a" /* Tab */], { refKey: __WEBPACK_IMPORTED_MODULE_7__constants_FolderConstants__["d" /* FOLDER_PRE_REQUEST_SCRIPTS */] },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Pre-request Scripts'),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null,

              this.props.isPreRequestScriptAvailable &&
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-tabs-badge' }))),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Tabs__["a" /* Tab */], { refKey: __WEBPACK_IMPORTED_MODULE_7__constants_FolderConstants__["e" /* FOLDER_TESTS */] },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Tests'),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null,

              this.props.isTestsAvailable &&
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-tabs-badge' }))),




          FOLDER_CONFIGURATIONS_ENABLED &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Tabs__["a" /* Tab */], { refKey: __WEBPACK_IMPORTED_MODULE_7__constants_FolderConstants__["b" /* FOLDER_CONFIGURATIONS */] },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Settings')))));





  }};


FolderModalTabs.defaultProps = {
  isAuthSelected: false,
  isPreRequestScriptAvailable: false,
  isTestsAvailable: false };

/***/ }),

/***/ 3945:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return FolderModalTabContents; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
let

FolderModalTabContents = class FolderModalTabContents extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  render() {

    let children = __WEBPACK_IMPORTED_MODULE_0_react___default.a.Children.map(this.props.children, child => {
      return __WEBPACK_IMPORTED_MODULE_0_react___default.a.cloneElement(child, { active: this.props.activeKey === child.key });
    });
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-tab-contents' },
        children));


  }};

/***/ }),

/***/ 3946:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return FolderModalTabContent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_classnames__);

let

FolderModalTabContent = class FolderModalTabContent extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  getClasses() {
    return __WEBPACK_IMPORTED_MODULE_1_classnames___default()({
      'collection-modal-tab-content': true,
      'is-hidden': !this.props.active },
    this.props.className);
  }

  render() {

    let classes = this.getClasses();

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: classes },
        this.props.children));


  }};

/***/ }),

/***/ 3947:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return FolderPreRequestScripts; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_TextEditor__ = __webpack_require__(311);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_keymaps_KeyMaps__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__external_navigation_ExternalNavigationService__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__constants_AppUrlConstants__ = __webpack_require__(64);







const keyMap = { beautifyCollectionPRScript: 'mod+b' };let

FolderPreRequestScripts = class FolderPreRequestScripts extends __WEBPACK_IMPORTED_MODULE_0_react___default.a.Component {
  constructor(props) {
    super(props);
    this.handleBeautify = this.handleBeautify.bind(this);
  }

  focus() {
    this.refs.editor.focus();
  }

  refresh() {
    this.refs.editor.refresh();
  }

  handleBeautify() {
    _.invoke(this, 'props.onBeautify');
  }

  getKeyMapHandlers() {
    return { 'beautifyCollectionPRScript': this.handleBeautify };
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_keymaps_KeyMaps__["a" /* default */], { keyMap: keyMap, handlers: this.getKeyMapHandlers() },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-tab-content-container' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-tab-content-description' }, 'This script will execute before every request in this folder.\xA0',

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', {
                className: 'external-link',
                onClick: () => {Object(__WEBPACK_IMPORTED_MODULE_4__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_5__constants_AppUrlConstants__["Y" /* PRE_REQUEST_SCRIPT_DOCS */]);} }, 'Learn more about Postman\u2019s execution order.')),




          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_TextEditor__["a" /* default */], {
            enableVariableSuggestions: true,
            value: this.props.value,
            fontSize: this.props.fontSize,
            mode: 'javascript',
            onChange: this.props.onChange,
            ref: 'editor',
            softTabs: true,
            enableAutocomplete: true,
            showScrollMargin: true,
            className: 'collection-modal-editor',
            height: '95%' }))));




  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 3948:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return FolderTests; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_TextEditor__ = __webpack_require__(311);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_keymaps_KeyMaps__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__external_navigation_ExternalNavigationService__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__constants_AppUrlConstants__ = __webpack_require__(64);
var _class;






const keyMap = { beautifyCollectionTests: 'mod+b' };let


FolderTests = __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default()(_class = class FolderTests extends __WEBPACK_IMPORTED_MODULE_0_react___default.a.Component {
  constructor(props) {
    super(props);
    this.handleBeautify = this.handleBeautify.bind(this);
  }

  focus() {
    this.refs.editor.focus();
  }

  refresh() {
    this.refs.editor.refresh();
  }

  handleBeautify() {
    _.invoke(this, 'props.onBeautify');
  }

  getKeyMapHandlers() {
    return { 'beautifyCollectionTests': this.handleBeautify };
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_keymaps_KeyMaps__["a" /* default */], { keyMap: keyMap, handlers: this.getKeyMapHandlers() },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-tab-content-container' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-tab-content-description' }, 'These tests will execute after every request in this folder.\xA0',

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', {
                className: 'external-link',
                onClick: () => {Object(__WEBPACK_IMPORTED_MODULE_4__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_5__constants_AppUrlConstants__["_13" /* TEST_SCRIPT_DOCS */]);} }, 'Learn more about Postman\u2019s execution order.')),




          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_TextEditor__["a" /* default */], {
            debug: true,
            enableVariableSuggestions: true,
            value: this.props.value,
            fontSize: this.props.fontSize,
            mode: 'javascript',
            onChange: this.props.onChange,
            ref: 'editor',
            softTabs: true,
            enableAutocomplete: true,
            showScrollMargin: true,
            className: 'collection-modal-editor',
            height: '95%' }))));




  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 3949:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return FolderConfigurationList; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__configuration_list_item_ConfigurationListItem__ = __webpack_require__(1534);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__constants_ConfigurationConstants__ = __webpack_require__(978);




/**
                                                                             * This is the list container for configuration list items in folder modal
                                                                             * `AddFolderModalContainer` and `EditFolderModalContainer` uses this component
                                                                             */let
FolderConfigurationList = class FolderConfigurationList extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  handleFieldChange(key, value) {
    /**
                                  * key in protocolProfileBehavior of folder will only be added in db when user explicitly changes the value of that specific settings
                                  */
    this.props.updateProtocolProfileBehavior && this.props.updateProtocolProfileBehavior(key, value);
  }

  handleRestoreDefault(key) {
    /**
                              * key in protocolProfileBehavior of folder will only be removed from db when user explicitly clicks `Restore Default` action
                              */
    this.props.removeKeyFromProtocolProfileBehavior && this.props.removeKeyFromProtocolProfileBehavior(key);
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-configuration-list' },

        _.map(__WEBPACK_IMPORTED_MODULE_2__constants_ConfigurationConstants__["b" /* CONFIGURATIONS */], configuration => {
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__configuration_list_item_ConfigurationListItem__["a" /* default */], {
              key: configuration.id,
              title: configuration.title,
              description: configuration.description,
              value: _.get(this.props.configuration, [configuration.id]),
              inheritedState: _.get(this.props.inheritedConfigParent, [configuration.id]),
              defaultValue: configuration.defaultValue,
              inputFieldType: configuration.inputFieldType,
              inputType: configuration.inputType,
              handleFieldChange: this.handleFieldChange.bind(this, configuration.id),
              handleRestoreDefault: this.handleRestoreDefault.bind(this, configuration.id),
              menuOptions: configuration.menuOptions,
              menuLabels: configuration.menuLabels }));


        })));



  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 3950:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return FolderDescription; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_TextEditor__ = __webpack_require__(311);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__constants_AppUrlConstants__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__external_navigation_ExternalNavigationService__ = __webpack_require__(59);
var _class;



let


FolderDescription = __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default()(_class = class FolderDescription extends __WEBPACK_IMPORTED_MODULE_0_react___default.a.Component {
  constructor(props) {
    super(props);
  }

  handleLinkClick() {
    Object(__WEBPACK_IMPORTED_MODULE_4__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_3__constants_AppUrlConstants__["Q" /* MARKDOWN_DOCS */]);
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-tab-content-container' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-tab-content-description' }, 'This description will show in your collection\u2019s documentation, along with the descriptions of its folders and requests.'),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_TextEditor__["a" /* default */], {
          hideGutter: true,
          showScrollMargin: true,
          className: 'collection-modal-editor',
          mode: 'markdown',
          placeholder: 'Make things easier for your teammates with a complete request description.',
          value: this.props.description,
          onChange: this.props.onChange,
          height: '100%' }),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'addnew-description-help-text' }, 'Descriptions support',

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', {
              className: 'btn btn-text inline-editor__markdown-link',
              onClick: this.handleLinkClick }, 'Markdown'))));






  }}) || _class;

/***/ }),

/***/ 3951:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return FolderAuthEditorContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_auth_AuthEditor__ = __webpack_require__(1533);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__constants_AppUrlConstants__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__external_navigation_ExternalNavigationService__ = __webpack_require__(59);



let
FolderAuthEditorContainer = class FolderAuthEditorContainer extends __WEBPACK_IMPORTED_MODULE_0_react___default.a.Component {
  constructor(props) {
    super(props);
    this.state = {
      showPassword: false,
      showAuthVariablesAlert: pm.settings.getSetting('showAuthVariablesAlert'),
      showAuthAdvancedFields: pm.settings.getSetting('showAuthAdvancedFields') };

    this.handleShowPassword = this.handleShowPassword.bind(this);
    this.handleVariablesLearnMore = this.handleVariablesLearnMore.bind(this);
    this.handleDismissVariablesAlert = this.handleDismissVariablesAlert.bind(this);
    this.toggleAdvancedFields = this.toggleAdvancedFields.bind(this);
    this.handleAuthorizationLearnMore = this.handleAuthorizationLearnMore.bind(this);
  }

  handleShowPassword() {
    this.setState({ showPassword: !this.state.showPassword });
  }

  handleVariablesLearnMore() {
    Object(__WEBPACK_IMPORTED_MODULE_3__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_2__constants_AppUrlConstants__["_16" /* VARIABLE_DOCS */]);
  }

  handleDismissVariablesAlert() {
    this.setState({ showAuthVariablesAlert: false }, () => {
      pm.settings.setSetting('showAuthVariablesAlert', false);
    });
  }

  toggleAdvancedFields() {
    const showAuthAdvancedFields = !this.state.showAuthAdvancedFields;

    this.setState({ showAuthAdvancedFields }, () => {
      pm.settings.setSetting('showAuthAdvancedFields', showAuthAdvancedFields);
    });
  }

  handleAuthorizationLearnMore() {
    Object(__WEBPACK_IMPORTED_MODULE_3__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_2__constants_AppUrlConstants__["m" /* AUTH_DOCS */]);
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-tab-content-container' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-tab-content-description' }, 'This authorization method will be used for every request in this folder. You can override this by specifying one in the request.'),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_auth_AuthEditor__["a" /* default */], {
          auth: this.props.auth,
          inheritedAuth: this.props.inheritedAuth,
          type: 'folder',
          collectionId: this.props.collectionId,
          showPreviewButton: false,
          showAuthVariablesAlert: this.state.showAuthVariablesAlert,
          showAuthAdvancedFields: this.state.showAuthAdvancedFields,
          showPassword: this.state.showPassword,
          onShowPasswordToggle: this.handleShowPassword,
          onAuthTypeSelect: this.props.handleAuthTypeSelect,
          onVariablesLearnMore: this.handleVariablesLearnMore,
          onDismissVariablesAlert: this.handleDismissVariablesAlert,
          onToggleAdvancedFields: this.toggleAdvancedFields,
          onAuthorizationLearnMore: this.handleAuthorizationLearnMore,
          onFieldChange: this.props.handleFieldChange,
          onUseToken: this.props.onUseToken,
          layout: this.props.layout,
          handleAuthAnalytics: this.props.handleAuthAnalytics })));



  }};

/***/ }),

/***/ 3952:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
let GetUniqueIdHelper = class GetUniqueIdHelper {
  constructor() {
  }

  /**
    @private
    @method generateUniqueId
    @usage
    Used to generate a unique identifier
    @return
    String will be a unique identifier prefixed with 'body-type-'
    **/

  generateUniqueId() {
    let uniqueId = Math.random().toString(36).substring(7);
    return `body-type-${uniqueId}`;
  }};



/* harmony default export */ __webpack_exports__["a"] = (new GetUniqueIdHelper());

/***/ }),

/***/ 3953:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
const IMPORT_FILE = 'File',
IMPORT_FOLDER = 'Folder',
IMPORT_TEXT = 'Text',
IMPORT_URL = 'Url';
/* harmony export (immutable) */ __webpack_exports__["a"] = IMPORT_FILE;

/* harmony export (immutable) */ __webpack_exports__["b"] = IMPORT_FOLDER;

/* harmony export (immutable) */ __webpack_exports__["c"] = IMPORT_TEXT;

/* harmony export (immutable) */ __webpack_exports__["d"] = IMPORT_URL;


/***/ }),

/***/ 3954:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__stores_get_store__ = __webpack_require__(5);


let MergeDispatchedRequestService = {
  /**
                                       * Merges the system headers, queryparams and body params and returns
                                       *
                                       * @param  {Object} request
                                       * @param  {Object} editorModel RequestEditorModel
                                       *
                                       * @return {Object} { headerData, queryParams, data}
                                       */
  _mergeSystemProperties(request, editorModel) {
    let headerData = _.concat(request.headerData || [], editorModel.getAdditionalData('systemHeaders')) || [],
    queryParams = _.concat(request.queryParams || [], editorModel.getAdditionalData('systemQueryParams')) || [],
    data = request.dataMode === 'urlencoded' || request.dataMode === 'params' ?
    _.concat(request.data || [], editorModel.getAdditionalData('systemBodyParams')[request.dataMode] || []) :
    request.data || [];

    return { headerData, queryParams, data };
  },

  /**
      * Used to add system headers and system query params
      *
      * @param  {Object} request
      * @returns {Promise<Object>}
      */
  mergeDispatchedRequest(editorId, request) {
    if (!editorId) {
      return Promise.reject(new Error('PrepareRequestService~addRestrictedParams: editorId is a mandatory parameter'));
    }

    let editor = Object(__WEBPACK_IMPORTED_MODULE_0__stores_get_store__["getStore"])('EditorStore').find(editorId),
    editorModel = editor && editor.model;

    if (!editorModel) {
      return Promise.reject(new Error('PrepareRequestService~addRestrictedParams: Could not find editor model'));
    }

    let { headerData, queryParams, data } = this._mergeSystemProperties(request, editorModel);

    return _.assign({}, request, { headerData, queryParams, data });
  } };


/* harmony default export */ __webpack_exports__["a"] = (MergeDispatchedRequestService);
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4011:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CookiesManagementCookiesList; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__CookiesManagementCookiesListItem__ = __webpack_require__(4919);


let

CookiesManagementCookiesList = class CookiesManagementCookiesList extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  render() {
    let cookies = this.props.cookies;

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'cookies-management-cookies-list-wrapper' },

        !_.isEmpty(cookies) && cookies.map((cookie, index) => {
          return __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__CookiesManagementCookiesListItem__["a" /* default */], {
            key: index,
            cookie: cookie,
            onSelect: this.props.onSelect,
            onDelete: this.props.onDelete,
            selectedCookie: this.props.selectedCookie });

        }),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
            type: 'primary',
            size: 'small',
            className: 'cookies-management-cookies__actions--add',
            onClick: this.props.onAdd }, '+ Add Cookie')));





  }};


CookiesManagementCookiesList.defaultProps = { selectedDomainCookiesList: [] };
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4012:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
const SYNC_CONFLICT_HEADER_MODEL = 'model',
SYNC_CONFLICT_HEADER_ID = 'id',
SYNC_CONFLICT_HEADER_NAME = 'nameOrId',
SYNC_CONFLICT_HEADER_KEY = 'key',
SYNC_CONFLICT_HEADER_SERVER_VALUE = 'serverValue',
SYNC_CONFLICT_HEADER_LOCAL_VALUE = 'localValue',
SYNC_CONFLICT_HEADER_IS_LOCAL_SELECTED = 'isLocalSelected',
SYNC_CONFLICT_HEADER_IS_SERVER_SELECTED = 'isServerSelected';
/* harmony export (immutable) */ __webpack_exports__["d"] = SYNC_CONFLICT_HEADER_MODEL;

/* harmony export (immutable) */ __webpack_exports__["a"] = SYNC_CONFLICT_HEADER_ID;

/* harmony export (immutable) */ __webpack_exports__["e"] = SYNC_CONFLICT_HEADER_NAME;

/* harmony export (immutable) */ __webpack_exports__["b"] = SYNC_CONFLICT_HEADER_KEY;

/* harmony export (immutable) */ __webpack_exports__["f"] = SYNC_CONFLICT_HEADER_SERVER_VALUE;

/* harmony export (immutable) */ __webpack_exports__["c"] = SYNC_CONFLICT_HEADER_LOCAL_VALUE;

/* unused harmony export SYNC_CONFLICT_HEADER_IS_LOCAL_SELECTED */

/* unused harmony export SYNC_CONFLICT_HEADER_IS_SERVER_SELECTED */


/***/ }),

/***/ 4013:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_prop_types__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_prop_types___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_prop_types__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_classnames__);




const Tag = props => {
  const { type, tagName, className } = props,
  classes = __WEBPACK_IMPORTED_MODULE_2_classnames___default()(
  'tag',
  `tag-${type}`,
  className);


  return (
    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: classes, title: tagName },
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, tagName)));


};

Tag.propTypes = {
  type: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.oneOf(['info', 'success', 'warn', 'error']),
  tagName: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.string };


Tag.defaultProps = {
  type: 'info',
  className: '' };


/* harmony default export */ __webpack_exports__["a"] = (Tag);

/***/ }),

/***/ 4014:
/***/ (function(module, exports, __webpack_require__) {

var toFinite = __webpack_require__(4973);

/**
 * Converts `value` to an integer.
 *
 * **Note:** This method is loosely based on
 * [`ToInteger`](http://www.ecma-international.org/ecma-262/7.0/#sec-tointeger).
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to convert.
 * @returns {number} Returns the converted integer.
 * @example
 *
 * _.toInteger(3.2);
 * // => 3
 *
 * _.toInteger(Number.MIN_VALUE);
 * // => 0
 *
 * _.toInteger(Infinity);
 * // => 1.7976931348623157e+308
 *
 * _.toInteger('3.2');
 * // => 3
 */
function toInteger(value) {
  var result = toFinite(value),
      remainder = result % 1;

  return result === result ? (remainder ? result - remainder : result) : 0;
}

module.exports = toInteger;


/***/ }),

/***/ 4015:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
 * Copyright (c) 2014-present, Facebook, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 * 
 * @providesModule EmitterSubscription
 * @typechecks
 */



function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var EventSubscription = __webpack_require__(4978);

/**
 * EmitterSubscription represents a subscription with listener and context data.
 */

var EmitterSubscription = (function (_EventSubscription) {
  _inherits(EmitterSubscription, _EventSubscription);

  /**
   * @param {EventSubscriptionVendor} subscriber - The subscriber that controls
   *   this subscription
   * @param {function} listener - Function to invoke when the specified event is
   *   emitted
   * @param {*} context - Optional context object to use when invoking the
   *   listener
   */

  function EmitterSubscription(subscriber, listener, context) {
    _classCallCheck(this, EmitterSubscription);

    _EventSubscription.call(this, subscriber);
    this.listener = listener;
    this.context = context;
  }

  return EmitterSubscription;
})(EventSubscription);

module.exports = EmitterSubscription;

/***/ }),

/***/ 4016:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _platform = __webpack_require__(4982);

var _platform2 = _interopRequireDefault(_platform);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getPlatformName = function getPlatformName() {
  var os = _platform2.default.os.family || '';
  os = os.toLowerCase().replace(/ /g, '');
  if (/\bwin/.test(os)) {
    os = 'windows';
  } else if (/darwin|osx/.test(os)) {
    os = 'osx';
  } else if (/linux|freebsd|sunos|ubuntu|debian|fedora|redhat|suse/.test(os)) {
    os = 'linux';
  } else {
    os = 'other';
  }
  return os;
};

var getCharacter = function getCharacter(event) {
  if (event.which == null) {
    // NOTE: IE
    return String.fromCharCode(event.keyCode);
  } else if (event.which !== 0 && event.charCode !== 0) {
    // NOTE: the rest
    return String.fromCharCode(event.which);
  }
  return null;
};

exports.default = { getPlatformName: getPlatformName, getCharacter: getCharacter };
module.exports = exports['default'];

/***/ }),

/***/ 4017:
/***/ (function(module, exports) {

module.exports = on
module.exports.on = on
module.exports.off = off

function on (element, event, callback, capture) {
  !element.addEventListener && (event = 'on' + event)
  ;(element.addEventListener || element.attachEvent).call(element, event, callback, capture)
  return callback
}

function off (element, event, callback, capture) {
  !element.removeEventListener && (event = 'on' + event)
  ;(element.removeEventListener || element.detachEvent).call(element, event, callback, capture)
  return callback
}


/***/ }),

/***/ 4018:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-env node, browser */


/**
 * takes the event and returns the key character
 *
 * @param {Event} e
 * @return {string}
 */
module.exports = function (e) {
  var SPECIAL_KEYS_MAP,
    SPECIAL_CHARACTERS_MAP
  SPECIAL_KEYS_MAP = __webpack_require__(4019)
  SPECIAL_CHARACTERS_MAP = __webpack_require__(4996)

  // for keypress events we should return the character as is
  if (e.type === 'keypress') {
    var character = String.fromCharCode(e.which)

    // if the shift key is not pressed then it is safe to assume
    // that we want the character to be lowercase.  this means if
    // you accidentally have caps lock on then your key bindings
    // will continue to work
    //
    // the only side effect that might not be desired is if you
    // bind something like 'A' cause you want to trigger an
    // event when capital A is pressed caps lock will no longer
    // trigger the event.  shift+a will though.
    if (!e.shiftKey) {
      character = character.toLowerCase()
    }

    return character
  }

  // for non keypress events the special maps are needed
  if (SPECIAL_KEYS_MAP[e.which] !== undefined) {
    return SPECIAL_KEYS_MAP[e.which]
  }

  if (SPECIAL_CHARACTERS_MAP[e.which] !== undefined) {
    return SPECIAL_CHARACTERS_MAP[e.which]
  }

  // if it is not in the special map

  // with keydown and keyup events the character seems to always
  // come in as an uppercase character whether you are pressing shift
  // or not.  we should make sure it is always lowercase for comparisons
  return String.fromCharCode(e.which).toLowerCase()
}


/***/ }),

/***/ 4019:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-env node, browser */

/**
 * mapping of special keycodes to their corresponding keys
 *
 * everything in this dictionary cannot use keypress events
 * so it has to be here to map to the correct keycodes for
 * keyup/keydown events
 *
 * @type {Object}
 */
module.exports = {
  8: 'backspace',
  9: 'tab',
  13: 'enter',
  16: 'shift',
  17: 'ctrl',
  18: 'alt',
  20: 'capslock',
  27: 'esc',
  32: 'space',
  33: 'pageup',
  34: 'pagedown',
  35: 'end',
  36: 'home',
  37: 'left',
  38: 'up',
  39: 'right',
  40: 'down',
  45: 'ins',
  46: 'del',
  91: 'meta',
  93: 'meta',
  173: 'minus',
  187: 'plus',
  189: 'minus',
  224: 'meta'
}

/**
 * loop through the f keys, f1 to f19 and add them to the map
 * programatically
 */
for (var i = 1; i < 20; ++i) {
  module.exports[111 + i] = 'f' + i
}

/**
 * loop through to map numbers on the numeric keypad
 */
for (i = 0; i <= 9; ++i) {
  module.exports[i + 96] = i
}


/***/ }),

/***/ 4020:
/***/ (function(module, exports, __webpack_require__) {

var assignValue = __webpack_require__(977),
    copyObject = __webpack_require__(538),
    createAssigner = __webpack_require__(5021),
    isArrayLike = __webpack_require__(67),
    isPrototype = __webpack_require__(221),
    keys = __webpack_require__(135);

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Assigns own enumerable string keyed properties of source objects to the
 * destination object. Source objects are applied from left to right.
 * Subsequent sources overwrite property assignments of previous sources.
 *
 * **Note:** This method mutates `object` and is loosely based on
 * [`Object.assign`](https://mdn.io/Object/assign).
 *
 * @static
 * @memberOf _
 * @since 0.10.0
 * @category Object
 * @param {Object} object The destination object.
 * @param {...Object} [sources] The source objects.
 * @returns {Object} Returns `object`.
 * @see _.assignIn
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 * }
 *
 * function Bar() {
 *   this.c = 3;
 * }
 *
 * Foo.prototype.b = 2;
 * Bar.prototype.d = 4;
 *
 * _.assign({ 'a': 0 }, new Foo, new Bar);
 * // => { 'a': 1, 'c': 3 }
 */
var assign = createAssigner(function(object, source) {
  if (isPrototype(source) || isArrayLike(source)) {
    copyObject(source, keys(source), object);
    return;
  }
  for (var key in source) {
    if (hasOwnProperty.call(source, key)) {
      assignValue(object, key, source[key]);
    }
  }
});

module.exports = assign;


/***/ }),

/***/ 4021:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = __webpack_require__(1);

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TypeSelector = function (_Component) {
  _inherits(TypeSelector, _Component);

  function TypeSelector() {
    _classCallCheck(this, TypeSelector);

    return _possibleConstructorReturn(this, (TypeSelector.__proto__ || Object.getPrototypeOf(TypeSelector)).apply(this, arguments));
  }

  _createClass(TypeSelector, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'select',
        {
          tabIndex: -1,
          value: this.props.value,
          onChange: this.props.onChange
        },
        _react2.default.createElement(
          'option',
          { value: 'string' },
          'str'
        ),
        _react2.default.createElement(
          'option',
          { value: 'number' },
          'num'
        ),
        _react2.default.createElement(
          'option',
          { value: 'boolean' },
          'bool'
        ),
        _react2.default.createElement(
          'option',
          { value: 'array' },
          'arr'
        ),
        _react2.default.createElement(
          'option',
          { value: 'object' },
          'obj'
        )
      );
    }
  }]);

  return TypeSelector;
}(_react.Component);

exports.default = TypeSelector;

/***/ }),

/***/ 4022:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _utils = __webpack_require__(3537);

var _utils2 = _interopRequireDefault(_utils);

var _forEach = __webpack_require__(1520);

var _forEach2 = _interopRequireDefault(_forEach);

var _get = __webpack_require__(1497);

var _get2 = _interopRequireDefault(_get);

var _immutable = __webpack_require__(32);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getColumns = function getColumns(config) {
  var columns = {};

  (0, _forEach2.default)(config.columns, function (column) {
    switch (column.type) {
      case 'string':
        columns['' + column.name] = {
          type: 'string',
          meta: { value: (0, _get2.default)(column, 'default', '') }
        };
        break;
      case 'number':
        columns['' + column.name] = {
          type: 'number',
          meta: { value: (0, _get2.default)(column, 'default', 0) }
        };
        break;
      case 'boolean':
        columns['' + column.name] = {
          type: 'boolean',
          meta: { value: (0, _get2.default)(column, 'default', true) }
        };
        break;
      case 'array':
        columns['' + column.name] = {
          type: 'array',
          meta: { key: (0, _get2.default)(column, 'default', ''), type: 'string' }
        };
        break;
      case 'object':
        columns['' + column.name] = {
          type: 'object',
          meta: { key: (0, _get2.default)(column, 'default.key', ''), value: (0, _get2.default)(column, 'default.value', ''), type: 'string' }
        };
        break;
      default:
    }
  });

  return columns;
};

var CreateReducer = function CreateReducer(state, _ref, payload, config) {
  var node = _ref.node,
      column = _ref.column;

  if (typeof node === 'undefined' || node === null) {
    // This means a new node is supposed to be created at the root level
    // Generate the new node
    var _newNodeId = _utils2.default.getId();
    var _newNode = {
      id: _newNodeId,
      depth: 0,
      columns: getColumns(config)

      // Add the new node to the state's map
    };state = state.setIn(['rows', '' + _newNodeId], (0, _immutable.fromJS)(_newNode));

    // Add the new node's ID to the state's order list, at the end
    var _order = state.getIn(['order']);
    _order = _order.concat(_newNodeId);
    state = state.setIn(['order'], _order);

    return state;
  }

  var parentNode = state.getIn(['rows', '' + node]);
  var newNodeId = _utils2.default.getId();

  // Generate the new node
  var newNode = {
    id: newNodeId,
    depth: parentNode.get('depth') + 1,
    parent: node,
    columns: getColumns(config)

    // Add the new node to the state's map
  };state = state.setIn(['rows', '' + newNodeId], (0, _immutable.fromJS)(newNode));

  // Add the new node's ID to the state's order list.
  // Find the parent's ID in the list and add this ID right after it (to indicate that this is a child)
  var order = state.getIn(['order']),
      parentPosition = order.indexOf(node);
  order = order.insert(parentPosition + 1, newNodeId);
  state = state.setIn(['order'], order);

  // Add this new node to the parent's allChildren list
  var parentAllChildren = state.getIn(['rows', '' + node, 'allChildren']);
  parentAllChildren = parentAllChildren.push(newNodeId);
  state = state.setIn(['rows', '' + node, 'allChildren'], parentAllChildren);

  // Add this new node to the parent's (direct) children list
  var parentChildren = state.getIn(['rows', '' + node, 'children']);
  parentChildren = parentChildren.push(newNodeId);
  state = state.setIn(['rows', '' + node, 'children'], parentChildren);

  // Add 1 to the parent's childrenCount
  var parentChildrenCount = state.getIn(['rows', '' + node, 'columns', '' + column, 'meta', 'childrenCount']);
  state = state.setIn(['rows', '' + node, 'columns', '' + column, 'meta', 'childrenCount'], parentChildrenCount + 1);

  return state;
};

exports.default = CreateReducer;

/***/ }),

/***/ 4023:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return RolesList; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__RolesListItem__ = __webpack_require__(5057);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__utils_util__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__modules_services_RolesService__ = __webpack_require__(3593);




let

RolesList = class RolesList extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.currentUser = Object(__WEBPACK_IMPORTED_MODULE_2__stores_get_store__["getStore"])('CurrentUserStore');
    this.getMemberDetails = this.getMemberDetails.bind(this);
  }

  /**
     * Fetches the name of the given member
     *
     * @param {Object} member
     * @param {String} member.id
     */
  getMemberDetails({ id, canRemove }) {
    return { id, name: __WEBPACK_IMPORTED_MODULE_3__utils_util__["a" /* default */].getUserNameForId(id, this.currentUser), canRemove };
  }

  getSelectedRole(memberId) {
    return _.get(this.props.selectedUserRoles, `${memberId}.name`);
  }

  getSelectedRoleName(selectedRole) {
    return _.get(this.props.rolesList, `${selectedRole}.displayName`, this.props.fallbackRole);
  }

  getWarningText(selectedRole) {
    let { teamRole = {}, superRoles = {} } = this.props,
    selectedTeamRole = teamRole.name;

    if (!selectedRole) {
      return 'This user doesn\'t have a role but might still get a role from the team or user group.';
    }

    if (!Object(__WEBPACK_IMPORTED_MODULE_4__modules_services_RolesService__["d" /* shouldOverrideRole */])(superRoles, selectedTeamRole, selectedRole)) {
      return '';
    }

    return `This user still has ${this.getSelectedRoleName(selectedTeamRole)}
    role because they are a part of the team`;
  }

  render() {
    let members = _.map(this.props.members, this.getMemberDetails);

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'permission-list-container' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'permission-list' },

          _.map(members, member => {
            let selectedRole = this.getSelectedRole(member.id);

            return (
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__RolesListItem__["a" /* default */], {
                hideRoles: this.props.hideRoles,
                warningText: this.getWarningText(selectedRole),
                canModifyMembers: this.props.canModifyMembers,
                canUpdateRoles: this.props.canUpdateRoles,
                selectedRole: this.getSelectedRoleName(selectedRole),
                key: member.id,
                rolesList: this.props.rolesList,
                member: member,
                onChange: this.props.onChange,
                onRemoveMember: this.props.onRemoveMember }));


          }))));




  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4024:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (immutable) */ __webpack_exports__["a"] = addMembersAsDiff;
/* harmony export (immutable) */ __webpack_exports__["c"] = removeMembersAsDiff;
/* harmony export (immutable) */ __webpack_exports__["b"] = calculateDiff;

/**
 * Adds workspace members as a diff with $add
 *
 * @param {*} workspace
 * @param {*} membersToAdd
 */
function addMembersAsDiff(workspace, membersToAdd) {
  let users = {
    $diff: true,
    $add: {} };


  users.$add = _.transform(membersToAdd, (acc, id) => {
    acc[id] = { id };
  }, {});

  if (!workspace.members) {
    workspace.members = { users };
  } else
  {
    _.merge(workspace.members, { users });
  }
}

/**
   *
   * Adds workspace members as a diff with $remove
   *
   * @param {*} workspace
   * @param {*} membersToRemove
   */
function removeMembersAsDiff(workspace, membersToRemove) {
  let users = {
    $diff: true,
    $remove: {} };


  users.$remove = _.transform(membersToRemove, (acc, id) => {
    acc[id] = { id };
  }, {});

  if (!workspace.members) {
    workspace.members = { users };
  } else
  {
    _.merge(workspace.members, { users });
  }
}

/**
   * Calculates $diff between the members that have been updated
   * @param {Object} oldMembers
   * @param {Object} updatedMembers
   */
function calculateDiff(oldMembers, updatedMembers) {
  let diff = false,
  users = {
    add: [],
    remove: [] };


  // Members that have been added
  _.forEach(updatedMembers, member => {
    if (!oldMembers[member.id]) {
      diff = true;
      users.add.push(member.id);
    }
    return;
  });

  // Members that have been removed
  _.forEach(oldMembers, member => {
    if (!updatedMembers[member.id]) {
      diff = true;
      users.remove.push(member.id);
    }
    return;
  });

  return { diff, users };
}
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4025:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return InviteUsersEmpty; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_XPaths_XPath__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__services_UIEventService__ = __webpack_require__(79);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__constants_UIEventConstants__ = __webpack_require__(217);





let
InviteUsersEmpty = class InviteUsersEmpty extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.handleInvite = this.handleInvite.bind(this);
  }

  handleInvite() {
    let options = {},
    currentUser = Object(__WEBPACK_IMPORTED_MODULE_2__stores_get_store__["getStore"])('CurrentUserStore');

    this.props.onInvite && this.props.onInvite();

    // Don't care if the user is a non-signedIn user
    if (!currentUser.isLoggedIn) {
      pm.mediator.trigger('openInviteSignoutModal');
      return;
    }

    options[this.props.modelType] = this.props.modelId;
    options.source = `share_${this.props.modelType}`;

    __WEBPACK_IMPORTED_MODULE_4__services_UIEventService__["a" /* default */].publish(__WEBPACK_IMPORTED_MODULE_5__constants_UIEventConstants__["d" /* OPEN_INVITE_MODAL */], options);
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_XPaths_XPath__["a" /* default */], { identifier: 'inviteUsersEmpty' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-to-workspace-empty--container' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-to-workspace-empty--title' }, 'Start collaborating!'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-to-workspace-empty--subtext' }, 'Share this ', this.props.modelType, ' with your colleagues and work together by inviting them to Postman!'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
              type: 'primary',
              onClick: this.handleInvite }, 'Invite'))));






  }};

/***/ }),

/***/ 4026:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CreateTeamEmpty; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__services_UIEventService__ = __webpack_require__(79);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__constants_UIEventConstants__ = __webpack_require__(217);






const typeTitle = {
  collection: 'collection',
  api: 'API' };let


CreateTeamEmpty = class CreateTeamEmpty extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.handleCreateFreeTeam = this.handleCreateFreeTeam.bind(this);
  }

  handleCreateFreeTeam() {
    let options = {},
    currentUser = Object(__WEBPACK_IMPORTED_MODULE_2__stores_get_store__["getStore"])('CurrentUserStore');

    this.props.onInvite && this.props.onInvite();

    // Don't care if the user is a non-signedIn user
    if (!currentUser.isLoggedIn) {
      pm.mediator.trigger('openInviteSignoutModal');
      return;
    }

    options[this.props.modelType] = this.props.modelId;
    options.source = `share_${this.props.modelType}`;

    __WEBPACK_IMPORTED_MODULE_3__services_UIEventService__["a" /* default */].publish(__WEBPACK_IMPORTED_MODULE_4__constants_UIEventConstants__["d" /* OPEN_INVITE_MODAL */], options);
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-team-empty' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-team-empty__title' }, 'To collaborate on this ',
          typeTitle[this.props.modelType], ', create a team and invite people to join'),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-team-empty__action' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
              type: 'primary',
              onClick: this.handleCreateFreeTeam }, 'Create a free team'))));






  }};

/***/ }),

/***/ 4027:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddToWorkspaceEmpty; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__constants_AppUrlConstants_js__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__external_navigation_ExternalNavigationService__ = __webpack_require__(59);



let
AddToWorkspaceEmpty = class AddToWorkspaceEmpty extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.handleWorkspaceCreate = this.handleWorkspaceCreate.bind(this);
  }

  handleWorkspaceCreate() {
    pm.mediator.trigger('openCreateNewWorkspaceModal');
    this.props.onCreateWorkspace && this.props.onCreateWorkspace();
  }


  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-to-workspace-empty--container' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-to-workspace-empty--title' }, 'You don\'t have any workspaces to share in'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-to-workspace-empty--subtext' }, 'Share your collections, environments, monitors, mock servers and integrations in contextual workspaces to organize your APIs.'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
            type: 'text',
            className: 'docs-link',
            onClick: () => {
              Object(__WEBPACK_IMPORTED_MODULE_3__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_2__constants_AppUrlConstants_js__["_21" /* WORKSPACE_DOCS */]);
            } }, 'Learn more about workspaces'),



        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
            type: 'primary',
            onClick: this.handleWorkspaceCreate }, 'Create a new workspace')));





  }};

/***/ }),

/***/ 4028:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return InviteLink; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__utils_ClipboardHelper__ = __webpack_require__(536);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_LoadingIndicator__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_Icons_MoreIcon__ = __webpack_require__(215);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__models_services_DashboardService__ = __webpack_require__(309);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__base_Dropdowns__ = __webpack_require__(31);










const PLACEHOLDER_INVITE_URL = 'https://app.getpostman.com/join-team?invite_code=1a2b3c4d5e';let

InviteLink = class InviteLink extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = { isLinkCopied: false };
    this.handleGetInviteLink = this.handleGetInviteLink.bind(this);
    this.handleCopyInviteLink = this.handleCopyInviteLink.bind(this);

    this.handleDropdownSelect = this.handleDropdownSelect.bind(this);
  }

  handleGetInviteLink() {
    this.props.onGetLink && this.props.onGetLink();
  }

  componentWillUnmount() {
    clearTimeout(this.timeout);
  }

  handleCopyInviteLink() {
    if (this.props.isLoading || !this.props.inviteLink) {
      return;
    }

    // Clearing timeout in case a previous
    // copy action had already taken place
    clearTimeout(this.timeout);

    this.setState({ isLinkCopied: true });

    __WEBPACK_IMPORTED_MODULE_4__utils_ClipboardHelper__["a" /* default */].copy(this.props.inviteLink);

    this.timeout = setTimeout(() => {
      this.setState({ isLinkCopied: false });
    }, 1500);
  }

  componentDidUpdate(prevProps) {
    prevProps.isLoading && this.props.isGenerated && this.selectText();
  }

  selectText() {
    this.refs.inviteLink && this.refs.inviteLink.selectAll();
  }

  renderSubtitle(canManageTeamInvites) {
    let unapprovedInviteText = 'They\'ll join your team once your admin approves.',
    subtitle = `Invite people to your ${this.props.entity} by sharing a link with them.
        ${!canManageTeamInvites ? unapprovedInviteText : ''}`;

    return subtitle;
  }

  handleDropdownSelect(type) {
    switch (type) {
      case 'manage-links':
        Object(__WEBPACK_IMPORTED_MODULE_7__models_services_DashboardService__["o" /* openManageInviteLinks */])();
        break;}

  }

  renderInviteLinkOptions(canManageTeamInvites) {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__base_Dropdowns__["a" /* Dropdown */], { onSelect: this.handleDropdownSelect },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__base_Dropdowns__["b" /* DropdownButton */], {
            dropdownStyle: 'nocaret',
            size: 'small' },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], null,
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Icons_MoreIcon__["a" /* default */], null))),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__base_Dropdowns__["c" /* DropdownMenu */], {
            fluid: true },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__base_Dropdowns__["d" /* MenuItem */], {
              disabled: !canManageTeamInvites,
              disabledText: 'Only admins can view and manage the invite links',
              key: 'manage-links',
              refKey: 'manage-links' },

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Manage invite links')))));




  }

  render() {
    const { inviteLink, isLoading } = this.props,
    isDisabled = !inviteLink || isLoading;

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'invite-user-team-link' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'invite-user-share-title' }, 'Or invite via link'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'invite-user-share-subtitle' }, this.renderSubtitle(this.props.canManageTeamInvites)),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'invite-user-actions' },

          this.props.isGenerated ?
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'invite-user-team-link-input-container' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Inputs__["b" /* Input */], {
              ref: 'inviteLink',
              readonly: true,
              type: 'text',
              onClick: this.handleCopyInviteLink,
              inputStyle: 'box',
              disabled: isDisabled,
              placeholder: PLACEHOLDER_INVITE_URL,
              value: inviteLink || '',
              className: __WEBPACK_IMPORTED_MODULE_1_classnames___default()(
              { 'is-copied': this.state.isLinkCopied },
              'invite-user-team-link-input') }),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
                type: 'secondary',
                size: 'small',
                onClick: this.handleCopyInviteLink },

              this.state.isLinkCopied ?
              'Copied' : 'Copy'),


            this.renderInviteLinkOptions(this.props.canManageTeamInvites)) :


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
              className: __WEBPACK_IMPORTED_MODULE_1_classnames___default()({ 'invite-user-team-link--loading': isLoading }),
              type: 'secondary',
              size: 'small',
              onClick: this.handleGetInviteLink },

            isLoading ? __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_LoadingIndicator__["a" /* default */], null) : 'Generate link')),



        this.props.renderAlert()));


  }};

/***/ }),

/***/ 4029:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return TeamDetailsUpdate; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_XPaths_XPath__ = __webpack_require__(24);


let

TeamDetailsUpdate = class TeamDetailsUpdate extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      teamName: '',
      teamUrl: '' };


    this.handleTeamNameChange = this.handleTeamNameChange.bind(this);
    this.handleTeamUrlChange = this.handleTeamUrlChange.bind(this);
  }

  handleTeamNameChange(teamName) {
    this.setState({ teamName });
    this.props.onChange && this.props.onChange({ teamName: teamName, teamUrl: this.state.teamUrl });
  }

  handleTeamUrlChange(teamUrl) {
    this.setState({ teamUrl });
    this.props.onChange && this.props.onChange({ teamName: this.state.teamName, teamUrl: teamUrl });
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_XPaths_XPath__["a" /* default */], { identifier: 'updateTeamDetails' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'setup-team-content' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'tab-share-content-meta-text' }, this.props.metaText),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'setup-team-container' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'left' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'input-container' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'input-label' }, 'Team name'),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_XPaths_XPath__["a" /* default */], { identifier: 'teamName' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Inputs__["b" /* Input */], {
                    placeholder: 'Enter name of your team',
                    inputStyle: 'box',
                    type: 'text',
                    className: 'setup-team-input',
                    onChange: this.handleTeamNameChange }))),



              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'input-container' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'input-label' }, 'Team URL'),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_XPaths_XPath__["a" /* default */], { identifier: 'teamURL' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'setup-team-input-container' },
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Inputs__["b" /* Input */], {
                      placeholder: 'Enter a url for your team',
                      inputStyle: 'box',
                      type: 'text',
                      className: 'setup-team-input',
                      onChange: this.handleTeamUrlChange }),

                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'setup-team-input-meta-container' },
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'setup-team-input-meta' }, '.postman.co')))))),





            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'right' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'setup-team-name-meta' }, 'Every team needs a name'),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'setup-team-url-meta' }, 'This will be your team\'s page on the web. Team URL should have 6 or more characters. Only letters, numbers and hyphens allowed. Must start with a letter.'))))));





  }};

/***/ }),

/***/ 4030:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_prop_types__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_prop_types___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_prop_types__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_react_transition_group_Transition__ = __webpack_require__(5090);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_react_transition_group_Transition___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_react_transition_group_Transition__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__utils__ = __webpack_require__(5094);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};function _objectWithoutProperties(obj, keys) {var target = {};for (var i in obj) {if (keys.indexOf(i) >= 0) continue;if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;target[i] = obj[i];}return target;}



let

CarouselItem = class CarouselItem extends __WEBPACK_IMPORTED_MODULE_0_react___default.a.Component {
  constructor(props) {
    super(props);

    this.state = {
      startAnimation: false };


    this.onEnter = this.onEnter.bind(this);
    this.onEntering = this.onEntering.bind(this);
    this.onExit = this.onExit.bind(this);
    this.onExiting = this.onExiting.bind(this);
    this.onExited = this.onExited.bind(this);
  }

  onEnter(node, isAppearing) {
    this.setState({ startAnimation: false });
    this.props.onEnter(node, isAppearing);
  }

  onEntering(node, isAppearing) {
    // getting this variable triggers a reflow
    const offsetHeight = node.offsetHeight;
    this.setState({ startAnimation: true });
    this.props.onEntering(node, isAppearing);
    return offsetHeight;
  }

  onExit(node) {
    this.setState({ startAnimation: false });
    this.props.onExit(node);
  }

  onExiting(node) {
    this.setState({ startAnimation: true });
    node.dispatchEvent(new CustomEvent('slide.bs.carousel'));
    this.props.onExiting(node);
  }

  onExited(node) {
    node.dispatchEvent(new CustomEvent('slid.bs.carousel'));
    this.props.onExited(node);
  }

  getItemClasses(status) {
    const { direction } = this.context,
    isActive = status === __WEBPACK_IMPORTED_MODULE_4__utils__["a" /* TransitionStatuses */].ENTERED || status === __WEBPACK_IMPORTED_MODULE_4__utils__["a" /* TransitionStatuses */].EXITING,
    directionClassName = (status === __WEBPACK_IMPORTED_MODULE_4__utils__["a" /* TransitionStatuses */].ENTERING || status === __WEBPACK_IMPORTED_MODULE_4__utils__["a" /* TransitionStatuses */].EXITING) &&
    this.state.startAnimation && (
    direction === 'right' ? 'carousel-item-left' : 'carousel-item-right'),
    orderClassName = status === __WEBPACK_IMPORTED_MODULE_4__utils__["a" /* TransitionStatuses */].ENTERING && (
    direction === 'right' ? 'carousel-item-next' : 'carousel-item-prev'),
    itemClasses = __WEBPACK_IMPORTED_MODULE_2_classnames___default()(
    this.props.className,
    'carousel-item',
    isActive && 'active',
    directionClassName,
    orderClassName);


    return itemClasses;
  }

  render() {
    const _props = this.props,{ in: isIn, children, slide, tag: Tag, className } = _props,transitionProps = _objectWithoutProperties(_props, ['in', 'children', 'slide', 'tag', 'className']);

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3_react_transition_group_Transition___default.a, _extends({},
        transitionProps, {
          enter: slide,
          exit: slide,
          'in': isIn,
          onEnter: this.onEnter,
          onEntering: this.onEntering,
          onExit: this.onExit,
          onExiting: this.onExiting,
          onExited: this.onExited }),


        status => {
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(Tag, { className: this.getItemClasses(status) },
              children));


        }));



  }};


CarouselItem.propTypes = _extends({},
__WEBPACK_IMPORTED_MODULE_3_react_transition_group_Transition___default.a.propTypes, {
  tag: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.oneOfType([__WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.func, __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.string]),
  in: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.bool,
  children: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.node,
  slide: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.bool,
  className: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.string });


CarouselItem.defaultProps = _extends({},
__WEBPACK_IMPORTED_MODULE_3_react_transition_group_Transition___default.a.defaultProps, {
  tag: 'div',
  timeout: __WEBPACK_IMPORTED_MODULE_4__utils__["b" /* TransitionTimeouts */].Carousel,
  slide: true });


CarouselItem.contextTypes = {
  direction: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.string };


/* harmony default export */ __webpack_exports__["a"] = (CarouselItem);

/***/ }),

/***/ 4031:
/***/ (function(module, exports, __webpack_require__) {

/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

if (false) {
  var ReactIs = require('react-is');

  // By explicitly using `prop-types` you are opting into new development behavior.
  // http://fb.me/prop-types-in-prod
  var throwOnDirectAccess = true;
  module.exports = require('./factoryWithTypeCheckers')(ReactIs.isElement, throwOnDirectAccess);
} else {
  // By explicitly using `prop-types` you are opting into new production behavior.
  // http://fb.me/prop-types-in-prod
  module.exports = __webpack_require__(5091)();
}


/***/ }),

/***/ 4032:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_prop_types__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_prop_types___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_prop_types__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__Icons_ForwardIcon__ = __webpack_require__(5095);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__Icons_BackIcon__ = __webpack_require__(5096);






const CarouselControl = props => {
  const { direction, onClickHandler, className } = props,
  anchorClasses = __WEBPACK_IMPORTED_MODULE_2_classnames___default()(
  className,
  `carousel-control-${direction}`),

  screenReaderClasses = __WEBPACK_IMPORTED_MODULE_2_classnames___default()(
  'sr-only'),

  getIcon = dir => {return dir === 'prev' ? __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__Icons_BackIcon__["a" /* default */], null) : __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__Icons_ForwardIcon__["a" /* default */], null);};

  return (
    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('a', {
        className: anchorClasses,
        role: 'button',
        tabIndex: '0',
        onClick: e => {
          e.preventDefault();
          onClickHandler();
        } },

      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: screenReaderClasses },
        getIcon(direction))));



};

CarouselControl.propTypes = {
  direction: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.oneOf(['prev', 'next']).isRequired,
  onClickHandler: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.func.isRequired,
  directionText: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.string,
  className: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.string };


/* harmony default export */ __webpack_exports__["a"] = (CarouselControl);

/***/ }),

/***/ 4033:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_prop_types__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_prop_types___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_prop_types__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_classnames__);




const CarouselIndicators = props => {
  const { items, activeIndex, onClickHandler, className } = props;

  const listClasses = __WEBPACK_IMPORTED_MODULE_2_classnames___default()(className, 'carousel-indicators');
  const indicators = items.map((item, idx) => {
    const indicatorClasses = __WEBPACK_IMPORTED_MODULE_2_classnames___default()(
    { active: activeIndex === idx });

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('li', {
        key: `${item.key || item.src}${item.caption}${item.altText}`,
        onClick: e => {
          e.preventDefault();
          onClickHandler(idx);
        },
        className: indicatorClasses }));

  });

  return (
    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('ol', { className: listClasses },
      indicators));


};

CarouselIndicators.propTypes = {
  items: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.array.isRequired,
  activeIndex: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.number.isRequired,
  onClickHandler: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.func.isRequired,
  className: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.string };


/* harmony default export */ __webpack_exports__["a"] = (CarouselIndicators);

/***/ }),

/***/ 4034:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return WorkspaceList; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__WorkspaceListItem__ = __webpack_require__(5105);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__utils_util__ = __webpack_require__(19);



let

WorkspaceList = class WorkspaceList extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  isAlreadySharedInWorkspace(workspaceId) {
    // Only when we're showing the list of already shared in
    // workspaces, we do not need to check for the workspace ID
    if (this.props.disableActions) {
      return true;
    }

    return _.some(this.props.alreadySharedIn, { id: workspaceId });
  }

  getWorkspaceMemberNames(workspace, isUnjoined) {
    const user = Object(__WEBPACK_IMPORTED_MODULE_2__stores_get_store__["getStore"])('CurrentUserStore'),
    members = _.get(workspace, 'members.users', []),
    getName = member => __WEBPACK_IMPORTED_MODULE_3__utils_util__["a" /* default */].getUserNameForId(member.id, user);

    let membersList = _.map(members, member => ({ name: getName(member), id: member.id }));

    // Incase it's a workspace belonging to the unjoined workspace list
    // then we can return the members list as it is.
    if (isUnjoined) {
      return membersList;
    }

    // Shift the current user to the first position in the array
    // when it's a joined workspace
    let userIndex = _.findIndex(membersList, { id: user.id });
    if (userIndex === -1) {
      return membersList;
    }

    [membersList[userIndex], membersList[0]] = [membersList[0], membersList[userIndex]];

    return membersList;
  }

  checkIfUnjoined(workspace = {}) {
    return this.props.disableActions ? false : !workspace.isJoined;
  }

  checkPermission(workspaceId) {
    if (this.props.fetchingPermissionsOnJoin === workspaceId) {
      return true;
    }

    return this.props.isFetchingPermissions || this.props.disableActions ?
    true :
    _.get(this.props, `permissions[${workspaceId}].allowed`);
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-list' },

        _.map(this.props.workspaces, workspace => {
          let isUnjoined = this.checkIfUnjoined(workspace);

          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__WorkspaceListItem__["a" /* default */], {
              canShare: this.checkPermission(workspace.id),
              isSelected: this.props.selectedWorkspace === workspace.id,
              isUnjoined: isUnjoined,
              disableActions: this.props.disableActions,
              key: workspace.id,
              workspace: workspace,
              members: this.getWorkspaceMemberNames(workspace, isUnjoined),
              onSelect: this.props.onSelect,
              onError: this.props.onError,
              onWorkspaceJoin: this.props.onWorkspaceJoin,
              isAlreadySharedIn: this.isAlreadySharedInWorkspace(workspace.id) }));


        })));



  }};


WorkspaceList.defaultProps = {
  onSelect: _.noop };
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4035:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Buttons__ = __webpack_require__(13);




const PermissionError = props => {
  return (
    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'permission-error' },
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: __WEBPACK_IMPORTED_MODULE_1_classnames___default()('permission-error--icon', props.thumbnail) }),

      props.title &&
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'permission-error--title' },
        props.title),


      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'permission-error--description' },
        props.error),


      !_.isEmpty(props.action) &&
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
          type: 'primary',
          className: 'permission-error--action',
          onClick: props.action.onClick },

        props.action.label)));




};

/* harmony default export */ __webpack_exports__["a"] = (PermissionError);

PermissionError.defaultProps = {
  action: {} };
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4036:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ManageRoles; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__share_WorkspaceList__ = __webpack_require__(4034);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__RolesList__ = __webpack_require__(4023);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Icons_TeamIcon__ = __webpack_require__(1491);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_LoadingIndicator__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_Dropdowns__ = __webpack_require__(31);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__base_FuzzySearchInput__ = __webpack_require__(1500);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__base_TeamLogo__ = __webpack_require__(5109);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10_mobx_react__ = __webpack_require__(11);
var _class;









let


ManageRoles = Object(__WEBPACK_IMPORTED_MODULE_10_mobx_react__["a" /* observer */])(_class = class ManageRoles extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      searchQuery: '',
      searchResults: [] };


    this.handleFuzzySearch = this.handleFuzzySearch.bind(this);
    this.handleMemberSelect = this.handleMemberSelect.bind(this);
  }

  handleFuzzySearch(searchQuery, searchResults) {
    this.setState({ searchQuery, searchResults });
  }

  handleMemberSelect(memberId) {
    this.setState({ searchQuery: '', searchResults: [] });
    this.props.onAddMember(memberId);
  }

  getSelectedRole(memberId) {
    let selectedRoleName = _.get(this.props.selectedUserRoles, `${memberId}.name`);

    if (!selectedRoleName) {
      return '';
    }

    return _.get(this.props.rolesList, `${selectedRoleName}.displayName`);
  }

  getSelectedTeamRole() {
    let selectedRole = _.get(this.props, 'teamRole.name', ''),
    roleDisplayName = _.get(this.props.rolesList, `${selectedRole}.displayName`, '');

    return {
      name: selectedRole,
      displayName: roleDisplayName };

  }

  renderRolesDropdown(onClickHandler, buttonChildren, dropdownButtonProps = {}) {
    let type = dropdownButtonProps.type || 'secondary',
    dropdownStyle = dropdownButtonProps.dropdownStyle;

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Dropdowns__["a" /* Dropdown */], { onSelect: onClickHandler },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Dropdowns__["b" /* DropdownButton */], {
            size: 'small',
            type: type,
            dropdownStyle: dropdownStyle },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_Buttons__["a" /* Button */], { type: type },
            buttonChildren)),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Dropdowns__["c" /* DropdownMenu */], { fluid: true },

          _.map(this.props.rolesList, role => {
            return (
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Dropdowns__["d" /* MenuItem */], { key: role.name, refKey: role.name },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, role.displayName)));


          }))));




  }

  getTeamRole() {
    let { name, displayName } = this.getSelectedTeamRole();

    if (!name) {
      return false;
    }

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'modify-permissions--main' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_9__base_TeamLogo__["a" /* default */], {
          className: 'modify-permissions--main-image',
          imageUrl: _.get(Object(__WEBPACK_IMPORTED_MODULE_2__stores_get_store__["getStore"])('CurrentUserStore'), 'team.logo_url') }),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'modify-permissions--main-title' }, 'Everyone in Team'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'modify-permissions--main-roles' },

          this.renderRolesDropdown(
          this.props.onTeamRoleChange,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'modify-permissions--main-roles--name' }, displayName)))));





  }

  getBulkEditRow() {
    if (!this.props.bulkEditOpts) {
      return false;
    }

    let {
      bulkEditTitle,
      onBulkEdit,
      bulkEditRole } =
    this.props.bulkEditOpts;

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'modify-permissions--main is-bulk' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'modify-permissions--main-title' }, bulkEditTitle),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'modify-permissions--main-roles' },
          this.renderRolesDropdown(onBulkEdit, bulkEditRole))));



  }

  render() {
    if (this.props.isFetchingRoles) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'modify-permissions is-loading' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_LoadingIndicator__["a" /* default */], null)));


    }

    let {
      name: teamRole,
      displayName: teamRoleDisplayName } =
    this.getSelectedTeamRole(),
    permissionErrorMessage = _.get(this.props, 'permissionError.message');

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'modify-permissions' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'modify-permissions--editor' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'modify-permissions--editor--title' }, 'Manage roles'),



          !this.props.isOffline &&
          !permissionErrorMessage &&
          this.props.canModifyMembers &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'modify-permissions--search' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__base_FuzzySearchInput__["a" /* default */], {
              ref: 'fuzzySearch',
              searchQuery: this.state.searchQuery,
              placeholder: 'Add another user',
              onChange: this.handleFuzzySearch,
              items: this.props.allTeamMembers,
              searchFields: ['name', 'email'] }),


            this.state.searchQuery && !_.isEmpty(this.state.searchResults) &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Dropdowns__["c" /* DropdownMenu */], {
                fluid: true,
                targetRef: this.refs.fuzzySearch,
                onSelect: this.handleMemberSelect },


              _.map(this.state.searchResults, member => {
                return (
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Dropdowns__["d" /* MenuItem */], { key: member.id, refKey: member.id },
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, member.name)));


              }))),






          permissionErrorMessage &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, permissionErrorMessage),


          !permissionErrorMessage &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'modify-permissions--roles-container' },

            this.props.canModifyMembers ?
            this.getTeamRole() :
            this.getBulkEditRow(),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__RolesList__["a" /* default */], {
              canModifyMembers: this.props.canModifyMembers,
              selectedUserRoles: this.props.selectedUserRoles,
              rolesList: this.props.rolesList,
              teamRole: this.props.teamRole,
              superRoles: this.props.superRoles,
              members: this.props.members,
              onChange: this.props.onChange,
              onRemoveMember: this.props.onRemoveMember }),


            !this.props.canModifyMembers && teamRole &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'modify-permissions--workspaces__team-access' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Icons_TeamIcon__["a" /* default */], { size: 'xs' }),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'modify-permissions--workspaces__team-access-text' }, 'Everyone on your team has ',
                teamRoleDisplayName, ' role on this collection',

                this.renderRolesDropdown(
                this.props.onTeamRoleChange,
                'Change',
                { type: 'text', dropdownStyle: 'nocaret' }))))),








        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'modify-permissions--separator' }),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'modify-permissions--workspaces' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'modify-permissions--workspaces__shared-in' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'modify-permissions--workspaces__shared-in--title' }, 'Currently shared in'),

            this.props.isFetchingWorkspaces ?
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'modify-permissions--workspaces__shared-in__is-loading' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_LoadingIndicator__["a" /* default */], null)) :

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__share_WorkspaceList__["a" /* default */], {
              disableActions: true,
              workspaces: this.props.alreadySharedIn })))));






  }}) || _class;


ManageRoles.defaultProps = {
  onAddMember: () => {} };
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4037:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__export_index__ = __webpack_require__(3841);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__services_APIService__ = __webpack_require__(174);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__controllers_UserController__ = __webpack_require__(39);




const COLLECTION = 'collection',
TAB = '\t';

let CollectionRemoteLinkService = {

  /**
                                     * Uploads / updates a collection to God Server and saves the link in memory, IndexedDB and Sync
                                     *
                                     * @param {UUID} id - ID of the collection that needs to be uploaded
                                     * @return {Promise}
                                     */
  uploadCollectionForLink(id) {
    let serializedCollection;

    return Promise.resolve()

    //  Get the exported collection in JSON format
    .then(() => {
      return __WEBPACK_IMPORTED_MODULE_0__export_index__["a" /* default */].exportSingle(COLLECTION, { id });
    })

    // cache the serialized collection
    .then(data => {
      if (!data || !_.isObject(data.json)) {
        console.warn('UploadCollectionForLink: empty data returned', data);
        throw new Error('UploadCollectionForLink: empty data returned');
      }

      serializedCollection = JSON.stringify(data.json, null, TAB);
    })

    // Get the user
    .then(() => {
      return __WEBPACK_IMPORTED_MODULE_2__controllers_UserController__["a" /* default */].get();
    })

    // Upload the serialized collection to get the link
    .then(user => {
      return new Promise((resolve, reject) => {
        Object(__WEBPACK_IMPORTED_MODULE_1__services_APIService__["q" /* UploadCollection */])(user, serializedCollection, false, (err, data) => {
          if (err) {
            return reject(new Error('Error in uploading collection', err));
          }
          return resolve(data);
        });
      });
    });
  },

  /**
        * Deletes a collection's link from God Server and from memory, IndexedDB and Sync
        *
        * @param {UUID} id           - ID of the collection whose link has to be deleted
        * @return {Promise}
        */
  deleteCollectionLink: function (id) {
    return new Promise((resolve, reject) => {
      __WEBPACK_IMPORTED_MODULE_2__controllers_UserController__["a" /* default */].
      get().
      then(user => {
        Object(__WEBPACK_IMPORTED_MODULE_1__services_APIService__["b" /* DeleteCollectionLink */])({ user, id }, (err, data) => {
          if (err) {
            return reject(new Error('Error in deleting collection link', err));
          }
          return resolve(data);
        });
      }).
      catch(e => {
        return reject(new Error('Error in fetching user data', e));
      });
    });
  } };


/* harmony default export */ __webpack_exports__["a"] = (CollectionRemoteLinkService);
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4038:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
const ERROR_FETCHING_VERSIONS = 'Error occurred while fetching versions',
MOCK_CREATION_FAILED = 'Unable to create mock',
MOCK_EDIT_FAILED = 'Unable to edit mock',
MOCK_CREATION_TRY_AGAIN = 'Something went wrong while creating this mock. You can try again later.',
INTERNET_ERROR = 'Please check your internet connection and try again.';
/* harmony export (immutable) */ __webpack_exports__["a"] = ERROR_FETCHING_VERSIONS;

/* harmony export (immutable) */ __webpack_exports__["c"] = MOCK_CREATION_FAILED;

/* harmony export (immutable) */ __webpack_exports__["e"] = MOCK_EDIT_FAILED;

/* harmony export (immutable) */ __webpack_exports__["d"] = MOCK_CREATION_TRY_AGAIN;

/* harmony export (immutable) */ __webpack_exports__["b"] = INTERNET_ERROR;


/***/ }),

/***/ 4698:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return RequesterModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__collections_AddRequestToCollectionContainer__ = __webpack_require__(4699);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__collections_AddMultipleRequestsToCollectionContainer__ = __webpack_require__(4701);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__collections_AddCollectionModalContainer__ = __webpack_require__(4703);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__collections_EditCollectionModalContainer__ = __webpack_require__(4704);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__collections_ForkCollectionModalContainer__ = __webpack_require__(4705);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__collections_DeleteCollectionModalContainer__ = __webpack_require__(4707);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__collections_ExportCollectionModalContainer__ = __webpack_require__(4708);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__collections_folder_AddFolderModalContainer__ = __webpack_require__(4710);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__collections_folder_EditFolderModalContainer__ = __webpack_require__(4711);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__collections_DeleteFolderModalContainer__ = __webpack_require__(4712);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__collections_EditRequestModalContainer__ = __webpack_require__(4713);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__collections_DeleteRequestModalContainer__ = __webpack_require__(4715);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__request_DeleteRequestMethodModalContainer__ = __webpack_require__(4716);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__import_ImportCollectionConflictModalContainer__ = __webpack_require__(4717);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__environments_ManageEnvironmentModalContainer__ = __webpack_require__(4719);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__headers_ManageHeaderPresetModalContainer__ = __webpack_require__(4733);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__headers_DeleteHeaderPresetContainer__ = __webpack_require__(4744);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__user_UserSignOutModalContainer__ = __webpack_require__(4745);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__external_navigation_OpenExternalLinkModalContainer__ = __webpack_require__(4747);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_20__user_UserInvalidSessionModalContainer__ = __webpack_require__(4749);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_21__settings_SettingsModalContainer__ = __webpack_require__(4751);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_22__import_ImportModalContainer__ = __webpack_require__(4784);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_23__request_RequestSnippetGeneratorModalContainer__ = __webpack_require__(4797);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_24__cookies_CookiesManagementModalContainer__ = __webpack_require__(4913);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_25__proxy_ProxySettingsModalContainer__ = __webpack_require__(4925);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_26__sync_SyncConflictModalContainer__ = __webpack_require__(4926);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_27__sync_SyncIssueModalContainer__ = __webpack_require__(4930);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_28__tabs_RequesterTabCloseUnsavedModalContainer__ = __webpack_require__(4932);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_29__update_UpdateModalContainer__ = __webpack_require__(4934);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_30__update_ReleaseNotesModalContainer__ = __webpack_require__(4941);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_31__components_base_diff_DiffModalView__ = __webpack_require__(4943);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_32__components_collections_browser_monitors_DeleteMonitorConfirmation__ = __webpack_require__(4944);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_33__components_collections_browser_mocks_DeleteMockConfirmation__ = __webpack_require__(4945);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_34__js_components_editor_response_ExampleDeleteConfirmation__ = __webpack_require__(4946);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_35__components_tabs_ForceCloseAllTabsConfirmation__ = __webpack_require__(4947);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_36__components_history_DeleteHistoryConfirmation__ = __webpack_require__(4948);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_37__components_collections_PublishDocsSignedoutModal__ = __webpack_require__(4949);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_38__containers_library_LibraryShareCollectionModalContainer__ = __webpack_require__(4951);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_39__containers_user_SwitchAccountConfirmationModal__ = __webpack_require__(4955);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_40__containers_user_AddAccountConfirmationModal__ = __webpack_require__(4956);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_41__containers_auth_OAuth2ManageTokensModalContainer__ = __webpack_require__(4957);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_42__containers_new_button_CreateNewXModalContainer__ = __webpack_require__(4960);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_43__containers_new_button_CreateNewMonitorModalContainer__ = __webpack_require__(4969);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_44__containers_new_button_CreateNewMockModalContainer__ = __webpack_require__(5041);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_45__containers_new_button_CreateNewDocumentationModalContainer__ = __webpack_require__(5043);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_46__containers_new_button_CustomizeTemplateModalContainer__ = __webpack_require__(5045);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_47__containers_new_button_ActivityFeedModalContainer__ = __webpack_require__(5048);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_48__containers_workspaces_WorkspaceJoinModalContainer__ = __webpack_require__(5051);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_49__containers_workspaces_WorkspaceJoinedModalContainer__ = __webpack_require__(5053);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_50__containers_workspaces_MissingCurrentWorkspaceModalContainer__ = __webpack_require__(1612);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_51__containers_workspaces_CreateNewWorkspaceModalContainer__ = __webpack_require__(5055);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_52__containers_workspaces_EditWorkspaceModalContainer__ = __webpack_require__(5062);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_53__containers_workspaces_AddToWorkspaceModalContainer__ = __webpack_require__(5064);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_54__collections_RemoveCollectionFromWorkspaceModalContainer__ = __webpack_require__(5066);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_55__containers_workspaces_WorkspaceDetailsModalContainer__ = __webpack_require__(5067);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_56__containers_workspaces_BulkAddToWorkspaceModalContainer__ = __webpack_require__(5071);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_57__containers_environments_DeleteEnvironmentContainer__ = __webpack_require__(5073);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_58__containers_environments_RemoveEnvironmentFromWorkspaceModalContainer__ = __webpack_require__(5074);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_59__containers_workspaces_DeleteWorkspaceContainer__ = __webpack_require__(5075);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_60__containers_workspaces_LeaveWorkspaceContainer__ = __webpack_require__(5076);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_61__containers_workspaces_ShareWorkspaceModalContainer__ = __webpack_require__(5077);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_62__containers_startup_StartupModalHandler__ = __webpack_require__(5079);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_63__containers_invite_flows_InviteModalContainer__ = __webpack_require__(5080);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_64__containers_invite_flows_InvitationSentModalContainer__ = __webpack_require__(5081);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_65__containers_invite_flows_SignedOutInviteModalContainer__ = __webpack_require__(5083);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_66__containers_invite_flows_SetupTeamContainer__ = __webpack_require__(5085);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_67__empty_states_sign_in_ContextualSignInModalContainer__ = __webpack_require__(5086);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_68__empty_states_sign_in_SignInModalContainer__ = __webpack_require__(5099);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_69__messaging_InAppModalContainer__ = __webpack_require__(5101);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_70__share_ShareEntityModalContainer__ = __webpack_require__(5103);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_71__components_permissions_ManageRolesContainer__ = __webpack_require__(5117);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_72__containers_user_UserLoginMigrationModalContainer__ = __webpack_require__(5118);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_73__api_dev_components_api_version_SwitchDirtyVersionModal_SwitchDirtyVersionModalContainer__ = __webpack_require__(5119);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_74__mocks_containers_MockModalContainer__ = __webpack_require__(5121);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_75__api_dev_components_api_version_SwitchDeletedVersionModal_SwitchDeletedVersionModalContainer__ = __webpack_require__(5127);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_76__api_dev_components_api_version_SwitchConflictedVersionModal_SwitchConflictedVersionModalContainer__ = __webpack_require__(5129);















































































let

RequesterModalContainer = class RequesterModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  componentDidMount() {
    Object(__WEBPACK_IMPORTED_MODULE_62__containers_startup_StartupModalHandler__["a" /* default */])();
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__collections_AddRequestToCollectionContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__collections_AddMultipleRequestsToCollectionContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__collections_AddCollectionModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__collections_EditCollectionModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__collections_DeleteCollectionModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__collections_ForkCollectionModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__collections_ExportCollectionModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__collections_folder_AddFolderModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_9__collections_folder_EditFolderModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__collections_DeleteFolderModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_11__collections_EditRequestModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_12__collections_DeleteRequestModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_13__request_DeleteRequestMethodModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_15__environments_ManageEnvironmentModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_16__headers_ManageHeaderPresetModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_19__external_navigation_OpenExternalLinkModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_21__settings_SettingsModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_22__import_ImportModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_23__request_RequestSnippetGeneratorModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_24__cookies_CookiesManagementModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_26__sync_SyncConflictModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_27__sync_SyncIssueModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_28__tabs_RequesterTabCloseUnsavedModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_29__update_UpdateModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_14__import_ImportCollectionConflictModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_31__components_base_diff_DiffModalView__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_32__components_collections_browser_monitors_DeleteMonitorConfirmation__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_33__components_collections_browser_mocks_DeleteMockConfirmation__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_34__js_components_editor_response_ExampleDeleteConfirmation__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_35__components_tabs_ForceCloseAllTabsConfirmation__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_36__components_history_DeleteHistoryConfirmation__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_37__components_collections_PublishDocsSignedoutModal__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_30__update_ReleaseNotesModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_38__containers_library_LibraryShareCollectionModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_39__containers_user_SwitchAccountConfirmationModal__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_40__containers_user_AddAccountConfirmationModal__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_47__containers_new_button_ActivityFeedModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_41__containers_auth_OAuth2ManageTokensModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_42__containers_new_button_CreateNewXModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_43__containers_new_button_CreateNewMonitorModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_44__containers_new_button_CreateNewMockModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_45__containers_new_button_CreateNewDocumentationModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_46__containers_new_button_CustomizeTemplateModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_48__containers_workspaces_WorkspaceJoinModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_49__containers_workspaces_WorkspaceJoinedModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_51__containers_workspaces_CreateNewWorkspaceModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_52__containers_workspaces_EditWorkspaceModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_53__containers_workspaces_AddToWorkspaceModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_54__collections_RemoveCollectionFromWorkspaceModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_55__containers_workspaces_WorkspaceDetailsModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_56__containers_workspaces_BulkAddToWorkspaceModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_50__containers_workspaces_MissingCurrentWorkspaceModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_57__containers_environments_DeleteEnvironmentContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_58__containers_environments_RemoveEnvironmentFromWorkspaceModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_59__containers_workspaces_DeleteWorkspaceContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_60__containers_workspaces_LeaveWorkspaceContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_61__containers_workspaces_ShareWorkspaceModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_17__headers_DeleteHeaderPresetContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_63__containers_invite_flows_InviteModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_64__containers_invite_flows_InvitationSentModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_66__containers_invite_flows_SetupTeamContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_65__containers_invite_flows_SignedOutInviteModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_67__empty_states_sign_in_ContextualSignInModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_68__empty_states_sign_in_SignInModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_69__messaging_InAppModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_70__share_ShareEntityModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_71__components_permissions_ManageRolesContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_72__containers_user_UserLoginMigrationModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_73__api_dev_components_api_version_SwitchDirtyVersionModal_SwitchDirtyVersionModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_74__mocks_containers_MockModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_75__api_dev_components_api_version_SwitchDeletedVersionModal_SwitchDeletedVersionModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_76__api_dev_components_api_version_SwitchConflictedVersionModal_SwitchConflictedVersionModalContainer__["a" /* default */], null),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_20__user_UserInvalidSessionModalContainer__["a" /* default */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_18__user_UserSignOutModalContainer__["a" /* default */], null)));


  }};

/***/ }),

/***/ 4699:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddRequestToCollectionContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_collections_AddRequestToCollection__ = __webpack_require__(4700);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_model_event__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_uuid_v4__ = __webpack_require__(47);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_uuid_v4___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_uuid_v4__);







const ORIGIN_HISTORY_SINGLE = 'history_single',
ORIGIN_BUILDER = 'builder/request/save';

/**
                                          * returns the default request object
                                          */
function getDefaultRequestObject() {
  return {
    id: __WEBPACK_IMPORTED_MODULE_5_uuid_v4___default()(),
    headerData: [],
    url: '',
    name: '',
    collection: '',
    queryParams: [],
    events: [],
    pathVariableData: [],
    method: 'GET',
    data: null,
    dataMode: null,
    auth: null,
    description: '' };

}let
AddRequestToCollectionContainer = class AddRequestToCollectionContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this._request = null;

    this.state = {
      isOpen: false,
      requestName: '',
      requestDescription: '',
      selected: null,
      target: {},
      createdCollections: [],
      nameError: false,
      origin: null };


    this.openModal = this.openModal.bind(this);
    this.handleSelect = this.handleSelect.bind(this);
    this.handleRequestNameChange = this.handleRequestNameChange.bind(this);
    this.handleRequestDescriptionChange = this.handleRequestDescriptionChange.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleSubmit = this.handleSubmit.bind(this);
  }

  componentWillMount() {
    this.attachModelListeners();
  }

  componentWillUnmount() {
    this.detachModelListeners();
  }

  detachModelListeners() {
    pm.mediator.off('showAddToCollectionModal', this.openModal);
  }

  attachModelListeners() {
    pm.mediator.on('showAddToCollectionModal', this.openModal);
  }

  closeModal() {
    this.setState({ isOpen: false });
    this.clearModal();
  }

  clearModal() {
    this.setState({
      requestName: '',
      requestDescription: '',
      createdCollections: [],
      selected: null,
      nameError: false,
      origin: null });

    this._request = null;
    this._callback = null;
  }

  openModal(request, opts, successCb, resetLifecycleCb) {
    this._request = request;
    this._successCb = successCb;
    this._resetLifecycleCb = resetLifecycleCb;

    let target = _.get(opts, 'target') ? opts.target : this.state.target;
    this.setState({
      isOpen: true,
      requestName: _.get(this._request, 'name') || _.get(this._request, 'url') || '',
      requestDescription: _.get(this._request, 'description') || '',
      target,
      origin: opts && opts.from || ORIGIN_BUILDER },
    () => {
      this.requestNameInput && this.requestNameInput.focus();
    });
  }

  // Used to set the target for collection explorer when
  // adding a request from sidebar to a empty collection
  // or folder.
  getInitialSelection() {
    if (_.isEmpty(this.state.target)) {
      return {};
    }

    let collections = Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('ActiveWorkspaceStore').editableCollections,
    folder = _.get(this.state.target, 'folder'),
    collection = _.get(this.state.target, 'collection');


    if (folder && !_.some(collections, ['id', folder.collection])) {
      return {};
    } else
    if (folder && !Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('FolderStore').find(folder.id)) {
      return {};
    }

    if (collection && !_.some(collections, ['id', collection.id])) {
      return {};
    }

    return this.state.target;
  }

  handleClose() {
    this.closeModal();
    _.isFunction(this._resetLifecycleCb) && this._resetLifecycleCb();
  }

  handleSelect(target) {
    let collection = null,
    folder = null;

    switch (target.type) {
      case 'collection':
        collection = target;
        break;
      case 'folder':
        folder = target;
        break;}


    this.setState({
      selected: target,
      target: { collection, folder } });

  }

  isNewCollection(collectionId) {
    return _.includes(this.state.createdCollections, collectionId);
  }

  handleRequestNameChange(value) {
    this.setState({ requestName: value });
  }

  handleRequestDescriptionChange(value) {
    this.setState({ requestDescription: value });
  }

  handleSubmit() {
    if (_.isEmpty(this.state.requestName)) {
      this.setState({ nameError: true });
      return;
    }

    let collection = {},
    target = 'collection',
    isNewCollection = false;

    if (this.state.selected) {
      if (_.get(this.state, 'selected.type') === 'folder') {
        collection.id = _.get(this.state, 'selected.collection');
        target = 'folder';
      } else
      {
        collection.id = _.get(this.state, 'selected.id');
        target = 'collection';
        isNewCollection = this.isNewCollection(collection.id);
      }
    } else
    if (_.isEmpty(this.state.selected)) {
      pm.toasts.error('Select an existing collection or provide a Collection name');
      return false;
    } else
    {
      pm.toasts.error('Provide a Collection name');
      return false;
    }

    let requestToBeSaved = _.merge(getDefaultRequestObject(), this._request, {
      name: this.state.requestName,
      description: this.state.requestDescription,
      collection: collection.id });


    let origin = this.state.origin,
    createRequestEvent;

    if (!origin) {
      origin = isNewCollection ? 'builder/new_collection' : 'builder/existing_collection';
    }

    createRequestEvent = Object(__WEBPACK_IMPORTED_MODULE_3__modules_model_event__["a" /* createEvent */])('create_deep',
    'request',
    {
      request: requestToBeSaved,
      target: {
        model: target === 'collection' ? 'collection' : 'folder',
        modelId: _.get(this.state, 'selected.id') } },


    [],
    { origin });


    Object(__WEBPACK_IMPORTED_MODULE_2__modules_pipelines_user_action__["a" /* default */])(createRequestEvent).then(response => {
      if (!_.isEmpty(_.get(response, 'error'))) {
        pm.logger.error('Error in creating request', response.error);
        return;
      }

      console.warn('@todo Select in the sidebar');
      pm.mediator.trigger('scrollToRequest', requestToBeSaved.id);
      pm.mediator.trigger('requestSaved', this._request, requestToBeSaved);
      isNewCollection && this.state.origin !== 'new-x-modal' && pm.mediator.trigger('focusCollectionInSideBar', collection.id, 'Documentation');

      // _successCb for handling the whether to close the editor, or open
      _.isFunction(this._successCb) && this._successCb();

      // reset the lifecycle back from saving -> idle
      _.isFunction(this._resetLifecycleCb) && this._resetLifecycleCb();
      this.closeModal();

    }).catch(err => {
      pm.logger.error('Error in pipeline for creating request', err);
      pm.toasts.error('Could not create request');
    });
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_collections_AddRequestToCollection__["a" /* default */], {
        isOpen: this.state.isOpen,
        selected: this.state.selected,
        requestName: this.state.requestName,
        requestDescription: this.state.requestDescription,
        origin: this.state.origin,
        onRequestNameChange: this.handleRequestNameChange,
        onRequestDescriptionChange: this.handleRequestDescriptionChange,
        onRequestClose: this.handleClose,
        onSelect: this.handleSelect,
        onSubmit: this.handleSubmit,
        initialSelection: this.getInitialSelection(),
        requestNameInput: input => {return this.requestNameInput = input;},
        requestNameError: this.state.nameError }));


  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4700:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddRequestToCollection; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_TextEditor__ = __webpack_require__(311);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_keymaps_KeyMaps__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__explorer_CollectionExplorer__ = __webpack_require__(3934);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__constants_AppUrlConstants__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__utils_CollectionSorter__ = __webpack_require__(1001);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__external_navigation_ExternalNavigationService__ = __webpack_require__(59);
var _class;










let


AddRequestToCollection = Object(__WEBPACK_IMPORTED_MODULE_1_mobx_react__["a" /* observer */])(_class = class AddRequestToCollection extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.memorizedSortedCollection = _.memoize(__WEBPACK_IMPORTED_MODULE_10__utils_CollectionSorter__["b" /* sortCollections */]);
  }

  getCustomStyles() {
    return { margin: 'auto' };
  }

  getKeyMapHandlers() {
    return { submit: pm.shortcuts.handle('submit', this.props.onSubmit) };
  }

  handleCollectionDocs() {
    Object(__WEBPACK_IMPORTED_MODULE_11__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_8__constants_AppUrlConstants__["r" /* COLLECTION_DOCS */]);
  }

  getCollections() {
    let collections = Object(__WEBPACK_IMPORTED_MODULE_9__stores_get_store__["getStore"])('ActiveWorkspaceStore').editableCollections;
    return this.memorizedSortedCollection(collections);
  }

  handleMarkdownLinkClick() {
    Object(__WEBPACK_IMPORTED_MODULE_11__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_8__constants_AppUrlConstants__["Q" /* MARKDOWN_DOCS */]);
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Modals__["a" /* Modal */], {
          className: 'save-request-modal addrequest-top-container-modal',
          isOpen: this.props.isOpen,
          onRequestClose: this.props.onRequestClose,
          customStyles: this.getCustomStyles() },














        this.props.isOpen &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_0_react___default.a.Fragment, null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Modals__["d" /* ModalHeader */], null, 'SAVE REQUEST'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Modals__["b" /* ModalContent */], null,
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_keymaps_KeyMaps__["a" /* default */], { keyMap: pm.shortcuts.getShortcuts(), handlers: this.getKeyMapHandlers() },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'addrequest-top-container' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'row add-request-helptext' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, 'Requests in Postman are saved in collections (a group of requests).'),
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
                      type: 'text',
                      onClick: this.handleCollectionDocs }, 'Learn more about creating collections')),




                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'row addrequest-top-container-name-row' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'field-label' }, 'Request name'),
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Inputs__["b" /* Input */], {
                    className: 'addrequest__request-name',
                    type: 'text',
                    inputStyle: 'box',
                    onChange: this.props.onRequestNameChange,
                    error: this.props.requestNameError,
                    onSubmit: this.props.onSubmit,
                    value: this.props.requestName,
                    ref: this.props.requestNameInput })),


                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'row' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'field-label' }, 'Request description (Optional)'),
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_TextEditor__["a" /* default */], {
                    value: this.props.requestDescription,
                    mode: 'markdown',
                    height: 'auto',
                    placeholder: 'Make things easier for your teammates with a complete request description.',
                    className: 'addrequest-request-description-editor',
                    onChange: this.props.onRequestDescriptionChange,
                    hideGutter: true,
                    showScrollMargin: true }),

                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'addnew-description-help-text' }, 'Descriptions support',

                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', {
                        className: 'btn btn-text inline-editor__markdown-link',
                        onClick: this.handleMarkdownLinkClick }, 'Markdown'))),






                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'addrequest-collection-name-container' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'row addrequest-collection-selector-row' },
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'field-label' }, 'Select a collection or folder to save to:'),


                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__explorer_CollectionExplorer__["a" /* default */], {
                      origin: this.props.origin,
                      onCreate: this.props.onCreate,
                      onSelect: this.props.onSelect,
                      initialSelection: this.props.initialSelection,
                      collections: this.getCollections(),
                      folders: Object(__WEBPACK_IMPORTED_MODULE_9__stores_get_store__["getStore"])('FolderStore').values,
                      requests: Object(__WEBPACK_IMPORTED_MODULE_9__stores_get_store__["getStore"])('RequestStore').values })))))),






          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Modals__["c" /* ModalFooter */], { separated: true },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
                disabled: !(this.props.selected && this.props.selected.id),
                type: 'primary',
                onClick: this.props.onSubmit },

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'content' }, 'Save ',
                this.props.selected && this.props.selected.name && ` to ${this.props.selected.name}`)),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
                type: 'secondary',
                onClick: this.props.onRequestClose }, 'Cancel')))));






  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4701:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddMultipleRequestsToCollectionContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_collections_AddMultipleRequestsToCollection__ = __webpack_require__(4702);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__utils_util__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_model_event__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_async_series__ = __webpack_require__(99);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_async_series___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_async_series__);





let

AddMultipleRequestsToCollectionContainer = class AddMultipleRequestsToCollectionContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      selected: null,
      createdCollections: [] };


    this.openModal = this.openModal.bind(this);
    this.handleSelect = this.handleSelect.bind(this);
    this.handleCreate = this.handleCreate.bind(this);
    this.handleCreate = this.handleCreate.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleSubmit = this.handleSubmit.bind(this);

  }

  componentWillMount() {
    this.attachModelListeners();
  }

  componentWillUnmount() {
    this.detachModelListeners();
  }

  attachModelListeners() {
    pm.mediator.on('addRequestsToCollection', this.openModal);
  }

  detachModelListeners() {
    pm.mediator.off('addRequestsToCollection', this.openModal);
  }

  closeModal() {
    this.setState({ isOpen: false }, () => {
      this.clearModal();
    });
  }

  clearModal() {
    this._requests = null;
    this.setState({
      selected: null,
      createdCollections: [] });

  }

  openModal(requests, opts) {
    this._requests = requests;

    this.setState({
      isOpen: true,
      origin: opts && opts.from },
    () => {
      this.modal && this.modal.focus();
    });
  }

  handleClose() {
    this.closeModal();
  }

  handleSelect(target) {
    this.setState({ selected: target });
  }

  addCollectionToList(id) {
    let createdCollections = this.state.createdCollections;
    createdCollections.push(id);
    this.setState({ createdCollections });
  }

  isNewCollection(collectionId) {
    return _.includes(this.state.createdCollections, collectionId);
  }

  handleCreate(entity) {
    if (entity.type === 'collection') {
      // This means you created a collection
      this.addCollectionToList(entity.id);
    }
  }

  handleSubmit() {
    let collection = {},
    target = 'collection',
    analyticsSent = false, // to be compatible with the old events, we don't want to send multiple events
    isNewCollection = false;

    if (this.state.selected) {
      if (_.get(this.state, 'selected.type') === 'folder') {
        collection.id = _.get(this.state, 'selected.collection');
        target = 'folder';
      } else
      {
        collection.id = _.get(this.state, 'selected.id');
        target = 'collection';
        isNewCollection = this.isNewCollection(collection.id);
      }
    } else
    if (_.isEmpty(this.state.selected)) {
      pm.toasts.error('Select an existing collection or provide a Collection name');
      return false;
    } else
    {
      pm.toasts.error('Please select an existing collection');
      return false;
    }

    __WEBPACK_IMPORTED_MODULE_5_async_series___default()(
    _.map(this._requests, request => {

      return callback => {
        let origin,
        value = _.size(this._requests),
        from = this.state.origin,
        reqCreateEvent;

        // `origin` is assigned a value in this block, so it will be undefined for all the requests expect the first one
        // Analytics handler uses this (origin to be undefined) to skip the event for the rest of the requests
        if (!analyticsSent) {
          analyticsSent = true;
          from && !isNewCollection && (origin = from);
          !from && (origin = isNewCollection ? 'new_collection' : 'existing_collection');
        }

        reqCreateEvent = Object(__WEBPACK_IMPORTED_MODULE_3__modules_model_event__["a" /* createEvent */])(
        'create_deep',
        'request',
        {
          request,
          target: {
            model: target === 'collection' ? 'collection' : 'folder',
            modelId: _.get(this.state, 'selected.id') } },


        null,
        { origin, value });


        Object(__WEBPACK_IMPORTED_MODULE_4__modules_pipelines_user_action__["a" /* default */])(reqCreateEvent).then(response => {
          if (!_.isEmpty(_.get(response, 'error'))) {
            pm.logger.error('Error in pipeline while adding request to collection', _.get(response, 'error'));
          }
          callback(null);
        }).catch(error => {
          pm.logger.error('Error in pipeline while adding request to collection', error);
          callback(null);
        });
      };
    }),
    (err, results) => {
      if (err) {
        this.closeModal();
        pm.logger.error('Error in pipeline while creating multiple requests', err);
        return;
      }

      isNewCollection && pm.mediator.trigger('focusCollectionInSideBar', collection.id, 'Documentation');
      this.closeModal();
    });

  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_collections_AddMultipleRequestsToCollection__["a" /* default */], {
        isOpen: this.state.isOpen,
        selected: this.state.selected,
        onRequestClose: this.handleClose,
        onCreate: this.handleCreate,
        onSelect: this.handleSelect,
        onSubmit: this.handleSubmit,
        modal: modal => {return this.modal = modal;},
        origin: this.state.origin }));


  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4702:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddMultipleRequestsToCollection; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_keymaps_KeyMaps__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__explorer_CollectionExplorer__ = __webpack_require__(3934);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__constants_AppUrlConstants__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__utils_CollectionSorter__ = __webpack_require__(1001);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__external_navigation_ExternalNavigationService__ = __webpack_require__(59);
var _class;









let



AddMultipleRequestsToCollection = Object(__WEBPACK_IMPORTED_MODULE_8_mobx_react__["a" /* observer */])(_class = class AddMultipleRequestsToCollection extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.memorizedSortedCollection = _.memoize(__WEBPACK_IMPORTED_MODULE_9__utils_CollectionSorter__["b" /* sortCollections */]);
  }

  getCustomStyles() {
    return { margin: 'auto' };
  }

  getKeyMapHandlers() {
    return { submit: pm.shortcuts.handle('submit', this.props.onSubmit) };
  }

  handleCollectionDocs() {
    Object(__WEBPACK_IMPORTED_MODULE_10__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_6__constants_AppUrlConstants__["r" /* COLLECTION_DOCS */]);
  }

  getCollections() {
    let collections = Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('ActiveWorkspaceStore').editableCollections;
    return this.memorizedSortedCollection(collections);
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Modals__["a" /* Modal */], {
          className: 'save-mutiple-requests-modal',
          isOpen: this.props.isOpen,
          onRequestClose: this.props.onRequestClose,
          customStyles: this.getCustomStyles() },














        this.props.isOpen &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_0_react___default.a.Fragment, null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Modals__["d" /* ModalHeader */], null, 'SAVE MULTIPLE REQUESTS'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Modals__["b" /* ModalContent */], null,
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_keymaps_KeyMaps__["a" /* default */], { keyMap: pm.shortcuts.getShortcuts(), handlers: this.getKeyMapHandlers() },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
                  ref: this.props.modal,
                  className: 'addrequest-top-container addrequest-collection-name-container' },

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'row add-request-helptext' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, 'Requests in Postman are saved in collections (a group of requests).'),
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                      type: 'text',
                      onClick: this.handleCollectionDocs }, 'Learn more about creating collections')),




                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'row add-request-top-row' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'field-label' }, 'Select a collection or folder to save to:'),


                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__explorer_CollectionExplorer__["a" /* default */], {
                    origin: this.props.origin,
                    onCreate: this.props.onCreate,
                    onSelect: this.props.onSelect,
                    collections: this.getCollections(),
                    folders: Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('FolderStore').values,
                    requests: Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('RequestStore').values }))))),





          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Modals__["c" /* ModalFooter */], { separated: true },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                disabled: !(this.props.selected && this.props.selected.id),
                type: 'primary',
                onClick: this.props.onSubmit },

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'content' }, 'Save ',
                this.props.selected && this.props.selected.name && ` to ${this.props.selected.name}`)),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                type: 'secondary',
                onClick: this.props.onRequestClose }, 'Cancel')))));






  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4703:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddCollectionModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_base_keymaps_KeyMaps__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_collections_CollectionModalTabs__ = __webpack_require__(3935);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__components_collections_CollectionModalTabContents__ = __webpack_require__(3936);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_collections_CollectionModalTabContent__ = __webpack_require__(3937);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__components_collections_CollectionDescription__ = __webpack_require__(3938);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__components_collections_CollectionPreRequestScripts__ = __webpack_require__(3939);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__components_collections_CollectionVariables__ = __webpack_require__(3940);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__components_collections_CollectionConfigurationList__ = __webpack_require__(3941);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__variables_CollectionVariablesProvider__ = __webpack_require__(973);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__components_collections_CollectionTests__ = __webpack_require__(3942);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__CollectionAuthEditorContainer__ = __webpack_require__(3943);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__modules_model_event__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__utils_util__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__utils_authUtil__ = __webpack_require__(137);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19_postman_collection__ = __webpack_require__(74);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19_postman_collection___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_19_postman_collection__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_20__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_21__utils_VariableSessionHelper__ = __webpack_require__(153);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_22__constants_CollectionModalTabsConstants__ = __webpack_require__(983);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_23__constants_AuthConstants__ = __webpack_require__(219);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_24__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_25__components_base_XPaths_XPath__ = __webpack_require__(24);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};

























let
AddCollectionModalContainer = class AddCollectionModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);this.






















































































































































































































































    handleColumnToggle = columns => {
      this.setNewColumns(columns);
      pm.settings.setSetting('dataEditorColumns', _extends({},
      pm.settings.getSetting('dataEditorColumns'), {
        session: columns }));

    };this.

    setNewColumns = columns => {
      this.setState({ showColumns: columns });
    };this.state = { isOpen: false, activeTab: __WEBPACK_IMPORTED_MODULE_22__constants_CollectionModalTabsConstants__["c" /* COLLECTION_DESCRIPTION */], nameError: false, showColumns: [], protocolProfileBehavior: {} };this.handleOpen = this.handleOpen.bind(this);this.handleClose = this.handleClose.bind(this);this.handleSubmit = this.handleSubmit.bind(this);this.handleTabSelect = this.handleTabSelect.bind(this);this.handleNameChange = this.handleNameChange.bind(this);this.handleDescriptionChange = this.handleDescriptionChange.bind(this);this.handleBeautifyPreRequestScript = this.handleBeautifyPreRequestScript.bind(this);this.handleBeautifyTests = this.handleBeautifyTests.bind(this);this.handlePreRequestScriptChange = this.handlePreRequestScriptChange.bind(this);this.handleTestsChange = this.handleTestsChange.bind(this);this.handleVariableValuesChange = this.handleVariableValuesChange.bind(this);this.handleAuthTypeSelect = this.handleAuthTypeSelect.bind(this);this.handleUseOauth2Token = this.handleUseOauth2Token.bind(this);this.handleFieldChange = this.handleFieldChange.bind(this);this.updateProtocolProfileBehavior = this.updateProtocolProfileBehavior.bind(this);this.removeKeyFromProtocolProfileBehavior = this.removeKeyFromProtocolProfileBehavior.bind(this);this.updateSavedAuths = _.debounce(__WEBPACK_IMPORTED_MODULE_18__utils_authUtil__["g" /* updateSavedAuths */], 1000);}clearModal() {this.setState({ name: '', description: null, activeWorkspaceId: null, auth: null, savedAuths: null, preRequestScript: null, tests: null, nameError: null, variables: null, protocolProfileBehavior: {} });}handleClose() {this._callback = null;this.setState({ isOpen: false });this.clearModal();}handleOpen(callback) {this._callback = callback;this.setState({ isOpen: true, activeTab: __WEBPACK_IMPORTED_MODULE_22__constants_CollectionModalTabsConstants__["c" /* COLLECTION_DESCRIPTION */], activeWorkspaceId: Object(__WEBPACK_IMPORTED_MODULE_20__stores_get_store__["getStore"])('ActiveWorkspaceStore').id, showColumns: _.get(pm.settings.getSetting('dataEditorColumns'), 'session'), name: '', description: '', auth: null, preRequestScript: '', tests: '', variables: [], protocolProfileBehavior: {} }, () => {this.collectionNameInput && this.collectionNameInput.focus();});Object(__WEBPACK_IMPORTED_MODULE_18__utils_authUtil__["d" /* getSavedAuths */])(auths => {this.setState({ savedAuths: auths });});}handleTabSelect(id) {if (id === this.state.activeTab) {return;}this.setState({ activeTab: id });}componentWillMount() {pm.mediator.on('showNewCollectionModal', this.handleOpen);pm.appWindow.trigger('registerInternalEvent', 'newCollection', this.handleOpen, this);}componentWillUnmount() {pm.mediator.off('showNewCollectionModal', this.handleOpen);}getCustomStyles() {return { marginTop: '8vh', width: '800px', height: '88vh' };}getKeyMapHandlers() {return { 'submit': pm.shortcuts.handle('submit', this.handleSubmit) };}handleDescriptionChange(value) {this.setState({ description: value });}handleNameChange(value) {this.setState({ name: value });}handlePreRequestScriptChange(value) {this.setState({ preRequestScript: value });}handleBeautifyPreRequestScript() {this.handlePreRequestScriptChange(__WEBPACK_IMPORTED_MODULE_16__utils_util__["a" /* default */].beautifyJs(this.state.preRequestScript));}handleTestsChange(value) {this.setState({ tests: value });}handleVariableValuesChange(values, done) {this.setState({ variables: values }, () => {if (_.isFunction(done)) {done();}});}handleBeautifyTests() {this.handleTestsChange(__WEBPACK_IMPORTED_MODULE_16__utils_util__["a" /* default */].beautifyJs(this.state.tests));}handleAuthTypeSelect(authType) {if (_.get(this.state, 'auth.type') === authType) {return;}let auth = { type: authType };if (authType !== __WEBPACK_IMPORTED_MODULE_23__constants_AuthConstants__["v" /* AUTH_TYPE_RAW_NO_AUTH */]) {auth[authType] = _.get(this.state, ['savedAuths', authType], Object(__WEBPACK_IMPORTED_MODULE_18__utils_authUtil__["b" /* getDefaultAuthProps */])(authType));}this.setState({ auth: authType === __WEBPACK_IMPORTED_MODULE_23__constants_AuthConstants__["v" /* AUTH_TYPE_RAW_NO_AUTH */] ? null : _.assign({}, auth) });}setValue(authType, k, v) {return Object(__WEBPACK_IMPORTED_MODULE_18__utils_authUtil__["e" /* setAuthValue */])(this.state.auth, authType, k, v);}handleFieldChange(authType, key, value) {let newAuth = this.setValue(authType, key, value),authObj = { type: authType };authObj[authType] = newAuth;this.setState({ auth: _.assign({}, authObj), savedAuths: _.assign({}, this.state.savedAuths, _.omit(authObj, ['type'])) }, () => {this.updateSavedAuths(_.omit(this.state.savedAuths, ['type']));});}handleUseOauth2Token(token) {let newAuth = Object(__WEBPACK_IMPORTED_MODULE_18__utils_authUtil__["f" /* setAuthValues */])(this.state.auth, 'oauth2', { accessToken: token.access_token, tokenType: token.token_type }),authObj = { type: 'oauth2' };authObj['oauth2'] = newAuth;this.setState({ auth: _.assign({}, authObj), savedAuths: _.assign({}, this.state.savedAuths, _.omit(authObj, ['type'])) }, () => {this.updateSavedAuths(_.omit(this.state.savedAuths, ['type']));});}handleSubmit() {if (_.isEmpty(_.isString(this.state.name) && this.state.name.trim())) {this.setState({ nameError: true });return;}let { variables, sessionVariables } = Object(__WEBPACK_IMPORTED_MODULE_21__utils_VariableSessionHelper__["e" /* unzipVariables */])(this.state.variables),collectionId = __WEBPACK_IMPORTED_MODULE_16__utils_util__["a" /* default */].guid();Promise.resolve() // create the collection
    .then(() => {let collectionData = _.pick(this.state, ['name', 'description', 'auth']),sdkEvents = [];collectionData.protocolProfileBehavior = this.state.protocolProfileBehavior;collectionData.variables = variables;!_.isEmpty(this.state.preRequestScript) && sdkEvents.push(new __WEBPACK_IMPORTED_MODULE_19_postman_collection__["Event"]({ listen: 'prerequest', script: this.state.preRequestScript }));!_.isEmpty(this.state.tests) && sdkEvents.push(new __WEBPACK_IMPORTED_MODULE_19_postman_collection__["Event"]({ listen: 'test', script: this.state.tests }));let eventsJson = new __WEBPACK_IMPORTED_MODULE_19_postman_collection__["EventList"]({}, sdkEvents).toJSON();!_.isEmpty(eventsJson) && (collectionData.events = eventsJson);let currentUser = Object(__WEBPACK_IMPORTED_MODULE_20__stores_get_store__["getStore"])('CurrentUserStore'),createCollectionEvent = Object(__WEBPACK_IMPORTED_MODULE_15__modules_model_event__["a" /* createEvent */])('create_deep', 'collection', { collection: _.assign(collectionData, { id: collectionId, owner: currentUser.id }) }, [], { origin: 'builder' });return Object(__WEBPACK_IMPORTED_MODULE_24__modules_pipelines_user_action__["a" /* default */])(createCollectionEvent);}) // create the session
    .then(() => {if (_.isEmpty(sessionVariables)) {return;}let session = { id: Object(__WEBPACK_IMPORTED_MODULE_21__utils_VariableSessionHelper__["b" /* getSessionId */])('collection', collectionId, this.state.activeWorkspaceId), model: 'collection', modelId: collectionId, workspace: this.state.activeWorkspaceId, values: sessionVariables },createSessionEvent = Object(__WEBPACK_IMPORTED_MODULE_15__modules_model_event__["a" /* createEvent */])('create', 'variablesession', session);__WEBPACK_IMPORTED_MODULE_17__modules_services_AnalyticsService__["a" /* default */].addEvent('session', 'user_create', 'collection');return Object(__WEBPACK_IMPORTED_MODULE_24__modules_pipelines_user_action__["a" /* default */])(createSessionEvent);}).then(() => {_.isFunction(this._callback) && this._callback(collectionId);this.handleClose();}).catch(err => {this.handleClose();pm.logger.error('Error in pipeline for creating collection or the session', err);});}getTooltipText(isDisabled) {
    if (isDisabled) {
      return 'You do not have permissions to perform this action.';
    }
  }

  updateProtocolProfileBehavior(key, value) {
    this.setState(prevState => (
    { protocolProfileBehavior: _.set(prevState.protocolProfileBehavior, [key], value) }));

  }

  removeKeyFromProtocolProfileBehavior(key) {
    this.setState(prevState => (
    { protocolProfileBehavior: _.omit(prevState.protocolProfileBehavior, [key]) }));

  }

  render() {
    const permissionsStore = Object(__WEBPACK_IMPORTED_MODULE_20__stores_get_store__["getStore"])('PermissionStore'),
    workspaceId = Object(__WEBPACK_IMPORTED_MODULE_20__stores_get_store__["getStore"])('ActiveWorkspaceStore').id,
    canAddCollection = permissionsStore.can('addCollection', 'workspace', workspaceId);

    /**
                                                                                         * @todo: Remove usage of feature flag - COLLECTION_CONFIGURATIONS_ENABLED,
                                                                                         *        once sync supports protocolProfileBehavior for collection and folders
                                                                                         */
    const COLLECTION_CONFIGURATIONS_ENABLED = Object(__WEBPACK_IMPORTED_MODULE_20__stores_get_store__["getStore"])('FeatureFlagsStore').isEnabled('collectionAndFolderConfigurations');

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_25__components_base_XPaths_XPath__["a" /* default */], { identifier: 'addCollection', isVisible: this.state.isOpen },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_Modals__["a" /* Modal */], {
            isOpen: this.state.isOpen,
            onRequestClose: this.handleClose,
            customStyles: this.getCustomStyles(),
            className: 'collection-modal' },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_Modals__["d" /* ModalHeader */], null, 'CREATE A NEW COLLECTION'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_Modals__["b" /* ModalContent */], { className: 'collection-modal-content' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_keymaps_KeyMaps__["a" /* default */], { keyMap: pm.shortcuts.getShortcuts(), handlers: this.getKeyMapHandlers() },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-content-container' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-name-container' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'field-label' }, 'Name'),


                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_25__components_base_XPaths_XPath__["a" /* default */], { identifier: 'name' },
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Inputs__["b" /* Input */], {
                      type: 'text',
                      inputStyle: 'box',
                      value: this.state.name,
                      error: this.state.nameError,
                      placeholder: 'Collection Name',
                      onChange: this.handleNameChange,
                      onSubmit: this.handleSubmit,
                      className: 'collection-modal-name-input',
                      ref: input => this.collectionNameInput = input })),


                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_collections_CollectionModalTabs__["a" /* default */], {
                    onSelect: this.handleTabSelect,
                    activeTab: this.state.activeTab,
                    isAuthSelected: !_.isEmpty(this.state.auth),
                    isPreRequestScriptAvailable: !!this.state.preRequestScript,
                    isTestsAvailable: !!this.state.tests,
                    hasVariables: !_.isEmpty(this.state.variables) })),


                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_12__variables_CollectionVariablesProvider__["a" /* default */], { collectionVariables: this.state.variables },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_collections_CollectionModalTabContents__["a" /* default */], {
                      activeKey: this.state.activeTab },

                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__components_collections_CollectionModalTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_22__constants_CollectionModalTabsConstants__["c" /* COLLECTION_DESCRIPTION */] },
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_25__components_base_XPaths_XPath__["a" /* default */], { identifier: 'description' },
                        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__components_collections_CollectionDescription__["a" /* default */], {
                          description: this.state.description,
                          onChange: this.handleDescriptionChange }))),



                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__components_collections_CollectionModalTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_22__constants_CollectionModalTabsConstants__["a" /* COLLECTION_AUTHORIZATION */] },
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_25__components_base_XPaths_XPath__["a" /* default */], { identifier: 'authorization' },
                        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_14__CollectionAuthEditorContainer__["a" /* default */], {
                          auth: this.state.auth,
                          onUseToken: this.handleUseOauth2Token,
                          handleAuthTypeSelect: this.handleAuthTypeSelect,
                          handleFieldChange: this.handleFieldChange,
                          handleAuthAnalytics: _.noop }))),



                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__components_collections_CollectionModalTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_22__constants_CollectionModalTabsConstants__["d" /* COLLECTION_PRE_REQUEST_SCRIPTS */] },
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_25__components_base_XPaths_XPath__["a" /* default */], { identifier: 'preRequest' },
                        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_9__components_collections_CollectionPreRequestScripts__["a" /* default */], {
                          value: this.state.preRequestScript,
                          onBeautify: this.handleBeautifyPreRequestScript,
                          onChange: this.handlePreRequestScriptChange }))),



                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__components_collections_CollectionModalTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_22__constants_CollectionModalTabsConstants__["e" /* COLLECTION_TESTS */] },
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_25__components_base_XPaths_XPath__["a" /* default */], { identifier: 'tests' },
                        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_13__components_collections_CollectionTests__["a" /* default */], {
                          value: this.state.tests,
                          onBeautify: this.handleBeautifyTests,
                          onChange: this.handleTestsChange }))),



                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__components_collections_CollectionModalTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_22__constants_CollectionModalTabsConstants__["f" /* COLLECTION_VARIABLES */] },
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_25__components_base_XPaths_XPath__["a" /* default */], { identifier: 'variables' },
                        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__components_collections_CollectionVariables__["a" /* default */], {
                          values: this.state.variables,
                          onChange: this.handleVariableValuesChange,
                          onColumnToggle: this.handleColumnToggle,
                          showColumns: this.state.showColumns }))),



                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__components_collections_CollectionModalTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_22__constants_CollectionModalTabsConstants__["b" /* COLLECTION_CONFIGURATIONS */] },

                      COLLECTION_CONFIGURATIONS_ENABLED &&
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_11__components_collections_CollectionConfigurationList__["a" /* default */], {
                        configuration: this.state.protocolProfileBehavior,
                        updateProtocolProfileBehavior: this.updateProtocolProfileBehavior,
                        removeKeyFromProtocolProfileBehavior: this.removeKeyFromProtocolProfileBehavior }))))))),








          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_Modals__["c" /* ModalFooter */], { className: 'collection-modal-footer' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_25__components_base_XPaths_XPath__["a" /* default */], { identifier: 'create' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Buttons__["a" /* Button */], {
                  type: 'primary',
                  onClick: this.handleSubmit,
                  disabled: !canAddCollection,
                  tooltip: this.getTooltipText(!canAddCollection) }, 'Create')),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_25__components_base_XPaths_XPath__["a" /* default */], { identifier: 'cancel' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Buttons__["a" /* Button */], {
                  type: 'secondary',
                  onClick: this.handleClose }, 'Cancel'))))));






  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4704:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return EditCollectionModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_mobx__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_base_keymaps_KeyMaps__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__components_collections_CollectionModalTabs__ = __webpack_require__(3935);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_collections_CollectionModalTabContents__ = __webpack_require__(3936);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__components_collections_CollectionModalTabContent__ = __webpack_require__(3937);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__components_collections_CollectionDescription__ = __webpack_require__(3938);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__components_collections_CollectionPreRequestScripts__ = __webpack_require__(3939);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__components_collections_CollectionTests__ = __webpack_require__(3942);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__components_collections_CollectionVariables__ = __webpack_require__(3940);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__components_collections_CollectionConfigurationList__ = __webpack_require__(3941);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__CollectionAuthEditorContainer__ = __webpack_require__(3943);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__variables_CollectionVariablesProvider__ = __webpack_require__(973);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__modules_controllers_CollectionController__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__modules_services_VariableSessionService__ = __webpack_require__(273);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_20__utils_VariableSessionHelper__ = __webpack_require__(153);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_21__modules_model_event__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_22__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_23__utils_util__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_24__utils_authUtil__ = __webpack_require__(137);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_25_postman_collection__ = __webpack_require__(74);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_25_postman_collection___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_25_postman_collection__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_26__constants_CollectionModalTabsConstants__ = __webpack_require__(983);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_27__constants_AuthConstants__ = __webpack_require__(219);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_28__components_base_XPaths_XPath__ = __webpack_require__(24);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};






























let

EditCollectionModalContainer = class EditCollectionModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.state = {
      isOpen: false,
      activeTab: __WEBPACK_IMPORTED_MODULE_26__constants_CollectionModalTabsConstants__["c" /* COLLECTION_DESCRIPTION */],
      nameError: false,
      showColumns: [],
      protocolProfileBehavior: {} };

    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleSubmit = this.handleSubmit.bind(this);
    this.handleTabSelect = this.handleTabSelect.bind(this);
    this.handleNameChange = this.handleNameChange.bind(this);
    this.handleDescriptionChange = this.handleDescriptionChange.bind(this);
    this.handleBeautifyPRScript = this.handleBeautifyPRScript.bind(this);
    this.handleBeautifyTests = this.handleBeautifyTests.bind(this);
    this.handlePreRequestScriptChange = this.handlePreRequestScriptChange.bind(this);
    this.handleTestsChange = this.handleTestsChange.bind(this);
    this.handleVariableValuesChange = this.handleVariableValuesChange.bind(this);
    this.handleAuthTypeSelect = this.handleAuthTypeSelect.bind(this);
    this.handleFieldChange = this.handleFieldChange.bind(this);
    this.handleUseOauth2Token = this.handleUseOauth2Token.bind(this);
    this.handleColumnToggle = this.handleColumnToggle.bind(this);
    this.setNewColumns = this.setNewColumns.bind(this);
    this.updateProtocolProfileBehavior = this.updateProtocolProfileBehavior.bind(this);
    this.removeKeyFromProtocolProfileBehavior = this.removeKeyFromProtocolProfileBehavior.bind(this);
    this.updateSavedAuths = _.debounce(__WEBPACK_IMPORTED_MODULE_24__utils_authUtil__["g" /* updateSavedAuths */], 1000);
  }

  clearModal() {
    this.setState({
      name: '',
      description: null,
      activeWorkspaceId: null,
      auth: null,
      savedAuths: null,
      preRequestScript: null,
      tests: null,
      nameError: null,
      showColumns: [],
      variables: null,
      protocolProfileBehavior: {} });

  }

  handleClose() {
    this.setState({ isOpen: false });
    this.clearModal();
  }

  handleVariableValuesChange(values, done) {
    this.setState({ variables: values }, () => {
      if (_.isFunction(done)) {
        done();
      }
    });
  }

  destructureEvents(collectionJSON) {
    if (_.isEmpty(collectionJSON)) {
      return {};
    }

    let sdkEvents = new __WEBPACK_IMPORTED_MODULE_25_postman_collection__["EventList"]({}, Array.isArray(collectionJSON.events) ? collectionJSON.events : []),
    preRequestEvent = _.head(sdkEvents.listenersOwn('prerequest')),
    testEvent = _.head(sdkEvents.listenersOwn('test'));
    return {
      preRequestScript: !_.isEmpty(preRequestEvent) ? _.invoke(preRequestEvent, 'script.toSource') : '',
      tests: !_.isEmpty(testEvent) ? _.invoke(testEvent, 'script.toSource') : '' };

  }

  handleOpen(collectionId, activeTab = __WEBPACK_IMPORTED_MODULE_26__constants_CollectionModalTabsConstants__["c" /* COLLECTION_DESCRIPTION */]) {
    let collectionJSON,
    session,
    savedAuths,
    variables = [],
    activeWorkspaceId = Object(__WEBPACK_IMPORTED_MODULE_19__stores_get_store__["getStore"])('ActiveWorkspaceStore').id,
    getSavedAuthsPromise = new Promise(resolve => {
      Object(__WEBPACK_IMPORTED_MODULE_24__utils_authUtil__["d" /* getSavedAuths */])(auths => {
        resolve();
      });
    }),
    getCollectionPromise = __WEBPACK_IMPORTED_MODULE_17__modules_controllers_CollectionController__["a" /* default */].getCollection({ id: collectionId });

    return Promise.all([getSavedAuthsPromise, getCollectionPromise]).
    then(result => {
      savedAuths = result[0];
      collectionJSON = result[1];
    })

    // get the session
    .then(() => {
      if (_.isEmpty(collectionJSON.variables)) {
        return;
      }

      let sessionId = Object(__WEBPACK_IMPORTED_MODULE_20__utils_VariableSessionHelper__["b" /* getSessionId */])('collection', collectionId, activeWorkspaceId);
      return Object(__WEBPACK_IMPORTED_MODULE_18__modules_services_VariableSessionService__["d" /* getSessionFor */])(sessionId, collectionJSON).
      then(variableSession => {
        session = variableSession;
        variables = Object(__WEBPACK_IMPORTED_MODULE_20__utils_VariableSessionHelper__["h" /* zipVariables */])(collectionJSON.variables, session.values);
      }).
      catch(err => {
        pm.logger.warn('Failed to get session in edit collection modal', err);
        pm.toasts.error('Something went wrong. Please check DevTools.');
      });
    })

    // update the state
    .then(() => {
      this.setState(_.assign(
      {
        isOpen: true,
        activeTab: activeTab,
        activeWorkspaceId,
        session,
        variables,
        showColumns: _.get(pm.settings.getSetting('dataEditorColumns'), 'session'),
        savedAuths },

      _.pick(collectionJSON,
      [
      'id',
      'name',
      'description',
      'auth',
      'events',
      'protocolProfileBehavior']),

      this.destructureEvents(collectionJSON)),
      () => {
        this.collectionNameInput && this.collectionNameInput.focus();
      });
    });
  }

  handleTabSelect(id) {
    if (id === this.state.activeTab) {
      return;
    }

    this.setState({ activeTab: id });
  }

  componentWillMount() {
    pm.mediator.on('showEditModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showEditModal', this.handleOpen);
  }

  getCustomStyles() {
    return {
      marginTop: '8vh',
      width: '800px',
      height: '88vh' };

  }

  getKeyMapHandlers() {
    return { 'submit': pm.shortcuts.handle('submit', this.handleSubmit) };
  }

  handleDescriptionChange(value) {
    this.setState({ description: value });
  }

  handleNameChange(value) {
    this.setState({ name: value });
  }

  handlePreRequestScriptChange(value) {
    this.setState({ preRequestScript: value });
  }

  handleBeautifyPRScript() {
    this.handlePreRequestScriptChange(__WEBPACK_IMPORTED_MODULE_23__utils_util__["a" /* default */].beautifyJs(this.state.preRequestScript));
  }

  handleTestsChange(value) {
    this.setState({ tests: value });
  }

  handleBeautifyTests() {
    this.handleTestsChange(__WEBPACK_IMPORTED_MODULE_23__utils_util__["a" /* default */].beautifyJs(this.state.tests));
  }

  handleAuthTypeSelect(authType) {
    if (_.get(this.state, 'auth.type') === authType) {
      return;
    }

    let auth = { type: authType };

    if (authType !== __WEBPACK_IMPORTED_MODULE_27__constants_AuthConstants__["v" /* AUTH_TYPE_RAW_NO_AUTH */]) {
      auth[authType] = _.get(this.state, ['savedAuths', authType], Object(__WEBPACK_IMPORTED_MODULE_24__utils_authUtil__["b" /* getDefaultAuthProps */])(authType));
    }

    this.setState({ auth: authType === __WEBPACK_IMPORTED_MODULE_27__constants_AuthConstants__["v" /* AUTH_TYPE_RAW_NO_AUTH */] ? null : _.assign({}, auth) });
  }

  setValue(authType, k, v) {
    return Object(__WEBPACK_IMPORTED_MODULE_24__utils_authUtil__["e" /* setAuthValue */])(this.state.auth, authType, k, v);
  }

  handleFieldChange(authType, key, value) {
    let newAuth = this.setValue(authType, key, value),
    authObj = { type: authType };

    authObj[authType] = newAuth;

    this.setState({
      auth: _.assign({}, authObj),
      savedAuths: _.assign({}, this.state.savedAuths, _.omit(authObj, ['type'])) },
    () => {
      this.updateSavedAuths(_.omit(this.state.savedAuths, ['type']));
    });
  }

  handleUseOauth2Token(token) {
    let newAuth = Object(__WEBPACK_IMPORTED_MODULE_24__utils_authUtil__["f" /* setAuthValues */])(this.state.auth, 'oauth2', {
      accessToken: token.access_token,
      tokenType: token.token_type }),

    authObj = { type: 'oauth2' };

    authObj['oauth2'] = newAuth;

    this.setState({
      auth: _.assign({}, authObj),
      savedAuths: _.assign({}, this.state.savedAuths, _.omit(authObj, ['type'])) },
    () => {
      this.updateSavedAuths(_.omit(this.state.savedAuths, ['type']));
    });
  }

  handleSubmit() {
    if (_.isEmpty(_.isString(this.state.name) && this.state.name.trim())) {
      this.setState({ nameError: true });
      return;
    }

    let { variables, sessionVariables } = Object(__WEBPACK_IMPORTED_MODULE_20__utils_VariableSessionHelper__["e" /* unzipVariables */])(this.state.variables);

    Promise.resolve()

    // update the collection
    .then(() => {
      let updatedData = _.pick(this.state, [
      'name',
      'description',
      'auth']),

      sdkEvents = new __WEBPACK_IMPORTED_MODULE_25_postman_collection__["EventList"]({}, this.state.events),
      preRequestEvent = _.head(sdkEvents.listenersOwn('prerequest')),
      testEvent = _.head(sdkEvents.listenersOwn('test'));

      updatedData.protocolProfileBehavior = this.state.protocolProfileBehavior;
      updatedData.variables = variables;
      if (_.isFunction(_.get(preRequestEvent, 'script.update'))) {
        preRequestEvent.script.update(this.state.preRequestScript);
      } else {
        preRequestEvent = new __WEBPACK_IMPORTED_MODULE_25_postman_collection__["Event"]({ listen: 'prerequest', script: this.state.preRequestScript });
      }

      if (_.isFunction(_.get(testEvent, 'script.update'))) {
        testEvent.script.update(this.state.tests);
      } else {
        testEvent = new __WEBPACK_IMPORTED_MODULE_25_postman_collection__["Event"]({ listen: 'test', script: this.state.tests });
      }

      updatedData.events = new __WEBPACK_IMPORTED_MODULE_25_postman_collection__["EventList"]({}, [preRequestEvent, testEvent]).toJSON();

      let updateCollectionEvent = Object(__WEBPACK_IMPORTED_MODULE_21__modules_model_event__["a" /* createEvent */])('update', 'collection', _.assign(updatedData, { id: this.state.id }));

      return Object(__WEBPACK_IMPORTED_MODULE_16__modules_pipelines_user_action__["a" /* default */])(updateCollectionEvent);
    })

    // create/update the session
    .then(() => {
      let createOrUpdateSessionEvent;

      if (this.state.session) {
        createOrUpdateSessionEvent = Object(__WEBPACK_IMPORTED_MODULE_21__modules_model_event__["a" /* createEvent */])('update', 'variablesession', _extends({},
        this.state.session, {
          values: sessionVariables }));

        __WEBPACK_IMPORTED_MODULE_22__modules_services_AnalyticsService__["a" /* default */].addEvent('session', 'user_edit', 'collection');
      } else
      if (!_.isEmpty(sessionVariables)) {
        let session = {
          id: Object(__WEBPACK_IMPORTED_MODULE_20__utils_VariableSessionHelper__["b" /* getSessionId */])('collection', this.state.id, this.state.activeWorkspaceId),
          model: 'collection',
          modelId: this.state.id,
          workspace: this.state.activeWorkspaceId,
          values: sessionVariables };

        createOrUpdateSessionEvent = Object(__WEBPACK_IMPORTED_MODULE_21__modules_model_event__["a" /* createEvent */])('create', 'variablesession', session);
        __WEBPACK_IMPORTED_MODULE_22__modules_services_AnalyticsService__["a" /* default */].addEvent('session', 'user_create', 'collection');
      }

      if (createOrUpdateSessionEvent) {
        return Object(__WEBPACK_IMPORTED_MODULE_16__modules_pipelines_user_action__["a" /* default */])(createOrUpdateSessionEvent);
      }
    }).
    then(() => {
      this.handleClose();
    }).
    catch(err => {
      this.handleClose();
      pm.logger.error('Error in pipeline for updating collection', err);
    });
  }

  handleColumnToggle(columns) {
    this.setNewColumns(columns);
    pm.settings.setSetting('dataEditorColumns', _extends({},
    pm.settings.getSetting('dataEditorColumns'), {
      session: columns }));

  }

  setNewColumns(columns) {
    this.setState({ showColumns: columns });
  }

  updateProtocolProfileBehavior(key, value) {
    this.setState(prevState => (
    { protocolProfileBehavior: _.set(prevState.protocolProfileBehavior, [key], value) }));

  }

  removeKeyFromProtocolProfileBehavior(key) {
    this.setState(prevState => (
    { protocolProfileBehavior: _.omit(prevState.protocolProfileBehavior, [key]) }));

  }

  render() {
    /**
             * @todo: Remove usage of feature flag - COLLECTION_CONFIGURATIONS_ENABLED,
             *        once sync supports protocolProfileBehavior for collection and folders
             */
    const COLLECTION_CONFIGURATIONS_ENABLED = Object(__WEBPACK_IMPORTED_MODULE_19__stores_get_store__["getStore"])('FeatureFlagsStore').isEnabled('collectionAndFolderConfigurations');

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_28__components_base_XPaths_XPath__["a" /* default */], { identifier: 'editCollection', isVisible: this.state.isOpen },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_Modals__["a" /* Modal */], {
            isOpen: this.state.isOpen,
            onRequestClose: this.handleClose,
            customStyles: this.getCustomStyles(),
            className: 'collection-modal' },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_Modals__["d" /* ModalHeader */], null, 'EDIT COLLECTION'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_Modals__["b" /* ModalContent */], { className: 'collection-modal-content' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_keymaps_KeyMaps__["a" /* default */], { keyMap: pm.shortcuts.getShortcuts(), handlers: this.getKeyMapHandlers() },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-content-container' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-name-container' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'field-label' }, 'Name'),


                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_28__components_base_XPaths_XPath__["a" /* default */], { identifier: 'name' },
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Inputs__["b" /* Input */], {
                      type: 'text',
                      inputStyle: 'box',
                      value: this.state.name,
                      error: this.state.nameError,
                      placeholder: 'Collection Name',
                      onChange: this.handleNameChange,
                      onSubmit: this.handleSubmit,
                      className: 'collection-modal-name-input',
                      ref: input => this.collectionNameInput = input })),


                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_collections_CollectionModalTabs__["a" /* default */], {
                    onSelect: this.handleTabSelect,
                    activeTab: this.state.activeTab,
                    isAuthSelected: !_.isEmpty(this.state.auth),
                    isPreRequestScriptAvailable: !!this.state.preRequestScript,
                    isTestsAvailable: !!this.state.tests,
                    hasVariables: !_.isEmpty(this.state.variables) })),


                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_15__variables_CollectionVariablesProvider__["a" /* default */], { collectionVariables: this.state.variables },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__components_collections_CollectionModalTabContents__["a" /* default */], {
                      activeKey: this.state.activeTab },

                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__components_collections_CollectionModalTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_26__constants_CollectionModalTabsConstants__["c" /* COLLECTION_DESCRIPTION */] },
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_28__components_base_XPaths_XPath__["a" /* default */], { identifier: 'description' },
                        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_9__components_collections_CollectionDescription__["a" /* default */], {
                          description: this.state.description,
                          onChange: this.handleDescriptionChange }))),



                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__components_collections_CollectionModalTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_26__constants_CollectionModalTabsConstants__["a" /* COLLECTION_AUTHORIZATION */] },
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_28__components_base_XPaths_XPath__["a" /* default */], { identifier: 'authorization' },
                        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_14__CollectionAuthEditorContainer__["a" /* default */], {
                          auth: this.state.auth,
                          collectionId: this.state.id,
                          onUseToken: this.handleUseOauth2Token,
                          handleAuthTypeSelect: this.handleAuthTypeSelect,
                          handleFieldChange: this.handleFieldChange,
                          handleAuthAnalytics: _.noop }))),



                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__components_collections_CollectionModalTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_26__constants_CollectionModalTabsConstants__["d" /* COLLECTION_PRE_REQUEST_SCRIPTS */] },
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_28__components_base_XPaths_XPath__["a" /* default */], { identifier: 'preRequest' },
                        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__components_collections_CollectionPreRequestScripts__["a" /* default */], {
                          value: this.state.preRequestScript,
                          onBeautify: this.handleBeautifyPRScript,
                          onChange: this.handlePreRequestScriptChange }))),



                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__components_collections_CollectionModalTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_26__constants_CollectionModalTabsConstants__["e" /* COLLECTION_TESTS */] },
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_28__components_base_XPaths_XPath__["a" /* default */], { identifier: 'tests' },
                        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_11__components_collections_CollectionTests__["a" /* default */], {
                          value: this.state.tests,
                          onBeautify: this.handleBeautifyTests,
                          onChange: this.handleTestsChange }))),



                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__components_collections_CollectionModalTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_26__constants_CollectionModalTabsConstants__["f" /* COLLECTION_VARIABLES */] },
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_28__components_base_XPaths_XPath__["a" /* default */], { identifier: 'variables' },
                        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_12__components_collections_CollectionVariables__["a" /* default */], {
                          values: this.state.variables,
                          onChange: this.handleVariableValuesChange,
                          onColumnToggle: this.handleColumnToggle,
                          showColumns: this.state.showColumns }))),



                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__components_collections_CollectionModalTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_26__constants_CollectionModalTabsConstants__["b" /* COLLECTION_CONFIGURATIONS */] },

                      COLLECTION_CONFIGURATIONS_ENABLED &&
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_13__components_collections_CollectionConfigurationList__["a" /* default */], {
                        configuration: this.state.protocolProfileBehavior,
                        updateProtocolProfileBehavior: this.updateProtocolProfileBehavior,
                        removeKeyFromProtocolProfileBehavior: this.removeKeyFromProtocolProfileBehavior }))))))),








          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_Modals__["c" /* ModalFooter */], { className: 'collection-modal-footer' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_28__components_base_XPaths_XPath__["a" /* default */], { identifier: 'update' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Buttons__["a" /* Button */], {
                  type: 'primary',
                  onClick: this.handleSubmit }, 'Update')),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_28__components_base_XPaths_XPath__["a" /* default */], { identifier: 'cancel' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Buttons__["a" /* Button */], {
                  type: 'secondary',
                  onClick: this.handleClose }, 'Cancel'))))));






  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4705:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ForkCollectionModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_collections_ForkCollectionModal__ = __webpack_require__(4706);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_base_LoadingIndicator__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__components_messaging_Alert__ = __webpack_require__(1490);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__modules_model_event__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__services_WorkspaceSwitchService__ = __webpack_require__(659);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__modules_services_AnalyticsService__ = __webpack_require__(16);
var _class;













const defaultState = {
  isLoading: false,
  isOpen: false,
  hasError: false,
  forkLabel: '',
  collectionUid: null,
  selectedWorkspace: '' };let



ForkCollectionModalContainer = Object(__WEBPACK_IMPORTED_MODULE_1_mobx_react__["a" /* observer */])(_class = class ForkCollectionModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = defaultState;

    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleForkLabelChange = this.handleForkLabelChange.bind(this);
    this.handleSelectedWorkspaceChange = this.handleSelectedWorkspaceChange.bind(this);
    this.handleForkCollection = this.handleForkCollection.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('showForkCollectionModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showForkCollectionModal', this.handleOpen);
  }

  handleClose() {
    this.setState(defaultState);
  }

  handleOpen(uid) {
    if (!Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('CurrentUserStore').isLoggedIn) {
      pm.mediator.trigger('showSignInModal', {
        type: 'fork',
        origin: 'fork_collection_modal' });

      return;
    }

    this.setState({
      isOpen: true,
      selectedWorkspace: Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('ActiveWorkspaceStore').id,
      collectionUid: uid });

  }

  handleError() {
    this.setState({
      hasError: true,
      isLoading: false });

  }

  handleSelectedWorkspaceChange(selectedWorkspace) {
    this.setState({ selectedWorkspace });
  }

  handleForkLabelChange(value) {
    this.setState({
      forkLabel: value });

  }

  handleForkCollection() {
    this.setState({
      isLoading: true,
      hasError: false });


    let forkCollectionEvent = Object(__WEBPACK_IMPORTED_MODULE_9__modules_model_event__["a" /* createEvent */])('createOnSync', 'forkedcollection', {
      model: 'forkedcollection',
      forkedcollection: {
        id: this.state.collectionUid,
        forkLabel: this.state.forkLabel },

      workspace: this.state.selectedWorkspace });


    return Object(__WEBPACK_IMPORTED_MODULE_8__modules_pipelines_user_action__["a" /* default */])(forkCollectionEvent).
    then(response => {
      if (!_.isEmpty(_.get(response, 'error'))) {
        this.handleError();
        pm.logger.warn('ForkCollectionModalContainer~handleForkCollection: Error in forking collection', response.error);

        return;
      }

      // Add analytics event to show that fork is successful
      __WEBPACK_IMPORTED_MODULE_11__modules_services_AnalyticsService__["a" /* default */].addEventV2({
        category: 'collection',
        action: 'successful_fork',
        label: 'collection_sidebar' });


      __WEBPACK_IMPORTED_MODULE_10__services_WorkspaceSwitchService__["a" /* default */].switchWorkspace(this.state.selectedWorkspace);
      this.handleClose();
    }).
    catch(err => {
      this.handleError();
      pm.logger.warn('ForkCollectionModalContainer~handleForkCollection: Error in pipeline for forking collection', err);
      return;
    });
  }

  render() {
    const permissionStore = Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('PermissionStore'),
    canFork = this.state.selectedWorkspace && permissionStore.can('addCollection', 'workspace', this.state.selectedWorkspace),
    invalidInput = !this.state.forkLabel || !this.state.selectedWorkspace || this.state.isLoading || !this.state.forkLabel.trim(),
    disableForkButton = invalidInput || !canFork;

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_Modals__["a" /* Modal */], {
          className: 'fork-collection-modal',
          isOpen: this.state.isOpen,
          onRequestClose: this.handleClose },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_Modals__["d" /* ModalHeader */], null, 'FORK COLLECTION'),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_Modals__["b" /* ModalContent */], { className: 'fork-collection-modal__contents' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_collections_ForkCollectionModal__["a" /* default */], {
            selectedWorkspaceId: this.state.selectedWorkspace,
            onChangeWorkspace: this.handleSelectedWorkspaceChange,
            onForkCollection: this.handleForkCollection,
            onForkLabelChange: this.handleForkLabelChange }),

          this.state.hasError &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_messaging_Alert__["a" /* default */], {
            message: 'Something went wrong while forking collection, please try again',
            type: 'error',
            isDismissable: false })),



        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_Modals__["c" /* ModalFooter */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Buttons__["a" /* Button */], {
              className: 'button-large',
              type: 'primary',
              onClick: this.handleForkCollection,
              disabled: disableForkButton },

            this.state.isLoading ? __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_LoadingIndicator__["a" /* default */], null) : 'Fork collection'),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Buttons__["a" /* Button */], {
              type: 'secondary',
              onClick: this.handleClose }, 'Cancel'))));






  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4706:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ForkCollectionModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_prop_types__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_prop_types___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_prop_types__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Dropdowns__ = __webpack_require__(31);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_Icons_TeamIcon__ = __webpack_require__(1491);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__stores_get_store__ = __webpack_require__(5);
var _class;







let


ForkCollectionModal = Object(__WEBPACK_IMPORTED_MODULE_2_mobx_react__["a" /* observer */])(_class = class ForkCollectionModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.handleSubmit = this.handleSubmit.bind(this);
    this.handleClose = this.handleClose.bind(this);
  }

  handleClose() {
    this.props.onClose && this.props.onClose();
  }

  handleSubmit() {
    this.props.onSubmit && this.props.onSubmit();
  }

  render() {
    const workspaceStore = Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('WorkspaceStore'),
    workspaces = workspaceStore.values;

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'fork-collection' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, 'Forking a collection creates a new collection with a reference to the original, allowing you to merge or pull changes between them.'),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'fork-collection__input-group' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'fork-collection__input-group__label' }, 'Fork label'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Inputs__["b" /* Input */], {
            className: 'fork-collection__input-group__input',
            inputStyle: 'box',
            value: this.props.name,
            onChange: this.props.onForkLabelChange,
            onSubmit: this.props.onForkCollection }),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'fork-collection__input-group__helptext' }, 'This will be used to identify this fork, and distinguish it from the parent and other related collections.'),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'fork-collection__input-group__label' }, 'Add this to a workspace'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Dropdowns__["a" /* Dropdown */], {
              className: 'fork-collection-dropdown',
              fullWidth: true,
              onSelect: this.props.onChangeWorkspace },

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Dropdowns__["b" /* DropdownButton */], {
                size: 'small',
                type: 'secondary' },

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Buttons__["a" /* Button */], null,
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'workspace-name' }, (workspaceStore.find(this.props.selectedWorkspaceId) || {}).name))),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Dropdowns__["c" /* DropdownMenu */], { fluid: true },

              _.map(workspaces, workspace => {
                return (
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Dropdowns__["d" /* MenuItem */], { key: workspace.id, refKey: workspace.id },
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, workspace.name),

                    workspace.type === 'team' &&
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Icons_TeamIcon__["a" /* default */], null)));



              }))),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'fork-collection__input-group__helptext' }, 'You can always add the fork to another workspace later.'))));





  }}) || _class;


ForkCollectionModal.propTypes = {
  selectedWorkspace: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.string.isRequired,
  onSubmit: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.func,
  onClose: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.func,
  onChangeWorkspace: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.func,
  onForkLabelChange: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.func };


ForkCollectionModal.defaultProps = {
  selectedWorkspace: '' };
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4707:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return DeleteCollectionModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_collections_DeleteConfirmationModal__ = __webpack_require__(3517);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__modules_model_event__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_mobx_react__ = __webpack_require__(11);
var _class;






let

DeleteCollectionModalContainer = Object(__WEBPACK_IMPORTED_MODULE_6_mobx_react__["a" /* observer */])(_class = class DeleteCollectionModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      id: null,
      meta: null,
      isDisabled: false };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleConfirm = this.handleConfirm.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('showCollectionDeleteModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showCollectionDeleteModal', this.handleOpen);
  }

  handleOpen(collectionId, { subscriberCount, published, origin }, callback) {
    let collection = Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('CollectionStore').find(collectionId);

    if (!collection) {
      return;
    }
    this.callback = callback;
    this.setState({
      isOpen: true,
      id: collection.id,
      origin: origin,
      meta: {
        name: collection.name,
        subscriberCount: subscriberCount,
        published: published } },

    () => {
      __WEBPACK_IMPORTED_MODULE_3__modules_services_AnalyticsService__["a" /* default */].addEvent('collection', 'initiate_delete', origin);

      _.invoke(this, 'keymapRef.focus');
    });
  }

  handleClose() {
    this.callback = null;
    this.setState({
      isOpen: false,
      id: null,
      meta: null,
      isDisabled: false },
    () => {
      pm.mediator.trigger('focusSidebar');
    });
  }

  handleConfirm() {
    this.setState({ isDisabled: true });
    let deleteCollectionEvent = {
      name: 'delete',
      namespace: 'collection',
      data: { id: this.state.id } };


    Object(__WEBPACK_IMPORTED_MODULE_2__modules_pipelines_user_action__["a" /* default */])(deleteCollectionEvent).
    then(response => {
      if (!_.isEmpty(_.get(response, 'error'))) {
        pm.logger.error('Error in deleting collection', response.error);
        return;
      }

      this.callback && this.callback();
      pm.mediator.trigger('hideCollectionBrowser', this.handleClose);

      __WEBPACK_IMPORTED_MODULE_3__modules_services_AnalyticsService__["a" /* default */].addEvent('collection', 'delete', this.state.origin);
      Object(__WEBPACK_IMPORTED_MODULE_5__modules_model_event__["b" /* findEvents */])(response.response, { name: 'deleted', namespace: 'variablesession' })[0] &&
      __WEBPACK_IMPORTED_MODULE_3__modules_services_AnalyticsService__["a" /* default */].addEvent('session', 'user_delete', 'collection');

      this.handleClose();
    }).
    catch(err => {
      this.setState({ isDisabled: false });
      pm.toasts.error('Unable to delete collection');
      pm.logger.error('Error in pipeline for deleting collection', err);
    });
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_collections_DeleteConfirmationModal__["a" /* default */], {
        preventFocusReset: true,
        isDisabled: this.state.isDisabled,
        primaryAction: this.state.isDisabled ? 'Deleting' : 'Delete',
        className: 'delete-collection-confirmation-modal',
        entity: 'COLLECTION',
        isOpen: this.state.isOpen,
        keymapRef: ref => {this.keymapRef = ref;},
        meta: this.state.meta,
        onConfirm: this.handleConfirm,
        onRequestClose: this.handleClose }));


  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4708:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ExportCollectionModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_collections_ExportCollectionModal__ = __webpack_require__(4709);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__services_conversion_promisifiedConverter__ = __webpack_require__(655);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__modules_controllers_CollectionController__ = __webpack_require__(34);
var _class;



let


ExportCollectionModalContainer = __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default()(_class = class ExportCollectionModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      id: null,
      name: '',
      format: pm.settings.getSetting('collectionExportFormat') || 'v2.1' };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleSubmit = this.handleSubmit.bind(this);
    this.handleFormatChange = this.handleFormatChange.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('showExportCollectionModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showExportCollectionModal', this.handleOpen);
  }

  handleOpen(id) {
    if (!id) {
      return;
    }

    __WEBPACK_IMPORTED_MODULE_4__modules_controllers_CollectionController__["a" /* default */].getCollection({ id: id }).then(collection => {
      if (!collection) {
        return;
      }

      this.setState({
        isOpen: true,
        id: id,
        name: collection.name,
        format: pm.settings.getSetting('collectionExportFormat') || 'v2.1' },
      () => {
        this.keymapRef && this.keymapRef.focus();
      });
    });
  }

  handleClose() {
    this.setState({
      isOpen: false,
      id: null,
      name: '',
      format: 'v2.1' });

  }

  handleFormatChange(format) {
    pm.settings.setSetting('collectionExportFormat', format || 'v2.1');
    this.setState({ format: format });
  }

  async handleSubmit() {
    let converter = await Object(__WEBPACK_IMPORTED_MODULE_3__services_conversion_promisifiedConverter__["a" /* default */])(),
    criteria = { id: this.state.id };

    if (this.state.format === 'v1') {
      converter.saveEntity(criteria, { type: 'collection' });
    } else
    if (this.state.format === 'v2') {
      converter.saveEntity(criteria, {
        type: 'collection',
        inputVersion: '1.0.0',
        outputVersion: '2.0.0' });

    } else
    if (this.state.format === 'v2.1') {
      converter.saveEntity(criteria, {
        type: 'collection',
        inputVersion: '1.0.0',
        outputVersion: '2.1.0' });

    }
    this.handleClose();
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_collections_ExportCollectionModal__["a" /* default */], {
        isOpen: this.state.isOpen,
        name: this.state.name,
        format: this.state.format,
        onFormatChange: this.handleFormatChange,
        onRequestClose: this.handleClose,
        onSubmit: this.handleSubmit,
        keymapRef: ref => {return this.keymapRef = ref;} }));


  }}) || _class;

/***/ }),

/***/ 4709:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ExportCollectionModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_react_radio_group__ = __webpack_require__(1503);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_react_radio_group___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_react_radio_group__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_keymaps_KeyMaps__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__constants_AppUrlConstants__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__external_navigation_ExternalNavigationService__ = __webpack_require__(59);






let
ExportCollectionModal = class ExportCollectionModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = { uniqueName: Math.random().toString(36).substring(7) };

    this.handleLearnMoreClick = this.handleLearnMoreClick.bind(this);
  }

  getKeyMapHandlers() {
    return {
      'submit': pm.shortcuts.handle('submit', this.props.onSubmit),
      'select': pm.shortcuts.handle('select', this.props.onSubmit) };

  }

  getCustomStyles() {
    return { marginTop: '30vh' };
  }

  handleLearnMoreClick() {
    Object(__WEBPACK_IMPORTED_MODULE_6__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_5__constants_AppUrlConstants__["s" /* COLLECTION_V2_BLOG */]);
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Modals__["a" /* Modal */], {
          isOpen: this.props.isOpen,
          onRequestClose: this.props.onRequestClose,
          className: 'export-collection-modal',
          customStyles: this.getCustomStyles() },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Modals__["d" /* ModalHeader */], null, 'EXPORT COLLECTION'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_keymaps_KeyMaps__["a" /* default */], { keyMap: pm.shortcuts.getShortcuts(), handlers: this.getKeyMapHandlers(), ref: this.props.keymapRef },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'export-collection-modal-content-wrapper' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'export-collection-modal__message' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'export-collection-modal__message__collection-name' }, ' ', this.props.name, ' '),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, ' will be exported as a JSON file. Export as:')),

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2_react_radio_group__["RadioGroup"], {
                  name: this.state.uniqueName,
                  selectedValue: this.props.format,
                  onChange: this.props.onFormatChange },

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'export-collection-modal__choices' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'export-collection-modal__choices-item' },
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('label', { className: 'export-collection-modal__choice__label' },
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2_react_radio_group__["Radio"], {
                        value: 'v1',
                        className: 'export-collection-modal__choice__button radio-button' }), 'Collection v1 (deprecated)')),




                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'export-collection-modal__choices-item' },
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('label', { className: 'export-collection-modal__choice__label' },
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2_react_radio_group__["Radio"], {
                        value: 'v2',
                        className: 'export-collection-modal__choice__button radio-button' }), 'Collection v2')),




                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'export-collection-modal__choices-item' },
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('label', { className: 'export-collection-modal__choice__label' },
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2_react_radio_group__["Radio"], {
                        value: 'v2.1',
                        className: 'export-collection-modal__choice__button radio-button' }), 'Collection v2.1 (recommended)')))),






              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'export-collection-modal__subtext' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'export-collection-modal__subtext__learn-more', onClick: this.handleLearnMoreClick }, 'Learn more about collection formats'))))),




        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Modals__["c" /* ModalFooter */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
              type: 'primary',
              onClick: this.props.onSubmit }, 'Export'),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
              type: 'secondary',
              onClick: this.props.onRequestClose }, 'Cancel'))));




  }};

/***/ }),

/***/ 4710:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddFolderModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_mobx__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_postman_collection__ = __webpack_require__(74);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_postman_collection___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_postman_collection__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__components_base_keymaps_KeyMaps__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__variables_CollectionVariablesProvider__ = __webpack_require__(973);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__components_collections_folder_FolderModalTabs__ = __webpack_require__(3944);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__components_collections_folder_FolderModalTabContents__ = __webpack_require__(3945);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__components_collections_folder_FolderModalTabContent__ = __webpack_require__(3946);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__components_collections_folder_FolderPreRequestScripts__ = __webpack_require__(3947);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__components_collections_folder_FolderTests__ = __webpack_require__(3948);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__components_collections_folder_FolderConfigurationList__ = __webpack_require__(3949);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__components_collections_folder_FolderDescription__ = __webpack_require__(3950);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__FolderAuthEditorContainer__ = __webpack_require__(3951);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__utils_util__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_20__utils_authUtil__ = __webpack_require__(137);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_21__utils_configurationsUtil__ = __webpack_require__(3746);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_22__constants_FolderConstants__ = __webpack_require__(982);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_23__constants_AuthConstants__ = __webpack_require__(219);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_24_util__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_24_util___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_24_util__);


























let

AddFolderModalContainer = class AddFolderModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      description: '',
      name: '',
      auth: null,
      savedAuths: null,
      preRequestScript: null,
      tests: null,
      nameError: false,
      collectionName: '',
      collection: '',
      parentFolder: false,
      inheritedAuth: null,
      activeTab: __WEBPACK_IMPORTED_MODULE_22__constants_FolderConstants__["c" /* FOLDER_DESCRIPTION */],
      inheritedConfigParent: null,
      protocolProfileBehavior: {} };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleSubmit = this.handleSubmit.bind(this);

    this.handleUseOauth2Token = this.handleUseOauth2Token.bind(this),
    this.handleTabSelect = this.handleTabSelect.bind(this);
    this.handleNameChange = this.handleNameChange.bind(this);
    this.handleDescriptionChange = this.handleDescriptionChange.bind(this);
    this.handleBeautifyPreRequestScript = this.handleBeautifyPreRequestScript.bind(this);
    this.handleBeautifyTests = this.handleBeautifyTests.bind(this);
    this.handlePreRequestScriptChange = this.handlePreRequestScriptChange.bind(this);
    this.handleTestsChange = this.handleTestsChange.bind(this);
    this.handleAuthTypeSelect = this.handleAuthTypeSelect.bind(this);
    this.handleFieldChange = this.handleFieldChange.bind(this);
    this.updateProtocolProfileBehavior = this.updateProtocolProfileBehavior.bind(this);
    this.removeKeyFromProtocolProfileBehavior = this.removeKeyFromProtocolProfileBehavior.bind(this);

    this.updateSavedAuths = _.debounce(__WEBPACK_IMPORTED_MODULE_20__utils_authUtil__["g" /* updateSavedAuths */], 1000);
  }

  componentWillMount() {
    pm.mediator.on('showAddFolderModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showAddFolderModal', this.handleOpen);
  }

  handleOpen(collectionId, folderId = null) {
    let collection, folder;

    if (collectionId) {
      collection = Object(__WEBPACK_IMPORTED_MODULE_19__stores_get_store__["getStore"])('CollectionStore').find(collectionId);
    }

    if (folderId) {
      let obsFolder = Object(__WEBPACK_IMPORTED_MODULE_19__stores_get_store__["getStore"])('FolderStore').find(folderId);
      folder = {
        id: obsFolder.id,
        name: obsFolder.name };

    }

    this.setState({
      isOpen: true,
      collectionName: collection.name,
      collection: collection,
      parentFolder: folder,
      description: '',
      auth: null,
      preRequestScript: '',
      tests: '',
      protocolProfileBehavior: {} },
    () => {
      this.folderName && this.folderName.focus();
      Object(__WEBPACK_IMPORTED_MODULE_20__utils_authUtil__["d" /* getSavedAuths */])(auths => {
        this.setState({ savedAuths: auths });
        this.setInheritedAuth();
        this.setInheritedConfigParent();
      });
    });
  }

  handleClose() {
    this.setState({ isOpen: false }, () => {
      pm.mediator.trigger('focusSidebar');
    });
    this.clearModal();
  }

  clearModal() {
    this.setState({
      name: '',
      description: '',
      collectionName: '',
      collection: '',
      parentFolder: false,
      inheritedAuth: null,
      nameError: false,
      inheritedConfigParent: null,
      protocolProfileBehavior: {} });

  }


  handleDescriptionChange(value) {
    this.setState({ description: value });
  }

  handleNameChange(value) {
    this.setState({ name: value });
  }

  handlePreRequestScriptChange(value) {
    this.setState({ preRequestScript: value });
  }

  handleTestsChange(value) {
    this.setState({ tests: value });
  }

  handleAuthTypeSelect(authType) {
    if (_.get(this.state, 'auth.type') === authType) {
      return;
    }

    let auth = { type: authType };

    if (authType !== __WEBPACK_IMPORTED_MODULE_23__constants_AuthConstants__["v" /* AUTH_TYPE_RAW_NO_AUTH */]) {
      auth[authType] = _.get(this.state, ['savedAuths', authType], Object(__WEBPACK_IMPORTED_MODULE_20__utils_authUtil__["b" /* getDefaultAuthProps */])(authType));
    }

    if (authType === __WEBPACK_IMPORTED_MODULE_23__constants_AuthConstants__["u" /* AUTH_TYPE_RAW_INHERIT */]) {
      this.setInheritedAuth();
    }

    this.setState({ auth: authType === __WEBPACK_IMPORTED_MODULE_23__constants_AuthConstants__["u" /* AUTH_TYPE_RAW_INHERIT */] ? null : _.assign({}, auth) });

  }

  setInheritedAuth() {
    let collection = this.state.collection,
    parentFolder = this.state.parentFolder;
    if (!collection) {
      return;
    }

    if (!_.isEmpty(collection)) {
      let entityId = parentFolder ? parentFolder.id : collection.id,
      entityType = parentFolder ? 'folder' : 'collection',
      inheritedAuth = Object(__WEBPACK_IMPORTED_MODULE_20__utils_authUtil__["c" /* getInheritedAuth */])(collection, entityId, entityType);
      this.setState({ inheritedAuth });
    }
  }

  setInheritedConfigParent() {
    let collection = this.state.collection,
    parentFolder = this.state.parentFolder;

    if (!_.isEmpty(collection)) {
      let entityId = parentFolder ? parentFolder.id : collection.id,
      inheritedConfigParent = Object(__WEBPACK_IMPORTED_MODULE_21__utils_configurationsUtil__["b" /* getFolderInheritedState */])(collection, entityId, 'add');

      this.setState({ inheritedConfigParent });
    }
  }

  setValue(authType, k, v) {
    return Object(__WEBPACK_IMPORTED_MODULE_20__utils_authUtil__["e" /* setAuthValue */])(this.state.auth, authType, k, v);
  }

  handleFieldChange(authType, key, value) {

    let newAuth = this.setValue(authType, key, value),
    authObj = { type: authType };

    authObj[authType] = newAuth;

    this.setState({
      auth: _.assign({}, authObj),
      savedAuths: _.assign({}, this.state.savedAuths, _.omit(authObj, ['type'])) },
    () => {
      this.updateSavedAuths(_.omit(this.state.savedAuths, ['type']));
    });
  }

  handleUseOauth2Token(token) {
    let newAuth = Object(__WEBPACK_IMPORTED_MODULE_20__utils_authUtil__["f" /* setAuthValues */])(this.state.auth, 'oauth2', {
      accessToken: token.access_token,
      tokenType: token.token_type }),

    authObj = { type: 'oauth2' };

    authObj['oauth2'] = newAuth;

    this.setState({
      auth: _.assign({}, authObj),
      savedAuths: _.assign({}, this.state.savedAuths, _.omit(authObj, ['type'])) },
    () => {
      this.updateSavedAuths(_.omit(this.state.savedAuths, ['type']));
    });
  }

  handleSubmit() {
    if (_.isEmpty(this.state.name.trim())) {
      this.setState({ nameError: true });
      return;
    }

    let collection = this.state.collection;

    if (!collection) {
      this.handleClose();
      return;
    }

    let sdkEvents = [],
    folderData = _.pick(this.state, [
    'name',
    'description',
    'auth']),

    parentFolder = this.state.parentFolder;

    folderData.protocolProfileBehavior = this.state.protocolProfileBehavior;

    // Events to the folder
    !_.isEmpty(this.state.preRequestScript) && sdkEvents.push(new __WEBPACK_IMPORTED_MODULE_3_postman_collection__["Event"]({ listen: 'prerequest', script: this.state.preRequestScript }));
    !_.isEmpty(this.state.tests) && sdkEvents.push(new __WEBPACK_IMPORTED_MODULE_3_postman_collection__["Event"]({ listen: 'test', script: this.state.tests }));

    let eventsJSON = new __WEBPACK_IMPORTED_MODULE_3_postman_collection__["EventList"]({}, sdkEvents).toJSON();

    !_.isEmpty(eventsJSON) && (folderData.events = eventsJSON);

    // added collection information
    folderData.collection = collection.id;

    let addFolderEvent = {
      name: 'create_deep',
      namespace: 'folder',
      data: {
        folder: _.assign(folderData, { id: __WEBPACK_IMPORTED_MODULE_17__utils_util__["a" /* default */].guid() }),
        target: {
          model: parentFolder ? 'folder' : 'collection',
          modelId: parentFolder ? parentFolder.id : folderData.collection } } };




    Object(__WEBPACK_IMPORTED_MODULE_18__modules_pipelines_user_action__["a" /* default */])(addFolderEvent).
    then(response => {
      if (!_.isEmpty(_.get(response, 'error'))) {
        pm.logger.error('Error in creating folder', response.error);
        return;
      }

      this.handleClose();
    }).
    catch(err => {
      pm.logger.error('Error in pipeline for creating folder', err);
    });
  }

  handleTabSelect(id) {
    if (id === this.state.activeTab) {
      return;
    }

    this.setState({ activeTab: id });
  }

  handleBeautifyPreRequestScript() {
    this.handlePreRequestScriptChange(__WEBPACK_IMPORTED_MODULE_17__utils_util__["a" /* default */].beautifyJs(this.state.preRequestScript));
  }

  handleBeautifyTests() {
    this.handleTestsChange(__WEBPACK_IMPORTED_MODULE_17__utils_util__["a" /* default */].beautifyJs(this.state.tests));
  }

  getCustomStyles() {
    return {
      marginTop: '8vh',
      width: '800px',
      height: '88vh' };

  }

  getKeyMapHandlers() {
    return { 'submit': pm.shortcuts.handle('submit', this.handleSubmit) };
  }

  updateProtocolProfileBehavior(key, value) {
    this.setState(prevState => (
    { protocolProfileBehavior: _.set(prevState.protocolProfileBehavior, [key], value) }));

  }

  removeKeyFromProtocolProfileBehavior(key) {
    this.setState(prevState => (
    { protocolProfileBehavior: _.omit(prevState.protocolProfileBehavior, [key]) }));

  }

  render() {
    let title = this.state.parentFolder ? _.get(this.state, 'parentFolder.name') : _.get(this.state, 'collectionName');

    /**
                                                                                                                         * @todo: Remove usage of feature flag - FOLDER_CONFIGURATIONS_ENABLED,
                                                                                                                         *        once sync supports protocolProfileBehavior for collection and folders
                                                                                                                         */
    const FOLDER_CONFIGURATIONS_ENABLED = Object(__WEBPACK_IMPORTED_MODULE_19__stores_get_store__["getStore"])('FeatureFlagsStore').isEnabled('collectionAndFolderConfigurations');

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__components_base_Modals__["a" /* Modal */], {
          isOpen: this.state.isOpen,
          onRequestClose: this.handleClose,
          customStyles: this.getCustomStyles(),
          className: 'collection-modal' },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__components_base_Modals__["d" /* ModalHeader */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-header' }, 'ADD FOLDER TO ',
            _.toUpper(title))),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__components_base_Modals__["b" /* ModalContent */], { className: 'collection-modal-content' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_base_keymaps_KeyMaps__["a" /* default */], { keyMap: pm.shortcuts.getShortcuts(), handlers: this.getKeyMapHandlers() },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-content-container' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-name-container' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'field-label' }, 'Name'),


                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_Inputs__["b" /* Input */], {
                  type: 'text',
                  inputStyle: 'box',
                  value: this.state.name,
                  error: this.state.nameError,
                  placeholder: 'Folder Name',
                  onChange: this.handleNameChange,
                  onSubmit: this.handleSubmit,
                  className: 'collection-modal-name-input',
                  ref: input => this.folderName = input }),

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_9__components_collections_folder_FolderModalTabs__["a" /* default */], {
                  onSelect: this.handleTabSelect,
                  activeTab: this.state.activeTab,
                  isAuthSelected: !_.isEmpty(this.state.auth),
                  isPreRequestScriptAvailable: !!this.state.preRequestScript,
                  isTestsAvailable: !!this.state.tests })),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__variables_CollectionVariablesProvider__["a" /* default */], { collectionId: _.get(this.state, 'collection.id') },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__components_collections_folder_FolderModalTabContents__["a" /* default */], {
                    activeKey: this.state.activeTab },

                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_11__components_collections_folder_FolderModalTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_22__constants_FolderConstants__["c" /* FOLDER_DESCRIPTION */] },
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_15__components_collections_folder_FolderDescription__["a" /* default */], {
                      description: this.state.description,
                      onChange: this.handleDescriptionChange })),


                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_11__components_collections_folder_FolderModalTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_22__constants_FolderConstants__["a" /* FOLDER_AUTHORIZATION */] },
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_16__FolderAuthEditorContainer__["a" /* default */], {
                      auth: this.state.auth,
                      collectionId: _.get(this.state, 'collection.id'),
                      inheritedAuth: this.state.inheritedAuth,
                      onUseToken: this.handleUseOauth2Token,
                      handleAuthTypeSelect: this.handleAuthTypeSelect,
                      handleFieldChange: this.handleFieldChange,
                      handleAuthAnalytics: _.noop })),


                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_11__components_collections_folder_FolderModalTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_22__constants_FolderConstants__["d" /* FOLDER_PRE_REQUEST_SCRIPTS */] },
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_12__components_collections_folder_FolderPreRequestScripts__["a" /* default */], {
                      value: this.state.preRequestScript,
                      onBeautify: this.handleBeautifyPreRequestScript,
                      onChange: this.handlePreRequestScriptChange })),


                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_11__components_collections_folder_FolderModalTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_22__constants_FolderConstants__["e" /* FOLDER_TESTS */] },
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_13__components_collections_folder_FolderTests__["a" /* default */], {
                      value: this.state.tests,
                      onBeautify: this.handleBeautifyTests,
                      onChange: this.handleTestsChange })),


                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_11__components_collections_folder_FolderModalTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_22__constants_FolderConstants__["b" /* FOLDER_CONFIGURATIONS */] },

                    FOLDER_CONFIGURATIONS_ENABLED &&
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_14__components_collections_folder_FolderConfigurationList__["a" /* default */], {
                      configuration: this.state.protocolProfileBehavior,
                      updateProtocolProfileBehavior: this.updateProtocolProfileBehavior,
                      removeKeyFromProtocolProfileBehavior: this.removeKeyFromProtocolProfileBehavior,
                      inheritedConfigParent: this.state.inheritedConfigParent }))))))),








        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__components_base_Modals__["c" /* ModalFooter */], { className: 'collection-modal-footer' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_Buttons__["a" /* Button */], {
              type: 'primary',
              onClick: this.handleSubmit }, 'Create'),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_Buttons__["a" /* Button */], {
              type: 'secondary',
              onClick: this.handleClose }, 'Cancel'))));




  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4711:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return EditFolderModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_postman_collection__ = __webpack_require__(74);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_postman_collection___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_postman_collection__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_base_keymaps_KeyMaps__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__variables_CollectionVariablesProvider__ = __webpack_require__(973);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__components_collections_folder_FolderModalTabs__ = __webpack_require__(3944);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__components_collections_folder_FolderModalTabContents__ = __webpack_require__(3945);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__components_collections_folder_FolderModalTabContent__ = __webpack_require__(3946);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__components_collections_folder_FolderPreRequestScripts__ = __webpack_require__(3947);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__components_collections_folder_FolderTests__ = __webpack_require__(3948);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__components_collections_folder_FolderDescription__ = __webpack_require__(3950);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__FolderAuthEditorContainer__ = __webpack_require__(3951);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__utils_util__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__modules_controllers_CollectionController__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__utils_authUtil__ = __webpack_require__(137);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__utils_configurationsUtil__ = __webpack_require__(3746);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_20__constants_FolderConstants__ = __webpack_require__(982);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_21__constants_AuthConstants__ = __webpack_require__(219);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_22__components_collections_folder_FolderConfigurationList__ = __webpack_require__(3949);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_23__stores_get_store__ = __webpack_require__(5);

























let

EditFolderModalContainer = class EditFolderModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      description: '',
      name: '',
      auth: null,
      savedAuths: null,
      preRequestScript: null,
      tests: null,
      events: null,
      nameError: false,
      collectionName: '',
      collection: '',
      inheritedAuth: null,
      activeTab: __WEBPACK_IMPORTED_MODULE_20__constants_FolderConstants__["c" /* FOLDER_DESCRIPTION */],
      inheritedConfigParent: null,
      protocolProfileBehavior: {} };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleSubmit = this.handleSubmit.bind(this);

    this.handleTabSelect = this.handleTabSelect.bind(this);
    this.handleNameChange = this.handleNameChange.bind(this);
    this.handleDescriptionChange = this.handleDescriptionChange.bind(this);
    this.handleBeautifyPreRequestScript = this.handleBeautifyPreRequestScript.bind(this);
    this.handleBeautifyTests = this.handleBeautifyTests.bind(this);
    this.handlePreRequestScriptChange = this.handlePreRequestScriptChange.bind(this);
    this.handleTestsChange = this.handleTestsChange.bind(this);
    this.handleVariableValuesChange = this.handleVariableValuesChange.bind(this);
    this.handleAuthTypeSelect = this.handleAuthTypeSelect.bind(this);
    this.handleFieldChange = this.handleFieldChange.bind(this);
    this.handleUseOauth2Token = this.handleUseOauth2Token.bind(this);
    this.setPRScriptAndTests = this.setPRScriptAndTests.bind(this);
    this.updateProtocolProfileBehavior = this.updateProtocolProfileBehavior.bind(this);
    this.removeKeyFromProtocolProfileBehavior = this.removeKeyFromProtocolProfileBehavior.bind(this);

    this.updateSavedAuths = _.debounce(__WEBPACK_IMPORTED_MODULE_18__utils_authUtil__["g" /* updateSavedAuths */], 1000);
  }

  componentWillMount() {
    pm.mediator.on('showEditFolderModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showEditFolderModal', this.handleOpen);
  }

  handleOpen(folderId, activeTab = __WEBPACK_IMPORTED_MODULE_20__constants_FolderConstants__["c" /* FOLDER_DESCRIPTION */]) {
    __WEBPACK_IMPORTED_MODULE_17__modules_controllers_CollectionController__["a" /* default */].getFolder({ id: folderId }).then(folder => {
      this.setState({
        isOpen: true,
        description: folder.description,
        name: folder.name,
        id: folder.id,
        collection: folder.collection,
        auth: folder.auth || null,
        events: folder.events,
        activeTab: activeTab,
        protocolProfileBehavior: _.get(folder, 'protocolProfileBehavior', {}) },
      () => {
        this.folderName && this.folderName.focus();
        this.setPRScriptAndTests(folder);
        this.setInheritedAuth();
        this.setInheritedConfigParent();
        Object(__WEBPACK_IMPORTED_MODULE_18__utils_authUtil__["d" /* getSavedAuths */])(auths => {
          this.setState({ savedAuths: auths });
        });
      });
    });
  }

  setPRScriptAndTests(folder) {
    let sdkEvents = new __WEBPACK_IMPORTED_MODULE_2_postman_collection__["EventList"]({}, Array.isArray(folder.events) ? folder.events : []),
    preRequestEvent = _.head(sdkEvents.listenersOwn('prerequest')),
    testEvent = _.head(sdkEvents.listenersOwn('test'));

    this.setState({
      preRequestScript: !_.isEmpty(preRequestEvent) ? _.invoke(preRequestEvent, 'script.toSource') : '',
      tests: !_.isEmpty(testEvent) ? _.invoke(testEvent, 'script.toSource') : '' });

  }

  handleClose() {
    this.setState({ isOpen: false }, () => {
      pm.mediator.trigger('focusSidebar');
    });
    this.clearModal();
  }

  clearModal() {
    this.setState({
      name: '',
      description: '',
      collectionName: '',
      collection: '',
      auth: null,
      preRequestScript: null,
      tests: null,
      events: null,
      inheritedAuth: null,
      nameError: false,
      inheritedConfigParent: null,
      protocolProfileBehavior: {} });

  }


  handleDescriptionChange(value) {
    this.setState({ description: value });
  }

  handleNameChange(value) {
    this.setState({ name: value });
  }

  handlePreRequestScriptChange(value) {
    this.setState({ preRequestScript: value });
  }

  handleBeautifyPreRequestScript() {
    this.handlePreRequestScriptChange(__WEBPACK_IMPORTED_MODULE_15__utils_util__["a" /* default */].beautifyJs(this.state.preRequestScript));
  }

  handleBeautifyTests() {
    this.handleTestsChange(__WEBPACK_IMPORTED_MODULE_15__utils_util__["a" /* default */].beautifyJs(this.state.tests));
  }

  handleTestsChange(value) {
    this.setState({ tests: value });
  }

  handleVariableValuesChange(values, done) {
    this.setState({ variables: values }, () => {
      if (_.isFunction(done)) {
        done();
      }
    });
  }

  handleAuthTypeSelect(authType) {
    if (_.get(this.state, 'auth.type') === authType) {
      return;
    }

    let auth = { type: authType };

    if (authType !== __WEBPACK_IMPORTED_MODULE_21__constants_AuthConstants__["v" /* AUTH_TYPE_RAW_NO_AUTH */]) {
      auth[authType] = _.get(this.state, ['savedAuths', authType], Object(__WEBPACK_IMPORTED_MODULE_18__utils_authUtil__["b" /* getDefaultAuthProps */])(authType));
    }

    if (authType === __WEBPACK_IMPORTED_MODULE_21__constants_AuthConstants__["u" /* AUTH_TYPE_RAW_INHERIT */]) {
      this.setInheritedAuth();
    }

    this.setState({ auth: authType === __WEBPACK_IMPORTED_MODULE_21__constants_AuthConstants__["u" /* AUTH_TYPE_RAW_INHERIT */] ? null : _.assign({}, auth) });
  }

  setInheritedAuth() {
    __WEBPACK_IMPORTED_MODULE_17__modules_controllers_CollectionController__["a" /* default */].
    getCollection({ id: this.state.collection }, { populate: true }).
    then(collectionJSON => {
      if (!collectionJSON) {
        return;
      }

      if (!_.isEmpty(collectionJSON)) {
        let inheritedAuth = Object(__WEBPACK_IMPORTED_MODULE_18__utils_authUtil__["c" /* getInheritedAuth */])(collectionJSON, this.state.id, 'folder');
        this.setState({ inheritedAuth });
      }
    }).
    catch(e => {
      pm.logger.error('Error in fetching collection', e);
    });
  }

  setInheritedConfigParent() {
    __WEBPACK_IMPORTED_MODULE_17__modules_controllers_CollectionController__["a" /* default */].
    getCollection({ id: this.state.collection }, { populate: true }).
    then(collectionJSON => {
      if (!_.isEmpty(collectionJSON)) {
        let inheritedConfigParent = Object(__WEBPACK_IMPORTED_MODULE_19__utils_configurationsUtil__["b" /* getFolderInheritedState */])(collectionJSON, this.state.id, 'edit');
        this.setState({ inheritedConfigParent });
      }
    }).
    catch(e => {
      pm.logger.error('Error in fetching collection', e);
    });
  }

  setValue(authType, k, v) {
    return Object(__WEBPACK_IMPORTED_MODULE_18__utils_authUtil__["e" /* setAuthValue */])(this.state.auth, authType, k, v);
  }

  handleFieldChange(authType, key, value) {

    let newAuth = this.setValue(authType, key, value),
    authObj = { type: authType };

    authObj[authType] = newAuth;

    this.setState({
      auth: _.assign({}, authObj),
      savedAuths: _.assign({}, this.state.savedAuths, _.omit(authObj, ['type'])) },
    () => {
      this.updateSavedAuths(_.omit(this.state.savedAuths, ['type']));
    });
  }

  handleUseOauth2Token(token) {
    let newAuth = Object(__WEBPACK_IMPORTED_MODULE_18__utils_authUtil__["f" /* setAuthValues */])(this.state.auth, 'oauth2', {
      accessToken: token.access_token,
      tokenType: token.token_type }),

    authObj = { type: 'oauth2' };

    authObj['oauth2'] = newAuth;

    this.setState({
      auth: _.assign({}, authObj),
      savedAuths: _.assign({}, this.state.savedAuths, _.omit(authObj, ['type'])) },
    () => {
      this.updateSavedAuths(_.omit(this.state.savedAuths, ['type']));
    });
  }

  handleSubmit() {
    if (_.isEmpty(this.state.name.trim())) {
      this.setState({ nameError: true });
      return;
    }

    let sdkEvents = new __WEBPACK_IMPORTED_MODULE_2_postman_collection__["EventList"]({}, this.state.events),
    preRequestEvent = _.head(sdkEvents.listenersOwn('prerequest')),
    testEvent = _.head(sdkEvents.listenersOwn('test')),
    folderData = _.pick(this.state, [
    'id',
    'collection', // @todo, need to migrate the folder collectionId to collection
    'name',
    'description',
    'auth']);


    folderData.protocolProfileBehavior = this.state.protocolProfileBehavior;

    // Events to the folder
    if (_.isFunction(_.get(preRequestEvent, 'script.update'))) {
      preRequestEvent.script.update(this.state.preRequestScript);
    } else {
      preRequestEvent = new __WEBPACK_IMPORTED_MODULE_2_postman_collection__["Event"]({ listen: 'prerequest', script: this.state.preRequestScript });
    }

    if (_.isFunction(_.get(testEvent, 'script.update'))) {
      testEvent.script.update(this.state.tests);
    } else {
      testEvent = new __WEBPACK_IMPORTED_MODULE_2_postman_collection__["Event"]({ listen: 'test', script: this.state.tests });
    }

    folderData.events = new __WEBPACK_IMPORTED_MODULE_2_postman_collection__["EventList"]({}, [preRequestEvent, testEvent]).toJSON();

    let updateFolderEvent = {
      name: 'update',
      namespace: 'folder',
      data: folderData };


    Object(__WEBPACK_IMPORTED_MODULE_16__modules_pipelines_user_action__["a" /* default */])(updateFolderEvent).
    then(response => {
      if (!_.isEmpty(_.get(response, 'error'))) {
        pm.logger.error('Error in updating folder', response.error);
        return;
      }

      this.handleClose();
    }).
    catch(err => {
      pm.logger.error('Error in pipeline for updating folder', err);
    });
  }

  handleTabSelect(id) {
    if (id === this.state.activeTab) {
      return;
    }

    this.setState({ activeTab: id });
  }

  getCustomStyles() {
    return {
      marginTop: '8vh',
      width: '800px',
      height: '88vh' };

  }

  getKeyMapHandlers() {
    return { 'submit': pm.shortcuts.handle('submit', this.handleSubmit) };
  }

  updateProtocolProfileBehavior(key, value) {
    this.setState(prevState => (
    { protocolProfileBehavior: _.set(prevState.protocolProfileBehavior, [key], value) }));

  }

  removeKeyFromProtocolProfileBehavior(key) {
    this.setState(prevState => (
    { protocolProfileBehavior: _.omit(prevState.protocolProfileBehavior, [key]) }));

  }

  render() {
    /**
             * @todo: Remove usage of feature flag - FOLDER_CONFIGURATIONS_ENABLED,
             *        once sync supports protocolProfileBehavior for collection and folders
             */
    const FOLDER_CONFIGURATIONS_ENABLED = Object(__WEBPACK_IMPORTED_MODULE_23__stores_get_store__["getStore"])('FeatureFlagsStore').isEnabled('collectionAndFolderConfigurations');

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_base_Modals__["a" /* Modal */], {
          isOpen: this.state.isOpen,
          onRequestClose: this.handleClose,
          customStyles: this.getCustomStyles(),
          className: 'collection-modal' },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_base_Modals__["d" /* ModalHeader */], null, 'EDIT FOLDER'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_base_Modals__["b" /* ModalContent */], { className: 'collection-modal-content' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_keymaps_KeyMaps__["a" /* default */], { keyMap: pm.shortcuts.getShortcuts(), handlers: this.getKeyMapHandlers() },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-content-container' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'collection-modal-name-container' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'field-label' }, 'Name'),


                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_Inputs__["b" /* Input */], {
                  type: 'text',
                  inputStyle: 'box',
                  value: this.state.name,
                  error: this.state.nameError,
                  placeholder: 'Folder Name',
                  onChange: this.handleNameChange,
                  onSubmit: this.handleSubmit,
                  className: 'collection-modal-name-input',
                  ref: input => this.folderName = input }),

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__components_collections_folder_FolderModalTabs__["a" /* default */], {
                  onSelect: this.handleTabSelect,
                  activeTab: this.state.activeTab,
                  isAuthSelected: !_.isEmpty(this.state.auth),
                  isPreRequestScriptAvailable: !!this.state.preRequestScript,
                  isTestsAvailable: !!this.state.tests,
                  hasVariables: !_.isEmpty(this.state.variables) })),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__variables_CollectionVariablesProvider__["a" /* default */], { collectionId: this.state.collection },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_9__components_collections_folder_FolderModalTabContents__["a" /* default */], {
                    activeKey: this.state.activeTab },

                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__components_collections_folder_FolderModalTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_20__constants_FolderConstants__["c" /* FOLDER_DESCRIPTION */] },
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_13__components_collections_folder_FolderDescription__["a" /* default */], {
                      description: this.state.description,
                      onChange: this.handleDescriptionChange })),


                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__components_collections_folder_FolderModalTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_20__constants_FolderConstants__["a" /* FOLDER_AUTHORIZATION */] },
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_14__FolderAuthEditorContainer__["a" /* default */], {
                      auth: this.state.auth,
                      inheritedAuth: this.state.inheritedAuth,
                      onUseToken: this.handleUseOauth2Token,
                      collectionId: this.state.collection,
                      handleAuthTypeSelect: this.handleAuthTypeSelect,
                      handleFieldChange: this.handleFieldChange,
                      handleAuthAnalytics: _.noop })),


                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__components_collections_folder_FolderModalTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_20__constants_FolderConstants__["d" /* FOLDER_PRE_REQUEST_SCRIPTS */] },
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_11__components_collections_folder_FolderPreRequestScripts__["a" /* default */], {
                      value: this.state.preRequestScript,
                      onBeautify: this.handleBeautifyPreRequestScript,
                      onChange: this.handlePreRequestScriptChange })),


                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__components_collections_folder_FolderModalTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_20__constants_FolderConstants__["e" /* FOLDER_TESTS */] },
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_12__components_collections_folder_FolderTests__["a" /* default */], {
                      value: this.state.tests,
                      onBeautify: this.handleBeautifyTests,
                      onChange: this.handleTestsChange })),


                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__components_collections_folder_FolderModalTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_20__constants_FolderConstants__["b" /* FOLDER_CONFIGURATIONS */] },

                    FOLDER_CONFIGURATIONS_ENABLED &&
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_22__components_collections_folder_FolderConfigurationList__["a" /* default */], {
                      configuration: this.state.protocolProfileBehavior,
                      updateProtocolProfileBehavior: this.updateProtocolProfileBehavior,
                      removeKeyFromProtocolProfileBehavior: this.removeKeyFromProtocolProfileBehavior,
                      inheritedConfigParent: this.state.inheritedConfigParent }))))))),








        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_base_Modals__["c" /* ModalFooter */], { className: 'collection-modal-footer' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Buttons__["a" /* Button */], {
              type: 'primary',
              onClick: this.handleSubmit }, 'Update'),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Buttons__["a" /* Button */], {
              type: 'secondary',
              onClick: this.handleClose }, 'Cancel'))));




  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4712:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return DeleteFolderModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_collections_DeleteConfirmationModal__ = __webpack_require__(3517);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__stores_get_store__ = __webpack_require__(5);
var _class;



let


DeleteFolderModalContainer = __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default()(_class = class DeleteFolderModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      id: null,
      meta: null,
      isDisabled: false };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleConfirm = this.handleConfirm.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('showDeleteFolderModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showDeleteFolderModal', this.handleOpen);
  }

  handleOpen(folderId, callback) {
    let folder = Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('FolderStore').find(folderId);
    if (!folder) {
      return; // @todo, show warning or error?
    }
    this.callback = callback;
    this.setState({
      isOpen: true,
      id: folder.id,
      meta: { name: folder.name } },
    () => {
      _.invoke(this, 'keymapRef.focus');
    });
  }

  handleClose() {
    this.callback = null;
    this.setState({
      isOpen: false,
      id: null,
      meta: null,
      isDisabled: false },
    () => {
      pm.mediator.trigger('focusSidebar');
    });
  }

  handleConfirm() {
    this.setState({ isDisabled: true });
    let deleteFolderEvent = {
      name: 'delete',
      namespace: 'folder',
      data: { id: this.state.id } };


    Object(__WEBPACK_IMPORTED_MODULE_3__modules_pipelines_user_action__["a" /* default */])(deleteFolderEvent).
    then(response => {
      if (!_.isEmpty(_.get(response, 'error'))) {
        pm.logger.error('Error in deleting folder', response.error);
        return;
      }
      this.callback && this.callback();
      this.handleClose();
    }).
    catch(err => {
      this.setState({ isDisabled: false });
      pm.toasts.error('Unable to delete this folder');
      pm.logger.error('Error in pipeline for deleting folder', err);
    });
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_collections_DeleteConfirmationModal__["a" /* default */], {
        preventFocusReset: true,
        isDisabled: this.state.isDisabled,
        primaryAction: this.state.isDisabled ? 'Deleting' : 'Delete',
        isOpen: this.state.isOpen,
        entity: 'FOLDER',
        keymapRef: ref => {this.keymapRef = ref;},
        meta: this.state.meta,
        onConfirm: this.handleConfirm,
        onRequestClose: this.handleClose }));


  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4713:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return EditRequestModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_collections_EditRequestModal__ = __webpack_require__(4714);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__modules_controllers_CollectionController__ = __webpack_require__(34);
var _class;



let


EditRequestModalContainer = __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default()(_class = class EditRequestModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      description: '',
      name: '',
      nameError: false,
      id: '' };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleDescriptionChange = this.handleDescriptionChange.bind(this);
    this.handleNameChange = this.handleNameChange.bind(this);
    this.handleSubmit = this.handleSubmit.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('editCollectionRequest', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('editCollectionRequest', this.handleOpen);
  }

  handleOpen(requestId) {
    __WEBPACK_IMPORTED_MODULE_4__modules_controllers_CollectionController__["a" /* default */].getRequest({ id: requestId }).then(request => {
      this.setState({
        isOpen: true,
        description: request.description,
        name: request.name,
        nameError: false,
        id: request.id },
      () => {
        this.requestNameInput && this.requestNameInput.focus();
      });
    });
  }

  handleClose() {
    this.setState({ isOpen: false });
    this.clearModal();
  }

  handleDescriptionChange(value) {
    this.setState({ description: value });
  }

  handleNameChange(value) {
    this.setState({
      name: value,
      nameError: false });

  }

  clearModal() {
    this.setState({
      name: '',
      nameError: false,
      description: '',
      id: '' });

  }

  handleSubmit() {
    if (_.isEmpty(this.state.name.trim())) {
      this.setState({ nameError: true });
      return;
    }
    let requestUpdateEvent = {
      name: 'update',
      namespace: 'request',
      data: {
        id: this.state.id,
        name: this.state.name,
        description: this.state.description } };



    Object(__WEBPACK_IMPORTED_MODULE_3__modules_pipelines_user_action__["a" /* default */])(requestUpdateEvent).
    then(response => {
      if (!_.isEmpty(_.get(response, 'error'))) {
        pm.logger.error('Error in updating request', response.error);
        return;
      }

      this.handleClose();
    }).
    catch(err => {
      pm.logger.error('Error in pipeline for updating request', err);
    });
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_collections_EditRequestModal__["a" /* default */], {
        name: this.state.name,
        description: this.state.description,
        nameError: this.state.nameError,
        isOpen: this.state.isOpen,
        requestNameInput: input => {return this.requestNameInput = input;},
        onDescriptionChange: this.handleDescriptionChange,
        onNameChange: this.handleNameChange,
        onSubmit: this.handleSubmit,
        onRequestClose: this.handleClose }));


  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4714:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return EditRequestModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_keymaps_KeyMaps__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_TextEditor__ = __webpack_require__(311);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_XPaths_XPath__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__constants_AppUrlConstants__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__external_navigation_ExternalNavigationService__ = __webpack_require__(59);








let

EditRequestModal = class EditRequestModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  getKeyMapHandlers() {
    return { 'submit': pm.shortcuts.handle('submit', this.props.onSubmit) };
  }

  getCustomStyles() {
    return {
      marginTop: '10vh',
      height: '80vh' };

  }

  handleLinkClick() {
    Object(__WEBPACK_IMPORTED_MODULE_8__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_7__constants_AppUrlConstants__["Q" /* MARKDOWN_DOCS */]);
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_XPaths_XPath__["a" /* default */], { identifier: 'editRequestModal', isVisible: this.props.isOpen },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Modals__["a" /* Modal */], {
            customStyles: this.getCustomStyles(),
            isOpen: this.props.isOpen,
            onRequestClose: this.props.onRequestClose,
            className: 'edit-request-modal' },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Modals__["d" /* ModalHeader */], null, 'EDIT REQUEST'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Modals__["b" /* ModalContent */], null,
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_keymaps_KeyMaps__["a" /* default */], { keyMap: pm.shortcuts.getShortcuts(), handlers: this.getKeyMapHandlers() },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'edit-request-modal-content-wrapper' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'field-label' }, 'Name'),


                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_XPaths_XPath__["a" /* default */], { identifier: 'name' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Inputs__["b" /* Input */], {
                    type: 'text',
                    inputStyle: 'box',
                    value: this.props.name,
                    error: this.props.nameError,
                    placeholder: 'Request Name',
                    onChange: this.props.onNameChange,
                    className: 'edit-request-modal-name-input',
                    ref: this.props.requestNameInput,
                    onSubmit: this.props.onSubmit })),


                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'field-label' }, 'Description'),


                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_XPaths_XPath__["a" /* default */], { identifier: 'description' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_TextEditor__["a" /* default */], {
                    hideGutter: true,
                    showScrollMargin: true,
                    className: 'edit-request-modal-description-editor',
                    mode: 'markdown',
                    placeholder: 'Make things easier for your teammates with a complete request description.',
                    value: this.props.description,
                    onChange: this.props.onDescriptionChange })),


                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'addnew-description-help-text' }, 'Descriptions support',

                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', {
                      className: 'btn btn-text inline-editor__markdown-link',
                      onClick: this.handleLinkClick }, 'Markdown'))))),







          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Modals__["c" /* ModalFooter */], null,
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_XPaths_XPath__["a" /* default */], { identifier: 'update' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                  type: 'primary',
                  onClick: this.props.onSubmit }, 'Update')),




            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_XPaths_XPath__["a" /* default */], { identifier: 'cancel' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                  type: 'secondary',
                  onClick: this.props.onRequestClose }, 'Cancel'))))));








  }};

/***/ }),

/***/ 4715:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return DeleteRequestModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_collections_DeleteConfirmationModal__ = __webpack_require__(3517);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__stores_get_store__ = __webpack_require__(5);
var _class;



let


DeleteRequestModalContainer = __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default()(_class = class DeleteRequestModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      id: null,
      meta: null,
      isDisabled: false };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleConfirm = this.handleConfirm.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('showDeleteRequestModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showDeleteRequestModal', this.handleOpen);
  }

  handleOpen(requestId, callback) {
    let request = Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('RequestStore').find(requestId);
    if (!request) {
      return; // Should we warn or alert?
    }

    this.callback = callback;
    this.setState({
      isOpen: true,
      id: request.id,
      meta: { name: request.name } },
    () => {
      _.invoke(this, 'keymapRef.focus');
    });
  }

  handleClose() {
    this.callback = null;
    this.setState({
      isOpen: false,
      id: null,
      meta: null,
      isDisabled: false },
    () => {
      pm.mediator.trigger('focusSidebar');
    });
  }

  handleConfirm() {
    this.setState({ isDisabled: true });
    let deleteRequestEvent = {
      name: 'delete',
      namespace: 'request',
      data: { id: this.state.id } };


    Object(__WEBPACK_IMPORTED_MODULE_3__modules_pipelines_user_action__["a" /* default */])(deleteRequestEvent).
    then(response => {
      if (!_.isEmpty(_.get(response, 'error'))) {
        pm.logger.error('Error in deleting request', response.error);
        return;
      }
      this.callback && this.callback();
      this.handleClose();
    }).
    catch(err => {
      this.setState({ isDisabled: false });
      pm.toasts.error('Unable to delete this request');
      pm.logger.error('Error in pipeline for deleting request', err);
    });
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_collections_DeleteConfirmationModal__["a" /* default */], {
        isDisabled: this.state.isDisabled,
        entity: 'REQUEST',
        primaryAction: this.state.isDisabled ? 'Deleting' : 'Delete',
        preventFocusReset: true,
        isOpen: this.state.isOpen,
        keymapRef: ref => {this.keymapRef = ref;},
        meta: this.state.meta,
        onConfirm: this.handleConfirm,
        onRequestClose: this.handleClose }));


  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4716:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return DeleteRequestMethodModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_collections_DeleteConfirmationModal__ = __webpack_require__(3517);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__modules_model_event__ = __webpack_require__(2);
var _class;



let


DeleteRequestMethodModalContainer = __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default()(_class = class DeleteRequestMethodModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      method: null,
      isDisabled: false };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleConfirm = this.handleConfirm.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('showDeleteRequestMethodModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showDeleteRequestMethodModal', this.handleOpen);
  }

  handleOpen(method, callback) {
    if (!method) {
      return;
    }

    this.callback = callback;
    this.setState({
      isOpen: true,
      method },
    () => {
      _.invoke(this, 'keymapRef.focus');
    });
  }

  handleClose() {
    this.callback = null;
    this.setState({
      isOpen: false,
      method: null,
      isDisabled: false },
    () => {
      pm.mediator.trigger('focusBuilder');
    });
  }

  handleConfirm() {
    this.setState({ isDisabled: true });

    let deleteRequestMethodEvent = Object(__WEBPACK_IMPORTED_MODULE_4__modules_model_event__["a" /* createEvent */])('removeMethod', 'requestmethod', this.state.method);

    Object(__WEBPACK_IMPORTED_MODULE_3__modules_pipelines_user_action__["a" /* default */])(deleteRequestMethodEvent).
    then(() => {
      this.callback && this.callback();
      this.handleClose();
    }).
    catch(err => {
      this.setState({ isDisabled: false });
      pm.toasts.error('Unable to delete this method');
      pm.logger.error('Error in pipeline for deleting request method', err);
    });
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_collections_DeleteConfirmationModal__["a" /* default */], {
        isDisabled: this.state.isDisabled,
        entity: 'METHOD',
        message: 'Are you sure you want to delete this method?',
        primaryAction: this.state.isDisabled ? 'Deleting' : 'Delete',
        preventFocusReset: true,
        isOpen: this.state.isOpen,
        keymapRef: ref => {this.keymapRef = ref;},
        onConfirm: this.handleConfirm,
        onRequestClose: this.handleClose }));


  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4717:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ImportCollectionConflictModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_lodash__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_lodash___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_lodash__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_import_ImportCollectionConflictModal__ = __webpack_require__(4718);
var _class;


let


ImportCollectionConflictModalContainer = __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default()(_class = class ImportCollectionConflictModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      currentCollectionName: '',
      currentCollectionId: null };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleReplace = this.handleReplace.bind(this);
    this.handleCopy = this.handleCopy.bind(this);
    this.acceptCollection = this.acceptCollection.bind(this);

    this.collectionQueue = [];
  }

  componentWillMount() {
    pm.mediator.on('resolveImportConflict', this.acceptCollection);
  }

  componentWillUnmount() {
    pm.mediator.off('resolveImportConflict', this.acceptCollection);
  }

  acceptCollection(collectionId, collectionName) {
    let collection = {
      id: collectionId,
      name: collectionName };


    this.collectionQueue.push(collection);

    if (this.collectionQueue.length > 1 || this.state.isOpen) return;

    this.handleOpen(collection);
  }

  handleOpen(collection) {
    this.setState({
      isOpen: true,
      currentCollectionName: collection.name,
      currentCollectionId: collection.id });

  }

  handleClose() {
    this.collectionQueue.shift();

    if (this.collectionQueue.length) {
      this.handleOpen(__WEBPACK_IMPORTED_MODULE_2_lodash___default.a.head(this.collectionQueue));
    } else {
      this.setState({
        isOpen: false,
        currentCollectionName: '',
        currentCollectionId: null });

    }
  }

  handleReplace() {
    pm.mediator.trigger('handleImportReplace' + __WEBPACK_IMPORTED_MODULE_2_lodash___default.a.head(this.collectionQueue).id);
    this.handleClose();
  }

  handleCopy() {
    pm.mediator.trigger('handleImportCopy' + __WEBPACK_IMPORTED_MODULE_2_lodash___default.a.head(this.collectionQueue).id);
    this.handleClose();
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_import_ImportCollectionConflictModal__["a" /* default */], {
        isOpen: this.state.isOpen,
        onRequestClose: this.handleClose,
        name: this.state.currentCollectionName,
        onReplace: this.handleReplace,
        onCopy: this.handleCopy }));


  }}) || _class;

/***/ }),

/***/ 4718:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ImportCollectionConflictModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Modals__ = __webpack_require__(189);


let

ImportCollectionConflictModal = class ImportCollectionConflictModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  getCustomStyles() {
    return { marginTop: '35vh' };
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Modals__["a" /* Modal */], {
          isOpen: this.props.isOpen,
          onRequestClose: this.props.onRequestClose,
          className: 'import-collection-conflict-modal',
          customStyles: this.getCustomStyles(),
          customOverlayStyles: { 'zIndex': 110 } },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Modals__["d" /* ModalHeader */], null, 'COLLECTION EXISTS'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'import-collection-conflict-modal-message' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'A collection\xA0'),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'import-collection-conflict-modal-entity-name' }, this.props.name),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, '\xA0already exists.')),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'import-collection-conflict-modal-message' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'What would you like to do?'))),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Modals__["c" /* ModalFooter */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
              type: 'primary',
              onClick: this.props.onCopy }, 'Import as Copy'),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
              type: 'secondary',
              onClick: this.props.onReplace }, 'Replace'))));




  }};

/***/ }),

/***/ 4719:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ManageEnvironmentModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ManageEnvironmentContainer__ = __webpack_require__(4720);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__modules_services_AuthHandlerService__ = __webpack_require__(532);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__constants_ManageEnvironmentViews__ = __webpack_require__(1493);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__components_base_XPaths_XPath__ = __webpack_require__(24);
var _class;







let


ManageEnvironmentModalContainer = __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default()(_class = class ManageEnvironmentModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      activeTab: 'Manage' };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleSignIn = this.handleSignIn.bind(this);
    this.handleTabSelect = this.handleTabSelect.bind(this);
    this.handleClose = this.handleClose.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('showManageEnvironmentModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showManageEnvironmentModal', this.handleOpen);
  }

  handleOpen(view) {
    this.setState({ isOpen: true }, () => {
      switch (view) {
        case 'Manage':
          this.handleTabSelect(view);
          break;
        case 'Templates':
          this.handleTabSelect(view);
          break;
        case __WEBPACK_IMPORTED_MODULE_5__constants_ManageEnvironmentViews__["a" /* MANAGE_ENVIRONMENT_VIEW_ADD_ENV */]:
        case __WEBPACK_IMPORTED_MODULE_5__constants_ManageEnvironmentViews__["d" /* MANAGE_ENVIRONMENT_VIEW_GLOBALS */]:
          this.handleTabSelect('Manage');
          this.refs.manageEnvironmentContainer && this.refs.manageEnvironmentContainer.handleViewChange && this.refs.manageEnvironmentContainer.handleViewChange(view);
          break;
        default:
          this.handleTabSelect('Manage');
          this.refs.manageEnvironmentContainer && this.refs.manageEnvironmentContainer.handleViewChange && this.refs.manageEnvironmentContainer.handleEnvironmentSelect(view);
          break;}

    });
  }

  handleClose() {
    this.setState({ isOpen: false });
  }

  getCustomStyles() {
    return {
      marginTop: '15vh',
      height: '70vh',
      width: '720px' };

  }

  handleSignIn() {
    this.handleClose();
    __WEBPACK_IMPORTED_MODULE_4__modules_services_AuthHandlerService__["a" /* default */].login();
  }

  handleTabSelect(value) {
    this.setState({ activeTab: value });
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_base_XPaths_XPath__["a" /* default */], { identifier: 'manageEnvironment', isVisible: this.state.isOpen },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Modals__["a" /* Modal */], {
            isOpen: this.state.isOpen,
            onRequestClose: this.handleClose,
            className: 'manage-environment-modal',
            customStyles: this.getCustomStyles() },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Modals__["d" /* ModalHeader */], null, 'MANAGE ENVIRONMENTS'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Modals__["b" /* ModalContent */], null,
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__ManageEnvironmentContainer__["a" /* default */], {
              onClose: this.handleClose,
              activeTab: this.state.activeTab,
              onTabSelect: this.handleTabSelect,
              onSignin: this.handleSignIn,
              ref: 'manageEnvironmentContainer' })))));





  }}) || _class;

/***/ }),

/***/ 4720:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ManageEnvironmentContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_environments_ManageEnvironmentControls__ = __webpack_require__(4721);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__EnvironmentListContainer__ = __webpack_require__(4722);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__AddEnvironmentContainer__ = __webpack_require__(4725);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__EditEnvironmentContainer__ = __webpack_require__(4727);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__ImportEnvironmentContainer__ = __webpack_require__(4729);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__EnvironmentGlobalsContainer__ = __webpack_require__(4731);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__constants_ManageEnvironmentViews__ = __webpack_require__(1493);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__constants_AppUrlConstants__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__components_base_XPaths_XPath__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__external_navigation_ExternalNavigationService__ = __webpack_require__(59);
var _class;

















let

ManageEnvironmentContainer = Object(__WEBPACK_IMPORTED_MODULE_12_mobx_react__["a" /* observer */])(_class = class ManageEnvironmentContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      currentView: __WEBPACK_IMPORTED_MODULE_9__constants_ManageEnvironmentViews__["f" /* MANAGE_ENVIRONMENT_VIEW_MAIN */],
      environmentId: '',
      sharingEnvironmentId: '' };


    this.handleEnvironmentSelect = this.handleEnvironmentSelect.bind(this);
    this.handleViewChange = this.handleViewChange.bind(this);
  }

  componentWillMount() {
  }

  handleViewChange(view) {
    this.setState({
      currentView: view,
      environmentId: '' },
    () => {
      switch (view) {
        case __WEBPACK_IMPORTED_MODULE_9__constants_ManageEnvironmentViews__["a" /* MANAGE_ENVIRONMENT_VIEW_ADD_ENV */]:{
            this.addEnvironmentNameInput && this.addEnvironmentNameInput.focus();
            break;
          }
        case __WEBPACK_IMPORTED_MODULE_9__constants_ManageEnvironmentViews__["f" /* MANAGE_ENVIRONMENT_VIEW_MAIN */]:{
            this.refs.viewMain && this.refs.viewMain.focus();
            break;
          }}

    });
  }

  handleEnvironmentSelect(id) {
    this.setState({
      currentView: __WEBPACK_IMPORTED_MODULE_9__constants_ManageEnvironmentViews__["c" /* MANAGE_ENVIRONMENT_VIEW_EDIT_ENV */],
      environmentId: id },
    () => {
      this.editEnvironmentNameInput && this.editEnvironmentNameInput.focus();
    });
  }

  getClasses(view) {
    return __WEBPACK_IMPORTED_MODULE_1_classnames___default()({
      'manage-environment-wrapper': true,
      'is-hidden': this.state.currentView !== view,
      'manage-environment-wrapper--main': view === __WEBPACK_IMPORTED_MODULE_9__constants_ManageEnvironmentViews__["f" /* MANAGE_ENVIRONMENT_VIEW_MAIN */],
      'manage-environment-wrapper--add-env': view === __WEBPACK_IMPORTED_MODULE_9__constants_ManageEnvironmentViews__["a" /* MANAGE_ENVIRONMENT_VIEW_ADD_ENV */],
      'manage-environment-wrapper--edit-env': view === __WEBPACK_IMPORTED_MODULE_9__constants_ManageEnvironmentViews__["c" /* MANAGE_ENVIRONMENT_VIEW_EDIT_ENV */],
      'manage-environment-wrapper--delete-env': view === __WEBPACK_IMPORTED_MODULE_9__constants_ManageEnvironmentViews__["b" /* MANAGE_ENVIRONMENT_VIEW_DELETE_ENV */],
      'manage-environment-wrapper--import-env': view === __WEBPACK_IMPORTED_MODULE_9__constants_ManageEnvironmentViews__["e" /* MANAGE_ENVIRONMENT_VIEW_IMPORT_ENV */],
      'manage-environment-wrapper--globals': view === __WEBPACK_IMPORTED_MODULE_9__constants_ManageEnvironmentViews__["d" /* MANAGE_ENVIRONMENT_VIEW_GLOBALS */] });

  }

  getManageEnvironmentClasses() {
    return __WEBPACK_IMPORTED_MODULE_1_classnames___default()({
      'manage-environment-container': true,
      'is-hidden': this.props.activeTab !== 'Manage' });

  }

  handleEnvironmentDocs() {
    Object(__WEBPACK_IMPORTED_MODULE_14__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_10__constants_AppUrlConstants__["B" /* ENVIRONMENT_DOCS */]);
  }

  render() {
    let environments = Object(__WEBPACK_IMPORTED_MODULE_11__stores_get_store__["getStore"])('ActiveWorkspaceStore').environments;
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'manage-environment-modal-content-wrapper' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: this.getManageEnvironmentClasses() },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: this.getClasses(__WEBPACK_IMPORTED_MODULE_9__constants_ManageEnvironmentViews__["f" /* MANAGE_ENVIRONMENT_VIEW_MAIN */]), ref: 'viewMain', tabIndex: '-1' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'manage-environment-meta' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'An environment is a set of variables that allow you to switch the context of your requests. Environments can be shared between multiple workspaces. '),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Buttons__["a" /* Button */], {
                  className: 'learn-more',
                  type: 'text',
                  onClick: this.handleEnvironmentDocs }, 'Learn more about environments'),




              _.size(environments) === 0 &&
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'variable-help-text' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'You can declare a variable in an environment and give it a starting value, then use it in a request by putting the variable name within curly-braces. '),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Buttons__["a" /* Button */], {
                    className: 'learn-more-link',
                    type: 'text',
                    onClick: this.handleViewChange.bind(this, __WEBPACK_IMPORTED_MODULE_9__constants_ManageEnvironmentViews__["a" /* MANAGE_ENVIRONMENT_VIEW_ADD_ENV */]) }, 'Create an environment'),



                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, ' to get started.'))),



            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_13__components_base_XPaths_XPath__["a" /* default */], { identifier: 'environmentList' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__EnvironmentListContainer__["a" /* default */], {
                environments: environments,
                onEnvironmentSelect: this.handleEnvironmentSelect })),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_13__components_base_XPaths_XPath__["a" /* default */], { identifier: 'footer' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_environments_ManageEnvironmentControls__["a" /* default */], {
                onAddEnvironmentSelect: this.handleViewChange.bind(this, __WEBPACK_IMPORTED_MODULE_9__constants_ManageEnvironmentViews__["a" /* MANAGE_ENVIRONMENT_VIEW_ADD_ENV */]),
                onImportEnvironmentSelect: this.handleViewChange.bind(this, __WEBPACK_IMPORTED_MODULE_9__constants_ManageEnvironmentViews__["e" /* MANAGE_ENVIRONMENT_VIEW_IMPORT_ENV */]),
                onGlobalsSelect: this.handleViewChange.bind(this, __WEBPACK_IMPORTED_MODULE_9__constants_ManageEnvironmentViews__["d" /* MANAGE_ENVIRONMENT_VIEW_GLOBALS */]) }))),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: this.getClasses(__WEBPACK_IMPORTED_MODULE_9__constants_ManageEnvironmentViews__["a" /* MANAGE_ENVIRONMENT_VIEW_ADD_ENV */]) },

            this.state.currentView === __WEBPACK_IMPORTED_MODULE_9__constants_ManageEnvironmentViews__["a" /* MANAGE_ENVIRONMENT_VIEW_ADD_ENV */] &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_13__components_base_XPaths_XPath__["a" /* default */], { identifier: 'addEnvironment' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__AddEnvironmentContainer__["a" /* default */], {
                environmentNameInput: input => {return this.addEnvironmentNameInput = input;},
                onClose: this.handleViewChange.bind(this, __WEBPACK_IMPORTED_MODULE_9__constants_ManageEnvironmentViews__["f" /* MANAGE_ENVIRONMENT_VIEW_MAIN */]) }))),




          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: this.getClasses(__WEBPACK_IMPORTED_MODULE_9__constants_ManageEnvironmentViews__["c" /* MANAGE_ENVIRONMENT_VIEW_EDIT_ENV */]) },

            this.state.currentView === __WEBPACK_IMPORTED_MODULE_9__constants_ManageEnvironmentViews__["c" /* MANAGE_ENVIRONMENT_VIEW_EDIT_ENV */] &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_13__components_base_XPaths_XPath__["a" /* default */], { identifier: 'editEnvironment' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__EditEnvironmentContainer__["a" /* default */], {
                environmentId: this.state.environmentId,
                environmentNameInput: input => {return this.editEnvironmentNameInput = input;},
                onClose: this.handleViewChange.bind(this, __WEBPACK_IMPORTED_MODULE_9__constants_ManageEnvironmentViews__["f" /* MANAGE_ENVIRONMENT_VIEW_MAIN */]) }))),




          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: this.getClasses(__WEBPACK_IMPORTED_MODULE_9__constants_ManageEnvironmentViews__["e" /* MANAGE_ENVIRONMENT_VIEW_IMPORT_ENV */]) },

            this.state.currentView === __WEBPACK_IMPORTED_MODULE_9__constants_ManageEnvironmentViews__["e" /* MANAGE_ENVIRONMENT_VIEW_IMPORT_ENV */] &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_13__components_base_XPaths_XPath__["a" /* default */], { identifier: 'importEnvironment' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__ImportEnvironmentContainer__["a" /* default */], {
                onClose: this.handleViewChange.bind(this, __WEBPACK_IMPORTED_MODULE_9__constants_ManageEnvironmentViews__["f" /* MANAGE_ENVIRONMENT_VIEW_MAIN */]) }))),




          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: this.getClasses(__WEBPACK_IMPORTED_MODULE_9__constants_ManageEnvironmentViews__["d" /* MANAGE_ENVIRONMENT_VIEW_GLOBALS */]) },

            this.state.currentView === __WEBPACK_IMPORTED_MODULE_9__constants_ManageEnvironmentViews__["d" /* MANAGE_ENVIRONMENT_VIEW_GLOBALS */] &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_13__components_base_XPaths_XPath__["a" /* default */], { identifier: 'globals' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__EnvironmentGlobalsContainer__["a" /* default */], {
                onClose: this.handleViewChange.bind(this, __WEBPACK_IMPORTED_MODULE_9__constants_ManageEnvironmentViews__["f" /* MANAGE_ENVIRONMENT_VIEW_MAIN */]) }))))));







  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4721:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ManageEnvironmentControls; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_XPaths_XPath__ = __webpack_require__(24);


let

ManageEnvironmentControls = class ManageEnvironmentControls extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.handleAddEnvironmentSelect = this.handleAddEnvironmentSelect.bind(this);
    this.handleGlobalsSelect = this.handleGlobalsSelect.bind(this);
    this.handleImportEnvironmentSelect = this.handleImportEnvironmentSelect.bind(this);
  }

  handleAddEnvironmentSelect() {
    this.props.onAddEnvironmentSelect && this.props.onAddEnvironmentSelect();
  }

  handleImportEnvironmentSelect() {
    this.props.onImportEnvironmentSelect && this.props.onImportEnvironmentSelect();
  }

  handleGlobalsSelect() {
    this.props.onGlobalsSelect && this.props.onGlobalsSelect();
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'manage-environment-controls' },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'manage-environment-buttons' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_XPaths_XPath__["a" /* default */], { identifier: 'globals' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                type: 'secondary',
                className: 'manage-environment-buttons--globals',
                onClick: this.handleGlobalsSelect }, 'Globals')),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_XPaths_XPath__["a" /* default */], { identifier: 'import' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                type: 'secondary',
                className: 'manage-environment-buttons--import-env',
                onClick: this.handleImportEnvironmentSelect }, 'Import')),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_XPaths_XPath__["a" /* default */], { identifier: 'add' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                type: 'primary',
                className: 'manage-environment-buttons--add-env',
                onClick: this.handleAddEnvironmentSelect }, 'Add')))));





  }};

/***/ }),

/***/ 4722:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return EnvironmentListContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_environments_EnvironmentList__ = __webpack_require__(4723);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__utils_EnvironmentActionUtil__ = __webpack_require__(3932);


let


EnvironmentListContainer = class EnvironmentListContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.handleSelect = this.handleSelect.bind(this);
    this.handleAction = this.handleAction.bind(this);
  }

  handleSelect(id) {
    this.props.onEnvironmentSelect && this.props.onEnvironmentSelect(id);
  }

  handleAction(id, action) {
    Object(__WEBPACK_IMPORTED_MODULE_2__utils_EnvironmentActionUtil__["a" /* default */])(id, action, {}, { origin: 'builder' });
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_environments_EnvironmentList__["a" /* default */], {
        environments: this.props.environments,
        onSelect: this.handleSelect,
        onAction: this.handleAction }));


  }};

/***/ }),

/***/ 4723:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return EnvironmentList; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__EnvironmentListItem__ = __webpack_require__(4724);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_XPaths_XPath__ = __webpack_require__(24);
var _class;


let


EnvironmentList = Object(__WEBPACK_IMPORTED_MODULE_2_mobx_react__["a" /* observer */])(_class = class EnvironmentList extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  handleSelect(id) {
    this.props.onSelect && this.props.onSelect(id);
  }

  handleAction(id, action) {
    this.props.onAction && this.props.onAction(id, action);
  }

  render() {
    let sortedList = _.sortBy(this.props.environments, environment => {
      return environment.name.toLowerCase();
    });

    let filteredSortedList = _.filter(sortedList, environment => {
      return !environment.team && !environment.isDeleted;
    });

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'environment-list' },

        filteredSortedList.map(environment => {
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_XPaths_XPath__["a" /* default */], { identifier: environment.id, key: environment.id },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__EnvironmentListItem__["a" /* default */], {
                environment: environment,
                onSelect: this.handleSelect.bind(this, environment.id),
                onAction: this.handleAction.bind(this, environment.id) })));



        })));



  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4724:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return EnvironmentListItem; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Icons_ShareIcon__ = __webpack_require__(1495);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Icons_CopyIcon__ = __webpack_require__(652);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Icons_DownloadIcon__ = __webpack_require__(975);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_Icons_MoreIcon__ = __webpack_require__(215);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__components_base_Dropdowns__ = __webpack_require__(31);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__base_XPaths_XPath__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__constants_MoreButtonTooltipConstant__ = __webpack_require__(310);
var _class;









let

EnvironmentListItem = Object(__WEBPACK_IMPORTED_MODULE_6_mobx_react__["a" /* observer */])(_class = class EnvironmentListItem extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.handleAction = this.handleAction.bind(this);
  }

  getActions() {
    const permissionStore = Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('PermissionStore'),
    workspaceId = Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('ActiveWorkspaceStore').id;

    return [
    {
      type: 'delete',
      label: 'Delete',
      isEnabled: permissionStore.can('delete', 'environment', this.props.environment.id) },

    {
      type: 'remove-from-workspace',
      label: 'Remove from workspace',
      isEnabled: permissionStore.can('removeEnvironment', 'workspace', workspaceId) }];


  }

  handleAction(action) {
    this.props.onAction && this.props.onAction(action);
  }

  getDisabledText(isDisabled) {
    if (isDisabled) {
      return 'You do not have permissions to perform this action.';
    }
  }

  getMenuItems() {
    return _.chain(this.getActions()) // eslint-disable-line
    .map(action => {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__components_base_Dropdowns__["d" /* MenuItem */], {
            key: action.type,
            refKey: action.type,
            disabled: !action.isEnabled,
            disabledText: this.getDisabledText(!action.isEnabled) },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'dropdown-menu-item-label' }, action.label)));


    }).value();
  }

  render() {
    const permissionStore = Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('PermissionStore'),
    workspaceId = Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('ActiveWorkspaceStore').id,
    canAddEnv = permissionStore.can('addEnvironment', 'workspace', workspaceId);

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'environment-list-item' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_9__base_XPaths_XPath__["a" /* default */], { identifier: 'name' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'environment-list-item__name-wrapper' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', {
                className: 'environment-list-item__name',
                onClick: this.props.onSelect },
              this.props.environment.name))),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'environment-list-item__actions' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_9__base_XPaths_XPath__["a" /* default */], { identifier: 'share' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                size: 'small',
                type: 'secondary',
                onClick: this.handleAction.bind(this, 'add-to-workspace') },

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Icons_ShareIcon__["a" /* default */], { className: 'share-icon' }),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Share'))),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["b" /* ButtonGroup */], null,
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                className: 'environment-list-item__action-button environment-list-item__action-button--duplicate',
                type: 'icon',
                onClick: this.handleAction.bind(this, 'duplicate'),
                disabled: !canAddEnv,
                tooltip: this.getDisabledText(!canAddEnv) || 'Duplicate Environment' },

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Icons_CopyIcon__["a" /* default */], { className: 'environment-list-item-action-duplicate' })),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                className: 'environment-list-item__action-button environment-list-item__action-button--download',
                tooltip: 'Download Environment',
                type: 'icon',
                onClick: this.handleAction.bind(this, 'download') },

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Icons_DownloadIcon__["a" /* default */], { className: 'environment-list-item-action-download' })),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__components_base_Dropdowns__["a" /* Dropdown */], {
                className: 'environment_item__action__dropdown',
                onSelect: this.handleAction },

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__components_base_Dropdowns__["b" /* DropdownButton */], {
                  dropdownStyle: 'nocaret',
                  type: 'custom' },

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], { tooltip: __WEBPACK_IMPORTED_MODULE_10__constants_MoreButtonTooltipConstant__["a" /* ACTION_TYPE_VIEW_MORE_ACTIONS_TOOLTIP */] }, ' ',
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Icons_MoreIcon__["a" /* default */], { className: 'environment_item__action__dropdown-btn' }))),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__components_base_Dropdowns__["c" /* DropdownMenu */], {
                  'align-right': true },

                this.getMenuItems()))))));






  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4725:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddEnvironmentContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_environments_AddEnvironment__ = __webpack_require__(4726);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__utils_util__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__utils_VariableSessionHelper__ = __webpack_require__(153);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__modules_model_event__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__modules_services_AnalyticsService__ = __webpack_require__(16);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};






let

AddEnvironmentContainer = class AddEnvironmentContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      name: '',
      nameError: false,
      values: [],
      showColumns: _.get(pm.settings.getSetting('dataEditorColumns'), 'session') };


    this.handleValuesChange = this.handleValuesChange.bind(this);
    this.handleNameChange = this.handleNameChange.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleSubmit = this.handleSubmit.bind(this);
    this.handleColumnToggle = this.handleColumnToggle.bind(this);
    this.setNewColumns = this.setNewColumns.bind(this);
  }

  handleClose() {
    this.clearState();
    this.props.onClose && this.props.onClose();
  }

  handleSubmit() {
    if (_.isEmpty(this.state.name.trim())) {
      this.setState({ nameError: true });
      return;
    }

    let activeWorkspaceStore = Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('ActiveWorkspaceStore'),
    currentUser = Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('CurrentUserStore'),
    { variables, sessionVariables } = Object(__WEBPACK_IMPORTED_MODULE_5__utils_VariableSessionHelper__["e" /* unzipVariables */])(this.state.values),
    activeWorkspaceId = activeWorkspaceStore.id,
    environmentId = __WEBPACK_IMPORTED_MODULE_3__utils_util__["a" /* default */].guid();

    Promise.resolve()

    // create the environment
    .then(() => {
      let createEnvironmentEvent = Object(__WEBPACK_IMPORTED_MODULE_6__modules_model_event__["a" /* createEvent */])('create', 'environment', {
        id: environmentId,
        name: this.state.name,
        values: variables,
        owner: currentUser.id });

      return Object(__WEBPACK_IMPORTED_MODULE_2__modules_pipelines_user_action__["a" /* default */])(createEnvironmentEvent);
    })

    // create the session for the environment
    .then(() => {
      let createVariableSessionEvent = Object(__WEBPACK_IMPORTED_MODULE_6__modules_model_event__["a" /* createEvent */])('create', 'variablesession', {
        id: Object(__WEBPACK_IMPORTED_MODULE_5__utils_VariableSessionHelper__["b" /* getSessionId */])('environment', environmentId, activeWorkspaceId),
        model: 'environment',
        modelId: environmentId,
        workspace: activeWorkspaceId,
        values: sessionVariables });


      __WEBPACK_IMPORTED_MODULE_7__modules_services_AnalyticsService__["a" /* default */].addEvent('session', 'user_create', 'environment');
      return Object(__WEBPACK_IMPORTED_MODULE_2__modules_pipelines_user_action__["a" /* default */])(createVariableSessionEvent);
    }).
    then(() => {
      this.handleClose();
    }).
    catch(err => {
      this.handleClose();
      pm.logger.error('Error while creating environment or updating it\'s session', err);
    });
  }

  clearState() {
    this.setState({
      name: '',
      nameError: false,
      values: [] });

  }

  handleNameChange(name) {
    this.setState({
      name: name,
      nameError: false });

  }

  handleValuesChange(values, done) {
    this.setState({ values: values }, () => {
      if (_.isFunction(done)) {
        done();
      }
    });
  }

  handleColumnToggle(columns) {
    this.setNewColumns(columns);
    pm.settings.setSetting('dataEditorColumns', _extends({},
    pm.settings.getSetting('dataEditorColumns'), {
      session: columns }));

  }

  setNewColumns(columns) {
    this.setState({ showColumns: columns });
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_environments_AddEnvironment__["a" /* default */], {
        name: this.state.name,
        values: this.state.values,
        nameError: this.state.nameError,
        environmentNameInput: this.props.environmentNameInput,
        onValuesChange: this.handleValuesChange,
        onNameChange: this.handleNameChange,
        onClose: this.handleClose,
        onSubmit: this.handleSubmit,
        onColumnToggle: this.handleColumnToggle,
        showColumns: this.state.showColumns }));


  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4726:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddEnvironment; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__keyvalue_editor_KeyValueEditor__ = __webpack_require__(362);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_keymaps_KeyMaps__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__variables_VariableAlertWrapper__ = __webpack_require__(3620);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__base_XPaths_XPath__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9_mobx_react__ = __webpack_require__(11);
var _class;










const keyMap = { 'submit': 'mod+enter' };let


AddEnvironment = Object(__WEBPACK_IMPORTED_MODULE_9_mobx_react__["a" /* observer */])(_class = class AddEnvironment extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  getKeyMapHandlers() {
    return { 'submit': this.props.onSubmit };
  }

  handleAnalyticsEvent(eventName) {
    switch (eventName) {
      case 'persist_all':
      case 'persist_single':
      case 'reset_all':
      case 'reset_single':
        __WEBPACK_IMPORTED_MODULE_6__modules_services_AnalyticsService__["a" /* default */].addEvent('session', eventName, 'environment');
        break;}

  }

  getDisabledText(isDisabled) {
    if (isDisabled) {
      return 'You do not have permissions to perform this action.';
    }
  }

  render() {
    const permissionStore = Object(__WEBPACK_IMPORTED_MODULE_8__stores_get_store__["getStore"])('PermissionStore'),
    workspaceId = Object(__WEBPACK_IMPORTED_MODULE_8__stores_get_store__["getStore"])('ActiveWorkspaceStore').id,
    canAddEnvironment = permissionStore.can('addEnvironment', 'workspace', workspaceId);

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_keymaps_KeyMaps__["a" /* default */], { keyMap: keyMap, handlers: this.getKeyMapHandlers() },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-environment' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-environment__header' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-environment__header__title' }, 'Add Environment')),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_XPaths_XPath__["a" /* default */], { identifier: 'name' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-environment__section-name' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Inputs__["b" /* Input */], {
                inputStyle: 'box',
                placeholder: 'Environment Name',
                value: this.props.name,
                error: this.props.nameError,
                onChange: this.props.onNameChange,
                ref: this.props.environmentNameInput,
                onSubmit: this.props.onSubmit }))),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-environment__section-values' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__keyvalue_editor_KeyValueEditor__["a" /* default */], {
              disallowDuplicates: true,
              values: this.props.values,
              keyHeading: 'VARIABLE',
              valueHeading: 'INITIAL VALUE',
              sessionHeading: 'CURRENT VALUE',
              keyPlaceholder: 'Add a new variable',
              valuePlaceholder: '',
              editor: this.props.valueEditor,
              onChange: this.props.onValuesChange,
              onAnalyticsEvent: this.handleAnalyticsEvent,
              onColumnToggle: this.props.onColumnToggle,
              showColumns: this.props.showColumns,
              allowedColumns: ['key', 'value', 'sessionValue'] })),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__variables_VariableAlertWrapper__["a" /* default */], { className: 'add-environment__section-alert' }),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-environment__section-controls' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_XPaths_XPath__["a" /* default */], { identifier: 'add' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
                  type: 'primary',
                  className: 'add-environment__section-controls__submit',
                  onClick: this.props.onSubmit,
                  disabled: !canAddEnvironment,
                  tooltip: this.getDisabledText(!canAddEnvironment) }, 'Add')),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_XPaths_XPath__["a" /* default */], { identifier: 'cancel' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
                  type: 'secondary',
                  className: 'add-environment__section-controls__cancel',
                  onClick: this.props.onClose }, 'Cancel'))))));






  }}) || _class;

/***/ }),

/***/ 4727:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return EditEnvironmentContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_environments_EditEnvironment__ = __webpack_require__(4728);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__modules_controllers_EnvironmentController__ = __webpack_require__(81);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__modules_services_VariableSessionService__ = __webpack_require__(273);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__utils_VariableSessionHelper__ = __webpack_require__(153);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__modules_model_event__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__modules_services_AnalyticsService__ = __webpack_require__(16);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};







let

EditEnvironmentContainer = class EditEnvironmentContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.state = {
      id: '',
      nameError: false,
      name: '',
      sessionId: '',
      variables: [],
      activeWorkspaceId: null,
      showColumns: _.get(pm.settings.getSetting('dataEditorColumns'), 'session') };


    this.handleModelChange = this.handleModelChange.bind(this);
    this.handleValuesChange = this.handleValuesChange.bind(this);
    this.handleNameChange = this.handleNameChange.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleSubmit = this.handleSubmit.bind(this);
    this.handleColumnToggle = this.handleColumnToggle.bind(this);
    this.setNewColumns = this.setNewColumns.bind(this);
  }

  componentWillMount() {
    this.handleModelChange(this.props.environmentId);
  }

  handleClose() {
    this.clearState();
    this.props.onClose && this.props.onClose();
  }

  componentWillReceiveProps(nextProps) {
    this.handleModelChange(nextProps.environmentId);
  }

  handleModelChange(environmentId) {
    if (!environmentId) {
      return;
    }

    let activeWorkspaceId = Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('ActiveWorkspaceStore').id,
    sessionId = Object(__WEBPACK_IMPORTED_MODULE_5__utils_VariableSessionHelper__["b" /* getSessionId */])('environment', environmentId, activeWorkspaceId);

    __WEBPACK_IMPORTED_MODULE_2__modules_controllers_EnvironmentController__["a" /* default */].get({ id: environmentId }).
    then(environment => {
      if (!environment) {
        return;
      }

      Object(__WEBPACK_IMPORTED_MODULE_4__modules_services_VariableSessionService__["d" /* getSessionFor */])(sessionId, environment).
      then(session => {
        this.setState({
          id: environmentId,
          name: environment.name,
          sessionId: session.id,
          activeWorkspaceId,
          variables: Object(__WEBPACK_IMPORTED_MODULE_5__utils_VariableSessionHelper__["h" /* zipVariables */])(environment.values, session.values) });

      }).
      catch(err => {
        pm.logger.warn('Failed to get session in edit environment modal', err);
        pm.toasts.error('Something went wrong. Please check DevTools.');
      });
    });
  }

  handleSubmit() {
    if (_.isEmpty(this.state.name.trim())) {
      this.setState({ nameError: true });
      return;
    }

    let workspaceId = this.state.activeWorkspaceId,
    { variables, sessionVariables } = Object(__WEBPACK_IMPORTED_MODULE_5__utils_VariableSessionHelper__["e" /* unzipVariables */])(this.state.variables);

    Promise.resolve()

    // update the environment
    .then(() => {
      let updateEnvironmentEvent = Object(__WEBPACK_IMPORTED_MODULE_7__modules_model_event__["a" /* createEvent */])('update', 'environment', {
        id: this.state.id,
        name: this.state.name,
        values: variables });

      return Object(__WEBPACK_IMPORTED_MODULE_3__modules_pipelines_user_action__["a" /* default */])(updateEnvironmentEvent);
    })

    // update the session
    .then(() => {
      let createOrUpdateSessionEvent,
      data;

      if (this.state.sessionId) {
        data = {
          id: this.state.sessionId,
          model: 'environment',
          modelId: this.state.id,
          workspace: workspaceId,
          values: sessionVariables };

        createOrUpdateSessionEvent = Object(__WEBPACK_IMPORTED_MODULE_7__modules_model_event__["a" /* createEvent */])('update', 'variablesession', data);
        __WEBPACK_IMPORTED_MODULE_8__modules_services_AnalyticsService__["a" /* default */].addEvent('session', 'user_edit', 'environment');
      } else
      {
        data = {
          id: Object(__WEBPACK_IMPORTED_MODULE_5__utils_VariableSessionHelper__["b" /* getSessionId */])('environment', this.state.id, workspaceId),
          model: 'environment',
          modelId: this.state.id,
          workspace: workspaceId,
          values: sessionVariables };

        createOrUpdateSessionEvent = Object(__WEBPACK_IMPORTED_MODULE_7__modules_model_event__["a" /* createEvent */])('create', 'variablesession', data);
        __WEBPACK_IMPORTED_MODULE_8__modules_services_AnalyticsService__["a" /* default */].addEvent('session', 'user_create', 'environment');
      }

      return Object(__WEBPACK_IMPORTED_MODULE_3__modules_pipelines_user_action__["a" /* default */])(createOrUpdateSessionEvent);
    }).
    then(() => {
      this.handleClose();
    }).
    catch(err => {
      this.handleClose();
      pm.logger.error('Error while updating environment or creating/updating it\'s session', err);
    });
  }

  clearState() {
    this.setState({
      id: '',
      nameError: false,
      name: '',
      sessionId: '',
      variables: [],
      activeWorkspaceId: null });

  }

  handleNameChange(name) {
    this.setState({
      name,
      nameError: false });

  }

  handleValuesChange(variables, done) {
    this.setState({ variables }, () => {
      if (_.isFunction(done)) {
        done();
      }
    });
  }

  handleColumnToggle(columns) {
    this.setNewColumns(columns);
    pm.settings.setSetting('dataEditorColumns', _extends({},
    pm.settings.getSetting('dataEditorColumns'), {
      session: columns }));

  }

  setNewColumns(columns) {
    this.setState({ showColumns: columns });
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_environments_EditEnvironment__["a" /* default */], {
        environmentId: this.props.environmentId,
        name: this.state.name,
        values: this.state.variables,
        nameError: this.state.nameError,
        environmentNameInput: this.props.environmentNameInput,
        onValuesChange: this.handleValuesChange,
        onNameChange: this.handleNameChange,
        onClose: this.handleClose,
        onSubmit: this.handleSubmit,
        onColumnToggle: this.handleColumnToggle,
        showColumns: this.state.showColumns }));


  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4728:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return EditEnvironment; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_keymaps_KeyMaps__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__keyvalue_editor_KeyValueEditor__ = __webpack_require__(362);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__variables_VariableAlertWrapper__ = __webpack_require__(3620);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__base_XPaths_XPath__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9_mobx_react__ = __webpack_require__(11);
var _class;










const keyMap = { 'submit': 'mod+enter' };let


EditEnvironment = Object(__WEBPACK_IMPORTED_MODULE_9_mobx_react__["a" /* observer */])(_class = class EditEnvironment extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  getKeyMapHandlers() {
    return { 'submit': this.props.onSubmit };
  }

  handleAnalyticsEvent(eventName) {
    switch (eventName) {
      case 'persist_all':
      case 'persist_single':
      case 'reset_all':
      case 'reset_single':
        __WEBPACK_IMPORTED_MODULE_6__modules_services_AnalyticsService__["a" /* default */].addEvent('session', eventName, 'environment');
        break;}

  }

  getDisabledText(isDisabled) {
    if (isDisabled) {
      return 'You do not have permissions to perform this action.';
    }
  }

  render() {
    const permissionStore = Object(__WEBPACK_IMPORTED_MODULE_8__stores_get_store__["getStore"])('PermissionStore'),
    canEditEnvironment = permissionStore.can('edit', 'environment', this.props.environmentId);

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_keymaps_KeyMaps__["a" /* default */], { keyMap: keyMap, handlers: this.getKeyMapHandlers() },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'edit-environment' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'edit-environment__header' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'edit-environment__header__title' }, 'Environment Name')),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_XPaths_XPath__["a" /* default */], { identifier: 'name' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'edit-environment__section-name' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Inputs__["b" /* Input */], {
                inputStyle: 'box',
                placeholder: 'Environment Name',
                value: this.props.name,
                error: this.props.nameError,
                onChange: this.props.onNameChange,
                ref: this.props.environmentNameInput,
                onSubmit: this.props.onSubmit }))),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'edit-environment__section-values' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__keyvalue_editor_KeyValueEditor__["a" /* default */], {
              disallowDuplicates: true,
              values: this.props.values,
              keyHeading: 'VARIABLE',
              valueHeading: 'INITIAL VALUE',
              sessionHeading: 'CURRENT VALUE',
              keyPlaceholder: 'Add a new variable',
              valuePlaceholder: '',
              editor: this.props.valueEditor,
              onChange: this.props.onValuesChange,
              onAnalyticsEvent: this.handleAnalyticsEvent,
              onColumnToggle: this.props.onColumnToggle,
              showColumns: this.props.showColumns,
              allowedColumns: ['key', 'value', 'sessionValue'] })),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__variables_VariableAlertWrapper__["a" /* default */], { className: 'edit-environment__section-alert' }),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'edit-environment__section-controls' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_XPaths_XPath__["a" /* default */], { identifier: 'update' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                  type: 'primary',
                  className: 'edit-environment__section-controls__submit',
                  onClick: this.props.onSubmit,
                  disabled: !canEditEnvironment,
                  tooltip: this.getDisabledText(!canEditEnvironment) }, 'Update')),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_XPaths_XPath__["a" /* default */], { identifier: 'cancel' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                  type: 'secondary',
                  className: 'edit-environment__section-controls__cancel',
                  onClick: this.props.onClose }, 'Cancel'))))));






  }}) || _class;

/***/ }),

/***/ 4729:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ImportEnvironmentContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_environments_ImportEnvironment__ = __webpack_require__(4730);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__services_conversion_promisifiedConverter__ = __webpack_require__(655);


let

ImportEnvironmentContainer = class ImportEnvironmentContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.handleClose = this.handleClose.bind(this);
    this.handleChange = this.handleChange.bind(this);
  }

  handleClose() {
    this.props.onClose && this.props.onClose();
  }

  handleChange(files) {
    Object(__WEBPACK_IMPORTED_MODULE_2__services_conversion_promisifiedConverter__["a" /* default */])().then(converter => {
      converter.importFiles(files);
    });
    this.handleClose();
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_environments_ImportEnvironment__["a" /* default */], {
        onClose: this.handleClose,
        onChange: this.handleChange }));


  }};

/***/ }),

/***/ 4730:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ImportEnvironment; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_XPaths_XPath__ = __webpack_require__(24);



let
ImportEnvironment = class ImportEnvironment extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.handleClose = this.handleClose.bind(this);
    this.handleChange = this.handleChange.bind(this);
  }

  handleClose() {
    this.props.onClose && this.props.onClose();
  }

  handleChange(value) {
    this.props.onChange && this.props.onChange(value);
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'import-environment' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'import-environment__header' }, 'Import Environment'),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'import-environment__message' }, 'Select environment files from your computer'),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_XPaths_XPath__["a" /* default */], { identifier: 'importFile' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'import-environment__inputs' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Inputs__["b" /* Input */], {
              type: 'file',
              onChange: this.handleChange }))),



        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'import-environment__controls' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_XPaths_XPath__["a" /* default */], { identifier: 'cancel' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
                type: 'secondary',
                className: 'import-environment__controls__cancel',
                onClick: this.handleClose }, 'Cancel')))));





  }};

/***/ }),

/***/ 4731:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return EnvironmentGlobalsContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_environments_EnvironmentGlobals__ = __webpack_require__(4732);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__modules_controllers_GlobalsController__ = __webpack_require__(86);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__services_conversion_promisifiedConverter__ = __webpack_require__(655);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__modules_services_VariableSessionService__ = __webpack_require__(273);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__utils_VariableSessionHelper__ = __webpack_require__(153);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__modules_model_event__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__modules_services_AnalyticsService__ = __webpack_require__(16);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};








let

EnvironmentGlobalsContainer = class EnvironmentGlobalsContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.state = {
      id: '',
      sessionId: '',
      variables: [],
      isDirty: false,
      activeWorkspaceId: Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('ActiveWorkspaceStore').id,
      showColumns: _.get(pm.settings.getSetting('dataEditorColumns'), 'session') };


    this.handleModelChange = this.handleModelChange.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleSubmit = this.handleSubmit.bind(this);
    this.handleChange = this.handleChange.bind(this);
    this.handleDownload = this.handleDownload.bind(this);
    this.handleColumnToggle = this.handleColumnToggle.bind(this);
    this.setNewColumns = this.setNewColumns.bind(this);
  }

  componentWillMount() {
    let activeGlobalId = Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('ActiveGlobalsStore').id;

    if (!activeGlobalId) {
      pm.logger.error('EnvironmentGlobalsContainer~handleModelChange: Could not find active globals');
      pm.toasts.error('Could not find global variables for this workspace');
      this.handleClose();
      return;
    }

    this.handleModelChange();
  }

  handleModelChange() {
    let activeGlobalsId = Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('ActiveGlobalsStore').id,
    activeWorkspaceId = Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('ActiveWorkspaceStore').id,
    activeGlobals,
    sessionId = Object(__WEBPACK_IMPORTED_MODULE_7__utils_VariableSessionHelper__["b" /* getSessionId */])('globals', activeGlobalsId, activeWorkspaceId);

    __WEBPACK_IMPORTED_MODULE_2__modules_controllers_GlobalsController__["a" /* default */].
    get({ id: activeGlobalsId }).
    then(globals => {
      activeGlobals = globals;
      return Object(__WEBPACK_IMPORTED_MODULE_6__modules_services_VariableSessionService__["d" /* getSessionFor */])(sessionId, globals);
    }).
    then(session => {
      this.setState({
        id: activeGlobalsId,
        sessionId: session.id,
        activeWorkspaceId,
        variables: Object(__WEBPACK_IMPORTED_MODULE_7__utils_VariableSessionHelper__["h" /* zipVariables */])(activeGlobals.values, session.values) });

    }).
    catch(err => {
      pm.logger.warn('Failed to get session in edit globals modal', err);
      pm.toasts.error('Something went wrong. Please check DevTools.');
    });
  }

  handleChange(variables, done) {
    this.setState({ variables, isDirty: true }, () => {
      if (_.isFunction(done)) {
        done();
      }
    });
  }

  handleClose() {
    this.props.onClose && this.props.onClose();
  }

  clearState() {
    this.setState({
      variables: [],
      activeWorkspaceId: null });

  }

  saveGlobals(downloadAfterSave = false) {
    let { variables, sessionVariables } = Object(__WEBPACK_IMPORTED_MODULE_7__utils_VariableSessionHelper__["e" /* unzipVariables */])(this.state.variables),
    workspaceId = this.state.activeWorkspaceId,
    updateGlobalsEvent = Object(__WEBPACK_IMPORTED_MODULE_8__modules_model_event__["a" /* createEvent */])('update', 'globals', {
      id: this.state.id,
      values: variables });


    Promise.resolve()

    // update the globals
    .then(() => {
      return Object(__WEBPACK_IMPORTED_MODULE_3__modules_pipelines_user_action__["a" /* default */])(updateGlobalsEvent);
    })

    // Update the session
    .then(() => {
      let data = {
        id: this.state.sessionId,
        model: 'globals',
        modelId: this.state.id,
        workspace: workspaceId,
        values: sessionVariables },

      createOrUpdateSessionEvent = Object(__WEBPACK_IMPORTED_MODULE_8__modules_model_event__["a" /* createEvent */])('update', 'variablesession', data);

      __WEBPACK_IMPORTED_MODULE_9__modules_services_AnalyticsService__["a" /* default */].addEvent('session', 'user_edit', 'globals');
      return Object(__WEBPACK_IMPORTED_MODULE_3__modules_pipelines_user_action__["a" /* default */])(createOrUpdateSessionEvent);
    })

    // close the modal and optionally start downloading the globals
    .then(() => {
      this.handleClose();
      downloadAfterSave && this.downloadGlobals();
    }).
    catch(err => {
      pm.logger.error('Error while updating globals or creating it\'s session', err);
      this.handleClose();
    });
  }

  handleSubmit() {
    this.saveGlobals(false);
  }

  handleDownload() {
    this.state.isDirty ? this.saveGlobals(true) : this.downloadGlobals();
  }

  downloadGlobals() {
    Object(__WEBPACK_IMPORTED_MODULE_5__services_conversion_promisifiedConverter__["a" /* default */])().then(converter => {
      let workspaceId = Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('ActiveWorkspaceSessionStore').workspace,
      criteria = { workspace: workspaceId };
      converter.saveEntity(criteria, { type: 'globals' });
    });
  }

  handleColumnToggle(columns) {
    this.setNewColumns(columns);
    pm.settings.setSetting('dataEditorColumns', _extends({},
    pm.settings.getSetting('dataEditorColumns'), {
      session: columns }));

  }

  setNewColumns(columns) {
    this.setState({ showColumns: columns });
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_environments_EnvironmentGlobals__["a" /* default */], {
        values: this.state.variables,
        onChange: this.handleChange,
        onDownload: this.handleDownload,
        onClose: this.handleClose,
        onSubmit: this.handleSubmit,
        isDirty: this.state.isDirty,
        onColumnToggle: this.handleColumnToggle,
        showColumns: this.state.showColumns }));


  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4732:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return EnvironmentGlobals; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_keymaps_KeyMaps__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__keyvalue_editor_KeyValueEditor__ = __webpack_require__(362);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__variables_VariableAlertWrapper__ = __webpack_require__(3620);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_XPaths_XPath__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__external_navigation_ExternalNavigationService__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__constants_AppUrlConstants__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10_mobx_react__ = __webpack_require__(11);
var _class;











const keyMap = { 'submit': 'mod+enter' };let


EnvironmentGlobals = Object(__WEBPACK_IMPORTED_MODULE_10_mobx_react__["a" /* observer */])(_class = class EnvironmentGlobals extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  getKeyMapHandlers() {
    return { 'submit': this.props.onSubmit };
  }

  handleAnalyticsEvent(eventName) {
    switch (eventName) {
      case 'persist_all':
      case 'persist_single':
      case 'reset_all':
      case 'reset_single':
        __WEBPACK_IMPORTED_MODULE_5__modules_services_AnalyticsService__["a" /* default */].addEvent('session', eventName, 'globals');
        break;}

  }

  handleGlobalDocs() {
    Object(__WEBPACK_IMPORTED_MODULE_7__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_8__constants_AppUrlConstants__["E" /* GLOBAL_VARIABLE_DOCS */]);
  }

  getDisabledText(isDisabled) {
    if (isDisabled) {
      return 'You do not have permissions to perform this action.';
    }
  }

  render() {
    const globalId = Object(__WEBPACK_IMPORTED_MODULE_9__stores_get_store__["getStore"])('ActiveGlobalsStore').id,
    canEditGlobals = Object(__WEBPACK_IMPORTED_MODULE_9__stores_get_store__["getStore"])('PermissionStore').can('edit', 'globals', globalId);

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'manage-environment-wrapper__content' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'manage-environment-meta' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Global variables for a workspace are a set of variables that are always available within the scope of that workspace. They can be viewed and edited by anyone in that workspace. '),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
              className: 'learn-more-link',
              type: 'text',
              onClick: this.handleGlobalDocs }, 'Learn more about globals')),




        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_keymaps_KeyMaps__["a" /* default */], { keyMap: keyMap, handlers: this.getKeyMapHandlers() },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'environment-globals' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'environment-globals__header' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'environment-globals__header__title' }, 'Globals')),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'environment-globals__values' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__keyvalue_editor_KeyValueEditor__["a" /* default */], {
                disallowDuplicates: true,
                values: this.props.values,
                keyHeading: 'VARIABLE',
                valueHeading: 'INITIAL VALUE',
                sessionHeading: 'CURRENT VALUE',
                keyPlaceholder: 'Add a new variable',
                valuePlaceholder: '',
                editor: this.props.valueEditor,
                onChange: this.props.onChange,
                onAnalyticsEvent: this.handleAnalyticsEvent,
                onColumnToggle: this.props.onColumnToggle,
                showColumns: this.props.showColumns,
                allowedColumns: ['key', 'value', 'sessionValue'] })),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__variables_VariableAlertWrapper__["a" /* default */], { className: 'environment-globals__alert' }),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'environment-globals__controls' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_XPaths_XPath__["a" /* default */], { identifier: 'save' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                    type: 'primary',
                    className: 'environment-globals__controls__submit',
                    onClick: this.props.onSubmit,
                    disabled: !(this.props.isDirty && canEditGlobals),
                    tooltip: this.getDisabledText(!canEditGlobals) }, 'Save')),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_XPaths_XPath__["a" /* default */], { identifier: 'cancel' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                    type: 'text',
                    className: 'environment-globals__controls__cancel',
                    onClick: this.props.onClose }, 'Cancel')),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_XPaths_XPath__["a" /* default */], { identifier: 'download' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                    type: 'secondary',
                    className: 'environment-globals__controls__download',
                    onClick: this.props.onDownload },

                  this.props.isDirty ? 'Save and Download as JSON' : 'Download as JSON')))))));







  }}) || _class;

/***/ }),

/***/ 4733:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ManageHeaderPresetModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ManageHeaderPresetContainer__ = __webpack_require__(4734);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_base_Modals__ = __webpack_require__(189);
var _class;


let


ManageHeaderPresetModalContainer = __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default()(_class = class ManageHeaderPresetModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = { isOpen: false };

    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('showManageHeaderPresetModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showManageHeaderPresetModal', this.handleOpen);
  }

  handleOpen() {
    this.setState({ isOpen: true });
  }

  handleClose() {
    this.setState({ isOpen: false });
  }

  getCustomStyles() {
    return {
      marginTop: '15vh',
      height: '70vh',
      width: '720px' };

  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Modals__["a" /* Modal */], {
          isOpen: this.state.isOpen,
          onRequestClose: this.handleClose,
          className: 'manage-header-preset-modal',
          customStyles: this.getCustomStyles() },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Modals__["d" /* ModalHeader */], null, 'MANAGE HEADER PRESETS'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'manage-header-preset-modal-content-wrapper' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__ManageHeaderPresetContainer__["a" /* default */], null)))));




  }}) || _class;

/***/ }),

/***/ 4734:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ManageHeaderPresetContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_headers_ManageHeaderPresetControls__ = __webpack_require__(4735);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__HeaderPresetListContainer__ = __webpack_require__(4736);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__AddHeaderPresetContainer__ = __webpack_require__(4740);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__EditHeaderPresetContainer__ = __webpack_require__(4742);









const MANAGE_HEADER_PRESET_VIEW_MAIN = 'main',
MANAGE_HEADER_PRESET_VIEW_ADD_ENV = 'add-environment',
MANAGE_HEADER_PRESET_VIEW_EDIT_ENV = 'edit-environment';let

ManageHeaderPresetContainer = class ManageHeaderPresetContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      currentView: MANAGE_HEADER_PRESET_VIEW_MAIN,
      headerPresetId: '' };


    this.handleHeaderPresetSelect = this.handleHeaderPresetSelect.bind(this);
  }

  handleViewChange(view) {
    this.setState({
      currentView: view,
      headerPresetId: '' },
    () => {
      if (view === MANAGE_HEADER_PRESET_VIEW_ADD_ENV) {
        this.addPresetNameInput && this.addPresetNameInput.focus();
      }
    });
  }

  handleHeaderPresetSelect(id) {
    this.setState({
      currentView: MANAGE_HEADER_PRESET_VIEW_EDIT_ENV,
      headerPresetId: id },
    () => {
      this.editPresetNameInput && this.editPresetNameInput.focus();
    });
  }

  getClasses(view) {
    return __WEBPACK_IMPORTED_MODULE_1_classnames___default()({
      'manage-header-preset-wrapper': true,
      'is-hidden': this.state.currentView !== view,
      'manage-header-preset-wrapper--main': view === MANAGE_HEADER_PRESET_VIEW_MAIN,
      'manage-header-preset-wrapper--add-env': view === MANAGE_HEADER_PRESET_VIEW_ADD_ENV,
      'manage-header-preset-wrapper--edit-env': view === MANAGE_HEADER_PRESET_VIEW_EDIT_ENV });

  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'manage-header-preset-container' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: this.getClasses(MANAGE_HEADER_PRESET_VIEW_MAIN) },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_headers_ManageHeaderPresetControls__["a" /* default */], {
            onAddHeaderPresetSelect: this.handleViewChange.bind(this, MANAGE_HEADER_PRESET_VIEW_ADD_ENV) }),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__HeaderPresetListContainer__["a" /* default */], {
            onHeaderPresetSelect: this.handleHeaderPresetSelect })),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: this.getClasses(MANAGE_HEADER_PRESET_VIEW_ADD_ENV) },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__AddHeaderPresetContainer__["a" /* default */], {
            presetNameInput: input => {return this.addPresetNameInput = input;},
            onClose: this.handleViewChange.bind(this, MANAGE_HEADER_PRESET_VIEW_MAIN) })),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: this.getClasses(MANAGE_HEADER_PRESET_VIEW_EDIT_ENV) },

          this.state.currentView === MANAGE_HEADER_PRESET_VIEW_EDIT_ENV &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__EditHeaderPresetContainer__["a" /* default */], {
            headerPresetId: this.state.headerPresetId,
            presetNameInput: input => {return this.editPresetNameInput = input;},
            onClose: this.handleViewChange.bind(this, MANAGE_HEADER_PRESET_VIEW_MAIN) }))));





  }};

/***/ }),

/***/ 4735:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ManageHeaderPresetControls; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_mobx_react__ = __webpack_require__(11);
var _class;


let


ManageHeaderPresetControls = Object(__WEBPACK_IMPORTED_MODULE_3_mobx_react__["a" /* observer */])(_class = class ManageHeaderPresetControls extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.handleAddHeaderPresetSelect = this.handleAddHeaderPresetSelect.bind(this);
  }

  handleAddHeaderPresetSelect() {
    this.props.onAddHeaderPresetSelect && this.props.onAddHeaderPresetSelect();
  }

  getTooltipText(isDisabled) {
    if (isDisabled) {
      return 'You do not have permissions to perform this action.';
    }
  }

  render() {
    const permissionStore = Object(__WEBPACK_IMPORTED_MODULE_2__stores_get_store__["getStore"])('PermissionStore'),
    workspaceId = Object(__WEBPACK_IMPORTED_MODULE_2__stores_get_store__["getStore"])('ActiveWorkspaceStore').id,
    canAddHeaderpreset = permissionStore.can('addHeaderpreset', 'workspace', workspaceId);

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'manage-header-preset-controls' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'manage-header-preset-meta' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Quickly add groups of header key/value pairs to the request. Start typing the name of the preset name and it\'ll show up in the dropdown list.')),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'manage-header-preset-buttons' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
              type: 'primary',
              size: 'small',
              className: 'manage-header-preset-buttons--add-header-preset',
              onClick: this.handleAddHeaderPresetSelect,
              disabled: !canAddHeaderpreset,
              tooltip: this.getTooltipText(!canAddHeaderpreset) }, 'Add'))));




  }}) || _class;

/***/ }),

/***/ 4736:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HeaderPresetListContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_headers_HeaderPresetList__ = __webpack_require__(4737);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__stores_get_store__ = __webpack_require__(5);
var _class;


let


HeaderPresetListContainer = Object(__WEBPACK_IMPORTED_MODULE_1_mobx_react__["a" /* observer */])(_class = class HeaderPresetListContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.handleSelect = this.handleSelect.bind(this);
    this.handleAction = this.handleAction.bind(this);
  }

  handleSelect(id) {
    this.props.onHeaderPresetSelect && this.props.onHeaderPresetSelect(id);
  }

  handleDelete(id) {
    pm.mediator.trigger('showHeaderPresetDeleteModal', id);
  }

  handleAction(id, action) {
    if (action === 'delete') {
      this.handleDelete(id);
    }
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_headers_HeaderPresetList__["a" /* default */], {
        headerPresets: Object(__WEBPACK_IMPORTED_MODULE_3__stores_get_store__["getStore"])('ActiveWorkspaceStore').headerPresets,
        onSelect: this.handleSelect,
        onAction: this.handleAction }));


  }}) || _class;

/***/ }),

/***/ 4737:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HeaderPresetList; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__HeaderPresetListItem__ = __webpack_require__(4738);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_mobx_react__ = __webpack_require__(11);
var _class;

let


HeaderPresetList = Object(__WEBPACK_IMPORTED_MODULE_2_mobx_react__["a" /* observer */])(_class = class HeaderPresetList extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  handleSelect(id) {
    this.props.onSelect && this.props.onSelect(id);
  }

  handleAction(id, action) {
    this.props.onAction && this.props.onAction(id, action);
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'header-preset-list' },

        this.props.headerPresets.map(headerPreset => {
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__HeaderPresetListItem__["a" /* default */], {
              headerPreset: headerPreset,
              key: headerPreset.id,
              onSelect: this.handleSelect.bind(this, headerPreset.id),
              onAction: this.handleAction.bind(this, headerPreset.id) }));


        })));



  }}) || _class;

/***/ }),

/***/ 4738:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HeaderPresetListItem; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Icons_CloseIcon__ = __webpack_require__(90);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__constants_HeaderPresetActionsTooltipConstants__ = __webpack_require__(4739);
var _class;




let


HeaderPresetListItem = Object(__WEBPACK_IMPORTED_MODULE_3_mobx_react__["a" /* observer */])(_class = class HeaderPresetListItem extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.handleSelect = this.handleSelect.bind(this);
  }

  handleAction(action, event) {
    event.stopPropagation();
    this.props.onAction && this.props.onAction(action);
  }

  handleSelect() {
    this.props.onSelect && this.props.onSelect();
  }

  getTooltipText(isDisabled) {
    if (isDisabled) {
      return 'You do not have permissions to perform this action.';
    }

    return __WEBPACK_IMPORTED_MODULE_5__constants_HeaderPresetActionsTooltipConstants__["a" /* ACTION_TYPE_DELETE_TOOLTIP */];
  }

  render() {
    const permissionStore = Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('PermissionStore'),
    canDeleteHeaderpreset = permissionStore.can('delete', 'headerpreset', this.props.headerPreset.id);

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'header-preset-list-item' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'header-preset-list-item__name-wrapper' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', {
              className: 'header-preset-list-item__name',
              onClick: this.handleSelect },
            this.props.headerPreset.name)),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'header-preset-list-item__actions' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["b" /* ButtonGroup */], null,
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                type: 'icon',
                onClick: this.handleAction.bind(this, 'delete'),
                disabled: !canDeleteHeaderpreset,
                tooltip: this.getTooltipText(!canDeleteHeaderpreset) },

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Icons_CloseIcon__["a" /* default */], { className: 'header-preset-list-item-action-delete' }))))));





  }}) || _class;

/***/ }),

/***/ 4739:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
const ACTION_TYPE_DELETE_TOOLTIP = 'Delete header preset';
/* harmony export (immutable) */ __webpack_exports__["a"] = ACTION_TYPE_DELETE_TOOLTIP;


/***/ }),

/***/ 4740:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddHeaderPresetContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_headers_AddHeaderPreset__ = __webpack_require__(4741);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__modules_model_event__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__utils_util__ = __webpack_require__(19);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};




let

AddHeaderPresetContainer = class AddHeaderPresetContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.state = {
      name: '',
      nameError: false,
      values: [],
      showColumns: _.get(pm.settings.getSetting('dataEditorColumns'), 'headers') };


    this.handleValuesChange = this.handleValuesChange.bind(this);
    this.computeHeadersWarning = this.computeHeadersWarning.bind(this);
    this.handleNameChange = this.handleNameChange.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleSubmit = this.handleSubmit.bind(this);
    this.handleColumnToggle = this.handleColumnToggle.bind(this);
  }

  handleClose() {
    this.props.onClose && this.props.onClose();
    this.clearState();
  }

  handleSubmit() {
    if (_.isEmpty(this.state.name.trim())) {
      this.setState({ nameError: true });
      return;
    }

    let currentUser = Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('CurrentUserStore'),
    headerPresetData = {
      id: __WEBPACK_IMPORTED_MODULE_5__utils_util__["a" /* default */].guid(),
      name: this.state.name,
      headers: this.state.values,
      owner: currentUser.id,
      workspace: Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('ActiveWorkspaceSessionStore').workspace // @todo: get current workspace from SessionController
    },
    addHeaderPresetEvent = Object(__WEBPACK_IMPORTED_MODULE_2__modules_model_event__["a" /* createEvent */])('create', 'headerpreset', headerPresetData);

    Object(__WEBPACK_IMPORTED_MODULE_3__modules_pipelines_user_action__["a" /* default */])(addHeaderPresetEvent).
    catch(e => {console.log('Error in creating header preset', e);});

    this.handleClose();
  }

  clearState() {
    this.setState({
      name: '',
      nameError: false,
      values: [] });

  }

  handleNameChange(name) {
    this.setState({
      name: name,
      nameError: false });

  }

  handleValuesChange(values, done) {
    this.setState({ values: this.computeHeadersWarning(values) }, () => {
      if (_.isFunction(done)) {
        done();
      }
    });
  }

  computeHeadersWarning(headers) {
    return headers;
  }

  handleColumnToggle(columns) {
    this.setState({ showColumns: columns });
    pm.settings.setSetting('dataEditorColumns', _extends({},
    pm.settings.getSetting('dataEditorColumns'), {
      headers: columns }));

  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_headers_AddHeaderPreset__["a" /* default */], {
        name: this.state.name,
        values: this.state.values,
        nameError: this.state.nameError,
        presetNameInput: this.props.presetNameInput,
        onValuesChange: this.handleValuesChange,
        onNameChange: this.handleNameChange,
        onClose: this.handleClose,
        showColumns: this.state.showColumns,
        onColumnToggle: this.handleColumnToggle,
        onSubmit: this.handleSubmit }));


  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4741:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddHeaderPreset; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_keymaps_KeyMaps__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__keyvalue_editor_KeyValueEditor__ = __webpack_require__(362);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__utils_AutoSuggestUtil__ = __webpack_require__(677);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__stores_get_store__ = __webpack_require__(5);







const keyMap = { 'submit': 'mod+enter' };let

AddHeaderPreset = class AddHeaderPreset extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {

  getKeyMapHandlers() {
    return { 'submit': this.props.onSubmit };
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_keymaps_KeyMaps__["a" /* default */], { keyMap: keyMap, handlers: this.getKeyMapHandlers() },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-header-preset' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-header-preset__header' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-header-preset__header__title' }, 'Add Header Preset')),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-header-preset__section-name' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Inputs__["b" /* Input */], {
              inputStyle: 'box',
              placeholder: 'Header Preset Name',
              value: this.props.name,
              error: this.props.nameError,
              ref: this.props.presetNameInput,
              onChange: this.props.onNameChange,
              onSubmit: this.props.onSubmit })),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-header-preset__section-values' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__keyvalue_editor_KeyValueEditor__["a" /* default */], {
              disableMultilineKey: true,
              disableMultilineValue: true,
              enableVariableSuggestions: true,
              allowedColumns: ['key', 'value', 'description'],
              values: this.props.values,
              editor: this.props.valueEditor,
              showColumns: this.props.showColumns,
              onColumnToggle: this.props.onColumnToggle,
              onChange: this.props.onValuesChange,
              keySuggestions: Object(__WEBPACK_IMPORTED_MODULE_5__utils_AutoSuggestUtil__["a" /* getKeySuggestions */])(Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('HeaderPreset')['headerPresetsForAutoComplete']),
              valueSuggestions: Object(__WEBPACK_IMPORTED_MODULE_5__utils_AutoSuggestUtil__["b" /* getValueSuggestions */])() })),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-header-preset__section-controls' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                type: 'primary',
                size: 'small',
                className: 'add-header-preset__section-controls__submit',
                onClick: this.props.onSubmit }, 'Add'),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                type: 'secondary',
                size: 'small',
                className: 'add-header-preset__section-controls__cancel',
                onClick: this.props.onClose }, 'Cancel')))));





  }};

/***/ }),

/***/ 4742:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return EditHeaderPresetContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_headers_EditHeaderPreset__ = __webpack_require__(4743);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__modules_controllers_HeaderPresetController__ = __webpack_require__(114);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_model_event__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__modules_pipelines_user_action__ = __webpack_require__(44);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};



let

EditHeaderPresetContainer = class EditHeaderPresetContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.state = {
      id: '',
      name: '',
      nameError: false,
      values: [],
      showColumns: _.get(pm.settings.getSetting('dataEditorColumns'), 'headers') };


    this.handleModelChange = this.handleModelChange.bind(this);
    this.handleValuesChange = this.handleValuesChange.bind(this);
    this.handleNameChange = this.handleNameChange.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleSubmit = this.handleSubmit.bind(this);
    this.handleColumnToggle = this.handleColumnToggle.bind(this);
  }

  componentWillMount() {
    this._headerPresetId = this.props.headerPresetId;
    this.handleModelChange();
  }

  componentWillUnmount() {
    this._headerPresetId = null;
  }

  handleClose() {
    this.clearState();
    this._headerPresetId = null;
    this.props.onClose && this.props.onClose();
  }

  componentWillReceiveProps(nextProps) {
    this._headerPresetId = nextProps.headerPresetId;
    this.handleModelChange();
  }

  handleModelChange() {
    if (!this._headerPresetId) {
      return;
    }

    __WEBPACK_IMPORTED_MODULE_2__modules_controllers_HeaderPresetController__["a" /* default */].
    get({ id: this._headerPresetId }).
    then(headerPreset => {
      this.setState({
        id: headerPreset.id,
        name: headerPreset.name,
        values: headerPreset.headers });

    });
  }

  handleSubmit() {
    if (_.isEmpty(this.state.name.trim())) {
      this.setState({ nameError: true });
      return;
    }

    let updateHeaderPresetEvent = Object(__WEBPACK_IMPORTED_MODULE_3__modules_model_event__["a" /* createEvent */])('update', 'headerpreset', {
      id: this.state.id,
      name: this.state.name,
      headers: this.state.values });


    Object(__WEBPACK_IMPORTED_MODULE_4__modules_pipelines_user_action__["a" /* default */])(updateHeaderPresetEvent);

    this.handleClose();
  }

  clearState() {
    this.setState({
      id: '',
      name: '',
      nameError: false,
      values: [] });

  }

  handleNameChange(name) {
    this.setState({
      name: name,
      nameError: false });

  }

  handleValuesChange(values, done) {
    this.setState({ values: values }, () => {
      if (_.isFunction(done)) {
        done();
      }
    });
  }

  handleColumnToggle(columns) {
    this.setState({ showColumns: columns });
    pm.settings.setSetting('dataEditorColumns', _extends({},
    pm.settings.getSetting('dataEditorColumns'), {
      headers: columns }));

  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_headers_EditHeaderPreset__["a" /* default */], {
        name: this.state.name,
        values: this.state.values,
        nameError: this.state.nameError,
        presetNameInput: this.props.presetNameInput,
        onValuesChange: this.handleValuesChange,
        onNameChange: this.handleNameChange,
        onClose: this.handleClose,
        showColumns: this.state.showColumns,
        onColumnToggle: this.handleColumnToggle,
        onSubmit: this.handleSubmit,
        headerPresetId: this.props.headerPresetId }));


  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4743:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return EditHeaderPreset; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_keymaps_KeyMaps__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__keyvalue_editor_KeyValueEditor__ = __webpack_require__(362);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__utils_AutoSuggestUtil__ = __webpack_require__(677);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7_mobx_react__ = __webpack_require__(11);
var _class;








const keyMap = { 'submit': 'mod+enter' };let


EditHeaderPreset = Object(__WEBPACK_IMPORTED_MODULE_7_mobx_react__["a" /* observer */])(_class = class EditHeaderPreset extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {

  getKeyMapHandlers() {
    return { 'submit': this.props.onSubmit };
  }

  getTooltipText(isDisabled) {
    if (isDisabled) {
      return 'You do not have permissions to perform this action.';
    }
  }

  render() {
    const permissionStore = Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('PermissionStore'),
    canEditHeaderpreset = permissionStore.can('edit', 'headerpreset', this.props.headerPresetId);

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_keymaps_KeyMaps__["a" /* default */], { keyMap: keyMap, handlers: this.getKeyMapHandlers() },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'edit-header-preset' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'edit-header-preset__header' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'edit-header-preset__header__title' }, 'Edit Header Preset')),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'edit-header-preset__section-name' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Inputs__["b" /* Input */], {
              inputStyle: 'box',
              placeholder: 'Header Preset Name',
              value: this.props.name,
              error: this.props.nameError,
              ref: this.props.presetNameInput,
              onChange: this.props.onNameChange,
              onSubmit: this.props.onSubmit })),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'edit-header-preset__section-values' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__keyvalue_editor_KeyValueEditor__["a" /* default */], {
              disableMultilineKey: true,
              disableMultilineValue: true,
              enableVariableSuggestions: true,
              allowedColumns: ['key', 'value', 'description'],
              values: this.props.values,
              editor: this.props.valueEditor,
              onChange: this.props.onValuesChange,
              showColumns: this.props.showColumns,
              onColumnToggle: this.props.onColumnToggle,
              keySuggestions: Object(__WEBPACK_IMPORTED_MODULE_5__utils_AutoSuggestUtil__["a" /* getKeySuggestions */])(Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('HeaderPreset')['headerPresetsForAutoComplete']),
              valueSuggestions: Object(__WEBPACK_IMPORTED_MODULE_5__utils_AutoSuggestUtil__["b" /* getValueSuggestions */])() })),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'edit-header-preset__section-controls' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                type: 'primary',
                size: 'small',
                className: 'edit-header-preset__section-controls__submit',
                onClick: this.props.onSubmit,
                disabled: !canEditHeaderpreset,
                tooltip: this.getTooltipText(!canEditHeaderpreset) }, 'Update'),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                type: 'secondary',
                size: 'small',
                className: 'edit-header-preset__section-controls__cancel',
                onClick: this.props.onClose }, 'Cancel')))));





  }}) || _class;

/***/ }),

/***/ 4744:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return DeleteHeaderPresetContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_collections_DeleteConfirmationModal__ = __webpack_require__(3517);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__modules_model_event__ = __webpack_require__(2);
var _class;




let


DeleteHeaderPresetContainer = __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default()(_class = class DeleteHeaderPresetContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      id: null,
      meta: null,
      isDisabled: false };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleConfirm = this.handleConfirm.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('showHeaderPresetDeleteModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showHeaderPresetDeleteModal', this.handleOpen);
  }

  handleOpen(headerPresetId, callback) {

    this.callback = _.isFunction(callback) && callback;
    this.setState({
      isOpen: true,
      id: headerPresetId,
      meta: {} },
    () => {
      _.invoke(this, 'keymapRef.focus');
    });
  }

  handleClose() {
    this.callback = null;
    this.setState({
      isOpen: false,
      id: null,
      meta: null,
      isDisabled: false });

  }

  handleConfirm() {
    let currentUser = Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('CurrentUserStore'),
    deleteHeaderPresetEvent = Object(__WEBPACK_IMPORTED_MODULE_5__modules_model_event__["a" /* createEvent */])('delete', 'headerpreset', { id: this.state.id, owner: currentUser.id });

    this.setState({ isDisabled: true });
    Object(__WEBPACK_IMPORTED_MODULE_3__modules_pipelines_user_action__["a" /* default */])(deleteHeaderPresetEvent).
    then(() => {
      this.handleClose();
    }).
    catch(err => {
      this.setState({ isDisabled: false });
      pm.toasts.error('Unable to delete this header preset');
      pm.logger.error('Could not delete header preset', err);
    });
  }

  getMessage() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'delete-confirmation-modal-message' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, 'Are you sure you want to delete this header preset from the workspace?')));


  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_collections_DeleteConfirmationModal__["a" /* default */], {
        preventFocusReset: true,
        isDisabled: this.state.isDisabled,
        className: 'delete-collection-confirmation-modal',
        title: 'DELETE HEADER PRESET',
        primaryAction: this.state.isDisabled ? 'Deleting' : 'Delete',
        message: this.getMessage(),
        isOpen: this.state.isOpen,
        keymapRef: ref => {this.keymapRef = ref;},
        meta: this.state.meta,
        onConfirm: this.handleConfirm,
        onRequestClose: this.handleClose }));


  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4745:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return UserSignOutModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_user_UserSignOutModal__ = __webpack_require__(4746);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_model_event__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__modules_pipelines_app_action__ = __webpack_require__(314);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__modules_controllers_WorkspaceController__ = __webpack_require__(56);
var _class;






let


UserSignOutModalContainer = __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default()(_class = class UserSignOutModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      isSessionExpired: false,
      acceptForceSignout: false };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleConfirm = this.handleConfirm.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.toggleSignoutCheck = this.toggleSignoutCheck.bind(this);
    this.handleSocketConnectedCase = this.handleSocketConnectedCase.bind(this);
    this.handleSocketDisconnectedCase = this.handleSocketDisconnectedCase.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('showUserSignoutModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showUserSignoutModal', this.handleOpen);
  }

  handleSocketConnectedCase() {
    this.syncManagerInternalChannelDisposer = pm.eventBus.channel('sync-manager-internal').subscribe(event => {
      // bail out and return do not do anything
      if (!this.state.isOpen) {
        return;
      }

      // bail out if any other event other than verification of sync data integrity
      if (event.name === 'verified' && event.namespace === 'sync-data-integrity') {
        let data = Object(__WEBPACK_IMPORTED_MODULE_3__modules_model_event__["d" /* getEventData */])(event),
        hasUnsyncedData = data && data.hasUnsyncedData,
        didFinishVerification = data && data.didFinishVerification;

        if (!didFinishVerification || hasUnsyncedData) {
          // if has unsynced data or we did not finish verification then show the warning
          this.setState({
            isLoading: false,
            showWarning: true,
            acceptForceSignout: false });

        } else {
          // this is the case where we have successfully verified that user data is in sync
          this.setState({
            isLoading: false,
            showWarning: false,
            acceptForceSignout: true });

        }
      }
    });

    pm.eventBus.channel('sync-manager-internal').publish(Object(__WEBPACK_IMPORTED_MODULE_3__modules_model_event__["a" /* createEvent */])('verify', 'sync-data-integrity'));
  }

  handleSocketDisconnectedCase() {
    this.setState({
      isLoading: false,
      showWarning: true,
      acceptForceSignout: false });

  }

  handleOpen({ isSessionExpired } = {}) {
    // clean up if existing listeners are already there
    this.syncManagerInternalChannelDisposer && this.syncManagerInternalChannelDisposer();

    // if session expired dont show any warning or anything and show the state where user can directly log out
    if (isSessionExpired) {
      this.setState({
        isLoading: false,
        showWarning: false,
        acceptForceSignout: true,
        isOpen: true,
        isSessionExpired: isSessionExpired || false });


      return;
    }

    this.setState({
      isOpen: true,
      isLoading: true,
      acceptForceSignout: false,
      showWarning: false,
      isSessionExpired: isSessionExpired || false });


    __WEBPACK_IMPORTED_MODULE_6__modules_services_AnalyticsService__["a" /* default */].addEvent('account', 'initiate_sign_out');

    if (Object(__WEBPACK_IMPORTED_MODULE_5__stores_get_store__["getStore"])('SyncStatusStore').isSocketConnected) {
      this.handleSocketConnectedCase();
    } else {
      this.handleSocketDisconnectedCase();
    }
  }

  handleClose() {
    this.syncManagerInternalChannelDisposer && this.syncManagerInternalChannelDisposer();

    this.setState({
      isOpen: false,
      isSigningOut: false,
      acceptForceSignout: true });


    /**
                                    * If the user's auth session is expired, then go back to the `session expired modal`
                                    * https://github.com/postmanlabs/postman-app-support/issues/4859
                                    */
    if (this.state.isSessionExpired) {
      pm.mediator.trigger('startReenterPassword');
    }
  }

  handleConfirm() {
    let currentUser = Object(__WEBPACK_IMPORTED_MODULE_5__stores_get_store__["getStore"])('CurrentUserStore'),
    logoutEvent = Object(__WEBPACK_IMPORTED_MODULE_3__modules_model_event__["a" /* createEvent */])('logout', 'user', { id: currentUser.id });

    this.setState({ isSigningOut: true });

    Object(__WEBPACK_IMPORTED_MODULE_4__modules_pipelines_app_action__["a" /* default */])(logoutEvent).
    then(() => {
      this.handleClose();
    }).
    catch(e => {
      pm.logger.warn('UserSignOutModalContainer~Error in logging out user ', e);

      this.setState({
        signInLoading: false,
        signInError: e, // @todo copy from vineeth
        isSigningOut: false,
        disableSignout: false,
        acceptForceSignout: true });

      this.handleClose();
    });

  }

  toggleSignoutCheck() {
    this.setState({
      acceptForceSignout: !this.state.acceptForceSignout });

  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_user_UserSignOutModal__["a" /* default */], {
        isSigningOut: this.state.isSigningOut,
        showWarning: this.state.showWarning,
        toggleSignoutCheck: this.toggleSignoutCheck,
        isLoading: this.state.isLoading,
        isOpen: this.state.isOpen,
        onClose: this.handleClose,
        onConfirm: this.handleConfirm,
        acceptForceSignout: this.state.acceptForceSignout }));


  }}) || _class;

/***/ }),

/***/ 4746:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return UserSignOutModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_LoadingIndicator__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_Icons_WarningIcon__ = __webpack_require__(657);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_Icons_SpannerIcon__ = __webpack_require__(3908);






let

UserSignOutModal = class UserSignOutModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.handleClose = this.handleClose.bind(this);
    this.handleConfirm = this.handleConfirm.bind(this);
    this.toggleSignoutCheck = this.toggleSignoutCheck.bind(this);
    this.renderModalContent = this.renderModalContent.bind(this);
  }

  handleClose() {
    this.props.onClose && this.props.onClose();
  }

  handleConfirm() {
    this.props.onConfirm && this.props.onConfirm();
  }

  toggleSignoutCheck() {
    this.props.toggleSignoutCheck && this.props.toggleSignoutCheck();
  }

  getCustomStyles() {
    return { marginTop: '35vh' };
  }

  renderModalContent() {
    let isLoading = this.props.isLoading,
    isSomethingWrong = !isLoading && this.props.showWarning;

    if (isLoading) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sign-out-loading--container--text' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'sign-out-loading--text' }, 'Checking for unsaved changes...'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_LoadingIndicator__["a" /* default */], { className: 'sign-out-loading-wrapper' })));


    } else

    if (isSomethingWrong) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sign-out-warning-container-wrapper' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sign-out-warning-container' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'sign-out-warning--header' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Icons_WarningIcon__["a" /* default */], { className: 'sign-out-warning--warning-icon' }), 'You have unsaved changes'),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('br', null),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sign-out-warning--text' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'You will lose your unsaved changes if you sign out now. To save your changes, follow these steps:'),

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('ul', { className: 'sign-out-warning--list' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('li', null, 'Export your data from ', __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Icons_SpannerIcon__["a" /* default */], { className: 'sign-out-settings-icon', size: 'xs' }), ' > Settings > Data to create a backup'),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('li', null, 'Ensure you have a working internet connection'),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('li', null, 'Quit the app (be sure to stay signed in)'),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('li', null, 'Re-open the app again')),

              ' ')),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null,
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Inputs__["a" /* Checkbox */], {
              className: 'sign-out-warning--checkbox',
              checked: this.props.acceptForceSignout,
              onChange: this.toggleSignoutCheck,
              disabled: this.props.isSigningOut }),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'sign-out-warning--checkbox-text' }, ' Sign out without saving my changes'))));



    }

    // nothing is wrong with data, allow signout
    else {
        return 'Signing out removes your synced history, collections and environments from local storage. You can access them again by signing back in anytime';
      }
  }

  render() {
    let disableSignout = this.props.isSigningOut || this.props.isLoading || this.props.showWarning && !this.props.acceptForceSignout;

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Modals__["a" /* Modal */], {
          isOpen: this.props.isOpen,
          className: 'user-signout-modal',
          customStyles: this.getCustomStyles() },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Modals__["d" /* ModalHeader */], null, 'SIGN OUT OF POSTMAN'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'user-signout-modal-message' },
            this.renderModalContent())),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Modals__["c" /* ModalFooter */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
              type: 'secondary',
              onClick: this.handleClose,
              disabled: this.props.isSigningOut }, 'Cancel'),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
              type: 'primary',
              onClick: this.handleConfirm,
              disabled: disableSignout },

            this.props.isSigningOut ? __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_LoadingIndicator__["a" /* default */], null) : 'Sign out and remove local data'))));




  }};


UserSignOutModal.defaultProps = { isLoading: false, isSigningOut: false };

/***/ }),

/***/ 4747:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return OpenExternalLinkModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__OpenExternalLinkModal__ = __webpack_require__(4748);
var _class;

let


OpenExternalLinkModalContainer = __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default()(_class = class OpenExternalLinkModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      url: '',
      cb: null };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleConfirm = this.handleConfirm.bind(this);
    this.handleClose = this.handleClose.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('showExternalNavigationModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showExternalNavigationModal', this.handleOpen);
  }

  handleOpen(href, callback) {
    this.setState({
      isOpen: true,
      url: href,
      cb: callback });

  }

  handleClose() {
    this.setState({
      isOpen: false,
      url: '',
      cb: null });
  }

  handleConfirm() {
    this.state.cb && _.isFunction(this.state.cb) && this.state.cb(true);
    this.handleClose();
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__OpenExternalLinkModal__["a" /* default */], {
        isOpen: this.state.isOpen,
        onClose: this.handleClose,
        onConfirm: this.handleConfirm,
        url: this.state.url }));


  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4748:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return OpenExternalLinkModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_base_Modals__ = __webpack_require__(189);


let

OpenExternalLinkModal = class OpenExternalLinkModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.handleClose = this.handleClose.bind(this);
    this.handleConfirm = this.handleConfirm.bind(this);
  }

  handleClose() {
    this.props.onClose && this.props.onClose();
  }

  handleConfirm() {
    this.props.onConfirm && this.props.onConfirm();
  }

  getCustomStyles() {
    return { marginTop: '35vh' };
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["a" /* Modal */], {
          isOpen: this.props.isOpen,
          onRequestClose: this.handleClose,
          className: 'open-external-link-modal',
          customStyles: this.getCustomStyles() },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["d" /* ModalHeader */], null, 'Opening external application'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'open-external-link-modal-body' }, 'You are trying to open a link using a non-standard protocol (HTTP/HTTPS). Are you sure you want to continue?',

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'open-external-link-modal-message' }, 'Link:',

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'open-external-link-modal-message-url' }, ' ', this.props.url)))),



        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["c" /* ModalFooter */], null,

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Buttons__["a" /* Button */], {
              type: 'secondary',
              onClick: this.handleConfirm }, 'Continue'),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Buttons__["a" /* Button */], {
              type: 'primary',
              onClick: this.handleClose }, 'Cancel'))));




  }};

/***/ }),

/***/ 4749:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return UserInvalidSessionModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_user_UserInvalidSessionModal__ = __webpack_require__(4750);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_pipelines_app_action__ = __webpack_require__(314);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__modules_model_event__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__modules_services_AuthHandlerService__ = __webpack_require__(532);
var _class;





let


UserInvalidSessionModalContainer = __WEBPACK_IMPORTED_MODULE_5_pure_render_decorator___default()(_class = class UserInvalidSessionModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = { isOpen: false };

    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleSignIn = this.handleSignIn.bind(this);
    this.handleSignOut = this.handleSignOut.bind(this);

    /**
                                                         * every time whenever there is a successful log in, then close
                                                         * the session expired modal if its already open.
                                                         *
                                                         * There may be pending requests which have got executed later and
                                                         * might have triggered this modal when the requester window was hidden
                                                         */
    pm.eventBus.channel('auth-handler-events').subscribe(event => {
      if (event && event.name === 'authenticated' && event.namespace === 'authentication') {
        this.handleClose && this.handleClose();
      }
    });
  }

  componentWillMount() {
    pm.mediator.on('startReenterPassword', this.handleOpen);

    // check if the current session is already locked
    // if the session is locked, the same event for showing this modal
    // (pm.mediator.trigger('startReenterPassword')) will be triggered
    pm.eventBus.channel('user-session-management').publish(Object(__WEBPACK_IMPORTED_MODULE_4__modules_model_event__["a" /* createEvent */])('isSessionLocked', 'sessionManagement'));
  }

  componentWillUnmount() {
    pm.mediator.off('startReenterPassword', this.handleOpen);
  }

  handleOpen() {
    this.setState({ isOpen: true });
  }

  handleClose() {
    this.setState({ isOpen: false });
  }

  handleSignIn() {
    // force locked login

    __WEBPACK_IMPORTED_MODULE_6__modules_services_AuthHandlerService__["a" /* default */].reAuthenticate();
    this.handleClose();
  }

  handleSignOut() {
    pm.mediator.trigger('showUserSignoutModal', { isSessionExpired: true });
    this.handleClose();
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_user_UserInvalidSessionModal__["a" /* default */], {
        isOpen: this.state.isOpen,
        onSignIn: this.handleSignIn,
        onSignOut: this.handleSignOut }));


  }}) || _class;

/***/ }),

/***/ 4750:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return UserInvalidSessionModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_keymaps_KeyMaps__ = __webpack_require__(72);



let

UserInvalidSessionModal = class UserInvalidSessionModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  getKeymapHandlers() {
    return { 'submit': pm.shortcuts.handle('submit', this.props.onSignOut) };
  }

  getCustomStyles() {
    return { marginTop: '35vh' };
  }

  render() {
    // This modal should not be close-able

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Modals__["a" /* Modal */], {
          customStyles: this.getCustomStyles(),
          isOpen: this.props.isOpen },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Modals__["d" /* ModalHeader */], null, 'Session Expired'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_keymaps_KeyMaps__["a" /* default */], { keyMap: pm.shortcuts.getShortcuts(), handlers: this.getKeymapHandlers() },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, 'Your session has expired. Please sign in again.'))),




        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Modals__["c" /* ModalFooter */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
              type: 'secondary',
              onClick: this.props.onSignOut }, 'Sign Out'),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
              type: 'primary',
              onClick: this.props.onSignIn }, 'Sign In'))));




  }};

/***/ }),

/***/ 4751:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SettingsModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_settings_SettingsTabs__ = __webpack_require__(4752);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_settings_SettingsTabContents__ = __webpack_require__(4753);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_settings_SettingsTabContent__ = __webpack_require__(4754);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__SettingsGeneralContainer__ = __webpack_require__(4755);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__SettingsThemesContainer__ = __webpack_require__(4759);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__SettingsSyncContainer__ = __webpack_require__(4761);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__SettingsProxyContainer__ = __webpack_require__(4763);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__SettingsUpdateContainer__ = __webpack_require__(4768);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__SettingsCertificatesContainer__ = __webpack_require__(4770);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__SettingsDataContainer__ = __webpack_require__(4775);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__SettingsShortcutsContainer__ = __webpack_require__(4777);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__SettingsAddonsContainer__ = __webpack_require__(4780);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__SettingsAboutContainer__ = __webpack_require__(4782);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__constants_SettingsTypeConstants__ = __webpack_require__(972);
var _class;

















let


SettingsModalContainer = __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default()(_class = class SettingsModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.state = {
      isOpen: false,
      activeTab: __WEBPACK_IMPORTED_MODULE_16__constants_SettingsTypeConstants__["e" /* SETTINGS_GENERAL */] };

    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleTabSelect = this.handleTabSelect.bind(this);

    this.attachModelListeners();
  }

  handleClose() {
    this.setState({ isOpen: false });
    pm.mediator.trigger('modalClosed', { name: 'settings' });
  }

  handleOpen(tab) {
    this.setState({
      isOpen: true,
      activeTab: tab || this.state.activeTab });

    pm.mediator.trigger('modalOpened', {
      name: 'settings',
      activeTab: tab || this.state.activeTab });

  }

  handleTabSelect(id) {
    if (id === this.state.activeTab) {
      return;
    }
    this.setState({ activeTab: id });
    pm.mediator.trigger('modalOpened', {
      name: 'settings',
      activeTab: id });

  }

  attachModelListeners() {
    pm.mediator.on('openSettingsModal', this.handleOpen, this);
    pm.mediator.on('closeSettingsModal', this.handleClose, this);

    // Documentation for registering menu actions can be found in App.js~registerMenuActions
    pm.shortcuts.registerMenuAction('openSettings', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('openSettingsModal', this.handleOpen);
    pm.mediator.off('closeSettingsModal', this.handleClose);
  }

  getCustomStyles() {
    return {
      marginTop: '20vh',
      width: '720px',
      height: '65vh' };

  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["a" /* Modal */], {
          isOpen: this.state.isOpen,
          onRequestClose: this.handleClose,
          customStyles: this.getCustomStyles(),
          className: 'settings-modal' },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["d" /* ModalHeader */], null, 'SETTINGS'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-container' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_settings_SettingsTabs__["a" /* default */], {
              onSelect: this.handleTabSelect,
              activeTab: this.state.activeTab }),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_settings_SettingsTabContents__["a" /* default */], {
                activeKey: this.state.activeTab },

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_settings_SettingsTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_16__constants_SettingsTypeConstants__["e" /* SETTINGS_GENERAL */] },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__SettingsGeneralContainer__["a" /* default */], null)),

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_settings_SettingsTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_16__constants_SettingsTypeConstants__["h" /* SETTINGS_THEMES */] },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__SettingsThemesContainer__["a" /* default */], null)),

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_settings_SettingsTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_16__constants_SettingsTypeConstants__["g" /* SETTINGS_SHORTCUTS */] },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_13__SettingsShortcutsContainer__["a" /* default */], null)),

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_settings_SettingsTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_16__constants_SettingsTypeConstants__["d" /* SETTINGS_DATA */] },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_12__SettingsDataContainer__["a" /* default */], null)),

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_settings_SettingsTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_16__constants_SettingsTypeConstants__["b" /* SETTINGS_ADDONS */] },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_14__SettingsAddonsContainer__["a" /* default */], null)),




              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_settings_SettingsTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_16__constants_SettingsTypeConstants__["c" /* SETTINGS_CERT */] },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_11__SettingsCertificatesContainer__["a" /* default */], null)),

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_settings_SettingsTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_16__constants_SettingsTypeConstants__["f" /* SETTINGS_PROXY */] },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_9__SettingsProxyContainer__["a" /* default */], null)),

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_settings_SettingsTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_16__constants_SettingsTypeConstants__["i" /* SETTINGS_UPDATE */] },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__SettingsUpdateContainer__["a" /* default */], null)),

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_settings_SettingsTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_16__constants_SettingsTypeConstants__["a" /* SETTINGS_ABOUT */] },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_15__SettingsAboutContainer__["a" /* default */], null)))))));






  }}) || _class;

/***/ }),

/***/ 4752:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SettingsTabs; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Tabs__ = __webpack_require__(103);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__constants_SettingsTypeConstants__ = __webpack_require__(972);



let

SettingsTabs = class SettingsTabs extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-tabs' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Tabs__["b" /* Tabs */], {
            type: 'primary',
            defaultActive: __WEBPACK_IMPORTED_MODULE_2__constants_SettingsTypeConstants__["e" /* SETTINGS_GENERAL */],
            activeRef: this.props.activeTab,
            onChange: this.props.onSelect },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Tabs__["a" /* Tab */], { refKey: __WEBPACK_IMPORTED_MODULE_2__constants_SettingsTypeConstants__["e" /* SETTINGS_GENERAL */] }, 'General'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Tabs__["a" /* Tab */], { refKey: __WEBPACK_IMPORTED_MODULE_2__constants_SettingsTypeConstants__["h" /* SETTINGS_THEMES */] }, 'Themes'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Tabs__["a" /* Tab */], { refKey: __WEBPACK_IMPORTED_MODULE_2__constants_SettingsTypeConstants__["g" /* SETTINGS_SHORTCUTS */] }, 'Shortcuts'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Tabs__["a" /* Tab */], { refKey: __WEBPACK_IMPORTED_MODULE_2__constants_SettingsTypeConstants__["d" /* SETTINGS_DATA */] }, 'Data'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Tabs__["a" /* Tab */], { refKey: __WEBPACK_IMPORTED_MODULE_2__constants_SettingsTypeConstants__["b" /* SETTINGS_ADDONS */] }, 'Add-ons'),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Tabs__["a" /* Tab */], { refKey: __WEBPACK_IMPORTED_MODULE_2__constants_SettingsTypeConstants__["c" /* SETTINGS_CERT */] }, 'Certificates'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Tabs__["a" /* Tab */], { refKey: __WEBPACK_IMPORTED_MODULE_2__constants_SettingsTypeConstants__["f" /* SETTINGS_PROXY */] }, 'Proxy'),
          pm.updateNotifier.get('isUpdateEnabled') && __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Tabs__["a" /* Tab */], { refKey: __WEBPACK_IMPORTED_MODULE_2__constants_SettingsTypeConstants__["i" /* SETTINGS_UPDATE */] }, 'Update'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Tabs__["a" /* Tab */], { refKey: __WEBPACK_IMPORTED_MODULE_2__constants_SettingsTypeConstants__["a" /* SETTINGS_ABOUT */] }, 'About'))));



  }};

/***/ }),

/***/ 4753:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SettingsTabContents; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
let

SettingsTabContents = class SettingsTabContents extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  render() {

    let children = __WEBPACK_IMPORTED_MODULE_0_react___default.a.Children.map(this.props.children, child => {
      return __WEBPACK_IMPORTED_MODULE_0_react___default.a.cloneElement(child, { active: this.props.activeKey === child.key });
    });
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-tab-contents' },
        children));


  }};

/***/ }),

/***/ 4754:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SettingsTabContent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_classnames__);

let

SettingsTabContent = class SettingsTabContent extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  getClasses() {
    return __WEBPACK_IMPORTED_MODULE_1_classnames___default()({
      'settings-tab-content': true,
      'is-hidden': !this.props.active },
    this.props.className);
  }

  render() {

    let classes = this.getClasses();

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: classes },
        this.props.children));


  }};

/***/ }),

/***/ 4755:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SettingsGeneralContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_settings_SettingsGeneral__ = __webpack_require__(4756);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__constants_RequesterTabLayoutConstants__ = __webpack_require__(63);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__constants_SettingsGeneralConstants__ = __webpack_require__(1507);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__modules_model_event__ = __webpack_require__(2);








const MB_MULTIPLIER = 1024 * 1024;let

SettingsGeneralContainer = class SettingsGeneralContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.state = {
      generalSettings: {
        trimKeysAndValues: true,
        experimentalCodegenMode: true,
        sendPostmanTokenHeader: true,
        sendNoCacheHeader: true,
        xhrTimeout: 2,
        maxResponseSize: 0,
        interceptorRedirect: true,
        requestNewTab: false,
        trackUnsavedRequests: true,
        responseFontSize: 12,
        retainLinkHeaders: false,
        languageDetection: 'Auto',
        instantDialogeBoxes: true,
        googleAnalytics: true,
        SSLCertVerify: false,
        requesterTabLayout: __WEBPACK_IMPORTED_MODULE_2__constants_RequesterTabLayoutConstants__["a" /* REQUESTER_TAB_LAYOUT_1_COLUMN */],
        variableAutocomplete: true,
        showJoinedWorkspaceModal: true,
        workingDir: '',
        insecureFileRead: false } };


    this.handleFieldChange = this.handleFieldChange.bind(this);
    this.handleConfigChange = this.handleConfigChange.bind(this);
  }

  componentWillMount() {
    this.model = pm.settings;
    this.setInitialValues();
  }

  componentWillUnmount() {
    this.model = null;
  }

  setInitialValues() {
    var settings = _.clone(this.state.generalSettings);
    for (let prop in settings) {
      if (settings.hasOwnProperty(prop)) {
        settings[prop] = pm.settings.getSetting(prop);

        if (prop === 'languageDetection' && settings[prop] === 'Auto') {
          settings[prop] = 'auto';
        }

        if (prop === 'maxResponseSize') {
          settings[prop] = parseInt(settings[prop]) / MB_MULTIPLIER; // Show in MB
        }
      }
    }

    this.setState({ generalSettings: settings });
  }

  handleFieldChange(key, value) {
    var settings = _.clone(this.state.generalSettings);
    if (key === 'requesterTabLayout') {
      value = value ? __WEBPACK_IMPORTED_MODULE_2__constants_RequesterTabLayoutConstants__["b" /* REQUESTER_TAB_LAYOUT_2_COLUMN */] : __WEBPACK_IMPORTED_MODULE_2__constants_RequesterTabLayoutConstants__["a" /* REQUESTER_TAB_LAYOUT_1_COLUMN */];
      this.toggleRequesterTabLayout(value);
    }

    if (key === `${__WEBPACK_IMPORTED_MODULE_3__constants_SettingsGeneralConstants__["c" /* CATEGORY_EDITOR */]}.${__WEBPACK_IMPORTED_MODULE_3__constants_SettingsGeneralConstants__["i" /* OPEN_IN_NEW */]}`) {
      this.handleConfigChange(`${__WEBPACK_IMPORTED_MODULE_3__constants_SettingsGeneralConstants__["c" /* CATEGORY_EDITOR */]}.${__WEBPACK_IMPORTED_MODULE_3__constants_SettingsGeneralConstants__["i" /* OPEN_IN_NEW */]}`, value);
    }

    if (key === `${__WEBPACK_IMPORTED_MODULE_3__constants_SettingsGeneralConstants__["c" /* CATEGORY_EDITOR */]}.${__WEBPACK_IMPORTED_MODULE_3__constants_SettingsGeneralConstants__["q" /* SKIP_CONFIRMATION_BEFORE_CLOSE */]}`) {
      this.handleConfigChange(`${__WEBPACK_IMPORTED_MODULE_3__constants_SettingsGeneralConstants__["c" /* CATEGORY_EDITOR */]}.${__WEBPACK_IMPORTED_MODULE_3__constants_SettingsGeneralConstants__["q" /* SKIP_CONFIRMATION_BEFORE_CLOSE */]}`, !value);
    }

    if (key === `${__WEBPACK_IMPORTED_MODULE_3__constants_SettingsGeneralConstants__["c" /* CATEGORY_EDITOR */]}.${__WEBPACK_IMPORTED_MODULE_3__constants_SettingsGeneralConstants__["p" /* SHOW_ICONS */]}`) {
      this.handleConfigChange(`${__WEBPACK_IMPORTED_MODULE_3__constants_SettingsGeneralConstants__["c" /* CATEGORY_EDITOR */]}.${__WEBPACK_IMPORTED_MODULE_3__constants_SettingsGeneralConstants__["p" /* SHOW_ICONS */]}`, value);
    }

    // value parameter is undefined when it has been triggered from toggler
    settings[key] = value !== undefined ? value : !settings[key];

    // Convert MB to Bytes after setting has been set
    if (key === 'maxResponseSize') {
      value = parseInt(value) * MB_MULTIPLIER;
    }

    if (value !== '') {
      // to prevent backspaced-blank values from being stored
      this.setSetting(key, value);
    }

    this.setState({ generalSettings: settings });
  }

  handleConfigChange(key, value) {
    Object(__WEBPACK_IMPORTED_MODULE_4__modules_pipelines_user_action__["a" /* default */])(Object(__WEBPACK_IMPORTED_MODULE_5__modules_model_event__["a" /* createEvent */])('update', 'userconfigs', { [key]: value })).
    catch(() => {
      pm.toasts.error('Something went wrong while updating this setting');
    });
  }

  toggleRequesterTabLayout(nextLayout) {
    pm.app.getCurrentLayout() !== nextLayout &&
    pm.app.toggleLayout();
  }

  setSetting(key, value) {
    this.model.setSetting(key, value);
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_settings_SettingsGeneral__["a" /* default */], {
        generalSettings: this.state.generalSettings,
        onFieldChange: this.handleFieldChange,
        onConfigChange: this.handleConfigChange }));


  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4756:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SettingsGeneral; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__SettingsValueDropdown__ = __webpack_require__(4757);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__SettingsValueInput__ = __webpack_require__(4758);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_ToggleSwitch__ = __webpack_require__(959);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_WarningButton__ = __webpack_require__(671);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_Icons_WarningIcon__ = __webpack_require__(657);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__external_navigation_ExternalNavigationService__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__utils_FsHelper__ = __webpack_require__(366);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__constants_SettingsGeneralConstants__ = __webpack_require__(1507);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__constants_RequesterTabLayoutConstants__ = __webpack_require__(63);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__constants_AppUrlConstants__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__constants_FsConstants__ = __webpack_require__(1624);
var _class;



















const languageDetectionLabelMap = {
  'auto': 'Auto',
  'JSON': 'JSON' };let



SettingsGeneral = Object(__WEBPACK_IMPORTED_MODULE_9_mobx_react__["a" /* observer */])(_class = class SettingsGeneral extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = { isWorkingDirAccessible: true };

    this.handleFileSelect = this.handleFileSelect.bind(this);
  }

  componentDidMount() {
    this.setWorkingDirAccess(this.props.generalSettings.workingDir);
  }

  setWorkingDirAccess(directory) {
    // If no directory selected then set the default working-dir
    !directory && (directory = __WEBPACK_IMPORTED_MODULE_15__constants_FsConstants__["a" /* DEFAULT_WORKING_DIR */]);

    Object(__WEBPACK_IMPORTED_MODULE_11__utils_FsHelper__["d" /* pathAccessible */])(directory, err => {
      if (err) {
        pm.logger.warn('SettingsGeneral~setWorkingDirAccess - Directory not accessible', err);
        this.setState({ isWorkingDirAccessible: false });
      } else {
        this.setState({ isWorkingDirAccessible: true });
      }
    });
  }

  handleFieldChange(key, value) {
    this.props.onFieldChange && this.props.onFieldChange(key, value);
  }

  handleConfigChange(key, value) {
    if (!key) {
      return;
    }

    this.props.onConfigChange && this.props.onConfigChange(key, value);
  }

  handleFileSelect() {
    const { dialog } = __webpack_require__(21).remote;

    dialog.showOpenDialog({
      buttonLabel: 'Select',
      properties: ['openDirectory', 'createDirectory'] },
    folderNames => {
      if (_.isArray(folderNames) && folderNames.length === 1) {
        this.setWorkingDirAccess(folderNames[0]);
        this.handleFieldChange(__WEBPACK_IMPORTED_MODULE_12__constants_SettingsGeneralConstants__["u" /* WORKING_DIR */], folderNames[0]);
      }
    });
  }

  render() {
    let generalSettingsObj = this.props.generalSettings,
    generalSettingsLanguageDetection = languageDetectionLabelMap[generalSettingsObj.languageDetection],
    configsMap = Object(__WEBPACK_IMPORTED_MODULE_8__stores_get_store__["getStore"])('ConfigurationStore').configs,
    workingDir = generalSettingsObj.workingDir || __WEBPACK_IMPORTED_MODULE_15__constants_FsConstants__["a" /* DEFAULT_WORKING_DIR */];

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-wrapper' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-group' }, 'REQUEST'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-label' }, 'Trim keys and values in request body'),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-value' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_ToggleSwitch__["a" /* default */], {
                isActive: generalSettingsObj.trimKeysAndValues,
                onClick: this.handleFieldChange.bind(this, __WEBPACK_IMPORTED_MODULE_12__constants_SettingsGeneralConstants__["s" /* TRIM_KEYS_AND_VALUES */]) }))),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-label' }, 'Experimental Codegen mode'),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-value experimental-codegen-mode' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_ToggleSwitch__["a" /* default */], {
                isActive: generalSettingsObj.experimentalCodegenMode,
                onClick: this.handleFieldChange.bind(this, __WEBPACK_IMPORTED_MODULE_12__constants_SettingsGeneralConstants__["e" /* EXPERIMENTAL_CODEGEN_MODE */]) }))),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item settings-general-list-item--ssl-verification' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-label' }, 'SSL certificate verification'),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-value' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_ToggleSwitch__["a" /* default */], {
                isActive: generalSettingsObj.SSLCertVerify,
                onClick: this.handleFieldChange.bind(this, __WEBPACK_IMPORTED_MODULE_12__constants_SettingsGeneralConstants__["r" /* SSL_CERT_VERIFY */]) }))),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-label' }, 'Always open requests in new tab'),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-value' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_ToggleSwitch__["a" /* default */], {
                isActive: configsMap.get(`${__WEBPACK_IMPORTED_MODULE_12__constants_SettingsGeneralConstants__["c" /* CATEGORY_EDITOR */]}.${__WEBPACK_IMPORTED_MODULE_12__constants_SettingsGeneralConstants__["i" /* OPEN_IN_NEW */]}`),
                onClick: this.handleFieldChange.bind(this, `${__WEBPACK_IMPORTED_MODULE_12__constants_SettingsGeneralConstants__["c" /* CATEGORY_EDITOR */]}.${__WEBPACK_IMPORTED_MODULE_12__constants_SettingsGeneralConstants__["i" /* OPEN_IN_NEW */]}`) }))),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-label' }, 'Always ask when closing unsaved tabs'),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-value' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_ToggleSwitch__["a" /* default */], {
                isActive: !configsMap.get(`${__WEBPACK_IMPORTED_MODULE_12__constants_SettingsGeneralConstants__["c" /* CATEGORY_EDITOR */]}.${__WEBPACK_IMPORTED_MODULE_12__constants_SettingsGeneralConstants__["q" /* SKIP_CONFIRMATION_BEFORE_CLOSE */]}`),
                onClick: this.handleFieldChange.bind(this, `${__WEBPACK_IMPORTED_MODULE_12__constants_SettingsGeneralConstants__["c" /* CATEGORY_EDITOR */]}.${__WEBPACK_IMPORTED_MODULE_12__constants_SettingsGeneralConstants__["q" /* SKIP_CONFIRMATION_BEFORE_CLOSE */]}`) }))),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-label' }, 'Language detection'),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-value' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__SettingsValueDropdown__["a" /* default */], {
                value: generalSettingsLanguageDetection,
                options: ['auto', 'JSON'],
                labels: ['Auto', 'JSON'],
                onValueChange: this.handleFieldChange.bind(this, __WEBPACK_IMPORTED_MODULE_12__constants_SettingsGeneralConstants__["g" /* LANGUAGE_DETECTION */]) }))),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item settings-general-list-item--xhr-timeout' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-label' }, 'Request timeout in ms (0 for infinity)'),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-value' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__SettingsValueInput__["a" /* default */], {
                value: generalSettingsObj.xhrTimeout,
                onValueChange: this.handleFieldChange.bind(this, __WEBPACK_IMPORTED_MODULE_12__constants_SettingsGeneralConstants__["v" /* XHR_TIMEOUT */]) }))),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item settings-general-list-item--max-res-size' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-label' }, 'Max response size in MB (0 to infinity)'),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-value' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__SettingsValueInput__["a" /* default */], {
                value: generalSettingsObj.maxResponseSize,
                onValueChange: this.handleFieldChange.bind(this, __WEBPACK_IMPORTED_MODULE_12__constants_SettingsGeneralConstants__["h" /* MAX_RESPONSE_SIZE */]) }))),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item settings-general-list-item--auto-persist-variables' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-label ' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, 'Automatically persist variable values'),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item--auto-persist-variables_help-text' }, 'Enabling this will persist the current value of variables to the initial value at the end of every request execution.',


                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item--auto-persist-variables_help-link' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Buttons__["a" /* Button */], {
                      className: 'learn-more-link',
                      type: 'text',
                      onClick: () => Object(__WEBPACK_IMPORTED_MODULE_10__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_14__constants_AppUrlConstants__["_16" /* VARIABLE_DOCS */]) }, 'Learn more about variable values')))),






            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-value' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_ToggleSwitch__["a" /* default */], {
                isActive: configsMap.get(`${__WEBPACK_IMPORTED_MODULE_12__constants_SettingsGeneralConstants__["d" /* CATEGORY_REQUEST */]}.${__WEBPACK_IMPORTED_MODULE_12__constants_SettingsGeneralConstants__["b" /* AUTO_PERSIST_VARIABLES */]}`),
                onClick: this.handleConfigChange.bind(this, `${__WEBPACK_IMPORTED_MODULE_12__constants_SettingsGeneralConstants__["d" /* CATEGORY_REQUEST */]}.${__WEBPACK_IMPORTED_MODULE_12__constants_SettingsGeneralConstants__["b" /* AUTO_PERSIST_VARIABLES */]}`) }))),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-separator' }),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-group' }, 'WORKING DIRECTORY'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-label' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item--working-dir_help-text' }, 'Collaborate on files used in requests by sharing your working directory.',

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item--working-dir_help-link' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Buttons__["a" /* Button */], {
                      className: 'learn-more-link',
                      type: 'text',
                      onClick: () => Object(__WEBPACK_IMPORTED_MODULE_10__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_14__constants_AppUrlConstants__["_19" /* WORKING_DIR_DOCS */]) }, 'Learn how to set up your working directory'))))),







          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item settings-general-list-item--working-dir' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-label' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-label--working-dir_label' }, 'Location',


                !this.state.isWorkingDirAccessible &&
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_WarningButton__["a" /* default */], { tooltip: 'The selected working directory does not exist' })),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item--working-dir_value' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item--working-dir_file-input', title: workingDir },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_Inputs__["b" /* Input */], {
                    inputStyle: 'box',
                    type: 'text',
                    value: workingDir,
                    disabled: true })),


                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item--working-dir_file-button' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Buttons__["a" /* Button */], {
                      className: 'working-dir__file-chooser',
                      type: 'secondary',
                      size: 'small',
                      onClick: this.handleFileSelect }, 'Choose'))))),







          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item settings-general-list-item--insecure-fileread' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-label' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, 'Allow reading files outside working directory'),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item--insecure-fileread_warn-text' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Icons_WarningIcon__["a" /* default */], { className: 'warning-icon', size: 'xs' }), 'Enabling this will allow any 3rd party collections to potentially read any file on your system.')),



            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-value' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_ToggleSwitch__["a" /* default */], {
                isActive: generalSettingsObj.insecureFileRead,
                onClick: this.handleFieldChange.bind(this, __WEBPACK_IMPORTED_MODULE_12__constants_SettingsGeneralConstants__["f" /* INSECURE_FILEREAD */]) })))),




        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-group' }, 'HEADERS'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-label' }, 'Send no-cache header'),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-value' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_ToggleSwitch__["a" /* default */], {
                isActive: generalSettingsObj.sendNoCacheHeader,
                onClick: this.handleFieldChange.bind(this, __WEBPACK_IMPORTED_MODULE_12__constants_SettingsGeneralConstants__["n" /* SEND_NO_CACHE_HEADER */]) }))),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-label' }, 'Send Postman Token header'),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-value' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_ToggleSwitch__["a" /* default */], {
                isActive: generalSettingsObj.sendPostmanTokenHeader,
                onClick: this.handleFieldChange.bind(this, __WEBPACK_IMPORTED_MODULE_12__constants_SettingsGeneralConstants__["o" /* SEND_POSTMAN_TOKEN_HEADER */]) }))),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-label' }, 'Retain headers when clicking on links'),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-value' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_ToggleSwitch__["a" /* default */], {
                isActive: generalSettingsObj.retainLinkHeaders,
                onClick: this.handleFieldChange.bind(this, __WEBPACK_IMPORTED_MODULE_12__constants_SettingsGeneralConstants__["l" /* RETAIN_HEADERS */]) }))),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-label' }, 'Automatically follow redirects'),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-value' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_ToggleSwitch__["a" /* default */], {
                isActive: generalSettingsObj.interceptorRedirect,
                onClick: this.handleFieldChange.bind(this, __WEBPACK_IMPORTED_MODULE_12__constants_SettingsGeneralConstants__["a" /* AUTO_FOLLOW_REDIRECTS */]) }))),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item settings-general-list-item--postman-token' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-label' }, 'Send anonymous usage data to Postman'),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-value' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_ToggleSwitch__["a" /* default */], {
                isActive: generalSettingsObj.googleAnalytics,
                onClick: this.handleFieldChange.bind(this, __WEBPACK_IMPORTED_MODULE_12__constants_SettingsGeneralConstants__["m" /* SEND_ANONYMOUS_DATA */]) }))),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-separator' }),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-group' }, 'USER INTERFACE'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-label' }, 'Editor Font Size (px)'),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-value' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__SettingsValueInput__["a" /* default */], {
                value: generalSettingsObj.responseFontSize,
                onValueChange: this.handleFieldChange.bind(this, __WEBPACK_IMPORTED_MODULE_12__constants_SettingsGeneralConstants__["k" /* RESPONSE_FONT_SIZE */]) }))),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-label' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Two-pane view')),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-value' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_ToggleSwitch__["a" /* default */], {
                isActive: generalSettingsObj.requesterTabLayout === __WEBPACK_IMPORTED_MODULE_13__constants_RequesterTabLayoutConstants__["b" /* REQUESTER_TAB_LAYOUT_2_COLUMN */],
                onClick: this.handleFieldChange.bind(this, __WEBPACK_IMPORTED_MODULE_12__constants_SettingsGeneralConstants__["j" /* REQUESTER_TAB_LAYOUT */]) }))),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-label' }, 'Show icons with tab names'),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-value' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_ToggleSwitch__["a" /* default */], {
                isActive: configsMap.get(`${__WEBPACK_IMPORTED_MODULE_12__constants_SettingsGeneralConstants__["c" /* CATEGORY_EDITOR */]}.${__WEBPACK_IMPORTED_MODULE_12__constants_SettingsGeneralConstants__["p" /* SHOW_ICONS */]}`),
                onClick: this.handleFieldChange.bind(this, `${__WEBPACK_IMPORTED_MODULE_12__constants_SettingsGeneralConstants__["c" /* CATEGORY_EDITOR */]}.${__WEBPACK_IMPORTED_MODULE_12__constants_SettingsGeneralConstants__["p" /* SHOW_ICONS */]}`) }))),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-label' }, 'Variable autocomplete'),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-general-list-item-value' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_ToggleSwitch__["a" /* default */], {
                isActive: generalSettingsObj.variableAutocomplete,
                onClick: this.handleFieldChange.bind(this, __WEBPACK_IMPORTED_MODULE_12__constants_SettingsGeneralConstants__["t" /* VARIABLE_AUTOCOMPLETE */]) }))))));






  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4757:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SettingsValueDropdown; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__ = __webpack_require__(31);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Buttons__ = __webpack_require__(13);


let

SettingsValueDropdown = class SettingsValueDropdown extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.handleValueSelect = this.handleValueSelect.bind(this);
  }
  handleValueSelect(value) {
    this.props.onValueChange && this.props.onValueChange(value);
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["a" /* Dropdown */], {
          onSelect: this.handleValueSelect },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["b" /* DropdownButton */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], null, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, this.props.value))),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["c" /* DropdownMenu */], { fluid: true },

          this.props.options.map((option, index) => {
            return __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], { refKey: option, key: option, 'align-center': true }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, this.props.labels[index]));
          }))));




  }};

/***/ }),

/***/ 4758:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SettingsValueInput; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Inputs__ = __webpack_require__(55);

let

SettingsValueInput = class SettingsValueInput extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.handleValueChange = this.handleValueChange.bind(this);
  }
  handleValueChange(value) {
    this.props.onValueChange && this.props.onValueChange(value);
  }

  render() {

    let value = this.props.value,
    placeholder = this.props.placeholder;
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Inputs__["b" /* Input */], {
        inputStyle: 'box',
        type: 'text',
        value: value,
        placeholder: placeholder,
        onChange: this.handleValueChange }));


  }};

/***/ }),

/***/ 4759:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SettingsAddonsContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__controllers_theme_ThemeManager__ = __webpack_require__(318);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_settings_SettingsThemes__ = __webpack_require__(4760);


let

SettingsAddonsContainer = class SettingsAddonsContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.state = { currentTheme: 'light' };
    this.handleThemeSelect = this.handleThemeSelect.bind(this);
  }

  componentWillMount() {
    this.setState({ currentTheme: pm.settings.getSetting('postmanTheme') });
  }

  handleThemeSelect(theme) {
    if (this.state.currentTheme === theme) {
      return;
    }
    __WEBPACK_IMPORTED_MODULE_1__controllers_theme_ThemeManager__["a" /* default */].changeTheme(theme).then(data => {
      this.setState({ currentTheme: data.currentTheme });
    });
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_settings_SettingsThemes__["a" /* default */], {
        currentTheme: this.state.currentTheme,
        onThemeSelect: this.handleThemeSelect }));


  }};

/***/ }),

/***/ 4760:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SettingsThemes; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_classnames__);

let

SettingsThemes = class SettingsThemes extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  handleThemeSelect(theme) {
    this.props.onThemeSelect && this.props.onThemeSelect(theme);
  }

  getThumbnailClasses(theme) {
    let isActive = _.includes(this.props.currentTheme, theme);

    return __WEBPACK_IMPORTED_MODULE_1_classnames___default()({
      'settings-theme-thumbnail': true,
      'active': isActive,
      'light-theme': theme === 'light',
      'dark-theme': theme === 'dark' });

  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-themes-wrapper' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-themes-description' }, 'Choose either the light or dark theme for the Postman app.'),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-themes-list' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
            className: this.getThumbnailClasses('light'),
            onClick: this.handleThemeSelect.bind(this, 'light') }),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
            className: this.getThumbnailClasses('dark'),
            onClick: this.handleThemeSelect.bind(this, 'dark') }))));




  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4761:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* unused harmony export default */
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_settings_SettingsSync__ = __webpack_require__(4762);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__modules_services_AuthHandlerService__ = __webpack_require__(532);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__external_navigation_ExternalNavigationService__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__constants_AppUrlConstants__ = __webpack_require__(64);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _class;







let


SettingsSyncContainer = Object(__WEBPACK_IMPORTED_MODULE_1_mobx_react__["a" /* observer */])(_class = class SettingsSyncContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isDisableSuccessful: false,
      isDisablingSync: false };


    this.handleDisableSync = this.handleDisableSync.bind(this);
    this.handleEnableSync = this.handleEnableSync.bind(this);
    this.handleForceSync = this.handleForceSync.bind(this);
    this.handleSignIn = this.handleSignIn.bind(this);
  }

  handleForceSync() {
    let isInSync = Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('SyncStatusStore').isInSync;
    if (!isInSync) {
      return;
    }

    pm.syncManager.forceSync();
    __WEBPACK_IMPORTED_MODULE_5__modules_services_AnalyticsService__["a" /* default */].addEvent('sync', 'force');
  }

  handleSignIn() {
    pm.mediator.trigger('closeSettingsModal');
    __WEBPACK_IMPORTED_MODULE_6__modules_services_AuthHandlerService__["a" /* default */].login();
  }

  handleEnableSync() {
    Object(__WEBPACK_IMPORTED_MODULE_7__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_8__constants_AppUrlConstants__["A" /* ENABLE_SYNC_DOCS_URL */]);
  }

  handleDisableSync() {
    Object(__WEBPACK_IMPORTED_MODULE_3__modules_pipelines_user_action__["a" /* default */])({ name: 'disableSync', namespace: 'user' }).
    then(() => {
      __WEBPACK_IMPORTED_MODULE_5__modules_services_AnalyticsService__["a" /* default */].addEvent('sync', 'disable');
      this.setState({
        isDisablingSync: false,
        isSyncEnabled: false,
        isDisableSuccessful: true });

    }).
    catch(e => {
      this.setState({ isDisablingSync: false });
      pm.toasts.error('Disabling the Sync action failed');
    });
  }

  render() {
    let currentUser = Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('CurrentUserStore'),
    gateKeeperStore = Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('GateKeeperStore'),
    isInSync = Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('SyncStatusStore').isInSync;

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_settings_SettingsSync__["a" /* default */], _extends({
        isSyncEnabled: gateKeeperStore.isSyncEnabled,
        isLoggedIn: currentUser.isLoggedIn,
        isInSync: isInSync },
      this.state, {
        onDisableSync: this.handleDisableSync,
        onEnableSync: this.handleEnableSync,
        onForceSync: this.handleForceSync,
        onSignin: this.handleSignIn })));


  }}) || _class;

/***/ }),

/***/ 4762:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SettingsSync; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__constants_AppUrlConstants__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__external_navigation_ExternalNavigationService__ = __webpack_require__(59);



let
SettingsSync = class SettingsSync extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.handleContactFormClick = this.handleContactFormClick.bind(this);
  }

  handleContactFormClick(e) {
    e.stopPropagation();
    e.preventDefault();
    Object(__WEBPACK_IMPORTED_MODULE_3__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(e.target.href);
  }

  handleSyncDocumentation() {
    Object(__WEBPACK_IMPORTED_MODULE_3__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_2__constants_AppUrlConstants__["_9" /* SYNC_DOCS */]);
  }

  render() {

    if (!this.props.isLoggedIn) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-sync-signed-out-container' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'modal-text' }, 'Syncing is a process that makes all your Postman data available wherever you\'re signed in to your Postman account. Any changes (edits, additions, deletions) you make will be synced across all devices linked to your account.'),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('br', null),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                type: 'text',
                onClick: this.handleSyncDocumentation }, 'Learn more about syncing')),




          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
              className: 'signout-out-signin-btn',
              size: 'huge',
              type: 'primary',
              onClick: this.props.onSignin }, 'Sign in to Postman')));





    }


    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-sync-wrapper' },

        this.props.isSyncEnabled ?
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-sync-header-description' }, 'If your data has not synced properly, click to manually re-sync.'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                disabled: !this.props.isInSync,
                type: 'secondary',
                onClick: this.props.onForceSync }, 'Re-sync')),





          _.includes(['dev', 'stage'], window.RELEASE_CHANNEL) &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-sync-section-separator' }),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-sync-header-description' }, 'Deactivate Postman Sync for your account'),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                  type: 'secondary',
                  onClick: this.props.onDisableSync }, 'Disable sync')))) :









        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-sync-header-description' }, 'Deactivate Postman Sync for your account:'),



          this.props.isDisableSuccessful &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-sync-header-description' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Sync has been disabled for your account. Please restart the app WITHOUT signing out to deactivate Sync. We would be grateful if you could share your feedback '),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('a', {
                className: 'settings-sync-feedback-link',
                href: __WEBPACK_IMPORTED_MODULE_2__constants_AppUrlConstants__["_10" /* SYNC_FEEDBACK */],
                onClick: this.handleContactFormClick }, 'through this form')),





          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                type: 'secondary',
                onClick: this.props.onEnableSync }, 'Enable Sync')))));









  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4763:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SettingsProxyContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_settings_proxy_SettingsCustomProxy__ = __webpack_require__(4764);



const MIN_PORT = 1,
MAX_PORT = 65535;let

SettingsProxyContainer = class SettingsProxyContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.handleToggleSystemProxy = this.handleToggleSystemProxy.bind(this);
    this.handleToggleProxyEnvironmentVariables = this.handleToggleProxyEnvironmentVariables.bind(this);
    this.handleSaveGlobalProxy = this.handleSaveGlobalProxy.bind(this);
    this.handleUpdateGlobalProxyProperty = this.handleUpdateGlobalProxyProperty.bind(this);
  }

  componentWillMount() {
    this.setState({
      errors: { globalProxy: {} },
      globalProxy: pm.proxyListManager.globalProxy,
      useSystemProxy: pm.settings.getSetting('useSystemProxy'),
      useProxyEnvironmentVariables: pm.settings.getSetting('useProxyEnvironmentVariables') });

  }

  handleToggleSystemProxy(useSystemProxy) {
    this.setState({ useSystemProxy }, () => {
      pm.settings.setSetting('useSystemProxy', useSystemProxy);
    });
  }

  handleToggleProxyEnvironmentVariables(useProxyEnvironmentVariables) {
    this.setState({ useProxyEnvironmentVariables }, () => {
      pm.settings.setSetting('useProxyEnvironmentVariables', useProxyEnvironmentVariables);
    });
  }

  handleSaveGlobalProxy() {
    let globalProxy = _.clone(this.state.globalProxy);

    if (!this.validateProxyConfig(globalProxy)) {
      return;
    }

    pm.proxyListManager.update({ globalProxy });
    pm.proxyListManager.saveToDB();
  }


  handleUpdateGlobalProxyProperty(key, value, cb) {
    let globalProxy = _.clone(this.state.globalProxy);

    globalProxy[key] = value;

    this.setState({ globalProxy: globalProxy }, cb);
  }

  validateProxyConfig(proxyConfig) {
    let errors = _.clone(this.state.errors),
    validHost = this.isValidHost(proxyConfig.host),
    validPort = this.isValidPort(proxyConfig.port);

    errors.globalProxy.host = validHost ? null : 'Invalid Host';
    errors.globalProxy.port = validPort ? null : 'Invalid Port';

    this.setState({ errors: errors });
    return validHost && validPort;
  }

  isValidHost(host) {
    return !_.isEmpty(host);
  }

  isValidPort(port) {
    return _.isInteger(port) && port >= MIN_PORT && port <= MAX_PORT;
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_settings_proxy_SettingsCustomProxy__["a" /* default */], {
        errors: this.state.errors,
        globalProxy: this.state.globalProxy,
        useSystemProxy: this.state.useSystemProxy,
        useProxyEnvironmentVariables: this.state.useProxyEnvironmentVariables,
        onSaveGlobalProxy: this.handleSaveGlobalProxy,
        onToggleSystemProxy: this.handleToggleSystemProxy,
        onUpdateGlobalProxy: this.handleUpdateGlobalProxyProperty,
        onToggleProxyEnvironmentVariables: this.handleToggleProxyEnvironmentVariables }));


  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4764:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SettingsCustomProxy; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_prop_types__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_prop_types___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_prop_types__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__SettingsSystemProxy__ = __webpack_require__(4765);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__SettingsGlobalProxy__ = __webpack_require__(4766);



let

SettingsCustomProxy = class SettingsCustomProxy extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-custom-proxy' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__SettingsGlobalProxy__["a" /* default */], {
          proxy: this.props.globalProxy,
          errors: this.props.errors.globalProxy,
          onSave: this.props.onSaveGlobalProxy,
          onUpdate: this.props.onUpdateGlobalProxy }),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'divider' }),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__SettingsSystemProxy__["a" /* default */], {
          useSystemProxy: this.props.useSystemProxy,
          onToggleSystemProxy: this.props.onToggleSystemProxy,
          useProxyEnvironmentVariables: this.props.useProxyEnvironmentVariables,
          onToggleProxyEnvironmentVariables: this.props.onToggleProxyEnvironmentVariables })));




  }};


SettingsCustomProxy.propTypes = {
  globalProxy: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.object.isRequired,
  onSaveGlobalProxy: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.func.isRequired,
  onToggleSystemProxy: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.func.isRequired,
  onUpdateGlobalProxy: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.func.isRequired,
  useSystemProxy: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.bool.isRequired };


SettingsCustomProxy.defaultProps = {
  onSaveGlobalProxy: _.noop,
  onToggleSystemProxy: _.noop,
  onUpdateGlobalProxy: _.noop,
  errors: { globalProxy: {} },
  useSystemProxy: true };
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4765:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SettingsSystemProxy; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_prop_types__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_prop_types___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_prop_types__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_ToggleSwitch__ = __webpack_require__(959);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_classnames__);




let

SettingsSystemProxy = class SettingsSystemProxy extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  render() {
    let { useSystemProxy, useProxyEnvironmentVariables } = this.props,
    proxyVarsClassName = __WEBPACK_IMPORTED_MODULE_4_classnames___default()({
      'proxy-environment-variables': true,
      disabled: !useSystemProxy });


    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-system-proxy' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'item-header' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('h4', { className: 'item-title' }, 'Use System Proxy'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_ToggleSwitch__["a" /* default */], {
            isActive: useSystemProxy,
            onClick: this.props.onToggleSystemProxy })),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, 'Enable this option to allow Postman to use the system\'s default proxy configurations.'),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: proxyVarsClassName },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Inputs__["a" /* Checkbox */], {
            checked: Boolean(useProxyEnvironmentVariables),
            disabled: !useSystemProxy,
            onChange: this.props.onToggleProxyEnvironmentVariables }),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Respect HTTP_PROXY, HTTPS_PROXY, and NO_PROXY environment variables.'))));




  }};


SettingsSystemProxy.propTypes = {
  onToggleSystemProxy: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.func.isRequired,
  useSystemProxy: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.bool.isRequired };


SettingsSystemProxy.defaultProps = {
  useSystemProxy: true,
  onToggleSystemProxy: _.noop };
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4766:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SettingsGlobalProxy; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_prop_types__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_prop_types___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_prop_types__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_InfoButton__ = __webpack_require__(222);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_TextArea__ = __webpack_require__(962);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_ToggleSwitch__ = __webpack_require__(959);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__external_navigation_ExternalNavigationService__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_8_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__base_PasswordInput__ = __webpack_require__(3747);











const proxyDocLink = 'https://go.pstmn.io/proxy-doc',

propsToSave = {
  httpProxy: true,
  httpsProxy: true,
  disabled: true,
  authenticate: true };let


SettingsGlobalProxy = class SettingsGlobalProxy extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.handleOnSave = this.handleOnSave.bind(this);

    this.handleProxyDisableChange = this.handleProxyPropertyChange.bind(this, 'disabled');
    this.handleHttpProtocolChange = this.handleProtocolChange.bind(this, 'httpProxy');
    this.handleHttpsProtocolChange = this.handleProtocolChange.bind(this, 'httpsProxy');

    this.handleProxyHostChange = this.handleProxyPropertyChange.bind(this, 'host');
    this.handleProxyPortChange = this.handleProxyPropertyChange.bind(this, 'port');

    this.handleProxyAuthEnableChange = this.handleProxyPropertyChange.bind(this, 'authenticate');
    this.handleProxyAuthUsernameChange = this.handleProxyPropertyChange.bind(this, 'username');
    this.handleProxyAuthPasswordChange = this.handleProxyPropertyChange.bind(this, 'password');

    this.handleProxyBypassChange = this.handleProxyPropertyChange.bind(this, 'bypass');
  }

  handleProxyDocumentation() {
    Object(__WEBPACK_IMPORTED_MODULE_7__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(proxyDocLink);
  }

  handleOnSave() {
    this.props.onSave();
  }

  handleProxyPropertyChange(key, value) {
    var finalValue = value;

    if (key === 'port') {
      finalValue = parseInt(value, 10);
    } else
    if (key === 'disabled') {
      finalValue = !value;
    }

    // @note: don't update local storage on input (e.g, host, port) onChange
    this.props.onUpdate(key, finalValue, () => {
      if (propsToSave[key]) {
        this.handleOnSave();
      }
    });
  }

  handleProtocolChange(prop, change) {
    let { httpProxy, httpsProxy } = this.props.proxy;

    if (prop === 'httpProxy') {
      httpProxy = change;
    } else
    {
      httpsProxy = change;
    }

    // both can't be turned off
    if (!httpProxy && !httpsProxy) {
      return;
    }

    this.handleProxyPropertyChange(prop, change);
  }

  render() {
    let proxy = this.props.proxy || {},
    disabled = proxy.disabled,
    hostError = this.props.errors.host,
    portError = this.props.errors.port,
    proxyAuthClassName = __WEBPACK_IMPORTED_MODULE_8_classnames___default()({
      'settings-global-proxy-group': true,
      secondary: true,
      disabled: !proxy.authenticate || disabled }),

    proxyBypassClassName = __WEBPACK_IMPORTED_MODULE_8_classnames___default()({
      'settings-global-proxy-group': true,
      secondary: true,
      disabled: disabled });


    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-global-proxy' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'item-header' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('h4', { className: 'item-title' }, 'Global Proxy Configuration'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_ToggleSwitch__["a" /* default */], {
            isActive: !disabled,
            onClick: this.handleProxyDisableChange })),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-global-proxy-desc' }, 'Specify a global proxy setting to act as an intermediary for requests sent to the server.',

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Buttons__["a" /* Button */], {
              className: 'learn-more-button',
              type: 'text',
              onClick: this.handleProxyDocumentation }, 'Learn more about using a global proxy')),





        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-global-proxy-group ' + (disabled ? 'disabled' : '') },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-global-proxy-group-row' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'row-label' }, 'Proxy Type'),



            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'row-values' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'row-value protocol-http' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Inputs__["a" /* Checkbox */], {
                  checked: Boolean(proxy.httpProxy),
                  disabled: disabled,
                  onChange: this.handleHttpProtocolChange }),

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'HTTP')),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'row-value protocol-https' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Inputs__["a" /* Checkbox */], {
                  checked: Boolean(proxy.httpsProxy),
                  disabled: disabled,
                  onChange: this.handleHttpsProtocolChange }),

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'HTTPS')))),




          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-global-proxy-group-row' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'row-label' }, 'Proxy Server'),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'row-values' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'proxy-server-host' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Inputs__["b" /* Input */], {
                  disabled: disabled,
                  error: hostError,
                  inputStyle: 'box',
                  placeholder: '127.0.0.1',
                  value: proxy.host || '',
                  onBlur: this.handleOnSave,
                  onChange: this.handleProxyHostChange })), ':',



              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'proxy-server-port' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Inputs__["b" /* Input */], {
                  disabled: disabled,
                  error: portError,
                  inputStyle: 'box',
                  placeholder: '8080',
                  type: 'number',
                  value: proxy.port,
                  onBlur: this.handleOnSave,
                  onChange: this.handleProxyPortChange })))),





          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-global-proxy-group-row proxy-authenticate' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'row-label' }, 'Proxy Auth',

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_InfoButton__["a" /* default */], {
                tooltip: 'Uses Basic Authentication method' })),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'row-values' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_ToggleSwitch__["a" /* default */], {
                isActive: proxy.authenticate,
                disabled: disabled,
                onClick: this.handleProxyAuthEnableChange })))),





        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: proxyAuthClassName },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-global-proxy-group-row proxy-username' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'row-label' }, 'Username'),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'row-values' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Inputs__["b" /* Input */], {
                disabled: !proxy.authenticate || disabled,
                inputStyle: 'box',
                value: proxy.username,
                placeholder: 'Username',
                onBlur: this.handleOnSave,
                onChange: this.handleProxyAuthUsernameChange }))),




          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-global-proxy-group-row proxy-password' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'row-label' }, 'Password'),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'row-values' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_9__base_PasswordInput__["a" /* default */], {
                className: 'proxy-password-input',
                disabled: !proxy.authenticate || disabled,
                inputStyle: 'box',
                placeholder: 'Password',
                value: proxy.password,
                onBlur: this.handleOnSave,
                onChange: this.handleProxyAuthPasswordChange })))),





        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: proxyBypassClassName },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-global-proxy-group-row proxy-bypass' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'row-label' }, 'Proxy Bypass'),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'row-values' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_TextArea__["a" /* default */], {
                className: 'proxy-bypass-list',
                rows: '2',
                value: proxy.bypass || '',
                disabled: disabled,
                onBlur: this.handleOnSave,
                onChange: this.handleProxyBypassChange,
                placeholder: 'Enter comma separated hosts to bypass proxy settings. Example: 127.0.0.1, localhost, *.example.com' }))))));






  }};



SettingsGlobalProxy.propTypes = {
  proxy: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.object.isRequired,
  onSave: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.func.isRequired,
  onUpdate: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.func.isRequired };


SettingsGlobalProxy.defaultProps = {
  errors: {},
  onSave: _.noop,
  onUpdate: _.noop };
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4767:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["a"] = HideIcon;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__Icon__ = __webpack_require__(28);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};


const icon =
__WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('svg', { width: '16', height: '16', viewBox: '0 0 16 16', fill: 'none' },
  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('defs', null,
    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('path', { id: 'hide-eye-icon', d: 'M12.6968 1L14.0832 2.24632L2.30324 15.5261L0.916748 14.2798L12.6968 1ZM8 4C2.75124 4 0 7.88439 0 8.50041C0 8.85541 0.913728 10.2956 2.69262 11.4523L4.5947 9.5C4.49668 9.1833 4.444 8.84744 4.444 8.49958C4.444 6.58742 6.03576 5.03723 8 5.03723C8.21467 5.03723 8.42489 5.05576 8.62908 5.09127L9.5 4.0823C9.08423 4.02897 8.45315 4 8 4ZM8 13C13.248 13 16 9.11561 16 8.50041C16 8.09109 14.7817 6.23423 12.4207 5.03723L11 6.64089C11.3515 7.17788 11.5552 7.81557 11.5552 8.49958C11.5552 10.4117 9.96344 11.9611 8 11.9611C7.46401 11.9611 6.95575 11.8458 6.5 11.6391L5.5 12.688C6.25761 12.8836 7.09138 13 8 13ZM9.77759 8.5004C9.77759 9.45567 8.98171 10.2308 7.99999 10.2308C7.82638 10.2308 7.6586 10.2066 7.5 10.1615L8.95037 8.45975C9.37624 8.3627 9.77759 8.27337 9.77759 8.5004Z' })),

  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('use', { fill: '#A9A9A9', fillRule: 'evenodd', xlinkHref: '#hide-eye-icon' }));



function HideIcon(props) {
  return (
    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__Icon__["a" /* default */], _extends({},
    props, {
      icon: icon })));


}

/***/ }),

/***/ 4768:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SettingsUpdateContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_settings_SettingsUpdate__ = __webpack_require__(4769);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__constants_AppSettingsDefaults__ = __webpack_require__(543);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_services_AnalyticsService__ = __webpack_require__(16);



let

SettingsUpdateContainer = class SettingsUpdateContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      updateStatus: null,
      currentVersion: pm.app.get('version'),
      updateData: null,
      autoDownloadUpdateStatus: __WEBPACK_IMPORTED_MODULE_2__constants_AppSettingsDefaults__["a" /* default */].autoDownload.MINOR,
      changelog: null };


    this.handleCheckForUpdate = this.handleCheckForUpdate.bind(this);
    this.handleDownloadUpdate = this.handleDownloadUpdate.bind(this);
    this.handleAutoDownloadChange = this.handleAutoDownloadChange.bind(this);
    this.handleRestart = this.handleRestart.bind(this);
    this.handleModelChange = this.handleModelChange.bind(this);
  }

  componentWillMount() {
    this.model = pm.updateNotifier;
    this.setAutoDownloadSettings();
    this.attachModelListeners();
    this.handleModelChange();
  }

  componentWillUnmount() {
    this.detachModelListeners();
    this.model = null;
  }

  attachModelListeners() {
    this.model.on('change', this.handleModelChange);
  }

  detachModelListeners() {
    this.model.off('change', this.handleModelChange);
  }

  setAutoDownloadSettings() {
    this.setState({ autoDownloadUpdateStatus: pm.settings.getSetting('autoDownloadUpdateStatus') });
  }

  handleAutoDownloadChange(value) {
    if (_.includes(_.values(__WEBPACK_IMPORTED_MODULE_2__constants_AppSettingsDefaults__["a" /* default */].autoDownload), value)) {
      this.setState({ autoDownloadUpdateStatus: value }, () => {
        pm.settings.setSetting('autoDownloadUpdateStatus', value);
      });
      __WEBPACK_IMPORTED_MODULE_3__modules_services_AnalyticsService__["a" /* default */].addEvent('app', 'select_update_preference', value === __WEBPACK_IMPORTED_MODULE_2__constants_AppSettingsDefaults__["a" /* default */].autoDownload.MINOR ? 'minor' : 'all');
    }
  }

  handleModelChange() {
    this.setState({
      updateStatus: this.model.get('status'),
      updateData: this.model.get('data'),
      changelog: this.model.get('changelog') });

  }

  handleCheckForUpdate(event, retry) {
    this.model.checkForUpdates(true);
    !retry && __WEBPACK_IMPORTED_MODULE_3__modules_services_AnalyticsService__["a" /* default */].addEvent('app', 'check_update', 'settings_modal');
    retry && __WEBPACK_IMPORTED_MODULE_3__modules_services_AnalyticsService__["a" /* default */].addEvent('app', 'retry_update_download', 'settings_modal');
  }

  handleDownloadUpdate() {
    this.model.downloadUpdate();
    __WEBPACK_IMPORTED_MODULE_3__modules_services_AnalyticsService__["a" /* default */].addEvent('app', 'initiate_update_download', 'settings_modal');
  }

  handleRestart() {
    this.model.applyUpdate();
    __WEBPACK_IMPORTED_MODULE_3__modules_services_AnalyticsService__["a" /* default */].addEvent('app', 'app_restart', 'settings_modal');
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_settings_SettingsUpdate__["a" /* default */], {
        autoDownloadUpdateStatus: this.state.autoDownloadUpdateStatus,
        updateStatus: this.state.updateStatus,
        currentVersion: this.state.currentVersion,
        updateVersion: this.state.updateData ? this.state.updateData.version : null,
        updateNotes: this.state.updateData ? this.state.updateData.notes : null,
        changelog: this.state.changelog,
        onAutoDownloadEnabledChanged: this.handleAutoDownloadChange,
        onCheckForUpdate: this.handleCheckForUpdate,
        onDownloadUpdate: this.handleDownloadUpdate,
        onApplyUpdate: this.handleRestart }));


  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4769:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SettingsUpdate; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_ProgressBar__ = __webpack_require__(3665);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_TextArea__ = __webpack_require__(962);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Markdown__ = __webpack_require__(173);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__constants_AppSettingsDefaults__ = __webpack_require__(543);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__utils_GetUniqueIdHelper__ = __webpack_require__(3952);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__base_ToggleSwitch__ = __webpack_require__(959);









const autoDownload = __WEBPACK_IMPORTED_MODULE_5__constants_AppSettingsDefaults__["a" /* default */].autoDownload;let

SettingsUpdate = class SettingsUpdate extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.setAppOnline = this.setAppOnline.bind(this);
    this.setAppOffline = this.setAppOffline.bind(this);
    this.handleAutoDownloadChange = this.handleAutoDownloadChange.bind(this);

    this.state = {
      uniqueName: __WEBPACK_IMPORTED_MODULE_6__utils_GetUniqueIdHelper__["a" /* default */].generateUniqueId(),
      isAppOnline: navigator.onLine };

  }

  componentWillMount() {
    window.addEventListener('online', this.setAppOnline);
    window.addEventListener('offline', this.setAppOffline);
  }

  componentWillUnmount() {
    window.removeEventListener('online', this.setAppOnline);
    window.removeEventListener('offline', this.setAppOffline);
  }

  handleAutoDownloadChange() {
    let oldValue = this.props.autoDownloadUpdateStatus;

    this.props.onAutoDownloadEnabledChanged(oldValue === autoDownload.ALL ? autoDownload.MINOR : autoDownload.ALL);
  }

  setAppOnline() {
    this.setState({ isAppOnline: true });
  }

  setAppOffline() {
    this.setState({ isAppOnline: false });
  }

  renderUpdateStatus(status) {
    var currentVersion = this.props.currentVersion;

    switch (status) {
      case 'idle':
        return (
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'update-idle' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'update-idle__version' }, 'You\'re on Postman v',
              currentVersion),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                type: 'primary',
                onClick: this.props.onCheckForUpdate,
                className: 'update-idle__button',
                disabled: !this.state.isAppOnline,
                tooltip: !this.state.isAppOnline ? 'You need to be online to check for updates.' : null }, 'Check for updates')));



      case 'updateAvailable':
        return (
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings__update' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings__update__container' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings__update__info-container' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings__update__header' }, 'Update Available'),


                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings__update__version' }, 'Current Version: v',
                  currentVersion)),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                  type: 'primary',
                  onClick: this.props.onDownloadUpdate,
                  className: 'update-idle__button',
                  disabled: !this.state.isAppOnline,
                  tooltip: !this.state.isAppOnline ? 'You need to be online to download the update.' : null }, 'Download update'))));




      case 'checking':
        return (
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'update-checking' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'update-checking__message' }, 'Checking for updates...'),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'update-checking__progress' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_ProgressBar__["a" /* default */], null))));



      case 'updateNotAvailable':
        return (
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings__update' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings__update__container' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings__update__info-container' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings__update__header' }, 'You are up to date!'),


                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings__update__version' }, 'Postman v',
                  currentVersion, ' is the latest version.')),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                  type: 'primary',
                  onClick: this.props.onCheckForUpdate,
                  className: 'update-not-available__button',
                  disabled: !this.state.isAppOnline,
                  tooltip: !this.state.isAppOnline ? 'You need to be online to check for updates.' : null }, 'Check for updates'))));




      case 'downloading':
        return (
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'update-downloading' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'update-downloading__message' }, 'Downloading update...'),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'update-downloading__progress' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_ProgressBar__["a" /* default */], null))));



      case 'downloaded':
        return (
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings__update' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings__update__container' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings__update__info-container' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings__update__header' }, 'Update Downloaded.'),


                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings__update__version' }, 'Current Version: v',
                  currentVersion)),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                  type: 'primary',
                  onClick: this.props.onApplyUpdate }, 'Restart to Install Update'))));




      case 'error':
        return (
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'update-error' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'update-error__message' }, 'Something went wrong. Please check your connection and try restarting the app.'),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                type: 'primary',
                onClick: event => this.props.onCheckForUpdate(event, true),
                disabled: !this.state.isAppOnline,
                tooltip: !this.state.isAppOnline ? 'You need to be online to check for updates.' : null }, 'Retry')));



      default:{
          return false;
        }}

  }

  renderUpdateOptions() {
    let autoDownloadUpdateStatus = this.props.autoDownloadUpdateStatus;
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-autoupdate' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-autoupdate-info-container' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-autoupdate-header' }, 'Automatically download major updates'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-autoupdate-body' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_ToggleSwitch__["a" /* default */], {
              isActive: autoDownloadUpdateStatus === autoDownload.ALL,
              activeLabel: 'Enabled',
              inactiveLabel: 'Disabled',
              onClick: this.handleAutoDownloadChange })),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-autoupdate-footer' }, 'Postman automatically downloads minor updates and bug fixes.'))));





  }

  renderChangelog(updateStatus, changelog) {
    if (!_.includes(['updateAvailable', 'downloaded'], updateStatus) || _.isEmpty(changelog)) {
      return false;
    }
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Markdown__["a" /* default */], {
        className: 'settings-update-changelog-container',
        source: changelog }));


  }

  render() {

    let updateStatus = this.props.updateStatus;
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
        this.renderUpdateOptions(),
        this.renderUpdateStatus(updateStatus),
        this.renderChangelog(updateStatus, this.props.changelog)));



  }};



SettingsUpdate.defaultProps = { autoDownloadUpdateStatus: 0 };
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4770:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SettingsCertificatesContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_certificates_CertificateList__ = __webpack_require__(4771);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__certificates_AddCertificateContainer__ = __webpack_require__(4772);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_certificates_CACertificate__ = __webpack_require__(4774);



let

SettingsCertificatesContainer = class SettingsCertificatesContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      certificates: [],
      showAdd: false };


    this.handleModelChange = this.handleModelChange.bind(this);
    this.handleDeleteCertificate = this.handleDeleteCertificate.bind(this);
    this.handleAddToggle = this.handleAddToggle.bind(this);
  }

  componentWillMount() {
    this.model = pm.certificateManager;
    this.attachModelListeners();
    this.handleModelChange();
  }

  componentWillUnmount() {
    this.detachModelListeners();
  }

  attachModelListeners() {
    if (!this.model) {
      return;
    }

    this.model.on('update reset change', this.handleModelChange);
  }

  detachModelListeners() {
    if (!this.model) {
      return;
    }

    this.model.off('update reset change', this.handleModelChange);
  }

  handleModelChange() {
    this.setState({ certificates: this.model.toJSON() });
  }

  handleDeleteCertificate(host) {
    this.model.removeCertificate(host);
  }

  handleAddToggle() {
    this.setState({ showAdd: !this.state.showAdd });
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,

        this.state.showAdd ?
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__certificates_AddCertificateContainer__["a" /* default */], {
          onCancel: this.handleAddToggle }) :


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_certificates_CACertificate__["a" /* default */], null),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'divider' }),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_certificates_CertificateList__["a" /* default */], {
            certificates: this.state.certificates,
            onDelete: this.handleDeleteCertificate,
            onAddToggle: this.handleAddToggle }))));






  }};

/***/ }),

/***/ 4771:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CertificateList; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_async__ = __webpack_require__(53);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_async___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_async__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__constants_AppUrlConstants__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_PasswordInput__ = __webpack_require__(3747);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_WarningButton__ = __webpack_require__(671);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__utils_FsHelper__ = __webpack_require__(366);






let

CertificateList = class CertificateList extends __WEBPACK_IMPORTED_MODULE_1_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = { warningList: [] };
  }

  componentDidMount() {
    this.computeWarningList(this.props);
  }

  computeWarningList(props) {
    __WEBPACK_IMPORTED_MODULE_0_async___default.a.map(props.certificates, (cert, cb) => {
      __WEBPACK_IMPORTED_MODULE_0_async___default.a.parallel({
        crt: next => {
          Object(__WEBPACK_IMPORTED_MODULE_6__utils_FsHelper__["a" /* fileReadable */])(cert.pemPath, err => {
            next(null, !!err);
          });
        },
        key: next => {
          Object(__WEBPACK_IMPORTED_MODULE_6__utils_FsHelper__["a" /* fileReadable */])(cert.keyPath, err => {
            next(null, !!err);
          });
        },
        pfx: next => {
          Object(__WEBPACK_IMPORTED_MODULE_6__utils_FsHelper__["a" /* fileReadable */])(cert.pfxPath, err => {
            next(null, !!err);
          });
        } },
      cb);
    }, (err, result) => {
      this.setState({ warningList: err ? [] : result });
    });
  }

  componentWillReceiveProps(nextProps) {
    this.computeWarningList(nextProps);
  }

  handleDelete(host) {
    this.props.onDelete && this.props.onDelete(host);
  }

  openCertificatesDocumentation() {
    pm.app.openExternalLink(__WEBPACK_IMPORTED_MODULE_3__constants_AppUrlConstants__["p" /* CERTIFICATES_DOC */]);
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_1_react___default.a.createElement('div', { className: 'certificate-list-wrapper' },
        __WEBPACK_IMPORTED_MODULE_1_react___default.a.createElement('div', { className: 'certificate-list-wrapper__heading' },
          __WEBPACK_IMPORTED_MODULE_1_react___default.a.createElement('h4', { className: 'certificate-list-wrapper__heading__title' }, 'Client Certificates'),


          __WEBPACK_IMPORTED_MODULE_1_react___default.a.createElement('div', { className: 'certificate-list-wrapper__heading__add', onClick: this.props.onAddToggle }, 'Add Certificate')),


        __WEBPACK_IMPORTED_MODULE_1_react___default.a.createElement('div', { className: 'certificate-list-wrapper-desc' }, 'Add and manage SSL certificates on a per domain basis.',

          __WEBPACK_IMPORTED_MODULE_1_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
              className: 'learn-more-button',
              type: 'text',
              onClick: this.openCertificatesDocumentation }, 'Learn more about working with certificates at our Learning Center.')),





        __WEBPACK_IMPORTED_MODULE_1_react___default.a.createElement('div', { className: 'certificate-list' },

          _.map(this.props.certificates, (certificate, index) => {
            return (
              __WEBPACK_IMPORTED_MODULE_1_react___default.a.createElement('div', { key: certificate.host, className: 'certificate-list-item' },
                __WEBPACK_IMPORTED_MODULE_1_react___default.a.createElement('div', { className: 'certificate-list-item__row' },
                  __WEBPACK_IMPORTED_MODULE_1_react___default.a.createElement('div', { className: 'certificate-list-item__key' }, 'Host'),
                  __WEBPACK_IMPORTED_MODULE_1_react___default.a.createElement('div', { className: 'certificate-list-item__value' }, certificate.host),
                  __WEBPACK_IMPORTED_MODULE_1_react___default.a.createElement('div', { className: 'certificate-list-item__controls', onClick: this.handleDelete.bind(this, certificate.host) }, 'Remove')),


                !_.isEmpty(certificate.pemPath) &&
                __WEBPACK_IMPORTED_MODULE_1_react___default.a.createElement('div', { className: 'certificate-list-item__row' },
                  __WEBPACK_IMPORTED_MODULE_1_react___default.a.createElement('div', { className: 'certificate-list-item__key' }, 'CRT file',

                    _.get(this.state.warningList, [index, 'crt'], false) && __WEBPACK_IMPORTED_MODULE_1_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_WarningButton__["a" /* default */], { tooltip: 'The selected CRT file is not readable, check file permissions.' })),

                  __WEBPACK_IMPORTED_MODULE_1_react___default.a.createElement('div', { className: 'certificate-list-item__value' }, certificate.pemPath)),



                !_.isEmpty(certificate.keyPath) &&
                __WEBPACK_IMPORTED_MODULE_1_react___default.a.createElement('div', { className: 'certificate-list-item__row' },
                  __WEBPACK_IMPORTED_MODULE_1_react___default.a.createElement('div', { className: 'certificate-list-item__key' }, 'KEY file',

                    _.get(this.state.warningList, [index, 'key'], false) && __WEBPACK_IMPORTED_MODULE_1_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_WarningButton__["a" /* default */], { tooltip: 'The selected KEY file is not readable, check file permissions.' })),

                  __WEBPACK_IMPORTED_MODULE_1_react___default.a.createElement('div', { className: 'certificate-list-item__value' }, certificate.keyPath)),



                !_.isEmpty(certificate.pfxPath) &&
                __WEBPACK_IMPORTED_MODULE_1_react___default.a.createElement('div', { className: 'certificate-list-item__row' },
                  __WEBPACK_IMPORTED_MODULE_1_react___default.a.createElement('div', { className: 'certificate-list-item__key' }, 'PFX file',

                    _.get(this.state.warningList, [index, 'pfx'], false) && __WEBPACK_IMPORTED_MODULE_1_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_WarningButton__["a" /* default */], { tooltip: 'The selected PFX file is not readable, check file permissions.' })),

                  __WEBPACK_IMPORTED_MODULE_1_react___default.a.createElement('div', { className: 'certificate-list-item__value' }, certificate.pfxPath)),



                !_.isEmpty(certificate.passphrase) &&
                __WEBPACK_IMPORTED_MODULE_1_react___default.a.createElement('div', { className: 'certificate-list-item__row' },
                  __WEBPACK_IMPORTED_MODULE_1_react___default.a.createElement('div', { className: 'certificate-list-item__key' }, 'Passphrase'),
                  __WEBPACK_IMPORTED_MODULE_1_react___default.a.createElement('div', { className: 'certificate-list-item__value' },
                    __WEBPACK_IMPORTED_MODULE_1_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_PasswordInput__["a" /* default */], {
                      className: 'certificate-list-item__value-password',
                      value: certificate.passphrase,
                      readOnly: true })))));






          }))));




  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4772:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddCertificateContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_certificates_AddCertificate__ = __webpack_require__(4773);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};
let

AddCertificateContainer = class AddCertificateContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      hostname: '',
      port: '',
      pemPath: '',
      keyPath: '',
      pfxPath: '',
      passphrase: '' };


    this.handleSubmit = this.handleSubmit.bind(this);
    this.handleChange = this.handleChange.bind(this);
  }

  handleSubmit() {
    let {
      hostname,
      port,
      pemPath,
      pfxPath,
      keyPath,
      passphrase } =
    this.state;

    if (_.isEmpty(hostname)) {
      pm.toasts.error('Hostname is required');
      return;
    }

    let host = this.sanitizeHost(hostname, port);

    pm.certificateManager.addCertificate(host, pemPath, keyPath, pfxPath, passphrase);
    this.props.onCancel();
  }

  sanitizeHost(host, port) {
    // if port is given, strip any port in the host

    let sanitizedHost = host.
    replace(/.*?:\/\//g, '') // strip protocol
    .replace(/\?.*/, '') // strip query
    .replace(/\/.*/, '') // strip patch
    .replace(/^\./, ''); // strip leading period

    if (!_.isEmpty(port)) {
      let hostNamePort = sanitizedHost.split(':');
      return hostNamePort[0] + ':' + port;
    }

    return sanitizedHost;
  }

  handleChange(key, value) {
    let nextState = _.assign({}, this.state);
    nextState[key] = value;
    this.setState(nextState);
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_certificates_AddCertificate__["a" /* default */], _extends({},
      this.state, {
        onCancel: this.props.onCancel,
        onSubmit: this.handleSubmit,
        onChange: this.handleChange })));


  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4773:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddCertificate; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_FileInput__ = __webpack_require__(676);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__constants_AppUrlConstants__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_PasswordInput__ = __webpack_require__(3747);





let

AddCertificate = class AddCertificate extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  handleFileSelect(field, files) {
    this.props.onChange(field, _.get(files, '[0].path', ''));
  }

  openCertificatesDocumentation() {
    pm.app.openExternalLink(__WEBPACK_IMPORTED_MODULE_4__constants_AppUrlConstants__["p" /* CERTIFICATES_DOC */]);
  }

  getValueForFileInput(filePath) {
    // If path doesn't exist then return empty array
    if (!filePath) {
      return [];
    }

    // Value exist then create array with single element
    return [filePath];
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-certificate-wrapper' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-certificate__heading' },


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'breadcrumbs', onClick: this.props.onCancel }, ' Client Certificates'), ' Add Certificate'),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-certificate__fields' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-certificate__field' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-certificate__field__label' }, 'Host'),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-certificate__field__value' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-certificate__field__tag' }, 'https://'),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Inputs__["b" /* Input */], {
                className: 'add-certificate__field__input add-certificate__field__input--url',
                inputStyle: 'box',
                type: 'text',
                value: this.props.hostname,
                placeholder: 'getpostman.com',
                onChange: this.props.onChange.bind(this, 'hostname') }),

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-certificate__field__divider' }, ':'),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Inputs__["b" /* Input */], {
                className: 'add-certificate__field__input add-certificate__field__input--port',
                inputStyle: 'box',
                type: 'text',
                value: this.props.port,
                placeholder: '443',
                onChange: this.props.onChange.bind(this, 'port') }))),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-certificate__field add-certificate__field-crt' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-certificate__field__label' }, 'CRT file'),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-certificate__field__value' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_FileInput__["a" /* default */], {
                value: this.getValueForFileInput(this.props.pemPath),
                onSelect: this.handleFileSelect.bind(this, 'pemPath'),
                onClear: this.handleFileSelect.bind(this, 'pemPath') }))),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-certificate__field add-certificate__field-key' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-certificate__field__label' }, 'KEY file'),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-certificate__field__value' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_FileInput__["a" /* default */], {
                value: this.getValueForFileInput(this.props.keyPath),
                onSelect: this.handleFileSelect.bind(this, 'keyPath'),
                onClear: this.handleFileSelect.bind(this, 'keyPath') }))),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-certificate__field add-certificate__field-pfx' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-certificate__field__label' }, 'PFX file'),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-certificate__field__value' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_FileInput__["a" /* default */], {
                value: this.getValueForFileInput(this.props.pfxPath),
                onSelect: this.handleFileSelect.bind(this, 'pfxPath'),
                onClear: this.handleFileSelect.bind(this, 'pfxPath') }))),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-certificate__field add-certificate__field-passphrase' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-certificate__field__label' }, 'Passphrase'),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-certificate__field__value' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_PasswordInput__["a" /* default */], {
                className: 'add-certificate__field__input',
                inputStyle: 'box',
                value: this.props.passphrase,
                onChange: this.props.onChange.bind(this, 'passphrase') })))),




        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-certificate__controls' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
              type: 'primary',
              onClick: this.props.onSubmit }, 'Add'),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
              type: 'text',
              onClick: this.props.onCancel }, 'Cancel')),



        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
            className: 'learn-more-button',
            type: 'text',
            onClick: this.openCertificatesDocumentation }, 'Learn more about working with certificates at our Learning Center.')));





  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4774:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CACertificate; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_ToggleSwitch__ = __webpack_require__(959);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_FileInput__ = __webpack_require__(676);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__utils_FsHelper__ = __webpack_require__(366);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_WarningButton__ = __webpack_require__(671);




let

CACertificate = class CACertificate extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      enabled: false,
      filePath: '',
      fileError: false };


    this.handleFileSelect = this.handleFileSelect.bind(this);
    this.handleToggle = this.handleToggle.bind(this);
  }

  componentWillMount() {
    this.setState({
      enabled: pm.settings.getSetting('isCACertEnabled'),
      filePath: pm.settings.getSetting('CACertPath') });


    this.fileErrorCheck(pm.settings.getSetting('CACertPath'));
  }

  componentWillReceiveProps() {
    this.setState({
      enabled: pm.settings.getSetting('isCACertEnabled'),
      filePath: pm.settings.getSetting('CACertPath') });


    this.fileErrorCheck(pm.settings.getSetting('CACertPath'));
  }

  handleFileSelect(files) {
    let path = _.get(files, '[0].path', '');

    this.setState({ filePath: path });
    this.fileErrorCheck(path);
    pm.settings.setSetting('CACertPath', path);
  }

  handleToggle(isActive) {
    this.setState({ enabled: isActive });
    pm.settings.setSetting('isCACertEnabled', isActive);
  }

  getValueForFileInput(filePath) {
    // If path doesn't exist then return empty array
    if (!filePath) {
      return [];
    }

    // Value exist then create array with single element
    return [filePath];
  }

  fileErrorCheck(filePath) {
    if (!filePath) {
      return false;
    }

    Object(__WEBPACK_IMPORTED_MODULE_3__utils_FsHelper__["a" /* fileReadable */])(filePath, err => {
      this.setState({ fileError: !!err });
    });
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'ca-certificate-wrapper' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'ca-certificate-wrapper__heading' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('h4', { className: 'ca-certificate-wrapper__heading__label' }, 'CA Certificates'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_ToggleSwitch__["a" /* default */], {
            className: 'ca-certificate-wrapper__heading__toggle',
            isActive: this.state.enabled,
            onClick: this.handleToggle })),



        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'ca-certificate-wrapper-desc' }, 'The file should consist of one or more trusted certificates in PEM format.'),



        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'ca-certificate__field ' + (this.state.enabled ? '' : 'disabled') },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'ca-certificate__field__label' }, 'PEM file',

            this.state.filePath && this.state.fileError && __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_WarningButton__["a" /* default */], { tooltip: 'The selected PEM file is not readable, check file permissions.' })),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_FileInput__["a" /* default */], {
            value: this.getValueForFileInput(this.state.filePath),
            onSelect: this.handleFileSelect,
            onClear: this.handleFileSelect,
            disabled: !this.state.enabled }))));




  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4775:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SettingsDataContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_settings_SettingsData__ = __webpack_require__(4776);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__services_conversion_promisifiedConverter__ = __webpack_require__(655);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__services_conversion_export_all__ = __webpack_require__(1526);
var _class;




let


SettingsDataContainer = Object(__WEBPACK_IMPORTED_MODULE_4_mobx_react__["a" /* observer */])(_class = class SettingsDataContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.state = {
      downloadOnlyMyData: true,
      downloadInprogress: false };

    this.handleExportData = this.handleExportData.bind(this);
    this.handleImportData = this.handleImportData.bind(this);
    this.handleDataSetSelect = this.handleDataSetSelect.bind(this);
  }

  componentWillUnmount() {
    clearTimeout(this.timeout);
  }

  handleExportData() {
    this.setState({ downloadInprogress: true });

    let exportAllData = !this.state.downloadOnlyMyData || !this.getUserOrgStatus();
    Object(__WEBPACK_IMPORTED_MODULE_5__services_conversion_export_all__["b" /* default */])({ exportLevel: exportAllData ? 'all' : 'user' })

    // If there were no errors, show success alert
    .then(state => {
      state === __WEBPACK_IMPORTED_MODULE_5__services_conversion_export_all__["a" /* EXPORT_STATE */].SUCCESS && pm.toasts.success('Your data was exported successfully.');
    })

    // If there was some error, show error alert and log the error
    .catch(err => {
      pm.toasts.error('Could not export the data. Please check the DevTools.');
      pm.logger.error('ExportAll: Error in pipeline', err);
    })

    // set the flag back to false
    .then(() => {
      this.setState({ downloadInprogress: false });
    });
  }

  handleImportData(files) {
    Object(__WEBPACK_IMPORTED_MODULE_2__services_conversion_promisifiedConverter__["a" /* default */])().then(converter => {
      converter.importFiles(files);
    });
  }

  handleDataSetSelect(value) {
    this.setState({ downloadOnlyMyData: value });
  }

  getUserOrgStatus() {
    let orgs = Object(__WEBPACK_IMPORTED_MODULE_3__stores_get_store__["getStore"])('CurrentUserStore').organizations;
    return orgs && orgs.length > 0 && Object(__WEBPACK_IMPORTED_MODULE_3__stores_get_store__["getStore"])('CurrentUserStore').teamSyncEnabled;
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_settings_SettingsData__["a" /* default */], {
        onImportData: this.handleImportData,
        onExportData: this.handleExportData,
        downloadOnlyMyData: this.state.downloadOnlyMyData,
        onDataSetChange: this.handleDataSetSelect,
        hasOrg: this.getUserOrgStatus(),
        downloadInprogress: this.state.downloadInprogress }));


  }}) || _class;

/***/ }),

/***/ 4776:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SettingsData; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_react_radio_group__ = __webpack_require__(1503);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_react_radio_group___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_react_radio_group__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__utils_GetUniqueIdHelper__ = __webpack_require__(3952);





let

SettingsData = class SettingsData extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.state = { uniqueName: __WEBPACK_IMPORTED_MODULE_4__utils_GetUniqueIdHelper__["a" /* default */].generateUniqueId() };
    this.handleExportData = this.handleExportData.bind(this);
    this.handleImportData = this.handleImportData.bind(this);
    this.handleDataSetSelect = this.handleDataSetSelect.bind(this);
  }

  handleExportData() {
    this.props.onExportData && this.props.onExportData();
  }

  handleImportData(value) {
    this.props.onImportData && this.props.onImportData(value);
  }

  handleDataSetSelect(value) {
    this.props.onDataSetChange && this.props.onDataSetChange(value);
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-data-wrapper' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-data-header' }, 'Export data'),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-data-header-description' }, 'Export all your collections, environments, globals and header presets to a single dump file. ',
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('br', null),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Note: Exporting a data dump will save your globals from different workspaces as individual environments.')),


        this.props.hasOrg &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-data-option-wrapper' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1_react_radio_group__["RadioGroup"], {
              name: this.state.uniqueName,
              selectedValue: this.props.downloadOnlyMyData,
              onChange: this.handleDataSetSelect },

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('label', { className: 'settings-data-option' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1_react_radio_group__["Radio"], { value: true, className: 'radio-button' }), 'Download only my data'),

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('label', { className: 'settings-data-option' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1_react_radio_group__["Radio"], { value: false, className: 'radio-button' }), 'Download all data including data in workspaces I have joined')))),






        this.props.downloadInprogress &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], { type: 'primary' }, 'Downloading...')),



        !this.props.downloadInprogress &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], { type: 'primary', onClick: this.handleExportData }, 'Download')),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-data-section-separator' }),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-data-header' }, 'Import data'),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-data-header-description' }, 'Import a Postman data dump.  This may overwrite existing data.'),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Inputs__["b" /* Input */], {
            type: 'file',
            onChange: this.handleImportData }))));




  }};

/***/ }),

/***/ 4777:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SettingsShortcutsContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_settings_SettingsShortcuts__ = __webpack_require__(4778);

let

SettingsShortcutsContainer = class SettingsShortcutsContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_settings_SettingsShortcuts__["a" /* default */], null));

  }};

/***/ }),

/***/ 4778:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_, process) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SettingsShortcuts; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__constants_SettingsShortcutsConstants__ = __webpack_require__(4779);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_ToggleSwitch__ = __webpack_require__(959);






const isDarwin = window ? _.includes(navigator.platform, 'Mac') : process.platform === 'darwin';let

SettingsShortcuts = class SettingsShortcuts extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = { shortcutsEnabled: !pm.app.get('shortcutsDisabled') };

    this.handleToggleShortcuts = this.handleToggleShortcuts.bind(this);
  }

  formatKeyLabel(label) {
    if (label.indexOf('through') >= 0) {
      return label;
    }
    return !isDarwin ? label.split('+').join(' + ') : label.split('').join(' ');
  }

  handleToggleShortcuts(shortcutsEnabled) {
    this.setState({ shortcutsEnabled }, () => {
      shortcutsEnabled ? pm.app.enableShortcuts() : pm.app.disableShortcuts();
    });
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-shortcuts-wrapper' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'item-header' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('h4', { className: 'item-title' }, 'Shortcuts'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_ToggleSwitch__["a" /* default */], {
            isActive: this.state.shortcutsEnabled,
            onClick: this.handleToggleShortcuts })),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'divider' }),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: __WEBPACK_IMPORTED_MODULE_1_classnames___default()({
              'settings-shortcuts-list': true,
              'disabled': !this.state.shortcutsEnabled }) },



          _.map(__WEBPACK_IMPORTED_MODULE_2__constants_SettingsShortcutsConstants__["a" /* SETTINGS_SHORTCUTS */], (group, groupIndex) => {
            return (
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-shortcuts-list-item-group', key: groupIndex },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-shortcuts-list-item-header' },
                  group.name),

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-shortcuts-list-item-content' },

                  _.map(group.shortcuts, shortcut => {
                    return (
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-shortcuts-list-item', key: shortcut.keyLabel },
                        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-shortcuts-list-item-label' },
                          shortcut.label),

                        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-shortcuts-list-item-value' },
                          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null,
                            this.formatKeyLabel(isDarwin ? shortcut.keyLabelDarwin : shortcut.keyLabel)))));




                  }))));




          }))));




  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0), __webpack_require__(3)))

/***/ }),

/***/ 4779:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__controllers_ShortcutsList__ = __webpack_require__(1494);


let shortcuts = _.includes(navigator.platform, 'Mac') ? Object(__WEBPACK_IMPORTED_MODULE_0__controllers_ShortcutsList__["a" /* getDarwinShortcuts */])() : Object(__WEBPACK_IMPORTED_MODULE_0__controllers_ShortcutsList__["e" /* getWindowsShortcuts */])();

const SETTINGS_SHORTCUTS = [{
  name: 'TABS',
  shortcuts: [
  shortcuts.openNewTab,
  shortcuts.closeCurrentTab,
  shortcuts.forceCloseCurrentTab,
  shortcuts.switchToNextTab,
  shortcuts.switchToPreviousTab,
  {
    label: 'Switch To Tab at Position',
    keyLabelDarwin: '⌘ 1 through ⌘ 8',
    keyLabel: 'Ctrl + 1 through Ctrl + 8' },

  shortcuts.switchToLastTab,
  shortcuts.reopenLastClosedTab] },

{
  name: 'REQUEST',
  shortcuts: [
  shortcuts.requestUrl,
  shortcuts.saveCurrentRequest,
  shortcuts.saveCurrentRequestAs,
  shortcuts.sendCurrentRequest,
  shortcuts.sendAndDownloadCurrentRequest,
  shortcuts.scrollToRequest,
  shortcuts.scrollToResponse] },

{
  name: 'SIDEBAR',
  shortcuts: [
  shortcuts.search,
  shortcuts.toggleSidebar,
  shortcuts.nextItem,
  shortcuts.prevItem,
  shortcuts.expandItem,
  shortcuts.collapseItem,
  shortcuts.select,
  {
    label: 'Open Request In A New Tab',
    keyLabelDarwin: '⇧ ⌘ click',
    keyLabel: 'Ctrl+Shift+click' },

  shortcuts.rename,
  shortcuts.groupItems,

  // shortcuts.moveItemUp,
  // shortcuts.moveItemDown,
  shortcuts.cut,
  shortcuts.copy,
  shortcuts.paste,
  shortcuts.duplicate,
  shortcuts.delete] },

{
  name: 'INTERFACE',
  shortcuts: [
  shortcuts.increaseUIZoom,
  shortcuts.decreaseUIZoom,
  shortcuts.resetUIZoom,
  shortcuts.toggleLayout,
  shortcuts.toggleWorkspaceView] },

{
  name: 'WINDOWS AND MODALS',
  shortcuts: [
  shortcuts.openCreateNewModal,
  shortcuts.newRequesterWindow,
  shortcuts.newRunnerWindow,
  shortcuts.newConsoleWindow,
  shortcuts.toggleFindReplace,
  shortcuts.import,
  shortcuts.manageEnvironments,
  shortcuts.settings,
  shortcuts.submit,
  shortcuts.shortcutCheats] }];
/* harmony export (immutable) */ __webpack_exports__["a"] = SETTINGS_SHORTCUTS;

/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4780:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SettingsAddonsContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_settings_SettingsAddons__ = __webpack_require__(4781);

let

SettingsAddonsContainer = class SettingsAddonsContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_settings_SettingsAddons__["a" /* default */], null));

  }};

/***/ }),

/***/ 4781:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SettingsAddons; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__external_navigation_ExternalNavigationService__ = __webpack_require__(59);

let
SettingsAddons = class SettingsAddons extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  // TODO:  If we have more addons must be pass through model or an const array
  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-addons-wrapper' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-addons-link-wrapper' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('a', {
              className: 'settings-addons-link',
              href: 'https://www.npmjs.com/package/newman',
              onClick: e => {e.preventDefault();Object(__WEBPACK_IMPORTED_MODULE_1__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(e.target.href);} }, 'Download Newman from npm')),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-addons-description' }, 'Postman\'s command-line companion lets you do amazing things! With Newman, you can integrate Postman collections with your build system. Or you can run automated tests for your API through a cron job.')));




  }};

/***/ }),

/***/ 4782:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SettingsAboutContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_settings_SettingsAbout__ = __webpack_require__(4783);

let

SettingsAboutContainer = class SettingsAboutContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  componentWillMount() {
    this.setState(pm.app.get('info'));
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_settings_SettingsAbout__["a" /* default */], this.state));

  }};

/***/ }),

/***/ 4783:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SettingsAbout; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__external_navigation_ExternalNavigationService__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__constants_AppUrlConstants__ = __webpack_require__(64);


let

SettingsAbout = class SettingsAbout extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.handleLinkClick = this.handleLinkClick.bind(this);
  }

  handleLinkClick(e) {
    e.preventDefault();
    Object(__WEBPACK_IMPORTED_MODULE_1__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(e.target.href);
  }

  getPlatformInfo() {
    switch (this.props.platform) {
      case 'darwin':
        return 'Mac';
      case 'win32':
        return 'Windows';
      case 'linux':
        return 'Linux';
      default:
        return '';}

  }

  render() {
    let changeLogBasedOnPlatform = __WEBPACK_IMPORTED_MODULE_2__constants_AppUrlConstants__["q" /* CHANGELOG_URL */];

    changeLogBasedOnPlatform = changeLogBasedOnPlatform + '#changelog-mac-app';

    let platform = this.getPlatformInfo();

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-about-wrapper' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-about-logo' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'postman-logo' }),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'postman-tag-line' }, 'Postman helps you develop APIs faster')),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-about-version' },

          !_.isEmpty(platform) && 'Postman for ' + platform),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-about-version' },
          'Version ' + this.props.version),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-about-version' },

          this.props.os + ' / ' + this.props.architecture),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-about-links-list' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-about-links-list-item' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('a', { className: 'settings-about-links', href: __WEBPACK_IMPORTED_MODULE_2__constants_AppUrlConstants__["F" /* HOME_PAGE_URL */], onClick: this.handleLinkClick }, 'Website')),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-about-links-list-item' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('a', { className: 'settings-about-links', href: __WEBPACK_IMPORTED_MODULE_2__constants_AppUrlConstants__["_14" /* TWITTER_URL */], onClick: this.handleLinkClick }, 'Twitter')),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-about-links-list-item' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('a', { className: 'settings-about-links', href: __WEBPACK_IMPORTED_MODULE_2__constants_AppUrlConstants__["N" /* LICENCE_URL */], onClick: this.handleLinkClick }, 'Licenses')),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-about-links-list-item' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('a', { className: 'settings-about-links', href: changeLogBasedOnPlatform, onClick: this.handleLinkClick }, 'Changelog')),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-about-links-list-item' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('a', { className: 'settings-about-links', href: __WEBPACK_IMPORTED_MODULE_2__constants_AppUrlConstants__["w" /* DOCS_URL */], onClick: this.handleLinkClick }, 'Documentation')),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-about-links-list-item' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('a', { className: 'settings-about-links', href: __WEBPACK_IMPORTED_MODULE_2__constants_AppUrlConstants__["L" /* ISSUES_URL */], onClick: this.handleLinkClick }, 'Report an issue')))));




  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4784:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ImportModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ImportContainer__ = __webpack_require__(4785);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__controllers_Importer__ = __webpack_require__(965);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__stores_get_store__ = __webpack_require__(5);
var _class;




let


ImportModalContainer = __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default()(_class = class ImportModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = { isOpen: false };

    this.openModal = this.openModal.bind(this);
    this.handleClose = this.handleClose.bind(this);
  }

  componentWillMount() {
    this.attachModelListeners();
  }

  componentWillUnmount() {
    this.detachModelListeners();
  }

  attachModelListeners() {
    pm.mediator.on('openImportModal', this.openModal);
    pm.mediator.on('closeImportModal', this.handleClose);

    // Documentation for registering menu actions can be found in App.js~registerMenuActions
    pm.shortcuts.registerMenuAction('openImport', this.openModal);
  }

  detachModelListeners() {
    pm.mediator.off('openImportModal', this.openModal);
    pm.mediator.off('closeImportModal', this.handleClose);
  }

  openModal() {
    __WEBPACK_IMPORTED_MODULE_4__controllers_Importer__["a" /* default */].permissionCheck().
    then(permission => {
      if (!permission) {
        pm.mediator.trigger('joinWorkspace');
        return;
      }

      this.setState({ isOpen: true });
    });
  }

  handleClose() {
    this.setState({ isOpen: false });
  }

  getCustomStyles() {
    return { marginTop: '10vh' };
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["a" /* Modal */], {
          className: 'import-modal',
          isOpen: this.state.isOpen,
          onRequestClose: this.handleClose,
          customStyles: this.getCustomStyles() },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["d" /* ModalHeader */], null, 'IMPORT'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__ImportContainer__["a" /* default */], null))));



  }}) || _class;

/***/ }),

/***/ 4785:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ImportContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_base_Tabs__ = __webpack_require__(103);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_import_ImportTabs__ = __webpack_require__(4786);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_import_ImportTabContents__ = __webpack_require__(4787);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_import_ImportTabContent__ = __webpack_require__(4788);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__ImportByFileContainer__ = __webpack_require__(4789);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__ImportByFolderContainer__ = __webpack_require__(4791);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__ImportByRawTextContainer__ = __webpack_require__(4793);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__ImportByUrlContainer__ = __webpack_require__(4795);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__constants_ImportTypeConstants__ = __webpack_require__(3953);










let

ImportContainer = class ImportContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.state = { activeTab: __WEBPACK_IMPORTED_MODULE_9__constants_ImportTypeConstants__["a" /* IMPORT_FILE */] };
    this.handleTabSelect = this.handleTabSelect.bind(this);
  }

  handleTabSelect(id) {
    if (id === this.state.activeTab) {
      return;
    }
    this.setState({ activeTab: id });
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'import-container' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'import-modal-description' }, 'Import a Postman Collection, Environment, data dump, curl command, or a RAML / WADL / Open API (1.0/2.0/3.0) / Runscope file.'),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_import_ImportTabs__["a" /* default */], {
          onSelect: this.handleTabSelect,
          activeTab: this.state.activeTab }),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_import_ImportTabContents__["a" /* default */], {
            activeKey: this.state.activeTab },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_import_ImportTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_9__constants_ImportTypeConstants__["a" /* IMPORT_FILE */] },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__ImportByFileContainer__["a" /* default */], null)),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_import_ImportTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_9__constants_ImportTypeConstants__["b" /* IMPORT_FOLDER */] },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__ImportByFolderContainer__["a" /* default */], null)),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_import_ImportTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_9__constants_ImportTypeConstants__["c" /* IMPORT_TEXT */] },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__ImportByRawTextContainer__["a" /* default */], null)),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_import_ImportTabContent__["a" /* default */], { key: __WEBPACK_IMPORTED_MODULE_9__constants_ImportTypeConstants__["d" /* IMPORT_URL */] },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__ImportByUrlContainer__["a" /* default */], null)))));




  }};

/***/ }),

/***/ 4786:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ImportTabs; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Tabs__ = __webpack_require__(103);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__constants_ImportTypeConstants__ = __webpack_require__(3953);



let

ImportTabs = class ImportTabs extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.handleSelect = this.handleSelect.bind(this);
  }

  handleSelect(id) {
    this.props.onSelect && this.props.onSelect(id);
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Tabs__["b" /* Tabs */], {
            type: 'primary',
            defaultActive: __WEBPACK_IMPORTED_MODULE_2__constants_ImportTypeConstants__["a" /* IMPORT_FILE */],
            activeRef: this.props.activeTab,
            onChange: this.handleSelect },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Tabs__["a" /* Tab */], { refKey: __WEBPACK_IMPORTED_MODULE_2__constants_ImportTypeConstants__["a" /* IMPORT_FILE */], className: 'import-modal-tab--file' }, 'Import File'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Tabs__["a" /* Tab */], { refKey: __WEBPACK_IMPORTED_MODULE_2__constants_ImportTypeConstants__["b" /* IMPORT_FOLDER */], className: 'import-modal-tab--folder' }, 'Import Folder'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Tabs__["a" /* Tab */], { refKey: __WEBPACK_IMPORTED_MODULE_2__constants_ImportTypeConstants__["d" /* IMPORT_URL */], className: 'import-modal-tab--link' }, 'Import From Link'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Tabs__["a" /* Tab */], { refKey: __WEBPACK_IMPORTED_MODULE_2__constants_ImportTypeConstants__["c" /* IMPORT_TEXT */], className: 'import-modal-tab--raw' }, 'Paste Raw Text'))));



  }};

/***/ }),

/***/ 4787:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ImportTabContents; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
let

ImportTabContents = class ImportTabContents extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  render() {

    let children = __WEBPACK_IMPORTED_MODULE_0_react___default.a.Children.map(this.props.children, child => {
      return __WEBPACK_IMPORTED_MODULE_0_react___default.a.cloneElement(child, { active: this.props.activeKey === child.key });
    });
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'import-tab-contents' },
        children));


  }};

/***/ }),

/***/ 4788:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ImportTabContent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_classnames__);

let

ImportTabContent = class ImportTabContent extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  getClasses() {
    return __WEBPACK_IMPORTED_MODULE_1_classnames___default()(
    'import-tab-content',
    { 'is-hidden': !this.props.active },
    this.props.className);

  }

  render() {

    let classes = this.getClasses();

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: classes },
        this.props.children));


  }};

/***/ }),

/***/ 4789:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ImportByFileContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_import_ImportByFile__ = __webpack_require__(4790);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__services_conversion_promisifiedConverter__ = __webpack_require__(655);


let

ImportByFileContainer = class ImportByFileContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.handleOnDropFile = this.handleOnDropFile.bind(this);
  }

  handleOnDropFile(files) {
    Object(__WEBPACK_IMPORTED_MODULE_2__services_conversion_promisifiedConverter__["a" /* default */])().then(converter => {
      converter.importFiles(files);
    });
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_import_ImportByFile__["a" /* default */], {
        onDropFile: this.handleOnDropFile }));


  }};

/***/ }),

/***/ 4790:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ImportByFile; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_DropZone__ = __webpack_require__(1513);



let

ImportByFile = class ImportByFile extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_DropZone__["a" /* DropZone */], { type: 'file', onDropFile: this.props.onDropFile },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'drop-files-dropzone' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'drop-files-inner-container' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'drop-files-dropzone-text' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, 'Drop files here ')),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], { type: 'primary' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, 'Choose Files'))))));





  }};

/***/ }),

/***/ 4791:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ImportByFolderContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_import_ImportByFolder__ = __webpack_require__(4792);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__services_conversion_promisifiedConverter__ = __webpack_require__(655);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_services_AnalyticsService__ = __webpack_require__(16);



let

ImportByFolderContainer = class ImportByFolderContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.handleOnDropFile = this.handleOnDropFile.bind(this);
    this.readEntry = this.readEntry.bind(this);
  }

  /**
      @private
      @method simpleFileProcessor
      @param file { Blob Obj }
      @usage Used to read the files from the Blob object and provide it back as an oject of below format
      @return { Object }
      @format
      {
        content: "file contents..."",
        fileName: "something",
        isRoot: true // Set to true if this is a root RAML File.
      }
    */
  simpleFileProcessor(file) {
    var fullPath = file.webkitRelativePath;
    if (!_.startsWith(fullPath, '/')) {
      fullPath = '/' + file.webkitRelativePath; // So the RAML converter can resolve paths properly.
    }
    return new Promise(function (resolve, reject) {
      var reader = new FileReader();
      reader.readAsText(file);
      reader.onload = function () {
        var isRoot,
        result,
        firstLine = reader.result.split('\n')[0];
        isRoot = _.startsWith(firstLine, '#%RAML ');
        result = {
          content: reader.result,
          fileName: fullPath,
          isRoot: isRoot };

        resolve(result);
      };
      reader.onerror = function (err) {
        reject(err);
      };
    });
  }

  /**
     * Processes a file with the newer "Entry" API. It returns a Promise, that
     * resolves to an object like this:
     *
     * {
     *     content: "file contents...",
     *     fileName: "something.raml",
     *     isRoot: true // Set to true if this is a root RAML File.
     * }
     */
  fileEntryProcessor(fileEntry) {
    return new Promise((resolve, reject) => {
      fileEntry.file(function (file) {
        if (file.size > 5242880) {
          reject(new Error('File ' + fileEntry.fullPath + 'is bigger than 5MB'));
          return;
        }
        var reader = new FileReader();
        reader.readAsText(file);
        reader.onload = function () {
          var isRoot,
          result,
          firstLine = reader.result.split('\n')[0];
          isRoot = _.startsWith(firstLine, '#%RAML ');
          result = {
            content: reader.result,
            fileName: fileEntry.fullPath,
            isRoot: isRoot };

          resolve(result);
        };
        reader.onerror = function (err) {
          reject(err);
        };
      });
    });
  }

  /**
     * Returns a Promise that resolves to a flattened Array of elements, where each element is an object that
     * looks like this:
     * {
     *     content: "file contents...",
     *     fileName: "something.raml",
     *     isRoot: true // Set to true if this is a root RAML File.
     * }
     */
  dirEntryProcessor(dirEntry) {
    let dirExclusions = /^\.[\s\S]+$/ig, // Anything that starts with a "."
    dirReader = dirEntry.createReader(),
    toExclude = dirExclusions.test(dirEntry.name),
    self = this;
    return toExclude ? undefined : this.getAllEntries(dirReader).
    then(allEntries => {
      return Promise.all(_.map(allEntries, self.readEntry, this));
    }).
    then(readingResults => {
      return _.flatten(readingResults);
    });
  }

  /**
     * The sad HTML5 Entry API does not return all files on calling it, so this returns a Promise
     * that resolves to *all* the Entries inside a DirectoryEntry. Meh :-/
     */
  getAllEntries(reader) {
    return new Promise((resolve, reject) => {
      let entries = [],
      getMoreEntries = function () {
        reader.readEntries(results => {
          if (!results.length) {
            entries.sort();
            resolve(entries);
          } else
          {
            entries = entries.concat(Array.prototype.slice.call(results || [], 0));
            getMoreEntries();
          }
        }, function (err) {
          reject(err);
        });
      };
      getMoreEntries();
    });
  }

  /**
     * Reads a single Entry and calls the proper file/folder processor.
     */
  readEntry(entry) {
    return entry.isFile ? this.fileEntryProcessor(entry) : this.dirEntryProcessor(entry);
  }

  /**
      @private
      @method simpleElectronFileProcessor
      @param file { String } path of the File
      @usage Used to read the files from the particular path and provide it back as an oject of below format
      @return { Object }
      @format
      {
        content: "file contents... 'UTF-8' format",
        fileName: "something",
        isRoot: true // Set to true if this is a root RAML File.
      }
    */
  simpleElectronFileProcessor(file) {
    let isRoot = false,
    result = {},
    content = __webpack_require__(33).readFileSync(file, 'utf8'),
    firstLine = content.split('\n')[0];
    isRoot = _.startsWith(firstLine, '#%RAML ');
    result = {
      content: content,
      fileName: file,
      isRoot: isRoot };

    return result;
  }

  processFolderRecursivelyForElectron(folderPath) {
    var allFileContent = [];
    var fs = __webpack_require__(33);
    try {
      let files = fs.readdirSync(folderPath),
      isHidden = function (file) {
        let filterRegex = /^\..*|^\/\.|.*\/\..*/g;
        return filterRegex.test(file.webkitRelativePath);
      };
      files.map(currentFile => {
        let file = folderPath + '/' + currentFile;
        let stat = fs.statSync(file);
        if (stat && stat.isDirectory()) {
          allFileContent = allFileContent.concat(this.processFolderRecursivelyForElectron(file));
        } else
        if (!isHidden(file)) {
          allFileContent.push(this.simpleElectronFileProcessor(file));
        }
      });
      return allFileContent;
    } catch (e) {
      console.log(e);
      return [];
    }
  }

  handleOnDropFile(folder) {
    let allFileContent = [],
    isHidden = function (file) {
      let filterRegex = /^\..*|^\/\.|.*\/\..*/g;
      return filterRegex.test(file.webkitRelativePath);
    },
    rootPath = folder[0].webkitRelativePath ? folder[0].webkitRelativePath.split('/')[0] : folder[0].fullPath;

    if (rootPath && !_.startsWith(rootPath, '/')) {
      rootPath = '/' + rootPath;
    }

    /**
      * Since the Electron is not providing the full Array of files inside the Folder
      * We are handling it by means of `node fs` by ourselves
      * Issue Reference: https://github.com/atom/electron/issues/749
      */

    if (folder.length && folder[0].path) {
      // For electron we gets only the folder obj, not a list of files
      // So we reads the directory using the fs module which inturn gives the array of files path
      allFileContent = this.processFolderRecursivelyForElectron(folder[0].path);
    } else
    {
      // Here we gets the list of files inside the Folder
      folder.map(file => {
        if (!file.webkitRelativePath) {
          if (file.getAsEntry) {// Standard HTML5 API
            file = file.getAsEntry();
          } else
          if (file.webkitGetAsEntry) {// WebKit implementation of HTML5 API.
            file = file.webkitGetAsEntry();
          }
          this.readEntry(file).
          then(res => {
            return Promise.all(res);
          }).
          then(allFiles => {
            Object(__WEBPACK_IMPORTED_MODULE_2__services_conversion_promisifiedConverter__["a" /* default */])().then(converter => {
              converter.importFolder(allFiles, rootPath);
            });
          });
        } else
        if (!isHidden(file)) {
          allFileContent.push(this.simpleFileProcessor(file));
        }
      });
    }
    Promise.all(allFileContent).
    then(results => {
      Object(__WEBPACK_IMPORTED_MODULE_2__services_conversion_promisifiedConverter__["a" /* default */])().then(converter => {
        converter.importFolder(results, rootPath);
      });
    });
  }
  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_import_ImportByFolder__["a" /* default */], {
        onDropFile: this.handleOnDropFile }));


  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4792:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ImportByFolder; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_DropZone__ = __webpack_require__(1513);



let

ImportByFolder = class ImportByFolder extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_DropZone__["a" /* DropZone */], { type: 'directory', onDropFile: this.props.onDropFile },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'drop-files-dropzone' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'drop-files-inner-container' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'drop-files-dropzone-text' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, 'Drop folders here ')),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], { type: 'primary' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, 'Choose Folders'))))));





  }};

/***/ }),

/***/ 4793:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ImportByRawTextContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_import_ImportByRawText__ = __webpack_require__(4794);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__controllers_Importer__ = __webpack_require__(965);


let

ImportByRawTextContainer = class ImportByRawTextContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.state = { text: '' };
    this.handleTextChange = this.handleTextChange.bind(this);
    this.handleImport = this.handleImport.bind(this);
  }

  handleTextChange(values) {
    this.setState({ text: values });
  }

  handleImport() {
    let text = this.state.text;

    __WEBPACK_IMPORTED_MODULE_2__controllers_Importer__["a" /* default */].importData(text, { origin: 'import/raw' });
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_import_ImportByRawText__["a" /* default */], {
        onTextChange: this.handleTextChange,
        onImport: this.handleImport }));


  }};

/***/ }),

/***/ 4794:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ImportByRawText; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_TextArea__ = __webpack_require__(962);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Buttons__ = __webpack_require__(13);


let

ImportByRawText = class ImportByRawText extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.handleTextChange = this.handleTextChange.bind(this);
    this.handleImport = this.handleImport.bind(this);
  }

  handleTextChange(values) {
    this.props.onTextChange && this.props.onTextChange(values);
  }

  handleImport() {
    this.props.onImport && this.props.onImport();
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_TextArea__["a" /* default */], {
          className: 'import-by-raw-text',
          onChange: this.handleTextChange }),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'import-by-raw-text-button-wrapper' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], { className: 'import-by-raw-text-button',
              type: 'primary',
              onClick: this.handleImport }, ' Import'))));





  }};

/***/ }),

/***/ 4795:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ImportByUrlContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_import_ImportByUrl__ = __webpack_require__(4796);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__services_conversion_promisifiedConverter__ = __webpack_require__(655);


let

ImportByUrlContainer = class ImportByUrlContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.state = { url: '' };
    this.handleUrlChange = this.handleUrlChange.bind(this);
    this.handleImport = this.handleImport.bind(this);
  }
  handleUrlChange(values) {
    this.setState({ url: values });
  }
  handleImport() {
    let url = this.state.url;
    Object(__WEBPACK_IMPORTED_MODULE_2__services_conversion_promisifiedConverter__["a" /* default */])().then(converter => {
      converter.importFileFromUrl(url);
    });
  }
  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_import_ImportByUrl__["a" /* default */], {
        onUrlChange: this.handleUrlChange,
        onImport: this.handleImport }));


  }};

/***/ }),

/***/ 4796:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ImportByUrl; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Buttons__ = __webpack_require__(13);


let

ImportByUrl = class ImportByUrl extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.handleUrlChange = this.handleUrlChange.bind(this);
    this.handleImport = this.handleImport.bind(this);
  }

  handleUrlChange(values) {
    this.props.onUrlChange && this.props.onUrlChange(values);
  }

  handleImport() {
    this.props.onImport && this.props.onImport();
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Inputs__["b" /* Input */], {
          placeholder: 'Enter a URL and press Import',
          inputStyle: 'box',
          type: 'text',
          className: 'import-by-url-input',
          onChange: this.handleUrlChange,
          onEnter: this.handleImport }),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'import-by-url-button-wrapper' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], { className: 'import-by-url-button',
              type: 'primary',
              onClick: this.handleImport }, ' Import'))));





  }};

/***/ }),

/***/ 4797:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return RequestSnippetGeneratorModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_editor_request_RequestSnippetGenerator__ = __webpack_require__(4798);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_editor_request_RequestSnippetGeneratorExperimental__ = __webpack_require__(4804);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__constants_RequestDataModeConstants__ = __webpack_require__(192);
var _class;





let


RequestSnippetGeneratorModalContainer = __WEBPACK_IMPORTED_MODULE_4_pure_render_decorator___default()(_class = class RequestSnippetGeneratorModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.state = {
      isOpen: false };

    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
  }

  componentDidMount() {
    requestIdleCallback(this.insertIframe);
  }

  componentWillMount() {
    pm.mediator.on('openSnippetGeneratorModel', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('openSnippetGeneratorModel', this.handleClose);
    clearTimeout(this.timeout);
  }

  insertIframe() {
    var iframe = document.createElement('iframe');
    iframe.style.display = 'none';
    iframe.src = 'tester_sandbox.html';
    iframe.id = 'tester_sandbox';
    document.body.appendChild(iframe);
  }

  handleOpen(editorId) {

    this.setState({
      isOpen: true,
      editorId: editorId });


  }

  handleClose() {
    this.setState({ isOpen: false });
  }

  getCustomStyles() {
    return {
      marginTop: '10vh',
      width: '720px' };

  }

  getExperimentalCustomStyles() {
    return {
      marginTop: '15vh',
      height: '65vh',
      minWidth: '720px',
      maxHeight: '700px',
      width: '55vw' };

  }
  getWarning(editorId) {
    let editor = editorId && Object(__WEBPACK_IMPORTED_MODULE_5__stores_get_store__["getStore"])('EditorStore').find(editorId);

    if (editor && editor.model && editor.model.getViewModel('dataMode') === __WEBPACK_IMPORTED_MODULE_6__constants_RequestDataModeConstants__["d" /* REQUEST_DATA_MODE_GRAPHQL */]) {
      return 'Code generation for GraphQL requests is in beta. Some features might not work as expected.';
    } else {
      return '';
    }
  }

  render() {

    if (!pm.settings.getSetting('experimentalCodegenMode')) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Modals__["a" /* Modal */], {
            isOpen: this.state.isOpen,
            onRequestClose: this.handleClose,
            className: 'snippet-generator-modal',
            customStyles: this.getCustomStyles() },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Modals__["d" /* ModalHeader */], null, 'GENERATE CODE SNIPPETS'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Modals__["b" /* ModalContent */], null,
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_editor_request_RequestSnippetGenerator__["a" /* default */], {
              editorId: this.state.editorId }))));




    }

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Modals__["a" /* Modal */], {
          isOpen: this.state.isOpen,
          onRequestClose: this.handleClose,
          className: 'snippet-generator-modal',
          customStyles: this.getExperimentalCustomStyles() },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Modals__["d" /* ModalHeader */], null, 'GENERATE CODE SNIPPETS'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Modals__["b" /* ModalContent */], { className: 'experimental-request-editor-snippet-generator-modal-content' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_editor_request_RequestSnippetGeneratorExperimental__["a" /* default */], {
            editorId: this.state.editorId }))));




  }}) || _class;

/***/ }),

/***/ 4798:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return RequestSnippetGenerator; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__ = __webpack_require__(31);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Icons_SuccessIcon__ = __webpack_require__(312);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_TextEditor__ = __webpack_require__(311);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__services_CodeGenerator__ = __webpack_require__(4799);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__utils_ClipboardHelper__ = __webpack_require__(536);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__constants_RequestSnippetTypeLabelMap__ = __webpack_require__(4803);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__ = __webpack_require__(3748);









let

RequestSnippetGenerator = class RequestSnippetGenerator extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.state = {
      activeLanguage: __WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["e" /* SNIPPET_TYPE_HTTP */],
      codeSnippet: '',
      editorMode: 'text',
      codeCopied: false };

    this.handleCodeTypeSelect = this.handleCodeTypeSelect.bind(this);
    this.handleCopyCode = this.handleCopyCode.bind(this);
    this.handleSnippetChange = this.handleSnippetChange.bind(this);
  }
  componentDidMount() {

    let defaultParent = __WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["e" /* SNIPPET_TYPE_HTTP */],
    defaultChild = '',
    oldSetting = pm.settings.getSetting('snippetLanguage');

    if (oldSetting) {
      let oldLingos = oldSetting.split('>>');

      defaultParent = oldLingos[0] ? oldLingos[0] : '';
      defaultChild = oldLingos[1] ? oldLingos[1] : '';
    }

    this.handleCodeTypeSelect(defaultParent, defaultChild, this.props.editorId);
  }

  handleCodeTypeSelect(parentLanguage, childLanguage, editorId) {

    editorId = editorId || this.props.editorId;
    __WEBPACK_IMPORTED_MODULE_5__services_CodeGenerator__["a" /* default */].getSnippet(editorId, { parentLanguage, childLanguage }).
    then(snippetObject => {
      if (!snippetObject) {
        return;
      }
      this.setState({
        codeSnippet: snippetObject.snippet,
        editorMode: snippetObject.editorMode,
        activeLanguage: `${__WEBPACK_IMPORTED_MODULE_7__constants_RequestSnippetTypeLabelMap__["a" /* default */][parentLanguage]}  ${__WEBPACK_IMPORTED_MODULE_7__constants_RequestSnippetTypeLabelMap__["a" /* default */][childLanguage] || ''}` },
      () => {

        // update the snippetLanguage in the settings
        let snippetLanguage = childLanguage ? `${parentLanguage}>>${childLanguage}` : parentLanguage;
        pm.settings.setSetting('snippetLanguage', snippetLanguage);
      });
    });
  }

  handleSnippetChange(content) {
    this.setState({ codeSnippet: content });
  }

  handleCopyCode() {
    __WEBPACK_IMPORTED_MODULE_6__utils_ClipboardHelper__["a" /* default */].copy(this.state.codeSnippet);
    this.setState({ codeCopied: true });
    this.timeout = setTimeout(() => {
      this.setState({ codeCopied: false });
    }, 1000);
  }

  render() {

    let isCopied = this.state.codeCopied;
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'request-editor-snippet-generator-wrapper' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'request-editor-snippet-generator-actions-wrapper' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["a" /* Dropdown */], {
              onSelect: this.handleCodeTypeSelect,
              className: 'request-editor-snippet-generator-dropdown' },

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["b" /* DropdownButton */], null,
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
                  size: 'small' },

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, this.state.activeLanguage))),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["c" /* DropdownMenu */], null,
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], { refKey: __WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["e" /* SNIPPET_TYPE_HTTP */] }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, __WEBPACK_IMPORTED_MODULE_7__constants_RequestSnippetTypeLabelMap__["a" /* default */][__WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["e" /* SNIPPET_TYPE_HTTP */]])),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], { refKey: __WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["a" /* SNIPPET_TYPE_C */] }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, __WEBPACK_IMPORTED_MODULE_7__constants_RequestSnippetTypeLabelMap__["a" /* default */][__WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["a" /* SNIPPET_TYPE_C */]])),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], { refKey: __WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["b" /* SNIPPET_TYPE_CURL */] }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, __WEBPACK_IMPORTED_MODULE_7__constants_RequestSnippetTypeLabelMap__["a" /* default */][__WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["b" /* SNIPPET_TYPE_CURL */]])),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], { refKey: __WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["c" /* SNIPPET_TYPE_C_SHARP */] }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, __WEBPACK_IMPORTED_MODULE_7__constants_RequestSnippetTypeLabelMap__["a" /* default */][__WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["c" /* SNIPPET_TYPE_C_SHARP */]])),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], { refKey: __WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["d" /* SNIPPET_TYPE_GO */] }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, __WEBPACK_IMPORTED_MODULE_7__constants_RequestSnippetTypeLabelMap__["a" /* default */][__WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["d" /* SNIPPET_TYPE_GO */]])),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], { refKey: __WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["f" /* SNIPPET_TYPE_JAVA */], hasSubMenu: true }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, __WEBPACK_IMPORTED_MODULE_7__constants_RequestSnippetTypeLabelMap__["a" /* default */][__WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["f" /* SNIPPET_TYPE_JAVA */]]),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["f" /* SubMenuItem */], null,
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], { refKey: __WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["j" /* SNIPPET_TYPE_JAVA_OK_HTTP */] }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, __WEBPACK_IMPORTED_MODULE_7__constants_RequestSnippetTypeLabelMap__["a" /* default */][__WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["j" /* SNIPPET_TYPE_JAVA_OK_HTTP */]])),
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], { refKey: __WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["k" /* SNIPPET_TYPE_JAVA_UNIREST */] }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, __WEBPACK_IMPORTED_MODULE_7__constants_RequestSnippetTypeLabelMap__["a" /* default */][__WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["k" /* SNIPPET_TYPE_JAVA_UNIREST */]])))),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], { refKey: __WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["g" /* SNIPPET_TYPE_JAVASCRIPT */], hasSubMenu: true }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, __WEBPACK_IMPORTED_MODULE_7__constants_RequestSnippetTypeLabelMap__["a" /* default */][__WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["g" /* SNIPPET_TYPE_JAVASCRIPT */]]),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["f" /* SubMenuItem */], null,
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], { refKey: __WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["h" /* SNIPPET_TYPE_JAVASCRIPT_JQUERY_AJAX */] }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, __WEBPACK_IMPORTED_MODULE_7__constants_RequestSnippetTypeLabelMap__["a" /* default */][__WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["h" /* SNIPPET_TYPE_JAVASCRIPT_JQUERY_AJAX */]])),
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], { refKey: __WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["i" /* SNIPPET_TYPE_JAVASCRIPT_XHR */] }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, __WEBPACK_IMPORTED_MODULE_7__constants_RequestSnippetTypeLabelMap__["a" /* default */][__WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["i" /* SNIPPET_TYPE_JAVASCRIPT_XHR */]])))),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], { refKey: __WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["l" /* SNIPPET_TYPE_NODEJS */], hasSubMenu: true }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, __WEBPACK_IMPORTED_MODULE_7__constants_RequestSnippetTypeLabelMap__["a" /* default */][__WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["l" /* SNIPPET_TYPE_NODEJS */]]),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["f" /* SubMenuItem */], null,
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], { refKey: __WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["m" /* SNIPPET_TYPE_NODEJS_NATIVE */] }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, __WEBPACK_IMPORTED_MODULE_7__constants_RequestSnippetTypeLabelMap__["a" /* default */][__WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["m" /* SNIPPET_TYPE_NODEJS_NATIVE */]])),
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], { refKey: __WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["n" /* SNIPPET_TYPE_NODEJS_REQUEST */] }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, __WEBPACK_IMPORTED_MODULE_7__constants_RequestSnippetTypeLabelMap__["a" /* default */][__WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["n" /* SNIPPET_TYPE_NODEJS_REQUEST */]])),
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], { refKey: __WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["o" /* SNIPPET_TYPE_NODEJS_UNIREST */] }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, __WEBPACK_IMPORTED_MODULE_7__constants_RequestSnippetTypeLabelMap__["a" /* default */][__WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["o" /* SNIPPET_TYPE_NODEJS_UNIREST */]])))),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], { refKey: __WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["p" /* SNIPPET_TYPE_OBJECTIVE_C */] }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, __WEBPACK_IMPORTED_MODULE_7__constants_RequestSnippetTypeLabelMap__["a" /* default */][__WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["p" /* SNIPPET_TYPE_OBJECTIVE_C */]])),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], { refKey: __WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["q" /* SNIPPET_TYPE_O_CAML */] }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, __WEBPACK_IMPORTED_MODULE_7__constants_RequestSnippetTypeLabelMap__["a" /* default */][__WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["q" /* SNIPPET_TYPE_O_CAML */]])),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], { refKey: __WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["r" /* SNIPPET_TYPE_PHP */], hasSubMenu: true }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, __WEBPACK_IMPORTED_MODULE_7__constants_RequestSnippetTypeLabelMap__["a" /* default */][__WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["r" /* SNIPPET_TYPE_PHP */]]),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["f" /* SubMenuItem */], null,
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], { refKey: __WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["t" /* SNIPPET_TYPE_PHP_HTTP_V1 */] }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, __WEBPACK_IMPORTED_MODULE_7__constants_RequestSnippetTypeLabelMap__["a" /* default */][__WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["t" /* SNIPPET_TYPE_PHP_HTTP_V1 */]])),
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], { refKey: __WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["u" /* SNIPPET_TYPE_PHP_HTTP_V2 */] }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, __WEBPACK_IMPORTED_MODULE_7__constants_RequestSnippetTypeLabelMap__["a" /* default */][__WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["u" /* SNIPPET_TYPE_PHP_HTTP_V2 */]])),
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], { refKey: __WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["s" /* SNIPPET_TYPE_PHP_CURL */] }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, __WEBPACK_IMPORTED_MODULE_7__constants_RequestSnippetTypeLabelMap__["a" /* default */][__WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["s" /* SNIPPET_TYPE_PHP_CURL */]])))),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], { refKey: __WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["v" /* SNIPPET_TYPE_PYTHON */], hasSubMenu: true }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, __WEBPACK_IMPORTED_MODULE_7__constants_RequestSnippetTypeLabelMap__["a" /* default */][__WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["v" /* SNIPPET_TYPE_PYTHON */]]),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["f" /* SubMenuItem */], null,
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], { refKey: __WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["w" /* SNIPPET_TYPE_PYTHON_3 */] }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, __WEBPACK_IMPORTED_MODULE_7__constants_RequestSnippetTypeLabelMap__["a" /* default */][__WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["w" /* SNIPPET_TYPE_PYTHON_3 */]])),
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], { refKey: __WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["x" /* SNIPPET_TYPE_PYTHON_REQUESTS */] }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, __WEBPACK_IMPORTED_MODULE_7__constants_RequestSnippetTypeLabelMap__["a" /* default */][__WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["x" /* SNIPPET_TYPE_PYTHON_REQUESTS */]])))),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], { refKey: __WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["y" /* SNIPPET_TYPE_RUBY */] }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, __WEBPACK_IMPORTED_MODULE_7__constants_RequestSnippetTypeLabelMap__["a" /* default */][__WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["y" /* SNIPPET_TYPE_RUBY */]])),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], { refKey: __WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["z" /* SNIPPET_TYPE_SHELL */], hasSubMenu: true }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, __WEBPACK_IMPORTED_MODULE_7__constants_RequestSnippetTypeLabelMap__["a" /* default */][__WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["z" /* SNIPPET_TYPE_SHELL */]]),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["f" /* SubMenuItem */], null,
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], { refKey: __WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["C" /* SNIPPET_TYPE_SHELL_WGET */] }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, __WEBPACK_IMPORTED_MODULE_7__constants_RequestSnippetTypeLabelMap__["a" /* default */][__WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["C" /* SNIPPET_TYPE_SHELL_WGET */]])),
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], { refKey: __WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["B" /* SNIPPET_TYPE_SHELL_HTTPIE */] }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, __WEBPACK_IMPORTED_MODULE_7__constants_RequestSnippetTypeLabelMap__["a" /* default */][__WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["B" /* SNIPPET_TYPE_SHELL_HTTPIE */]])),
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], { refKey: __WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["A" /* SNIPPET_TYPE_SHELL_CURL */] }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, __WEBPACK_IMPORTED_MODULE_7__constants_RequestSnippetTypeLabelMap__["a" /* default */][__WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["A" /* SNIPPET_TYPE_SHELL_CURL */]])))),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], { refKey: __WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["D" /* SNIPPET_TYPE_SWIFT */] }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, __WEBPACK_IMPORTED_MODULE_7__constants_RequestSnippetTypeLabelMap__["a" /* default */][__WEBPACK_IMPORTED_MODULE_8__constants_RequestSnippetType__["D" /* SNIPPET_TYPE_SWIFT */]])))),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'request-editor-snippet-generator-copy' },

            !isCopied &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
                onClick: this.handleCopyCode,
                type: 'primary',
                size: 'small',
                className: 'request-editor-snippet-generator-copy-button' }, 'Copy to Clipboard'),





            isCopied &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
                className: 'request-editor-snippet-generator-copied-button',
                size: 'small' },

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Icons_SuccessIcon__["a" /* default */], { style: 'primary', className: 'request-editor-snippet-generator-copied-button-icon' })))),





        this.props.warning &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(Alert, {
          className: 'request-editor-snipper-generator-warning',
          type: 'warn',
          isDismissable: false,
          message: this.props.warning }),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_TextEditor__["a" /* default */], {
          ref: input => {return input && input.focus();},
          value: this.state.codeSnippet,
          mode: this.state.editorMode,
          className: 'request-snippet-generator-editor',
          onChange: this.handleSnippetChange,
          wrapLine: true,
          height: '450px' })));



  }};

/***/ }),

/***/ 4799:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__ResolveRequest__ = __webpack_require__(1531);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__SnippetGeneratorService__ = __webpack_require__(4800);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__PrepareRequestService__ = __webpack_require__(1002);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__MergeDispatchedRequestService__ = __webpack_require__(3954);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__modules_services_RequestWithFileBodyService_js__ = __webpack_require__(1530);







var codeGenerator = {

  /**
                       * Used to return the snippet for a particular language
                       *
                       * @param  {Object} editorId - editorId
                       * @param  {Object} selectedLanguage - parentLanguage
                       * @param  {String} selectedLanguage.parentLanguage
                       * @param  {String} [selectedLanguage.childLanguage]
                       *
                       * Currently, all languages dont have a child language
                       *
                       * @return {Promise}
                       */
  getSnippet(editorId, selectedLanguage) {
    let editor,
    request;

    return Promise.resolve().
    then(() => {
      if (!editorId || !selectedLanguage) {
        return Promise.reject(new Error('CodeGenerator~getSnippet: Incorrect Parameters.'));
      }

      if (!selectedLanguage.parentLanguage) {
        return Promise.reject(new Error('CodeGenerator~getSnippet: Incorrect Parameters.'));
      }

      editor = Object(__WEBPACK_IMPORTED_MODULE_2__stores_get_store__["getStore"])('EditorStore').find(editorId);

      if (!editor) {
        return Promise.reject(new Error('CodeGenerator~getSnippet: Editor not found.'));
      }

      request = editor.model && Object(__WEBPACK_IMPORTED_MODULE_5__modules_services_RequestWithFileBodyService_js__["a" /* getRequestWithFileBody */])(editor.model);

      if (!request) {
        return Promise.reject(new Error('CodeGenerator~getSnippet: Request not found.'));
      }

      return request;
    })

    // add system restricted parameters
    .then(request => {
      return __WEBPACK_IMPORTED_MODULE_4__MergeDispatchedRequestService__["a" /* default */].mergeDispatchedRequest(editorId, request);
    })

    // Get the complete request from db
    .then(resolvedRestrictedParamsRequest => {
      return __WEBPACK_IMPORTED_MODULE_3__PrepareRequestService__["a" /* default */].getPopulatedRequest(resolvedRestrictedParamsRequest);
    })

    // prepare the request to be used for codeGen (eg: adding default headers)
    .then(populatedRequest => {
      return __WEBPACK_IMPORTED_MODULE_3__PrepareRequestService__["a" /* default */].addDefaultHeaders(populatedRequest);
    })

    // resolve the variables for the current request
    .then(preparedRequest => {
      return __WEBPACK_IMPORTED_MODULE_0__ResolveRequest__["a" /* default */].resolve(preparedRequest);
    }).

    then(resolvedRequest => {
      if (!resolvedRequest) {
        return Promise.reject('CodeGenerator~getSnippet: Error in resolving request.');
      }

      // point where you have the resolved Request,
      // and integration of code gen as plugins can be called from here
      // in the future
      return __WEBPACK_IMPORTED_MODULE_1__SnippetGeneratorService__["a" /* default */].getSnippet(resolvedRequest, selectedLanguage);
    });
  } };


/* harmony default export */ __webpack_exports__["a"] = (codeGenerator);

/***/ }),

/***/ 4800:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__utils_util__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__constants_RequestSnippetTypeActionMap__ = __webpack_require__(4801);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__GenerateHttpRequestSnippetService__ = __webpack_require__(4802);




const SNIPPET_HTTP = 'HTTP',
MESSAGE = 'message',
SNIPPET_EVENT_TYPE = 'snippet_generated',
SNIPPET_GENERATE_COMMAND = 'getSnippet',
POST_MESSAGE_ORIGIN_OPTION = '*',

SANDBOX_TIMEOUT = 5 * 1000; // 5 seconds

var SnippetGenerator = {
  /**
                          * Used to convert the resolved SDK request to a form postman snippet generator understands
                          *
                          * Converts the header Variable List to a string eg: [{key: '1', value: '2'}, {key: 'foo', value: 'bar'}] -> '1: 2\nfoo: bar'
                          * Converts raw body to `rawModeData` = 'Hi i am raw'
                          * Also, Removes body for those methods which are not supported
                          *
                          * @param  {Object} resolvedRequest
                          *
                          * @returns {Object}
                          */
  transformRequestObject(resolvedRequest) {
    let req = {};

    req['url'] = resolvedRequest.url.toString();
    req['method'] = resolvedRequest.method;

    if (!_.isEmpty(resolvedRequest.getHeaders({ enabled: true }))) {
      let headers = '',
      headerObject = resolvedRequest.getHeaders({ enabled: true });

      _.forEach(Object.keys(headerObject), function (key) {
        headers += `${key}: ${headerObject[key]}\n`;
      });

      req['headers'] = `${headers}`;
    }

    if (!_.isEmpty(_.reject(resolvedRequest.toJSON().body, 'disabled'))) {
      let requestBody = resolvedRequest.toJSON().body;

      switch (requestBody.mode) {
        case 'raw':
          req['rawModeData'] = requestBody[requestBody.mode];
          req['dataMode'] = requestBody.mode;
          break;
        case 'urlencoded':
          req['dataMode'] = requestBody.mode;
          req['data'] = _.reject(requestBody[requestBody.mode], { disabled: true });
          break;
        case 'formdata':
          req['dataMode'] = 'params';

          req['data'] = _.chain(requestBody[requestBody.mode]).
          reject({ disabled: true })

          // copy `body.src` to `body.value`
          .map(item => {
            return item.src ? _.assign(item, { value: item.src }) : item;
          }).
          value();
          break;
        case 'binary':
          req['dataMode'] = requestBody.mode;
          break;}

    }

    // added this because when converted request containing urlencoded data in to PostmanSdk Object
    // it is loosing its property of type
    // while works fine in case of form-data
    // @todo: need to check once why is it loosing the value
    req.dataMode === 'urlencoded' && _.forEach(req.data, datum => {
      if (!datum.type) {
        datum.type = 'text';
        return;
      }
      return;
    });

    return req;
  },


  /**
      * Used to return the snippet for a particular language
      *
      * @param  {Object} resolvedRequest
      * @param  {Object} selectedLanguage
      * @param  {String} selectedLanguage.parentLanguage
      * @param  {String} [selectedLanguage.childLanguage]
      *
      * Currently, all languages dont have a child language
      *
      * @return {Promise}
      */
  getSnippet(resolvedRequest, selectedLanguage) {

    if (!resolvedRequest || !selectedLanguage || !selectedLanguage.parentLanguage) {
      return Promise.reject(new Error('SnippetGeneratorService~getSnippet: Incorrect parameters.'));
    }

    let { parentLanguage, childLanguage } = selectedLanguage,
    snippetOptions;

    return Promise.resolve().
    then(() => {

      // checks first if its for 'HTTP', returns the snippet from the HTTPRequestSnippet
      if (parentLanguage === SNIPPET_HTTP) {

        return {
          snippet: __WEBPACK_IMPORTED_MODULE_2__GenerateHttpRequestSnippetService__["a" /* default */].generateSnippet(resolvedRequest),
          editorMode: 'text' };

      }

      // checks if has child language then proceed
      // else does not have a child language and proceeds
      // with the flow where only parentLanguage is present
      if (childLanguage && typeof childLanguage === 'string') {
        snippetOptions = _.get(__WEBPACK_IMPORTED_MODULE_1__constants_RequestSnippetTypeActionMap__["a" /* default */], [parentLanguage, childLanguage]);

        if (!snippetOptions) {
          Promise.reject(new Error('SnippetGeneratorService: Could not generate snippet. Not a valid childLanguage'));
        }
      } else {
        snippetOptions = _.get(__WEBPACK_IMPORTED_MODULE_1__constants_RequestSnippetTypeActionMap__["a" /* default */], [parentLanguage]);

        if (!snippetOptions) {
          return Promise.reject(new Error('SnippetGeneratorService: Could not generate snippet. Not a valid parentLanguage'));
        }
      }

      if (!snippetOptions.generatorFunction) {
        return Promise.reject(new Error('SnippetGeneratorService: Could not generate snippet. Not a valid Language'));
      }

      let requestObject = SnippetGenerator.transformRequestObject(resolvedRequest),
      sandbox = document.getElementById('tester_sandbox');

      return new Promise((resolve, reject) => {
        let message,
        finished = false,
        timer;

        // construct message to send to the tester sandbox
        message = {
          command: SNIPPET_GENERATE_COMMAND,
          request: requestObject,
          snippetName: snippetOptions.generatorFunction,
          options: snippetOptions.options };


        // start a timer to reject the promise if no message is received from tester sandbox
        timer = setTimeout(() => {
          !finished && reject(new Error('Could not generate snippet. Sandbox request timed out.'));

          // mark finished to true, when the response comes after timeout
          // it should not attempt to resolve
          finished = true;
        }, SANDBOX_TIMEOUT);

        // attach listener for the response
        window.addEventListener(MESSAGE, function handler(event) {
          if (event.data.type !== SNIPPET_EVENT_TYPE || finished) {
            return;
          }

          // cleanup

          // remove the timeout
          clearTimeout(timer);

          // mark flag as done
          finished = true;

          // remove listener
          window.removeEventListener(MESSAGE, handler);

          // return the result
          resolve({
            snippet: event.data.result,
            editorMode: snippetOptions.editorMode });

        });

        // send the message to sandbox
        sandbox.contentWindow.postMessage(message, POST_MESSAGE_ORIGIN_OPTION);
      });
    });
  } };


/* harmony default export */ __webpack_exports__["a"] = (SnippetGenerator);
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4801:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__ = __webpack_require__(3748);


let SNIPPET_TYPE_MAP = {};

SNIPPET_TYPE_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["b" /* SNIPPET_TYPE_CURL */]] = {
  generatorFunction: 'generateShellCurlSnippet',
  editorMode: 'powershell',
  options: { short: true } };


SNIPPET_TYPE_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["a" /* SNIPPET_TYPE_C */]] = {
  generatorFunction: 'generateCLibCurlSnippet',
  editorMode: 'c_cpp' };

SNIPPET_TYPE_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["c" /* SNIPPET_TYPE_C_SHARP */]] = {
  generatorFunction: 'generateCSharpRestSharpSnippet',
  editorMode: 'csharp' };

SNIPPET_TYPE_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["d" /* SNIPPET_TYPE_GO */]] = {
  generatorFunction: 'generateGoNativeSnippet',
  editorMode: 'golang' };


SNIPPET_TYPE_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["f" /* SNIPPET_TYPE_JAVA */]] = {};
SNIPPET_TYPE_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["f" /* SNIPPET_TYPE_JAVA */]][__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["j" /* SNIPPET_TYPE_JAVA_OK_HTTP */]] = {
  generatorFunction: 'generateJavaOkHttpSnippet',
  editorMode: 'java' };

SNIPPET_TYPE_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["f" /* SNIPPET_TYPE_JAVA */]][__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["k" /* SNIPPET_TYPE_JAVA_UNIREST */]] = {
  generatorFunction: 'generateJavaUnirestSnippet',
  editorMode: 'java' };


SNIPPET_TYPE_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["g" /* SNIPPET_TYPE_JAVASCRIPT */]] = {};
SNIPPET_TYPE_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["g" /* SNIPPET_TYPE_JAVASCRIPT */]][__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["h" /* SNIPPET_TYPE_JAVASCRIPT_JQUERY_AJAX */]] = {
  generatorFunction: 'generateJavaScriptjQueryAjaxSnippet',
  editorMode: 'javascript' };

SNIPPET_TYPE_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["g" /* SNIPPET_TYPE_JAVASCRIPT */]][__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["i" /* SNIPPET_TYPE_JAVASCRIPT_XHR */]] = {
  generatorFunction: 'generateJavaScriptXMLHttpRequestSnippet',
  editorMode: 'javascript' };


SNIPPET_TYPE_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["l" /* SNIPPET_TYPE_NODEJS */]] = {};
SNIPPET_TYPE_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["l" /* SNIPPET_TYPE_NODEJS */]][__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["m" /* SNIPPET_TYPE_NODEJS_NATIVE */]] = {
  generatorFunction: 'generateNodeNativeSnippet',
  editorMode: 'javascript' };

SNIPPET_TYPE_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["l" /* SNIPPET_TYPE_NODEJS */]][__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["n" /* SNIPPET_TYPE_NODEJS_REQUEST */]] = {
  generatorFunction: 'generateNodeRequestSnippet',
  editorMode: 'javascript' };

SNIPPET_TYPE_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["l" /* SNIPPET_TYPE_NODEJS */]][__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["o" /* SNIPPET_TYPE_NODEJS_UNIREST */]] = {
  generatorFunction: 'generateNodeUnirestSnippet',
  editorMode: 'javascript' };


SNIPPET_TYPE_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["p" /* SNIPPET_TYPE_OBJECTIVE_C */]] = {
  generatorFunction: 'generateObjectiveCNSURLSnippet',
  editorMode: 'objectivec' };

SNIPPET_TYPE_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["q" /* SNIPPET_TYPE_O_CAML */]] = {
  generatorFunction: 'generateOCamlCoHttpSnippet',
  editorMode: 'ocaml' };


SNIPPET_TYPE_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["r" /* SNIPPET_TYPE_PHP */]] = {};
SNIPPET_TYPE_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["r" /* SNIPPET_TYPE_PHP */]][__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["t" /* SNIPPET_TYPE_PHP_HTTP_V1 */]] = {
  generatorFunction: 'generatePhpPeclHttpV1Snippet',
  editorMode: 'php' };

SNIPPET_TYPE_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["r" /* SNIPPET_TYPE_PHP */]][__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["u" /* SNIPPET_TYPE_PHP_HTTP_V2 */]] = {
  generatorFunction: 'generatePhpPeclHttpV2Snippet',
  editorMode: 'php' };

SNIPPET_TYPE_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["r" /* SNIPPET_TYPE_PHP */]][__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["s" /* SNIPPET_TYPE_PHP_CURL */]] = {
  generatorFunction: 'generatePhpExtCurlSnippet',
  editorMode: 'php' };


SNIPPET_TYPE_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["v" /* SNIPPET_TYPE_PYTHON */]] = {};
SNIPPET_TYPE_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["v" /* SNIPPET_TYPE_PYTHON */]][__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["w" /* SNIPPET_TYPE_PYTHON_3 */]] = {
  generatorFunction: 'generatePythonPython3Snippet',
  editorMode: 'python' };

SNIPPET_TYPE_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["v" /* SNIPPET_TYPE_PYTHON */]][__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["x" /* SNIPPET_TYPE_PYTHON_REQUESTS */]] = {
  generatorFunction: 'generatePythonRequestsSnippet',
  editorMode: 'python' };


SNIPPET_TYPE_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["y" /* SNIPPET_TYPE_RUBY */]] = {
  generatorFunction: 'generateRubyNativeSnippet',
  editorMode: 'ruby' };


SNIPPET_TYPE_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["z" /* SNIPPET_TYPE_SHELL */]] = {};
SNIPPET_TYPE_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["z" /* SNIPPET_TYPE_SHELL */]][__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["C" /* SNIPPET_TYPE_SHELL_WGET */]] = {
  generatorFunction: 'generateShellWgetSnippet',
  editorMode: 'powershell' };

SNIPPET_TYPE_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["z" /* SNIPPET_TYPE_SHELL */]][__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["B" /* SNIPPET_TYPE_SHELL_HTTPIE */]] = {
  generatorFunction: 'generateShellHttpieSnippet',
  editorMode: 'powershell' };

SNIPPET_TYPE_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["z" /* SNIPPET_TYPE_SHELL */]][__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["A" /* SNIPPET_TYPE_SHELL_CURL */]] = {
  generatorFunction: 'generateShellCurlSnippet',
  editorMode: 'powershell',
  options: { escape: true } };

SNIPPET_TYPE_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["D" /* SNIPPET_TYPE_SWIFT */]] = {
  generatorFunction: 'generateSwiftNSURLSnippet',
  editorMode: 'swift' };


/* harmony default export */ __webpack_exports__["a"] = (SNIPPET_TYPE_MAP);

/***/ }),

/***/ 4802:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__utils_util__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__common_utils_url__ = __webpack_require__(1617);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__common_utils_url___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1__common_utils_url__);



/**
                                                        * @param  {String} url
                                                        */
function splitUrlIntoHostAndPath(url) {
  var path = '',
  host,
  parts = url.split('/');

  host = parts[2];

  var prefix = parts[0] + '/' + parts[1] + '/',
  partsCount = parts.length;

  for (var i = 3; i < partsCount; i++) {
    path += '/' + parts[i];
  }

  var quesLocation = path.indexOf('?'),
  hasParams = quesLocation >= 0;

  if (hasParams) {
    parts = __WEBPACK_IMPORTED_MODULE_0__utils_util__["a" /* default */].getUrlVars(path);
    var count = parts.length,
    encodedPath = path.substr(0, quesLocation + 1);

    for (var j = 0; j < count; j++) {
      var value = parts[j].value,
      key = parts[j].key,
      equals = parts[j].equals ? '=' : '';

      encodedPath += key + equals + value + '&';
    }

    // only do this to remove the trailing '&' if params are present
    if (count > 0) {
      encodedPath = encodedPath.substr(0, encodedPath.length - 1);
    }

    path = encodedPath;
  }

  return {
    host: host,
    path: path,
    prefix: prefix };

}

var HttpRequestSnippet = {
  /**
                            * used to get the boundary for form-data in a request
                            */
  getFormDataBoundary() {
    return '----WebKitFormBoundary7MA4YWxkTrZu0gW';
  },

  /**
      * Used to generate snippets for HTTP Type
      *
      * @param  {Object} resolvedRequest - postman SDK request object
      *
      * @returns {String}
      */
  generateSnippet(resolvedRequest) {
    let requestPreview = '',
    method = resolvedRequest.method.toUpperCase(),
    httpVersion = 'HTTP/1.1',
    url = Object(__WEBPACK_IMPORTED_MODULE_1__common_utils_url__["ensureProperUrl"])(resolvedRequest.url.toString()),
    hostAndPath = splitUrlIntoHostAndPath(url),
    path = _.get(hostAndPath, 'path'),
    host = _.get(hostAndPath, 'host');

    if (!method) {method = 'GET';}

    path = path && path.replace(/&/g, '&amp; ') || '';

    requestPreview += `${method} ${path} ${httpVersion}\n`;
    requestPreview += host && `Host: ${host}\n` || '';

    let dataMode = _.get(resolvedRequest, 'body.mode');

    if (dataMode === 'formdata') {
      resolvedRequest.upsertHeader({
        key: 'Content-Type',
        value: `multipart/form-data; boundary=${this.getFormDataBoundary()}` });

    }

    if (!_.isEmpty(resolvedRequest.getHeaders({ enabled: true }))) {
      let headerObject = resolvedRequest.getHeaders({ enabled: true });

      _.forEach(Object.keys(headerObject), key => {
        requestPreview += `${key}: ${headerObject[key]}\n`;
      });
    }

    let requestBody = _.get(resolvedRequest.toJSON(), 'body');

    if (requestBody) {
      // there should be a new line after headers
      requestPreview += '\n';

      let body = '',
      enabledBodyList;
      switch (requestBody.mode) {
        case 'raw':requestPreview += _.get(requestBody, 'raw');

        case 'formdata':
          let formDataRecords = [];
          body = '';
          enabledBodyList = _.reject(requestBody[requestBody.mode], 'disabled');
          if (!_.isEmpty(enabledBodyList)) {

            _.forEach(enabledBodyList, value => {
              if (!value || !value.key) {
                return;
              }
              if (value.type === 'file') {
                body += '\nContent-Disposition: form-data; name="' + value.key + '"; filename=';
                body += '"' + value.src || value.value + '"\n' + 'Content-Type: ' + value.type;
                body += '\n\n\n';
              } else
              if (value.type === 'text') {
                body += '\nContent-Disposition: form-data; name="' + value.key + '"\n\n';
                body += value.value + '\n';
              }
              body += `--${this.getFormDataBoundary()}--`;
              formDataRecords.push(body);
            });

            requestPreview += formDataRecords.join();
          }
          break;

        case 'urlencoded':
          enabledBodyList = _.reject(requestBody[requestBody.mode], 'disabled');
          let encodedData = [];
          if (!_.isEmpty(enabledBodyList)) {
            _.forEach(enabledBodyList, function (value) {
              if (!value || !value.key) {
                return;
              }
              encodedData.push(`${encodeURIComponent(value.key).replace(/%20/g, '+')}=${encodeURIComponent(value.value).replace(/%20/g, '+')}`);
            });
          }
          requestPreview += encodedData.join('&');
          break;

        default:requestPreview;}

    }

    return requestPreview;
  } };


/* harmony default export */ __webpack_exports__["a"] = (HttpRequestSnippet);
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4803:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__ = __webpack_require__(3748);


let SNIPPET_TYPE_LABEL_MAP = {};

SNIPPET_TYPE_LABEL_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["e" /* SNIPPET_TYPE_HTTP */]] = 'HTTP';

SNIPPET_TYPE_LABEL_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["a" /* SNIPPET_TYPE_C */]] = 'C (LibCurl)';

SNIPPET_TYPE_LABEL_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["b" /* SNIPPET_TYPE_CURL */]] = 'cURL';

SNIPPET_TYPE_LABEL_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["c" /* SNIPPET_TYPE_C_SHARP */]] = 'C# (RestSharp)';

SNIPPET_TYPE_LABEL_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["d" /* SNIPPET_TYPE_GO */]] = 'Go';

SNIPPET_TYPE_LABEL_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["f" /* SNIPPET_TYPE_JAVA */]] = 'Java';
SNIPPET_TYPE_LABEL_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["j" /* SNIPPET_TYPE_JAVA_OK_HTTP */]] = 'OK HTTP';
SNIPPET_TYPE_LABEL_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["k" /* SNIPPET_TYPE_JAVA_UNIREST */]] = 'Unirest';

SNIPPET_TYPE_LABEL_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["g" /* SNIPPET_TYPE_JAVASCRIPT */]] = 'JavaScript';
SNIPPET_TYPE_LABEL_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["h" /* SNIPPET_TYPE_JAVASCRIPT_JQUERY_AJAX */]] = 'Jquery AJAX';
SNIPPET_TYPE_LABEL_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["i" /* SNIPPET_TYPE_JAVASCRIPT_XHR */]] = 'XHR';

SNIPPET_TYPE_LABEL_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["l" /* SNIPPET_TYPE_NODEJS */]] = 'NodeJS';
SNIPPET_TYPE_LABEL_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["m" /* SNIPPET_TYPE_NODEJS_NATIVE */]] = 'Native';
SNIPPET_TYPE_LABEL_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["n" /* SNIPPET_TYPE_NODEJS_REQUEST */]] = 'Request';
SNIPPET_TYPE_LABEL_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["o" /* SNIPPET_TYPE_NODEJS_UNIREST */]] = 'Unirest';

SNIPPET_TYPE_LABEL_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["p" /* SNIPPET_TYPE_OBJECTIVE_C */]] = 'Objective-C (NSURL)';

SNIPPET_TYPE_LABEL_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["q" /* SNIPPET_TYPE_O_CAML */]] = 'OCaml (Cohttp)';

SNIPPET_TYPE_LABEL_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["r" /* SNIPPET_TYPE_PHP */]] = 'PHP';
SNIPPET_TYPE_LABEL_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["t" /* SNIPPET_TYPE_PHP_HTTP_V1 */]] = 'HttpRequest';
SNIPPET_TYPE_LABEL_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["u" /* SNIPPET_TYPE_PHP_HTTP_V2 */]] = 'pecl_http';
SNIPPET_TYPE_LABEL_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["s" /* SNIPPET_TYPE_PHP_CURL */]] = 'cURL';

SNIPPET_TYPE_LABEL_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["v" /* SNIPPET_TYPE_PYTHON */]] = 'Python';
SNIPPET_TYPE_LABEL_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["w" /* SNIPPET_TYPE_PYTHON_3 */]] = 'http.client (Python 3)';
SNIPPET_TYPE_LABEL_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["x" /* SNIPPET_TYPE_PYTHON_REQUESTS */]] = 'Requests';

SNIPPET_TYPE_LABEL_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["y" /* SNIPPET_TYPE_RUBY */]] = 'Ruby (NET::Http)';

SNIPPET_TYPE_LABEL_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["z" /* SNIPPET_TYPE_SHELL */]] = 'Shell';
SNIPPET_TYPE_LABEL_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["C" /* SNIPPET_TYPE_SHELL_WGET */]] = 'wget';
SNIPPET_TYPE_LABEL_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["B" /* SNIPPET_TYPE_SHELL_HTTPIE */]] = 'Httpie';
SNIPPET_TYPE_LABEL_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["A" /* SNIPPET_TYPE_SHELL_CURL */]] = 'cURL';

SNIPPET_TYPE_LABEL_MAP[__WEBPACK_IMPORTED_MODULE_0__RequestSnippetType__["D" /* SNIPPET_TYPE_SWIFT */]] = 'Swift (NSURL)';

/* harmony default export */ __webpack_exports__["a"] = (SNIPPET_TYPE_LABEL_MAP);

/***/ }),

/***/ 4804:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return RequestSnippetGeneratorExperimental; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_TextEditor__ = __webpack_require__(311);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__RequestSnippetGeneratorOptions__ = __webpack_require__(4805);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Icons_SettingsIcon__ = __webpack_require__(3930);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_Icons_CopyIcon__ = __webpack_require__(652);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_Icons_SuccessIcon__ = __webpack_require__(312);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__base_Icons_LeftArrowIcon__ = __webpack_require__(1511);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_8_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__utils_ClipboardHelper__ = __webpack_require__(536);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__services_CodeGeneratorExperimental__ = __webpack_require__(4806);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__RequestSnippetGeneratorLanguages__ = __webpack_require__(4911);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__external_navigation_ExternalNavigationService__ = __webpack_require__(59);














const CODEGEN_URL = 'https://go.pstmn.io/generic-codegen-repo';let
RequestSnippetGeneratorExperimental = class RequestSnippetGeneratorExperimental extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.state = {
      activeLanguage: { language: 'curl', variant: 'cURL' },
      optionsArray: [],
      optionsPreference: {},
      codeSnippet: '',
      languageList: [],
      labelEditorMap: {},
      showOptions: false,
      submitOptions: false,
      codeCopied: false };

    this.handleCodeTypeSelect = this.handleCodeTypeSelect.bind(this);
    this.handleCopyCode = this.handleCopyCode.bind(this);
    this.handleSnippetChange = this.handleSnippetChange.bind(this);
    this.handleSubmitOptions = this.handleSubmitOptions.bind(this);
    this.handleToggleOptions = this.handleToggleOptions.bind(this);
    this.sortLanguageList = this.sortLanguageList.bind(this);
  }
  componentWillMount() {
    let language = 'curl',
    variant = 'cURL',
    languageTree,
    displayName,
    languageList = [],
    labelEditorMap = {};
    let oldSetting = pm.settings.getSetting('codegen.experimentalSnippetLanguage');
    if (oldSetting) {
      // OldSetting would be stored as a language>>variant string for the users who have already used the previous version of experimental codegen.
      // Hence to provide backward compatibility, provide option to parse as JSON or as string.
      try {
        oldSetting = JSON.parse(oldSetting);
        language = _.get(oldSetting, 'language', 'curl');
        variant = _.get(oldSetting, 'variant', 'cURL');
      }
      catch (e) {
        let snippetSettings = oldSetting.split('>>');
        language = snippetSettings[0] || 'curl';
        variant = snippetSettings[1] || 'cURL';
      }
    }

    __WEBPACK_IMPORTED_MODULE_10__services_CodeGeneratorExperimental__["a" /* default */].getLanguages().
    then(languages => {
      languageTree = languages;
      if (languageTree && languageTree.length) {
        languageTree.forEach(language => {
          if (!language.variants || !language.variants.length) {
            return;
          }
          if (language.variants.length > 1) {
            language.variants.forEach(variant => {
              displayName = language.label + ' - ' + variant.key;
              languageList.push(
              {
                key: JSON.stringify({
                  language: language.key,
                  variant: variant.key }),

                displayName: displayName });

              labelEditorMap[`${language.key}_${variant.key}`] = {
                displayName: displayName,
                editorMode: language.syntax_mode };

            });
          } else
          {
            displayName = language.label.toLowerCase() !== language.variants[0].key.toLowerCase() ? language.label + ' - ' + language.variants[0].key : language.label;
            languageList.push(
            {
              key: JSON.stringify({
                language: language.key,
                variant: language.variants[0].key }),

              displayName: displayName });

            labelEditorMap[`${language.key}_${language.variants[0].key}`] = {
              displayName: displayName,
              editorMode: language.syntax_mode };

          }
        });
        this.setState({
          languageList: languageList,
          labelEditorMap: labelEditorMap,
          activeLanguage: { language, variant } });

      }
      this.handleCodeTypeSelect(JSON.stringify({ language, variant }));
    });
  }

  handleCodeTypeSelect(key) {
    let codegen = JSON.parse(key),
    { language, variant } = codegen,
    defaultOptions = {},
    optionsPreference,
    temporaryHeaderOption = {
      name: 'Include Temporary Headers',
      id: 'includeTemporaryHeaders',
      type: 'boolean',
      default: pm.settings.getSetting('codegen.globalOptions.includeTemporaryHeaders'),
      description: 'Include temporary headers in the generated code snippet ' +
      '(these are auto-generated by Postman while sending your request)' };


    this.setState({
      activeLanguage: { language, variant } });

    __WEBPACK_IMPORTED_MODULE_10__services_CodeGeneratorExperimental__["a" /* default */].getOptions(language, variant).
    then(options => {
      if (options && options.length) {
        options.unshift(temporaryHeaderOption);
        this.setState({
          optionsArray: options });

        options.forEach(option => {
          defaultOptions[option.id] = option.default;
        });
      }
    }).
    catch(err => {
      var options = [];
      options.unshift(temporaryHeaderOption);
      this.setState({
        optionsArray: options });

      defaultOptions[temporaryHeaderOption.id] = temporaryHeaderOption.default;
      pm.logger.error(`RequestSnippetGeneratorExperimental~handleCodeTypeSelect - ${err}`);
    }).
    then(() => {
      optionsPreference = pm.settings.getSetting(`codegen.snippetOptions.${language}_${variant}`) || defaultOptions;
      this.setState({
        optionsPreference: optionsPreference });

    }).
    then(() => {
      __WEBPACK_IMPORTED_MODULE_10__services_CodeGeneratorExperimental__["a" /* default */].getSnippet(this.props.editorId, { language, variant, optionsPreference }).
      then(snippetObject => {
        if (!snippetObject) {
          return;
        }
        this.setState({
          codeSnippet: snippetObject.snippet },
        () => {

          // update the snippetLanguage in the settings
          let snippetLanguage = JSON.stringify({ language, variant });
          pm.settings.setSetting('codegen.experimentalSnippetLanguage', snippetLanguage);
        });
      });
    }).
    then(() => {
      __WEBPACK_IMPORTED_MODULE_12__modules_services_AnalyticsService__["a" /* default */].addEvent('codegen', 'convert', `${language}_${variant}`);
    });
  }

  handleCopyCode() {
    __WEBPACK_IMPORTED_MODULE_9__utils_ClipboardHelper__["a" /* default */].copy(this.state.codeSnippet);
    this.setState({ codeCopied: true });
    clearTimeout(this.timeout);
    this.timeout = setTimeout(() => {
      this.setState({ codeCopied: false });
    }, 1500);
  }

  handleSnippetChange(content) {
    this.setState({ codeSnippet: content });
  }

  handleSubmitOptions(optionsPreference) {
    pm.settings.setSetting(`codegen.snippetOptions.${this.state.activeLanguage.language}_${this.state.activeLanguage.variant}`, optionsPreference);
    let language = this.state.activeLanguage.language ? this.state.activeLanguage.language : '',
    variant = this.state.activeLanguage.variant ? this.state.activeLanguage.variant : '';
    __WEBPACK_IMPORTED_MODULE_12__modules_services_AnalyticsService__["a" /* default */].addEvent('codegen', 'configure', `${language}_${variant}`);
    this.handleCodeTypeSelect(JSON.stringify({ language, variant }));
  }
  handleToggleOptions() {
    this.setState(prevState => ({
      showOptions: !prevState.showOptions }));


  }

  getCopyButtonClasses() {
    return __WEBPACK_IMPORTED_MODULE_8_classnames___default()(
    { 'experimental-request-editor-snippet-generator-copied-button': this.state.codeCopied,
      'experimental-request-editor-snippet-generator-copy-button': !this.state.codeCopied });


  }
  sortLanguageList(languageList) {
    languageList.sort((element1, element2) => {
      return element1.displayName.localeCompare(element2.displayName);
    });
    return languageList;
  }

  render() {
    let activeLanguage = _.get(this.state.activeLanguage, 'language', 'curl'),
    activeVariant = _.get(this.state.activeLanguage, 'variant', 'cURL'),
    displayName = this.state.labelEditorMap[`${activeLanguage}_${activeVariant}`] ? this.state.labelEditorMap[`${activeLanguage}_${activeVariant}`].displayName : 'cURL',
    editorMode = this.state.labelEditorMap[`${activeLanguage}_${activeVariant}`] ? this.state.labelEditorMap[`${activeLanguage}_${activeVariant}`].editorMode : 'powershell';

    if (this.state.showOptions) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'experimental-request-editor-snippet-generator-options-wrapper' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'experimental-request-editor-snippet-generator-options-header' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'experimental-request-editor-snippet-generator-options-header__section-left' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                  onClick: this.handleToggleOptions,
                  className: 'experimental-request-editor-snippet-generator-options-back-button' },

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_Icons_LeftArrowIcon__["a" /* default */], {
                  size: 'sm',
                  style: 'normal' })),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', {
                  className: 'experimental-request-editor-snippet-generator-options-header-back-label',
                  onClick: this.handleToggleOptions }, 'Back to generated code'))),





          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'experimental-request-editor-snippet-generator-options-header-settings-label' }, 'Settings for ', displayName, ' '),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'experimental-request-editor-snippet-generator-options' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__RequestSnippetGeneratorOptions__["a" /* default */], {
              isOpen: this.state.showOptions,
              optionsArray: this.state.optionsArray,
              optionsPreference: this.state.optionsPreference,
              onSubmit: this.handleSubmitOptions }))));




    }
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'experimental-request-editor-snippet-generator-wrapper' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'experimental-request-editor-snippet-generator-languages-pane' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_11__RequestSnippetGeneratorLanguages__["a" /* default */], {
            data: this.sortLanguageList(this.state.languageList),
            onSelect: this.handleCodeTypeSelect,
            'default': JSON.stringify({ language: activeLanguage, variant: activeVariant }),
            searchPlaceholder: 'Filter languages...' })),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'experimental-request-editor-snippet-generator-editor-options-pane' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'experimental-request-editor-snippet-generator-header' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'experimental-request-editor-snippet-generator-header__section-left' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'experimental-request-editor-snippet-generator-header-label' }, 'Generated code for ', displayName, ' ')),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'experimental-request-editor-snippet-generator-header__section-right' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', {
                  onClick: () => {Object(__WEBPACK_IMPORTED_MODULE_13__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(CODEGEN_URL);},
                  className: 'experimental-request-editor-snippet-generator-contribute' }, 'Contribute on GitHub'),



              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                  onClick: this.handleToggleOptions,
                  tooltip: 'View Settings',
                  className: 'experimental-request-editor-snippet-generator-options-button' },

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Icons_SettingsIcon__["a" /* default */], {
                  size: 'sm',
                  style: 'normal' })),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                  onClick: this.handleCopyCode,
                  tooltip: 'Copy',
                  className: this.getCopyButtonClasses() },


                !this.state.codeCopied ?
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Icons_CopyIcon__["a" /* default */], {
                  size: 'sm',
                  style: 'normal' }) :


                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Icons_SuccessIcon__["a" /* default */], {
                  size: 'sm',
                  style: 'normal' })))),





          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'experimental-request-editor-snippet-generator-editor' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_TextEditor__["a" /* default */], {
              ref: input => {return input && input.focus();},
              value: this.state.codeSnippet,
              mode: editorMode,
              className: 'experimental-request-editor-snippet-generator-text-editor',
              onChange: this.handleSnippetChange,
              wrapLine: true,
              height: '100%',
              width: '100%' })))));





  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4805:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_lodash__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_lodash___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_lodash__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_ToggleSwitch__ = __webpack_require__(959);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Markdown__ = __webpack_require__(173);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_Dropdowns__ = __webpack_require__(31);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_Buttons__ = __webpack_require__(13);






let

RequestSnippetGeneratorOptions = class RequestSnippetGeneratorOptions extends __WEBPACK_IMPORTED_MODULE_0_react___default.a.Component {
  constructor(props) {
    super(props);
    this.state = {};
    this.onSubmit = this.onSubmit.bind(this);
    this.onChange = this.onChange.bind(this);
    this.renderOptions = this.renderOptions.bind(this);
    this.delayedSubmit = __WEBPACK_IMPORTED_MODULE_1_lodash___default.a.debounce(this.onSubmit, 500);
  }

  componentDidMount() {
    var optionsPreference = this.props.optionsPreference,
    optionsArray = this.props.optionsArray;
    optionsArray.forEach(option => {
      this.setState({
        [option.id]: optionsPreference[option.id] !== undefined ? optionsPreference[option.id] : option.default });

    });
  }

  onChange(key, type, value) {
    if (type === 'positiveinteger') {
      let intValue = parseInt(value);
      value = isNaN(intValue) ? 0 : intValue;
    }
    this.setState({
      [key]: value });

    if (key === 'includeTemporaryHeaders') {
      pm.settings.setSetting('codegen.globalOptions.includeTemporaryHeaders', value);
    }
    this.delayedSubmit();
  }

  onSubmit() {
    // everything except includeTemporaryHeaders needs to be stored as
    // a language-level setting by the parent component
    // includeTemporaryHeaders is set in pm.settings using a separate key
    // in the onChange function
    var options = __WEBPACK_IMPORTED_MODULE_1_lodash___default.a.omit(this.state, 'includeTemporaryHeaders');
    this.props.onSubmit && this.props.onSubmit(options);
  }

  renderOptions() {
    let optionsArray = this.props.optionsArray,
    input,
    options = optionsArray.map(option => {
      let key = option.id,
      label = option.name,
      type = option.type,
      description = option.description;
      type = typeof type === 'string' ? type.toLowerCase() : type;
      switch (type) {
        case 'boolean':
          input =
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_ToggleSwitch__["a" /* default */], {
            isActive: this.state[key],
            onClick: this.onChange.bind(this, key, type) });


          break;
        case 'enum':
          input =
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Dropdowns__["a" /* Dropdown */], { onSelect: this.onChange.bind(this, key, type) },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Dropdowns__["b" /* DropdownButton */], { type: 'text' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Buttons__["a" /* Button */], null, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, this.state[key]))),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Dropdowns__["c" /* DropdownMenu */], { 'align-right': true },

              option.availableOptions.map(dropdownItem => {
                return __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Dropdowns__["d" /* MenuItem */], { refKey: dropdownItem, key: dropdownItem }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, dropdownItem));
              })));




          break;
        default:
          input =
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Inputs__["b" /* Input */], {
            inputStyle: 'box',
            value: this.state[key] !== undefined ? this.state[key] : option.default,
            onChange: this.onChange.bind(this, key, type) });}



      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'experimental-request-editor-snippet-generator-options-list-item', key: key },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'experimental-request-editor-snippet-generator-options-list-item-label' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
              label),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'experimental-request-editor-snippet-generator-options-list-item-description' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Markdown__["a" /* default */], { source: description }))),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'experimental-request-editor-snippet-generator-options-list-item-value' },
            input)));



    });
    return options;
  }

  render() {
    return (
      this.props.isOpen ?
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'experimental-request-editor-snippet-generator-options-wrapper' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'experimental-request-editor-snippet-generator-options-list' },
          this.renderOptions())) :



      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null));

  }};


/* harmony default export */ __webpack_exports__["a"] = (RequestSnippetGeneratorOptions);

/***/ }),

/***/ 4806:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__ResolveRequest__ = __webpack_require__(1531);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__PrepareRequestService__ = __webpack_require__(1002);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__MergeDispatchedRequestService__ = __webpack_require__(3954);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__modules_services_RequestWithFileBodyService_js__ = __webpack_require__(1530);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_workspace_activity_feed_WorkspaceActivityItemComponents__ = __webpack_require__(3621);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__controllers_VariablesCache__ = __webpack_require__(3918);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__services_codegen_importCodeGenerators__ = __webpack_require__(4807);










var codeGeneratorExperimental = {

  /**
                                   * Used to return the snippet for a particular language
                                   *
                                   * @param  {Object} editorId - editorId
                                   * @param  {Object} selectedLanguage - parentLanguage
                                   * @param  {String} selectedLanguage.language
                                   * @param  {String} selectedLanguage.variant
                                   * @param  {Object} selectedLanguage.optionsPreference
                                   *
                                   *
                                   * @return {Promise}
                                   */
  async getSnippet(editorId, selectedLanguage) {
    let editor,
    request,
    snippetObject,
    codeGen = await Object(__WEBPACK_IMPORTED_MODULE_7__services_codegen_importCodeGenerators__["a" /* default */])();

    return Promise.resolve().
    then(() => {
      if (!editorId || !selectedLanguage) {
        return Promise.reject(new Error('CodeGeneratorExperimental~getSnippet: Incorrect Parameters.'));
      }

      if (!selectedLanguage.language || !selectedLanguage.variant) {
        return Promise.reject(new Error('CodeGeneratorExperimental~getSnippet: Incorrect Parameters.'));
      }

      editor = Object(__WEBPACK_IMPORTED_MODULE_1__stores_get_store__["getStore"])('EditorStore').find(editorId);

      if (!editor) {
        return Promise.reject(new Error('CodeGeneratorExperimental~getSnippet: Editor not found.'));
      }

      request = editor.model && Object(__WEBPACK_IMPORTED_MODULE_4__modules_services_RequestWithFileBodyService_js__["a" /* getRequestWithFileBody */])(editor.model);

      if (!request) {
        return Promise.reject(new Error('CodeGeneratorExperimental~getSnippet: Request not found.'));
      }

      return request;
    })

    // add system restricted parameters
    .then(request => {
      return __WEBPACK_IMPORTED_MODULE_3__MergeDispatchedRequestService__["a" /* default */].mergeDispatchedRequest(editorId, request);
    })

    // Get the complete request from db
    .then(resolvedRestrictedParamsRequest => {
      return __WEBPACK_IMPORTED_MODULE_2__PrepareRequestService__["a" /* default */].getPopulatedRequest(resolvedRestrictedParamsRequest);
    })


    // resolve the variables for the current request
    .then(preparedRequest => {
      return __WEBPACK_IMPORTED_MODULE_0__ResolveRequest__["a" /* default */].resolve(preparedRequest);
    }).

    then(resolvedRequest => {
      if (!resolvedRequest) {
        return Promise.reject('CodeGeneratorExperimental~getSnippet: Error in resolving request.');
      }

      // point where you have the resolved Request,
      // and integration of code gen as plugins can be called from here
      // in the future
      resolvedRequest.headers.map(header => {
        if (!header.value) {
          header.value = '';
        }
        return header.value = header.value.toString();
      });
      if (!pm.settings.getSetting('codegen.globalOptions.includeTemporaryHeaders')) {
        resolvedRequest.headers.remove(header => {
          if (header.system) {
            return !(header.key.toLowerCase() === 'content-type' || header.key.toLowerCase() === 'authorization');
          }
          return false;
        });
      }
      if (resolvedRequest.body.mode === 'graphql') {
        let query = resolvedRequest.body.graphql.query,
        graphqlVariables;
        try {
          graphqlVariables = JSON.parse(resolvedRequest.body.graphql.variables);
        }
        catch (e) {
          graphqlVariables = {};
        }
        resolvedRequest.body.mode = 'raw';
        resolvedRequest.body['raw'] = JSON.stringify({
          query: query,
          variables: graphqlVariables });

      }

      try {
        codeGen.convert(selectedLanguage.language, selectedLanguage.variant, resolvedRequest, selectedLanguage.optionsPreference, (err, snippet) => {
          if (err || !snippet) {
            pm.logger.error(`CodeGeneratorExperimental~getSnippet - ${err}: Cannot convert request`);
            snippetObject = {
              snippet: 'Cannot generate snippet. See logs for more information.' };

          } else
          {
            snippetObject = {
              snippet: snippet };

          }
        });
      }
      catch (e) {
        pm.logger.error('CodeGeneratorExperimental~getSnippet - Cannot convert request');
        snippetObject = {
          snippet: 'Error generating snippet. See logs for more information.' };


        // This is needed because we need the error message to show up in the renderer console
        console.error(e); // eslint-disable-line no-console
      }
      return snippetObject;
    });
  },
  async getLanguages() {
    var codeGen = await Object(__WEBPACK_IMPORTED_MODULE_7__services_codegen_importCodeGenerators__["a" /* default */])();
    return codeGen.getLanguageList();
  },

  async getOptions(language, variant) {
    var codeGen = await Object(__WEBPACK_IMPORTED_MODULE_7__services_codegen_importCodeGenerators__["a" /* default */])();
    return new Promise((resolve, reject) => {
      if (!language && !variant) {
        return reject(new Error('CodeGeneratorExperimental~getOptions: Incorrect Parameters.'));
      }
      codeGen.getOptions(language, variant, (err, options) => {
        if (err) {
          return reject(err);
        }
        return resolve(options);
      });
    });
  } };


/* harmony default export */ __webpack_exports__["a"] = (codeGeneratorExperimental);

/***/ }),

/***/ 4807:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/**
 * Lazy loads codegen service
 */
/* harmony default export */ __webpack_exports__["a"] = (async function () {
  let codeGenerator = await __webpack_require__.e/* import() */(31).then(__webpack_require__.bind(null, 4808));
  return codeGenerator;
});

/***/ }),

/***/ 4911:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Icons_SearchIcon__ = __webpack_require__(554);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Icons_CloseIcon__ = __webpack_require__(90);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__RequestSnippetGeneratorLanguage__ = __webpack_require__(4912);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_lodash__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_lodash___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_lodash__);





let
RequestSnippetGeneratorLanguages = class RequestSnippetGeneratorLanguages extends __WEBPACK_IMPORTED_MODULE_0_react___default.a.Component {
  constructor(props) {
    super(props);
    this.state = {
      searchInput: '',
      selectedKey: this.props.default || '',
      data: this.props.data || [],
      filteredData: this.props.data || [] };

    this.onSelect = this.onSelect.bind(this);
    this.onSearchInputChange = this.onSearchInputChange.bind(this);
    this.onSearchInputCancel = this.onSearchInputCancel.bind(this);
    this.listItems = this.listItems.bind(this);
  }

  componentWillReceiveProps(nextProps) {
    if (nextProps.data !== this.props.data || nextProps.default !== this.state.default) {
      this.setState({
        selectedKey: nextProps.default,
        data: nextProps.data });

      if (this.state.searchInput.length) {
        var data = nextProps.data,
        filteredData;
        filteredData = data.filter(item => {
          return item.displayName.toLowerCase().includes(this.state.searchInput.toLowerCase());
        });
        this.setState({
          filteredData: filteredData });

      } else
      {
        this.setState({
          filteredData: nextProps.data });

      }
    }
  }

  onSelect(key) {
    this.setState({
      selectedKey: key });

    this.props.onSelect && this.props.onSelect(key);
  }
  onSearchInputChange(value) {
    this.setState({
      searchInput: value });

    var data = this.state.data,
    filteredData;
    filteredData = data.filter(item => {
      return item.displayName.toLowerCase().includes(value.toLowerCase());
    });
    this.setState({
      filteredData: filteredData });

  }
  onSearchInputCancel() {
    var data = this.state.data;
    this.setState({
      searchInput: '',
      filteredData: data });

  }

  isSelected(refKey) {
    return refKey === this.state.selectedKey;
  }

  listItems() {
    var data = this.state.filteredData,
    listItems;
    listItems = data.map(item => {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__RequestSnippetGeneratorLanguage__["a" /* default */], {
          refKey: item.key,
          id: item.key,
          key: item.key,
          label: item.displayName,
          onSelect: this.onSelect,
          selected: this.isSelected(item.key) }));


    });
    return listItems;
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'experimental-request-editor-snippet-generator-language-details' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'experimental-request-editor-snippet-generator-search-box' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Inputs__["b" /* Input */], {
            ref: 'filterSearch',
            inputStyle: 'huge',
            value: this.state.searchInput,
            placeholder: this.props.searchPlaceholder,
            className: 'experimental-request-editor-snippet-generator-search-input',
            onChange: this.onSearchInputChange.bind(this) }),


          this.state.searchInput.length ?
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Icons_CloseIcon__["a" /* default */], {
            className: 'experimental-request-editor-snippet-generator-close-icon',
            onClick: this.onSearchInputCancel }) :


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Icons_SearchIcon__["a" /* default */], {
            className: 'experimental-request-editor-snippet-generator-search-icon' })),



        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'experimental-request-editor-snippet-generator-search-language-seperator' }),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'experimental-request-editor-snippet-generator-language-list' },
          this.listItems())));



  }};

/* harmony default export */ __webpack_exports__["a"] = (RequestSnippetGeneratorLanguages);

/***/ }),

/***/ 4912:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_react_dom__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_react_dom___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_react_dom__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_classnames__);


let
RequestSnippetGeneratorLanguage = class RequestSnippetGeneratorLanguage extends __WEBPACK_IMPORTED_MODULE_0_react___default.a.Component {
  constructor(props) {
    super(props);
    this.state = {
      isHovered: false };

    this.handleSelect = this.handleSelect.bind(this);
    this.handleMouseOver = this.handleMouseOver.bind(this);
    this.handleMouseOut = this.handleMouseOut.bind(this);
  }
  handleSelect() {
    this.props.onSelect && this.props.onSelect(this.props.refKey);
  }
  handleMouseOver() {
    this.setState({
      isHovered: true });

  }
  handleMouseOut() {
    this.setState({
      isHovered: false });

  }

  componentDidMount() {
    this.ensureVisible();
  }

  componentDidUpdate() {
    this.ensureVisible();
  }

  ensureVisible() {
    if (this.props.selected) {
      Object(__WEBPACK_IMPORTED_MODULE_1_react_dom__["findDOMNode"])(this).scrollIntoViewIfNeeded(true);
    }
  }

  getClasses() {
    return __WEBPACK_IMPORTED_MODULE_2_classnames___default()({
      'experimental-request-editor-snippet-generator-language-item-is-selected': this.props.selected,
      'experimental-request-editor-snippet-generator-language-item-is-hovered': this.state.isHovered && !this.props.selected,
      'experimental-request-editor-snippet-generator-language-item': true });

  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
          id: this.props.id,
          className: this.getClasses(),
          onClick: this.handleSelect,
          onMouseOver: this.handleMouseOver,
          onMouseOut: this.handleMouseOut },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'experimental-request-editor-snippet-generator-language-label' },
          this.props.label)));



  }};

/* harmony default export */ __webpack_exports__["a"] = (RequestSnippetGeneratorLanguage);

/***/ }),

/***/ 4913:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CookiesManagementModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__CookiesManagementContainer__ = __webpack_require__(4914);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_base_Modals__ = __webpack_require__(189);
var _class;


let


CookiesManagementModalContainer = __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default()(_class = class CookiesManagementModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      cookieCounter: 1 };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleCookieAdd = this.handleCookieAdd.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('showCookieManagementModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showCookieManagementModal', this.handleOpen);
  }

  handleOpen() {
    pm.mediator.once('loadedCookies', domainList => {
      this.setState({ isOpen: true });
    });
    pm.cookieManager.loadCookies();
  }

  handleClose() {
    this.setState({ isOpen: false });
  }

  handleCookieAdd() {
    this.setState({ cookieCounter: this.state.cookieCounter + 1 });
  }

  getCustomStyles() {
    return {
      marginTop: '10vh',
      width: '720px' };

  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Modals__["a" /* Modal */], {
          isOpen: this.state.isOpen,
          onRequestClose: this.handleClose,
          customStyles: this.getCustomStyles(),
          className: 'cookies-management-modal' },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Modals__["d" /* ModalHeader */], null, 'MANAGE COOKIES'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'cookies-management-modal-container' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__CookiesManagementContainer__["a" /* default */], {
              onCookieAdd: this.handleCookieAdd,
              cookieCounter: this.state.cookieCounter })))));





  }}) || _class;

/***/ }),

/***/ 4914:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CookiesManagementContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_cookies_CookiesManagement__ = __webpack_require__(4915);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__CookiesManagementDomainWhitelistContainer__ = __webpack_require__(4922);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__utils_util__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__external_navigation_ExternalNavigationService__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__constants_AppUrlConstants__ = __webpack_require__(64);






let

CookiesManagementContainer = class CookiesManagementContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      domains: [],
      cookies: {},
      selectedDomain: '',
      selectedCookie: '',
      showDomainWhitelist: false,
      domainsBeingDeleted: [] };


    this.getDomainList = this.getDomainList.bind(this);
    this.handleDomainSelect = this.handleDomainSelect.bind(this);
    this.handleCookieAdd = this.handleCookieAdd.bind(this);
    this.handleCookieSelect = this.handleCookieSelect.bind(this);
    this.handleDomainDelete = this.handleDomainDelete.bind(this);
    this.handleDomainAdd = this.handleDomainAdd.bind(this);
    this.handleCookieDelete = this.handleCookieDelete.bind(this);
    this.handleCookieChange = this.handleCookieChange.bind(this);
    this.handleLinkClick = this.handleLinkClick.bind(this);
    this.handleDomainWhitelistToggle = this.handleDomainWhitelistToggle.bind(this);
  }

  componentWillMount() {
    this.model = pm.cookieManager;
    this.getDomainList();
  }

  processCookies() {
    let cookies = {};

    _.each(this.state.domains, domain => {
      cookies[domain] = [];
      _.each(this.model.cookies[domain], domainCookies => {
        cookies[domain] = cookies[domain].concat(domainCookies);
      });
    });

    this.setState({ cookies: cookies });
  }

  getDomainList() {
    if (this.model) {
      this.setState({ domains: this.model.getDomainList() }, () => {
        this.processCookies();
      });
    }
  }

  handleDomainSelect(domain) {
    this.setState({
      selectedCookie: '',
      selectedDomain: domain });

  }

  handleCookieSelect(cookie) {
    let domain = cookie ? cookie.domain[0] === '.' ? cookie.domain.slice(1) : cookie.domain : '';
    this.setState({
      selectedCookie: cookie || '',
      selectedDomain: domain });

  }

  handleDomainDelete(domain) {
    let domainsBeingDeleted = [...this.state.domainsBeingDeleted, domain];

    this.setState({ domainsBeingDeleted: domainsBeingDeleted }, () => {
      this.model.deleteDomain(domain, res => {
        this.getDomainList();
        let deletedDomain = res && res.domain,
        domainsBeingDeleted = this.state.domainsBeingDeleted.filter(item => item !== deletedDomain);

        // Remove deleted domain from list
        this.setState({ domainsBeingDeleted: domainsBeingDeleted }, () => {
          if (res.type === 'Success') {
            pm.toasts.success(`Cookies for domain ${deletedDomain} deleted successfully.`);
            return;
          }

          if (res.type === 'RemoveCookieError') {
            pm.toasts.error(`Failed to delete cookies for domain ${deletedDomain}.`);
            return;
          }
        });

      });

    });
  }

  handleDomainAdd(domain) {
    if (domain && domain !== '') {
      this.model.addNewDomain(domain.toLowerCase());
      this.getDomainList();
    }
  }

  handleCookieDelete(cookie) {
    let domain = cookie.domain,
    cookieName = cookie.name,
    path = cookie.path; // TODO: Samvel - why _.find(cookie, (cookiePart) => cookiePart.name === "path"); ?

    // TODO: Samvel - is this needed under any other circumstances?
    // if(pathObj && pathObj.value!="/") {
    //   path = pathObj.value;
    // }
    this.model.deleteCookie(domain, cookieName, path, error => {
      error && pm.logger.error(error);
      !error && this.setState({ selectedCookie: '' }, () => {
        this.processCookies();
      });
    });
  }

  handleCookieAdd(domain) {
    let cookieString = 'Cookie_' + this.props.cookieCounter + '=value; path=/; domain=' + domain + ';',
    cookieObject = __WEBPACK_IMPORTED_MODULE_4__utils_util__["a" /* default */]._parseSingleCookieString(domain, cookieString);

    this.model.addSingleCookie(cookieObject.url, domain, cookieObject, error => {
      if (error) {
        return;
      }

      var newCookie = this.model.cookies[domain][cookieObject.name][0];
      this.handleCookieSelect(newCookie);
      this.props.onCookieAdd && this.props.onCookieAdd();
      this.processCookies();
    });
  }

  handleCookieChange(value) {
    let domain = this.state.selectedDomain,
    cookieObject = __WEBPACK_IMPORTED_MODULE_4__utils_util__["a" /* default */]._parseSingleCookieString(domain, value),
    oldCookieObject = this.state.selectedCookie;

    this.model.editCookie(domain, oldCookieObject, cookieObject, error => {
      !error && this.setState({ selectedCookie: '' }, () => {
        this.processCookies();
      });
    });
  }

  handleLinkClick() {
    Object(__WEBPACK_IMPORTED_MODULE_5__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_6__constants_AppUrlConstants__["_20" /* WORKING_WITH_COOKIES_DOCS_URL */]);
  }

  handleDomainWhitelistToggle() {
    this.setState(prevState => ({
      showDomainWhitelist: !prevState.showDomainWhitelist }));

  }

  render() {

    return (
      this.state.showDomainWhitelist ?

      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__CookiesManagementDomainWhitelistContainer__["a" /* default */], {
        onCancel: this.handleDomainWhitelistToggle }) :



      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_cookies_CookiesManagement__["a" /* default */], {
          domains: this.state.domains,
          cookies: this.state.cookies,
          onDomainAdd: this.handleDomainAdd,
          onDomainSelect: this.handleDomainSelect,
          onDomainDelete: this.handleDomainDelete,
          selectedDomain: this.state.selectedDomain,

          onCookieAdd: this.handleCookieAdd,
          onCookieSelect: this.handleCookieSelect,
          onCookieChange: this.handleCookieChange,
          onCookieDelete: this.handleCookieDelete,
          selectedCookie: this.state.selectedCookie,
          domainsBeingDeleted: this.state.domainsBeingDeleted }),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'cookie-management-container__footer' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Buttons__["a" /* Button */], {
              className: 'cookie-management-container__footer__button',
              type: 'text',
              onClick: this.handleDomainWhitelistToggle }, 'Whitelist Domains'),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Buttons__["a" /* Button */], {
              className: 'cookie-management-container__footer__button',
              type: 'text',
              onClick: this.handleLinkClick }, 'Learn More'))));







  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4915:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CookiesManagement; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__CookiesManagementDomainsList__ = __webpack_require__(4916);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__CookiesManagementCookiesList__ = __webpack_require__(4011);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__CookiesManagementAddDomain__ = __webpack_require__(4921);



let

CookiesManagement = class CookiesManagement extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'cookies-management-wrapper' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__CookiesManagementAddDomain__["a" /* default */], {
          onDomainAdd: this.props.onDomainAdd }),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'cookies-management-container' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__CookiesManagementDomainsList__["a" /* default */], {
            domains: this.props.domains,
            cookies: this.props.cookies,
            selectedDomain: this.props.selectedDomain,
            selectedCookie: this.props.selectedCookie,
            onDomainSelect: this.props.onDomainSelect,
            onDomainDelete: this.props.onDomainDelete,
            onCookieAdd: this.props.onCookieAdd,
            onCookieSelect: this.props.onCookieSelect,
            onCookieChange: this.props.onCookieChange,
            onCookieDelete: this.props.onCookieDelete,
            domainsBeingDeleted: this.props.domainsBeingDeleted }))));




  }};

/***/ }),

/***/ 4916:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CookiesManagementDomainsList; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_EmptyListMessage__ = __webpack_require__(4917);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__CookiesManagementDomainsListItem__ = __webpack_require__(4918);


let

CookiesManagementDomainsList = class CookiesManagementDomainsList extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  render() {
    let domains = this.props.domains;
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'cookies-management-domain-list-wrapper' },

        _.isEmpty(domains) &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_EmptyListMessage__["a" /* default */], { className: 'cookies-management-domain-list-empty' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'cookies-management-domain-list-empty__icon' }), 'No Cookies available'),




        !_.isEmpty(domains) &&
        domains.map(domain => {
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__CookiesManagementDomainsListItem__["a" /* default */], {
              key: domain,
              domain: domain,
              cookies: this.props.cookies[domain],
              selectedDomain: this.props.selectedDomain,
              onDomainSelect: this.props.onDomainSelect,
              onDomainDelete: this.props.onDomainDelete,
              selectedCookie: this.props.selectedCookie,
              onCookieAdd: this.props.onCookieAdd,
              onCookieSelect: this.props.onCookieSelect,
              onCookieChange: this.props.onCookieChange,
              onCookieDelete: this.props.onCookieDelete,
              domainsBeingDeleted: this.props.domainsBeingDeleted }));


        })));



  }};


CookiesManagementDomainsList.defaultProps = { domains: [] };
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4917:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return EmptyListMessage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
let

EmptyListMessage = class EmptyListMessage extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }
  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: this.props.className },
        this.props.children));


  }};

/***/ }),

/***/ 4918:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CookiesManagementDomainsListItem; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_react_dom__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_react_dom___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_react_dom__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__CookiesManagementCookiesList__ = __webpack_require__(4011);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__CookiesManagementCookieEditor__ = __webpack_require__(4920);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__utils_PluralizeHelper__ = __webpack_require__(533);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__utils_util__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_Icons_CloseIcon__ = __webpack_require__(90);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__base_LoadingIndicator__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_8_classnames__);








let

CookiesManagementDomainsListItem = class CookiesManagementDomainsListItem extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isEditorVisible: false,
      editorValue: '',
      isOpen: true };


    this.handleDomainSelect = this.handleDomainSelect.bind(this);
    this.handleCookieAdd = this.handleCookieAdd.bind(this);
    this.handleCookieSelect = this.handleCookieSelect.bind(this);
    this.handleCookieChange = this.handleCookieChange.bind(this);
    this.handleCookieChangeCancel = this.handleCookieChangeCancel.bind(this);
    this.handleEditorChange = this.handleEditorChange.bind(this);
    this.handleCookieDelete = this.handleCookieDelete.bind(this);
    this.handleDomainDelete = this.handleDomainDelete.bind(this);
  }

  getClasses() {
    return __WEBPACK_IMPORTED_MODULE_8_classnames___default()({
      'cookies-management-domain-list-item': true,
      'is-selected': this.props.selectedDomain === this.props.domain });

  }

  componentWillReceiveProps(nextProps) {
    if (nextProps.selectedCookie !== this.props.selectedCookie && nextProps.selectedDomain === this.props.domain) {
      this.setState({
        isEditorVisible: true,
        editorValue: __WEBPACK_IMPORTED_MODULE_5__utils_util__["a" /* default */].stringifyCookieObject(nextProps.selectedCookie) });

    }
  }

  handleDomainSelect() {
    // For a selected domain, if delete is already in progress, do not expand domain accordion
    if (this.props.domainsBeingDeleted && this.props.domainsBeingDeleted.includes(this.props.domain)) {
      return;
    }

    this.setState({
      isEditorVisible: false,
      isOpen: !this.state.isOpen });

    this.props.onDomainSelect && this.props.onDomainSelect(this.props.domain);
  }

  handleDomainDelete(e) {
    // Stop click event to propagate to list item header div. Collapse domain item on delete.
    e.stopPropagation();
    this.collapseSelectedDomain();
    this.props.onDomainDelete(this.props.domain);
  }

  collapseSelectedDomain() {
    this.setState({
      isEditorVisible: false,
      isOpen: false });

  }

  handleCookieAdd() {
    this.setState({ isOpen: true });
    this.props.onCookieAdd && this.props.onCookieAdd(this.props.domain);
  }

  handleCookieSelect(cookie) {
    this.setState({
      isEditorVisible: true,
      editorValue: __WEBPACK_IMPORTED_MODULE_5__utils_util__["a" /* default */].stringifyCookieObject(cookie) });

    this.props.onCookieSelect && this.props.onCookieSelect(cookie);
  }

  handleCookieChange() {
    Object(__WEBPACK_IMPORTED_MODULE_1_react_dom__["findDOMNode"])(this.refs.domain).focus();
    this.setState({ isEditorVisible: false });
    this.props.onCookieChange && this.props.onCookieChange(this.state.editorValue);
  }

  handleCookieChangeCancel() {
    Object(__WEBPACK_IMPORTED_MODULE_1_react_dom__["findDOMNode"])(this.refs.domain).focus();
    this.setState({
      isEditorVisible: false,
      editorValue: this.props.selectedCookie });

    this.props.onCookieSelect && this.props.onCookieSelect();
  }

  handleEditorChange(value) {
    this.setState({ editorValue: value });
  }

  handleCookieDelete(cookie) {
    this.setState({ isEditorVisible: false });
    this.props.onCookieDelete && this.props.onCookieDelete(cookie);
  }

  render() {
    let domain = this.props.domain,
    cookieCount = _.keys(this.props.cookies).length,
    isDeleteDomainInProgress = this.props.domainsBeingDeleted && this.props.domainsBeingDeleted.includes(this.props.domain);

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
          className: this.getClasses(),
          tabIndex: '-1',
          ref: 'domain' },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
            className: 'cookies-management-domain-list-item__header',
            onClick: this.handleDomainSelect },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'cookies-management-domain-list-item__header__name' },
            domain),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'cookies-management-domain-list-item__header__cookie-count' },
            cookieCount, ' ',
            __WEBPACK_IMPORTED_MODULE_4__utils_PluralizeHelper__["a" /* default */].pluralize({
              count: cookieCount,
              singular: 'cookie',
              plural: 'cookies' })),




          isDeleteDomainInProgress ?
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'cookies-management-domain-list-item__header__action-delete' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_LoadingIndicator__["a" /* default */], null)) :


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'cookies-management-domain-list-item__header__actions' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Icons_CloseIcon__["a" /* default */], { className: 'cookies-management-domain-list-item__header__action--delete', onClick: this.handleDomainDelete }))),




        this.state.isOpen &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__CookiesManagementCookiesList__["a" /* default */], {
          selectedCookie: this.props.selectedCookie,
          cookies: this.props.cookies,
          onSelect: this.handleCookieSelect,
          onDelete: this.handleCookieDelete,
          onAdd: this.handleCookieAdd }),



        this.props.selectedDomain === this.props.domain && this.state.isEditorVisible && this.props.selectedCookie !== '' &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__CookiesManagementCookieEditor__["a" /* default */], {
          value: this.state.editorValue,
          onChange: this.handleEditorChange,
          onSave: this.handleCookieChange,
          onCancel: this.handleCookieChangeCancel })));




  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4919:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CookiesManagementCookiesListItem; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Icons_CloseIcon__ = __webpack_require__(90);


let

CookiesManagementCookiesListItem = class CookiesManagementCookiesListItem extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.handleDelete = this.handleDelete.bind(this);
  }

  isSelected(selectedCookie, cookie) {
    return (
      selectedCookie.domain === cookie.domain &&
      selectedCookie.name === cookie.name &&
      selectedCookie.path === cookie.path);

  }

  getClasses() {
    return __WEBPACK_IMPORTED_MODULE_1_classnames___default()(
    'cookies-management-cookies-list-item',
    { 'is-selected': this.isSelected(this.props.selectedCookie, this.props.cookie) });

  }

  handleDelete(e) {
    e && e.stopPropagation();
    this.props.onDelete && this.props.onDelete(this.props.cookie);
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
          className: this.getClasses(),
          onClick: this.props.onSelect.bind(this, this.props.cookie) },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'cookies-management-cookies-list-item__name' }, this.props.cookie.name),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
            className: 'cookies-management-cookies-list-item__remove',
            onClick: this.handleDelete },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Icons_CloseIcon__["a" /* default */], { className: 'cookies-management-cookies-list-item__remove-icon' }))));



  }};

/***/ }),

/***/ 4920:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CookiesManagementCookieEditor; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_TextArea__ = __webpack_require__(962);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_keymaps_KeyMaps__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Buttons__ = __webpack_require__(13);





const keyMap = {
  'submit': ['mod+enter', 'enter'],
  'cancel': 'esc' };let


CookiesManagementCookieEditor = class CookiesManagementCookieEditor extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  componentDidMount() {
    this.refs.editor && this.refs.editor.focus();
  }

  getKeyMapHandlers() {
    return {
      'submit': this.props.onSave,
      'cancel': this.props.onCancel };

  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'cookies-management-cookie-editor-wrapper' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_keymaps_KeyMaps__["a" /* default */], { keyMap: keyMap, handlers: this.getKeyMapHandlers() },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_TextArea__["a" /* default */], {
            ref: 'editor',
            className: 'cookies-management-cookie-editor',
            value: this.props.value,
            onChange: this.props.onChange })),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'cookies-management-cookie-editor__actions' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
              className: 'cookies-management-cookie-editor__action cookies-management-cookie-editor__action--cancel',
              onClick: this.props.onCancel,
              type: 'text' }, 'Cancel'),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
              className: 'cookies-management-cookie-editor__action cookies-management-cookie-editor__action--save',
              onClick: this.props.onSave,
              type: 'primary' }, 'Save'))));






  }};

/***/ }),

/***/ 4921:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CookiesManagementAddDomain; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_keymaps_KeyMaps__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Buttons__ = __webpack_require__(13);





const keyMap = { 'submit': 'enter' };let

CookiesManagementAddDomain = class CookiesManagementAddDomain extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = { domain: '' };

    this.handleDomainAdd = this.handleDomainAdd.bind(this);
    this.handleDomainChange = this.handleDomainChange.bind(this);
  }

  componentWillReceiveProps() {
    this.state.domain !== '' && this.setState({ domain: '' });
  }

  getKeyMapHandlers() {
    return { 'submit': this.handleDomainAdd };
  }

  handleDomainChange(value) {
    this.setState({ domain: value });
  }

  handleDomainAdd() {
    this.props.onDomainAdd && this.props.onDomainAdd(this.state.domain);
    this.setState({ domain: '' });
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'cookies-management-cookie-preview-container' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'cookies-management-cookie-domain-preview' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_keymaps_KeyMaps__["a" /* default */], { keyMap: keyMap, handlers: this.getKeyMapHandlers() },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Inputs__["b" /* Input */], {
              inputStyle: 'box',
              placeholder: 'Type a domain name',
              onChange: this.handleDomainChange,
              value: this.state.domain })),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
              type: 'primary',
              tooltip: 'Add domain',
              className: 'cookies-management-cookie-action-button',
              onClick: this.handleDomainAdd }, 'Add'))));






  }};

/***/ }),

/***/ 4922:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CookiesManagementDomainWhitelistContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_services_CookieService__ = __webpack_require__(1008);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__external_navigation_ExternalNavigationService__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_cookies_CookiesManagementDomainWhitelistList__ = __webpack_require__(4923);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__components_base_Icons_LeftArrowIcon__ = __webpack_require__(1511);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__constants_AppUrlConstants__ = __webpack_require__(64);







let

CookiesManagementDomainWhitelistContainer = class CookiesManagementDomainWhitelistContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      domain: '',
      whitelistedDomains: [] };

    this.handleDomainAdd = this.handleDomainAdd.bind(this);
    this.handleDomainDelete = this.handleDomainDelete.bind(this);
    this.handleLinkClick = this.handleLinkClick.bind(this);
    this.handleDomainChange = this.handleDomainChange.bind(this);
  }

  componentDidMount() {
    this.setState({ whitelistedDomains: __WEBPACK_IMPORTED_MODULE_3__modules_services_CookieService__["a" /* default */].getWhitelistedDomains() });
  }

  handleDomainAdd() {
    if (__WEBPACK_IMPORTED_MODULE_3__modules_services_CookieService__["a" /* default */].addWhitelistDomain(this.state.domain)) {
      this.setState(prevState => ({
        domain: '',
        whitelistedDomains: _.concat(prevState.whitelistedDomains, [_.trim(_.toLower(this.state.domain))]) }));

    }
  }

  handleDomainDelete(domainToDelete) {
    if (__WEBPACK_IMPORTED_MODULE_3__modules_services_CookieService__["a" /* default */].deleteWhitelistDomain(domainToDelete)) {
      this.setState(prevState => ({
        whitelistedDomains: _.filter(prevState.whitelistedDomains, domain => {return domain != domainToDelete;}) }));

    }
  }

  handleLinkClick() {
    Object(__WEBPACK_IMPORTED_MODULE_4__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_7__constants_AppUrlConstants__["t" /* COOKIE_JAR_DOCS */]);
  }

  handleDomainChange(value) {
    this.setState({ domain: value });
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
            className: 'cookie-management-container-domain-whitelist__back',
            onClick: this.props.onCancel },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'cookie-management-container-domain-whitelist__back__icon' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_base_Icons_LeftArrowIcon__["a" /* default */], {
              style: 'secondary',
              size: 'xs' })),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'cookie-management-container-domain-whitelist__back__text' }, 'Back to cookies')),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'cookies-management-domain-whitelist-container' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'cookies-management-domain-whitelist-container__heading' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('h3', null, 'Whitelist Domains')),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'cookies-management-domain-whitelist-container__meta-text' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Add a domain to the whitelist to allow cookies for that domain to be accessed in scripts. '),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Buttons__["a" /* Button */], {
                className: 'cookies-management-domain-whitelist-container__learn-more',
                type: 'text',
                onClick: this.handleLinkClick }, 'Learn more about accessing cookies in scripts')),




          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'cookies-management-domain-whitelist-container__add-domain' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Inputs__["b" /* Input */], {
              inputStyle: 'box',
              placeholder: 'Add a domain to the whitelist',
              onChange: this.handleDomainChange,
              value: this.state.domain,
              className: 'cookies-management-domain-whitelist-container__input',
              onEnter: this.handleDomainAdd }),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Buttons__["a" /* Button */], {
                type: 'secondary',
                className: 'cookies-management-domain-whitelist-container__add-button',
                onClick: this.handleDomainAdd }, 'Add')),




          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_cookies_CookiesManagementDomainWhitelistList__["a" /* default */], {
            onDelete: this.handleDomainDelete,
            whitelistedDomains: this.state.whitelistedDomains }))));




  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4923:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CookiesManagementDomainWhitelistList; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__CookiesManagementDomainWhitelistListItem__ = __webpack_require__(4924);

let


CookiesManagementDomainWhitelistList = class CookiesManagementDomainWhitelistList extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  render() {
    let whitelistedDomains = this.props.whitelistedDomains;

    if (_.isEmpty(whitelistedDomains)) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'cookies-management-domain-whitelist-list__empty' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'No domains in whitelist')));


    }

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'cookies-management-domain-whitelist-list' },

        _.map(whitelistedDomains, domain => {
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__CookiesManagementDomainWhitelistListItem__["a" /* default */], {
              key: domain,
              domain: domain,
              onDelete: this.props.onDelete }));


        })));



  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4924:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CookiesManagementDomainWhitelistListItem; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Icons_CloseIcon__ = __webpack_require__(90);

let

CookiesManagementDomainWhitelistListItem = class CookiesManagementDomainWhitelistListItem extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.onDelete = this.onDelete.bind(this);
  }

  onDelete() {
    this.props.onDelete && this.props.onDelete(this.props.domain);
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'cookies-management-domain-whitelist-list-item' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'cookies-management-domain-whitelist-list-item__name', title: this.props.domain },
          this.props.domain),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'cookies-management-domain-whitelist-list-item__action' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Icons_CloseIcon__["a" /* default */], {
            className: 'cookies-management-domain-list-item__header__action--delete',
            size: 'xs',
            style: 'tertiary',
            onClick: this.onDelete }))));




  }};

/***/ }),

/***/ 4925:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* unused harmony export default */
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_base_keymaps_KeyMaps__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_proxy_ProxySettingsTabs__ = __webpack_require__(3911);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__components_proxy_ProxySettingsTabContents__ = __webpack_require__(3912);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_proxy_ProxySettingsTabContent__ = __webpack_require__(3913);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__components_proxy_ProxySettingsConnection__ = __webpack_require__(3914);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__components_proxy_ProxySettingsFilters__ = __webpack_require__(3915);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__components_interceptor_InterceptorSettingsTab__ = __webpack_require__(3916);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__stores_get_store__ = __webpack_require__(5);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _class;











const STATUS_CONNECTING = 'connecting';
const STATUS_CONNECTED = 'connected';
const STATUS_DISCONNECTING = 'disconnecting';
const STATUS_DISCONNECTED = 'disconnected';
const DEFAULT_PORT = 5555;

let


ProxySettingsModalContainer = __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default()(_class = class ProxySettingsModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      activeTab: 'Connection',
      connection: {
        port: DEFAULT_PORT,
        selectedTarget: {
          id: 'history',
          name: 'History' },

        filterItems: [],
        status: STATUS_DISCONNECTED },

      filters: {
        url: '',
        url_disabled: '',
        methods: '' } };



    this.openModal = this.toggleOpen.bind(this, true);
    this.closeModal = this.toggleOpen.bind(this, false);
    this.handleTabSelect = this.handleTabSelect.bind(this);

    this.handleFilterChange = this.handleFilterChange.bind(this);
    this.handleFilterSave = this.handleFilterSave.bind(this);

    this.handleTargetSelect = this.handleTargetSelect.bind(this);
    this.handleConnect = this.handleConnect.bind(this);
    this.handlePortChange = this.handlePortChange.bind(this);
    this.handleCancelTargetSelect = this.handleCancelTargetSelect.bind(this);
    this.getFilterItems = this.getFilterItems.bind(this);
    this.handleProxyConnectionAttemptSuccess = this.handleProxyConnectionAttemptSuccess.bind(this);
    this.handleProxyConnectionAttemptFailed = this.handleProxyConnectionAttemptFailed.bind(this);
    this.handleProxyDisConnectionAttemptSuccess = this.handleProxyDisConnectionAttemptSuccess.bind(this);
    this.handleProxyDisConnectionAttemptFailed = this.handleProxyDisConnectionAttemptFailed.bind(this);
  }

  /** Public API's **/

  componentWillMount() {
    this.model = pm.tcpReader;
    this.attachListeners();
  }

  componentWillUnmount() {
    this.detachListeners();
    this.model = null;
  }

  attachListeners() {
    pm.mediator.on('proxyStartSuccess', this.handleProxyConnectionAttemptSuccess, this);
    pm.mediator.on('proxyStartFailure', this.handleProxyConnectionAttemptFailed, this);
    pm.mediator.on('proxyStopSuccess', this.handleProxyDisConnectionAttemptSuccess, this);
    pm.mediator.on('proxyStopFailure', this.handleProxyDisConnectionAttemptFailed, this);

    pm.mediator.on('openProxySettingsModal', this.openModal);
    pm.mediator.on('closeProxySettingsModal', this.closeModal);
  }

  detachListeners() {
    pm.mediator.off('proxyStartSuccess', this.handleProxyConnectionAttemptSuccess);
    pm.mediator.off('proxyStartFailure', this.handleProxyConnectionAttemptFailed);
    pm.mediator.off('proxyStopSuccess', this.handleProxyDisConnectionAttemptSuccess);
    pm.mediator.off('proxyStopFailure', this.handleProxyDisConnectionAttemptFailed);

    pm.mediator.off('openProxySettingsModal', this.openModal);
    pm.mediator.off('closeProxySettingsModal', this.closeModal);
  }

  getCustomStyles() {
    return {
      marginTop: '15vh',
      height: '70vh' };

  }

  getKeyMapHandlers() {
    if (this.state.activeTab === 'Filters') {
      return { 'submit': pm.shortcuts.handle('submit', this.handleFilterSave) };
    }
    return { 'submit': pm.shortcuts.handle('submit', this.handleConnect) };
  }

  toggleOpen(isOpen) {
    this.setState({ isOpen: isOpen || !this.state.isOpen }, () => {
      this.state.isOpen && this.setInitialValues();
    });
  }

  handleTabSelect(id) {
    if (id === this.state.activeTab) {
      return;
    }

    this.setState({ activeTab: id });
  }

  setInitialValues() {
    this.setState(prevState => {
      return {
        filters: this.model.filters,
        connection: _extends({},
        this.state.connection, {
          filterItems: this.getFilterItems(Object(__WEBPACK_IMPORTED_MODULE_11__stores_get_store__["getStore"])('ActiveWorkspaceStore').collections),
          status: this.model.status === 'connected' ? STATUS_CONNECTED : prevState.connection.status,
          port: pm.settings.getSetting('proxyPort') || DEFAULT_PORT }) };


    });
  }

  /** Filter API's **/

  handleFilterSave() {
    let model = this.model;
    model.filters = this.state.filters;
    model.save();
    this.closeModal();
  }

  handleFilterChange(key, value) {
    this.setState({
      filters: _extends({},
      this.state.filters, {
        [key]: value }) });


  }

  /** Connections API's **/

  handleTargetSelect(value) {
    this.setState({
      connection: _extends({},
      this.state.connection, {
        selectedTarget: { id: value.id } }) });


  }

  handleConnect() {
    let model = this.model,
    target = this.state.connection.selectedTarget;

    if (target === null) {
      pm.toasts.error('Select a target to proceed');
      return;
    }

    _.assign(model, {
      target_type: target.id === 'history' ? 'history' : 'collection',
      target_id: target.id === 'history' ? 'history' : target.id,
      port: this.state.connection.port });

    model.save();

    if (this.state.connection.status === STATUS_CONNECTED) {
      model.disconnect();
      this.setState({
        connection: _extends({},
        this.state.connection, {
          status: STATUS_DISCONNECTING }) });


    } else
    if (this.state.connection.status === STATUS_DISCONNECTED) {
      model.connect();
      this.setState({
        connection: _extends({},
        this.state.connection, {
          status: STATUS_CONNECTING }) });


    }
  }

  handlePortChange(value) {
    this.setState({
      connection: _extends({},
      this.state.connection, {
        port: value }) });



    pm.settings.setSetting('proxyPort', value);
  }

  handleCancelTargetSelect() {
    this.setState({
      connection: _extends({},
      this.state.connection, {
        selectedTarget: null }) });


  }

  getFilterItems(collections) {
    let historyObjArray = [{
      meta: {
        id: 'history',
        name: 'History' } }];


    let filterItems = _.chain(collections).
    filter(collection => Object(__WEBPACK_IMPORTED_MODULE_11__stores_get_store__["getStore"])('PermissionStore').can('edit', 'collection', collection.id)).
    map(collection => {
      let collectionItem = {
        meta: {
          type: 'collection',
          id: collection.id,
          name: 'Collection: ' + collection.name } };


      return collectionItem;
    }).
    value();

    return historyObjArray.concat(filterItems);
  }

  handleProxyConnectionAttemptSuccess() {
    this.setState({
      connection: _extends({},
      this.state.connection, {
        status: STATUS_CONNECTED }) });


    pm.toasts.success('Proxy Connected');
    this.closeModal();
  }

  handleProxyConnectionAttemptFailed() {
    pm.toasts.error('Proxy Connection failed');
    this.setState({
      connection: _extends({},
      this.state.connection, {
        status: STATUS_DISCONNECTED }) });


  }

  handleProxyDisConnectionAttemptSuccess() {
    pm.toasts.success('Proxy Disconnected');
    this.setState({
      connection: _extends({},
      this.state.connection, {
        status: STATUS_DISCONNECTED }) });


  }

  handleProxyDisConnectionAttemptFailed() {
    pm.toasts.error('Proxy Disconnection failed');
    this.setState({
      connection: _extends({},
      this.state.connection, {
        status: STATUS_CONNECTED }) });


  }

  render() {
    let status = this.state.connection.status;
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["a" /* Modal */], {
          className: 'proxy-modal',
          customStyles: this.getCustomStyles(),
          isOpen: this.state.isOpen,
          onRequestClose: this.closeModal },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["d" /* ModalHeader */], null, 'CAPTURE'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_keymaps_KeyMaps__["a" /* default */], { keyMap: pm.shortcuts.getShortcuts(), handlers: this.getKeyMapHandlers() },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'settings-container notification-panel-list' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_proxy_ProxySettingsTabs__["a" /* default */], {
                activeTab: this.state.activeTab,
                onSelect: this.handleTabSelect }),

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_proxy_ProxySettingsTabContents__["a" /* default */], {
                  activeKey: this.state.activeTab },

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__components_proxy_ProxySettingsTabContent__["a" /* default */], { key: 'Connection' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__components_proxy_ProxySettingsConnection__["a" /* default */], _extends({},
                  this.state.connection, {
                    onCancelTargetSelect: this.handleCancelTargetSelect,
                    onPortChange: this.handlePortChange,
                    onTargetSelect: this.handleTargetSelect })),

                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_9__components_proxy_ProxySettingsFilters__["a" /* default */], {
                    filters: this.state.filters,
                    onFilterChange: this.handleFilterChange })),


                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__components_proxy_ProxySettingsTabContent__["a" /* default */], { key: 'Cookies' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__components_interceptor_InterceptorSettingsTab__["a" /* default */], null)))))),





        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["c" /* ModalFooter */], null,

          this.state.activeTab === 'Connection' &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,

            _.isEqual(status, STATUS_CONNECTING) &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Buttons__["a" /* Button */], { type: 'primary' }, 'Connecting'),




            _.isEqual(status, STATUS_CONNECTED) &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Buttons__["a" /* Button */], {
                type: 'primary',
                onClick: this.handleConnect }, 'Disconnect'),





            _.isEqual(status, STATUS_DISCONNECTING) &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Buttons__["a" /* Button */], { type: 'primary' }, 'Disconnecting'),




            _.isEqual(status, STATUS_DISCONNECTED) &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Buttons__["a" /* Button */], {
                type: 'primary',
                onClick: this.handleConnect }, 'Connect')),







          this.state.activeTab === 'Filters' &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Buttons__["a" /* Button */], {
              type: 'primary',
              onClick: this.handleFilterSave }, 'Save'))));





  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4926:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SyncConflictModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_sync_SyncConflict__ = __webpack_require__(4927);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_sync_SyncConflictFooter__ = __webpack_require__(4929);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__modules_sync_timeline_helpers_ConflictResolutionsService__ = __webpack_require__(695);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__modules_model_event__ = __webpack_require__(2);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};





let

SyncConflictModalContainer = class SyncConflictModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.state = {
      isOpen: false,
      conflictsInTimeline: {} };


    this.handleValueSelect = this.handleValueSelect.bind(this);
    this.handleAllLocalValueSelected = this.handleAllLocalValueSelected.bind(this);
    this.handleAllServerValueSelected = this.handleAllServerValueSelected.bind(this);
    this.handleResync = this.handleResync.bind(this);
    this.openModal = this.openModal.bind(this);
    this.showConflicts = this.showConflicts.bind(this);
  }

  componentWillMount() {
    this.attachModelListeners();
    this.fetchPendingConflicts();
  }

  componentWillUnmount() {
    this.detachModelListeners();
  }

  fetchPendingConflicts() {
    pm.eventBus.channel('conflict-resolution').publish(Object(__WEBPACK_IMPORTED_MODULE_6__modules_model_event__["a" /* createEvent */])('pushPending', 'conflicts'));
  }

  attachModelListeners() {
    this.unsubscribe = pm.eventBus.channel('conflict-resolution').subscribe(this.showConflicts);
  }

  detachModelListeners() {
    this.unsubscribe && this.unsubscribe();
  }

  showConflicts(event) {
    if (!event || event.namespace !== 'conflicts' || event.name !== 'show') {
      return;
    }

    this.openModal(event.data.conflicts, event.data.timeline);
    __WEBPACK_IMPORTED_MODULE_4__modules_services_AnalyticsService__["a" /* default */].addEvent('sync', 'conflict');
  }

  openModal(conflicts, timeline) {
    this.setState({
      isOpen: true,
      conflictsInTimeline: _extends({},
      this.state.conflictsInTimeline, {
        [`${timeline.model}:${timeline.modelId}`]: { conflicts } }) },

    () => {
      this.computeBulkAction();
    });
  }

  handleClose() {
    this.setState({
      isOpen: false,
      conflictArray: [] },
    () => {
      this.computeBulkAction();
    });
  }

  getCustomStyles() {
    return {
      height: '80vh',
      width: '720px' };

  }

  handleValueSelect(timeline, index, value) {
    let tempConflictArray = _.cloneDeep(this.state.conflictsInTimeline[timeline].conflicts);

    let row = tempConflictArray[index.rowIndex];

    if (Array.isArray(row.value)) {
      row = row.value[index.valueIndex];
    }

    if (value === 'local') {
      row.isLocalSelected = true;
      row.isServerSelected = false;
    } else
    {
      row.isServerSelected = true;
      row.isLocalSelected = false;
    }
    this.setState({
      conflictsInTimeline: _extends({},
      this.state.conflictsInTimeline, {
        [timeline]: _extends({},
        this.state.conflictsInTimeline[timeline], {
          conflicts: tempConflictArray }) }) },


    () => {
      this.computeBulkAction();
    });
  }

  computeBulkAction() {
    let finalState = _.cloneDeep(this.state.conflictsInTimeline);

    _.forEach(finalState, conflictsPerTimeline => {
      if (!conflictsPerTimeline) {
        return;
      }

      conflictsPerTimeline.isAllLocalValueSelected = _.every(conflictsPerTimeline.conflicts, data => {
        if (Array.isArray(data.value)) {
          return _.every(data.value, valueRow => valueRow.isLocalSelected);
        }
        return data.isLocalSelected;
      });

      conflictsPerTimeline.isAllServerValueSelected = _.every(conflictsPerTimeline.conflicts, data => {
        if (Array.isArray(data.value)) {
          return _.every(data.value, valueRow => valueRow.isServerSelected);
        }
        return data.isServerSelected;
      });
    });

    this.setState({
      conflictsInTimeline: finalState });

  }

  handleAllLocalValueSelected(timeline) {
    let tempConflictArray = _.cloneDeep(this.state.conflictsInTimeline[timeline]).conflicts;
    _.forEach(tempConflictArray, data => {
      if (Array.isArray(data.value)) {
        _.forEach(data.value, row => {
          row.isLocalSelected = true;
          row.isServerSelected = false;
        });
      } else
      {
        data.isLocalSelected = true;
        data.isServerSelected = false;
      }
      return data;
    });

    this.setState({
      conflictsInTimeline: _extends({},
      this.state.conflictsInTimeline, {
        [timeline]: {
          isAllLocalValueSelected: true,
          isAllServerValueSelected: false,
          conflicts: tempConflictArray } }) });



  }

  handleAllServerValueSelected(timeline) {
    let tempConflictArray = _.cloneDeep(this.state.conflictsInTimeline[timeline]).conflicts;
    _.forEach(tempConflictArray, data => {
      if (Array.isArray(data.value)) {
        _.forEach(data.value, row => {
          row.isLocalSelected = false;
          row.isServerSelected = true;
        });
      } else
      {
        data.isLocalSelected = false;
        data.isServerSelected = true;
      }
      return data;
    });

    this.setState({
      conflictsInTimeline: _extends({},
      this.state.conflictsInTimeline, {
        [timeline]: {
          isAllLocalValueSelected: false,
          isAllServerValueSelected: true,
          conflicts: tempConflictArray } }) });



  }

  handleResync(timeline) {
    let [model, modelId] = timeline.split(':');

    Object(__WEBPACK_IMPORTED_MODULE_5__modules_sync_timeline_helpers_ConflictResolutionsService__["b" /* submitUserResolution */])(_.get(this.state.conflictsInTimeline, [timeline, 'conflicts']), { model, modelId });

    let currentTimelineRemoved = this.state.conflictsInTimeline,
    isNoMoreConflictsToResolve = false;

    currentTimelineRemoved[timeline] = null;

    isNoMoreConflictsToResolve = _.chain(currentTimelineRemoved).
    values().
    compact().
    isEmpty().
    value();

    if (isNoMoreConflictsToResolve) {
      this.handleClose();
    }

    this.setState(currentTimelineRemoved);
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Modals__["a" /* Modal */], {
          className: 'sync-conflict-modal',
          isOpen: this.state.isOpen,
          customStyles: this.getCustomStyles() },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Modals__["d" /* ModalHeader */], null, 'RESOLVE SYNC CONFLICTS'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Modals__["b" /* ModalContent */], null,
          _.map(this.state.conflictsInTimeline, (timelineConflicts, timeline) => {
            if (!timelineConflicts) {
              return null;
            }

            return (
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { key: timeline },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_sync_SyncConflict__["a" /* default */], {
                  conflictArray: timelineConflicts.conflicts,
                  isAllLocalValueSelected: timelineConflicts.isAllLocalValueSelected,
                  isAllServerValueSelected: timelineConflicts.isAllServerValueSelected,
                  onValueSelect: this.handleValueSelect.bind(this, timeline),
                  onAllLocalValueSelected: () => this.handleAllLocalValueSelected(timeline),
                  onAllServerValueSelected: () => this.handleAllServerValueSelected(timeline),
                  onSubmit: () => this.handleResync(timeline) }),

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_sync_SyncConflictFooter__["a" /* default */], {
                  onResyncClicked: () => this.handleResync(timeline) })));



          }))));



  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4927:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SyncConflict; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_keymaps_KeyMaps__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__constants_SyncConflictsHeaderKeys__ = __webpack_require__(4012);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__constants_SyncConflictsHeaderKeysMap__ = __webpack_require__(4928);







let

SyncConflict = class SyncConflict extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.getUIConflictRows = this.getUIConflictRows.bind(this);
  }

  handleValueSelect(index, isLocalValue, value) {
    this.props.onValueSelect && this.props.onValueSelect(index, isLocalValue, value);
  }

  getKeyMapHandlers() {
    return { 'submit': pm.shortcuts.handle('submit', this.props.onSubmit) };
  }

  getConflictUIRow(conflictRow, index, valueIndex) {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sync-conflict-wrapper', key: index },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sync-conflict-data-value' },
          conflictRow.model),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sync-conflict-data-value' },
          conflictRow.nameOrId),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sync-conflict-data-value' },
          conflictRow.key),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sync-conflict-data-value' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sync-conflict-checkbox-wrapper' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Inputs__["a" /* Checkbox */], {
              checked: conflictRow.isLocalSelected,
              onChange: this.handleValueSelect.bind(this, { rowIndex: index, valueIndex }, 'local'),
              className: 'sync-conflict-checkbox' }),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sync-conflict-value' },
              conflictRow.localText))),



        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sync-conflict-data-value' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sync-conflict-checkbox-wrapper' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Inputs__["a" /* Checkbox */], {
              checked: conflictRow.isServerSelected,
              onChange: this.handleValueSelect.bind(this, { rowIndex: index, valueIndex }, 'server'),
              className: 'sync-conflict-checkbox' }),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sync-conflict-value' },
              conflictRow.serverText)))));





  }

  getUIConflictRows(conflictRows) {
    let conflictUI = conflictRows.
    map((conflictRow, rowIndex) => {
      return this.getConflictUIRow(conflictRow, rowIndex);
    });

    return _.flatten(conflictUI);
  }

  render() {

    let conflictArray = this.props.conflictArray;
    let isAllLocalValueSelected = this.props.isAllLocalValueSelected;
    let isAllServerValueSelected = this.props.isAllServerValueSelected;
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_keymaps_KeyMaps__["a" /* default */], { keyMap: pm.shortcuts.getShortcuts(), handlers: this.getKeyMapHandlers() },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sync-conflict' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sync-conflict-wrapper' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sync-conflict-data-header' }, 'Item Type'),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sync-conflict-data-header' }, 'Item Id / Item Name'),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sync-conflict-data-header' }, 'Property Name'),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sync-conflict-data-header' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sync-conflict-checkbox-wrapper' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Inputs__["a" /* Checkbox */], {
                  checked: isAllLocalValueSelected,
                  onChange: this.props.onAllLocalValueSelected,
                  className: 'sync-conflict-checkbox' }), 'Local Value')),




            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sync-conflict-data-header' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sync-conflict-checkbox-wrapper' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Inputs__["a" /* Checkbox */], {
                  checked: isAllServerValueSelected,
                  onChange: this.props.onAllServerValueSelected,
                  className: 'sync-conflict-checkbox' }), 'Server Value'))),





          this.getUIConflictRows(conflictArray))));



  }};


SyncConflict.defaultProps = { conflictArray: [] };
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4928:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__SyncConflictsHeaderKeys__ = __webpack_require__(4012);


let SYNC_CONFLICT_HEADER_VALUE_MAP = {};

SYNC_CONFLICT_HEADER_VALUE_MAP[__WEBPACK_IMPORTED_MODULE_0__SyncConflictsHeaderKeys__["d" /* SYNC_CONFLICT_HEADER_MODEL */]] = 'Item Type';
SYNC_CONFLICT_HEADER_VALUE_MAP[__WEBPACK_IMPORTED_MODULE_0__SyncConflictsHeaderKeys__["a" /* SYNC_CONFLICT_HEADER_ID */]] = 'Item Id';
SYNC_CONFLICT_HEADER_VALUE_MAP[__WEBPACK_IMPORTED_MODULE_0__SyncConflictsHeaderKeys__["e" /* SYNC_CONFLICT_HEADER_NAME */]] = 'Item Id / Item Name';
SYNC_CONFLICT_HEADER_VALUE_MAP[__WEBPACK_IMPORTED_MODULE_0__SyncConflictsHeaderKeys__["b" /* SYNC_CONFLICT_HEADER_KEY */]] = 'Property Name';
SYNC_CONFLICT_HEADER_VALUE_MAP[__WEBPACK_IMPORTED_MODULE_0__SyncConflictsHeaderKeys__["f" /* SYNC_CONFLICT_HEADER_SERVER_VALUE */]] = 'Server Value';
SYNC_CONFLICT_HEADER_VALUE_MAP[__WEBPACK_IMPORTED_MODULE_0__SyncConflictsHeaderKeys__["c" /* SYNC_CONFLICT_HEADER_LOCAL_VALUE */]] = 'Local Value';


/* unused harmony default export */ var _unused_webpack_default_export = (SYNC_CONFLICT_HEADER_VALUE_MAP);

/***/ }),

/***/ 4929:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SyncConflictFooter; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Buttons__ = __webpack_require__(13);

let

SyncConflictFooter = class SyncConflictFooter extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.handleResync = this.handleResync.bind(this);
  }

  handleResync() {
    this.props.onResyncClicked && this.props.onResyncClicked();
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sync-conflict-footer-wrapper' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
            type: 'primary',
            onClick: this.handleResync }, 'Resync')));





  }};

/***/ }),

/***/ 4930:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SyncIssueModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__utils_util__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__utils_SyncIssueHelper__ = __webpack_require__(1554);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_sync_SyncIssue__ = __webpack_require__(4931);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__external_navigation_ExternalNavigationService__ = __webpack_require__(59);
var _class;









const COLLECTION_ENTITIES = ['collection', 'folder', 'request', 'response'];let


SyncIssueModalContainer = Object(__WEBPACK_IMPORTED_MODULE_7_mobx_react__["a" /* observer */])(_class = class SyncIssueModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.state = {
      isOpen: false,
      errorLog: '',
      changeSet: '' };

    this.openModal = this.openModal.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleResyncNow = this.handleResyncNow.bind(this);
    this.handleDiscardChange = this.handleDiscardChange.bind(this);
    this.handleErrorReporting = this.handleErrorReporting.bind(this);
  }

  componentWillMount() {
    this.attachModelListeners();
  }

  componentWillUnmount() {
    this.detachModelListeners();
  }

  attachModelListeners() {
    pm.mediator.on('showSyncIssue', this.openModal);
  }

  detachModelListeners() {
    pm.mediator.off('showSyncIssue', this.openModal);
  }

  openModal(changeSet) {
    this.setState({
      errorLog: this.constructErrorLog(changeSet),
      isOpen: true,
      changeSet: changeSet });

  }

  handleResyncNow() {
    let changeSet = this.state.changeSet,
    { entity, data, res } = changeSet,
    analyticsLog = __WEBPACK_IMPORTED_MODULE_2__utils_SyncIssueHelper__["a" /* default */].constructLogToAnalytics(changeSet);
    if (entity && data) {
      if (_.includes(COLLECTION_ENTITIES, entity)) {
        let id = entity === 'collection' ? data.id : data.collection;
        pm.syncManager.forceSyncCollectionAndContinue(id);
        __WEBPACK_IMPORTED_MODULE_3__modules_services_AnalyticsService__["a" /* default */].addEvent('sync', 'force_collection', 'issue', null, analyticsLog);
      } else
      {
        pm.syncManager.forceSync() && __WEBPACK_IMPORTED_MODULE_3__modules_services_AnalyticsService__["a" /* default */].addEvent('sync', 'force', 'issue', null, analyticsLog);
      }
    }

    // Don't want anything to block the UI, so closing it without any restrictions
    this.handleClose();
  }

  handleDiscardChange() {
    // @todo numaan drop changeset and resume
    __WEBPACK_IMPORTED_MODULE_3__modules_services_AnalyticsService__["a" /* default */].addEvent('sync', 'discard_changeset', 'issue', null, __WEBPACK_IMPORTED_MODULE_2__utils_SyncIssueHelper__["a" /* default */].constructLogToAnalytics(this.state.changeSet));

    // Don't want anything to block the UI, so closing it without any restrictions
    this.handleClose();
  }

  handleErrorReporting() {
    let changeSet = this.state.changeSet,
    link = this.constructMailBody(changeSet);
    try {
      link = encodeURI(link);
    }
    catch (e) {
      pm.logger.error(e);
    } finally
    {
      Object(__WEBPACK_IMPORTED_MODULE_8__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(link);
      __WEBPACK_IMPORTED_MODULE_3__modules_services_AnalyticsService__["a" /* default */].addEvent('sync', 'report_issue', 'issue', null, __WEBPACK_IMPORTED_MODULE_2__utils_SyncIssueHelper__["a" /* default */].constructLogToAnalytics(changeSet));
    }
  }

  handleClose() {
    this.setState({
      isOpen: false,
      errorLog: '',
      changeSet: '' });

  }

  constructMailBody(changeSet) {
    let link = 'mailto:help@getpostman.com?Subject=Error Syncing data&body=',
    messageBody = [
    this.getAppBasicInfoTemplateString(),
    'Entity: ' + changeSet.entity,
    'Action: ' + changeSet.verb,
    'Request Size: ' + changeSet.dataSize];

    if (changeSet.res && changeSet.res.error) {
      messageBody.push('Error: ' + __WEBPACK_IMPORTED_MODULE_1__utils_util__["a" /* default */].beautifyJs(changeSet.res.error));
    } else
    {
      messageBody.push('Error: ' + __WEBPACK_IMPORTED_MODULE_1__utils_util__["a" /* default */].beautifyJs({ name: 'Timeout' }));
    }
    return link + messageBody.join('\n');
  }

  constructErrorLog(changeSet) {
    let log = [
    'Entity: ' + changeSet.entity,
    'Action: ' + changeSet.verb,
    'Request Size: ' + changeSet.dataSize];

    if (changeSet.res && changeSet.res.error) {
      log.push('Error: ' + __WEBPACK_IMPORTED_MODULE_1__utils_util__["a" /* default */].beautifyJs(changeSet.res.error));
    } else
    {
      log.push('Error: timeout');
    }
    return log.join('\n');
  }

  /**
      Having this here now, will move to util if they need in more places
    */
  getAppBasicInfoTemplateString() {
    let currentUser = Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('CurrentUserStore');


    let appInfo = pm.app.get('info'),
    info = [
    'App ID: ' + pm.app.get('installationId'),
    'Version: ' + appInfo.version,
    'User ID: ' + currentUser.id,
    'App Type: Electron',
    'OS: ' + appInfo.os,
    'Architecture: ' + appInfo.architecture];

    return info.join('\n');
  }

  getCustomStyles() {
    return {
      height: '515px',
      width: '480px' };

  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_Modals__["a" /* Modal */], {
          isOpen: this.state.isOpen,
          customStyles: this.getCustomStyles() },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_Modals__["d" /* ModalHeader */], null, 'SYNC ISSUES'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_sync_SyncIssue__["a" /* default */], {
            errorLog: this.state.errorLog,
            onDiscardChange: this.handleDiscardChange,
            onErrorReporting: this.handleErrorReporting,
            onResyncNow: this.handleResyncNow }))));




  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4931:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SyncIssue; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_TextArea__ = __webpack_require__(962);


let

SyncIssue = class SyncIssue extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sync-issue' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sync-issue-container' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sync-issue-content-left' }, 'Your updates couldn\u2019t be synced with Postman\u2019s servers. Please wait a few minutes and try again.'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sync-issue-content-right' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                type: 'primary',
                className: 'sync-issue-button',
                onClick: this.props.onResyncNow }, 'Resync Now'))),






        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sync-issue-detailed-log-container' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sync-issue-detailed-log-head-text' }, ' Detailed log:'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_TextArea__["a" /* default */], {
            className: 'sync-issue-detailed-log',
            value: this.props.errorLog,
            ref: textarea => {return this.props.isVisible && textarea && textarea.focus();},
            readOnly: true })),



        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sync-issue-container' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sync-issue-content-left' }, 'Sync issues aren\u2019t common; please alert our support team.'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sync-issue-content-right' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                type: 'secondary',
                className: 'sync-issue-button',
                onClick: this.props.onErrorReporting }, 'Report Issue'))),






        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sync-issue-container' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sync-issue-content-left' }, 'Discarding will restore your sync, but the changes mentioned above will be lost.'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sync-issue-content-right' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                type: 'secondary',
                className: 'sync-issue-button',
                onClick: this.props.onDiscardChange }, 'Discard Failed Updates')))));








  }};

/***/ }),

/***/ 4932:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return RequesterTabCloseUnsavedModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_mobx__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_base_keymaps_KeyMaps__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__ = __webpack_require__(4933);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__constants_SettingsGeneralConstants__ = __webpack_require__(1507);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__services_EditorService__ = __webpack_require__(66);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__modules_model_event__ = __webpack_require__(2);
var _class, _desc, _value, _class2;function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {var desc = {};Object['ke' + 'ys'](descriptor).forEach(function (key) {desc[key] = descriptor[key];});desc.enumerable = !!desc.enumerable;desc.configurable = !!desc.configurable;if ('value' in desc || desc.initializer) {desc.writable = true;}desc = decorators.slice().reverse().reduce(function (desc, decorator) {return decorator(target, property, desc) || desc;}, desc);if (context && desc.initializer !== void 0) {desc.value = desc.initializer ? desc.initializer.call(context) : void 0;desc.initializer = undefined;}if (desc.initializer === void 0) {Object['define' + 'Property'](target, property, desc);desc = null;}return desc;}
















const TAB_NAME_LENGTH = 40;

/**
                             * This Modal is used for both save cases as well as closing cases.
                             *
                             * Closing a resource actions in order
                             *  1. Dirty with no conflict:
                             *      This tab TAB_NAME has unsaved changes which will be lost if you choose to close it. Save these changes to avoid losing your work.
                             *
                             *      Don't save - Cancel - Save changes
                             *
                             *  2. Dirty with Update conflict:
                             *      This tab TAB_NAME has unsaved changes which will be lost if you choose to close it. This MODEL_NAME has been modified from another tab.
                             *      Saving these changes will overwrite the MODEL_NAME.
                             *
                             *      Discard changes in a Tab - Save and overwrite - Save as a new MODEL_NAME
                             *
                             *  3. Dirty with Delete conflict:
                             *      This tab TAB_NAME has unsaved changes which will be lost if you choose to close it. Save these changes to avoid losing your work.
                             *
                             *      Don't save - Cancel - Save
                             *
                             * Saving a resource actions
                             *  1. Update conflict:
                             *     This tab TAB_NAME has unsaved changes which will be lost if you choose to close it. This MODEL_NAME has been modified from another tab.
                             *     Saving these changes will overwrite the MODEL_NAME.
                             *
                             *     Cancel - Save and overwrite - Save as a new MODEL_NAME
                             *
                             */let


RequesterTabCloseUnsavedModalContainer = Object(__WEBPACK_IMPORTED_MODULE_2_mobx_react__["a" /* observer */])(_class = (_class2 = class RequesterTabCloseUnsavedModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {

  get currentClosingEditorId() {
    return Object(__WEBPACK_IMPORTED_MODULE_10__stores_get_store__["getStore"])('TabUIStore').closingTabId;
  }


  get requestingSaveTabId() {
    return Object(__WEBPACK_IMPORTED_MODULE_10__stores_get_store__["getStore"])('TabUIStore').requestingSaveTabId;
  }


  get requestConfirmationFor() {
    return this.requestingSaveTabId || this.currentClosingEditorId;
  }



  get editorModelForConfirmation() {
    let editor = Object(__WEBPACK_IMPORTED_MODULE_10__stores_get_store__["getStore"])('EditorStore').find(this.requestConfirmationFor);

    return editor && editor.model;
  }


  get isClosing() {
    return this.requestConfirmationFor === this.currentClosingEditorId;
  }


  get allowDiscard() {
    // allow discard only if we are closing the tab
    return this.isClosing;
  }


  get isConflicted() {
    return this.editorModelForConfirmation && this.editorModelForConfirmation.isConflicted;
  }


  get allowSaveAs() {
    return this.isConflicted;
  }


  get tabOrder() {
    let editorModel = this.editorModelForConfirmation,
    conflictType = editorModel && editorModel.conflictState && editorModel.conflictState.type,
    tabOrder = [];

    if (conflictType === 'updated') {
      // as it is conflicted then we need to check whether this is a save operation
      // or a closing operation, save has 'Cancel' and close has 'Discard'
      if (this.isClosing) {
        tabOrder = [__WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__["b" /* MODAL_BUTTON_DISCARD */], __WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__["c" /* MODAL_BUTTON_SAVE */], __WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__["d" /* MODAL_BUTTON_SAVE_AS */]];
      } else {
        tabOrder = [__WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__["a" /* MODAL_BUTTON_CANCEL */], __WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__["c" /* MODAL_BUTTON_SAVE */], __WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__["d" /* MODAL_BUTTON_SAVE_AS */]];
      }
    } else if (conflictType === 'deleted') {
      tabOrder = [__WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__["b" /* MODAL_BUTTON_DISCARD */], __WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__["a" /* MODAL_BUTTON_CANCEL */], __WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__["d" /* MODAL_BUTTON_SAVE_AS */]];
    } else {
      tabOrder = [__WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__["b" /* MODAL_BUTTON_DISCARD */], __WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__["a" /* MODAL_BUTTON_CANCEL */], __WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__["c" /* MODAL_BUTTON_SAVE */]];
    }

    return tabOrder;
  }

  constructor(props) {
    super(props);

    this.state = { focusedButton: __WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__["c" /* MODAL_BUTTON_SAVE */] };

    this.handleCancel = this.handleUserAction.bind(this, __WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__["a" /* MODAL_BUTTON_CANCEL */]);
    this.handleSave = this.handleUserAction.bind(this, __WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__["c" /* MODAL_BUTTON_SAVE */]);
    this.handleSaveAs = this.handleUserAction.bind(this, __WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__["d" /* MODAL_BUTTON_SAVE_AS */]);
    this.handleDiscard = this.handleUserAction.bind(this, __WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__["b" /* MODAL_BUTTON_DISCARD */]);
    this.handleSwitchFocus = this.handleSwitchFocus.bind(this);
    this.handleFocusClick = this.handleFocusClick.bind(this);
    this.getCustomStyles = this.getCustomStyles.bind(this);
    this.getKeyMapHandlers = this.getKeyMapHandlers.bind(this);
    this.getModalContentsForSave = this.getModalContentsForSave.bind(this);
    this.getModalContentsForClose = this.getModalContentsForClose.bind(this);
    this.getUnsavedModalFooter = this.getUnsavedModalFooter.bind(this);
    this.getConflictedModalFooterForDeleted = this.getConflictedModalFooterForDeleted.bind(this);
    this.getConflictedModalFooterForUpdated = this.getConflictedModalFooterForUpdated.bind(this);
    this.updateShowConfirmationModalSetting = this.updateShowConfirmationModalSetting.bind(this);
    this.toggleShowConfirmationModalSetting = this.toggleShowConfirmationModalSetting.bind(this);

    // componentDidUpdate will get called before ref get attached to any children of the modal
    // so ideally we need to wait for the whole event loop for re rendering to finish, attaching the ref
    // to it and then calling focus on ref
    // if directly called inside the set state callback the ref remains undefined
    // https://github.com/reactjs/react-modal/issues/338
    Object(__WEBPACK_IMPORTED_MODULE_1_mobx__["q" /* reaction */])(() => this.requestConfirmationFor, () => {
      this.setState({
        focusedButton: __WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__["c" /* MODAL_BUTTON_SAVE */],
        currentSkipConfirmationModalSetting: false },
      () => {
        requestIdleCallback(() => {
          this.keyMapsRef && this.keyMapsRef.focus();
        });
      });
    });
  }

  handleUserAction(action) {
    return Promise.resolve().
    then(() => {
      return this.updateShowConfirmationModalSetting(action);
    }).
    then(() => {
      switch (action) {
        case __WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__["b" /* MODAL_BUTTON_DISCARD */]:
          this.handleDiscardAction();
          break;
        case __WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__["a" /* MODAL_BUTTON_CANCEL */]:
          this.handleCancelAction();
          break;
        case __WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__["c" /* MODAL_BUTTON_SAVE */]:
          this.handleSaveAction();
          break;
        case __WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__["d" /* MODAL_BUTTON_SAVE_AS */]:
          this.handleSaveAsAction();
          break;
        default:
          return;}

    });
  }

  handleCancelAction() {
    // (Cancel Button)

    // if this modal shows up for cancel, terminate pending cancel
    if (this.isClosing) {
      __WEBPACK_IMPORTED_MODULE_11__services_EditorService__["a" /* default */].cancelClose();
    }

    // else this modal is open because there is a pending save, so cancel that
    else {
        __WEBPACK_IMPORTED_MODULE_11__services_EditorService__["a" /* default */].cancelSave();
      }
  }

  handleSaveAction() {
    let confirmationTabId = this.requestConfirmationFor;

    return __WEBPACK_IMPORTED_MODULE_11__services_EditorService__["a" /* default */].save({ id: confirmationTabId }, { closeOnSave: this.isClosing });
  }

  handleSaveAsAction() {
    let confirmationTabId = this.requestConfirmationFor;

    return __WEBPACK_IMPORTED_MODULE_11__services_EditorService__["a" /* default */].saveAs({ id: confirmationTabId }, { closeOnSave: this.isClosing });
  }

  handleDiscardAction() {
    let currentClosingEditorId = this.currentClosingEditorId;

    return __WEBPACK_IMPORTED_MODULE_11__services_EditorService__["a" /* default */].close({ id: currentClosingEditorId }, { force: true });
  }

  handleSwitchFocus(e) {
    e.stopPropagation();
    e.preventDefault();

    let currentFocus = _.findIndex(this.tabOrder, tab => {
      return tab === this.state.focusedButton;
    }),
    nextFocus;

    nextFocus = this.tabOrder[(currentFocus + 1) % this.tabOrder.length];
    this.setState({ focusedButton: nextFocus });
  }

  getCustomStyles() {
    return { marginTop: '35vh' };
  }

  toggleShowConfirmationModalSetting() {
    this.setState({ currentSkipConfirmationModalSetting: !this.state.currentSkipConfirmationModalSetting });
  }

  updateShowConfirmationModalSetting(action) {
    // early bail out if action is cancel, or if the setting has not been changed
    // assuming this modal will only open when skipConfirmationModal setting is false, hence updating only when it becomes true.
    if (action === __WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__["a" /* MODAL_BUTTON_CANCEL */] || !this.state.currentSkipConfirmationModalSetting) {
      return Promise.resolve();
    }

    // update the setting
    return Object(__WEBPACK_IMPORTED_MODULE_12__modules_pipelines_user_action__["a" /* default */])(Object(__WEBPACK_IMPORTED_MODULE_13__modules_model_event__["a" /* createEvent */])('update', 'userconfigs', { [`${__WEBPACK_IMPORTED_MODULE_9__constants_SettingsGeneralConstants__["c" /* CATEGORY_EDITOR */]}.${__WEBPACK_IMPORTED_MODULE_9__constants_SettingsGeneralConstants__["q" /* SKIP_CONFIRMATION_BEFORE_CLOSE */]}`]: this.state.currentSkipConfirmationModalSetting })).
    catch(() => {
      pm.toasts.error('Something went wrong while saving your preference');
    });
  }

  getKeyMapHandlers() {
    return {
      quit: pm.shortcuts.handle('quit', this.props.handleCancel), // cancel closing tab
      select: pm.shortcuts.handle('select', this.handleFocusClick), // save and close
      submit: pm.shortcuts.handle('submit', this.handleFocusClick), // save and close
      space: pm.shortcuts.handle('space', this.handleFocusClick), // select whichever is highlighted
      focusNext: pm.shortcuts.handle('focusNext', this.handleSwitchFocus) // focus next item
    };
  }

  handleFocusClick() {
    this.handleUserAction(this.state.focusedButton);
  }

  // used to populate the modal body for close
  getModalContentsForClose(name, modelType, conflictType) {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, 'This tab',
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'tab-unsaved-confirmation-modal_body-title' }, ' ', _.truncate(name, { length: TAB_NAME_LENGTH }), ' '), 'has unsaved changes which will be lost if you choose to close it.',

        conflictType === 'updated' ?
        ` This ${modelType} has been modified from another tab. Saving these changes will overwrite the ${modelType}.` :
        ' Save these changes to avoid losing your work.'));



  }

  // used to populate the modal body for save actions
  getModalContentsForSave(name, modelType, conflictType) {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, 'This tab',
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'tab-unsaved-confirmation-modal_body-title' }, ' ', _.truncate(name, { length: TAB_NAME_LENGTH }), ' '),
        conflictType === 'updated' &&
        `has been modified from another tab. Saving these changes will overwrite the ${modelType}.`));



  }

  // used to populated the footer where the modal is in conflicted state
  // handles both cases whether the editor is being closed or is being saved
  getConflictedModalFooterForUpdated(isClosing, modelType) {
    let secondaryButtonText = 'Discard changes in this tab',
    onClickHandlerForSecondaryButton = this.handleDiscard,
    buttonConstant = __WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__["b" /* MODAL_BUTTON_DISCARD */];

    // if it is not closing, then it comes here because of the save action
    // hence buttonText, and handler need to be changed accordingly
    if (!isClosing) {
      secondaryButtonText = 'Cancel';
      onClickHandlerForSecondaryButton = this.handleCancel;
      buttonConstant = __WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__["a" /* MODAL_BUTTON_CANCEL */];
    }

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'tab-unsaved-confirmation-modal__footer-wrapper conflict' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'tab-unsaved-confirmation-modal__footer-actions' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'tab-unsaved-confirmation-modal__footer__left' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_Buttons__["a" /* Button */], {
                className: isClosing && 'large',
                type: 'secondary',
                onClick: onClickHandlerForSecondaryButton,
                focused: this.state.focusedButton === buttonConstant },

              secondaryButtonText)),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'tab-unsaved-confirmation-modal__footer__right' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_Buttons__["a" /* Button */], {
                className: 'large',
                type: 'primary',
                onClick: this.handleSave,
                focused: this.state.focusedButton === __WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__["c" /* MODAL_BUTTON_SAVE */] }, 'Save and overwrite'))),





        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'tab-unsaved-confirmation-modal__footer-additional-actions' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_Buttons__["a" /* Button */], {
              className: 'large',
              type: 'text',
              onClick: this.handleSaveAs,
              focused: this.state.focusedButton === __WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__["d" /* MODAL_BUTTON_SAVE_AS */] },

            `Save as a new ${modelType}`))));





  }

  // this is used to get the footer actions for the case where the resource is deleted
  // the footer remains same whether we are closing it or saving it
  getConflictedModalFooterForDeleted() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'tab-unsaved-confirmation-modal__footer-wrapper' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'tab-unsaved-confirmation-modal__footer-actions' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'tab-unsaved-confirmation-modal__footer__left' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_Buttons__["a" /* Button */], {
                type: 'secondary',
                onClick: this.handleDiscard,
                focused: this.state.focusedButton === __WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__["b" /* MODAL_BUTTON_DISCARD */] }, 'Don\'t save')),




          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'tab-unsaved-confirmation-modal__footer__right' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_Buttons__["a" /* Button */], {
                type: 'primary',
                onClick: this.handleSaveAs,
                focused: this.state.focusedButton === __WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__["d" /* MODAL_BUTTON_SAVE_AS */] }, 'Save'),



            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_Buttons__["a" /* Button */], {
                type: 'secondary',
                onClick: this.handleCancel,
                focused: this.state.focusedButton === __WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__["a" /* MODAL_BUTTON_CANCEL */] }, 'Cancel')))));







  }

  // this is the modal footer which is used in cases where the tab is not in a conflicted state
  // i.e. neither deleted nor conflicted
  getUnsavedModalFooter() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'tab-unsaved-confirmation-modal__footer-wrapper' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'tab-unsaved-confirmation-modal__footer-actions' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'tab-unsaved-confirmation-modal__footer__left' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_Buttons__["a" /* Button */], {
                type: 'secondary',
                onClick: this.handleDiscard,
                focused: this.state.focusedButton === __WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__["b" /* MODAL_BUTTON_DISCARD */] }, 'Don\'t save')),




          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'tab-unsaved-confirmation-modal__footer__right' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_Buttons__["a" /* Button */], {
                type: 'primary',
                onClick: this.handleSave,
                focused: this.state.focusedButton === __WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__["c" /* MODAL_BUTTON_SAVE */] }, 'Save changes'),



            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_Buttons__["a" /* Button */], {
                type: 'secondary',
                onClick: this.handleCancel,
                focused: this.state.focusedButton === __WEBPACK_IMPORTED_MODULE_8__constants_ModalButtonsConstants__["a" /* MODAL_BUTTON_CANCEL */] }, 'Cancel')))));







  }

  getConfirmationModalToggleSettingContent() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'tab-unsaved-confirmation-modal--open-modal-confirmation-container' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'tab-unsaved-confirmation-modal--confirmation-setting' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'confirmation-checkbox' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_Inputs__["a" /* Checkbox */], {
              checked: this.state.currentSkipConfirmationModalSetting,
              onChange: this.toggleShowConfirmationModalSetting }),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'confirmation-text' }, 'Do not ask me again'))),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'confirmation-helper-text' }, 'You can change this anytime from your Settings')));




  }

  getModalFooterClasses(isConflicted) {
    return __WEBPACK_IMPORTED_MODULE_3_classnames___default()({ 'tab-unsaved-confirmation-modal__footer': true, 'conflict': isConflicted });
  }

  render() {
    let confirmationTabId = this.requestConfirmationFor,
    isOpen = Boolean(confirmationTabId);

    if (!isOpen) {
      return false;
    }


    let editor = Object(__WEBPACK_IMPORTED_MODULE_10__stores_get_store__["getStore"])('EditorStore').find(confirmationTabId),
    editorModel = editor && editor.model;

    if (!editorModel) {
      return false;
    }

    let name = editorModel && editorModel.name || '',
    modelType = editorModel && editorModel.userFriendlyResourceName,
    closingEditorsCount = Object(__WEBPACK_IMPORTED_MODULE_10__stores_get_store__["getStore"])('EditorStore').closingEditorsCount,
    showConfirmationModal = closingEditorsCount === 1 && this.isClosing,
    conflictType = '';

    if (this.isConflicted) {
      conflictType = editorModel.conflictState && editorModel.conflictState.type;
    }

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_base_Modals__["a" /* Modal */], {
          isOpen: isOpen,
          onRequestClose: this.handleCancel,
          className: 'tab-unsaved-confirmation-modal',
          customStyles: this.getCustomStyles() },


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_base_Modals__["d" /* ModalHeader */], null, 'DO YOU WANT TO SAVE?'),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_base_Modals__["b" /* ModalContent */], null,
          this.isClosing ? this.getModalContentsForClose(name, modelType, conflictType) : this.getModalContentsForSave(name, modelType, conflictType),


          showConfirmationModal && this.getConfirmationModalToggleSettingContent()),



        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_base_Modals__["c" /* ModalFooter */], { className: this.getModalFooterClasses(this.isConflicted) },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__components_base_keymaps_KeyMaps__["a" /* default */], { keyMap: pm.shortcuts.getShortcuts(), handlers: this.getKeyMapHandlers(), ref: component => this.keyMapsRef = component },

            this.isConflicted ?
            conflictType === 'updated' ? this.getConflictedModalFooterForUpdated(this.isClosing, modelType) : this.getConflictedModalFooterForDeleted() :
            this.getUnsavedModalFooter()))));






  }}, (_applyDecoratedDescriptor(_class2.prototype, 'currentClosingEditorId', [__WEBPACK_IMPORTED_MODULE_1_mobx__["f" /* computed */]], Object.getOwnPropertyDescriptor(_class2.prototype, 'currentClosingEditorId'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'requestingSaveTabId', [__WEBPACK_IMPORTED_MODULE_1_mobx__["f" /* computed */]], Object.getOwnPropertyDescriptor(_class2.prototype, 'requestingSaveTabId'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'requestConfirmationFor', [__WEBPACK_IMPORTED_MODULE_1_mobx__["f" /* computed */]], Object.getOwnPropertyDescriptor(_class2.prototype, 'requestConfirmationFor'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'editorModelForConfirmation', [__WEBPACK_IMPORTED_MODULE_1_mobx__["f" /* computed */]], Object.getOwnPropertyDescriptor(_class2.prototype, 'editorModelForConfirmation'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'isClosing', [__WEBPACK_IMPORTED_MODULE_1_mobx__["f" /* computed */]], Object.getOwnPropertyDescriptor(_class2.prototype, 'isClosing'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'allowDiscard', [__WEBPACK_IMPORTED_MODULE_1_mobx__["f" /* computed */]], Object.getOwnPropertyDescriptor(_class2.prototype, 'allowDiscard'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'isConflicted', [__WEBPACK_IMPORTED_MODULE_1_mobx__["f" /* computed */]], Object.getOwnPropertyDescriptor(_class2.prototype, 'isConflicted'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'allowSaveAs', [__WEBPACK_IMPORTED_MODULE_1_mobx__["f" /* computed */]], Object.getOwnPropertyDescriptor(_class2.prototype, 'allowSaveAs'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'tabOrder', [__WEBPACK_IMPORTED_MODULE_1_mobx__["f" /* computed */]], Object.getOwnPropertyDescriptor(_class2.prototype, 'tabOrder'), _class2.prototype)), _class2)) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4933:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
const MODAL_BUTTON_SAVE = 'save';
/* harmony export (immutable) */ __webpack_exports__["c"] = MODAL_BUTTON_SAVE;

const MODAL_BUTTON_SAVE_AS = 'saveAs';
/* harmony export (immutable) */ __webpack_exports__["d"] = MODAL_BUTTON_SAVE_AS;

const MODAL_BUTTON_DISCARD = 'discard';
/* harmony export (immutable) */ __webpack_exports__["b"] = MODAL_BUTTON_DISCARD;

const MODAL_BUTTON_CANCEL = 'cancel';
/* harmony export (immutable) */ __webpack_exports__["a"] = MODAL_BUTTON_CANCEL;


/***/ }),

/***/ 4934:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return UpdateModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_update_UpdateCheckingModal__ = __webpack_require__(4935);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_update_UpdateAvailableModal__ = __webpack_require__(4936);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_update_UpdateNotAvailableModal__ = __webpack_require__(4937);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_update_UpdateDownloadingModal__ = __webpack_require__(4938);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__components_update_UpdateApplyModal__ = __webpack_require__(4939);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_update_UpdateErrorModal__ = __webpack_require__(4940);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__utils_util__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__constants_AppUrlConstants__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__external_navigation_ExternalNavigationService__ = __webpack_require__(59);
var _class;











const ALLOWED_ORIGINS = ['settings_indicator', 'auto', 'manual', 'broadcast'];let


UpdateModalContainer = __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default()(_class = class UpdateModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      updateStatus: null,
      currentVersion: pm.app.get('version'),
      updateData: null,
      changelog: null,
      origin: null };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleDownloadClose = this.handleDownloadClose.bind(this);
    this.handleCheckForUpdate = this.handleCheckForUpdate.bind(this);
    this.handleDownloadUpdate = this.handleDownloadUpdate.bind(this);
    this.handleRestart = this.handleRestart.bind(this);
    this.handleStatusChange = this.handleStatusChange.bind(this);
    this.handleChangelogChange = this.handleChangelogChange.bind(this);
    this.handleManualDownload = this.handleManualDownload.bind(this);
  }

  componentWillMount() {
    this.model = pm.updateNotifier;
    this.attachModelListeners();
    this.handleStatusChange();
    this.handleChangelogChange();
  }

  componentWillUnmount() {
    this.detachModelListeners();
    this.model = null;
  }

  attachModelListeners() {
    pm.mediator.on('showUpdateModal', this.handleOpen);
    pm.mediator.on('hideUpdateModal', this.handleClose);
    this.model.on('change:status', this.handleStatusChange);
    this.model.on('change:changelog', this.handleChangelogChange);
  }

  detachModelListeners() {
    pm.mediator.off('showUpdateModal', this.handleOpen);
    pm.mediator.off('hideUpdateModal', this.handleClose);
    this.model.off('change:status', this.handleStatusChange);
    this.model.off('change:changelog', this.handleChangelogChange);
  }

  handleStatusChange() {
    this.setState({
      updateStatus: this.model.get('status'),
      updateData: this.model.get('data') });


    if (this.model.get('status') === 'error' && this.state.isOpen) {
      let label = this.model.get('isAutoDownloaded') ? 'auto_update' : 'manual_update';
      __WEBPACK_IMPORTED_MODULE_10__modules_services_AnalyticsService__["a" /* default */].addEvent('app', 'open_error_modal', label);
    }
  }

  handleChangelogChange() {
    this.setState({ changelog: this.model.get('changelog') });
  }

  handleOpen(options = {}) {
    let origin = _.includes(ALLOWED_ORIGINS, options.origin) ? options.origin : null;

    this.setState({
      origin,
      isOpen: true });


    let status = this.model.get('status');

    if (status === 'error') {
      let label = this.model.get('isAutoDownloaded') ? 'auto_update' : 'manual_update';
      __WEBPACK_IMPORTED_MODULE_10__modules_services_AnalyticsService__["a" /* default */].addEvent('app', 'open_error_modal', label);
    }
  }

  handleClose() {
    let origin = this.state.origin;

    if (origin && _.includes(ALLOWED_ORIGINS, origin)) {
      __WEBPACK_IMPORTED_MODULE_10__modules_services_AnalyticsService__["a" /* default */].addEvent('app', 'dismiss_update_available_modal', origin);
      origin = null;
    }
    this.setState({
      origin,
      isOpen: false });

  }

  handleCheckForUpdate() {
    this.model.checkForUpdates(true);
    __WEBPACK_IMPORTED_MODULE_10__modules_services_AnalyticsService__["a" /* default */].addEvent('app', 'retry_update_download', 'update_modal');
  }

  handleManualDownload() {
    Object(__WEBPACK_IMPORTED_MODULE_11__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_9__constants_AppUrlConstants__["V" /* NATIVE_APPS_URL */]);
    __WEBPACK_IMPORTED_MODULE_10__modules_services_AnalyticsService__["a" /* default */].addEvent('app', 'manual_update_download');
    this.handleClose();
  }

  handleDownloadUpdate() {
    this.model.downloadUpdate();
    __WEBPACK_IMPORTED_MODULE_10__modules_services_AnalyticsService__["a" /* default */].addEvent('app', 'initiate_update_download', 'update_modal');
  }

  handleRestart() {
    this.model.applyUpdate();
    __WEBPACK_IMPORTED_MODULE_10__modules_services_AnalyticsService__["a" /* default */].addEvent('app', 'app_restart', 'update_modal');
  }

  handleDownloadClose() {
    pm.toasts.info('Download will continue in the background');
    this.handleClose();
  }

  render() {


    switch (this.state.updateStatus) {
      case 'checking':{
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_update_UpdateCheckingModal__["a" /* default */], {
              isOpen: this.state.isOpen,
              onRequestClose: this.handleClose }));


        }
      case 'updateAvailable':{
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_update_UpdateAvailableModal__["a" /* default */], {
              changelog: this.state.changelog ? this.state.changelog : null,
              isOpen: this.state.isOpen,
              updateNotes: this.state.updateData ? this.state.updateData.notes : null,
              updateVersion: this.state.updateData ? this.state.updateData.version : null,
              onDownloadUpdate: this.handleDownloadUpdate,
              onRequestClose: this.handleClose }));


        }
      case 'updateNotAvailable':{
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_update_UpdateNotAvailableModal__["a" /* default */], {
              currentVersion: this.state.currentVersion,
              isOpen: this.state.isOpen,
              onRequestClose: this.handleClose }));


        }
      case 'downloading':{
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_update_UpdateDownloadingModal__["a" /* default */], {
              isOpen: this.state.isOpen,
              onCancel: this.handleClose,
              onRequestClose: this.handleDownloadClose }));


        }
      case 'downloaded':{
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_update_UpdateApplyModal__["a" /* default */], {
              isOpen: this.state.isOpen,
              onApplyUpdate: this.handleRestart,
              onRequestClose: this.handleClose }));


        }
      case 'error':{
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__components_update_UpdateErrorModal__["a" /* default */], {
              isOpen: this.state.isOpen,
              onRequestClose: this.handleClose,
              onRetryUpdate: this.handleCheckForUpdate,
              onManualDownload: this.handleManualDownload }));


        }
      default:{
          return false;
        }}

  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4935:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return UpdateCheckingModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_ProgressBar__ = __webpack_require__(3665);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Buttons__ = __webpack_require__(13);



let

UpdateCheckingModal = class UpdateCheckingModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["a" /* Modal */], {
          isOpen: this.props.isOpen,
          onRequestClose: this.props.onRequestClose,
          className: 'update-checking' },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["d" /* ModalHeader */], null, 'CHECKING FOR UPDATES...'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'update-checking__progress' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_ProgressBar__["a" /* default */], null))),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["c" /* ModalFooter */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
              type: 'secondary',
              onClick: this.props.onRequestClose }, 'Cancel'))));




  }};

/***/ }),

/***/ 4936:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return UpdateAvailableModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Markdown__ = __webpack_require__(173);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_LoadingIndicator__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_keymaps_KeyMaps__ = __webpack_require__(72);





let

UpdateAvailableModal = class UpdateAvailableModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.dismissHandler = this.dismissHandler.bind(this);
  }

  getCustomStyles() {
    return {
      marginTop: '15vh',
      height: '70vh',
      width: '720px' };

  }

  getKeymapHandlers() {
    return { 'select': pm.shortcuts.handle('select', this.props.onDownloadUpdate) };
  }

  dismissHandler() {
    pm.updateNotifier.set('updateModalDismissed', true);
    this.props.onRequestClose();
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["a" /* Modal */], {
          className: 'update-available',
          customStyles: this.getCustomStyles(),
          isOpen: this.props.isOpen,
          onRequestClose: this.dismissHandler },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["d" /* ModalHeader */], null, 'UPDATE AVAILABLE (v',
          this.props.updateVersion, ')'),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_keymaps_KeyMaps__["a" /* default */], { shortcuts: pm.shortcuts.getShortcuts(), handlers: this.getKeymapHandlers() },

            _.isEmpty(this.props.changelog) ?
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'update-available__loading-container' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_LoadingIndicator__["a" /* default */], { className: 'update-available__notes-loader' })) :

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'changelog-content' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Markdown__["a" /* default */], { source: this.props.changelog || '' })))),




        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["c" /* ModalFooter */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
              type: 'primary',
              onClick: this.props.onDownloadUpdate }, 'Update'),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
              type: 'secondary',
              onClick: this.dismissHandler }, 'Dismiss'))));




  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4937:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return UpdateNotAvailableModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Modals__ = __webpack_require__(189);

let

UpdateNotAvailableModal = class UpdateNotAvailableModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["a" /* Modal */], {
          isOpen: this.props.isOpen,
          onRequestClose: this.props.onRequestClose,
          className: 'update-not-available' },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["d" /* ModalHeader */], null, 'UP TO DATE'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'update-not-available__message' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'postman-logo' }),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, 'You are up to date! Postman v', this.props.currentVersion, ' is the latest version.')))));




  }};

/***/ }),

/***/ 4938:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return UpdateDownloadingModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_ProgressBar__ = __webpack_require__(3665);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Buttons__ = __webpack_require__(13);



let

UpdateDownloadingModal = class UpdateDownloadingModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["a" /* Modal */], {
          isOpen: this.props.isOpen,
          onRequestClose: this.props.onRequestClose,
          className: 'update-downloading' },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["d" /* ModalHeader */], null, 'DOWNLOADING UPDATE'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'update-downloading__progress' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_ProgressBar__["a" /* default */], null))),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["c" /* ModalFooter */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
              type: 'primary',
              onClick: this.props.onRequestClose }, 'Download in background'),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
              type: 'secondary',
              onClick: this.props.onCancel }, 'Cancel'))));




  }};

/***/ }),

/***/ 4939:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return UpdateApplyModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Buttons__ = __webpack_require__(13);


let

UpdateApplyModal = class UpdateApplyModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["a" /* Modal */], {
          isOpen: this.props.isOpen,
          onRequestClose: this.props.onRequestClose,
          className: 'update-apply' },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["d" /* ModalHeader */], null, 'RESTART AND INSTALL UPDATE'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'update-apply__message' }, 'Update downloaded. You need to restart Postman to install the update.')),



        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["c" /* ModalFooter */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
              type: 'primary',
              onClick: this.props.onApplyUpdate }, 'Restart and Install Update'),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
              type: 'secondary',
              onClick: this.props.onRequestClose }, 'Later'))));




  }};

/***/ }),

/***/ 4940:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return UpdateErrorModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__constants_AppUrlConstants__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__external_navigation_ExternalNavigationService__ = __webpack_require__(59);




let
UpdateErrorModal = class UpdateErrorModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.setAppOnline = this.setAppOnline.bind(this);
    this.setAppOffline = this.setAppOffline.bind(this);

    this.state = { isAppOnline: navigator.onLine };
  }

  componentWillMount() {
    window.addEventListener('online', this.setAppOnline);
    window.addEventListener('offline', this.setAppOffline);
  }

  componentWillUnmount() {
    window.removeEventListener('online', this.setAppOnline);
    window.removeEventListener('offline', this.setAppOffline);
  }

  setAppOnline() {
    this.setState({ isAppOnline: true });
  }

  setAppOffline() {
    this.setState({ isAppOnline: false });
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["a" /* Modal */], {
          isOpen: this.props.isOpen,
          onRequestClose: this.props.onRequestClose,
          className: 'update-error' },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["d" /* ModalHeader */], null, 'UPDATE FAILED'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'update-error__message' }, 'Something went wrong while trying to update your app. Check the DevTools for more details.'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
              className: 'learn-more-button',
              type: 'text',
              onClick: () => {Object(__WEBPACK_IMPORTED_MODULE_4__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_3__constants_AppUrlConstants__["_15" /* UPDATE_FLOW_TROUBLESHOOT_LINK */]);} }, 'Learn more about troubleshooting updates')),




        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["c" /* ModalFooter */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
              type: 'primary',
              onClick: this.props.onRetryUpdate,
              disabled: !this.state.isAppOnline,
              tooltip: !this.state.isAppOnline ? 'You need to be online to check for updates.' : null }, 'Retry update'),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
              type: 'secondary',
              onClick: this.props.onManualDownload }, 'Manually download'))));




  }};

/***/ }),

/***/ 4941:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ReleaseNotesModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_update_ReleaseNotesModal__ = __webpack_require__(4942);
var _class;

let


ReleaseNotesModalContainer = __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default()(_class = class ReleaseNotesModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      releaseNotes: '' };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
  }

  componentWillMount() {
    this.attachModelListeners();
  }

  componentWillUnmount() {
    this.detachModelListeners();
  }

  attachModelListeners() {
    pm.mediator.on('showReleaseNotesModal', this.handleOpen);
  }

  detachModelListeners() {
    pm.mediator.off('showReleaseNotesModal', this.handleOpen);
  }

  handleOpen() {
    this.setState({
      isOpen: true,
      releaseNotes: pm.updateNotifier.get('releaseNotes') });

  }

  handleClose() {
    this.setState({ isOpen: false });
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_update_ReleaseNotesModal__["a" /* default */], {
        isOpen: this.state.isOpen,
        onRequestClose: this.handleClose,
        changelog: this.state.releaseNotes }));


  }}) || _class;

/***/ }),

/***/ 4942:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ReleaseNotesModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Markdown__ = __webpack_require__(173);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__constants_AppUrlConstants__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__external_navigation_ExternalNavigationService__ = __webpack_require__(59);





let
ReleaseNotesModal = class ReleaseNotesModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  getCustomStyles() {
    return {
      marginTop: '15vh',
      height: '70vh',
      width: '720px' };

  }

  handleOpenLink(event) {
    Object(__WEBPACK_IMPORTED_MODULE_5__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_4__constants_AppUrlConstants__["q" /* CHANGELOG_URL */]);
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Modals__["a" /* Modal */], {
          isOpen: this.props.isOpen,
          onRequestClose: this.props.onRequestClose,
          className: 'release-notes-modal',
          customStyles: this.getCustomStyles() },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Modals__["d" /* ModalHeader */], null, 'Release Notes'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'changelog-content' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Markdown__["a" /* default */], { source: this.props.changelog || '' }),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                type: 'text',
                onClick: this.handleOpenLink,
                className: 'release-notes-modal--view-changelog-link' }, 'View full Changelog')))));







  }};

/***/ }),

/***/ 4943:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return DiffModalView; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__Diff__ = __webpack_require__(3744);
var _class;


let


DiffModalView = __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default()(_class = class DiffModalView extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.state = {
      isOpen: false,
      previous: '',
      current: '',
      type: 'lines',
      modalHeader: '' };

    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('showDiffModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showDiffModal', this.handleOpen);
  }

  handleOpen(previous, current, type = 'sentences', modalHeader) {
    this.setState({
      isOpen: true,
      previous: previous,
      current: current,
      type: type,
      modalHeader: modalHeader });

  }

  handleClose() {
    this.setState({
      isOpen: false,
      previous: '',
      current: '',
      type: 'lines' });

  }

  getCustomStyles() {
    return {
      marginTop: 0,
      height: '100%',
      width: '100%' };

  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__Modals__["a" /* Modal */], {
          fullscreen: true,
          className: 'diff-view-modal',
          customStyles: this.getCustomStyles(),
          isOpen: this.state.isOpen,
          onRequestClose: this.handleClose },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__Modals__["d" /* ModalHeader */], { className: 'diff-view-modal-header' }, this.state.modalHeader),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__Modals__["b" /* ModalContent */], { className: 'diff-view-modal-content' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__Diff__["a" /* default */], {
            ignoreOverlay: true,
            current: this.state.current,
            previous: this.state.previous,
            type: this.state.type }))));




  }}) || _class;

/***/ }),

/***/ 4944:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return DeleteMonitorConfirmation; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__collections_DeleteConfirmationModal__ = __webpack_require__(3517);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__modules_model_event__ = __webpack_require__(2);
var _class;




let


DeleteMonitorConfirmation = __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default()(_class = class DeleteMonitorConfirmation extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      meta: {},
      isDisabled: false };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleConfirm = this.handleConfirm.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('showDeleteMonitorModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showDeleteMonitorModal', this.handleOpen);
  }

  handleOpen(monitor, onSuccess, { origin }) {
    this.setState({
      isOpen: true,
      origin: origin,
      meta: {
        id: monitor.id,
        name: monitor.name } },

    () => {
      this.onSuccess = onSuccess;
      _.invoke(this, 'keymapRef.focus');
      __WEBPACK_IMPORTED_MODULE_3__modules_services_AnalyticsService__["a" /* default */].addEvent('monitor', 'initiate_delete', origin);
    });
  }

  handleClose() {
    this.setState({
      isOpen: false,
      isDisabled: false },
    () => {
      this.onSuccess = null;
    });
  }

  handleConfirm() {
    let monitorDeleteEvent = Object(__WEBPACK_IMPORTED_MODULE_5__modules_model_event__["a" /* createEvent */])('delete', 'monitor', { id: this.state.meta.id });
    this.setState({ isDisabled: true });
    Object(__WEBPACK_IMPORTED_MODULE_4__modules_pipelines_user_action__["a" /* default */])(monitorDeleteEvent).then(() => {
      this.onSuccess && this.onSuccess();
      this.handleClose();

      __WEBPACK_IMPORTED_MODULE_3__modules_services_AnalyticsService__["a" /* default */].addEvent('monitor', 'confirm_delete', this.state.origin);
    }).catch(() => {
      this.setState({ isDisabled: false });
      pm.toasts.error('Unable to delete the monitor');
    });
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__collections_DeleteConfirmationModal__["a" /* default */], {
        isDisabled: this.state.isDisabled,
        preventFocusReset: true,
        entity: 'MONITOR',
        primaryAction: this.state.isDisabled ? 'Deleting' : 'Delete',
        isOpen: this.state.isOpen,
        keymapRef: ref => {this.keymapRef = ref;},
        meta: this.state.meta,
        name: this.state.meta.name,
        onConfirm: this.handleConfirm,
        onRequestClose: this.handleClose }));


  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4945:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return DeleteMockConfirmation; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__collections_DeleteConfirmationModal__ = __webpack_require__(3517);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__modules_model_event__ = __webpack_require__(2);
var _class;




let


DeleteMockConfirmation = __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default()(_class = class DeleteMockConfirmation extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      meta: {},
      isDisabled: false };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleConfirm = this.handleConfirm.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('showDeleteMockModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showDeleteMockModal', this.handleOpen);
  }

  handleOpen(mock, onSuccess, { origin }) {
    this.model = mock;
    this.setState({
      isOpen: true,
      origin: origin,
      meta: {
        id: mock.id,
        name: mock.name } },

    () => {
      this.onSuccess = onSuccess;
      _.invoke(this, 'keymapRef.focus');

      __WEBPACK_IMPORTED_MODULE_3__modules_services_AnalyticsService__["a" /* default */].addEventV2({
        category: 'mock',
        action: 'initiate_delete',
        label: origin,
        entityId: mock.id });

    });
  }

  handleClose() {
    this.setState({
      isOpen: false,
      isDisabled: false },
    () => {
      this.onSuccess = null;
    });
  }

  handleConfirm() {
    let mockDeleteEvent = Object(__WEBPACK_IMPORTED_MODULE_5__modules_model_event__["a" /* createEvent */])('delete', 'mock', { id: this.state.meta.id });
    this.setState({ isDisabled: true });
    Object(__WEBPACK_IMPORTED_MODULE_4__modules_pipelines_user_action__["a" /* default */])(mockDeleteEvent).then(() => {
      this.onSuccess && this.onSuccess();
      this.handleClose();

      __WEBPACK_IMPORTED_MODULE_3__modules_services_AnalyticsService__["a" /* default */].addEventV2({
        category: 'mock',
        action: 'confirm_delete',
        label: this.state.origin,
        entityId: this.state.meta.id });

    }).catch(() => {
      this.setState({ isDisabled: false });
      pm.toasts.error('Unable to delete the mock');
    });
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__collections_DeleteConfirmationModal__["a" /* default */], {
        isDisabled: this.state.isDisabled,
        preventFocusReset: true,
        entity: 'MOCK',
        isOpen: this.state.isOpen,
        primaryAction: this.state.isDisabled ? 'Deleting' : 'Delete',
        keymapRef: ref => {this.keymapRef = ref;},
        meta: this.state.meta,
        name: 'this mock',
        onConfirm: this.handleConfirm,
        onRequestClose: this.handleClose }));


  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4946:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ExampleDeleteConfirmation; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__collections_DeleteConfirmationModal__ = __webpack_require__(3517);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_model_event__ = __webpack_require__(2);



let

ExampleDeleteConfirmation = class ExampleDeleteConfirmation extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      meta: {},
      isDisabled: false };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleConfirm = this.handleConfirm.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('showDeleteExampleModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showDeleteExampleModal', this.handleClose);
  }

  handleConfirm() {
    let info = this.state.meta;

    if (!info || !info.responseId) {
      return;
    }

    this.setState({ isDisabled: true });

    let deleteResponseEvent = Object(__WEBPACK_IMPORTED_MODULE_3__modules_model_event__["a" /* createEvent */])('delete', 'response', { id: info.responseId });

    return Object(__WEBPACK_IMPORTED_MODULE_2__modules_pipelines_user_action__["a" /* default */])(deleteResponseEvent).
    then(response => {
      if (!_.isEmpty(_.get(response, 'error'))) {
        pm.logger.error('Error in deleting response', response.error);
        return;
      }

      // used for handling whether the editor needs to be closed or not
      _.isFunction(this.onSuccess) && this.onSuccess();
      this.handleClose();
    }).
    catch(err => {
      this.setState({ isDisabled: false });
      pm.logger.error('Error in pipeline while deleting response', err);
    });
  }

  handleClose() {
    this.setState({
      isOpen: false,
      isDisabled: false },
    () => {
      this.onSuccess = null;
    });
  }

  handleOpen(info, onSuccess) {
    this.setState({
      isOpen: true,
      meta: info },
    () => {
      this.onSuccess = onSuccess;
    });
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__collections_DeleteConfirmationModal__["a" /* default */], {
        isDisabled: this.state.isDisabled,
        preventFocusReset: true,
        entity: 'EXAMPLE',
        isOpen: this.state.isOpen,
        primaryAction: this.state.isDisabled ? 'Deleting' : 'Delete',
        keymapRef: ref => {this.keymapRef = ref;},
        meta: this.state.meta,
        onConfirm: this.handleConfirm,
        onRequestClose: this.handleClose }));


  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4947:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ForceCloseAllTabsConfirmation; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__services_EditorService__ = __webpack_require__(66);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__collections_DeleteConfirmationModal__ = __webpack_require__(3517);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__stores_get_store__ = __webpack_require__(5);



let

ForceCloseAllTabsConfirmation = class ForceCloseAllTabsConfirmation extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = { isOpen: false };

    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleConfirm = this.handleConfirm.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('showForceCloseConfirmationModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showForceCloseConfirmationModal', this.handleOpen);
  }

  handleOpen() {

    this.setState({ isOpen: true });
  }

  handleClose() {
    this.setState({ isOpen: false });
  }

  handleConfirm() {
    __WEBPACK_IMPORTED_MODULE_1__services_EditorService__["a" /* default */].confirmForceCloseAll();
    this.handleClose();
  }

  render() {
    let dirtyEditorsCount = Object(__WEBPACK_IMPORTED_MODULE_3__stores_get_store__["getStore"])('EditorStore').dirtyEditorsCount;

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__collections_DeleteConfirmationModal__["a" /* default */], {
        preventFocusReset: true,
        entity: 'TAB',
        isOpen: this.state.isOpen,
        keymapRef: ref => {this.keymapRef = ref;},
        meta: { count: dirtyEditorsCount },
        primaryAction: 'Force Close',
        onConfirm: this.handleConfirm,
        onRequestClose: this.handleClose }));


  }};

/***/ }),

/***/ 4948:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return DeleteHistoryConfirmation; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__collections_DeleteConfirmationModal__ = __webpack_require__(3517);
var _class;



const DELETE_ALL_HISTORY_ACTION = 'all',
DELETE_SELECTED_HISTORY_ACTION = 'selected';let


DeleteHistoryConfirmation = __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default()(_class = class DeleteHistoryConfirmation extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      isDeleting: false };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleConfirm = this.handleConfirm.bind(this);
    this.onConfirm = null;
  }

  componentWillMount() {
    pm.mediator.on('showDeleteHistoryModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showDeleteHistoryModal', this.handleOpen);
  }

  handleOpen(onConfirm, options) {
    this.onConfirm = onConfirm;
    this.options = options || {};
    this.setState({
      isOpen: true,
      isDeleting: false },
    () => {
      _.invoke(this, 'keymapRef.focus');
    });
  }

  handleClose() {
    this.setState({ isOpen: false }, () => {
      pm.mediator.trigger('focusSidebar');
      this.onConfirm = null;
    });
  }

  handleConfirm() {
    this.setState({ isDeleting: true }, () => {
      return Promise.resolve().
      then(() => {
        return this.onConfirm && this.onConfirm();
      }).
      then(() => {
        this.handleClose();
      }).
      catch(() => {
        pm.logger.warn('DeleteHistoryConfirmation~handleConfirm: Could not delete history');
        this.handleClose();
      });
    });
  }

  getModalMessage(identifier) {
    switch (identifier) {
      case DELETE_ALL_HISTORY_ACTION:
        return 'Are you sure you want to clear all your history requests for this workspace?';
      case DELETE_SELECTED_HISTORY_ACTION:
        return 'Are you sure you want to clear all the selected history requests from this workspace?';
      default:
        return 'Are you sure you want to clear all the selected history requests from this workspace?';}

  }

  render() {
    let identifier = this.options && this.options.identifier || 'selected',
    message = this.getModalMessage(identifier);

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__collections_DeleteConfirmationModal__["a" /* default */], {
        preventFocusReset: true,
        entity: 'HISTORY',
        isOpen: this.state.isOpen,
        keymapRef: ref => {this.keymapRef = ref;},
        onConfirm: this.handleConfirm,
        onRequestClose: this.handleClose,
        message: message,
        isDeleting: this.state.isDeleting }));


  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4949:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return PublishDocsSignedoutModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__user_SignedOutModal__ = __webpack_require__(4950);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__external_navigation_ExternalNavigationService__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__constants_AppUrlConstants__ = __webpack_require__(64);




let

PublishDocsSignedoutModal = class PublishDocsSignedoutModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = { isOpen: false };
    this.toggleOpen = this.toggleOpen.bind(this);
    this.handlePublishDocsDocumentation = this.handlePublishDocsDocumentation.bind(this);
    this.renderSignedOutText = this.renderSignedOutText.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('publishDocsSignedoutModal', this.toggleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('publishDocsSignedoutModal', this.toggleOpen);
  }

  toggleOpen(value = false) {
    this.setState({ isOpen: value });
  }

  handlePublishDocsDocumentation() {
    Object(__WEBPACK_IMPORTED_MODULE_3__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_4__constants_AppUrlConstants__["_2" /* PUBLISHING_DOCS */]);
  }


  renderSignedOutText() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, 'You can publish your documentation in Postman. Documentation lets you create and share beautiful web pages publicly or privately. You must be signed in to your Postman account to publish.'),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('br', null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
            type: 'text',
            onClick: this.handlePublishDocsDocumentation }, 'Learn more about publishing')));





  }


  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__user_SignedOutModal__["a" /* default */], {
        isOpen: this.state.isOpen,
        message: this.renderSignedOutText,
        title: 'PUBLISH DOCUMENTATION',
        onRequestClose: this.toggleOpen }));


  }};

/***/ }),

/***/ 4950:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SignedOutModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_services_AuthHandlerService__ = __webpack_require__(532);



let

SignedOutModal = class SignedOutModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = { isOpen: false };

    this.handleClose = this.handleClose.bind(this);
    this.handleSignIn = this.handleSignIn.bind(this);
  }

  componentWillMount() {
    this.setState({ isOpen: this.props.isOpen });
  }

  componentWillReceiveProps(nextProps) {
    this.setState({ isOpen: nextProps.isOpen });
  }

  handleClose() {
    this.setState({ isOpen: false }, this.props.onRequestClose);
  }

  handleSignIn() {
    this.handleClose();
    __WEBPACK_IMPORTED_MODULE_3__modules_services_AuthHandlerService__["a" /* default */].login();
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["a" /* Modal */], {
          className: 'signed-out-modal',
          isOpen: this.state.isOpen,
          onRequestClose: this.handleClose },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["d" /* ModalHeader */], null,
          this.props.title),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'signed-out-modal-container-wrapper' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'signed-out-modal-login-empty-message-container' },

              this.props.message ?
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'signed-out-modal-login-empty-message' },
                _.isFunction(this.props.message) ? this.props.message() : this.props.message) :


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'signed-out-modal-login-empty-message' }, 'You must be ',
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'signed-out-modal-login-link', onClick: this.handleSignIn }, ' signed in'), ' to Postman to ', this.props.action, '.')),





            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
                type: 'primary',
                size: 'huge',
                className: 'signout-out-signin-btn',
                onClick: this.handleSignIn }, 'Sign in to Postman')))));







  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4951:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return LibraryShareCollectionModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_library_LibraryShareCollectionModal__ = __webpack_require__(4952);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__stores_get_store__ = __webpack_require__(5);




let

LibraryShareCollectionModalContainer = class LibraryShareCollectionModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      type: null };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleShareEntities = this.handleShareEntities.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('showEntitiesAddToWorkspaceModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showEntitiesAddToWorkspaceModal', this.handleOpen);
  }

  handleOpen(type = 'collection') {
    this.setState({
      isOpen: true,
      type });

  }

  handleClose() {
    this.setState({
      isOpen: false,
      type: null });

  }

  getCustomStyles() {
    return {
      marginTop: '15vh',
      height: '440px',
      width: '460px' };

  }

  handleShareEntities(entities) {
    let dependencies = _.map(entities, id => {
      let storeEntity = Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])(`${_.upperFirst(this.state.type)}Store`).find(id);
      return {
        model: this.state.type,
        modelId: storeEntity.uid };

    });
    let dependencyAddEvent = {
      name: 'add_dependencies',
      namespace: 'workspace',
      data: {
        dependencies: dependencies,
        model: 'workspace',
        workspace: { id: Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('ActiveBrowseWorkspaceStore').id } } };


    Object(__WEBPACK_IMPORTED_MODULE_3__modules_pipelines_user_action__["a" /* default */])(dependencyAddEvent);
    this.handleClose();
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["a" /* Modal */], {
          isOpen: this.state.isOpen,
          onRequestClose: this.handleClose,
          className: 'library-share-collection-modal',
          customStyles: this.getCustomStyles(),
          customOverlayStyles: { 'zIndex': 110 } },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["d" /* ModalHeader */], null, 'ADD TO WORKSPACE'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_library_LibraryShareCollectionModal__["a" /* default */], {
            onShareEntities: this.handleShareEntities,
            onClose: this.handleClose,
            type: this.state.type }))));




  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4952:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return LibraryShareCollectionModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__team_invite_flows_TeamLibraryShareCollection__ = __webpack_require__(4953);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__team_invite_flows_TeamLibraryShareEnvironment__ = __webpack_require__(4954);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_mobx_react__ = __webpack_require__(11);
var _class;




let


LibraryShareCollectionModal = Object(__WEBPACK_IMPORTED_MODULE_5_mobx_react__["a" /* observer */])(_class = class LibraryShareCollectionModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.state = { selectedEntities: [] };
    this.handleSelectEntities = this.handleSelectEntities.bind(this);
    this.handleShareEntities = this.handleShareEntities.bind(this);
  }

  handleSelectEntities(selectedEntities) {
    this.setState({ selectedEntities });
  }

  handleShareEntities() {
    this.props.onShareEntities(this.state.selectedEntities);
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'library-share-collection-wrapper' },

        this.props.type === 'collection' &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__team_invite_flows_TeamLibraryShareCollection__["a" /* default */], {
          alreadyShared: true,
          collections: Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('CollectionStore').values,
          selectedCollections: this.state.selectedEntities,
          onSelectCollection: this.handleSelectEntities }),



        this.props.type === 'environment' &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__team_invite_flows_TeamLibraryShareEnvironment__["a" /* default */], {
          environments: Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('EnvironmentStore').values,
          selectedEnvironments: this.state.selectedEntities,
          onSelectEnvironment: this.handleSelectEntities }),



        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
            className: 'library-share-collection-action',
            disabled: _.isEmpty(this.state.selectedEntities),
            type: 'primary',
            onClick: this.handleShareEntities }, 'Add these to workspace')));





  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4953:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return TeamLibraryShareCollection; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_base_MultiSelectEntity__ = __webpack_require__(3768);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__constants_AppUrlConstants__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__external_navigation_ExternalNavigationService__ = __webpack_require__(59);




let
TeamLibraryShareCollection = class TeamLibraryShareCollection extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  render() {
    if (_.isEmpty(this.props.collections)) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'team-library-share-collection__box-wrapper isEmpty' },

          this.props.alreadyShared ?
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Looks like you don\u2019t have any personal collections to add to this workspace. Create a new collection in the sidebar and save some requests in it to get started. ') :
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Looks like you don\u2019t have any personal collections to add to this workspace. API requests in Postman are saved in Collections. Create a new collection in the sidebar and save some requests in it to get started. '),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Buttons__["a" /* Button */], {
              className: 'learn-more',
              type: 'text',
              onClick: () => {
                Object(__WEBPACK_IMPORTED_MODULE_4__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_3__constants_AppUrlConstants__["r" /* COLLECTION_DOCS */]);
              } }, 'Learn more about Postman collections')));





    }
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'team-library-share-collection__box-wrapper em' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'team-library-share-collection__label' }, 'Choose the collections you want to add to this workspace.'),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_MultiSelectEntity__["a" /* default */], {
          type: 'collections',
          items: this.props.collections,
          selectedEntities: this.props.selectedCollections,
          onSelectEntity: this.props.onSelectCollection })));



  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4954:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return TeamLibraryShareEnvironment; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_base_MultiSelectEntity__ = __webpack_require__(3768);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__constants_AppUrlConstants__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__external_navigation_ExternalNavigationService__ = __webpack_require__(59);





let
TeamLibraryShareEnvironment = class TeamLibraryShareEnvironment extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  handleEnvironmentDocs() {
    __WEBPACK_IMPORTED_MODULE_4__modules_services_AnalyticsService__["a" /* default */].addEvent('onboarding', 'view_documentation_environments', 'team_library');
    Object(__WEBPACK_IMPORTED_MODULE_5__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_3__constants_AppUrlConstants__["B" /* ENVIRONMENT_DOCS */]);
  }

  render() {
    if (_.isEmpty(this.props.environments)) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'team-library-share-collection__box-wrapper isEmpty' }, 'Looks like you don\u2019t have any environments to add to this workspace. Environments give you the ability to customize requests using variables. You can easily switch between different setups without changing your requests. Create an environment in the Builder to get started.',

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Buttons__["a" /* Button */], {
              className: 'learn-more',
              type: 'text',
              onClick: this.handleEnvironmentDocs }, 'Learn more about Postman environments')));





    }

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'team-library-share-collection__box-wrapper' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'team-library-share-collection__label' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Choose the environments you want to add to this workspace.')),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_MultiSelectEntity__["a" /* default */], {
          type: 'environments',
          items: this.props.environments,
          selectedEntities: this.props.selectedEnvironments,
          onSelectEntity: this.props.onSelectEnvironment })));



  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4955:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SwitchAccountConfirmationModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_base_keymaps_KeyMaps__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__modules_model_event__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__modules_pipelines_user_action__ = __webpack_require__(44);





let

SwitchAccountConfirmationModal = class SwitchAccountConfirmationModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.state = {
      userId: '',
      isOpen: false };

    this.handleSubmit = this.handleSubmit.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleOpen = this.handleOpen.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('showAccountSwitchConfirmation', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showAccountSwitchConfirmation', this.handleOpen);
  }


  getKeyMapHandlers() {
    return {
      quit: pm.shortcuts.handle('quit', this.handleClose), // discard and close
      select: pm.shortcuts.handle('select', this.handleSubmit), // save and close
      submit: pm.shortcuts.handle('submit', this.handleSubmit) // save and close
    };
  }

  handleOpen(userId) {
    this.setState({
      userId: userId,
      isOpen: true });

  }

  handleClose() {
    this.setState({
      userId: '',
      isOpen: false });

  }

  handleSubmit() {
    // @todo handle multi-user login
    // pm.user.handleSwitchAccount(this.state.userId);
    Object(__WEBPACK_IMPORTED_MODULE_5__modules_pipelines_user_action__["a" /* default */])(Object(__WEBPACK_IMPORTED_MODULE_4__modules_model_event__["a" /* createEvent */])('switch', 'users', { id: this.state.userId }));
  }

  getCustomStyles() {
    return { marginTop: '35vh' };
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["a" /* Modal */], {
          customStyles: this.getCustomStyles(),
          isOpen: this.state.isOpen,
          onRequestClose: this.handleClose },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["d" /* ModalHeader */], null, 'Switch account'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_keymaps_KeyMaps__["a" /* default */], {
              handlers: this.getKeyMapHandlers(),
              keyMap: pm.shortcuts.getShortcuts(),
              ref: this.props.keymapRef },

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'delete-confirmation-modal__message' }, 'Switching accounts will close other windows open with your current account. You might lose any unsaved work.',

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'delete-confirmation-modal-message' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Are you sure you wish to proceed?'))),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'delete-confirmation-modal-controls' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Buttons__["a" /* Button */], {
                    className: 'delete-confirmation-modal-delete-button',
                    type: 'primary',
                    onClick: this.handleSubmit }, 'Close windows and switch account'),

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Buttons__["a" /* Button */], {
                    className: 'delete-confirmation-modal-cancel-button',
                    type: 'secondary',
                    onClick: this.handleClose }, 'Cancel')))))));







  }};

/***/ }),

/***/ 4956:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddAccountConfirmationModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_base_keymaps_KeyMaps__ = __webpack_require__(72);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__modules_model_event__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__modules_pipelines_user_action__ = __webpack_require__(44);





let

AddAccountConfirmationModal = class AddAccountConfirmationModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.state = { isOpen: false };
    this.handleSubmit = this.handleSubmit.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleOpen = this.handleOpen.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('showAddAccountConfirmation', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showAddAccountConfirmation', this.handleOpen);
  }


  getKeyMapHandlers() {
    return {
      quit: pm.shortcuts.handle('quit', this.handleClose), // discard and close
      select: pm.shortcuts.handle('select', this.handleSubmit), // save and close
      submit: pm.shortcuts.handle('submit', this.handleSubmit) // save and close
    };
  }

  handleOpen() {
    this.setState({ isOpen: true });
  }

  handleClose() {
    this.setState({ isOpen: false });
  }

  handleSubmit() {
    Object(__WEBPACK_IMPORTED_MODULE_5__modules_pipelines_user_action__["a" /* default */])(Object(__WEBPACK_IMPORTED_MODULE_4__modules_model_event__["a" /* createEvent */])('add', 'users'));
  }

  getCustomStyles() {
    return { marginTop: '35vh' };
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["a" /* Modal */], {
          customStyles: this.getCustomStyles(),
          isOpen: this.state.isOpen,
          onRequestClose: this.handleClose },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["d" /* ModalHeader */], null, 'Add account'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_keymaps_KeyMaps__["a" /* default */], {
              handlers: this.getKeyMapHandlers(),
              keyMap: pm.shortcuts.getShortcuts(),
              ref: this.props.keymapRef },

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'delete-confirmation-modal__message' }, 'Adding new account will close other windows open with your current account. You might lose any unsaved work.',

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'delete-confirmation-modal-message' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Are you sure you wish to proceed?'))),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'delete-confirmation-modal-controls' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Buttons__["a" /* Button */], {
                    className: 'delete-confirmation-modal-delete-button',
                    type: 'primary',
                    onClick: this.handleSubmit }, 'Close windows and add new account'),

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Buttons__["a" /* Button */], {
                    className: 'delete-confirmation-modal-cancel-button',
                    type: 'secondary',
                    onClick: this.handleClose }, 'Cancel')))))));







  }};

/***/ }),

/***/ 4957:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return OAuth2ManageTokensModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_auth_OAuth2ManageAccessTokensModal__ = __webpack_require__(4958);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_base_Modals__ = __webpack_require__(189);
var _class;


let


OAuth2ManageTokensModalContainer = __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default()(_class = class OAuth2ManageTokensModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.model = pm.oAuth2Manager;
    this.state = {
      isOpen: false,
      selectedTokenId: null,
      savedOAuth2Tokens: [],
      oauth2EditorsObject: {
        accessTokenUrl: '',
        authUrl: '',
        client_authentication: 'header',
        clientId: '',
        clientSecret: '',
        grant_type: 'authorization_code',
        name: '',
        password: '',
        redirect_uri: '',
        scope: '',
        showPassword: false,
        state: '',
        username: '' } };



    this.setInitialState = this.setInitialState.bind(this);
    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleUpdateToken = this.handleUpdateToken.bind(this);
    this.handleDeleteToken = this.handleDeleteToken.bind(this);
    this.handleNewToken = this.handleNewToken.bind(this);
    this.handleTokenSelect = this.handleTokenSelect.bind(this);
    this.handleUseToken = this.handleUseToken.bind(this);
  }

  componentWillMount() {
    this.model.on('change', this.setInitialState);
    this.attachModelListeners();
    this.setInitialState();
  }

  componentWillUnmount() {
    this.model.off('change', this.setInitialState);
    this.detachModelListeners();
  }

  setInitialState() {
    let state = {
      oauth2EditorsObject: this.model.get('oAuth2'),
      savedOAuth2Tokens: this.model.get('savedOAuth2Tokens') };

    this.setState(state);
  }

  attachModelListeners() {
    pm.mediator.on('openNewOAuth2Token', this.handleNewToken);
    pm.mediator.on('openManageTokensModal', this.handleOpen);
  }

  detachModelListeners() {
    pm.mediator.off('openNewOAuth2Token', this.handleNewToken);
    pm.mediator.off('openManageTokensModal', this.handleOpen);
  }

  handleNewToken(token, callback) {
    this._callback = callback;

    this.setState({
      selectedTokenId: token && token.id,
      isOpen: true });

  }

  handleOpen(opts, callback) {
    let firstToken = _.first(this.state.savedOAuth2Tokens);
    this._callback = callback;

    this.setState({
      isOpen: true,
      selectedTokenId: firstToken && firstToken.id });

  }

  handleClose() {
    this._callback = null;
    this.setState({ isOpen: false });
  }

  handleUpdateToken(updatedToken) {
    this.model.updateOAauth2Token(updatedToken);
  }

  handleDeleteToken(token) {
    let savedOAuth2Tokens = this.state.savedOAuth2Tokens,
    nextState;

    // do nothing if token being deleted is not the token in view
    if (token.id !== this.state.selectedTokenId) {
      nextState = {};
    }

    // set the view to the next token in list
    else {
        // remove token being deleted from the list
        let newTokenList = _.reject(savedOAuth2Tokens, ['id', token.id]),
        tokenPosition = _.findIndex(newTokenList, ['id', token.id]),

        // find next element to select
        tokenToSelect = _.nth(newTokenList, tokenPosition + 1) || _.first(newTokenList);

        // move selection to next item if possible, close modal id all items are removed,
        nextState = tokenToSelect ? { selectedTokenId: tokenToSelect.id } : { isOpen: false };
      }

    this.setState(
    nextState,
    () => {
      this.model.processOAuth2DeleteToken(token);
    });

  }

  handleTokenSelect(token) {
    this.setState({ selectedTokenId: token.id });
  }

  handleUseToken(token) {
    this.setState({ isOpen: false }, () => {
      _.isFunction(this._callback) && this._callback(token);
    });
  }

  getCustomStyles() {
    return {
      marginTop: '20vh',
      width: '800px',
      height: '55vh',
      maxHeight: '400px' };

  }

  render() {
    let oauth2EditorsObject = this.state.oauth2EditorsObject;

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_auth_OAuth2ManageAccessTokensModal__["a" /* default */], {
        isOpen: this.state.isOpen,
        oAuth2: oauth2EditorsObject,
        savedOAuth2Tokens: this.state.savedOAuth2Tokens,
        selectedTokenId: this.state.selectedTokenId,
        onClose: this.handleClose,
        onSavedAccessTokenUpdate: this.handleUpdateToken,
        onSavedAccessTokenDelete: this.handleDeleteToken,
        onTokenSelect: this.handleTokenSelect,
        onUseToken: this.handleUseToken }));


  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4958:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return OAuth2ManageAccessTokensModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Icons_DeleteIcon__ = __webpack_require__(214);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__OAuth2TokenDetails__ = __webpack_require__(4959);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_prop_types__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_prop_types___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_prop_types__);





let

OAuth2ManageAccessTokensModal = class OAuth2ManageAccessTokensModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.state = { selectedTokenId: null };
    this.handleDeleteToken = this.handleDeleteToken.bind(this);
  }

  getCustomStyles() {
    return {
      marginTop: '20vh',
      width: '800px',
      height: '55vh',
      maxHeight: '400px' };

  }

  getSidebarItemClasses(token) {
    let selectedTokenId = this.props.selectedTokenId;
    return __WEBPACK_IMPORTED_MODULE_4_classnames___default()({
      'oauth2-manage-tokens-sidebar__item': true,
      'oauth2-manage-tokens-sidebar__item--active': selectedTokenId && selectedTokenId === token.id });

  }

  handleDeleteToken(token, e) {
    e.preventDefault();
    e.stopPropagation();
    this.props.onSavedAccessTokenDelete(token);
  }

  render() {

    let oAuth2 = this.props.oAuth2,
    savedOAuth2Tokens = this.props.savedOAuth2Tokens,
    selectedTokenId = this.props.selectedTokenId,
    selectedToken;

    selectedTokenId && (selectedToken = _.find(savedOAuth2Tokens, ['id', this.props.selectedTokenId]));

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["a" /* Modal */], {
          className: 'oauth2-manage-tokens-modal',
          isOpen: this.props.isOpen,
          onRequestClose: this.props.onClose,
          customStyles: this.getCustomStyles() },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["d" /* ModalHeader */], null, 'MANAGE ACCESS TOKENS'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'oauth2-manage-tokens-sidebar' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'oauth2-manage-tokens-sidebar__header' }, 'ALL TOKENS'),



            _.map(savedOAuth2Tokens, token => {
              return (
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
                    className: this.getSidebarItemClasses(token),
                    key: token.id,
                    onClick: this.props.onTokenSelect.bind(this, token) },

                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'oauth2-manage-tokens-sidebar__token-name-wrapper' },
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'oauth2-manage-tokens-sidebar__token-name' },
                      token.name),

                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Icons_DeleteIcon__["a" /* default */], {
                      className: 'oauth2-token-delete-icon',
                      size: 'xs',
                      onClick: this.handleDeleteToken.bind(this, token) }))));




            })),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'oauth2-manage-tokens-description' },

            selectedToken &&

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__OAuth2TokenDetails__["a" /* default */], {
              token: selectedToken,
              onUseToken: this.props.onUseToken,
              onUpdateToken: this.props.onSavedAccessTokenUpdate })))));







  }};


OAuth2ManageAccessTokensModal.propTypes = { savedOAuth2Tokens: __WEBPACK_IMPORTED_MODULE_5_prop_types___default.a.array.isRequired };
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4959:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return OAuth2TokenDetails; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_InfoButton__ = __webpack_require__(222);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Icons_EditIcon__ = __webpack_require__(534);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_InlineInput__ = __webpack_require__(653);







const BANNED_DETAILS = ['result', 'id', 'name', 'access_token', 'token_type'];let

OAuth2TokenDetails = class OAuth2TokenDetails extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      showEditNameToggle: true };


    this.handleNameChange = this.handleNameChange.bind(this);
  }

  beautifyTokenField(value) {
    let retVal = JSON.stringify(value);
    if (retVal && retVal[0] === '"') {
      return retVal.replace(/\"/g, '');
    }
    return retVal;
  }

  getTokenItemClasses(warning) {
    return __WEBPACK_IMPORTED_MODULE_1_classnames___default()({
      'oauth2-token-details-item-group': true,
      'oauth2-token-details-item-group--warning': warning });

  }

  toggleNameEdit(isEditing) {
    let tokenNameField = this.refs.tokenName;

    // open the edit inputbox and select the whole token string for renaming
    if (tokenNameField && isEditing) {
      tokenNameField.startEditing();
      tokenNameField.focus();
      tokenNameField.selectAll();
    }

    this.setState({
      showEditNameToggle: !isEditing });

  }

  handleNameChange(updatedName) {
    if (!updatedName || typeof updatedName !== 'string') {
      return;
    }

    let updatedToken = _.clone(this.props.token);
    if (!updatedToken) {
      return;
    }

    updatedToken.name = updatedName;
    this.props.onUpdateToken(updatedToken);
  }

  render() {
    let token = this.props.token,
    maskedToken = _.pickBy(token, (detailValue, detailName) => {
      return !_.includes(BANNED_DETAILS, detailName);
    }),
    isAccessTokenMissing = !token.access_token,
    isTokenTypeIncorrect = token.token_type && token.token_type.toLowerCase() !== 'bearer';

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'oauth2-token-details-wrapper' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: this.getTokenItemClasses() },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'oauth2-token-details-item-group__label' }, 'Token Name'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'oauth2-token-details-item-group__value' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_InlineInput__["a" /* default */], {
              ref: 'tokenName',
              allowEmpty: false,
              editable: true,
              value: token.name,
              onToggleEdit: this.toggleNameEdit.bind(this),
              onSubmit: this.handleNameChange }),


            this.state.showEditNameToggle &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'oauth2-token-details-item-group__value-edit-button' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], { onClick: this.toggleNameEdit.bind(this, true) },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Icons_EditIcon__["a" /* default */], { size: 'xs' }))))),





        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: this.getTokenItemClasses(isAccessTokenMissing) },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'oauth2-token-details-item-group__label' }, 'Access Token',

            isAccessTokenMissing &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_InfoButton__["a" /* default */], {
              tooltip:
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null,
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'oauth2-token-details-tooltip__highlight' }, 'access_token'), ' not found in the response. If the access token value is present elsewhere in the response, you can copy and use that in the Access Token input field.'),


              type: 'error' })),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'oauth2-token-details-item-group__value' },
            token.access_token)),


        token.token_type &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: this.getTokenItemClasses(isTokenTypeIncorrect) },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'oauth2-token-details-item-group__label' }, 'Token Type',

            isTokenTypeIncorrect &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_InfoButton__["a" /* default */], {
              tooltip:
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Only ',
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'oauth2-token-details-tooltip__highlight' }, 'bearer'), ' token types are supported.'),


              type: 'error' })),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'oauth2-token-details-item-group__value' },
            token.token_type)),




        _.map(maskedToken, (value, key) => {
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
                className: this.getTokenItemClasses(),
                key: key },

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'oauth2-token-details-item-group__label' },
                key),

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'oauth2-token-details-item-group__value' },
                this.beautifyTokenField(value))));



        }),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'oauth2-token-details-action-group' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
              disabled: isAccessTokenMissing || isTokenTypeIncorrect,
              type: 'primary',
              onClick: this.props.onUseToken.bind(this, token) }, 'Use Token'))));






  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4960:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CreateNewXModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_base_Tabs__ = __webpack_require__(103);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__services_EditorService__ = __webpack_require__(66);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__constants_ManageEnvironmentViews__ = __webpack_require__(1493);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__constants_AppUrlConstants__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__components_new_button_CreateNewXModal__ = __webpack_require__(4961);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__components_base_XPaths_XPath__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__utils_EditorUtils__ = __webpack_require__(113);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__utils_EditorUtils___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_11__utils_EditorUtils__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12_uuid_v4__ = __webpack_require__(47);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12_uuid_v4___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_12_uuid_v4__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__CreateNewXService__ = __webpack_require__(3617);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__services_UIEventService__ = __webpack_require__(79);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__external_navigation_ExternalNavigationService__ = __webpack_require__(59);


















const NEW = 'new',
TEMPLATE = 'template',
API_NETWORK = 'apiNetwork';

const tabTypes = {
  new: NEW,
  template: TEMPLATE,
  apiNetwork: API_NETWORK };let


CreateNewXModalContainer = class CreateNewXModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      activeTab: NEW, // 'new' or 'template' or 'apiNetwork'
      showOnStartup: _.isUndefined(pm.settings.getSetting('showCreateNewXModalOnStartup')) ? true : pm.settings.getSetting('showCreateNewXModalOnStartup'),
      meta: {} };


    this.handleToggle = this.handleToggle.bind(this);
    this.handleOpen = this.handleToggle.bind(this, false);
    this.handleClose = this.handleToggle.bind(this, true);
    this.handleTabChange = this.handleTabChange.bind(this);
    this.handleShowOnStartup = this.handleShowOnStartup.bind(this);
    this.handleSelectCard = this.handleSelectCard.bind(this);
    this.handleSignupSuccess = this.handleSignupSuccess.bind(this);
  }

  componentDidMount() {
    pm.mediator.on('openCreateNewXModal', this.handleOpen);
    this.signInListener = __WEBPACK_IMPORTED_MODULE_14__services_UIEventService__["a" /* default */].subscribe('userSignedIn', () => {
      this.handleClose(NEW);
    });
  }

  componentWillUnmount() {
    pm.mediator.off('openCreateNewXModal', this.handleOpen);
    this.signInListener();
  }

  getStyles() {
    return {
      marginTop: '10vh',
      height: '75vh',
      minWidth: '760px',
      maxHeight: '570px',
      width: '80vw' };

  }

  handleToggle(value = this.state.isOpen, activeTab = this.state.activeTab, callback, meta = {}) {
    if (!tabTypes[activeTab]) {
      activeTab = NEW;
    }

    this.setState({
      isOpen: !value,
      activeTab,
      meta },
    () => {
      _.isFunction(callback) && callback();
    });
  }

  handleSignupSuccess() {
    this.handleOpen();
  }

  handleTabChange(activeTab) {
    this.setState({ activeTab, meta: {} });
  }

  handleShowOnStartup() {
    this.setState({ showOnStartup: !this.state.showOnStartup }, () => {
      pm.settings.setSetting('showCreateNewXModalOnStartup', this.state.showOnStartup);
    });
  }

  handleSelectCard(card) {
    this.handleToggle();

    switch (card) {
      case 'request':
        let newReqId = __WEBPACK_IMPORTED_MODULE_12_uuid_v4___default()(),
        reqResource = Object(__WEBPACK_IMPORTED_MODULE_11__utils_EditorUtils__["requestResourceId"])({ id: newReqId });

        __WEBPACK_IMPORTED_MODULE_5__modules_services_AnalyticsService__["a" /* default */].addEvent('onboarding', 'initiate_request_create', 'create_new_modal');
        pm.mediator.trigger('showAddToCollectionModal', { id: newReqId }, { from: 'new-x-modal' }, () => {
          __WEBPACK_IMPORTED_MODULE_6__services_EditorService__["a" /* default */].open(reqResource, { forceNew: true });
        });
        break;
      case 'collection':
        __WEBPACK_IMPORTED_MODULE_5__modules_services_AnalyticsService__["a" /* default */].addEvent('onboarding', 'initiate_collection_create', 'create_new_modal');
        pm.mediator.trigger('showNewCollectionModal', id => {
          pm.mediator.trigger('focusCollectionInSideBar', id);
        });
        break;
      case 'environment':
        __WEBPACK_IMPORTED_MODULE_5__modules_services_AnalyticsService__["a" /* default */].addEvent('onboarding', 'initiate_environment_create', 'create_new_modal');
        pm.mediator.trigger('showManageEnvironmentModal', __WEBPACK_IMPORTED_MODULE_7__constants_ManageEnvironmentViews__["a" /* MANAGE_ENVIRONMENT_VIEW_ADD_ENV */]);
        break;
      case 'monitor':
        __WEBPACK_IMPORTED_MODULE_13__CreateNewXService__["a" /* default */].create(
        'openCreateNewMonitorModal',
        {
          opts: {
            activeStep: 1,
            from: 'create_new_modal' } },


        null,
        { from: 'create_new_modal' });

        break;
      case 'documentation':
        __WEBPACK_IMPORTED_MODULE_13__CreateNewXService__["a" /* default */].create(
        'openCreateNewDocumentationModal',
        {
          opts: {
            activeStep: 1,
            from: 'create_new_modal' } },


        null,
        { from: 'create_new_modal' });

        break;
      case 'mock':
        __WEBPACK_IMPORTED_MODULE_13__CreateNewXService__["a" /* default */].create(
        'openCreateNewMockModal',
        {
          opts: {
            activeStep: 1,
            from: 'create_new_modal' } },


        null,
        { from: 'create_new_modal' });

        break;}

  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__components_base_XPaths_XPath__["a" /* default */], { identifier: 'createNewXModal', isVisible: this.state.isOpen },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Modals__["a" /* Modal */], {
            className: 'create-new-modal',
            isOpen: this.state.isOpen,
            onRequestClose: this.handleClose,
            customStyles: this.getStyles() },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Modals__["d" /* ModalHeader */], null,
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Tabs__["b" /* Tabs */], {
                type: 'primary',
                defaultActive: NEW,
                activeRef: this.state.activeTab,
                onChange: this.handleTabChange },

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__components_base_XPaths_XPath__["a" /* default */], { identifier: 'createNewTab' }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Tabs__["a" /* Tab */], { refKey: NEW }, 'Create New')),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__components_base_XPaths_XPath__["a" /* default */], { identifier: 'templateTab' }, '  ', __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Tabs__["a" /* Tab */], { refKey: TEMPLATE }, 'Templates')),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__components_base_XPaths_XPath__["a" /* default */], { identifier: 'apiNetworkTab' }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Tabs__["a" /* Tab */], { refKey: API_NETWORK }, 'API Network')))),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Modals__["b" /* ModalContent */], null,
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_9__components_new_button_CreateNewXModal__["a" /* default */], {
              activeTab: this.state.activeTab,
              meta: this.state.meta,
              onSelectCard: this.handleSelectCard,
              onClose: this.handleToggle.bind(this, true),
              onTabChange: this.handleTabChange.bind(this, TEMPLATE) })),



          this.state.activeTab === NEW &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Modals__["c" /* ModalFooter */], null,
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__open' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_Inputs__["a" /* Checkbox */], {
                className: 'create-new-modal__intro__checkbox',
                checked: this.state.showOnStartup,
                onChange: this.handleShowOnStartup }),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { onClick: this.handleShowOnStartup, className: 'create-new-modal__intro__checkbox__text' }, 'Show this window on launch')),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Buttons__["a" /* Button */], {
                type: 'text',
                onClick: __WEBPACK_IMPORTED_MODULE_15__external_navigation_ExternalNavigationService__["a" /* openExternalLink */].bind(this, __WEBPACK_IMPORTED_MODULE_8__constants_AppUrlConstants__["u" /* DOCS */]) }, 'Learn more on Postman Docs')))));








  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4961:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CreateNewXModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__CreateNewXIntro__ = __webpack_require__(4962);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__containers_new_button_CreateNewXTemplateContainer__ = __webpack_require__(4963);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__containers_new_button_CreateNewAPINetworkContainer__ = __webpack_require__(4966);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_XPaths_XPath__ = __webpack_require__(24);




let

CreateNewXModal = class CreateNewXModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__content' },

        this.props.activeTab === 'new' &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_XPaths_XPath__["a" /* default */], { identifier: 'createNewXIntro' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__CreateNewXIntro__["a" /* default */], {
            meta: this.props.meta,
            onSelectCard: this.props.onSelectCard,
            onTabChange: this.props.onTabChange })),




        this.props.activeTab === 'template' &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_XPaths_XPath__["a" /* default */], { identifier: 'template' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__containers_new_button_CreateNewXTemplateContainer__["a" /* default */], {
            meta: this.props.meta,
            onClose: this.props.onClose })),




        this.props.activeTab === 'apiNetwork' &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_XPaths_XPath__["a" /* default */], { identifier: 'apiNetwork' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__containers_new_button_CreateNewAPINetworkContainer__["a" /* default */], {
            meta: this.props.meta,
            onClose: this.props.onClose }))));





  }};

/***/ }),

/***/ 4962:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CreateNewXIntro; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Icons_RequestIcon__ = __webpack_require__(1496);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Icons_CollectionIcon__ = __webpack_require__(958);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Icons_EnvironmentIcon__ = __webpack_require__(969);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_Icons_MockIcon__ = __webpack_require__(960);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_Icons_MonitorIcon__ = __webpack_require__(654);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__base_Icons_PublishIcon__ = __webpack_require__(961);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__base_XPaths_XPath__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__modules_services_AnalyticsService__ = __webpack_require__(16);









let

CreateNewXIntro = class CreateNewXIntro extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.handleOnUseTemplate = this.handleOnUseTemplate.bind(this);
  }

  handleOnUseTemplate() {
    __WEBPACK_IMPORTED_MODULE_9__modules_services_AnalyticsService__["a" /* default */].addEvent('onboarding', 'view_documentation_template');
    this.props.onTabChange();
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__heading' }, 'Building Blocks'),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__cards create-new-modal__intro__cards--basic' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__base_XPaths_XPath__["a" /* default */], { identifier: 'request' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__card create-new-modal__intro__card--request', onClick: this.props.onSelectCard.bind(this, 'request') },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__card__icon' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Icons_RequestIcon__["a" /* default */], {
                  className: 'create-new-modal__intro__card__icon__icon',
                  size: 'lg' })),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__card__content' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__card__title' }, 'Request'),


                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__card__description' }, 'Create a basic request')))),






          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__base_XPaths_XPath__["a" /* default */], { identifier: 'collection' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__card create-new-modal__intro__card--collection', onClick: this.props.onSelectCard.bind(this, 'collection') },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__card__icon' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Icons_CollectionIcon__["a" /* default */], {
                  className: 'create-new-modal__intro__card__icon__icon',
                  size: 'lg' }),

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__card__icon__icon' })),

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__card__content' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__card__title' }, 'Collection'),


                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__card__description' }, 'Save your requests in a collection for reuse and sharing')))),






          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__base_XPaths_XPath__["a" /* default */], { identifier: 'environment' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__card create-new-modal__intro__card--environment', onClick: this.props.onSelectCard.bind(this, 'environment') },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__card__icon' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Icons_EnvironmentIcon__["a" /* default */], {
                  className: 'create-new-modal__intro__card__icon__icon',
                  size: 'lg' })),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__card__content' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__card__title' }, 'Environment'),


                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__card__description' }, 'Save values you frequently use in an environment'))))),







        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__heading' }, 'Advanced'),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__cards create-new-modal__intro__cards--advanced' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__base_XPaths_XPath__["a" /* default */], { identifier: 'documentation' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__card create-new-modal__intro__card--documentation', onClick: this.props.onSelectCard.bind(this, 'documentation') },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__card__icon' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_Icons_PublishIcon__["a" /* default */], {
                  className: 'create-new-modal__intro__card__icon__icon',
                  size: 'lg' })),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__card__content' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__card__title' }, 'API Documentation'),


                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__card__description' }, 'Create and publish beautiful documentation for your APIs')))),






          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__base_XPaths_XPath__["a" /* default */], { identifier: 'mock' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__card create-new-modal__intro__card--mock', onClick: this.props.onSelectCard.bind(this, 'mock') },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__card__icon' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Icons_MockIcon__["a" /* default */], {
                  className: 'create-new-modal__intro__card__icon__icon',
                  size: 'lg' })),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__card__content' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__card__title' }, 'Mock Server'),


                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__card__description' }, 'Create a mock server for your in-development APIs')))),






          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__base_XPaths_XPath__["a" /* default */], { identifier: 'monitor' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__card create-new-modal__intro__card--monitor', onClick: this.props.onSelectCard.bind(this, 'monitor') },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__card__icon' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Icons_MonitorIcon__["a" /* default */], {
                  className: 'create-new-modal__intro__card__icon__icon',
                  size: 'lg' })),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__card__content' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__card__title' }, 'Monitor'),


                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__card__description' }, 'Schedule automated tests and check performance of your APIs'))))),







        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__intro__help' }, 'Not sure where to start? Use a',

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
              type: 'text',
              onClick: this.handleOnUseTemplate }, 'template'), 'to see how Postman can help you in your work.')));







  }};

/***/ }),

/***/ 4963:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CreateNewXTemplateContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_new_button_CreateNewXTemplateList__ = __webpack_require__(4964);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_new_button_CreateNewXTemplateItem__ = __webpack_require__(4965);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_new_button_CreationError__ = __webpack_require__(963);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__modules_services_AnalyticsService__ = __webpack_require__(16);







let

CreateNewXTemplateContainer = class CreateNewXTemplateContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      viewMode: props.meta.viewMode || 'list', // 'list' or 'template',
      activeTemplateId: props.meta.activeTemplateId || null,
      lifecycle: 'view' };


    this.handleViewModeChange = this.handleViewModeChange.bind(this);
    this.handleSelectTemplate = this.handleSelectTemplate.bind(this);
    this.handleUseTemplate = this.handleUseTemplate.bind(this);
    this.handleOfflineRetry = this.handleOfflineRetry.bind(this);
  }

  componentDidMount() {
    pm.mediator.on('changeActiveTemplate', this.handleSelectTemplate);
    __WEBPACK_IMPORTED_MODULE_6__modules_services_AnalyticsService__["a" /* default */].addEvent('onboarding', 'view_use_template_modal');
  }

  componentWillUnmount() {
    pm.mediator.off('changeActiveTemplate', this.handleSelectTemplate);

    let activeCategory = Object(__WEBPACK_IMPORTED_MODULE_2__stores_get_store__["getStore"])('TemplateCategoryStore').activeCategory;
    activeCategory && activeCategory.clearSearch();
  }

  getClasses() {
    return __WEBPACK_IMPORTED_MODULE_1_classnames___default()({
      'create-new-modal__template-wrapper': true });

  }

  handleViewModeChange(viewMode) {
    this.setState({ viewMode });
  }

  handleSelectTemplate(templateId) {
    this.setState({
      viewMode: 'template',
      activeTemplateId: templateId || null });

  }

  handleUseTemplate() {
    if (this.checkOffline()) {
      return;
    }

    let templateId = this.state.activeTemplateId,
    template = Object(__WEBPACK_IMPORTED_MODULE_2__stores_get_store__["getStore"])('TemplateListStore').find(templateId);

    pm.mediator.trigger('showCustomizeTemplateContainer', templateId, null, template.activeVersion);

    __WEBPACK_IMPORTED_MODULE_6__modules_services_AnalyticsService__["a" /* default */].addEvent('template', 'initiate_import', _.snakeCase(template.name));
    this.props.onClose && this.props.onClose();
  }

  checkOffline() {
    return !navigator.onLine;
  }

  handleOfflineRetry() {
    if (this.checkOffline()) {
      return;
    }
  }

  render() {
    let isOffline = this.checkOffline();

    if (isOffline) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: this.getClasses() },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-template__error' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_new_button_CreationError__["a" /* default */], {
              subtitle: 'Please check your internet connection and try again.',
              onRetry: this.handleOfflineRetry }))));




    }

    let templateExists = Object(__WEBPACK_IMPORTED_MODULE_2__stores_get_store__["getStore"])('TemplateListStore').has(this.state.templateId),
    template = templateExists && Object(__WEBPACK_IMPORTED_MODULE_2__stores_get_store__["getStore"])('TemplateListStore').find(this.state.templateId),
    isFailureInTemplate = template && template.lifecycle === 'failure';

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: this.getClasses() },

        this.state.viewMode === 'list' &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_new_button_CreateNewXTemplateList__["a" /* default */], { onSelectTemplate: this.handleSelectTemplate }),


        this.state.viewMode === 'template' && !isFailureInTemplate &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_new_button_CreateNewXTemplateItem__["a" /* default */], {
          templateId: this.state.activeTemplateId,
          onBack: this.handleViewModeChange.bind(this, 'list'),
          onUseTemplate: this.handleUseTemplate }),



        this.state.viewMode === 'template' && isFailureInTemplate &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_new_button_CreationError__["a" /* default */], {
            subtitle: 'Something went wrong while importing this template. You can try again later.' }))));





  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4964:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CreateNewXTemplateList; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Tabs__ = __webpack_require__(103);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Tag__ = __webpack_require__(4013);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_LoadingIndicator__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__empty_states_NoResultFound__ = __webpack_require__(3560);
var _class;






let


CreateNewXTemplateList = Object(__WEBPACK_IMPORTED_MODULE_1_mobx_react__["a" /* observer */])(_class = class CreateNewXTemplateList extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.handleSearch = this.handleSearch.bind(this);
    this.handleScroll = _.debounce(this.handleScroll.bind(this), 300);
    this.handleChangeCategory = this.handleChangeCategory.bind(this);
    this.handleChangeSearchQuery = this.handleChangeSearchQuery.bind(this);

    this.handleSearchDebounced = _.debounce(this.handleSearch, 1000);
  }

  handleScroll(e) {
    if (!this.listNode) {
      return;
    }

    let {
      scrollTop,
      offsetHeight,
      scrollHeight } =
    this.listNode,
    activeCategory = Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('TemplateCategoryStore').activeCategory;

    // Ignore scrolling if the store is already in a loading state
    if (activeCategory.isLoading) {
      return;
    }

    if (scrollTop + offsetHeight >= scrollHeight) {
      activeCategory.loadMore();
    }
  }

  handleChangeCategory(categoryId) {
    this.listNode && (this.listNode.scrollTop = 0);
    Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('TemplateCategoryStore').changeCategory(categoryId);
  }

  handleSearch() {
    Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('TemplateCategoryStore').activeCategory.search();
  }

  handleTemplateSelect(templateId) {
    this.props.onSelectTemplate(templateId);

    let selectedTemplate = Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('TemplateListStore').find(templateId);

    selectedTemplate && selectedTemplate.populate();
  }

  handleChangeSearchQuery(searchQuery) {
    Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('TemplateCategoryStore').
    activeCategory.
    updateSearchQuery(searchQuery);

    this.handleSearchDebounced();
  }

  render() {
    let TemplateCategoryStore = Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('TemplateCategoryStore');

    if (TemplateCategoryStore.isLoading) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__templates__loader' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_LoadingIndicator__["a" /* default */], null)));


    }

    let categories = TemplateCategoryStore.categories,
    activeCategory = TemplateCategoryStore.activeCategory,
    templates = activeCategory ? activeCategory.templates : [],
    searchQuery = activeCategory.searchQuery,
    sortedCategories = _.sortBy(categories, category => {
      if (category.id === 'all') {
        return `0-${category.name}`;
      }
      return `1-${category.name}`;
    });

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__templates templates' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__templates__sidebar' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__templates__sidebar__title' }, 'Categories'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Tabs__["b" /* Tabs */], {
              type: 'primary',
              vertical: true,
              defaultActive: 'All',
              activeRef: TemplateCategoryStore.activeCategoryId,
              onChange: this.handleChangeCategory },


            _.map(sortedCategories, category => {
              return (
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Tabs__["a" /* Tab */], {
                    key: category.id,
                    refKey: category.id },

                  category.name));


            }))),




        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__templates__content' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__templates__search' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Inputs__["b" /* Input */], {
              placeholder: 'Search',
              inputStyle: 'search',
              onChange: this.handleChangeSearchQuery,
              query: searchQuery })),



          _.isEmpty(templates) &&
          !activeCategory.isLoading ?
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__empty_states_NoResultFound__["a" /* default */], null)) :

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
              className: 'create-new-modal__templates__template-list',
              onScroll: this.handleScroll,
              ref: list => this.listNode = list },


            _.map(templates, template => {
              let tagName = _.get(_.find(template.tags, { visible: true }), 'name', null);

              return (
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
                    className: 'create-new-modal__template-card',
                    onClick: this.handleTemplateSelect.bind(this, template.id),
                    key: template.id },

                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__template-card__title-wrapper' },
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'create-new-modal__template-card__title' }, template.name),

                    tagName &&
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Tag__["a" /* default */], {
                      tagName: tagName })),



                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'create-new-modal__template-card__description' }, template.summary),
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'create-new-modal__template-card__downloads' }, 'Imports:\xA0',

                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'create-new-modal__template-card__downloads-count' },
                      _.get(template, 'metrics.0.runCount', 0)))));




            }),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__templates__template-list__load-more' },

              activeCategory && activeCategory.isLoading &&
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__templates__loader' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_LoadingIndicator__["a" /* default */], null)))))));










  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4965:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CreateNewXTemplateItem; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Dropdowns__ = __webpack_require__(31);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_Markdown__ = __webpack_require__(173);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__base_LoadingIndicator__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__base_Icons_LeftSolidIcon__ = __webpack_require__(367);
var _class;








let


CreateNewXTemplateItem = Object(__WEBPACK_IMPORTED_MODULE_1_mobx_react__["a" /* observer */])(_class = class CreateNewXTemplateItem extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.handleActiveVersionChange = this.handleActiveVersionChange.bind(this);
  }

  getContentClasses(isLoading) {
    return __WEBPACK_IMPORTED_MODULE_2_classnames___default()({
      'create-new-modal__template__content': true,
      'is-loading': isLoading });

  }

  handleActiveVersionChange(activeVersion) {
    let template = Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('TemplateListStore').find(this.props.templateId);
    template && template.changeActiveVersion(activeVersion);
  }

  render() {
    let template = Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('TemplateListStore').find(this.props.templateId),
    isLoading = template.isLoading,
    activeVersion = template.activeVersion,
    activeVersionApiName = _.get(_.filter(template.versionTags, { versionTag: activeVersion }), '[0].apiName'),
    downloadCount = _.get(template, 'metrics.0.runCount', 0),
    description = _.get(template, 'description', ''),
    summary = _.get(template, 'summary', '');

    // Show version dropdown only if it has multiple versions
    const showVersionDropdown = !isLoading && _.get(template, 'versionTags.length') > 1;

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__template' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: this.getContentClasses(isLoading) },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Buttons__["a" /* Button */], {
              type: 'text',
              className: 'create-new-modal__template__back-btn',
              onClick: this.props.onBack },

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__base_Icons_LeftSolidIcon__["a" /* default */], { className: 'create-new-modal__template__back-icon', style: 'secondary' }),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Back to all templates')),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__flex__content' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__template__title' },
              _.get(template, 'name', '')),


            showVersionDropdown &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Dropdowns__["a" /* Dropdown */], {
                className: 'create-new-modal__template__version',
                onSelect: this.handleActiveVersionChange },

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Dropdowns__["b" /* DropdownButton */], {
                  size: 'small',
                  type: 'secondary' },

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Buttons__["a" /* Button */], null,
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'create-new-modal__template__version-name' }, activeVersionApiName))),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Dropdowns__["c" /* DropdownMenu */], { fluid: true },
                _.map(template.versionTags, (versionTag, key) => {
                  return (
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Dropdowns__["d" /* MenuItem */], { refKey: versionTag.versionTag, key: key },
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { title: versionTag.apiName }, versionTag.apiName)));


                })))),





          isLoading &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_LoadingIndicator__["a" /* default */], { className: 'create-new-modal__template__loading' }),


          !isLoading && summary &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__template__summary' },
            summary),



          !isLoading && description &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__template__description' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Markdown__["a" /* default */], { source: description }))),



        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__template__info' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Buttons__["a" /* Button */], {
              type: 'primary',
              className: 'run-in-postman',
              onClick: this.props.onUseTemplate },

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'arrow' }, '\u25B6'),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Run In Postman')),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__template__info__categories' }, 'Categories',

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__template__info__categories--names' },
              _.map(template.categories, 'name').join(', '))),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__template__info__download' }, 'Imports',

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__template__info__download-count' },
              downloadCount)))));





  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4966:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CreateNewAPINetworkContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__modules_controllers_APINetworkController__ = __webpack_require__(553);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_new_button_CreateNewAPINetworkList__ = __webpack_require__(4967);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_new_button_CreateNewAPINetworkItem__ = __webpack_require__(4968);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_new_button_CreationError__ = __webpack_require__(963);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__components_new_button_DisabledOperationModal__ = __webpack_require__(3675);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9_mobx_react__ = __webpack_require__(11);
var _class;









let


CreateNewAPINetworkContainer = Object(__WEBPACK_IMPORTED_MODULE_9_mobx_react__["a" /* observer */])(_class = class CreateNewAPINetworkContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      viewMode: props.meta.viewMode || 'list', // 'list' or 'team',
      activeTeamId: props.meta.teamId || '' };


    this.handleViewModeChange = this.handleViewModeChange.bind(this);
    this.handleSelectTeam = this.handleSelectTeam.bind(this);
    this.handleOfflineRetry = this.handleOfflineRetry.bind(this);
    this.handleRunInPostman = this.handleRunInPostman.bind(this);
  }

  componentDidMount() {
    __WEBPACK_IMPORTED_MODULE_8__modules_services_AnalyticsService__["a" /* default */].addEvent('onboarding', 'view_api_network_modal', '');
  }

  componentWillUnmount() {
    let activeCategory = Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('APINetworkCategoryStore').activeCategory;
    activeCategory && activeCategory.clearSearch();
  }

  handleSelectTeam(teamId, teamName) {
    this.setState({
      activeTeamId: teamId,
      viewMode: 'team' });


    __WEBPACK_IMPORTED_MODULE_8__modules_services_AnalyticsService__["a" /* default */].addEvent('onboarding', 'view_api_network_publisher', _.snakeCase(teamName));
  }

  handleRunInPostman(linkId, onSuccess, onError) {
    let currentUser = Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('CurrentUserStore');

    if (!(currentUser && currentUser.isLoggedIn)) {
      return;
    }
    __WEBPACK_IMPORTED_MODULE_2__modules_controllers_APINetworkController__["b" /* default */].onRunInPostman(linkId, onSuccess, onError);
  }

  handleViewModeChange(viewMode) {
    this.setState({ viewMode });
  }

  handleOfflineRetry() {
    let isOffline = !navigator.onLine;
    if (isOffline) {
      return;
    }

    if (this.state.viewMode === 'team') {
      Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('APINetworkTeamStore').find(this.state.activeTeamId).populate();
      this.handleSelectTeam(this.state.activeTeamId);
    }
  }

  render() {
    let currentUser = Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('CurrentUserStore'),
    isOffline = !navigator.onLine;

    if (isOffline) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__template-wrapper' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-template__error' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_new_button_CreationError__["a" /* default */], {
              subtitle: 'Please check your internet connection and try again.',
              onRetry: this.handleOfflineRetry }))));




    }

    if (!(currentUser && currentUser.isLoggedIn) && this.state.viewMode === 'team') {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__template-wrapper' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_new_button_DisabledOperationModal__["a" /* default */], {
            isSyncEnabled: true,
            isLoggedIn: currentUser.isLoggedIn,
            entity: 'apiNetwork' })));



    }

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__template-wrapper' },

        this.state.viewMode === 'list' &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_new_button_CreateNewAPINetworkList__["a" /* default */], { onSelectTeam: this.handleSelectTeam }),


        this.state.viewMode === 'team' &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_new_button_CreateNewAPINetworkItem__["a" /* default */], {
          teamId: this.state.activeTeamId,
          onBack: this.handleViewModeChange.bind(this, 'list'),
          onRunInPostman: this.handleRunInPostman })));




  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4967:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CreateNewAPINetworkList; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Tabs__ = __webpack_require__(103);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_LoadingIndicator__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__empty_states_NoResultFound__ = __webpack_require__(3560);
var _class;







let


CreateNewAPINetworkList = Object(__WEBPACK_IMPORTED_MODULE_1_mobx_react__["a" /* observer */])(_class = class CreateNewAPINetworkList extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.handleSearch = this.handleSearch.bind(this);
    this.handleScroll = _.debounce(this.handleScroll.bind(this), 300);
    this.handleChangeCategory = this.handleChangeCategory.bind(this);
    this.handleChangeSearchQuery = this.handleChangeSearchQuery.bind(this);

    this.handleSearchDebounced = _.debounce(this.handleSearch, 1000);
  }

  handleScroll(e) {
    if (!this.listNode) {
      return;
    }
    let {
      scrollTop,
      offsetHeight,
      scrollHeight } =
    this.listNode,
    activeCategory = Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('APINetworkCategoryStore').activeCategory;

    // Ignore scrolling if the store is already in a loading state
    if (activeCategory.isLoading) {
      return;
    }

    if (scrollTop + offsetHeight >= scrollHeight) {
      Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('APINetworkCategoryStore').activeCategory.loadMore();
    }
  }

  handleChangeCategory(categoryId) {
    this.listNode && (this.listNode.scrollTop = 0);
    Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('APINetworkCategoryStore').changeCategory(categoryId);
  }

  async handleSelectTeam(teamId) {
    let isOffline = !navigator.onLine;

    if (isOffline) {
      return;
    }

    let teamName = _.get(Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('APINetworkTeamStore').find(teamId), 'name');
    Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('APINetworkCategoryStore').activeCategory.populateTeam(teamId);

    this.props.onSelectTeam(teamId, teamName);
  }

  handleSearch() {
    Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('APINetworkCategoryStore').activeCategory.search();
  }

  handleChangeSearchQuery(searchQuery) {
    Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('APINetworkCategoryStore').
    activeCategory.
    updateSearchQuery(searchQuery);

    this.handleSearchDebounced();
  }

  render() {
    let APINetworkCategoryStore = Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('APINetworkCategoryStore');

    if (APINetworkCategoryStore.isLoading) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__templates__loader' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_LoadingIndicator__["a" /* default */], null)));


    }

    let categories = APINetworkCategoryStore.categories,
    activeCategory = APINetworkCategoryStore.activeCategory,
    teams = activeCategory ? activeCategory.teams : [],
    searchQuery = activeCategory.searchQuery,
    sortedCategories = _.sortBy(categories, category => {
      if (category.id === 'all') {
        return `0-${category.name}`;
      }
      return `1-${category.name}`;
    });

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__templates api-networks' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__templates__sidebar' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__templates__sidebar__title' }, 'Categories'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Tabs__["b" /* Tabs */], {
              type: 'primary',
              vertical: true,
              defaultActive: 'All',
              activeRef: APINetworkCategoryStore.activeCategoryId,
              onChange: this.handleChangeCategory },


            _.map(sortedCategories, category => {
              return (
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Tabs__["a" /* Tab */], { key: category.id, refKey: category.id },
                  category.name));


            }))),



        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__templates__content' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__templates__search' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Inputs__["b" /* Input */], {
              placeholder: 'Search',
              inputStyle: 'search',
              onChange: this.handleChangeSearchQuery,
              query: searchQuery })),



          _.isEmpty(teams) &&
          !(activeCategory && activeCategory.isLoading) ?
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__empty_states_NoResultFound__["a" /* default */], null)) :

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
              className: 'create-new-modal__templates__template-list',
              onScroll: this.handleScroll,
              ref: list => this.listNode = list },


            _.map(teams, team => {
              return (
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
                    className: 'create-new-modal__template-card',
                    onClick: this.handleSelectTeam.bind(this, team.id),
                    key: team.id },

                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'api-network__label__wrapper' },
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'api-network__icon__wrapper' }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('img', { src: team.profileURL, height: '30px', width: '30px' })),
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'create-new-modal__template-card__title' }, team.name)),

                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'create-new-modal__template-card__description' }, team.description)));


            }),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__templates__template-list__load-more' },

              activeCategory && activeCategory.isLoading &&
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__templates__loader' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_LoadingIndicator__["a" /* default */], null)))))));









  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4968:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CreateNewAPINetworkItem; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Dropdowns__ = __webpack_require__(31);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Icons_LeftSolidIcon__ = __webpack_require__(367);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_Icons_CollectionIcon__ = __webpack_require__(958);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_Markdown__ = __webpack_require__(173);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__utils_util__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__base_LoadingIndicator__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__external_navigation_ExternalNavigationService__ = __webpack_require__(59);
var _class;











let

CreateNewAPINetworkItem = Object(__WEBPACK_IMPORTED_MODULE_1_mobx_react__["a" /* observer */])(_class = class CreateNewAPINetworkItem extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.state = { loadingButtonIndex: null };
    this.openPublisherDocs = this.openPublisherDocs.bind(this);
    this._renderRunButtons = this._renderRunButtons.bind(this);
  }

  handleRunInPostman(team, linkId, buttonId) {
    this.setState({ loadingButtonIndex: buttonId });
    this.trackInitiateImport(team, buttonId);
    this.props.onRunInPostman(linkId, () => {
      this.setState({ loadingButtonIndex: null });
    }, () => {
      this.setState({ loadingButtonIndex: null });
    });
  }

  trackInitiateImport(team, buttonId) {
    let teamName = team.name;
    let collectionName = team.runButtons[buttonId].collectionName;
    __WEBPACK_IMPORTED_MODULE_9__modules_services_AnalyticsService__["a" /* default */].addEvent('api_network', 'initiate_import', `${_.snakeCase(teamName)}__${_.snakeCase(collectionName)}`);
  }

  getEnvironment(runButton) {
    if (!runButton.environment) {
      return __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'environment-empty' }, 'No Environment');
    }
    return __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'environment-name' }, _.truncate(runButton.environmentName, { length: 40 }));
  }

  openPublisherDocs(team) {
    Object(__WEBPACK_IMPORTED_MODULE_11__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(team.link);
    __WEBPACK_IMPORTED_MODULE_9__modules_services_AnalyticsService__["a" /* default */].addEvent('api_network', 'view_documentation_link', _.snakeCase(team.name));
  }

  handleVersionChange(runButtonId, activeVersion) {
    let team = Object(__WEBPACK_IMPORTED_MODULE_10__stores_get_store__["getStore"])('APINetworkTeamStore').find(this.props.teamId);
    team && team.changeActiveVersion(runButtonId, activeVersion);
  }

  _renderRunButtons(team) {
    if (team.isLoading) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__base_LoadingIndicator__["a" /* default */], null));

    }

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__run__buttons' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__run__buttons__label' }, 'Available Collections'),

        _.map(team.runButtons, (runButton, index) => {

          // Show version dropdown only if it has multiple versions
          const showRunButtonVersions = _.get(runButton, 'versionTags.length') > 1;

          let activeVersion = _.get(team.activeVersions, [runButton.id]),
          activeVersionRunButton = _.find(runButton.versionTags, { versionTag: activeVersion });

          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
                className: 'create-new-modal__run__button__wrapper',
                key: index },

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__run__button__content-title-container' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__run__button__name' },
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Icons_CollectionIcon__["a" /* default */], { className: 'api-network__icon--collection' }),
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, _.truncate(_.get(runButton, 'collectionName'), { length: 40 }))),

                  showRunButtonVersions &&
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Dropdowns__["a" /* Dropdown */], {
                      className: 'create-new-modal__run__button__version',
                      onSelect: this.handleVersionChange.bind(this, _.get(runButton, 'id')) },

                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Dropdowns__["b" /* DropdownButton */], {
                        size: 'small',
                        type: 'secondary' },

                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], null,
                        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'create-new-modal__run__button__version-name' },
                          _.get(activeVersionRunButton, 'apiName')))),



                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Dropdowns__["c" /* DropdownMenu */], { fluid: true },
                      _.map(runButton.versionTags, (versionTag, key) => {
                        return (
                          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Dropdowns__["d" /* MenuItem */], { refKey: versionTag.versionTag, key: key },
                            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { title: versionTag.apiName }, versionTag.apiName)));


                      })))),




                this.getEnvironment(runButton),
                _.get(runButton, 'summary') &&
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'create-new-modal__run__button__summary' },
                  _.get(runButton, 'summary'))),




              this.state.loadingButtonIndex === index ?

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
                  type: 'primary',
                  className: 'run-in-postman' },

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__base_LoadingIndicator__["a" /* default */], null)) :



              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
                  type: 'primary',
                  className: 'run-in-postman',
                  onClick: this.handleRunInPostman.bind(this, team, _.get(activeVersionRunButton, 'runButtonId'), index) },

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'arrow' }, '\u25B6'),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Run In Postman'))));





        })));



  }

  render() {
    let team = Object(__WEBPACK_IMPORTED_MODULE_10__stores_get_store__["getStore"])('APINetworkTeamStore').find(this.props.teamId);

    if (!team) {
      return false;
    }

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__template api-network' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__template__content' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
              type: 'text',
              className: 'create-new-modal__template__back-btn',
              onClick: this.props.onBack },

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Icons_LeftSolidIcon__["a" /* default */], { className: 'create-new-modal__template__back-icon', style: 'secondary' }),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Back to API Network')),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__template__title' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'api-network__icon__wrapper' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('img', { src: team.profileURL, height: '50px', width: '50px' })),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, team.name)),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-modal__template__description' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, team.description, ' '),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
                type: 'text',
                className: 'learn-more-link',
                onClick: this.openPublisherDocs.bind(this, team) },

              team.linkText || '')),



          this._renderRunButtons(team))));




  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4969:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CreateNewMonitorModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_moment_timezone__ = __webpack_require__(1015);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_moment_timezone___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_moment_timezone__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_postman_collection__ = __webpack_require__(74);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_postman_collection___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_postman_collection__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_base_Tabs__ = __webpack_require__(103);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__services_VersionTagService__ = __webpack_require__(984);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__services_MonitorRegionsService__ = __webpack_require__(1629);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__utils_util__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__utils_httpstatuscodes__ = __webpack_require__(974);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__components_new_button_CreateNewMonitorModal__ = __webpack_require__(4970);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__modules_model_event__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__modules_controllers_UserController__ = __webpack_require__(39);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__modules_controllers_CollectionController__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__modules_services_SyncChangesetEventService__ = __webpack_require__(1529);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_20__models_services_DashboardService__ = __webpack_require__(309);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_21__components_base_Icons_SuccessIcon__ = __webpack_require__(312);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_22__components_base_XPaths_XPath__ = __webpack_require__(24);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _class;




























let getAllStatusList = () => {
  return _.reduce(__WEBPACK_IMPORTED_MODULE_12__utils_httpstatuscodes__["a" /* default */], (acc, obj, key) => {
    acc.push({ value: `${key} ${obj.name}` });
    return acc;
  }, []);
};

let initialState = {
  monitorId: '',
  isOpen: false,
  activeStep: 1,
  activeSource: 'new',
  isLoadingVersions: false,
  isLoadingRegions: false,
  errorFetchingRegions: false,
  errorFetchingVersions: false,
  ownCollections: [],
  ownEnvironments: [],
  ownVersions: [],
  availableRegions: [],
  selectedOptions: {
    name: '',
    requests: [],
    tests: [{
      name: 'Check Response code',
      code: 'pm.response.to.have.status({{variable}});',
      enabled: true,
      suggestions: getAllStatusList(),
      type: 'number',
      placeholder: 'Enter response code' },
    {
      name: 'Check Response time',
      code: 'pm.expect(pm.response.responseTime).to.be.below({{variable}});',
      enabled: true,
      postfix: 'ms',
      type: 'number',
      placeholder: 'Enter response time' }],

    collectionId: '',
    ownerId: '',
    environmentId: '',
    versionId: null,
    schedule: '0 0 0 * * *',
    regions: [] },

  from: 'create_new_x',
  monitorStatus: {
    loading: true,
    error: false },

  collectionStatus: {
    loading: true,
    error: false },

  userStatus: {
    isSyncEnabled: false,
    isLoggedIn: false },

  saveToActivity: false,
  workspaceId: null,
  notifications: {
    enabled: false,
    recipients: [] // TODO:: Add the guy's name in here by default
  },
  followRedirects: true,
  strictSSL: true,
  requestTimeout: {
    enabled: false,
    timeout: 5000 },

  requestDelay: {
    enabled: false,
    delay: 0 } };let




CreateNewMonitorModalContainer = Object(__WEBPACK_IMPORTED_MODULE_1_mobx_react__["a" /* observer */])(_class = class CreateNewMonitorModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = initialState;

    this.loadWorkspaceCollections = this.loadWorkspaceCollections.bind(this);
    this.loadOwnEnvironments = this.loadOwnEnvironments.bind(this);
    this.loadOwnVersions = this.loadOwnVersions.bind(this);
    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleChangeSource = this.handleChangeSource.bind(this);

    this.handleSelectCollection = this.handleSelectCollection.bind(this);
    this.handleSelectEnvironment = this.handleSelectEnvironment.bind(this);
    this.handleTestToggle = this.handleTestToggle.bind(this);
    this.handleRequestChange = this.handleRequestChange.bind(this);
    this.handleSelectVersion = this.handleSelectVersion.bind(this);
    this.handleMonitorNameChange = this.handleMonitorNameChange.bind(this);
    this.handleMonitorScheduleChange = this.handleMonitorScheduleChange.bind(this);
    this.handleRegionChange = this.handleRegionChange.bind(this);
    this.handleCreate = this.handleCreate.bind(this);
    this.handleOfflineRetry = this.handleOfflineRetry.bind(this);
    this.handleVersionFetchRetry = this.handleVersionFetchRetry.bind(this);
    this.handleRetry = this.handleRetry.bind(this);
    this.handleBack = this.handleBack.bind(this);

    this.constructCollection = this.constructCollection.bind(this);
    this.constructMonitor = this.constructMonitor.bind(this);

    this.handleNotificationChange = this.handleNotificationChange.bind(this);
    this.handleTimeoutChange = this.handleTimeoutChange.bind(this);
    this.handleDelayChange = this.handleDelayChange.bind(this);
    this.handleStrictSSLChange = this.handleStrictSSLChange.bind(this);
    this.handleRedirectChange = this.handleRedirectChange.bind(this);
    this.handleOpenMonitor = this.handleOpenMonitor.bind(this);
  }

  handleNotificationChange(enabled, recipientIndex, recipient) {
    if (_.isUndefined(recipientIndex)) {
      this.setState({ notifications: { enabled, recipients: this.state.notifications.recipients } });
      return;
    }
    let recipients = [
    ..._.slice(this.state.notifications.recipients, 0, recipientIndex),
    recipient,
    ..._.slice(this.state.notifications.recipients, recipientIndex + 1)];


    recipients = _.compact(recipients);

    this.setState({
      notifications: {
        enabled,
        recipients } });


  }

  handleTimeoutChange(enabled, timeout = this.state.requestTimeout.timeout) {
    this.setState({
      requestTimeout: {
        enabled,
        timeout } });


  }

  handleDelayChange(enabled, delay = this.state.requestDelay.delay) {
    this.setState({
      requestDelay: {
        enabled,
        delay } });


  }

  handleStrictSSLChange(value) {
    this.setState({ strictSSL: !value });
  }

  handleRedirectChange(value) {
    this.setState({ followRedirects: !value });
  }

  componentDidMount() {
    pm.mediator.on('openCreateNewMonitorModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('openCreateNewMonitorModal', this.handleOpen);
  }

  getStyles() {
    return {
      marginTop: '10vh',
      height: '75vh',
      minWidth: '900px',
      width: '80vw' };

  }

  loadWorkspaceCollections() {
    let editableCollections = Object(__WEBPACK_IMPORTED_MODULE_16__stores_get_store__["getStore"])('ActiveWorkspaceStore').editableCollections;
    this.setState({ ownCollections: editableCollections });
  }

  loadOwnEnvironments() {
    let ownEnvironments = Object(__WEBPACK_IMPORTED_MODULE_16__stores_get_store__["getStore"])('ActiveWorkspaceStore').environments,
    sortedEnvironments = _.sortBy(ownEnvironments, environment => {
      return environment.name.toLowerCase();
    }),
    allEnvironments = _.concat({ id: null, name: 'No Environment' }, sortedEnvironments);

    this.setState({ ownEnvironments: allEnvironments });
  }

  loadOwnVersions(criteria) {
    return Object(__WEBPACK_IMPORTED_MODULE_9__services_VersionTagService__["a" /* fetchAllTags */])(criteria);
  }

  handleClose() {
    this.handleSaveToActivity();
    this.setState(_extends({},
    initialState, {
      isOpen: false }));

    this.onSuccess = null;
    this.disposer && this.disposer();
  }

  handleSaveToActivity() {
    if (!this.state.saveToActivity) {
      return;
    }
    let options = _.pick(this.state.selectedOptions, ['name', 'collectionId', 'environmentId']);
    let metaObj = {
      activeSource: this.state.activeSource,
      collectionStatus: this.state.collectionStatus,
      monitorStatus: this.state.monitorStatus,
      selectedOptions: options };

    pm.mediator.trigger('saveXFlowActivity', 'monitor', metaObj);
  }

  handleOpen(openState = {}, onSuccess) {
    if (this.state.isOpen) {
      return;
    }

    let shouldLoadVersions = _.get(openState, 'selectedOptions.collectionId'),
    defaultSelectedRegions = [];

    this.setState(_extends({},
    initialState,
    openState, {
      selectedOptions: _extends({},
      initialState.selectedOptions,
      openState.selectedOptions),

      availableRegions: [],
      isOpen: true,
      isLoadingRegions: true,
      isLoadingVersions: shouldLoadVersions }),
    () => {
      __WEBPACK_IMPORTED_MODULE_8__modules_services_AnalyticsService__["a" /* default */].addEvent('monitor', 'initiate_create', this.state.from);
    });

    Object(__WEBPACK_IMPORTED_MODULE_10__services_MonitorRegionsService__["a" /* fetchAvailableRegions */])().
    then(regions => {
      defaultSelectedRegions.push(_.get(_.find(regions, { default: true }), 'id'));

      this.setState({
        availableRegions: regions,
        isLoadingRegions: false,
        selectedOptions: _extends({},
        this.state.selectedOptions, {
          regions: defaultSelectedRegions }) });


    }).
    catch(err => {
      this.setState({ isLoadingRegions: false, errorFetchingRegions: true });
      pm.toasts.error(_.get(err, 'message') || 'Error occured while fetching regions');
    });

    if (shouldLoadVersions) {
      this.loadOwnVersions({ collectionUid: `${_.get(openState, 'selectedOptions.ownerId')}-${_.get(openState, 'selectedOptions.collectionId')}` }).
      then(versions => {
        this.setState(_extends({},
        initialState,
        openState, {
          ownVersions: versions,
          isLoadingVersions: false,
          selectedOptions: _extends({},
          this.state.selectedOptions, {
            versionId: _.get(versions, '0.id') }),

          isOpen: true }));

      }).
      catch(err => {
        this.setState({ isLoadingVersions: false, errorFetchingVersions: true });
        pm.toasts.error(_.get(err, 'message') || 'Error occured while fetching versions');
      });
    }

    this.onSuccess = onSuccess;
  }

  handleChangeSource(activeSource) {
    this.setState({ activeSource }, () => {
      if (this.state.activeSource === 'workspace') {
        this.loadWorkspaceCollections();
      }
    });
  }

  handleSelectVersion(versionId) {
    this.setState(state => {
      return {
        selectedOptions: _extends({},
        state.selectedOptions, {
          versionId }) };


    });
  }

  handleSelectCollection(collection) {
    let newState = {},
    defaultSelectedRegions = [];
    switch (this.state.activeSource) {
      case 'new':
        newState = {
          selectedOptions: _extends({},
          this.state.selectedOptions, {
            collectionId: '' }) };


        break;
      case 'workspace':
        newState = {
          selectedOptions: _extends({},
          this.state.selectedOptions, {
            collectionId: collection.id,
            name: collection.name + ' 1',
            ownerId: collection.owner }) };


        break;}


    this.setState({ isLoadingRegions: true });

    Object(__WEBPACK_IMPORTED_MODULE_10__services_MonitorRegionsService__["a" /* fetchAvailableRegions */])().
    then(regions => {
      defaultSelectedRegions.push(_.get(_.find(regions, { default: true }), 'id'));

      this.setState(_extends({},
      newState, {
        availableRegions: regions,

        selectedOptions: _extends({},
        this.state.selectedOptions, {
          regions: defaultSelectedRegions }),

        isLoadingRegions: false }),
      () => {
        this.refs.content.onCollectionSelect && this.refs.content.onCollectionSelect();
      });
    }).
    catch(err => {
      this.setState({ isLoadingRegions: false, errorFetchingRegions: true });
      pm.toasts.error(_.get(err, 'message') || 'Error occured while fetching regions');
    });

    this.loadOwnEnvironments();

    // check for collection uid for fetching versions
    if (collection.uid) {
      this.setState(_extends({ activeStep: 2, isLoadingVersions: true }, newState));
      this.loadOwnVersions({ collectionUid: collection.uid }).
      then(versions => {
        this.setState(_extends({},
        newState, {
          selectedOptions: _extends({},
          this.state.selectedOptions, {
            versionId: _.get(versions, '0.id') }),

          isLoadingVersions: false,
          ownVersions: versions }),
        () => {
          this.refs.content.onCollectionSelect && this.refs.content.onCollectionSelect();
        });
      }).
      catch(err => {
        this.setState({ isLoadingVersions: false, errorFetchingVersions: true });
        pm.toasts.error(_.get(err, 'message') || 'Error occured while fetching versions');
      });
    } else
    {
      this.setState(_extends({},
      newState, {
        activeStep: 2,
        isLoadingVersions: false }),
      () => {
        this.refs.content.onCollectionSelect && this.refs.content.onCollectionSelect();
      });
    }
  }

  handleSelectEnvironment(environmentId) {
    this.setState(state => {
      return {
        selectedOptions: _extends({},
        state.selectedOptions, {
          environmentId }) };


    });
  }

  handleTestToggle(index, enabled) {
    this.setState(state => {
      let newTests = state.selectedOptions.tests;
      newTests[index].enabled = enabled;

      return {
        selectedOptions: _extends({},
        state.selectedOptions, {
          tests: newTests }) };


    });
  }

  handleRequestChange(requests) {
    this.setState(state => {
      let newRequests = _.map(requests, request => {
        return {
          url: request.url,
          method: request.method,
          body: request.body,
          description: request.description,
          tests: [
          parseInt(request.testResponseCode),
          parseInt(request.testResponseTime)] };


      });

      return {
        selectedOptions: _extends({},
        state.selectedOptions, {
          requests: newRequests }) };


    });
  }

  handleMonitorNameChange(name) {
    this.setState(state => {
      return {
        selectedOptions: _extends({},
        state.selectedOptions, {
          name }) };


    });
  }

  handleMonitorScheduleChange(schedule) {
    this.setState(state => {
      return {
        selectedOptions: _extends({},
        state.selectedOptions, {
          schedule }) };


    });
  }

  handleRegionChange(regionName) {
    let regions = this.state.selectedOptions.regions;

    if (_.includes(regions, regionName)) {
      _.remove(regions, r => {return r === regionName;});
    } else
    {
      regions.push(regionName);
    }

    this.setState(state => {
      return {
        selectedOptions: _extends({},
        state.selectedOptions, {
          regions }) };


    });
  }

  handleCreate() {
    if (!Object(__WEBPACK_IMPORTED_MODULE_16__stores_get_store__["getStore"])('SyncStatusStore').isSocketConnected) {
      pm.toasts.error('Unable to create monitor');
      this.setState({ isOffline: true });
      return;
    }

    if (_.isEmpty(this.state.selectedOptions.name) || _.isEmpty(this.state.selectedOptions.regions)) {
      return;
    }

    if (_.isEmpty(this.state.selectedOptions.collectionId)) {
      this.constructCollection(collectionId => {
        this.disposer = Object(__WEBPACK_IMPORTED_MODULE_19__modules_services_SyncChangesetEventService__["a" /* onChangesetResponse */])({
          model: 'collection',
          action: 'import',
          modelId: collectionId },
        err => {
          this.disposer();
          if (err) {
            return;
          }

          this.constructMonitor();
        });
      });
    } else
    {
      this.constructMonitor();
    }

    this.setState({ activeStep: 3 });
  }

  handleVersionFetchRetry() {
    this.setState({ isLoadingVersions: true, errorFetchingVersions: false }, () => {
      this.loadOwnVersions({
        collectionUid: `${_.get(this.state, 'selectedOptions.ownerId')}-${_.get(this.state, 'selectedOptions.collectionId')}` }).

      then(versions => {
        this.setState({
          ownVersions: versions,
          isLoadingVersions: false,
          selectedOptions: _extends({},
          this.state.selectedOptions, {
            versionId: _.get(versions, '0.id') }) });


      }).
      catch(err => {
        this.setState({ isLoadingVersions: false, errorFetchingVersions: true });
        pm.toasts.error(_.get(err, 'message') || 'Error occured while fetching versions');
      });
    });
  }

  handleRetry() {
    if (!Object(__WEBPACK_IMPORTED_MODULE_16__stores_get_store__["getStore"])('SyncStatusStore').isSocketConnected) {
      return;
    }

    if (this.state.collectionStatus.error) {
      this.setState({
        collectionStatus: {
          error: false,
          loading: true },

        monitorStatus: {
          error: false,
          loading: true } },

      () => {
        this.constructCollection(collectionId => {
          this.disposer = Object(__WEBPACK_IMPORTED_MODULE_19__modules_services_SyncChangesetEventService__["a" /* onChangesetResponse */])({
            model: 'collection',
            action: 'import',
            modelId: collectionId },
          err => {
            this.disposer();
            if (err) {
              return;
            }

            this.constructMonitor();
          });
        });
      });
    } else
    if (this.state.monitorStatus.error) {
      this.setState({
        monitorStatus: {
          error: false,
          loading: true } },

      () => {
        this.constructMonitor();
      });
    }
  }

  handleBack(activeStep) {
    if (activeStep === 0) {
      this.handleClose();
      return pm.mediator.trigger('openCreateNewXModal');
    }

    this.setState({ activeStep });
  }

  handleOfflineRetry() {
    if (!Object(__WEBPACK_IMPORTED_MODULE_16__stores_get_store__["getStore"])('SyncStatusStore').isSocketConnected) {
      return;
    }

    if (this.state.activeStep === 2) {
      this.handleCreate();
    }
  }

  async constructCollection(callback) {
    let { id: ownerId } = await __WEBPACK_IMPORTED_MODULE_17__modules_controllers_UserController__["a" /* default */].get(),
    collection = {
      name: this.state.selectedOptions.name,
      id: __WEBPACK_IMPORTED_MODULE_11__utils_util__["a" /* default */].guid(),
      owner: ownerId },

    requests = _.map(this.state.selectedOptions.requests,
    request => {
      let tests = _.reduce(request.tests, (acc, test, testIndex) => {
        if (this.state.selectedOptions.tests[testIndex].enabled) {
          acc.push('\t' + _.replace(this.state.selectedOptions.tests[testIndex].code, '{{variable}}', parseInt(test)));
        }
        return acc;
      }, []),

      testCode = _.join([
      'pm.test(\'Some test name\', function () {',
      ...tests,
      '})'],
      '\n');
      return {
        id: __WEBPACK_IMPORTED_MODULE_11__utils_util__["a" /* default */].guid(),
        url: request.url,
        method: request.method,
        data: request.body,
        dataMode: 'raw',
        collection: collection.id,
        name: request.url,
        description: request.description,
        time: new Date().getTime(),
        events: new __WEBPACK_IMPORTED_MODULE_4_postman_collection__["EventList"]({}, [{ listen: 'test', script: testCode || '' }]).toJSON() };

    }),
    order = _.map(requests, 'id');

    _.assign(collection, { requests, order });

    let getOriginMeta = from => {
      if (from.startsWith('history')) {
        return 'history/monitor';
      }

      return from === 'create_new_x' ? 'cnx' : from;
    },
    collectionEvent = Object(__WEBPACK_IMPORTED_MODULE_14__modules_model_event__["a" /* createEvent */])(
    'create_deep',
    'collection',
    { collection },
    null,
    { origin: getOriginMeta(this.state.from) });


    try {
      let response = await Object(__WEBPACK_IMPORTED_MODULE_15__modules_pipelines_user_action__["a" /* default */])(collectionEvent);
      if (!_.isEmpty(_.get(response, 'error'))) {
        pm.logger.error('Error in creating monitor', response.error);
        return;
      }

      this.setState(state => {
        return {
          selectedOptions: _extends({},
          state.selectedOptions, {
            collectionId: collection.id,
            ownerId: collection.owner }),

          collectionStatus: _extends({},
          state.collectionStatus, {
            loading: false,
            error: false }) };


      }, () => {
        callback && callback(collection.id);
      });
    }
    catch (err) {
      pm.logger.error('Error in pipeline for creating monitor', err);
    }
  }

  constructMonitor(callback) {
    let selectedOptions = this.state.selectedOptions;

    return __WEBPACK_IMPORTED_MODULE_18__modules_controllers_CollectionController__["a" /* default */].getCollection({ id: selectedOptions.collectionId }).
    then(({ id, owner }) => {
      __WEBPACK_IMPORTED_MODULE_17__modules_controllers_UserController__["a" /* default */].
      get().
      then(user => {
        let uuid = `${owner}-${id}`,
        userEmail = user.email,
        notificationArray = this.state.notifications.enabled ? _.map(this.state.notifications.recipients, recipient => {
          return {
            type: 'email',
            'address': recipient };

        }) : [];

        // Adding default as user itself
        !_.some(notificationArray, { address: userEmail }) && notificationArray.push({
          type: 'email',
          'address': userEmail });


        let requestBody = {
          name: selectedOptions.name,
          collection: uuid,
          schedule: {
            cronPattern: selectedOptions.schedule,
            timeZone: __WEBPACK_IMPORTED_MODULE_3_moment_timezone___default.a.tz.guess() },

          distribution: _.map(selectedOptions.regions, region => {
            return {
              region,
              runCount: 1 };

          }),
          options: {
            strictSSL: this.state.strictSSL,
            followRedirects: this.state.followRedirects,
            requestTimeout: this.state.requestTimeout.enabled ? parseInt(this.state.requestTimeout.timeout) : null,
            requestDelay: this.state.requestDelay.enabled ? parseInt(this.state.requestDelay.delay) : 0 },

          notifications: {
            onFailure: notificationArray,
            onError: notificationArray } };



        requestBody.versionTag = selectedOptions.versionId === 'latest' ? null : selectedOptions.versionId;

        if (!_.isEmpty(selectedOptions.environmentId)) {
          let environment = Object(__WEBPACK_IMPORTED_MODULE_16__stores_get_store__["getStore"])('EnvironmentStore').find(selectedOptions.environmentId);
          requestBody.environment = environment.uid;
        }

        let monitorCreateEvent = Object(__WEBPACK_IMPORTED_MODULE_14__modules_model_event__["a" /* createEvent */])('create', 'monitor', requestBody);

        Object(__WEBPACK_IMPORTED_MODULE_15__modules_pipelines_user_action__["a" /* default */])(monitorCreateEvent).then(monitorEventResponse => {
          let monitorEvent = Object(__WEBPACK_IMPORTED_MODULE_14__modules_model_event__["b" /* findEvents */])(monitorEventResponse.response, { name: 'created', namespace: 'monitor' }),
          monitor = Object(__WEBPACK_IMPORTED_MODULE_14__modules_model_event__["d" /* getEventData */])(_.head(monitorEvent));
          this.setState(state => {
            return {
              monitorId: monitor && monitor.id,
              monitorStatus: _extends({},
              state.monitorStatus, {
                loading: false,
                error: false }),

              saveToActivity: true };

          }, () => {
            this.onSuccess && this.onSuccess();
            __WEBPACK_IMPORTED_MODULE_8__modules_services_AnalyticsService__["a" /* default */].addEvent('monitor', 'confirm_create', this.state.from);
            pm.mediator.trigger('focusCollectionInSideBar', selectedOptions.collectionId, 'Monitors');
          });
        }).catch(() => {
          this.setState(state => {
            return {
              monitorStatus: _extends({},
              state.monitorStatus, {
                loading: false,
                error: true }) };


          });
        });
      });
    });
  }

  handleOpenMonitor() {
    if (_.isEmpty(this.state.monitorId)) {
      return;
    }

    __WEBPACK_IMPORTED_MODULE_8__modules_services_AnalyticsService__["a" /* default */].addEvent('monitor', 'view_run_details', 'collection_browser');
    Object(__WEBPACK_IMPORTED_MODULE_20__models_services_DashboardService__["l" /* openEntity */])('monitors', this.state.monitorId, Object(__WEBPACK_IMPORTED_MODULE_16__stores_get_store__["getStore"])('ActiveWorkspaceStore').id);
  }

  getStepClasses(step) {
    return __WEBPACK_IMPORTED_MODULE_2_classnames___default()({ 'is-done': this.state.activeStep > step });
  }

  render() {
    let currentUser = Object(__WEBPACK_IMPORTED_MODULE_16__stores_get_store__["getStore"])('CurrentUserStore'),
    isLoggedIn = currentUser && currentUser.isLoggedIn,
    isSyncEnabled = Object(__WEBPACK_IMPORTED_MODULE_16__stores_get_store__["getStore"])('GateKeeperStore').isSyncEnabled,
    isOffline = !Object(__WEBPACK_IMPORTED_MODULE_16__stores_get_store__["getStore"])('SyncStatusStore').isSocketConnected;

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_22__components_base_XPaths_XPath__["a" /* default */], { identifier: 'createMonitorModal', isVisible: this.state.isOpen },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_Modals__["a" /* Modal */], {
            className: 'create-new-monitor-modal',
            isOpen: this.state.isOpen,
            onRequestClose: this.handleClose,
            customStyles: this.getStyles() },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_Modals__["d" /* ModalHeader */], null,
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__components_base_Tabs__["b" /* Tabs */], {
                type: 'primary',
                defaultActive: 1,
                activeRef: this.state.activeStep },

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__components_base_Tabs__["a" /* Tab */], { className: this.getStepClasses(1), refKey: 1 }, this.state.activeStep <= 1 ? '1.' : __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_21__components_base_Icons_SuccessIcon__["a" /* default */], { size: 'xs' }), __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, '\xA0Select requests to monitor')),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__components_base_Tabs__["a" /* Tab */], { className: this.getStepClasses(2), refKey: 2 }, this.state.activeStep <= 2 ? '2.' : __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_21__components_base_Icons_SuccessIcon__["a" /* default */], { size: 'xs' }), __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, '\xA0Configuration')),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__components_base_Tabs__["a" /* Tab */], { className: this.getStepClasses(3), refKey: 3 }, this.state.activeStep <= 3 ? '3.' : __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_21__components_base_Icons_SuccessIcon__["a" /* default */], { size: 'xs' }), __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, '\xA0Next steps')))),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_Modals__["b" /* ModalContent */], { className: `step${this.state.activeStep}` },

            isLoggedIn && isSyncEnabled &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_13__components_new_button_CreateNewMonitorModal__["a" /* default */], {
              ref: 'content',
              activeStep: this.state.activeStep,
              activeSource: this.state.activeSource,
              errorFetchingVersions: this.state.errorFetchingVersions,
              isLoadingVersions: this.state.isLoadingVersions,
              isLoadingRegions: this.state.isLoadingRegions,
              isOffline: isOffline,
              onOfflineRetry: this.handleOfflineRetry,
              onChangeSource: this.handleChangeSource,
              ownCollections: this.state.ownCollections,
              ownEnvironments: this.state.ownEnvironments,
              ownVersions: this.state.ownVersions,
              onSelectCollection: this.handleSelectCollection,
              onSelectEnvironment: this.handleSelectEnvironment,
              onSelectVersion: this.handleSelectVersion,
              selectedOptions: this.state.selectedOptions,

              onTestToggle: this.handleTestToggle,
              onRequestChange: this.handleRequestChange,
              onMonitorNameChange: this.handleMonitorNameChange,
              onMonitorScheduleChange: this.handleMonitorScheduleChange,
              onRegionChange: this.handleRegionChange,
              onCreateMonitor: this.handleCreate,
              onVersionFetchRetry: this.handleVersionFetchRetry,
              onMonitorClick: this.handleOpenMonitor,
              onRetry: this.handleRetry,
              onClose: this.handleClose,

              monitorStatus: this.state.monitorStatus,
              collectionStatus: this.state.collectionStatus,

              notifications: this.state.notifications,
              regions: this.state.availableRegions,
              requestTimeout: this.state.requestTimeout,
              requestDelay: this.state.requestDelay,
              followRedirects: this.state.followRedirects,
              strictSSL: this.state.strictSSL,

              onNotificationChange: this.handleNotificationChange,
              onRequestDelayChange: this.handleDelayChange,
              onRequestTimeoutChange: this.handleTimeoutChange,
              onStrictSSLChange: this.handleStrictSSLChange,
              onFollowRedirectsChange: this.handleRedirectChange })),




          isLoggedIn &&
          isSyncEnabled &&
          !this.state.errorFetchingVersions &&
          !this.state.isLoadingVersions &&
          !this.state.collectionStatus.error &&
          !this.state.monitorStatus.error &&
          !isOffline &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_Modals__["c" /* ModalFooter */], { className: `step${this.state.activeStep}` },

            this.state.activeStep === 1 &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__footer' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_22__components_base_XPaths_XPath__["a" /* default */], { identifier: 'next' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_base_Buttons__["a" /* Button */], {
                    type: 'primary',
                    disabled: _.isEmpty(this.state.selectedOptions.requests) || this.state.activeSource !== 'new',
                    onClick: this.handleSelectCollection }, 'Next')),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_22__components_base_XPaths_XPath__["a" /* default */], { identifier: 'back' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_base_Buttons__["a" /* Button */], {
                    type: 'secondary',
                    onClick: this.handleBack.bind(this, 0) }, 'Back'))),






            this.state.activeStep === 2 &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__footer' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_22__components_base_XPaths_XPath__["a" /* default */], { identifier: 'back' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_base_Buttons__["a" /* Button */], {
                      type: 'secondary',
                      onClick: this.handleBack.bind(this, 1) }, 'Back')),


                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_22__components_base_XPaths_XPath__["a" /* default */], { identifier: 'create' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_base_Buttons__["a" /* Button */], {
                      type: 'primary',
                      disabled: _.isEmpty(this.state.selectedOptions.name) || _.isEmpty(this.state.selectedOptions.regions),
                      onClick: this.handleCreate }, 'Create')))),







            this.state.activeStep === 3 &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__footer' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_22__components_base_XPaths_XPath__["a" /* default */], { identifier: 'close' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_base_Buttons__["a" /* Button */], {
                    type: 'primary',
                    onClick: this.handleClose }, 'Close')))))));









  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4970:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CreateNewMonitorModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Tabs__ = __webpack_require__(103);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_AutoSuggest_AutoSuggestInput__ = __webpack_require__(141);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_Dropdowns__ = __webpack_require__(31);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__base_LoadingIndicator__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__base_Icons_CollectionIcon__ = __webpack_require__(958);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__base_Icons_MonitorIcon__ = __webpack_require__(654);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__monitor_MonitorScheduleSelector__ = __webpack_require__(1536);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__CreationError__ = __webpack_require__(963);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__empty_states_CollectionsEmpty__ = __webpack_require__(3671);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__models_services_DashboardService__ = __webpack_require__(309);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__external_navigation_ExternalNavigationService__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__constants_AppUrlConstants__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__collections_CollectionMetaIcons__ = __webpack_require__(1492);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__collections_CollectionForkLabel__ = __webpack_require__(656);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__postman_data_editor__ = __webpack_require__(3623);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__postman_data_editor___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_19__postman_data_editor__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_20__base_data_editor_RowRenderer__ = __webpack_require__(3770);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_21__base_data_editor_components_DEInputs__ = __webpack_require__(3771);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_22__base_data_editor_components_HeaderActions__ = __webpack_require__(3772);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_23__utils_PluralizeHelper__ = __webpack_require__(533);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_24__utils_httpstatuscodes__ = __webpack_require__(974);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_25__constants_MonitorScheduleConstants__ = __webpack_require__(1630);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_26__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_27__base_XPaths_XPath__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_28__DataEditorRequestMethods__ = __webpack_require__(3773);
var _class;

































let getAllStatusList = () => {
  return _.reduce(__WEBPACK_IMPORTED_MODULE_24__utils_httpstatuscodes__["a" /* default */], (acc, obj, key) => {
    acc.push({ value: `${key} ${obj.name}` });
    return acc;
  }, []);
};let


CreateNewMonitorModal = Object(__WEBPACK_IMPORTED_MODULE_1_mobx_react__["a" /* observer */])(_class = class CreateNewMonitorModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    let DEConfig = {
      columns: [{
        name: 'method',
        type: 'string',
        label: 'Request Method',
        width: 21,
        resize: true,
        default: 'GET',
        renderer: (value, onAction, { isCollapsed, subColumnIndex }, style, cellInfo) => {
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_28__DataEditorRequestMethods__["a" /* default */], { value: value, onChange: value => onAction('edit', { value }) }));

        } },

      {
        name: 'url',
        type: 'string',
        label: 'Request URL',
        width: 37,
        resize: true,
        default: '',
        renderer: (value, onAction, { isCollapsed, subColumnIndex }, style, cellInfo) => {
          let handleChange = value => {
            onAction && onAction(
            'edit',
            { value: value });

          };
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_27__base_XPaths_XPath__["a" /* default */], { identifier: 'url', key: 'url' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_21__base_data_editor_components_DEInputs__["a" /* default */], {
                type: 'autosuggest',
                value: value,
                onAction: handleChange,
                cellInfo: cellInfo,
                placeholder: 'URL' })));



        } },
      {
        name: 'body',
        hidden: true,
        type: 'string',
        label: 'Request Body',
        width: 25,
        resize: true,
        default: '',
        renderer: (value, onAction, { isCollapsed, subColumnIndex }, style, cellInfo) => {
          let handleChange = value => {
            onAction && onAction(
            'edit',
            { value: value });

          };
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_27__base_XPaths_XPath__["a" /* default */], { identifier: 'body', key: 'body' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_21__base_data_editor_components_DEInputs__["a" /* default */], {
                type: 'autosuggest',
                value: value,
                onAction: handleChange,
                cellInfo: cellInfo,
                placeholder: 'Body' })));



        } },
      {
        name: 'description',
        hidden: true,
        type: 'string',
        label: 'Description',
        width: 20,
        resize: true,
        default: '',
        renderer: (value, onAction, { isCollapsed, subColumnIndex }, style, cellInfo) => {
          let handleChange = value => {
            onAction && onAction(
            'edit',
            { value: value });

          };
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_27__base_XPaths_XPath__["a" /* default */], { identifier: 'description', key: 'description' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_21__base_data_editor_components_DEInputs__["a" /* default */], {
                type: 'autosuggest',
                value: value,
                onAction: handleChange,
                cellInfo: cellInfo,
                placeholder: 'Description' })));



        } },
      {
        name: 'testResponseCode',
        type: 'string',
        label: 'Check Status Code',
        width: 21,
        resize: true,
        default: 200,
        renderer: (value, onAction, { isCollapsed, subColumnIndex }, style, cellInfo) => {
          let handleChange = value => {
            onAction && onAction(
            'edit',
            { value: value });

          };

          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_27__base_XPaths_XPath__["a" /* default */], { identifier: 'testResponseCode', key: 'testResponseCode' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_21__base_data_editor_components_DEInputs__["a" /* default */], {
                type: 'number',
                value: value,
                onAction: handleChange,
                cellInfo: cellInfo,
                placeholder: 'Status Code',
                suggestions: getAllStatusList() })));



        } },
      {
        name: 'testResponseTime',
        type: 'number',
        label: 'Check Response Time',
        width: 21,
        resize: true,
        default: 400,
        renderer: (value, onAction, { isCollapsed, subColumnIndex }, style, cellInfo) => {
          let handleChange = value => {
            onAction && onAction(
            'edit',
            { value: value });

          };

          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_27__base_XPaths_XPath__["a" /* default */], { identifier: 'testResponseTime', key: 'testResponseTime' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'data-editor__cell--time' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_21__base_data_editor_components_DEInputs__["a" /* default */], {
                  type: 'number',
                  value: value,
                  onAction: handleChange,
                  cellInfo: cellInfo,
                  placeholder: 'Response Time' }),

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'postfix' }, 'ms'))));



        } }],

      renderers: {
        row: ({ children, index, nodeId }, onAction, { isCollapsed, subColumnIndex }, style) => {
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_20__base_data_editor_RowRenderer__["a" /* default */], {
                index: index,
                style: style,
                nodeId: nodeId,
                onAction: onAction },

              children));


        },
        header: children => {
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'data-editor__custom-header' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'data-editor__header-offset' }),
              children,
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'data-editor__header__controls' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_22__base_data_editor_components_HeaderActions__["a" /* default */], {
                  onColumnToggle: this.handleColumnToggle,
                  config: this.state.config,
                  columnGroups: [
                  {
                    label: 'Show columns',
                    columns: [
                    'method',
                    'url',
                    'body',
                    'description'] },

                  {
                    label: 'Add tests',
                    columns: [
                    'testResponseCode',
                    'testResponseTime'] }] }))));







        } },

      height: 300 };


    this.state = {
      values: [],
      config: DEConfig,
      isAdvanced: false,
      newRecipient: '' };


    this.getSelectedOptionName = this.getSelectedOptionName.bind(this);
    this.openLink = this.openLink.bind(this);
    this.handleChange = this.handleChange.bind(this);
    this.handleColumnToggle = this.handleColumnToggle.bind(this);

    this.handleNewRecipientChange = this.handleNewRecipientChange.bind(this);
    this.handleToggleAdvanced = this.handleToggleAdvanced.bind(this);
    this.handleRecipientAdd = this.handleRecipientAdd.bind(this);
  }

  getClasses() {
    return __WEBPACK_IMPORTED_MODULE_2_classnames___default()({
      'create-new-monitor-modal__content': true,
      [`step${this.props.activeStep}`]: true });

  }

  getSelectedOptionName(list, selectedItem, defaultValue) {
    let item = _.find(list, ['id', selectedItem]);

    if (!item) {
      return defaultValue;
    }

    return item.name;
  }

  openLink(link) {
    link && Object(__WEBPACK_IMPORTED_MODULE_15__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(link);
  }

  handleTestChange(requestIndex, testIndex, value) {
    let tests = _.get(this.props, `selectedOptions.requests[${requestIndex}].tests`, ['200', '400']);
    tests[testIndex] = parseInt(value) || '';
    this.props.onRequestChange(requestIndex, 'test', tests);
  }

  onCollectionSelect() {
    this.refs.monitorName && this.refs.monitorName.focus();
  }

  handleChange(values) {
    this.setState({ values });

    let requests = _.dropRight(__WEBPACK_IMPORTED_MODULE_19__postman_data_editor__["utils"].unflattenNodes(values));
    this.props.onRequestChange(requests);
  }

  handleColumnToggle(newConfig) {
    this.setState({ config: newConfig });
  }

  handleNewRecipientChange(newValue) {
    this.setState({ newRecipient: newValue });
  }

  handleRecipientAdd() {
    let newRecipientCount = _.size(this.props.notifications.recipients);
    this.props.onNotificationChange && this.props.onNotificationChange(true, newRecipientCount, this.state.newRecipient);

    this.setState({ newRecipient: '' }, () => {
      this.refs['recipientAdd'] && this.refs['recipientAdd'].clear();
    });
  }

  handleToggleAdvanced() {
    this.setState({ isAdvanced: !this.state.isAdvanced });
  }

  renderStep1() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__body step1' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Tabs__["b" /* Tabs */], {
            type: 'primary',
            defaultActive: 'new',
            activeRef: this.props.activeSource,
            onChange: this.props.onChangeSource },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_27__base_XPaths_XPath__["a" /* default */], { identifier: 'createNewTab' }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Tabs__["a" /* Tab */], { refKey: 'new' }, 'Create a new API')),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_27__base_XPaths_XPath__["a" /* default */], { identifier: 'chooseCollectionTab' }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Tabs__["a" /* Tab */], { refKey: 'workspace' }, 'Use collection from this workspace'))),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__right__intro' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Enter the requests you want to monitor. Optionally, add a request body by clicking on the (\u2022\u2022\u2022) icon.')),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__right' },

          this.props.activeSource === 'new' &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_27__base_XPaths_XPath__["a" /* default */], { identifier: 'createNew' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__right__table' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__data-editor' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_19__postman_data_editor__["DataEditor"], {
                  input: this.state.values,
                  config: this.state.config,
                  onChange: this.handleChange })))),







          this.props.activeSource === 'workspace' && _.isEmpty(this.props.ownCollections) &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_13__empty_states_CollectionsEmpty__["a" /* default */], {
            isMember: true,
            workspaceId: Object(__WEBPACK_IMPORTED_MODULE_26__stores_get_store__["getStore"])('ActiveWorkspaceStore').id,
            onClose: this.props.onClose }),




          this.props.activeSource === 'workspace' && !_.isEmpty(this.props.ownCollections) &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_27__base_XPaths_XPath__["a" /* default */], { identifier: 'chooseCollection' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__right__collections' },

              _.map(this.props.ownCollections, c => {
                return (
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_27__base_XPaths_XPath__["a" /* default */], { identifier: c.id },
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__card', key: c.id, onClick: this.props.onSelectCollection.bind(this, c) },
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_9__base_Icons_CollectionIcon__["a" /* default */], { className: 'create-new-monitor-modal__card__icon' }),
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__card__content' },
                        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__card__title' },
                          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, c.name),
                          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_17__collections_CollectionMetaIcons__["a" /* default */], { collection: c })),

                        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__card__subtitle' },
                          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'create-new-monitor-modal__card__requests' },
                            c.requestCount, ' ', __WEBPACK_IMPORTED_MODULE_23__utils_PluralizeHelper__["a" /* default */].pluralize({
                              count: c.requestCount,
                              singular: 'request',
                              plural: 'requests' })),


                          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_18__collections_CollectionForkLabel__["a" /* default */], { forkInfo: _.get(c, 'forkInfo') }))))));





              })))),





        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__footer__helptext' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('b', null, 'What is a monitor? '),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'A monitor lets you run requests periodically to check for its performance and response though '),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_Buttons__["a" /* Button */], {
              type: 'text',
              className: 'learn-more-link',
              onClick: () => {
                Object(__WEBPACK_IMPORTED_MODULE_15__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_16__constants_AppUrlConstants__["_13" /* TEST_SCRIPT_DOCS */]);
              } }, 'tests.'),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, ' Learn more about '),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_Buttons__["a" /* Button */], {
              type: 'text',
              className: 'learn-more-link',
              onClick: () => {
                Object(__WEBPACK_IMPORTED_MODULE_15__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_16__constants_AppUrlConstants__["T" /* MONITORING_DOCS */]);
              } }, 'monitors.'))));




  }

  renderStep2() {
    if (this.props.isLoadingRegions || this.props.isLoadingVersions) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__body step2 is-loading' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__base_LoadingIndicator__["a" /* default */], null)));


    }

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__body step2' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input-group create-new-monitor__body__input-group--name' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__label' }, 'Monitor name'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__field' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_27__base_XPaths_XPath__["a" /* default */], { identifier: 'monitorName' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Inputs__["b" /* Input */], {
                  ref: 'monitorName',
                  inputStyle: 'box',
                  value: this.props.selectedOptions.name,
                  onChange: this.props.onMonitorNameChange,
                  onEnter: this.props.onCreateMonitor }))),



            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input__helptext' }, 'Enter a title to describe your requests. This will help you identify your monitor and API collection in Postman.'))),




        _.get(this.props.selectedOptions, 'collectionId') &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input-group create-new-monitor__body__input-group--environment' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__label' }, 'Version Tag'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__field' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_27__base_XPaths_XPath__["a" /* default */], { identifier: 'version' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Dropdowns__["a" /* Dropdown */], {
                    allowScroll: true,
                    fullWidth: true,
                    onSelect: this.props.onSelectVersion,
                    className: 'version-dropdown' },

                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Dropdowns__["b" /* DropdownButton */], {
                      size: 'small',
                      type: 'secondary' },

                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_Buttons__["a" /* Button */], null,
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'version-dropdown-button' },
                        this.getSelectedOptionName(this.props.ownVersions, _.get(this.props.selectedOptions, 'versionId'), '')))),



                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Dropdowns__["c" /* DropdownMenu */], { fluid: true },

                    _.map(this.props.ownVersions, version => {
                      return (
                        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Dropdowns__["d" /* MenuItem */], {
                            key: version.id,
                            refKey: version.id },

                          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, version.name)));


                    }))))),





            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'create-new-monitor__body__input__helptext' }, 'Choose a collection version for this monitor. If the collection is not linked to an API, monitor can only be created on current version.'))),






        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input-group create-new-monitor__body__input-group--environment' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__label' }, 'Use an environment (optional)'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__field' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_27__base_XPaths_XPath__["a" /* default */], { identifier: 'environment' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Dropdowns__["a" /* Dropdown */], {
                    allowScroll: true,
                    fullWidth: true,
                    onSelect: this.props.onSelectEnvironment },

                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Dropdowns__["b" /* DropdownButton */], {
                      size: 'small',
                      type: 'secondary' },

                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_Buttons__["a" /* Button */], null, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, this.getSelectedOptionName(this.props.ownEnvironments, this.props.selectedOptions.environmentId, 'No Environment')))),

                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Dropdowns__["c" /* DropdownMenu */], { fluid: true },

                    _.isEmpty(this.props.ownEnvironments) ?
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Dropdowns__["d" /* MenuItem */], { refKey: '' }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'No Environment')) :
                    _.map(this.props.ownEnvironments, obj => {
                      return (
                        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Dropdowns__["d" /* MenuItem */], {
                            key: obj.id,
                            refKey: obj.id },

                          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, obj.name)));


                    }))))),





            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input__helptext' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'An environment is a group of variables useful for storing and reusing values. '),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_Buttons__["a" /* Button */], {
                  type: 'text',
                  className: 'learn-more-link',
                  onClick: () => {
                    Object(__WEBPACK_IMPORTED_MODULE_15__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_16__constants_AppUrlConstants__["B" /* ENVIRONMENT_DOCS */]);
                  } }, 'Learn more')))),






        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input-group create-new-monitor__body__input-group--frequency' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__label' }, 'Monitor run frequency'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__field' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_27__base_XPaths_XPath__["a" /* default */], { identifier: 'scheduler' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_11__monitor_MonitorScheduleSelector__["a" /* default */], {
                  onChange: this.props.onMonitorScheduleChange }))),



            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input__helptext' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Frequent runs give you a finer view of performance but also cost more monitoring calls which might be limited by your Postman account. Check your '),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_Buttons__["a" /* Button */], {
                  type: 'text',
                  className: 'learn-more-link',
                  onClick: __WEBPACK_IMPORTED_MODULE_14__models_services_DashboardService__["q" /* openPostmanUsages */] }, 'usage limits')))),






        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input-group create-new-monitor__body__input-group--regions' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: `create-new-monitor__body__label ${_.isEmpty(this.props.selectedOptions.regions) && 'is-error'}` }, 'Region'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input create-new-monitor__body__input--regions' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_27__base_XPaths_XPath__["a" /* default */], { identifier: 'regions' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__field' },

                _.map(this.props.regions, region => {
                  return (
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input__checkbox', key: region.id },
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Inputs__["a" /* Checkbox */], {
                        checked: _.includes(this.props.selectedOptions.regions, region.id),
                        onChange: this.props.onRegionChange.bind(this, region.id) }),
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, region.name)));


                }))),



            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input__helptext' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'You can select one or more regions to monitor your requests from. '),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_Buttons__["a" /* Button */], {
                  type: 'text',
                  className: 'learn-more-link',
                  onClick: () => {
                    Object(__WEBPACK_IMPORTED_MODULE_15__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_16__constants_AppUrlConstants__["U" /* MONITORING_REGION_DOCS */]);
                  } }, 'Learn more'))),





          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__show-more' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_Buttons__["a" /* Button */], {
                className: 'advanced-section-toggle',
                type: 'text',
                onClick: this.handleToggleAdvanced },

              this.state.isAdvanced ? 'Hide' : 'Show', ' additional preferences'),


            this.state.isAdvanced &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'advanced-section' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'advanced-section advanced-section--notifications' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'advanced-section__checkbox' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Inputs__["a" /* Checkbox */], {
                    checked: this.props.notifications.enabled,
                    onChange: this.props.onNotificationChange }),

                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'advanced-section__checkbox__label' }, 'Receive email notifications for run failures and errors')),



                this.props.notifications.enabled &&
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'advanced-section__field advanced-section__field--notifications' },

                  _.map(this.props.notifications.recipients, (recipient, index) => {
                    return (
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Inputs__["b" /* Input */], {
                        inputStyle: 'box',
                        key: index,
                        ref: 'recipient-' + index,
                        value: recipient,
                        onChange: this.props.onNotificationChange.bind(this, true, index) }));


                  }),


                  _.size(this.props.notifications.recipients) < 5 &&
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Inputs__["b" /* Input */], {
                    inputStyle: 'box',
                    placeholder: 'Add another recipient email',
                    ref: 'recipientAdd',
                    onBlur: this.handleRecipientAdd,
                    onChange: this.handleNewRecipientChange,
                    onSubmit: this.handleRecipientAdd }),


                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'advanced-section__field__meta' }, 'You can add up to 5 notification recipients'))),




              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'advanced-section advanced-section--timeout' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'advanced-section__checkbox' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Inputs__["a" /* Checkbox */], {
                    checked: this.props.requestTimeout.enabled,
                    onChange: this.props.onRequestTimeoutChange }),

                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'advanced-section__checkbox__label' }, 'Request timeout')),



                this.props.requestTimeout.enabled &&
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'advanced-section__field advanced-section__field--timeout' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Inputs__["b" /* Input */], {
                    inputStyle: 'box',
                    type: 'number',
                    value: this.props.requestTimeout.timeout,
                    onChange: this.props.onRequestTimeoutChange.bind(this, true) }),
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'ms'))),




              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'advanced-section advanced-section--delay' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'advanced-section__checkbox' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Inputs__["a" /* Checkbox */], {
                    checked: this.props.requestDelay.enabled,
                    onChange: this.props.onRequestDelayChange }),

                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'advanced-section__checkbox__label' }, 'Request delay')),



                this.props.requestDelay.enabled &&
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'advanced-section__field advanced-section__field--delay' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Inputs__["b" /* Input */], {
                    inputStyle: 'box',
                    type: 'number',
                    value: this.props.requestDelay.delay,
                    onChange: this.props.onRequestDelayChange.bind(this, true) }),
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'ms'))),




              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'advanced-section advanced-section--redirects' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'advanced-section__checkbox' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Inputs__["a" /* Checkbox */], {
                    checked: !this.props.followRedirects,
                    onChange: this.props.onFollowRedirectsChange }),

                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'advanced-section__checkbox__label' }, 'Don\'t follow redirects'))),



              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'advanced-section advanced-section--ssl' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'advanced-section__checkbox' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Inputs__["a" /* Checkbox */], {
                    checked: !this.props.strictSSL,
                    onChange: this.props.onStrictSSLChange }),

                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'advanced-section__checkbox__label' }, 'Disable SSL Validation'))))))));








  }

  renderStep3() {
    if (_.isEqual(this.props.activeSource, 'new') && this.props.collectionStatus.loading || this.props.monitorStatus.loading) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__body step3' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__base_LoadingIndicator__["a" /* default */], null)));


    }

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__body step3' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__card__center' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__content__header' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__content__header__icon' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__base_Icons_MonitorIcon__["a" /* default */], {
                className: 'create-new-monitor-modal__content__header__icon__monitor',
                size: 'lg' }),

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__content__header__icon__monitor' })),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__content__header__text' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'create-new-monitor-modal__content__header__text__title' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('b', null, _.truncate(this.props.selectedOptions.name, { length: 40 })), ' monitor created'),

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__content__header__text__text' }, 'Runs at a schedule to check the performance of your requests'))),



          _.isEqual(this.props.activeSource, 'new') &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__content__header' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__content__header__icon' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_9__base_Icons_CollectionIcon__["a" /* default */], {
                className: 'create-new-monitor-modal__content__header__icon__collection',
                size: 'lg' })),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__content__header__text' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'create-new-monitor-modal__content__header__text__title' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('b', null, _.truncate(this.props.selectedOptions.name, { length: 40 })), ' collection created'),

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__content__header__text__text' }, 'Contains all the requests which are being monitored'))),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'separator' }, 'NEXT STEPS',

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'separator-line' })),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__content__footer' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__step' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__step__title' }, 'Check monitor results'),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__step__text' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'See the monitor run results on the '),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_Buttons__["a" /* Button */], {
                    className: 'monitor-url',
                    onClick: this.props.onMonitorClick,
                    type: 'text' }, 'web dashboard'))),



            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__step' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__step__title' }, 'Add more requests to this collection'),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__step__text' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Save new requests to this collection in the postman app. '),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_Buttons__["a" /* Button */], {
                    className: 'learn-more-link',
                    onClick: this.openLink.bind(this, __WEBPACK_IMPORTED_MODULE_16__constants_AppUrlConstants__["_5" /* SAVE_REQUEST_DOCS */]),
                    type: 'text' }, 'Learn how'))),



            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__step' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__step__title' }, 'Add custom tests to a request'),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__step__text' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Write test scripts in Javascript and add them to any request. '),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_Buttons__["a" /* Button */], {
                    className: 'learn-more-link',
                    onClick: this.openLink.bind(this, __WEBPACK_IMPORTED_MODULE_16__constants_AppUrlConstants__["_13" /* TEST_SCRIPT_DOCS */]),
                    type: 'text' }, 'Learn how')))))));







  }

  render() {
    if (this.props.collectionStatus.error || this.props.monitorStatus.error) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__error' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_12__CreationError__["a" /* default */], {
            subtitle: 'Something went wrong while creating this monitor. You can try again later.',
            onRetry: this.props.onRetry })));



    }
    if (this.props.isOffline && this.props.activeStep !== 3) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__error' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_12__CreationError__["a" /* default */], {
            subtitle: 'Please check your internet connection and try again.',
            onRetry: this.props.onOfflineRetry })));



    }

    if (this.props.errorFetchingVersions) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__error' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_12__CreationError__["a" /* default */], {
            subtitle: 'Please check your internet connection and try again.',
            onRetry: this.props.onVersionFetchRetry })));



    }

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: this.getClasses() },

        this.props.activeStep === 1 && this.renderStep1(),


        this.props.activeStep === 2 && this.renderStep2(),


        this.props.activeStep === 3 && this.renderStep3()));



  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 4971:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = __webpack_require__(1);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(10);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _get = __webpack_require__(1497);

var _get2 = _interopRequireDefault(_get);

var _map = __webpack_require__(1505);

var _map2 = _interopRequireDefault(_map);

var _reduce = __webpack_require__(1518);

var _reduce2 = _interopRequireDefault(_reduce);

var _findIndex = __webpack_require__(4972);

var _findIndex2 = _interopRequireDefault(_findIndex);

var _isEqual = __webpack_require__(4975);

var _isEqual2 = _interopRequireDefault(_isEqual);

var _fbemitter = __webpack_require__(4976);

var _reactShortcuts = __webpack_require__(3575);

var _utils = __webpack_require__(3537);

var _utils2 = _interopRequireDefault(_utils);

var _shortcuts = __webpack_require__(5022);

var _shortcuts2 = _interopRequireDefault(_shortcuts);

var _GenerateRenderers = __webpack_require__(5023);

var _GenerateRenderers2 = _interopRequireDefault(_GenerateRenderers);

var _reducers = __webpack_require__(5032);

var _reducers2 = _interopRequireDefault(_reducers);

var _Header = __webpack_require__(5038);

var _Header2 = _interopRequireDefault(_Header);

var _ListRenderer = __webpack_require__(5039);

var _ListRenderer2 = _interopRequireDefault(_ListRenderer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
// import ListRenderer from '../components/ListRenderer'


var shortcutManager = new _reactShortcuts.ShortcutManager(_shortcuts2.default);

var DataEditor = function (_Component) {
  _inherits(DataEditor, _Component);

  function DataEditor(props) {
    _classCallCheck(this, DataEditor);

    var _this = _possibleConstructorReturn(this, (DataEditor.__proto__ || Object.getPrototypeOf(DataEditor)).call(this, props));

    _this.generateGridToColumnMap(props.config.columns);

    var shortCircuitInput = _utils2.default.isMap(props.input);
    var flattenedNodes = shortCircuitInput ? {
      state: props.input,
      maxDepth: _utils2.default.getMaxDepth(props.input)
    } : _utils2.default.flattenNodes(props.config, props.input);

    _this.state = {
      is: flattenedNodes.state,
      columnWidths: (0, _map2.default)(_this.GridToColumnMap, function (c) {
        return c.width;
      })

      // console.log(this.state.is.toJS())

    };_this.listConfig = {
      widths: _this.state.columnWidths,
      cellWidth: 260 + flattenedNodes.maxDepth * 20,
      height: props.config.height
    };

    _this.reducer = new _reducers2.default(props.config);
    _this.initializeRenderers(props.config);

    _this.events = new _fbemitter.EventEmitter();

    _this.handleColumnResize = _this.handleColumnResize.bind(_this);
    _this.handleColumnClick = _this.handleColumnClick.bind(_this);
    _this.handleAction = _this.handleAction.bind(_this);
    _this.moveToCell = _this.moveToCell.bind(_this);
    _this._renderColumn = _this._renderColumn.bind(_this);
    _this._renderRow = _this._renderRow.bind(_this);
    return _this;
  }

  _createClass(DataEditor, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        events: this.events,
        shortcuts: shortcutManager
      };
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      !_utils2.default.isMap(this.props.input) && this.generateCreateRow(this.props.config);
      this.events.addListener('moveToCell', this.moveToCell);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (!(0, _isEqual2.default)(this.props.config.columns, nextProps.config.columns)) {
        this.generateGridToColumnMap(nextProps.config.columns);
        var widths = (0, _map2.default)(this.GridToColumnMap, function (c) {
          return c.width;
        });
        this.listConfig = Object.assign({}, this.listConfig, {
          widths: widths
        });
        this.setState({
          columnWidths: widths
        });
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.events.removeAllListeners('moveToCell');
    }
  }, {
    key: 'generateGridToColumnMap',
    value: function generateGridToColumnMap(columns) {
      this.GridToColumnMap = (0, _reduce2.default)(columns, function (map, column) {
        if (!column.hidden) {
          if (column.type === 'string' || column.type === 'number' || column.type === 'boolean') {
            map.push({
              name: column.name,
              index: 0,
              width: column.width,
              renderer: (0, _get2.default)(column, 'renderer'),
              header: (0, _get2.default)(column, 'label', column.name),
              resize: !!column.resize
            });
          } else if (column.type === 'object' || column.type === 'array') {
            map.push({
              name: column.name,
              index: 0,
              width: column.width / 2,
              renderer: (0, _get2.default)(column, 'renderer'),
              header: (0, _get2.default)(column, 'label.key', column.name),
              resize: !!column.resize
            });
            map.push({
              name: column.name,
              index: 1,
              width: column.width / 2,
              renderer: (0, _get2.default)(column, 'renderer'),
              header: (0, _get2.default)(column, 'label.value', column.name),
              resize: !!column.resize
            });
          }
        }

        return map;
      }, []);
    }
  }, {
    key: 'initializeRenderers',
    value: function initializeRenderers(config) {
      this.renderers = (0, _GenerateRenderers2.default)(config.renderers);
    }
  }, {
    key: 'generateCreateRow',
    value: function generateCreateRow(config) {
      var _this2 = this;

      this.setState(function (state) {
        return {
          is: _this2.reducer.reduce(state.is, {
            source: {},
            type: 'create'
          })
        };
      });
    }
  }, {
    key: 'handleColumnResize',
    value: function handleColumnResize(columnWidths) {
      this.listConfig = Object.assign({}, this.listConfig, {
        widths: columnWidths
      });

      this.setState({
        columnWidths: columnWidths
      });
    }
  }, {
    key: 'handleColumnClick',
    value: function handleColumnClick(rowIndex, columnIndex) {
      this.events.emit('focusCell', {
        node: _utils2.default.getImmutablePathValue(this.state.is, ['order', rowIndex]),
        column: (0, _get2.default)(this.GridToColumnMap, '[' + columnIndex + '].name')
      });
    }
  }, {
    key: 'handleAction',
    value: function handleAction(source, actionType, actionPayload) {
      var _this3 = this;

      var order = _utils2.default.getImmutablePathValue(this.state.is, ['order']);
      // TODO:: handle maxDepth as well (when adding a child)
      if (actionType === 'edit' && _utils2.default.getLastInList(order) === source.node) {
        // If you edited the last row (the create row), add a create row
        this.generateCreateRow();
      }

      this.setState(function (state) {
        var action = _utils2.default.createAction(source, actionType, actionPayload);

        return {
          is: _this3.reducer.reduce(state.is, action)
        };
      }, function () {
        _this3.props.onChange && _this3.props.onChange(_this3.state.is);
      });
    }
  }, {
    key: 'moveToCell',
    value: function moveToCell(_ref) {
      var node = _ref.node,
          column = _ref.column,
          direction = _ref.direction;

      var order = _utils2.default.getImmutablePathValue(this.state.is, ['order']),
          columns = this.GridToColumnMap,
          currentNodeIndex = _utils2.default.findIndexInOrder(order, node),
          currentColumnIndex = (0, _findIndex2.default)(columns, function (c) {
        return c.name === column;
      }),
          nextNodeIndex = void 0,
          nextColumnIndex = void 0,
          maxRows = order.size - 1,
          maxColumns = this.GridToColumnMap.length - 1;

      switch (direction) {
        case 'left':
        case 'shiftTab':
          if (currentColumnIndex - 1 >= 0) {
            nextNodeIndex = currentNodeIndex;
            nextColumnIndex = currentColumnIndex - 1;
          } else if (currentNodeIndex - 1 >= 0) {
            nextNodeIndex = currentNodeIndex - 1;
            nextColumnIndex = maxColumns;
          }

          this.events.emit('focusCell', {
            node: _utils2.default.getImmutablePathValue(this.state.is, ['order', nextNodeIndex]),
            column: (0, _get2.default)(this.GridToColumnMap, '[' + nextColumnIndex + '].name'),
            direction: direction
          });
          break;
        case 'right':
        case 'tab':
          if (currentColumnIndex + 1 <= maxColumns) {
            nextNodeIndex = currentNodeIndex;
            nextColumnIndex = currentColumnIndex + 1;
          } else if (currentNodeIndex + 1 <= maxRows) {
            nextNodeIndex = currentNodeIndex + 1;
            nextColumnIndex = 0;
          }

          this.events.emit('focusCell', {
            node: _utils2.default.getImmutablePathValue(this.state.is, ['order', nextNodeIndex]),
            column: (0, _get2.default)(this.GridToColumnMap, '[' + nextColumnIndex + '].name'),
            direction: direction
          });
          break;
        case 'up':
          if (currentNodeIndex - 1 >= 0) {
            nextNodeIndex = _utils2.default.getImmutablePathValue(this.state.is, ['order', currentNodeIndex - 1]);
            this.events.emit('focusCell', { node: nextNodeIndex, column: column, direction: direction });
          }
          break;
        case 'down':
          if (currentNodeIndex + 1 <= maxRows) {
            nextNodeIndex = _utils2.default.getImmutablePathValue(this.state.is, ['order', currentNodeIndex + 1]);
            this.events.emit('focusCell', { node: nextNodeIndex, column: column, direction: direction });
          }
          break;
        default:
          break;
      }
    }
  }, {
    key: '_renderColumn',
    value: function _renderColumn(_ref2) {
      var rowIndex = _ref2.rowIndex,
          columnIndex = _ref2.columnIndex;

      var ISRowIndex = _utils2.default.getImmutablePathValue(this.state.is, ['order', rowIndex]);
      var node = _utils2.default.getImmutablePathValue(this.state.is, ['rows', '' + ISRowIndex, 'columns', this.GridToColumnMap[columnIndex].name]);
      var nodeId = ISRowIndex;

      if (!node) {
        return;
      }

      var type = _utils2.default.getImmutablePathValue(node, ['type']);
      var depth = _utils2.default.getImmutablePathValue(this.state.is, ['rows', '' + ISRowIndex, 'depth']);
      var marginLeft = depth * 20 + 'px';
      var meta = _utils2.default.getImmutablePathValue(node, ['meta']);
      var isCollapsed = !!_utils2.default.getImmutablePathValue(this.state.is, ['collapsedRows', '' + nodeId]);

      if (this.GridToColumnMap[columnIndex].renderer) {
        return this.GridToColumnMap[columnIndex].renderer && typeof this.GridToColumnMap[columnIndex].renderer === 'function' && this.GridToColumnMap[columnIndex].renderer(meta, this.handleAction.bind(this, {
          node: nodeId,
          column: this.GridToColumnMap[columnIndex].name
        }), {
          isCollapsed: isCollapsed,
          subColumnIndex: this.GridToColumnMap[columnIndex].index
        }, { marginLeft: marginLeft }, { node: nodeId, column: this.GridToColumnMap[columnIndex].name });
      }

      return this.renderers && this.renderers[type] && typeof this.renderers[type] === 'function' && this.renderers[type](meta, this.handleAction.bind(this, {
        node: nodeId,
        column: this.GridToColumnMap[columnIndex].name
      }), {
        isCollapsed: isCollapsed,
        subColumnIndex: this.GridToColumnMap[columnIndex].index
      }, { marginLeft: marginLeft }, { node: nodeId, column: this.GridToColumnMap[columnIndex].name });
    }
  }, {
    key: '_renderRow',
    value: function _renderRow(children, index, style) {
      var nodeId = _utils2.default.getImmutablePathValue(this.state.is, ['order', index]);
      return this.renderers.row && this.renderers.row({ children: children, index: index, nodeId: nodeId }, this.handleAction.bind(this, { node: nodeId }), { isCollapsed: false, subColumnIndex: 0 }, style);
    }
  }, {
    key: 'render',
    value: function render() {
      var rowCount = _utils2.default.getImmutablePathValue(this.state.is, ['order']).size;
      return _react2.default.createElement(
        'div',
        { className: 'data-editor' },
        _react2.default.createElement(_Header2.default, {
          columns: this.GridToColumnMap,
          columnWidths: this.state.columnWidths,
          renderers: this.renderers,
          onColumnResize: this.handleColumnResize
        }),
        _react2.default.createElement(_ListRenderer2.default, {
          state: this.state.is // Dummy to force rerenders when state changes
          , rowCount: rowCount,
          columnCount: this.GridToColumnMap.length,
          config: this.listConfig,
          cellRenderer: this._renderColumn,
          rowRenderer: this._renderRow,
          className: this.props.className,
          classNames: this.props.config.classNames,
          onColumnClick: this.handleColumnClick
        })
      );
    }
  }]);

  return DataEditor;
}(_react.Component);

DataEditor.childContextTypes = {
  shortcuts: _propTypes2.default.object.isRequired,
  events: _propTypes2.default.object
};

exports.default = DataEditor;

/***/ }),

/***/ 4972:
/***/ (function(module, exports, __webpack_require__) {

var baseFindIndex = __webpack_require__(1618),
    baseIteratee = __webpack_require__(537),
    toInteger = __webpack_require__(4014);

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeMax = Math.max;

/**
 * This method is like `_.find` except that it returns the index of the first
 * element `predicate` returns truthy for instead of the element itself.
 *
 * @static
 * @memberOf _
 * @since 1.1.0
 * @category Array
 * @param {Array} array The array to inspect.
 * @param {Function} [predicate=_.identity] The function invoked per iteration.
 * @param {number} [fromIndex=0] The index to search from.
 * @returns {number} Returns the index of the found element, else `-1`.
 * @example
 *
 * var users = [
 *   { 'user': 'barney',  'active': false },
 *   { 'user': 'fred',    'active': false },
 *   { 'user': 'pebbles', 'active': true }
 * ];
 *
 * _.findIndex(users, function(o) { return o.user == 'barney'; });
 * // => 0
 *
 * // The `_.matches` iteratee shorthand.
 * _.findIndex(users, { 'user': 'fred', 'active': false });
 * // => 1
 *
 * // The `_.matchesProperty` iteratee shorthand.
 * _.findIndex(users, ['active', false]);
 * // => 0
 *
 * // The `_.property` iteratee shorthand.
 * _.findIndex(users, 'active');
 * // => 2
 */
function findIndex(array, predicate, fromIndex) {
  var length = array == null ? 0 : array.length;
  if (!length) {
    return -1;
  }
  var index = fromIndex == null ? 0 : toInteger(fromIndex);
  if (index < 0) {
    index = nativeMax(length + index, 0);
  }
  return baseFindIndex(array, baseIteratee(predicate, 3), index);
}

module.exports = findIndex;


/***/ }),

/***/ 4973:
/***/ (function(module, exports, __webpack_require__) {

var toNumber = __webpack_require__(4974);

/** Used as references for various `Number` constants. */
var INFINITY = 1 / 0,
    MAX_INTEGER = 1.7976931348623157e+308;

/**
 * Converts `value` to a finite number.
 *
 * @static
 * @memberOf _
 * @since 4.12.0
 * @category Lang
 * @param {*} value The value to convert.
 * @returns {number} Returns the converted number.
 * @example
 *
 * _.toFinite(3.2);
 * // => 3.2
 *
 * _.toFinite(Number.MIN_VALUE);
 * // => 5e-324
 *
 * _.toFinite(Infinity);
 * // => 1.7976931348623157e+308
 *
 * _.toFinite('3.2');
 * // => 3.2
 */
function toFinite(value) {
  if (!value) {
    return value === 0 ? value : 0;
  }
  value = toNumber(value);
  if (value === INFINITY || value === -INFINITY) {
    var sign = (value < 0 ? -1 : 1);
    return sign * MAX_INTEGER;
  }
  return value === value ? value : 0;
}

module.exports = toFinite;


/***/ }),

/***/ 4974:
/***/ (function(module, exports, __webpack_require__) {

var isObject = __webpack_require__(98),
    isSymbol = __webpack_require__(660);

/** Used as references for various `Number` constants. */
var NAN = 0 / 0;

/** Used to match leading and trailing whitespace. */
var reTrim = /^\s+|\s+$/g;

/** Used to detect bad signed hexadecimal string values. */
var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;

/** Used to detect binary string values. */
var reIsBinary = /^0b[01]+$/i;

/** Used to detect octal string values. */
var reIsOctal = /^0o[0-7]+$/i;

/** Built-in method references without a dependency on `root`. */
var freeParseInt = parseInt;

/**
 * Converts `value` to a number.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to process.
 * @returns {number} Returns the number.
 * @example
 *
 * _.toNumber(3.2);
 * // => 3.2
 *
 * _.toNumber(Number.MIN_VALUE);
 * // => 5e-324
 *
 * _.toNumber(Infinity);
 * // => Infinity
 *
 * _.toNumber('3.2');
 * // => 3.2
 */
function toNumber(value) {
  if (typeof value == 'number') {
    return value;
  }
  if (isSymbol(value)) {
    return NAN;
  }
  if (isObject(value)) {
    var other = typeof value.valueOf == 'function' ? value.valueOf() : value;
    value = isObject(other) ? (other + '') : other;
  }
  if (typeof value != 'string') {
    return value === 0 ? value : +value;
  }
  value = value.replace(reTrim, '');
  var isBinary = reIsBinary.test(value);
  return (isBinary || reIsOctal.test(value))
    ? freeParseInt(value.slice(2), isBinary ? 2 : 8)
    : (reIsBadHex.test(value) ? NAN : +value);
}

module.exports = toNumber;


/***/ }),

/***/ 4975:
/***/ (function(module, exports, __webpack_require__) {

var baseIsEqual = __webpack_require__(976);

/**
 * Performs a deep comparison between two values to determine if they are
 * equivalent.
 *
 * **Note:** This method supports comparing arrays, array buffers, booleans,
 * date objects, error objects, maps, numbers, `Object` objects, regexes,
 * sets, strings, symbols, and typed arrays. `Object` objects are compared
 * by their own, not inherited, enumerable properties. Functions and DOM
 * nodes are compared by strict equality, i.e. `===`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
 * @example
 *
 * var object = { 'a': 1 };
 * var other = { 'a': 1 };
 *
 * _.isEqual(object, other);
 * // => true
 *
 * object === other;
 * // => false
 */
function isEqual(value, other) {
  return baseIsEqual(value, other);
}

module.exports = isEqual;


/***/ }),

/***/ 4976:
/***/ (function(module, exports, __webpack_require__) {

/**
 * Copyright (c) 2014-present, Facebook, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

var fbemitter = {
  EventEmitter: __webpack_require__(4977),
  EmitterSubscription : __webpack_require__(4015)
};

module.exports = fbemitter;


/***/ }),

/***/ 4977:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
 * Copyright (c) 2014-present, Facebook, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 *
 * @providesModule BaseEventEmitter
 * @typechecks
 */



function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var EmitterSubscription = __webpack_require__(4015);
var EventSubscriptionVendor = __webpack_require__(4979);

var emptyFunction = __webpack_require__(227);
var invariant = __webpack_require__(42);

/**
 * @class BaseEventEmitter
 * @description
 * An EventEmitter is responsible for managing a set of listeners and publishing
 * events to them when it is told that such events happened. In addition to the
 * data for the given event it also sends a event control object which allows
 * the listeners/handlers to prevent the default behavior of the given event.
 *
 * The emitter is designed to be generic enough to support all the different
 * contexts in which one might want to emit events. It is a simple multicast
 * mechanism on top of which extra functionality can be composed. For example, a
 * more advanced emitter may use an EventHolder and EventFactory.
 */

var BaseEventEmitter = (function () {
  /**
   * @constructor
   */

  function BaseEventEmitter() {
    _classCallCheck(this, BaseEventEmitter);

    this._subscriber = new EventSubscriptionVendor();
    this._currentSubscription = null;
  }

  /**
   * Adds a listener to be invoked when events of the specified type are
   * emitted. An optional calling context may be provided. The data arguments
   * emitted will be passed to the listener function.
   *
   * TODO: Annotate the listener arg's type. This is tricky because listeners
   *       can be invoked with varargs.
   *
   * @param {string} eventType - Name of the event to listen to
   * @param {function} listener - Function to invoke when the specified event is
   *   emitted
   * @param {*} context - Optional context object to use when invoking the
   *   listener
   */

  BaseEventEmitter.prototype.addListener = function addListener(eventType, listener, context) {
    return this._subscriber.addSubscription(eventType, new EmitterSubscription(this._subscriber, listener, context));
  };

  /**
   * Similar to addListener, except that the listener is removed after it is
   * invoked once.
   *
   * @param {string} eventType - Name of the event to listen to
   * @param {function} listener - Function to invoke only once when the
   *   specified event is emitted
   * @param {*} context - Optional context object to use when invoking the
   *   listener
   */

  BaseEventEmitter.prototype.once = function once(eventType, listener, context) {
    var emitter = this;
    return this.addListener(eventType, function () {
      emitter.removeCurrentListener();
      listener.apply(context, arguments);
    });
  };

  /**
   * Removes all of the registered listeners, including those registered as
   * listener maps.
   *
   * @param {?string} eventType - Optional name of the event whose registered
   *   listeners to remove
   */

  BaseEventEmitter.prototype.removeAllListeners = function removeAllListeners(eventType) {
    this._subscriber.removeAllSubscriptions(eventType);
  };

  /**
   * Provides an API that can be called during an eventing cycle to remove the
   * last listener that was invoked. This allows a developer to provide an event
   * object that can remove the listener (or listener map) during the
   * invocation.
   *
   * If it is called when not inside of an emitting cycle it will throw.
   *
   * @throws {Error} When called not during an eventing cycle
   *
   * @example
   *   var subscription = emitter.addListenerMap({
   *     someEvent: function(data, event) {
   *       console.log(data);
   *       emitter.removeCurrentListener();
   *     }
   *   });
   *
   *   emitter.emit('someEvent', 'abc'); // logs 'abc'
   *   emitter.emit('someEvent', 'def'); // does not log anything
   */

  BaseEventEmitter.prototype.removeCurrentListener = function removeCurrentListener() {
    !!!this._currentSubscription ?  false ? invariant(false, 'Not in an emitting cycle; there is no current subscription') : invariant(false) : undefined;
    this._subscriber.removeSubscription(this._currentSubscription);
  };

  /**
   * Returns an array of listeners that are currently registered for the given
   * event.
   *
   * @param {string} eventType - Name of the event to query
   * @return {array}
   */

  BaseEventEmitter.prototype.listeners = function listeners(eventType) /* TODO: Array<EventSubscription> */{
    var subscriptions = this._subscriber.getSubscriptionsForType(eventType);
    return subscriptions ? subscriptions.filter(emptyFunction.thatReturnsTrue).map(function (subscription) {
      return subscription.listener;
    }) : [];
  };

  /**
   * Emits an event of the given type with the given data. All handlers of that
   * particular type will be notified.
   *
   * @param {string} eventType - Name of the event to emit
   * @param {*} Arbitrary arguments to be passed to each registered listener
   *
   * @example
   *   emitter.addListener('someEvent', function(message) {
   *     console.log(message);
   *   });
   *
   *   emitter.emit('someEvent', 'abc'); // logs 'abc'
   */

  BaseEventEmitter.prototype.emit = function emit(eventType) {
    var subscriptions = this._subscriber.getSubscriptionsForType(eventType);
    if (subscriptions) {
      var keys = Object.keys(subscriptions);
      for (var ii = 0; ii < keys.length; ii++) {
        var key = keys[ii];
        var subscription = subscriptions[key];
        // The subscription may have been removed during this event loop.
        if (subscription) {
          this._currentSubscription = subscription;
          this.__emitToSubscription.apply(this, [subscription].concat(Array.prototype.slice.call(arguments)));
        }
      }
      this._currentSubscription = null;
    }
  };

  /**
   * Provides a hook to override how the emitter emits an event to a specific
   * subscription. This allows you to set up logging and error boundaries
   * specific to your environment.
   *
   * @param {EmitterSubscription} subscription
   * @param {string} eventType
   * @param {*} Arbitrary arguments to be passed to each registered listener
   */

  BaseEventEmitter.prototype.__emitToSubscription = function __emitToSubscription(subscription, eventType) {
    var args = Array.prototype.slice.call(arguments, 2);
    subscription.listener.apply(subscription.context, args);
  };

  return BaseEventEmitter;
})();

module.exports = BaseEventEmitter;

/***/ }),

/***/ 4978:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
 * Copyright (c) 2014-present, Facebook, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 *
 * @providesModule EventSubscription
 * @typechecks
 */



/**
 * EventSubscription represents a subscription to a particular event. It can
 * remove its own subscription.
 */

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var EventSubscription = (function () {

  /**
   * @param {EventSubscriptionVendor} subscriber the subscriber that controls
   *   this subscription.
   */

  function EventSubscription(subscriber) {
    _classCallCheck(this, EventSubscription);

    this.subscriber = subscriber;
  }

  /**
   * Removes this subscription from the subscriber that controls it.
   */

  EventSubscription.prototype.remove = function remove() {
    if (this.subscriber) {
      this.subscriber.removeSubscription(this);
      this.subscriber = null;
    }
  };

  return EventSubscription;
})();

module.exports = EventSubscription;

/***/ }),

/***/ 4979:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
 * Copyright (c) 2014-present, Facebook, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 * 
 * @providesModule EventSubscriptionVendor
 * @typechecks
 */



function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var invariant = __webpack_require__(42);

/**
 * EventSubscriptionVendor stores a set of EventSubscriptions that are
 * subscribed to a particular event type.
 */

var EventSubscriptionVendor = (function () {
  function EventSubscriptionVendor() {
    _classCallCheck(this, EventSubscriptionVendor);

    this._subscriptionsForType = {};
    this._currentSubscription = null;
  }

  /**
   * Adds a subscription keyed by an event type.
   *
   * @param {string} eventType
   * @param {EventSubscription} subscription
   */

  EventSubscriptionVendor.prototype.addSubscription = function addSubscription(eventType, subscription) {
    !(subscription.subscriber === this) ?  false ? invariant(false, 'The subscriber of the subscription is incorrectly set.') : invariant(false) : undefined;
    if (!this._subscriptionsForType[eventType]) {
      this._subscriptionsForType[eventType] = [];
    }
    var key = this._subscriptionsForType[eventType].length;
    this._subscriptionsForType[eventType].push(subscription);
    subscription.eventType = eventType;
    subscription.key = key;
    return subscription;
  };

  /**
   * Removes a bulk set of the subscriptions.
   *
   * @param {?string} eventType - Optional name of the event type whose
   *   registered supscriptions to remove, if null remove all subscriptions.
   */

  EventSubscriptionVendor.prototype.removeAllSubscriptions = function removeAllSubscriptions(eventType) {
    if (eventType === undefined) {
      this._subscriptionsForType = {};
    } else {
      delete this._subscriptionsForType[eventType];
    }
  };

  /**
   * Removes a specific subscription. Instead of calling this function, call
   * `subscription.remove()` directly.
   *
   * @param {object} subscription
   */

  EventSubscriptionVendor.prototype.removeSubscription = function removeSubscription(subscription) {
    var eventType = subscription.eventType;
    var key = subscription.key;

    var subscriptionsForType = this._subscriptionsForType[eventType];
    if (subscriptionsForType) {
      delete subscriptionsForType[key];
    }
  };

  /**
   * Returns the array of subscriptions that are currently registered for the
   * given event type.
   *
   * Note: This array can be potentially sparse as subscriptions are deleted
   * from it when they are removed.
   *
   * TODO: This returns a nullable array. wat?
   *
   * @param {string} eventType
   * @return {?array}
   */

  EventSubscriptionVendor.prototype.getSubscriptionsForType = function getSubscriptionsForType(eventType) {
    return this._subscriptionsForType[eventType];
  };

  return EventSubscriptionVendor;
})();

module.exports = EventSubscriptionVendor;

/***/ }),

/***/ 4980:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(process) {

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _justReduceObject = __webpack_require__(4981);

var _justReduceObject2 = _interopRequireDefault(_justReduceObject);

var _invariant = __webpack_require__(107);

var _invariant2 = _interopRequireDefault(_invariant);

var _events = __webpack_require__(35);

var _helpers = __webpack_require__(4016);

var _helpers2 = _interopRequireDefault(_helpers);

var _utils = __webpack_require__(4983);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var warning = function warning(text) {
  if (process && 'production' !== 'production') {
    console.warn(text);
  }
};

var ShortcutManager = function (_EventEmitter) {
  _inherits(ShortcutManager, _EventEmitter);

  function ShortcutManager() {
    var keymap = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, ShortcutManager);

    var _this = _possibleConstructorReturn(this, (ShortcutManager.__proto__ || Object.getPrototypeOf(ShortcutManager)).call(this));

    _this._platformName = _helpers2.default.getPlatformName();

    _this._parseShortcutDescriptor = function (item) {
      if ((0, _utils.isPlainObject)(item)) {
        return item[_this._platformName];
      }
      return item;
    };

    _this._keymap = keymap;
    return _this;
  }

  _createClass(ShortcutManager, [{
    key: 'addUpdateListener',
    value: function addUpdateListener(callback) {
      (0, _invariant2.default)(callback, 'addUpdateListener: callback argument is not defined or falsy');
      this.on(ShortcutManager.CHANGE_EVENT, callback);
    }
  }, {
    key: 'removeUpdateListener',
    value: function removeUpdateListener(callback) {
      this.removeListener(ShortcutManager.CHANGE_EVENT, callback);
    }
  }, {
    key: 'setKeymap',
    value: function setKeymap(keymap) {
      (0, _invariant2.default)(keymap, 'setKeymap: keymap argument is not defined or falsy.');
      this._keymap = keymap;
      this.emit(ShortcutManager.CHANGE_EVENT);
    }
  }, {
    key: 'extendKeymap',
    value: function extendKeymap(keymap) {
      (0, _invariant2.default)(keymap, 'extendKeymap: keymap argument is not defined or falsy.');
      this._keymap = Object.assign({}, this._keymap, keymap);
      this.emit(ShortcutManager.CHANGE_EVENT);
    }
  }, {
    key: 'getAllShortcuts',
    value: function getAllShortcuts() {
      return this._keymap;
    }
  }, {
    key: 'getAllShortcutsForPlatform',
    value: function getAllShortcutsForPlatform(platformName) {
      var _transformShortcuts = function _transformShortcuts(shortcuts) {
        return (0, _justReduceObject2.default)(shortcuts, function (result, keyName, keyValue) {
          if ((0, _utils.isPlainObject)(keyValue)) {
            if (keyValue[platformName]) {
              keyValue = keyValue[platformName];
            } else {
              result[keyName] = _transformShortcuts(keyValue);
              return result;
            }
          }

          result[keyName] = keyValue;
          return result;
        }, {});
      };

      return _transformShortcuts(this._keymap);
    }
  }, {
    key: 'getAllShortcutsForCurrentPlatform',
    value: function getAllShortcutsForCurrentPlatform() {
      return this.getAllShortcutsForPlatform(this._platformName);
    }
  }, {
    key: 'getShortcuts',
    value: function getShortcuts(componentName) {
      (0, _invariant2.default)(componentName, 'getShortcuts: name argument is not defined or falsy.');

      var cursor = this._keymap[componentName];
      if (!cursor) {
        warning('getShortcuts: There are no shortcuts with name ' + componentName + '.');
        return;
      }

      var shortcuts = (0, _utils.compact)((0, _utils.flatten)((0, _utils.map)(cursor, this._parseShortcutDescriptor)));

      return shortcuts;
    }
  }, {
    key: '_parseShortcutKeyName',
    value: function _parseShortcutKeyName(obj, keyName) {
      var _this2 = this;

      var result = (0, _utils.findKey)(obj, function (item) {
        if ((0, _utils.isPlainObject)(item)) {
          item = item[_this2._platformName];
        }
        if ((0, _utils.isArray)(item)) {
          var index = item.indexOf(keyName);
          if (index >= 0) {
            item = item[index];
          }
        }
        return item === keyName;
      });

      return result;
    }
  }, {
    key: 'findShortcutName',
    value: function findShortcutName(keyName, componentName) {
      (0, _invariant2.default)(keyName, 'findShortcutName: keyName argument is not defined or falsy.');
      (0, _invariant2.default)(componentName, 'findShortcutName: componentName argument is not defined or falsy.');

      var cursor = this._keymap[componentName];
      var result = this._parseShortcutKeyName(cursor, keyName);

      return result;
    }
  }]);

  return ShortcutManager;
}(_events.EventEmitter);

ShortcutManager.CHANGE_EVENT = 'shortcuts:update';
exports.default = ShortcutManager;
module.exports = exports['default'];
/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(3)))

/***/ }),

/***/ 4981:
/***/ (function(module, exports) {

module.exports = reduce;

function reduce(obj, predicate /*, initialValue*/) {
  var args = [callback];
  // `initialValue` is optional
  var hasInitialValue = 2 in arguments;
  hasInitialValue && args.push(arguments[2]);

  function callback(previousValue, currentKey, currentIndex, array) {
    // when `initialValue` is not provided then
    // `previousValue` is the value associated to the first key
    if (!hasInitialValue) {
      previousValue = obj[array[0]];
      hasInitialValue = true;
    }
    return predicate(
      previousValue,
      currentKey,
      obj[currentKey],
      currentIndex,
      array
    );
  }

  return Array.prototype.reduce.apply(Object.keys(obj), args);
}


/***/ }),

/***/ 4982:
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(module, global) {var __WEBPACK_AMD_DEFINE_RESULT__;/*!
 * Platform.js <https://mths.be/platform>
 * Copyright 2014-2018 Benjamin Tan <https://bnjmnt4n.now.sh/>
 * Copyright 2011-2013 John-David Dalton <http://allyoucanleet.com/>
 * Available under MIT license <https://mths.be/mit>
 */
;(function() {
  'use strict';

  /** Used to determine if values are of the language type `Object`. */
  var objectTypes = {
    'function': true,
    'object': true
  };

  /** Used as a reference to the global object. */
  var root = (objectTypes[typeof window] && window) || this;

  /** Backup possible global object. */
  var oldRoot = root;

  /** Detect free variable `exports`. */
  var freeExports = objectTypes[typeof exports] && exports;

  /** Detect free variable `module`. */
  var freeModule = objectTypes[typeof module] && module && !module.nodeType && module;

  /** Detect free variable `global` from Node.js or Browserified code and use it as `root`. */
  var freeGlobal = freeExports && freeModule && typeof global == 'object' && global;
  if (freeGlobal && (freeGlobal.global === freeGlobal || freeGlobal.window === freeGlobal || freeGlobal.self === freeGlobal)) {
    root = freeGlobal;
  }

  /**
   * Used as the maximum length of an array-like object.
   * See the [ES6 spec](http://people.mozilla.org/~jorendorff/es6-draft.html#sec-tolength)
   * for more details.
   */
  var maxSafeInteger = Math.pow(2, 53) - 1;

  /** Regular expression to detect Opera. */
  var reOpera = /\bOpera/;

  /** Possible global object. */
  var thisBinding = this;

  /** Used for native method references. */
  var objectProto = Object.prototype;

  /** Used to check for own properties of an object. */
  var hasOwnProperty = objectProto.hasOwnProperty;

  /** Used to resolve the internal `[[Class]]` of values. */
  var toString = objectProto.toString;

  /*--------------------------------------------------------------------------*/

  /**
   * Capitalizes a string value.
   *
   * @private
   * @param {string} string The string to capitalize.
   * @returns {string} The capitalized string.
   */
  function capitalize(string) {
    string = String(string);
    return string.charAt(0).toUpperCase() + string.slice(1);
  }

  /**
   * A utility function to clean up the OS name.
   *
   * @private
   * @param {string} os The OS name to clean up.
   * @param {string} [pattern] A `RegExp` pattern matching the OS name.
   * @param {string} [label] A label for the OS.
   */
  function cleanupOS(os, pattern, label) {
    // Platform tokens are defined at:
    // http://msdn.microsoft.com/en-us/library/ms537503(VS.85).aspx
    // http://web.archive.org/web/20081122053950/http://msdn.microsoft.com/en-us/library/ms537503(VS.85).aspx
    var data = {
      '10.0': '10',
      '6.4':  '10 Technical Preview',
      '6.3':  '8.1',
      '6.2':  '8',
      '6.1':  'Server 2008 R2 / 7',
      '6.0':  'Server 2008 / Vista',
      '5.2':  'Server 2003 / XP 64-bit',
      '5.1':  'XP',
      '5.01': '2000 SP1',
      '5.0':  '2000',
      '4.0':  'NT',
      '4.90': 'ME'
    };
    // Detect Windows version from platform tokens.
    if (pattern && label && /^Win/i.test(os) && !/^Windows Phone /i.test(os) &&
        (data = data[/[\d.]+$/.exec(os)])) {
      os = 'Windows ' + data;
    }
    // Correct character case and cleanup string.
    os = String(os);

    if (pattern && label) {
      os = os.replace(RegExp(pattern, 'i'), label);
    }

    os = format(
      os.replace(/ ce$/i, ' CE')
        .replace(/\bhpw/i, 'web')
        .replace(/\bMacintosh\b/, 'Mac OS')
        .replace(/_PowerPC\b/i, ' OS')
        .replace(/\b(OS X) [^ \d]+/i, '$1')
        .replace(/\bMac (OS X)\b/, '$1')
        .replace(/\/(\d)/, ' $1')
        .replace(/_/g, '.')
        .replace(/(?: BePC|[ .]*fc[ \d.]+)$/i, '')
        .replace(/\bx86\.64\b/gi, 'x86_64')
        .replace(/\b(Windows Phone) OS\b/, '$1')
        .replace(/\b(Chrome OS \w+) [\d.]+\b/, '$1')
        .split(' on ')[0]
    );

    return os;
  }

  /**
   * An iteration utility for arrays and objects.
   *
   * @private
   * @param {Array|Object} object The object to iterate over.
   * @param {Function} callback The function called per iteration.
   */
  function each(object, callback) {
    var index = -1,
        length = object ? object.length : 0;

    if (typeof length == 'number' && length > -1 && length <= maxSafeInteger) {
      while (++index < length) {
        callback(object[index], index, object);
      }
    } else {
      forOwn(object, callback);
    }
  }

  /**
   * Trim and conditionally capitalize string values.
   *
   * @private
   * @param {string} string The string to format.
   * @returns {string} The formatted string.
   */
  function format(string) {
    string = trim(string);
    return /^(?:webOS|i(?:OS|P))/.test(string)
      ? string
      : capitalize(string);
  }

  /**
   * Iterates over an object's own properties, executing the `callback` for each.
   *
   * @private
   * @param {Object} object The object to iterate over.
   * @param {Function} callback The function executed per own property.
   */
  function forOwn(object, callback) {
    for (var key in object) {
      if (hasOwnProperty.call(object, key)) {
        callback(object[key], key, object);
      }
    }
  }

  /**
   * Gets the internal `[[Class]]` of a value.
   *
   * @private
   * @param {*} value The value.
   * @returns {string} The `[[Class]]`.
   */
  function getClassOf(value) {
    return value == null
      ? capitalize(value)
      : toString.call(value).slice(8, -1);
  }

  /**
   * Host objects can return type values that are different from their actual
   * data type. The objects we are concerned with usually return non-primitive
   * types of "object", "function", or "unknown".
   *
   * @private
   * @param {*} object The owner of the property.
   * @param {string} property The property to check.
   * @returns {boolean} Returns `true` if the property value is a non-primitive, else `false`.
   */
  function isHostType(object, property) {
    var type = object != null ? typeof object[property] : 'number';
    return !/^(?:boolean|number|string|undefined)$/.test(type) &&
      (type == 'object' ? !!object[property] : true);
  }

  /**
   * Prepares a string for use in a `RegExp` by making hyphens and spaces optional.
   *
   * @private
   * @param {string} string The string to qualify.
   * @returns {string} The qualified string.
   */
  function qualify(string) {
    return String(string).replace(/([ -])(?!$)/g, '$1?');
  }

  /**
   * A bare-bones `Array#reduce` like utility function.
   *
   * @private
   * @param {Array} array The array to iterate over.
   * @param {Function} callback The function called per iteration.
   * @returns {*} The accumulated result.
   */
  function reduce(array, callback) {
    var accumulator = null;
    each(array, function(value, index) {
      accumulator = callback(accumulator, value, index, array);
    });
    return accumulator;
  }

  /**
   * Removes leading and trailing whitespace from a string.
   *
   * @private
   * @param {string} string The string to trim.
   * @returns {string} The trimmed string.
   */
  function trim(string) {
    return String(string).replace(/^ +| +$/g, '');
  }

  /*--------------------------------------------------------------------------*/

  /**
   * Creates a new platform object.
   *
   * @memberOf platform
   * @param {Object|string} [ua=navigator.userAgent] The user agent string or
   *  context object.
   * @returns {Object} A platform object.
   */
  function parse(ua) {

    /** The environment context object. */
    var context = root;

    /** Used to flag when a custom context is provided. */
    var isCustomContext = ua && typeof ua == 'object' && getClassOf(ua) != 'String';

    // Juggle arguments.
    if (isCustomContext) {
      context = ua;
      ua = null;
    }

    /** Browser navigator object. */
    var nav = context.navigator || {};

    /** Browser user agent string. */
    var userAgent = nav.userAgent || '';

    ua || (ua = userAgent);

    /** Used to flag when `thisBinding` is the [ModuleScope]. */
    var isModuleScope = isCustomContext || thisBinding == oldRoot;

    /** Used to detect if browser is like Chrome. */
    var likeChrome = isCustomContext
      ? !!nav.likeChrome
      : /\bChrome\b/.test(ua) && !/internal|\n/i.test(toString.toString());

    /** Internal `[[Class]]` value shortcuts. */
    var objectClass = 'Object',
        airRuntimeClass = isCustomContext ? objectClass : 'ScriptBridgingProxyObject',
        enviroClass = isCustomContext ? objectClass : 'Environment',
        javaClass = (isCustomContext && context.java) ? 'JavaPackage' : getClassOf(context.java),
        phantomClass = isCustomContext ? objectClass : 'RuntimeObject';

    /** Detect Java environments. */
    var java = /\bJava/.test(javaClass) && context.java;

    /** Detect Rhino. */
    var rhino = java && getClassOf(context.environment) == enviroClass;

    /** A character to represent alpha. */
    var alpha = java ? 'a' : '\u03b1';

    /** A character to represent beta. */
    var beta = java ? 'b' : '\u03b2';

    /** Browser document object. */
    var doc = context.document || {};

    /**
     * Detect Opera browser (Presto-based).
     * http://www.howtocreate.co.uk/operaStuff/operaObject.html
     * http://dev.opera.com/articles/view/opera-mini-web-content-authoring-guidelines/#operamini
     */
    var opera = context.operamini || context.opera;

    /** Opera `[[Class]]`. */
    var operaClass = reOpera.test(operaClass = (isCustomContext && opera) ? opera['[[Class]]'] : getClassOf(opera))
      ? operaClass
      : (opera = null);

    /*------------------------------------------------------------------------*/

    /** Temporary variable used over the script's lifetime. */
    var data;

    /** The CPU architecture. */
    var arch = ua;

    /** Platform description array. */
    var description = [];

    /** Platform alpha/beta indicator. */
    var prerelease = null;

    /** A flag to indicate that environment features should be used to resolve the platform. */
    var useFeatures = ua == userAgent;

    /** The browser/environment version. */
    var version = useFeatures && opera && typeof opera.version == 'function' && opera.version();

    /** A flag to indicate if the OS ends with "/ Version" */
    var isSpecialCasedOS;

    /* Detectable layout engines (order is important). */
    var layout = getLayout([
      { 'label': 'EdgeHTML', 'pattern': 'Edge' },
      'Trident',
      { 'label': 'WebKit', 'pattern': 'AppleWebKit' },
      'iCab',
      'Presto',
      'NetFront',
      'Tasman',
      'KHTML',
      'Gecko'
    ]);

    /* Detectable browser names (order is important). */
    var name = getName([
      'Adobe AIR',
      'Arora',
      'Avant Browser',
      'Breach',
      'Camino',
      'Electron',
      'Epiphany',
      'Fennec',
      'Flock',
      'Galeon',
      'GreenBrowser',
      'iCab',
      'Iceweasel',
      'K-Meleon',
      'Konqueror',
      'Lunascape',
      'Maxthon',
      { 'label': 'Microsoft Edge', 'pattern': 'Edge' },
      'Midori',
      'Nook Browser',
      'PaleMoon',
      'PhantomJS',
      'Raven',
      'Rekonq',
      'RockMelt',
      { 'label': 'Samsung Internet', 'pattern': 'SamsungBrowser' },
      'SeaMonkey',
      { 'label': 'Silk', 'pattern': '(?:Cloud9|Silk-Accelerated)' },
      'Sleipnir',
      'SlimBrowser',
      { 'label': 'SRWare Iron', 'pattern': 'Iron' },
      'Sunrise',
      'Swiftfox',
      'Waterfox',
      'WebPositive',
      'Opera Mini',
      { 'label': 'Opera Mini', 'pattern': 'OPiOS' },
      'Opera',
      { 'label': 'Opera', 'pattern': 'OPR' },
      'Chrome',
      { 'label': 'Chrome Mobile', 'pattern': '(?:CriOS|CrMo)' },
      { 'label': 'Firefox', 'pattern': '(?:Firefox|Minefield)' },
      { 'label': 'Firefox for iOS', 'pattern': 'FxiOS' },
      { 'label': 'IE', 'pattern': 'IEMobile' },
      { 'label': 'IE', 'pattern': 'MSIE' },
      'Safari'
    ]);

    /* Detectable products (order is important). */
    var product = getProduct([
      { 'label': 'BlackBerry', 'pattern': 'BB10' },
      'BlackBerry',
      { 'label': 'Galaxy S', 'pattern': 'GT-I9000' },
      { 'label': 'Galaxy S2', 'pattern': 'GT-I9100' },
      { 'label': 'Galaxy S3', 'pattern': 'GT-I9300' },
      { 'label': 'Galaxy S4', 'pattern': 'GT-I9500' },
      { 'label': 'Galaxy S5', 'pattern': 'SM-G900' },
      { 'label': 'Galaxy S6', 'pattern': 'SM-G920' },
      { 'label': 'Galaxy S6 Edge', 'pattern': 'SM-G925' },
      { 'label': 'Galaxy S7', 'pattern': 'SM-G930' },
      { 'label': 'Galaxy S7 Edge', 'pattern': 'SM-G935' },
      'Google TV',
      'Lumia',
      'iPad',
      'iPod',
      'iPhone',
      'Kindle',
      { 'label': 'Kindle Fire', 'pattern': '(?:Cloud9|Silk-Accelerated)' },
      'Nexus',
      'Nook',
      'PlayBook',
      'PlayStation Vita',
      'PlayStation',
      'TouchPad',
      'Transformer',
      { 'label': 'Wii U', 'pattern': 'WiiU' },
      'Wii',
      'Xbox One',
      { 'label': 'Xbox 360', 'pattern': 'Xbox' },
      'Xoom'
    ]);

    /* Detectable manufacturers. */
    var manufacturer = getManufacturer({
      'Apple': { 'iPad': 1, 'iPhone': 1, 'iPod': 1 },
      'Archos': {},
      'Amazon': { 'Kindle': 1, 'Kindle Fire': 1 },
      'Asus': { 'Transformer': 1 },
      'Barnes & Noble': { 'Nook': 1 },
      'BlackBerry': { 'PlayBook': 1 },
      'Google': { 'Google TV': 1, 'Nexus': 1 },
      'HP': { 'TouchPad': 1 },
      'HTC': {},
      'LG': {},
      'Microsoft': { 'Xbox': 1, 'Xbox One': 1 },
      'Motorola': { 'Xoom': 1 },
      'Nintendo': { 'Wii U': 1,  'Wii': 1 },
      'Nokia': { 'Lumia': 1 },
      'Samsung': { 'Galaxy S': 1, 'Galaxy S2': 1, 'Galaxy S3': 1, 'Galaxy S4': 1 },
      'Sony': { 'PlayStation': 1, 'PlayStation Vita': 1 }
    });

    /* Detectable operating systems (order is important). */
    var os = getOS([
      'Windows Phone',
      'Android',
      'CentOS',
      { 'label': 'Chrome OS', 'pattern': 'CrOS' },
      'Debian',
      'Fedora',
      'FreeBSD',
      'Gentoo',
      'Haiku',
      'Kubuntu',
      'Linux Mint',
      'OpenBSD',
      'Red Hat',
      'SuSE',
      'Ubuntu',
      'Xubuntu',
      'Cygwin',
      'Symbian OS',
      'hpwOS',
      'webOS ',
      'webOS',
      'Tablet OS',
      'Tizen',
      'Linux',
      'Mac OS X',
      'Macintosh',
      'Mac',
      'Windows 98;',
      'Windows '
    ]);

    /*------------------------------------------------------------------------*/

    /**
     * Picks the layout engine from an array of guesses.
     *
     * @private
     * @param {Array} guesses An array of guesses.
     * @returns {null|string} The detected layout engine.
     */
    function getLayout(guesses) {
      return reduce(guesses, function(result, guess) {
        return result || RegExp('\\b' + (
          guess.pattern || qualify(guess)
        ) + '\\b', 'i').exec(ua) && (guess.label || guess);
      });
    }

    /**
     * Picks the manufacturer from an array of guesses.
     *
     * @private
     * @param {Array} guesses An object of guesses.
     * @returns {null|string} The detected manufacturer.
     */
    function getManufacturer(guesses) {
      return reduce(guesses, function(result, value, key) {
        // Lookup the manufacturer by product or scan the UA for the manufacturer.
        return result || (
          value[product] ||
          value[/^[a-z]+(?: +[a-z]+\b)*/i.exec(product)] ||
          RegExp('\\b' + qualify(key) + '(?:\\b|\\w*\\d)', 'i').exec(ua)
        ) && key;
      });
    }

    /**
     * Picks the browser name from an array of guesses.
     *
     * @private
     * @param {Array} guesses An array of guesses.
     * @returns {null|string} The detected browser name.
     */
    function getName(guesses) {
      return reduce(guesses, function(result, guess) {
        return result || RegExp('\\b' + (
          guess.pattern || qualify(guess)
        ) + '\\b', 'i').exec(ua) && (guess.label || guess);
      });
    }

    /**
     * Picks the OS name from an array of guesses.
     *
     * @private
     * @param {Array} guesses An array of guesses.
     * @returns {null|string} The detected OS name.
     */
    function getOS(guesses) {
      return reduce(guesses, function(result, guess) {
        var pattern = guess.pattern || qualify(guess);
        if (!result && (result =
              RegExp('\\b' + pattern + '(?:/[\\d.]+|[ \\w.]*)', 'i').exec(ua)
            )) {
          result = cleanupOS(result, pattern, guess.label || guess);
        }
        return result;
      });
    }

    /**
     * Picks the product name from an array of guesses.
     *
     * @private
     * @param {Array} guesses An array of guesses.
     * @returns {null|string} The detected product name.
     */
    function getProduct(guesses) {
      return reduce(guesses, function(result, guess) {
        var pattern = guess.pattern || qualify(guess);
        if (!result && (result =
              RegExp('\\b' + pattern + ' *\\d+[.\\w_]*', 'i').exec(ua) ||
              RegExp('\\b' + pattern + ' *\\w+-[\\w]*', 'i').exec(ua) ||
              RegExp('\\b' + pattern + '(?:; *(?:[a-z]+[_-])?[a-z]+\\d+|[^ ();-]*)', 'i').exec(ua)
            )) {
          // Split by forward slash and append product version if needed.
          if ((result = String((guess.label && !RegExp(pattern, 'i').test(guess.label)) ? guess.label : result).split('/'))[1] && !/[\d.]+/.test(result[0])) {
            result[0] += ' ' + result[1];
          }
          // Correct character case and cleanup string.
          guess = guess.label || guess;
          result = format(result[0]
            .replace(RegExp(pattern, 'i'), guess)
            .replace(RegExp('; *(?:' + guess + '[_-])?', 'i'), ' ')
            .replace(RegExp('(' + guess + ')[-_.]?(\\w)', 'i'), '$1 $2'));
        }
        return result;
      });
    }

    /**
     * Resolves the version using an array of UA patterns.
     *
     * @private
     * @param {Array} patterns An array of UA patterns.
     * @returns {null|string} The detected version.
     */
    function getVersion(patterns) {
      return reduce(patterns, function(result, pattern) {
        return result || (RegExp(pattern +
          '(?:-[\\d.]+/|(?: for [\\w-]+)?[ /-])([\\d.]+[^ ();/_-]*)', 'i').exec(ua) || 0)[1] || null;
      });
    }

    /**
     * Returns `platform.description` when the platform object is coerced to a string.
     *
     * @name toString
     * @memberOf platform
     * @returns {string} Returns `platform.description` if available, else an empty string.
     */
    function toStringPlatform() {
      return this.description || '';
    }

    /*------------------------------------------------------------------------*/

    // Convert layout to an array so we can add extra details.
    layout && (layout = [layout]);

    // Detect product names that contain their manufacturer's name.
    if (manufacturer && !product) {
      product = getProduct([manufacturer]);
    }
    // Clean up Google TV.
    if ((data = /\bGoogle TV\b/.exec(product))) {
      product = data[0];
    }
    // Detect simulators.
    if (/\bSimulator\b/i.test(ua)) {
      product = (product ? product + ' ' : '') + 'Simulator';
    }
    // Detect Opera Mini 8+ running in Turbo/Uncompressed mode on iOS.
    if (name == 'Opera Mini' && /\bOPiOS\b/.test(ua)) {
      description.push('running in Turbo/Uncompressed mode');
    }
    // Detect IE Mobile 11.
    if (name == 'IE' && /\blike iPhone OS\b/.test(ua)) {
      data = parse(ua.replace(/like iPhone OS/, ''));
      manufacturer = data.manufacturer;
      product = data.product;
    }
    // Detect iOS.
    else if (/^iP/.test(product)) {
      name || (name = 'Safari');
      os = 'iOS' + ((data = / OS ([\d_]+)/i.exec(ua))
        ? ' ' + data[1].replace(/_/g, '.')
        : '');
    }
    // Detect Kubuntu.
    else if (name == 'Konqueror' && !/buntu/i.test(os)) {
      os = 'Kubuntu';
    }
    // Detect Android browsers.
    else if ((manufacturer && manufacturer != 'Google' &&
        ((/Chrome/.test(name) && !/\bMobile Safari\b/i.test(ua)) || /\bVita\b/.test(product))) ||
        (/\bAndroid\b/.test(os) && /^Chrome/.test(name) && /\bVersion\//i.test(ua))) {
      name = 'Android Browser';
      os = /\bAndroid\b/.test(os) ? os : 'Android';
    }
    // Detect Silk desktop/accelerated modes.
    else if (name == 'Silk') {
      if (!/\bMobi/i.test(ua)) {
        os = 'Android';
        description.unshift('desktop mode');
      }
      if (/Accelerated *= *true/i.test(ua)) {
        description.unshift('accelerated');
      }
    }
    // Detect PaleMoon identifying as Firefox.
    else if (name == 'PaleMoon' && (data = /\bFirefox\/([\d.]+)\b/.exec(ua))) {
      description.push('identifying as Firefox ' + data[1]);
    }
    // Detect Firefox OS and products running Firefox.
    else if (name == 'Firefox' && (data = /\b(Mobile|Tablet|TV)\b/i.exec(ua))) {
      os || (os = 'Firefox OS');
      product || (product = data[1]);
    }
    // Detect false positives for Firefox/Safari.
    else if (!name || (data = !/\bMinefield\b/i.test(ua) && /\b(?:Firefox|Safari)\b/.exec(name))) {
      // Escape the `/` for Firefox 1.
      if (name && !product && /[\/,]|^[^(]+?\)/.test(ua.slice(ua.indexOf(data + '/') + 8))) {
        // Clear name of false positives.
        name = null;
      }
      // Reassign a generic name.
      if ((data = product || manufacturer || os) &&
          (product || manufacturer || /\b(?:Android|Symbian OS|Tablet OS|webOS)\b/.test(os))) {
        name = /[a-z]+(?: Hat)?/i.exec(/\bAndroid\b/.test(os) ? os : data) + ' Browser';
      }
    }
    // Add Chrome version to description for Electron.
    else if (name == 'Electron' && (data = (/\bChrome\/([\d.]+)\b/.exec(ua) || 0)[1])) {
      description.push('Chromium ' + data);
    }
    // Detect non-Opera (Presto-based) versions (order is important).
    if (!version) {
      version = getVersion([
        '(?:Cloud9|CriOS|CrMo|Edge|FxiOS|IEMobile|Iron|Opera ?Mini|OPiOS|OPR|Raven|SamsungBrowser|Silk(?!/[\\d.]+$))',
        'Version',
        qualify(name),
        '(?:Firefox|Minefield|NetFront)'
      ]);
    }
    // Detect stubborn layout engines.
    if ((data =
          layout == 'iCab' && parseFloat(version) > 3 && 'WebKit' ||
          /\bOpera\b/.test(name) && (/\bOPR\b/.test(ua) ? 'Blink' : 'Presto') ||
          /\b(?:Midori|Nook|Safari)\b/i.test(ua) && !/^(?:Trident|EdgeHTML)$/.test(layout) && 'WebKit' ||
          !layout && /\bMSIE\b/i.test(ua) && (os == 'Mac OS' ? 'Tasman' : 'Trident') ||
          layout == 'WebKit' && /\bPlayStation\b(?! Vita\b)/i.test(name) && 'NetFront'
        )) {
      layout = [data];
    }
    // Detect Windows Phone 7 desktop mode.
    if (name == 'IE' && (data = (/; *(?:XBLWP|ZuneWP)(\d+)/i.exec(ua) || 0)[1])) {
      name += ' Mobile';
      os = 'Windows Phone ' + (/\+$/.test(data) ? data : data + '.x');
      description.unshift('desktop mode');
    }
    // Detect Windows Phone 8.x desktop mode.
    else if (/\bWPDesktop\b/i.test(ua)) {
      name = 'IE Mobile';
      os = 'Windows Phone 8.x';
      description.unshift('desktop mode');
      version || (version = (/\brv:([\d.]+)/.exec(ua) || 0)[1]);
    }
    // Detect IE 11 identifying as other browsers.
    else if (name != 'IE' && layout == 'Trident' && (data = /\brv:([\d.]+)/.exec(ua))) {
      if (name) {
        description.push('identifying as ' + name + (version ? ' ' + version : ''));
      }
      name = 'IE';
      version = data[1];
    }
    // Leverage environment features.
    if (useFeatures) {
      // Detect server-side environments.
      // Rhino has a global function while others have a global object.
      if (isHostType(context, 'global')) {
        if (java) {
          data = java.lang.System;
          arch = data.getProperty('os.arch');
          os = os || data.getProperty('os.name') + ' ' + data.getProperty('os.version');
        }
        if (rhino) {
          try {
            version = context.require('ringo/engine').version.join('.');
            name = 'RingoJS';
          } catch(e) {
            if ((data = context.system) && data.global.system == context.system) {
              name = 'Narwhal';
              os || (os = data[0].os || null);
            }
          }
          if (!name) {
            name = 'Rhino';
          }
        }
        else if (
          typeof context.process == 'object' && !context.process.browser &&
          (data = context.process)
        ) {
          if (typeof data.versions == 'object') {
            if (typeof data.versions.electron == 'string') {
              description.push('Node ' + data.versions.node);
              name = 'Electron';
              version = data.versions.electron;
            } else if (typeof data.versions.nw == 'string') {
              description.push('Chromium ' + version, 'Node ' + data.versions.node);
              name = 'NW.js';
              version = data.versions.nw;
            }
          }
          if (!name) {
            name = 'Node.js';
            arch = data.arch;
            os = data.platform;
            version = /[\d.]+/.exec(data.version);
            version = version ? version[0] : null;
          }
        }
      }
      // Detect Adobe AIR.
      else if (getClassOf((data = context.runtime)) == airRuntimeClass) {
        name = 'Adobe AIR';
        os = data.flash.system.Capabilities.os;
      }
      // Detect PhantomJS.
      else if (getClassOf((data = context.phantom)) == phantomClass) {
        name = 'PhantomJS';
        version = (data = data.version || null) && (data.major + '.' + data.minor + '.' + data.patch);
      }
      // Detect IE compatibility modes.
      else if (typeof doc.documentMode == 'number' && (data = /\bTrident\/(\d+)/i.exec(ua))) {
        // We're in compatibility mode when the Trident version + 4 doesn't
        // equal the document mode.
        version = [version, doc.documentMode];
        if ((data = +data[1] + 4) != version[1]) {
          description.push('IE ' + version[1] + ' mode');
          layout && (layout[1] = '');
          version[1] = data;
        }
        version = name == 'IE' ? String(version[1].toFixed(1)) : version[0];
      }
      // Detect IE 11 masking as other browsers.
      else if (typeof doc.documentMode == 'number' && /^(?:Chrome|Firefox)\b/.test(name)) {
        description.push('masking as ' + name + ' ' + version);
        name = 'IE';
        version = '11.0';
        layout = ['Trident'];
        os = 'Windows';
      }
      os = os && format(os);
    }
    // Detect prerelease phases.
    if (version && (data =
          /(?:[ab]|dp|pre|[ab]\d+pre)(?:\d+\+?)?$/i.exec(version) ||
          /(?:alpha|beta)(?: ?\d)?/i.exec(ua + ';' + (useFeatures && nav.appMinorVersion)) ||
          /\bMinefield\b/i.test(ua) && 'a'
        )) {
      prerelease = /b/i.test(data) ? 'beta' : 'alpha';
      version = version.replace(RegExp(data + '\\+?$'), '') +
        (prerelease == 'beta' ? beta : alpha) + (/\d+\+?/.exec(data) || '');
    }
    // Detect Firefox Mobile.
    if (name == 'Fennec' || name == 'Firefox' && /\b(?:Android|Firefox OS)\b/.test(os)) {
      name = 'Firefox Mobile';
    }
    // Obscure Maxthon's unreliable version.
    else if (name == 'Maxthon' && version) {
      version = version.replace(/\.[\d.]+/, '.x');
    }
    // Detect Xbox 360 and Xbox One.
    else if (/\bXbox\b/i.test(product)) {
      if (product == 'Xbox 360') {
        os = null;
      }
      if (product == 'Xbox 360' && /\bIEMobile\b/.test(ua)) {
        description.unshift('mobile mode');
      }
    }
    // Add mobile postfix.
    else if ((/^(?:Chrome|IE|Opera)$/.test(name) || name && !product && !/Browser|Mobi/.test(name)) &&
        (os == 'Windows CE' || /Mobi/i.test(ua))) {
      name += ' Mobile';
    }
    // Detect IE platform preview.
    else if (name == 'IE' && useFeatures) {
      try {
        if (context.external === null) {
          description.unshift('platform preview');
        }
      } catch(e) {
        description.unshift('embedded');
      }
    }
    // Detect BlackBerry OS version.
    // http://docs.blackberry.com/en/developers/deliverables/18169/HTTP_headers_sent_by_BB_Browser_1234911_11.jsp
    else if ((/\bBlackBerry\b/.test(product) || /\bBB10\b/.test(ua)) && (data =
          (RegExp(product.replace(/ +/g, ' *') + '/([.\\d]+)', 'i').exec(ua) || 0)[1] ||
          version
        )) {
      data = [data, /BB10/.test(ua)];
      os = (data[1] ? (product = null, manufacturer = 'BlackBerry') : 'Device Software') + ' ' + data[0];
      version = null;
    }
    // Detect Opera identifying/masking itself as another browser.
    // http://www.opera.com/support/kb/view/843/
    else if (this != forOwn && product != 'Wii' && (
          (useFeatures && opera) ||
          (/Opera/.test(name) && /\b(?:MSIE|Firefox)\b/i.test(ua)) ||
          (name == 'Firefox' && /\bOS X (?:\d+\.){2,}/.test(os)) ||
          (name == 'IE' && (
            (os && !/^Win/.test(os) && version > 5.5) ||
            /\bWindows XP\b/.test(os) && version > 8 ||
            version == 8 && !/\bTrident\b/.test(ua)
          ))
        ) && !reOpera.test((data = parse.call(forOwn, ua.replace(reOpera, '') + ';'))) && data.name) {
      // When "identifying", the UA contains both Opera and the other browser's name.
      data = 'ing as ' + data.name + ((data = data.version) ? ' ' + data : '');
      if (reOpera.test(name)) {
        if (/\bIE\b/.test(data) && os == 'Mac OS') {
          os = null;
        }
        data = 'identify' + data;
      }
      // When "masking", the UA contains only the other browser's name.
      else {
        data = 'mask' + data;
        if (operaClass) {
          name = format(operaClass.replace(/([a-z])([A-Z])/g, '$1 $2'));
        } else {
          name = 'Opera';
        }
        if (/\bIE\b/.test(data)) {
          os = null;
        }
        if (!useFeatures) {
          version = null;
        }
      }
      layout = ['Presto'];
      description.push(data);
    }
    // Detect WebKit Nightly and approximate Chrome/Safari versions.
    if ((data = (/\bAppleWebKit\/([\d.]+\+?)/i.exec(ua) || 0)[1])) {
      // Correct build number for numeric comparison.
      // (e.g. "532.5" becomes "532.05")
      data = [parseFloat(data.replace(/\.(\d)$/, '.0$1')), data];
      // Nightly builds are postfixed with a "+".
      if (name == 'Safari' && data[1].slice(-1) == '+') {
        name = 'WebKit Nightly';
        prerelease = 'alpha';
        version = data[1].slice(0, -1);
      }
      // Clear incorrect browser versions.
      else if (version == data[1] ||
          version == (data[2] = (/\bSafari\/([\d.]+\+?)/i.exec(ua) || 0)[1])) {
        version = null;
      }
      // Use the full Chrome version when available.
      data[1] = (/\bChrome\/([\d.]+)/i.exec(ua) || 0)[1];
      // Detect Blink layout engine.
      if (data[0] == 537.36 && data[2] == 537.36 && parseFloat(data[1]) >= 28 && layout == 'WebKit') {
        layout = ['Blink'];
      }
      // Detect JavaScriptCore.
      // http://stackoverflow.com/questions/6768474/how-can-i-detect-which-javascript-engine-v8-or-jsc-is-used-at-runtime-in-androi
      if (!useFeatures || (!likeChrome && !data[1])) {
        layout && (layout[1] = 'like Safari');
        data = (data = data[0], data < 400 ? 1 : data < 500 ? 2 : data < 526 ? 3 : data < 533 ? 4 : data < 534 ? '4+' : data < 535 ? 5 : data < 537 ? 6 : data < 538 ? 7 : data < 601 ? 8 : '8');
      } else {
        layout && (layout[1] = 'like Chrome');
        data = data[1] || (data = data[0], data < 530 ? 1 : data < 532 ? 2 : data < 532.05 ? 3 : data < 533 ? 4 : data < 534.03 ? 5 : data < 534.07 ? 6 : data < 534.10 ? 7 : data < 534.13 ? 8 : data < 534.16 ? 9 : data < 534.24 ? 10 : data < 534.30 ? 11 : data < 535.01 ? 12 : data < 535.02 ? '13+' : data < 535.07 ? 15 : data < 535.11 ? 16 : data < 535.19 ? 17 : data < 536.05 ? 18 : data < 536.10 ? 19 : data < 537.01 ? 20 : data < 537.11 ? '21+' : data < 537.13 ? 23 : data < 537.18 ? 24 : data < 537.24 ? 25 : data < 537.36 ? 26 : layout != 'Blink' ? '27' : '28');
      }
      // Add the postfix of ".x" or "+" for approximate versions.
      layout && (layout[1] += ' ' + (data += typeof data == 'number' ? '.x' : /[.+]/.test(data) ? '' : '+'));
      // Obscure version for some Safari 1-2 releases.
      if (name == 'Safari' && (!version || parseInt(version) > 45)) {
        version = data;
      }
    }
    // Detect Opera desktop modes.
    if (name == 'Opera' &&  (data = /\bzbov|zvav$/.exec(os))) {
      name += ' ';
      description.unshift('desktop mode');
      if (data == 'zvav') {
        name += 'Mini';
        version = null;
      } else {
        name += 'Mobile';
      }
      os = os.replace(RegExp(' *' + data + '$'), '');
    }
    // Detect Chrome desktop mode.
    else if (name == 'Safari' && /\bChrome\b/.exec(layout && layout[1])) {
      description.unshift('desktop mode');
      name = 'Chrome Mobile';
      version = null;

      if (/\bOS X\b/.test(os)) {
        manufacturer = 'Apple';
        os = 'iOS 4.3+';
      } else {
        os = null;
      }
    }
    // Strip incorrect OS versions.
    if (version && version.indexOf((data = /[\d.]+$/.exec(os))) == 0 &&
        ua.indexOf('/' + data + '-') > -1) {
      os = trim(os.replace(data, ''));
    }
    // Add layout engine.
    if (layout && !/\b(?:Avant|Nook)\b/.test(name) && (
        /Browser|Lunascape|Maxthon/.test(name) ||
        name != 'Safari' && /^iOS/.test(os) && /\bSafari\b/.test(layout[1]) ||
        /^(?:Adobe|Arora|Breach|Midori|Opera|Phantom|Rekonq|Rock|Samsung Internet|Sleipnir|Web)/.test(name) && layout[1])) {
      // Don't add layout details to description if they are falsey.
      (data = layout[layout.length - 1]) && description.push(data);
    }
    // Combine contextual information.
    if (description.length) {
      description = ['(' + description.join('; ') + ')'];
    }
    // Append manufacturer to description.
    if (manufacturer && product && product.indexOf(manufacturer) < 0) {
      description.push('on ' + manufacturer);
    }
    // Append product to description.
    if (product) {
      description.push((/^on /.test(description[description.length - 1]) ? '' : 'on ') + product);
    }
    // Parse the OS into an object.
    if (os) {
      data = / ([\d.+]+)$/.exec(os);
      isSpecialCasedOS = data && os.charAt(os.length - data[0].length - 1) == '/';
      os = {
        'architecture': 32,
        'family': (data && !isSpecialCasedOS) ? os.replace(data[0], '') : os,
        'version': data ? data[1] : null,
        'toString': function() {
          var version = this.version;
          return this.family + ((version && !isSpecialCasedOS) ? ' ' + version : '') + (this.architecture == 64 ? ' 64-bit' : '');
        }
      };
    }
    // Add browser/OS architecture.
    if ((data = /\b(?:AMD|IA|Win|WOW|x86_|x)64\b/i.exec(arch)) && !/\bi686\b/i.test(arch)) {
      if (os) {
        os.architecture = 64;
        os.family = os.family.replace(RegExp(' *' + data), '');
      }
      if (
          name && (/\bWOW64\b/i.test(ua) ||
          (useFeatures && /\w(?:86|32)$/.test(nav.cpuClass || nav.platform) && !/\bWin64; x64\b/i.test(ua)))
      ) {
        description.unshift('32-bit');
      }
    }
    // Chrome 39 and above on OS X is always 64-bit.
    else if (
        os && /^OS X/.test(os.family) &&
        name == 'Chrome' && parseFloat(version) >= 39
    ) {
      os.architecture = 64;
    }

    ua || (ua = null);

    /*------------------------------------------------------------------------*/

    /**
     * The platform object.
     *
     * @name platform
     * @type Object
     */
    var platform = {};

    /**
     * The platform description.
     *
     * @memberOf platform
     * @type string|null
     */
    platform.description = ua;

    /**
     * The name of the browser's layout engine.
     *
     * The list of common layout engines include:
     * "Blink", "EdgeHTML", "Gecko", "Trident" and "WebKit"
     *
     * @memberOf platform
     * @type string|null
     */
    platform.layout = layout && layout[0];

    /**
     * The name of the product's manufacturer.
     *
     * The list of manufacturers include:
     * "Apple", "Archos", "Amazon", "Asus", "Barnes & Noble", "BlackBerry",
     * "Google", "HP", "HTC", "LG", "Microsoft", "Motorola", "Nintendo",
     * "Nokia", "Samsung" and "Sony"
     *
     * @memberOf platform
     * @type string|null
     */
    platform.manufacturer = manufacturer;

    /**
     * The name of the browser/environment.
     *
     * The list of common browser names include:
     * "Chrome", "Electron", "Firefox", "Firefox for iOS", "IE",
     * "Microsoft Edge", "PhantomJS", "Safari", "SeaMonkey", "Silk",
     * "Opera Mini" and "Opera"
     *
     * Mobile versions of some browsers have "Mobile" appended to their name:
     * eg. "Chrome Mobile", "Firefox Mobile", "IE Mobile" and "Opera Mobile"
     *
     * @memberOf platform
     * @type string|null
     */
    platform.name = name;

    /**
     * The alpha/beta release indicator.
     *
     * @memberOf platform
     * @type string|null
     */
    platform.prerelease = prerelease;

    /**
     * The name of the product hosting the browser.
     *
     * The list of common products include:
     *
     * "BlackBerry", "Galaxy S4", "Lumia", "iPad", "iPod", "iPhone", "Kindle",
     * "Kindle Fire", "Nexus", "Nook", "PlayBook", "TouchPad" and "Transformer"
     *
     * @memberOf platform
     * @type string|null
     */
    platform.product = product;

    /**
     * The browser's user agent string.
     *
     * @memberOf platform
     * @type string|null
     */
    platform.ua = ua;

    /**
     * The browser/environment version.
     *
     * @memberOf platform
     * @type string|null
     */
    platform.version = name && version;

    /**
     * The name of the operating system.
     *
     * @memberOf platform
     * @type Object
     */
    platform.os = os || {

      /**
       * The CPU architecture the OS is built for.
       *
       * @memberOf platform.os
       * @type number|null
       */
      'architecture': null,

      /**
       * The family of the OS.
       *
       * Common values include:
       * "Windows", "Windows Server 2008 R2 / 7", "Windows Server 2008 / Vista",
       * "Windows XP", "OS X", "Ubuntu", "Debian", "Fedora", "Red Hat", "SuSE",
       * "Android", "iOS" and "Windows Phone"
       *
       * @memberOf platform.os
       * @type string|null
       */
      'family': null,

      /**
       * The version of the OS.
       *
       * @memberOf platform.os
       * @type string|null
       */
      'version': null,

      /**
       * Returns the OS string.
       *
       * @memberOf platform.os
       * @returns {string} The OS string.
       */
      'toString': function() { return 'null'; }
    };

    platform.parse = parse;
    platform.toString = toStringPlatform;

    if (platform.version) {
      description.unshift(version);
    }
    if (platform.name) {
      description.unshift(name);
    }
    if (os && name && !(os == String(os).split(' ')[0] && (os == name.split(' ')[0] || product))) {
      description.push(product ? '(' + os + ')' : 'on ' + os);
    }
    if (description.length) {
      platform.description = description.join(' ');
    }
    return platform;
  }

  /*--------------------------------------------------------------------------*/

  // Export platform.
  var platform = parse();

  // Some AMD build optimizers, like r.js, check for condition patterns like the following:
  if (true) {
    // Expose platform on the global object to prevent errors when platform is
    // loaded by a script tag in the presence of an AMD loader.
    // See http://requirejs.org/docs/errors.html#mismatch for more details.
    root.platform = platform;

    // Define as an anonymous module so platform can be aliased through path mapping.
    !(__WEBPACK_AMD_DEFINE_RESULT__ = function() {
      return platform;
    }.call(exports, __webpack_require__, exports, module),
				__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
  }
  // Check for `exports` after `define` in case a build optimizer adds an `exports` object.
  else if (freeExports && freeModule) {
    // Export for CommonJS support.
    forOwn(platform, function(value, key) {
      freeExports[key] = value;
    });
  }
  else {
    // Export to the global object.
    root.platform = platform;
  }
}.call(this));

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(41)(module), __webpack_require__(4)))

/***/ }),

/***/ 4983:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var isArray = exports.isArray = function isArray(arr) {
  return Array.isArray(arr);
};

var isPlainObject = exports.isPlainObject = function isPlainObject(obj) {
  var isObject = (typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) === 'object' && obj !== null && !isArray(obj);
  if (!isObject || obj.toString && obj.toString() !== '[object Object]') return false;
  var proto = Object.getPrototypeOf(obj);
  if (proto === null) {
    return true;
  }
  var Ctor = Object.prototype.hasOwnProperty.call(proto, 'constructor') && proto.constructor;
  return typeof Ctor === 'function' && Ctor instanceof Ctor && Function.prototype.toString.call(Ctor) === Function.prototype.toString.call(Object);
};

var findKey = exports.findKey = function findKey(obj, fn) {
  if (!isPlainObject(obj) && !isArray(obj)) return;

  var keys = Object.keys(obj);
  return keys.find(function (key) {
    return fn(obj[key]);
  });
};

var compact = exports.compact = function compact(arr) {
  return arr.filter(Boolean);
};

var flattenOnce = function flattenOnce(arr) {
  var recurse = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

  return arr.reduce(function (acc, val) {
    if (isArray(val) && recurse) return acc.concat(flattenOnce(val, false));
    acc.push(val);
    return acc;
  }, []);
};

var flatten = exports.flatten = function flatten(arr) {
  if (!isArray(arr)) throw new Error('flatten expects an array');
  return flattenOnce(arr);
};

var map = exports.map = function map(itr, fn) {
  if (isArray(itr)) return itr.map(fn);

  var results = [];
  var keys = Object.keys(itr);
  var len = keys.length;
  for (var i = 0; i < len; i += 1) {
    var key = keys[i];
    results.push(fn(itr[key], key));
  }

  return results;
};

/***/ }),

/***/ 4984:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


module.exports = __webpack_require__(4985);

/***/ }),

/***/ 4985:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = __webpack_require__(1);

var _react2 = _interopRequireDefault(_react);

var _invariant = __webpack_require__(107);

var _invariant2 = _interopRequireDefault(_invariant);

var _combokeys = __webpack_require__(4986);

var _combokeys2 = _interopRequireDefault(_combokeys);

var _propTypes = __webpack_require__(10);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _helpers = __webpack_require__(4016);

var _helpers2 = _interopRequireDefault(_helpers);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _class = function (_React$Component) {
  _inherits(_class, _React$Component);

  function _class() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, _class);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = _class.__proto__ || Object.getPrototypeOf(_class)).call.apply(_ref, [this].concat(args))), _this), _this._combokeys = null, _this._lastEvent = null, _this._bindShortcuts = function (shortcutsArr) {
      var element = _this._getElementToBind();
      element.setAttribute('tabindex', _this.props.tabIndex);
      _this._combokeys = new _combokeys2.default(element, { storeInstancesGlobally: false });
      _this._decorateCombokeys();
      _this._combokeys.bind(shortcutsArr, _this._handleShortcuts, _this.props.eventType);

      if (_this.props.global) {
        element.addEventListener('shortcuts:global', _this._customGlobalHandler);
      }
    }, _this._customGlobalHandler = function (e) {
      var _e$detail = e.detail,
          character = _e$detail.character,
          modifiers = _e$detail.modifiers,
          event = _e$detail.event;


      var targetNode = null;
      if (_this.props.targetNodeSelector) {
        targetNode = document.querySelector(_this.props.targetNodeSelector);
      }

      if (e.target !== _this._domNode && e.target !== targetNode) {
        _this._combokeys.handleKey(character, modifiers, event, true);
      }
    }, _this._decorateCombokeys = function () {
      var element = _this._getElementToBind();
      var originalHandleKey = _this._combokeys.handleKey.bind(_this._combokeys);

      // NOTE: stopCallback is a method that is called to see
      // if the keyboard event should fire
      _this._combokeys.stopCallback = function (event, domElement, combo) {
        var isInputLikeElement = domElement.tagName === 'INPUT' || domElement.tagName === 'SELECT' || domElement.tagName === 'TEXTAREA' || domElement.contentEditable && domElement.contentEditable === 'true';

        var isReturnString = void 0;
        if (event.key) {
          isReturnString = event.key.length === 1;
        } else {
          isReturnString = Boolean(_helpers2.default.getCharacter(event));
        }

        if (isInputLikeElement && isReturnString && !_this.props.alwaysFireHandler) {
          return true;
        }

        return false;
      };

      _this._combokeys.handleKey = function (character, modifiers, event, isGlobalHandler) {
        if (_this._lastEvent && event.timeStamp === _this._lastEvent.timeStamp && event.type === _this._lastEvent.type) {
          return;
        }
        _this._lastEvent = event;

        var isolateOwner = false;
        if (_this.props.isolate && !event.__isolateShortcuts) {
          event.__isolateShortcuts = true;
          isolateOwner = true;
        }

        if (!isGlobalHandler) {
          element.dispatchEvent(new CustomEvent('shortcuts:global', {
            detail: { character: character, modifiers: modifiers, event: event },
            bubbles: true,
            cancelable: true
          }));
        }

        // NOTE: works normally if it's not an isolated event
        if (!event.__isolateShortcuts) {
          if (_this.props.preventDefault) {
            event.preventDefault();
          }
          if (_this.props.stopPropagation && !isGlobalHandler) {
            event.stopPropagation();
          }
          originalHandleKey(character, modifiers, event);
          return;
        }

        // NOTE: global shortcuts should work even for an isolated event
        if (_this.props.global || isolateOwner) {
          originalHandleKey(character, modifiers, event);
        }
      };
    }, _this._getElementToBind = function () {
      var element = null;
      if (_this.props.targetNodeSelector) {
        element = document.querySelector(_this.props.targetNodeSelector);
        (0, _invariant2.default)(element, 'Node selector \'' + _this.props.targetNodeSelector + '\'  was not found.');
      } else {
        element = _this._domNode;
      }

      return element;
    }, _this._unbindShortcuts = function () {
      if (_this._combokeys) {
        _this._combokeys.detach();
        _this._combokeys.reset();
      }
    }, _this._onUpdate = function () {
      var shortcutsArr = _this.props.name && _this.context.shortcuts.getShortcuts(_this.props.name);
      _this._unbindShortcuts();
      _this._bindShortcuts(shortcutsArr || []);
    }, _this._handleShortcuts = function (event, keyName) {
      if (_this.props.name) {
        var shortcutName = _this.context.shortcuts.findShortcutName(keyName, _this.props.name);

        if (_this.props.handler) {
          _this.props.handler(shortcutName, event);
        }
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(_class, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this._onUpdate();

      if (this.props.name) {
        this.context.shortcuts.addUpdateListener(this._onUpdate);
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this._unbindShortcuts();

      if (this.props.name) {
        this.context.shortcuts.removeUpdateListener(this._onUpdate);
      }

      if (this.props.global) {
        var element = this._getElementToBind();
        element.removeEventListener('shortcuts:global', this._customGlobalHandler);
      }
    }

    // NOTE: combokeys must be instance per component

  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      return _react2.default.createElement(
        'div',
        {
          ref: function ref(node) {
            _this2._domNode = node;
          },
          tabIndex: this.props.tabIndex,
          className: this.props.className
        },
        this.props.children
      );
    }
  }]);

  return _class;
}(_react2.default.Component);

_class.displayName = 'Shortcuts';
_class.contextTypes = {
  shortcuts: _propTypes2.default.object.isRequired
};
_class.propTypes = {
  children: _propTypes2.default.node,
  handler: _propTypes2.default.func,
  name: _propTypes2.default.string,
  tabIndex: _propTypes2.default.number,
  className: _propTypes2.default.string,
  eventType: _propTypes2.default.string,
  stopPropagation: _propTypes2.default.bool,
  preventDefault: _propTypes2.default.bool,
  targetNodeSelector: _propTypes2.default.string,
  global: _propTypes2.default.bool,
  isolate: _propTypes2.default.bool,
  alwaysFireHandler: _propTypes2.default.bool
};
_class.defaultProps = {
  tabIndex: -1,
  className: null,
  eventType: null,
  stopPropagation: true,
  preventDefault: false,
  targetNodeSelector: null,
  global: false,
  isolate: false,
  alwaysFireHandler: false
};
exports.default = _class;
module.exports = exports['default'];

/***/ }),

/***/ 4986:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-env node, browser */


module.exports = function (element, options) {
  var self = this
  var Combokeys = self.constructor

  /**
   * an object of passed options
   *
   * @type { storeInstancesGlobally?: true }
   */

  self.options = Object.assign({ storeInstancesGlobally: true }, options || {})

  /**
   * a list of all the callbacks setup via Combokeys.bind()
   *
   * @type {Object}
   */
  self.callbacks = {}

  /**
   * direct map of string combinations to callbacks used for trigger()
   *
   * @type {Object}
   */
  self.directMap = {}

  /**
   * keeps track of what level each sequence is at since multiple
   * sequences can start out with the same sequence
   *
   * @type {Object}
   */
  self.sequenceLevels = {}

  /**
   * variable to store the setTimeout call
   *
   * @type {null|number}
   */
  self.resetTimer = null

  /**
   * temporary state where we will ignore the next keyup
   *
   * @type {boolean|string}
   */
  self.ignoreNextKeyup = false

  /**
   * temporary state where we will ignore the next keypress
   *
   * @type {boolean}
   */
  self.ignoreNextKeypress = false

  /**
   * are we currently inside of a sequence?
   * type of action ("keyup" or "keydown" or "keypress") or false
   *
   * @type {boolean|string}
   */
  self.nextExpectedAction = false

  self.element = element

  self.addEvents()

  if (self.options.storeInstancesGlobally) {
    Combokeys.instances.push(self)
  }

  return self
}

module.exports.prototype.bind = __webpack_require__(4987)
module.exports.prototype.bindMultiple = __webpack_require__(4988)
module.exports.prototype.unbind = __webpack_require__(4989)
module.exports.prototype.trigger = __webpack_require__(4990)
module.exports.prototype.reset = __webpack_require__(4991)
module.exports.prototype.stopCallback = __webpack_require__(4992)
module.exports.prototype.handleKey = __webpack_require__(4993)
module.exports.prototype.addEvents = __webpack_require__(4994)
module.exports.prototype.bindSingle = __webpack_require__(4998)
module.exports.prototype.getKeyInfo = __webpack_require__(4999)
module.exports.prototype.pickBestAction = __webpack_require__(5003)
module.exports.prototype.getReverseMap = __webpack_require__(5004)
module.exports.prototype.getMatches = __webpack_require__(5005)
module.exports.prototype.resetSequences = __webpack_require__(5007)
module.exports.prototype.fireCallback = __webpack_require__(5008)
module.exports.prototype.bindSequence = __webpack_require__(5011)
module.exports.prototype.resetSequenceTimer = __webpack_require__(5012)
module.exports.prototype.detach = __webpack_require__(5013)

module.exports.instances = []
module.exports.reset = __webpack_require__(5014)

/**
 * variable to store the flipped version of MAP from above
 * needed to check if we should use keypress or not when no action
 * is specified
 *
 * @type {Object|undefined}
 */
module.exports.REVERSE_MAP = null


/***/ }),

/***/ 4987:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-env node, browser */

/**
 * binds an event to Combokeys
 *
 * can be a single key, a combination of keys separated with +,
 * an array of keys, or a sequence of keys separated by spaces
 *
 * be sure to list the modifier keys first to make sure that the
 * correct key ends up getting bound (the last key in the pattern)
 *
 * @param {string|Array} keys
 * @param {Function} callback
 * @param {string=} action - "keypress", "keydown", or "keyup"
 * @returns void
 */
module.exports = function (keys, callback, action) {
  var self = this

  keys = keys instanceof Array ? keys : [keys]
  self.bindMultiple(keys, callback, action)
  return self
}


/***/ }),

/***/ 4988:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-env node, browser */


/**
 * binds multiple combinations to the same callback
 *
 * @param {Array} combinations
 * @param {Function} callback
 * @param {string|undefined} action
 * @returns void
 */
module.exports = function (combinations, callback, action) {
  var self = this

  for (var j = 0; j < combinations.length; ++j) {
    self.bindSingle(combinations[j], callback, action)
  }
}


/***/ }),

/***/ 4989:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-env node, browser */

/**
 * unbinds an event to Combokeys
 *
 * the unbinding sets the callback function of the specified key combo
 * to an empty function and deletes the corresponding key in the
 * directMap dict.
 *
 * TODO: actually remove this from the callbacks dictionary instead
 * of binding an empty function
 *
 * the keycombo+action has to be exactly the same as
 * it was defined in the bind method
 *
 * @param {string|Array} keys
 * @param {string} action
 * @returns void
 */
module.exports = function (keys, action) {
  var self = this

  return self.bind(keys, function () {}, action)
}


/***/ }),

/***/ 4990:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-env node, browser */

/**
 * triggers an event that has already been bound
 *
 * @param {string} keys
 * @param {string=} action
 * @returns void
 */
module.exports = function (keys, action) {
  var self = this
  if (self.directMap[keys + ':' + action]) {
    self.directMap[keys + ':' + action]({}, keys)
  }
  return this
}


/***/ }),

/***/ 4991:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-env node, browser */


/**
 * resets the library back to its initial state. This is useful
 * if you want to clear out the current keyboard shortcuts and bind
 * new ones - for example if you switch to another page
 *
 * @returns void
 */
module.exports = function () {
  var self = this
  self.callbacks = {}
  self.directMap = {}
  return this
}


/***/ }),

/***/ 4992:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-env node, browser */


/**
* should we stop this event before firing off callbacks
*
* @param {Event} e
* @param {Element} element
* @return {boolean}
*/
module.exports = function (e, element) {
  // if the element has the class "combokeys" then no need to stop
  if ((' ' + element.className + ' ').indexOf(' combokeys ') > -1) {
    return false
  }

  var tagName = element.tagName.toLowerCase()

  // stop for input, select, and textarea
  return tagName === 'input' || tagName === 'select' || tagName === 'textarea' || element.isContentEditable
}


/***/ }),

/***/ 4993:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-env node, browser */


/**
 * handles a character key event
 *
 * @param {string} character
 * @param {Array} modifiers
 * @param {Event} e
 * @returns void
 */
module.exports = function (character, modifiers, e) {
  var self = this
  var callbacks
  var j
  var doNotReset = {}
  var maxLevel = 0
  var processedSequenceCallback = false
  var isModifier
  var ignoreThisKeypress

  callbacks = self.getMatches(character, modifiers, e)
  // Calculate the maxLevel for sequences so we can only execute the longest callback sequence
  for (j = 0; j < callbacks.length; ++j) {
    if (callbacks[j].seq) {
      maxLevel = Math.max(maxLevel, callbacks[j].level)
    }
  }

  // loop through matching callbacks for this key event
  for (j = 0; j < callbacks.length; ++j) {
    // fire for all sequence callbacks
    // this is because if for example you have multiple sequences
    // bound such as "g i" and "g t" they both need to fire the
    // callback for matching g cause otherwise you can only ever
    // match the first one
    if (callbacks[j].seq) {
      // only fire callbacks for the maxLevel to prevent
      // subsequences from also firing
      //
      // for example 'a option b' should not cause 'option b' to fire
      // even though 'option b' is part of the other sequence
      //
      // any sequences that do not match here will be discarded
      // below by the resetSequences call
      if (callbacks[j].level !== maxLevel) {
        continue
      }

      processedSequenceCallback = true

      // keep a list of which sequences were matches for later
      doNotReset[callbacks[j].seq] = 1
      self.fireCallback(callbacks[j].callback, e, callbacks[j].combo, callbacks[j].seq)
      continue
    }

    // if there were no sequence matches but we are still here
    // that means this is a regular match so we should fire that
    if (!processedSequenceCallback) {
      self.fireCallback(callbacks[j].callback, e, callbacks[j].combo)
    }
  }

  // if the key you pressed matches the type of sequence without
  // being a modifier (ie "keyup" or "keypress") then we should
  // reset all sequences that were not matched by this event
  //
  // this is so, for example, if you have the sequence "h a t" and you
  // type "h e a r t" it does not match.  in this case the "e" will
  // cause the sequence to reset
  //
  // modifier keys are ignored because you can have a sequence
  // that contains modifiers such as "enter ctrl+space" and in most
  // cases the modifier key will be pressed before the next key
  //
  // also if you have a sequence such as "ctrl+b a" then pressing the
  // "b" key will trigger a "keypress" and a "keydown"
  //
  // the "keydown" is expected when there is a modifier, but the
  // "keypress" ends up matching the nextExpectedAction since it occurs
  // after and that causes the sequence to reset
  //
  // we ignore keypresses in a sequence that directly follow a keydown
  // for the same character
  ignoreThisKeypress = e.type === 'keypress' && self.ignoreNextKeypress
  isModifier = __webpack_require__(3769)
  if (e.type === self.nextExpectedAction && !isModifier(character) && !ignoreThisKeypress) {
    self.resetSequences(doNotReset)
  }

  self.ignoreNextKeypress = processedSequenceCallback && e.type === 'keydown'
}


/***/ }),

/***/ 4994:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-env node, browser */

module.exports = function () {
  var self = this
  var on = __webpack_require__(4017)
  var element = self.element

  self.eventHandler = __webpack_require__(4995).bind(self)

  on(element, 'keypress', self.eventHandler)
  on(element, 'keydown', self.eventHandler)
  on(element, 'keyup', self.eventHandler)
}


/***/ }),

/***/ 4995:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-env node, browser */


/**
 * handles a keydown event
 *
 * @param {Event} e
 * @returns void
 */
module.exports = function (e) {
  var self = this
  var characterFromEvent
  var eventModifiers

  // normalize e.which for key events
  // @see http://stackoverflow.com/questions/4285627/javascript-keycode-vs-charcode-utter-confusion
  if (typeof e.which !== 'number') {
    e.which = e.keyCode
  }
  characterFromEvent = __webpack_require__(4018)
  var character = characterFromEvent(e)

  // no character found then stop
  if (character === undefined) {
    return
  }

  // need to use === for the character check because the character can be 0
  if (e.type === 'keyup' && self.ignoreNextKeyup === character) {
    self.ignoreNextKeyup = false
    return
  }

  eventModifiers = __webpack_require__(4997)
  self.handleKey(character, eventModifiers(e), e)
}


/***/ }),

/***/ 4996:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-env node, browser */

/**
 * mapping for special characters so they can support
 *
 * this dictionary is only used incase you want to bind a
 * keyup or keydown event to one of these keys
 *
 * @type {Object}
 */
module.exports = {
  106: '*',
  107: 'plus',
  109: 'minus',
  110: '.',
  111: '/',
  186: ';',
  187: '=',
  188: ',',
  189: '-',
  190: '.',
  191: '/',
  192: '`',
  219: '[',
  220: '\\',
  221: ']',
  222: "'"
}


/***/ }),

/***/ 4997:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-env node, browser */


/**
 * takes a key event and figures out what the modifiers are
 *
 * @param {Event} e
 * @returns {Array}
 */
module.exports = function (e) {
  var modifiers = []

  if (e.shiftKey) {
    modifiers.push('shift')
  }

  if (e.altKey) {
    modifiers.push('alt')
  }

  if (e.ctrlKey) {
    modifiers.push('ctrl')
  }

  if (e.metaKey) {
    modifiers.push('meta')
  }

  return modifiers
}


/***/ }),

/***/ 4998:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-env node, browser */


/**
 * binds a single keyboard combination
 *
 * @param {string} combination
 * @param {Function} callback
 * @param {string=} action
 * @param {string=} sequenceName - name of sequence if part of sequence
 * @param {number=} level - what part of the sequence the command is
 * @returns void
 */
module.exports = function (combination, callback, action, sequenceName, level) {
  var self = this

  // store a direct mapped reference for use with Combokeys.trigger
  self.directMap[combination + ':' + action] = callback

  // make sure multiple spaces in a row become a single space
  combination = combination.replace(/\s+/g, ' ')

  var sequence = combination.split(' ')
  var info

  // if this pattern is a sequence of keys then run through this method
  // to reprocess each pattern one key at a time
  if (sequence.length > 1) {
    self.bindSequence(combination, sequence, callback, action)
    return
  }

  info = self.getKeyInfo(combination, action)

  // make sure to initialize array if this is the first time
  // a callback is added for this key
  self.callbacks[info.key] = self.callbacks[info.key] || []

  // remove an existing match if there is one
  self.getMatches(info.key, info.modifiers, {type: info.action}, sequenceName, combination, level)

  // add this call back to the array
  // if it is a sequence put it at the beginning
  // if not put it at the end
  //
  // this is important because the way these are processed expects
  // the sequence ones to come first
  self.callbacks[info.key][sequenceName ? 'unshift' : 'push']({
    callback: callback,
    modifiers: info.modifiers,
    action: info.action,
    seq: sequenceName,
    level: level,
    combo: combination
  })
}


/***/ }),

/***/ 4999:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-env node, browser */


/**
 * Gets info for a specific key combination
 *
 * @param  {string} combination key combination ("command+s" or "a" or "*")
 * @param  {string=} action
 * @returns {Object}
 */
module.exports = function (combination, action) {
  var self = this
  var keysFromString
  var keys
  var key
  var j
  var modifiers = []
  var SPECIAL_ALIASES
  var SHIFT_MAP
  var isModifier

  keysFromString = __webpack_require__(5000)
  // take the keys from this pattern and figure out what the actual
  // pattern is all about
  keys = keysFromString(combination)

  SPECIAL_ALIASES = __webpack_require__(5001)
  SHIFT_MAP = __webpack_require__(5002)
  isModifier = __webpack_require__(3769)
  for (j = 0; j < keys.length; ++j) {
    key = keys[j]

    // normalize key names
    if (SPECIAL_ALIASES[key]) {
      key = SPECIAL_ALIASES[key]
    }

    // if this is not a keypress event then we should
    // be smart about using shift keys
    // this will only work for US keyboards however
    if (action && action !== 'keypress' && SHIFT_MAP[key]) {
      key = SHIFT_MAP[key]
      modifiers.push('shift')
    }

    // if this key is a modifier then add it to the list of modifiers
    if (isModifier(key)) {
      modifiers.push(key)
    }
  }

  // depending on what the key combination is
  // we will try to pick the best event for it
  action = self.pickBestAction(key, modifiers, action)

  return {
    key: key,
    modifiers: modifiers,
    action: action
  }
}


/***/ }),

/***/ 5000:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-env node, browser */


/**
 * Converts from a string key combination to an array
 *
 * @param  {string} combination like "command+shift+l"
 * @return {Array}
 */
module.exports = function (combination) {
  if (combination === '+') {
    return ['+']
  }

  return combination.split('+')
}


/***/ }),

/***/ 5001:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-env node, browser */

/**
 * this is a list of special strings you can use to map
 * to modifier keys when you specify your keyboard shortcuts
 *
 * @type {Object}
 */
module.exports = {
  'option': 'alt',
  'command': 'meta',
  'return': 'enter',
  'escape': 'esc',
  'mod': /Mac|iPod|iPhone|iPad/.test(navigator.platform) ? 'meta' : 'ctrl'
}


/***/ }),

/***/ 5002:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-env node, browser */

/**
 * this is a mapping of keys that require shift on a US keypad
 * back to the non shift equivelents
 *
 * this is so you can use keyup events with these keys
 *
 * note that this will only work reliably on US keyboards
 *
 * @type {Object}
 */
module.exports = {
  '~': '`',
  '!': '1',
  '@': '2',
  '#': '3',
  '$': '4',
  '%': '5',
  '^': '6',
  '&': '7',
  '*': '8',
  '(': '9',
  ')': '0',
  '_': '-',
  '+': '=',
  ':': ';',
  '"': "'",
  '<': ',',
  '>': '.',
  '?': '/',
  '|': '\\'
}


/***/ }),

/***/ 5003:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-env node, browser */


/**
 * picks the best action based on the key combination
 *
 * @param {string} key - character for key
 * @param {Array} modifiers
 * @param {string=} action passed in
 */
module.exports = function (key, modifiers, action) {
  var self = this

  // if no action was picked in we should try to pick the one
  // that we think would work best for this key
  if (!action) {
    action = self.getReverseMap()[key] ? 'keydown' : 'keypress'
  }

  // modifier keys don't work as expected with keypress,
  // switch to keydown
  if (action === 'keypress' && modifiers.length) {
    action = 'keydown'
  }

  return action
}


/***/ }),

/***/ 5004:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-env node, browser */


/**
 * reverses the map lookup so that we can look for specific keys
 * to see what can and can't use keypress
 *
 * @return {Object}
 */
module.exports = function () {
  var self = this
  var constructor = self.constructor
  var SPECIAL_KEYS_MAP

  if (!constructor.REVERSE_MAP) {
    constructor.REVERSE_MAP = {}
    SPECIAL_KEYS_MAP = __webpack_require__(4019)
    for (var key in SPECIAL_KEYS_MAP) {
      // pull out the numeric keypad from here cause keypress should
      // be able to detect the keys from the character
      if (key > 95 && key < 112) {
        continue
      }

      if (SPECIAL_KEYS_MAP.hasOwnProperty(key)) {
        constructor.REVERSE_MAP[SPECIAL_KEYS_MAP[key]] = key
      }
    }
  }
  return constructor.REVERSE_MAP
}


/***/ }),

/***/ 5005:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-env node, browser */


/**
 * finds all callbacks that match based on the keycode, modifiers,
 * and action
 *
 * @param {string} character
 * @param {Array} modifiers
 * @param {Event|Object} e
 * @param {string=} sequenceName - name of the sequence we are looking for
 * @param {string=} combination
 * @param {number=} level
 * @returns {Array}
 */
module.exports = function (character, modifiers, e, sequenceName, combination, level) {
  var self = this
  var j
  var callback
  var matches = []
  var action = e.type
  var isModifier
  var modifiersMatch

  if (
      action === 'keypress' &&
      // Firefox fires keypress for arrows
      !(e.code && e.code.slice(0, 5) === 'Arrow')
  ) {
    // 'any-character' callbacks are only on `keypress`
    var anyCharCallbacks = self.callbacks['any-character'] || []
    anyCharCallbacks.forEach(function (callback) {
      matches.push(callback)
    })
  }

  if (!self.callbacks[character]) { return matches }

  isModifier = __webpack_require__(3769)
  // if a modifier key is coming up on its own we should allow it
  if (action === 'keyup' && isModifier(character)) {
    modifiers = [character]
  }

  // loop through all callbacks for the key that was pressed
  // and see if any of them match
  for (j = 0; j < self.callbacks[character].length; ++j) {
    callback = self.callbacks[character][j]

    // if a sequence name is not specified, but this is a sequence at
    // the wrong level then move onto the next match
    if (!sequenceName && callback.seq && self.sequenceLevels[callback.seq] !== callback.level) {
      continue
    }

    // if the action we are looking for doesn't match the action we got
    // then we should keep going
    if (action !== callback.action) {
      continue
    }

    // if this is a keypress event and the meta key and control key
    // are not pressed that means that we need to only look at the
    // character, otherwise check the modifiers as well
    //
    // chrome will not fire a keypress if meta or control is down
    // safari will fire a keypress if meta or meta+shift is down
    // firefox will fire a keypress if meta or control is down
    modifiersMatch = __webpack_require__(5006)
    if ((action === 'keypress' && !e.metaKey && !e.ctrlKey) || modifiersMatch(modifiers, callback.modifiers)) {
      // when you bind a combination or sequence a second time it
      // should overwrite the first one.  if a sequenceName or
      // combination is specified in this call it does just that
      //
      // @todo make deleting its own method?
      var deleteCombo = !sequenceName && callback.combo === combination
      var deleteSequence = sequenceName && callback.seq === sequenceName && callback.level === level
      if (deleteCombo || deleteSequence) {
        self.callbacks[character].splice(j, 1)
      }

      matches.push(callback)
    }
  }

  return matches
}


/***/ }),

/***/ 5006:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-env node, browser */


/**
 * checks if two arrays are equal
 *
 * @param {Array} modifiers1
 * @param {Array} modifiers2
 * @returns {boolean}
 */
module.exports = function (modifiers1, modifiers2) {
  return modifiers1.sort().join(',') === modifiers2.sort().join(',')
}


/***/ }),

/***/ 5007:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-env node, browser */


/**
 * resets all sequence counters except for the ones passed in
 *
 * @param {Object} doNotReset
 * @returns void
 */
module.exports = function (doNotReset) {
  var self = this

  doNotReset = doNotReset || {}

  var activeSequences = false
  var key

  for (key in self.sequenceLevels) {
    if (doNotReset[key]) {
      activeSequences = true
      continue
    }
    self.sequenceLevels[key] = 0
  }

  if (!activeSequences) {
    self.nextExpectedAction = false
  }
}


/***/ }),

/***/ 5008:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-env node, browser */


/**
 * actually calls the callback function
 *
 * if your callback function returns false this will use the jquery
 * convention - prevent default and stop propogation on the event
 *
 * @param {Function} callback
 * @param {Event} e
 * @returns void
 */
module.exports = function (callback, e, combo, sequence) {
  var self = this
  var preventDefault
  var stopPropagation

  // if this event should not happen stop here
  if (self.stopCallback(e, e.target || e.srcElement, combo, sequence)) {
    return
  }

  if (callback(e, combo) === false) {
    preventDefault = __webpack_require__(5009)
    preventDefault(e)
    stopPropagation = __webpack_require__(5010)
    stopPropagation(e)
  }
}


/***/ }),

/***/ 5009:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-env node, browser */


/**
 * prevents default for this event
 *
 * @param {Event} e
 * @returns void
 */
module.exports = function (e) {
  if (e.preventDefault) {
    e.preventDefault()
    return
  }

  e.returnValue = false
}


/***/ }),

/***/ 5010:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-env node, browser */


/**
 * stops propogation for this event
 *
 * @param {Event} e
 * @returns void
 */
module.exports = function (e) {
  if (e.stopPropagation) {
    e.stopPropagation()
    return
  }

  e.cancelBubble = true
}


/***/ }),

/***/ 5011:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-env node, browser */


/**
 * binds a key sequence to an event
 *
 * @param {string} combo - combo specified in bind call
 * @param {Array} keys
 * @param {Function} callback
 * @param {string=} action
 * @returns void
 */
module.exports = function (combo, keys, callback, action) {
  var self = this

  // start off by adding a sequence level record for this combination
  // and setting the level to 0
  self.sequenceLevels[combo] = 0

  /**
   * callback to increase the sequence level for this sequence and reset
   * all other sequences that were active
   *
   * @param {string} nextAction
   * @returns {Function}
   */
  function increaseSequence (nextAction) {
    return function () {
      self.nextExpectedAction = nextAction
      ++self.sequenceLevels[combo]
      self.resetSequenceTimer()
    }
  }

  /**
   * wraps the specified callback inside of another function in order
   * to reset all sequence counters as soon as this sequence is done
   *
   * @param {Event} e
   * @returns void
   */
  function callbackAndReset (e) {
    var characterFromEvent
    self.fireCallback(callback, e, combo)

    // we should ignore the next key up if the action is key down
    // or keypress.  this is so if you finish a sequence and
    // release the key the final key will not trigger a keyup
    if (action !== 'keyup') {
      characterFromEvent = __webpack_require__(4018)
      self.ignoreNextKeyup = characterFromEvent(e)
    }

    // weird race condition if a sequence ends with the key
    // another sequence begins with
    setTimeout(
      function () {
        self.resetSequences()
      },
      10
    )
  }

  // loop through keys one at a time and bind the appropriate callback
  // function.  for any key leading up to the final one it should
  // increase the sequence. after the final, it should reset all sequences
  //
  // if an action is specified in the original bind call then that will
  // be used throughout.  otherwise we will pass the action that the
  // next key in the sequence should match.  this allows a sequence
  // to mix and match keypress and keydown events depending on which
  // ones are better suited to the key provided
  for (var j = 0; j < keys.length; ++j) {
    var isFinal = j + 1 === keys.length
    var wrappedCallback = isFinal ? callbackAndReset : increaseSequence(action || self.getKeyInfo(keys[j + 1]).action)
    self.bindSingle(keys[j], wrappedCallback, action, combo, j)
  }
}


/***/ }),

/***/ 5012:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-env node, browser */

/**
 * called to set a 1 second timeout on the specified sequence
 *
 * this is so after each key press in the sequence you have 1 second
 * to press the next key before you have to start over
 *
 * @returns void
 */
module.exports = function () {
  var self = this

  clearTimeout(self.resetTimer)
  self.resetTimer = setTimeout(
    function () {
      self.resetSequences()
    },
    1000
  )
}


/***/ }),

/***/ 5013:
/***/ (function(module, exports, __webpack_require__) {

var off = __webpack_require__(4017).off
module.exports = function () {
  var self = this
  var element = self.element

  off(element, 'keypress', self.eventHandler)
  off(element, 'keydown', self.eventHandler)
  off(element, 'keyup', self.eventHandler)
}


/***/ }),

/***/ 5014:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-env node, browser */


module.exports = function () {
  var self = this

  self.instances.forEach(function (combokeys) {
    combokeys.reset()
  })
}


/***/ }),

/***/ 5015:
/***/ (function(module, exports, __webpack_require__) {

var baseGetTag = __webpack_require__(105),
    isObjectLike = __webpack_require__(84);

/** `Object#toString` result references. */
var numberTag = '[object Number]';

/**
 * Checks if `value` is classified as a `Number` primitive or object.
 *
 * **Note:** To exclude `Infinity`, `-Infinity`, and `NaN`, which are
 * classified as numbers, use the `_.isFinite` method.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a number, else `false`.
 * @example
 *
 * _.isNumber(3);
 * // => true
 *
 * _.isNumber(Number.MIN_VALUE);
 * // => true
 *
 * _.isNumber(Infinity);
 * // => true
 *
 * _.isNumber('3');
 * // => false
 */
function isNumber(value) {
  return typeof value == 'number' ||
    (isObjectLike(value) && baseGetTag(value) == numberTag);
}

module.exports = isNumber;


/***/ }),

/***/ 5016:
/***/ (function(module, exports, __webpack_require__) {

var baseGetTag = __webpack_require__(105),
    isObjectLike = __webpack_require__(84);

/** `Object#toString` result references. */
var boolTag = '[object Boolean]';

/**
 * Checks if `value` is classified as a boolean primitive or object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a boolean, else `false`.
 * @example
 *
 * _.isBoolean(false);
 * // => true
 *
 * _.isBoolean(null);
 * // => false
 */
function isBoolean(value) {
  return value === true || value === false ||
    (isObjectLike(value) && baseGetTag(value) == boolTag);
}

module.exports = isBoolean;


/***/ }),

/***/ 5017:
/***/ (function(module, exports, __webpack_require__) {

var baseForOwn = __webpack_require__(995),
    castFunction = __webpack_require__(1506);

/**
 * Iterates over own enumerable string keyed properties of an object and
 * invokes `iteratee` for each property. The iteratee is invoked with three
 * arguments: (value, key, object). Iteratee functions may exit iteration
 * early by explicitly returning `false`.
 *
 * @static
 * @memberOf _
 * @since 0.3.0
 * @category Object
 * @param {Object} object The object to iterate over.
 * @param {Function} [iteratee=_.identity] The function invoked per iteration.
 * @returns {Object} Returns `object`.
 * @see _.forOwnRight
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 *   this.b = 2;
 * }
 *
 * Foo.prototype.c = 3;
 *
 * _.forOwn(new Foo, function(value, key) {
 *   console.log(key);
 * });
 * // => Logs 'a' then 'b' (iteration order is not guaranteed).
 */
function forOwn(object, iteratee) {
  return object && baseForOwn(object, castFunction(iteratee));
}

module.exports = forOwn;


/***/ }),

/***/ 5018:
/***/ (function(module, exports, __webpack_require__) {

var arrayPush = __webpack_require__(669),
    baseFlatten = __webpack_require__(1012),
    copyArray = __webpack_require__(1521),
    isArray = __webpack_require__(51);

/**
 * Creates a new array concatenating `array` with any additional arrays
 * and/or values.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Array
 * @param {Array} array The array to concatenate.
 * @param {...*} [values] The values to concatenate.
 * @returns {Array} Returns the new concatenated array.
 * @example
 *
 * var array = [1];
 * var other = _.concat(array, 2, [3], [[4]]);
 *
 * console.log(other);
 * // => [1, 2, 3, [4]]
 *
 * console.log(array);
 * // => [1]
 */
function concat() {
  var length = arguments.length;
  if (!length) {
    return [];
  }
  var args = Array(length - 1),
      array = arguments[0],
      index = length;

  while (index--) {
    args[index - 1] = arguments[index];
  }
  return arrayPush(isArray(array) ? copyArray(array) : [array], baseFlatten(args, 1));
}

module.exports = concat;


/***/ }),

/***/ 5019:
/***/ (function(module, exports, __webpack_require__) {

var arrayFilter = __webpack_require__(668),
    baseFilter = __webpack_require__(1522),
    baseIteratee = __webpack_require__(537),
    isArray = __webpack_require__(51),
    negate = __webpack_require__(5020);

/**
 * The opposite of `_.filter`; this method returns the elements of `collection`
 * that `predicate` does **not** return truthy for.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Collection
 * @param {Array|Object} collection The collection to iterate over.
 * @param {Function} [predicate=_.identity] The function invoked per iteration.
 * @returns {Array} Returns the new filtered array.
 * @see _.filter
 * @example
 *
 * var users = [
 *   { 'user': 'barney', 'age': 36, 'active': false },
 *   { 'user': 'fred',   'age': 40, 'active': true }
 * ];
 *
 * _.reject(users, function(o) { return !o.active; });
 * // => objects for ['fred']
 *
 * // The `_.matches` iteratee shorthand.
 * _.reject(users, { 'age': 40, 'active': true });
 * // => objects for ['barney']
 *
 * // The `_.matchesProperty` iteratee shorthand.
 * _.reject(users, ['active', false]);
 * // => objects for ['fred']
 *
 * // The `_.property` iteratee shorthand.
 * _.reject(users, 'active');
 * // => objects for ['barney']
 */
function reject(collection, predicate) {
  var func = isArray(collection) ? arrayFilter : baseFilter;
  return func(collection, negate(baseIteratee(predicate, 3)));
}

module.exports = reject;


/***/ }),

/***/ 5020:
/***/ (function(module, exports) {

/** Error message constants. */
var FUNC_ERROR_TEXT = 'Expected a function';

/**
 * Creates a function that negates the result of the predicate `func`. The
 * `func` predicate is invoked with the `this` binding and arguments of the
 * created function.
 *
 * @static
 * @memberOf _
 * @since 3.0.0
 * @category Function
 * @param {Function} predicate The predicate to negate.
 * @returns {Function} Returns the new negated function.
 * @example
 *
 * function isEven(n) {
 *   return n % 2 == 0;
 * }
 *
 * _.filter([1, 2, 3, 4, 5, 6], _.negate(isEven));
 * // => [1, 3, 5]
 */
function negate(predicate) {
  if (typeof predicate != 'function') {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  return function() {
    var args = arguments;
    switch (args.length) {
      case 0: return !predicate.call(this);
      case 1: return !predicate.call(this, args[0]);
      case 2: return !predicate.call(this, args[0], args[1]);
      case 3: return !predicate.call(this, args[0], args[1], args[2]);
    }
    return !predicate.apply(this, args);
  };
}

module.exports = negate;


/***/ }),

/***/ 5021:
/***/ (function(module, exports, __webpack_require__) {

var baseRest = __webpack_require__(372),
    isIterateeCall = __webpack_require__(1631);

/**
 * Creates a function like `_.assign`.
 *
 * @private
 * @param {Function} assigner The function to assign values.
 * @returns {Function} Returns the new assigner function.
 */
function createAssigner(assigner) {
  return baseRest(function(object, sources) {
    var index = -1,
        length = sources.length,
        customizer = length > 1 ? sources[length - 1] : undefined,
        guard = length > 2 ? sources[2] : undefined;

    customizer = (assigner.length > 3 && typeof customizer == 'function')
      ? (length--, customizer)
      : undefined;

    if (guard && isIterateeCall(sources[0], sources[1], guard)) {
      customizer = length < 3 ? undefined : customizer;
      length = 1;
    }
    object = Object(object);
    while (++index < length) {
      var source = sources[index];
      if (source) {
        assigner(object, source, index, customizer);
      }
    }
    return object;
  });
}

module.exports = createAssigner;


/***/ }),

/***/ 5022:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = {
  navigation: {
    MOVE_LEFT: 'left',
    MOVE_RIGHT: 'right',
    MOVE_UP: 'up',
    MOVE_DOWN: 'down',
    MOVE_TAB: 'tab',
    MOVE_SHIFT_TAB: 'shift+tab'
  }
};

/***/ }),

/***/ 5023:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = __webpack_require__(1);

var _react2 = _interopRequireDefault(_react);

var _assign = __webpack_require__(4020);

var _assign2 = _interopRequireDefault(_assign);

var _StringInput = __webpack_require__(5024);

var _StringInput2 = _interopRequireDefault(_StringInput);

var _NumberInput = __webpack_require__(5025);

var _NumberInput2 = _interopRequireDefault(_NumberInput);

var _BooleanInput = __webpack_require__(5026);

var _BooleanInput2 = _interopRequireDefault(_BooleanInput);

var _ObjectMeta = __webpack_require__(5027);

var _ObjectMeta2 = _interopRequireDefault(_ObjectMeta);

var _ArrayMeta = __webpack_require__(5028);

var _ArrayMeta2 = _interopRequireDefault(_ArrayMeta);

var _ObjectNameInput = __webpack_require__(5029);

var _ObjectNameInput2 = _interopRequireDefault(_ObjectNameInput);

var _ObjectKeyInput = __webpack_require__(5030);

var _ObjectKeyInput2 = _interopRequireDefault(_ObjectKeyInput);

var _ObjectValueInput = __webpack_require__(5031);

var _ObjectValueInput2 = _interopRequireDefault(_ObjectValueInput);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (customRenderers) {
  var renderers = {
    // Methods used to render base types
    string: function string(value, onAction, _ref, style, cellInfo) {
      var isCollapsed = _ref.isCollapsed,
          subColumnIndex = _ref.subColumnIndex;

      return _react2.default.createElement(_StringInput2.default, {
        value: value,
        onAction: onAction,
        cellInfo: cellInfo
      });
    },

    number: function number(value, onAction, _ref2, style, cellInfo) {
      var isCollapsed = _ref2.isCollapsed,
          subColumnIndex = _ref2.subColumnIndex;

      return _react2.default.createElement(_NumberInput2.default, {
        value: value,
        onAction: onAction,
        cellInfo: cellInfo
      });
    },

    boolean: function boolean(value, onAction, _ref3, style, cellInfo) {
      var isCollapsed = _ref3.isCollapsed,
          subColumnIndex = _ref3.subColumnIndex;

      return _react2.default.createElement(_BooleanInput2.default, {
        value: value,
        onAction: onAction,
        cellInfo: cellInfo
      });
    },

    objectmeta: function objectmeta(value, onAction, _ref4, style, cellInfo) {
      var isCollapsed = _ref4.isCollapsed,
          subColumnIndex = _ref4.subColumnIndex;

      if (subColumnIndex === 0) {
        return renderers.objectNameInput(value, onAction, { isCollapsed: isCollapsed, subColumnIndex: subColumnIndex }, style, cellInfo);
      } else if (subColumnIndex === 1) {
        return _react2.default.createElement(_ObjectMeta2.default, {
          value: value,
          onAction: onAction,
          cellInfo: cellInfo
        });
      }
    },

    arraymeta: function arraymeta(value, onAction, _ref5, style, cellInfo) {
      var isCollapsed = _ref5.isCollapsed,
          subColumnIndex = _ref5.subColumnIndex;

      if (subColumnIndex === 0) {
        return renderers.objectNameInput(value, onAction, { isCollapsed: isCollapsed, subColumnIndex: subColumnIndex }, style, cellInfo);
      } else if (subColumnIndex === 1) {
        return _react2.default.createElement(_ArrayMeta2.default, {
          value: value,
          onAction: onAction,
          cellInfo: cellInfo
        });
      }
    },

    object: function object(value, onAction, _ref6, style, cellInfo) {
      var isCollapsed = _ref6.isCollapsed,
          subColumnIndex = _ref6.subColumnIndex;

      if (subColumnIndex === 0) {
        return renderers.objectKeyInput(value, onAction, { isCollapsed: isCollapsed, subColumnIndex: subColumnIndex }, style, cellInfo);
      } else if (subColumnIndex === 1) {
        return renderers.objectValueInput(value, onAction, { isCollapsed: isCollapsed, subColumnIndex: subColumnIndex }, {}, cellInfo);
      }
    },

    row: function row(value, onAction, _ref7, style) {
      var isCollapsed = _ref7.isCollapsed,
          subColumnIndex = _ref7.subColumnIndex;

      return _react2.default.createElement(
        'div',
        { className: 'data-editor__basic-row' },
        value.children,
        _react2.default.createElement(
          'div',
          { className: 'data-editor__row__actions' },
          _react2.default.createElement('div', {
            className: 'data-editor__row__action--delete',
            onClick: function onClick() {
              onAction('delete');
            }
          })
        )
      );
    },

    // Methods used to render cells inside base types
    objectNameInput: function objectNameInput(value, onAction, _ref8, style, cellInfo) {
      var isCollapsed = _ref8.isCollapsed,
          subColumnIndex = _ref8.subColumnIndex;

      return _react2.default.createElement(_ObjectNameInput2.default, {
        style: style,
        value: value,
        onAction: onAction,
        isCollapsed: isCollapsed,
        cellInfo: cellInfo
      });
    },

    objectKeyInput: function objectKeyInput(value, onAction, _ref9, style, cellInfo) {
      var isCollapsed = _ref9.isCollapsed,
          subColumnIndex = _ref9.subColumnIndex;

      return _react2.default.createElement(_ObjectKeyInput2.default, {
        style: style,
        value: value,
        onAction: onAction,
        cellInfo: cellInfo
      });
    },

    objectValueInput: function objectValueInput(value, onAction, _ref10, style, cellInfo) {
      var isCollapsed = _ref10.isCollapsed,
          subColumnIndex = _ref10.subColumnIndex;

      return _react2.default.createElement(_ObjectValueInput2.default, {
        value: value,
        onAction: onAction,
        cellInfo: cellInfo
      });
    },

    header: function header(children) {
      return _react2.default.createElement(
        'div',
        { className: 'data-editor__basic-header' },
        children
      );
    }
  };

  return (0, _assign2.default)(renderers, customRenderers);
};

/***/ }),

/***/ 5024:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = __webpack_require__(1);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(10);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactShortcuts = __webpack_require__(3575);

var _utils = __webpack_require__(3537);

var _utils2 = _interopRequireDefault(_utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var StringInput = function (_Component) {
  _inherits(StringInput, _Component);

  function StringInput(props) {
    _classCallCheck(this, StringInput);

    var _this = _possibleConstructorReturn(this, (StringInput.__proto__ || Object.getPrototypeOf(StringInput)).call(this, props));

    _this.handleFocus = _this.handleFocus.bind(_this);
    _this.handleChange = _this.handleChange.bind(_this);
    _this.handleShortcut = _this.handleShortcut.bind(_this);
    return _this;
  }

  _createClass(StringInput, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.subscription = this.context.events.addListener('focusCell', this.handleFocus);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.subscription.remove();
    }
  }, {
    key: 'handleFocus',
    value: function handleFocus(_ref) {
      var node = _ref.node,
          column = _ref.column;

      if (node !== this.props.cellInfo.node || column !== this.props.cellInfo.column) {
        // This is not meant for me
        return;
      }

      this.refs.input && this.refs.input.focus();
    }
  }, {
    key: 'handleChange',
    value: function handleChange(e) {
      this.props.onAction && this.props.onAction('edit', { value: e.target.value });
    }
  }, {
    key: 'handleShortcut',
    value: function handleShortcut(action, e) {
      var value = _utils2.default.getImmutablePathValue(this.props.value, ['value']);

      switch (action) {
        case 'MOVE_LEFT':
          if (this.refs.input.selectionStart === 0) {
            e && e.preventDefault();
            e && e.stopPropagation();

            this.context.events.emit('moveToCell', {
              node: this.props.cellInfo.node,
              column: this.props.cellInfo.column,
              direction: 'left'
            });
          }
          break;
        case 'MOVE_RIGHT':
          if (this.refs.input.selectionStart === value.length) {
            e && e.preventDefault();
            e && e.stopPropagation();

            this.context.events.emit('moveToCell', {
              node: this.props.cellInfo.node,
              column: this.props.cellInfo.column,
              direction: 'right'
            });
          }
          break;
        case 'MOVE_UP':
          e && e.preventDefault();
          e && e.stopPropagation();
          this.context.events.emit('moveToCell', {
            node: this.props.cellInfo.node,
            column: this.props.cellInfo.column,
            direction: 'up'
          });
          break;
        case 'MOVE_DOWN':
          e && e.preventDefault();
          e && e.stopPropagation();
          this.context.events.emit('moveToCell', {
            node: this.props.cellInfo.node,
            column: this.props.cellInfo.column,
            direction: 'down'
          });
          break;
        default:
          break;
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var value = _utils2.default.getImmutablePathValue(this.props.value, ['value']);

      return _react2.default.createElement(
        _reactShortcuts.Shortcuts,
        {
          name: 'navigation',
          handler: this.handleShortcut,
          className: 'data-editor__cell__string'
        },
        _react2.default.createElement('input', {
          ref: 'input',
          onChange: this.handleChange,
          value: value
        })
      );
    }
  }]);

  return StringInput;
}(_react.Component);

exports.default = StringInput;


StringInput.contextTypes = { events: _propTypes2.default.object };

/***/ }),

/***/ 5025:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = __webpack_require__(1);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(10);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactShortcuts = __webpack_require__(3575);

var _utils = __webpack_require__(3537);

var _utils2 = _interopRequireDefault(_utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var NumberInput = function (_Component) {
  _inherits(NumberInput, _Component);

  function NumberInput(props) {
    _classCallCheck(this, NumberInput);

    var _this = _possibleConstructorReturn(this, (NumberInput.__proto__ || Object.getPrototypeOf(NumberInput)).call(this, props));

    _this.handleFocus = _this.handleFocus.bind(_this);
    _this.handleChange = _this.handleChange.bind(_this);
    _this.handleShortcut = _this.handleShortcut.bind(_this);
    return _this;
  }

  _createClass(NumberInput, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.subscription = this.context.events.addListener('focusCell', this.handleFocus);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.subscription.remove();
    }
  }, {
    key: 'handleFocus',
    value: function handleFocus(_ref) {
      var node = _ref.node,
          column = _ref.column;

      if (node !== this.props.cellInfo.node || column !== this.props.cellInfo.column) {
        // This is not meant for me
        return;
      }

      this.refs.input && this.refs.input.focus();
    }
  }, {
    key: 'handleChange',
    value: function handleChange(e) {
      this.props.onAction && this.props.onAction('edit', { value: parseInt(e.target.value, 10) });
    }
  }, {
    key: 'handleShortcut',
    value: function handleShortcut(action, e) {
      var value = _utils2.default.getImmutablePathValue(this.props.value, ['value']);

      switch (action) {
        case 'MOVE_LEFT':
          if (this.refs.input.selectionStart === 0) {
            e && e.preventDefault();
            e && e.stopPropagation();

            this.context.events.emit('moveToCell', {
              node: this.props.cellInfo.node,
              column: this.props.cellInfo.column,
              direction: 'left'
            });
          }
          break;
        case 'MOVE_RIGHT':
          if (this.refs.input.selectionStart === value.length) {
            e && e.preventDefault();
            e && e.stopPropagation();

            this.context.events.emit('moveToCell', {
              node: this.props.cellInfo.node,
              column: this.props.cellInfo.column,
              direction: 'right'
            });
          }
          break;
        case 'MOVE_UP':
          e && e.preventDefault();
          e && e.stopPropagation();
          this.context.events.emit('moveToCell', {
            node: this.props.cellInfo.node,
            column: this.props.cellInfo.column,
            direction: 'up'
          });
          break;
        case 'MOVE_DOWN':
          e && e.preventDefault();
          e && e.stopPropagation();
          this.context.events.emit('moveToCell', {
            node: this.props.cellInfo.node,
            column: this.props.cellInfo.column,
            direction: 'down'
          });
          break;
        default:
          break;
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var value = _utils2.default.getImmutablePathValue(this.props.value, ['value']);

      return _react2.default.createElement(
        _reactShortcuts.Shortcuts,
        {
          name: 'navigation',
          handler: this.handleShortcut,
          className: 'data-editor__cell__number'
        },
        _react2.default.createElement('input', {
          ref: 'input',
          onChange: this.handleChange,
          value: value
        })
      );
    }
  }]);

  return NumberInput;
}(_react.Component);

exports.default = NumberInput;


NumberInput.contextTypes = { events: _propTypes2.default.object };

/***/ }),

/***/ 5026:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = __webpack_require__(1);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(10);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactShortcuts = __webpack_require__(3575);

var _utils = __webpack_require__(3537);

var _utils2 = _interopRequireDefault(_utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BooleanInput = function (_Component) {
  _inherits(BooleanInput, _Component);

  function BooleanInput(props) {
    _classCallCheck(this, BooleanInput);

    var _this = _possibleConstructorReturn(this, (BooleanInput.__proto__ || Object.getPrototypeOf(BooleanInput)).call(this, props));

    _this.handleFocus = _this.handleFocus.bind(_this);
    _this.handleChange = _this.handleChange.bind(_this);
    _this.handleShortcut = _this.handleShortcut.bind(_this);
    return _this;
  }

  _createClass(BooleanInput, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.subscription = this.context.events.addListener('focusCell', this.handleFocus);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.subscription.remove();
    }
  }, {
    key: 'handleFocus',
    value: function handleFocus(_ref) {
      var node = _ref.node,
          column = _ref.column;

      if (node !== this.props.cellInfo.node || column !== this.props.cellInfo.column) {
        // This is not meant for me
        return;
      }

      this.refs.input && this.refs.input.focus();
    }
  }, {
    key: 'handleChange',
    value: function handleChange(e) {
      this.props.onAction && this.props.onAction('edit', { value: e.target.value });
    }
  }, {
    key: 'handleShortcut',
    value: function handleShortcut(action, e) {
      var value = _utils2.default.getImmutablePathValue(this.props.value, ['value']);

      switch (action) {
        case 'MOVE_LEFT':
          if (this.refs.input.selectionStart === 0) {
            e && e.preventDefault();
            e && e.stopPropagation();

            this.context.events.emit('moveToCell', {
              node: this.props.cellInfo.node,
              column: this.props.cellInfo.column,
              direction: 'left'
            });
          }
          break;
        case 'MOVE_RIGHT':
          if (this.refs.input.selectionStart === value.length) {
            e && e.preventDefault();
            e && e.stopPropagation();

            this.context.events.emit('moveToCell', {
              node: this.props.cellInfo.node,
              column: this.props.cellInfo.column,
              direction: 'right'
            });
          }
          break;
        case 'MOVE_UP':
          e && e.preventDefault();
          e && e.stopPropagation();
          this.context.events.emit('moveToCell', {
            node: this.props.cellInfo.node,
            column: this.props.cellInfo.column,
            direction: 'up'
          });
          break;
        case 'MOVE_DOWN':
          e && e.preventDefault();
          e && e.stopPropagation();
          this.context.events.emit('moveToCell', {
            node: this.props.cellInfo.node,
            column: this.props.cellInfo.column,
            direction: 'down'
          });
          break;
        default:
          break;
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var value = _utils2.default.getImmutablePathValue(this.props.value, ['value']);

      return _react2.default.createElement(
        _reactShortcuts.Shortcuts,
        {
          name: 'navigation',
          handler: this.handleShortcut,
          className: 'data-editor__cell__boolean'
        },
        _react2.default.createElement('input', {
          ref: 'input',
          onChange: this.handleChange,
          value: value
        })
      );
    }
  }]);

  return BooleanInput;
}(_react.Component);

exports.default = BooleanInput;


BooleanInput.contextTypes = { events: _propTypes2.default.object };

/***/ }),

/***/ 5027:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = __webpack_require__(1);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(10);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = __webpack_require__(3537);

var _utils2 = _interopRequireDefault(_utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ObjectMeta = function (_Component) {
  _inherits(ObjectMeta, _Component);

  function ObjectMeta(props) {
    _classCallCheck(this, ObjectMeta);

    var _this = _possibleConstructorReturn(this, (ObjectMeta.__proto__ || Object.getPrototypeOf(ObjectMeta)).call(this, props));

    _this.handleFocus = _this.handleFocus.bind(_this);
    _this.handleAddChild = _this.handleAddChild.bind(_this);
    return _this;
  }

  _createClass(ObjectMeta, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.subscription = this.context.events.addListener('focusCell', this.handleFocus);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.subscription.remove();
    }
  }, {
    key: 'handleFocus',
    value: function handleFocus(_ref) {
      var node = _ref.node,
          column = _ref.column,
          direction = _ref.direction;

      if (node !== this.props.cellInfo.node || column !== this.props.cellInfo.column) {
        // This is not meant for me
        return;
      }

      this.context.events.emit('moveToCell', {
        node: this.props.cellInfo.node,
        column: this.props.cellInfo.column,
        direction: direction
      });
    }
  }, {
    key: 'handleAddChild',
    value: function handleAddChild() {
      this.props.onAction && this.props.onAction('create');
    }
  }, {
    key: 'render',
    value: function render() {
      var count = _utils2.default.getImmutablePathValue(this.props.value, ['childrenCount']);

      return _react2.default.createElement(
        'div',
        { className: 'data-editor__object-meta' },
        'Object (' + count + ' items)',
        _react2.default.createElement(
          'div',
          {
            className: 'data-editor__add-child',
            onClick: this.handleAddChild
          },
          '+'
        )
      );
    }
  }]);

  return ObjectMeta;
}(_react.Component);

exports.default = ObjectMeta;


ObjectMeta.contextTypes = { events: _propTypes2.default.object };

/***/ }),

/***/ 5028:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = __webpack_require__(1);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(10);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = __webpack_require__(3537);

var _utils2 = _interopRequireDefault(_utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ArrayMeta = function (_Component) {
  _inherits(ArrayMeta, _Component);

  function ArrayMeta(props) {
    _classCallCheck(this, ArrayMeta);

    var _this = _possibleConstructorReturn(this, (ArrayMeta.__proto__ || Object.getPrototypeOf(ArrayMeta)).call(this, props));

    _this.handleFocus = _this.handleFocus.bind(_this);
    _this.handleAddChild = _this.handleAddChild.bind(_this);
    return _this;
  }

  _createClass(ArrayMeta, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.subscription = this.context.events.addListener('focusCell', this.handleFocus);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.subscription.remove();
    }
  }, {
    key: 'handleFocus',
    value: function handleFocus(_ref) {
      var node = _ref.node,
          column = _ref.column,
          direction = _ref.direction;

      if (node !== this.props.cellInfo.node || column !== this.props.cellInfo.column) {
        // This is not meant for me
        return;
      }

      this.context.events.emit('moveToCell', {
        node: this.props.cellInfo.node,
        column: this.props.cellInfo.column,
        direction: direction
      });
    }
  }, {
    key: 'handleAddChild',
    value: function handleAddChild() {
      this.props.onAction && this.props.onAction('create');
    }
  }, {
    key: 'render',
    value: function render() {
      var count = _utils2.default.getImmutablePathValue(this.props.value, ['childrenCount']);

      return _react2.default.createElement(
        'div',
        { className: 'data-editor__array-meta' },
        'Array (' + count + ' items)',
        _react2.default.createElement(
          'div',
          {
            className: 'data-editor__add-child',
            onClick: this.handleAddChild
          },
          '+'
        )
      );
    }
  }]);

  return ArrayMeta;
}(_react.Component);

exports.default = ArrayMeta;


ArrayMeta.contextTypes = { events: _propTypes2.default.object };

/***/ }),

/***/ 5029:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = __webpack_require__(1);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(10);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactShortcuts = __webpack_require__(3575);

var _TypeSelector = __webpack_require__(4021);

var _TypeSelector2 = _interopRequireDefault(_TypeSelector);

var _utils = __webpack_require__(3537);

var _utils2 = _interopRequireDefault(_utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ObjectNameInput = function (_Component) {
  _inherits(ObjectNameInput, _Component);

  function ObjectNameInput(props) {
    _classCallCheck(this, ObjectNameInput);

    var _this = _possibleConstructorReturn(this, (ObjectNameInput.__proto__ || Object.getPrototypeOf(ObjectNameInput)).call(this, props));

    _this.handleFocus = _this.handleFocus.bind(_this);
    _this.handleChangeName = _this.handleChangeName.bind(_this);
    _this.handleChangeType = _this.handleChangeType.bind(_this);
    _this.handleCollapse = _this.handleCollapse.bind(_this);
    _this.handleShortcut = _this.handleShortcut.bind(_this);
    return _this;
  }

  _createClass(ObjectNameInput, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.subscription = this.context.events.addListener('focusCell', this.handleFocus);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.subscription.remove();
    }
  }, {
    key: 'handleFocus',
    value: function handleFocus(_ref) {
      var node = _ref.node,
          column = _ref.column;

      if (node !== this.props.cellInfo.node || column !== this.props.cellInfo.column) {
        // This is not meant for me
        return;
      }

      this.refs.input && this.refs.input.focus();
    }
  }, {
    key: 'handleChangeName',
    value: function handleChangeName(e) {
      this.props.onAction && this.props.onAction('edit', { name: e.target.value });
    }
  }, {
    key: 'handleChangeType',
    value: function handleChangeType(e) {
      this.props.onAction && this.props.onAction('edit', { type: e.target.value });
    }
  }, {
    key: 'handleShortcut',
    value: function handleShortcut(action, e) {
      e && e.preventDefault();
      e && e.stopPropagation();

      switch (action) {
        case 'MOVE_LEFT':
          this.context.events.emit('moveToCell', {
            node: this.props.cellInfo.node,
            column: this.props.cellInfo.column,
            direction: 'left'
          });
          break;
        case 'MOVE_RIGHT':
          this.context.events.emit('moveToCell', {
            node: this.props.cellInfo.node,
            column: this.props.cellInfo.column,
            direction: 'right'
          });
          break;
        case 'MOVE_UP':
          this.context.events.emit('moveToCell', {
            node: this.props.cellInfo.node,
            column: this.props.cellInfo.column,
            direction: 'up'
          });
          break;
        case 'MOVE_DOWN':
          this.context.events.emit('moveToCell', {
            node: this.props.cellInfo.node,
            column: this.props.cellInfo.column,
            direction: 'down'
          });
          break;
        default:
          break;
      }
    }
  }, {
    key: 'handleCollapse',
    value: function handleCollapse() {
      if (this.props.isCollapsed) {
        this.props.onAction && this.props.onAction('expand');
      } else {
        this.props.onAction && this.props.onAction('collapse');
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var name = _utils2.default.getImmutablePathValue(this.props.value, ['name']),
          type = _utils2.default.getImmutablePathValue(this.props.value, ['type']),
          isCollapsed = this.props.isCollapsed;

      return _react2.default.createElement(
        _reactShortcuts.Shortcuts,
        {
          name: 'navigation',
          handler: this.handleShortcut,
          className: 'data-editor__object-name'
        },
        _react2.default.createElement(
          'div',
          { className: 'data-editor__object-name__content', style: this.props.style },
          _react2.default.createElement(
            'div',
            {
              className: 'data-editor__collapse',
              onClick: this.handleCollapse
            },
            _react2.default.createElement('div', { className: 'data-editor__collapse__icon ' + (isCollapsed ? 'is-collapsed' : '') })
          ),
          _react2.default.createElement('input', {
            ref: 'input',
            value: name,
            onChange: this.handleChangeName
          }),
          _react2.default.createElement(_TypeSelector2.default, {
            value: type,
            onChange: this.handleChangeType
          })
        )
      );
    }
  }]);

  return ObjectNameInput;
}(_react.Component);

exports.default = ObjectNameInput;


ObjectNameInput.contextTypes = { events: _propTypes2.default.object };

/***/ }),

/***/ 5030:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = __webpack_require__(1);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(10);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactShortcuts = __webpack_require__(3575);

var _TypeSelector = __webpack_require__(4021);

var _TypeSelector2 = _interopRequireDefault(_TypeSelector);

var _utils = __webpack_require__(3537);

var _utils2 = _interopRequireDefault(_utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ObjectKeyInput = function (_Component) {
  _inherits(ObjectKeyInput, _Component);

  function ObjectKeyInput(props) {
    _classCallCheck(this, ObjectKeyInput);

    var _this = _possibleConstructorReturn(this, (ObjectKeyInput.__proto__ || Object.getPrototypeOf(ObjectKeyInput)).call(this, props));

    _this.handleFocus = _this.handleFocus.bind(_this);
    _this.handleKeyChange = _this.handleKeyChange.bind(_this);
    _this.handleTypeChange = _this.handleTypeChange.bind(_this);
    _this.handleShortcut = _this.handleShortcut.bind(_this);
    return _this;
  }

  _createClass(ObjectKeyInput, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.subscription = this.context.events.addListener('focusCell', this.handleFocus);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.subscription.remove();
    }
  }, {
    key: 'handleFocus',
    value: function handleFocus(_ref) {
      var node = _ref.node,
          column = _ref.column;

      console.log('test');
      if (node !== this.props.cellInfo.node || column !== this.props.cellInfo.column) {
        console.log('not meant for me');
        // This is not meant for me
        return;
      }

      console.log(this.refs.input);
      this.refs.input && this.refs.input.focus();
    }
  }, {
    key: 'handleShortcut',
    value: function handleShortcut(action, e) {
      e && e.preventDefault();
      e && e.stopPropagation();

      switch (action) {
        case 'MOVE_LEFT':
          this.context.events.emit('moveToCell', {
            node: this.props.cellInfo.node,
            column: this.props.cellInfo.column,
            direction: 'left'
          });
          break;
        case 'MOVE_RIGHT':
          this.context.events.emit('moveToCell', {
            node: this.props.cellInfo.node,
            column: this.props.cellInfo.column,
            direction: 'right'
          });
          break;
        case 'MOVE_UP':
          this.context.events.emit('moveToCell', {
            node: this.props.cellInfo.node,
            column: this.props.cellInfo.column,
            direction: 'up'
          });
          break;
        case 'MOVE_DOWN':
          this.context.events.emit('moveToCell', {
            node: this.props.cellInfo.node,
            column: this.props.cellInfo.column,
            direction: 'down'
          });
          break;
        default:
          break;
      }
    }
  }, {
    key: 'handleKeyChange',
    value: function handleKeyChange(e) {
      this.props.onAction && this.props.onAction('edit', { key: e.target.value });
    }
  }, {
    key: 'handleTypeChange',
    value: function handleTypeChange(e) {
      this.props.onAction && this.props.onAction('edit', { type: e.target.value });
    }
  }, {
    key: 'render',
    value: function render() {
      var key = _utils2.default.getImmutablePathValue(this.props.value, ['key']),
          type = _utils2.default.getImmutablePathValue(this.props.value, ['type']);

      return _react2.default.createElement(
        _reactShortcuts.Shortcuts,
        {
          name: 'navigation',
          handler: this.handleShortcut,
          className: 'data-editor__object-key'
        },
        _react2.default.createElement(
          'div',
          { className: 'data-editor__object-key__content', style: this.props.style },
          _react2.default.createElement('input', {
            ref: 'input',
            value: key,
            onChange: this.handleKeyChange
          }),
          _react2.default.createElement(_TypeSelector2.default, {
            value: type,
            onChange: this.handleTypeChange
          })
        )
      );
    }
  }]);

  return ObjectKeyInput;
}(_react.Component);

exports.default = ObjectKeyInput;


ObjectKeyInput.contextTypes = { events: _propTypes2.default.object };

/***/ }),

/***/ 5031:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = __webpack_require__(1);

var _react2 = _interopRequireDefault(_react);

var _propTypes = __webpack_require__(10);

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactShortcuts = __webpack_require__(3575);

var _utils = __webpack_require__(3537);

var _utils2 = _interopRequireDefault(_utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ObjectValueInput = function (_Component) {
  _inherits(ObjectValueInput, _Component);

  function ObjectValueInput(props) {
    _classCallCheck(this, ObjectValueInput);

    var _this = _possibleConstructorReturn(this, (ObjectValueInput.__proto__ || Object.getPrototypeOf(ObjectValueInput)).call(this, props));

    _this.handleFocus = _this.handleFocus.bind(_this);
    _this.handleChange = _this.handleChange.bind(_this);
    _this.handleShortcut = _this.handleShortcut.bind(_this);
    return _this;
  }

  _createClass(ObjectValueInput, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.subscription = this.context.events.addListener('focusCell', this.handleFocus);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.subscription.remove();
    }
  }, {
    key: 'handleFocus',
    value: function handleFocus(_ref) {
      var node = _ref.node,
          column = _ref.column;

      console.log('test2');
      if (node !== this.props.cellInfo.node || column !== this.props.cellInfo.column) {
        // This is not meant for me
        return;
      }

      this.refs.input && this.refs.input.focus();
    }
  }, {
    key: 'handleShortcut',
    value: function handleShortcut(action, e) {
      e && e.preventDefault();
      e && e.stopPropagation();

      switch (action) {
        case 'MOVE_LEFT':
          this.context.events.emit('moveToCell', {
            node: this.props.cellInfo.node,
            column: this.props.cellInfo.column,
            direction: 'left'
          });
          break;
        case 'MOVE_RIGHT':
          this.context.events.emit('moveToCell', {
            node: this.props.cellInfo.node,
            column: this.props.cellInfo.column,
            direction: 'right'
          });
          break;
        case 'MOVE_UP':
          this.context.events.emit('moveToCell', {
            node: this.props.cellInfo.node,
            column: this.props.cellInfo.column,
            direction: 'up'
          });
          break;
        case 'MOVE_DOWN':
          this.context.events.emit('moveToCell', {
            node: this.props.cellInfo.node,
            column: this.props.cellInfo.column,
            direction: 'down'
          });
          break;
        default:
          break;
      }
    }
  }, {
    key: 'handleChange',
    value: function handleChange(e) {
      this.props.onAction && this.props.onAction('edit', { value: e.target.value });
    }
  }, {
    key: 'render',
    value: function render() {
      var value = _utils2.default.getImmutablePathValue(this.props.value, ['value']);

      return _react2.default.createElement(
        _reactShortcuts.Shortcuts,
        {
          name: 'navigation',
          handler: this.handleShortcut,
          className: 'data-editor__object-value'
        },
        _react2.default.createElement(
          'div',
          { className: 'data-editor__object-value__content', style: this.props.style },
          _react2.default.createElement('input', {
            ref: 'input',
            value: value,
            onChange: this.handleChange
          })
        )
      );
    }
  }]);

  return ObjectValueInput;
}(_react.Component);

exports.default = ObjectValueInput;


ObjectValueInput.contextTypes = { events: _propTypes2.default.object };

/***/ }),

/***/ 5032:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _CreateReducer = __webpack_require__(4022);

var _CreateReducer2 = _interopRequireDefault(_CreateReducer);

var _EditReducer = __webpack_require__(5033);

var _EditReducer2 = _interopRequireDefault(_EditReducer);

var _MoveReducer = __webpack_require__(5034);

var _MoveReducer2 = _interopRequireDefault(_MoveReducer);

var _DeleteReducer = __webpack_require__(5035);

var _DeleteReducer2 = _interopRequireDefault(_DeleteReducer);

var _CollapseReducer = __webpack_require__(5036);

var _CollapseReducer2 = _interopRequireDefault(_CollapseReducer);

var _ExpandReducer = __webpack_require__(5037);

var _ExpandReducer2 = _interopRequireDefault(_ExpandReducer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Reducer = function () {
  function Reducer(config) {
    _classCallCheck(this, Reducer);

    this.config = config;
  }

  _createClass(Reducer, [{
    key: 'reduce',
    value: function reduce(state, action) {
      switch (action.type) {
        case 'create':
          return (0, _CreateReducer2.default)(state, action.source, action.payload, this.config);
        case 'edit':
          return (0, _EditReducer2.default)(state, action.source, action.payload, this.config);
        case 'move':
          return (0, _MoveReducer2.default)(state, action.source, action.payload);
        case 'delete':
          return (0, _DeleteReducer2.default)(state, action.source, action.payload);
        case 'collapse':
          return (0, _CollapseReducer2.default)(state, action.source);
        case 'expand':
          return (0, _ExpandReducer2.default)(state, action.source);
        default:
          return state;
      }
    }
  }]);

  return Reducer;
}();

exports.default = Reducer;

/***/ }),

/***/ 5033:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _immutable = __webpack_require__(32);

var _CreateReducer = __webpack_require__(4022);

var _CreateReducer2 = _interopRequireDefault(_CreateReducer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var EditReducer = function EditReducer(state, _ref, _ref2, config) {
  var node = _ref.node,
      column = _ref.column;
  var meta = _ref2.meta;

  // Set the meta name
  if (!(typeof meta.name === 'undefined')) {
    state = state.setIn(['rows', '' + node, 'columns', '' + column, 'meta', 'name'], meta.name);
  }

  // Set the meta key
  if (!(typeof meta.key === 'undefined')) {
    state = state.setIn(['rows', '' + node, 'columns', '' + column, 'meta', 'key'], meta.key);
  }

  // Set the meta value
  if (!(typeof meta.value === 'undefined')) {
    state = state.setIn(['rows', '' + node, 'columns', '' + column, 'meta', 'value'], meta.value);
  }

  // Set the meta type
  if (!(typeof meta.type === 'undefined')) {
    // Set the object's type
    state = state.setIn(['rows', '' + node, 'columns', '' + column, 'meta', 'type'], meta.type);

    // Type conversions
    // Check if this node has children. If it does, remove all their references
    var children = state.getIn(['rows', '' + node, 'allChildren']);

    if (children) {
      // Remove all children from the order list
      var order = state.getIn(['order']);
      order = order.filter(function (nodeId) {
        return !children.includes(nodeId);
      });
      state = state.setIn(['order'], order);

      // Remove all children from the state map
      children.forEach(function (child) {
        state = state.deleteIn(['rows', '' + child]);
      });

      // Remove all children from the allChildren list
      state = state.deleteIn(['rows', '' + node, 'children']);
      state = state.deleteIn(['rows', '' + node, 'allChildren']);
      state = state.deleteIn(['rows', '' + node, 'columns', '' + column, 'meta', 'childrenCount']);
    }

    var previousName = state.getIn(['rows', '' + node, 'columns', '' + column, 'meta', 'key']) || state.getIn(['rows', '' + node, 'columns', '' + column, 'meta', 'name']) || state.getIn(['rows', '' + node, 'columns', '' + column, 'meta', 'value']);

    // Initialize row correctly based on the new type
    if (meta.type === 'string' || meta.type === 'number' || meta.type === 'boolean') {
      // If the new type is a simple type, set the row's type as object
      state = state.setIn(['rows', '' + node, 'columns', '' + column, 'type'], 'object');
      state = state.setIn(['rows', '' + node, 'columns', '' + column, 'meta'], (0, _immutable.fromJS)({ key: previousName || '' }));
    } else if (meta.type === 'array') {
      // If the new type is an array, set the row's type as arraymeta and initialize children meta
      state = state.setIn(['rows', '' + node, 'columns', '' + column, 'type'], 'arraymeta');
      state = state.setIn(['rows', '' + node, 'children'], (0, _immutable.fromJS)([]));
      state = state.setIn(['rows', '' + node, 'allChildren'], (0, _immutable.fromJS)([]));
      state = state.setIn(['rows', '' + node, 'columns', '' + column, 'meta'], (0, _immutable.fromJS)({ name: previousName || '', childrenCount: 0, type: 'array' }));

      // Add a child to this node by default
      state = (0, _CreateReducer2.default)(state, { node: node, column: column }, {}, config);
    } else if (meta.type === 'object') {
      // If the new type is an object, set the row's type as objectmeta and initialize children meta
      state = state.setIn(['rows', '' + node, 'columns', '' + column, 'type'], 'objectmeta');
      state = state.setIn(['rows', '' + node, 'children'], (0, _immutable.fromJS)([]));
      state = state.setIn(['rows', '' + node, 'allChildren'], (0, _immutable.fromJS)([]));
      state = state.setIn(['rows', '' + node, 'columns', '' + column, 'meta'], (0, _immutable.fromJS)({ name: previousName || '', childrenCount: 0, type: 'object' }));

      // Add a child to this node by default
      state = (0, _CreateReducer2.default)(state, { node: node, column: column }, {}, config);
    }
  }

  return state;
};

exports.default = EditReducer;

/***/ }),

/***/ 5034:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
var MoveReducer = function MoveReducer(state, _ref, _ref2) {
  var node = _ref.node;
  var sourceIndex = _ref2.sourceIndex,
      position = _ref2.position;

  // node is the row index that as moved
  // destination is the row index that node was moved after
  var order = state.getIn(['order']);
  var destinationNodeId = node;
  var sourceNodeId = order.get(sourceIndex);
  var destinationNodeIndex = order.indexOf(destinationNodeId);
  position === 'before' && (destinationNodeIndex -= 1);

  if (destinationNodeIndex === order.size - 1 || sourceIndex === order.size - 1) {
    // If the last row was moved, or a node was moved to the last row, stop it, because
    // the last row is the create row
    return state;
  }

  // Get the actual IDs of the row that was moved
  // let nodeId = order.get(node);

  // Get the destination's children
  var nodeChildren = state.getIn(['rows', '' + destinationNodeId, 'allChildren']);

  // Delete the source node and it's children from the order list
  order = order.delete(sourceIndex);
  if (nodeChildren) {
    nodeChildren.forEach(function () {
      order = order.delete(sourceIndex);
    });
  }

  // Add the node and it's children to the order array at the correct indices

  // Since children are involved and we are working with indices, and we've
  // deleted them all in the previous section, it matters if the row was dropped before
  // or after it's own index.

  // If the row was dropped after it's own index, it's simple. Deletes would not have affected
  // the indeices we are supposed to insert children to.
  if (sourceIndex > destinationNodeIndex) {
    order = order.insert(destinationNodeIndex + 1, sourceNodeId);
    if (nodeChildren) {
      nodeChildren.forEach(function (child, index) {
        order = order.insert(destinationNodeIndex + 1 + index + 1, child);
      });
    }
  }
  // However, if the row was dropped before it's own index, deletes would have messed with
  // the index the children have to be inserted at. We have to (mathematically) adjust indices accordingly
  else {
      if (nodeChildren) {
        order = order.insert(destinationNodeIndex - nodeChildren.size, sourceNodeId);
        nodeChildren.forEach(function (child, index) {
          order = order.insert(destinationNodeIndex + index + 1 - nodeChildren.size, child);
        });
      } else {
        order = order.insert(destinationNodeIndex, sourceNodeId);
      }
    }

  // Set the order list in the state
  state = state.setIn(['order'], order);
  return state;
};

exports.default = MoveReducer;

/***/ }),

/***/ 5035:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
var DeleteReducer = function DeleteReducer(state, _ref) {
  var node = _ref.node,
      column = _ref.column;

  // Check if the node has any children
  var children = state.getIn(['rows', '' + node, 'allChildren']),
      order = state.getIn(['order']);

  if (children) {
    // If there are children
    children.forEach(function (child) {
      // Delete child from the state map
      state = state.deleteIn('rows', ['' + node]);

      // Delete child from the state order list
      var childIndex = order.findIndex(function (nodeId) {
        return nodeId === child;
      });
      order = order.delete(childIndex);
    });
  }

  // Find parent
  var parentId = state.getIn(['rows', '' + node, 'parent']);

  if (parentId) {
    var parent = state.getIn(['rows', '' + parentId]);

    // Remove node's ID from parent's allChildren list
    var parentAllChildren = parent.get('allChildren');
    var nodeInParentAllChildren = parentAllChildren.indexOf(node);
    parent.set('allChildren', parentAllChildren.delete(nodeInParentAllChildren));

    // Remove node's ID from parent's children list
    var parentChildren = parent.get('children');
    var nodeInParentChildren = parentChildren.indexOf(node);
    parent.set('children', parentChildren.delete(nodeInParentChildren));

    // Decrement parent's childrenCount
    // WHyyyyyy delete reducer is depending on column ??
    // console.log('parent',parent, column);
    // let parentChildrenCount = parent.get('columns', `${column}`, 'meta', 'childrenCount')
    // console.log(parentChildrenCount)
    // parent.set('columns', `${column}`, 'meta', 'childrenCount', parentChildrenCount - 1)
  }

  // Delete the current node from the state map
  state = state.deleteIn(['rows', '' + node]);

  // Delete the node from the order list
  var nodeIndex = order.indexOf(node);
  order = order.delete(nodeIndex);
  state = state.setIn(['order'], order);

  return state;
};

exports.default = DeleteReducer;

/***/ }),

/***/ 5036:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
var CollapseReducer = function CollapseReducer(state, _ref) {
  var node = _ref.node,
      column = _ref.column;

  // Check if the current node has children. If it doesn't, nothing has to be done
  var children = state.getIn(['rows', '' + node, 'allChildren']);
  if (!children) {
    return state;
  }

  // If the row is already collapsed, there is nothing to do
  var isCollapsed = state.getIn(['collapsedRows', '' + node]);
  if (isCollapsed) {
    return state;
  }

  // Remove the node's children from the state's order list
  var order = state.getIn(['order']);
  order = order.filter(function (nodeId) {
    return !children.includes(nodeId);
  });
  state = state.setIn(['order'], order);

  // Add this node to the collapsedRows list
  state = state.setIn(['collapsedRows', '' + node], true);

  return state;
};

exports.default = CollapseReducer;

/***/ }),

/***/ 5037:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
var ExpandReducer = function ExpandReducer(state, _ref) {
  var node = _ref.node,
      column = _ref.column;

  // Check if the current node has children. If it doesn't, nothing has to be done
  var children = state.getIn(['rows', '' + node, 'allChildren']);
  if (!children) {
    return state;
  }

  // If the row is already expanded, there is nothing to do
  var isExpanded = !state.getIn(['collapsedRows', '' + node]);
  if (isExpanded) {
    return state;
  }

  // Append the current node's children to the order array after the current node
  var order = state.getIn(['order']),
      currentNodePosition = order.findIndex(function (nodeId) {
    return nodeId === node;
  });
  children.forEach(function (child, index) {
    order = order.insert(currentNodePosition + index + 1, child);
  });
  state = state.setIn(['order'], order);

  // Remove this node from the collapsedRows list
  state = state.deleteIn(['collapsedRows', '' + node]);

  return state;
};

exports.default = ExpandReducer;

/***/ }),

/***/ 5038:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = __webpack_require__(1);

var _react2 = _interopRequireDefault(_react);

var _reduce = __webpack_require__(1518);

var _reduce2 = _interopRequireDefault(_reduce);

var _map = __webpack_require__(1505);

var _map2 = _interopRequireDefault(_map);

var _clone = __webpack_require__(1591);

var _clone2 = _interopRequireDefault(_clone);

var _isEmpty = __webpack_require__(1610);

var _isEmpty2 = _interopRequireDefault(_isEmpty);

var _get = __webpack_require__(1497);

var _get2 = _interopRequireDefault(_get);

var _reactDraggable = __webpack_require__(220);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Header = function (_Component) {
  _inherits(Header, _Component);

  function Header(props) {
    _classCallCheck(this, Header);

    var _this = _possibleConstructorReturn(this, (Header.__proto__ || Object.getPrototypeOf(Header)).call(this, props));

    _this.state = {
      widths: (0, _map2.default)(props.columns, function (c) {
        return c.width;
      })
    };

    _this.widths = _this.state.widths;
    _this.handleResize = _this.handleResize.bind(_this);
    _this.handleResizeStart = _this.handleResizeStart.bind(_this);
    _this.handleResizeStop = _this.handleResizeStop.bind(_this);
    return _this;
  }

  _createClass(Header, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _this2 = this;

      this.setState({
        widths: nextProps.columnWidths
      }, function () {
        _this2.widths = nextProps.columnWidths;
      });
    }
  }, {
    key: 'handleResize',
    value: function handleResize(e) {
      var diff = this.initial.pageX - e.pageX,
          index = this.initial.index,
          currentWidth = (0, _clone2.default)(this.widths),
          percentage = diff / this.refs.DataEditorHeader.offsetWidth * 100,
          leftColumnWidth = currentWidth[index] - percentage,
          rightColumnWidth = currentWidth[index + 1] + percentage;

      if (leftColumnWidth > 5 && rightColumnWidth > 5) {
        currentWidth[index] = leftColumnWidth;
        currentWidth[index + 1] = rightColumnWidth;
        this.setState({ widths: currentWidth });
        this.widths = currentWidth;
        this.initial.pageX = e.pageX;
      }
    }
  }, {
    key: 'handleResizeStart',
    value: function handleResizeStart(e) {
      var resizeHandleIndex = Number(e.target.getAttribute('data-index'));
      var headerContents = this.refs.DataEditorHeader.querySelectorAll('.data-editor__header__cell');
      this.initial = {
        pageX: e.pageX,
        index: resizeHandleIndex,
        leftColumnContentWidth: headerContents[resizeHandleIndex].getBoundingClientRect().width,
        rightColumnContentWidth: headerContents[resizeHandleIndex + 1].getBoundingClientRect().width,
        headerActionsWidth: this.refs.editorToggleControls ? this.refs.editorToggleControls.getBoundingClientRect().width : 0
      };
    }
  }, {
    key: 'handleResizeStop',
    value: function handleResizeStop(e) {
      this.initial = {};
      this.props.onColumnResize && this.props.onColumnResize(this.widths);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var resizePreviewWidth = (0, _reduce2.default)(Array((0, _get2.default)(this.initial, 'index', 0) + 1), function (total, value, index) {
        return total + (0, _get2.default)(_this3, 'state.widths[' + index + ']', 0);
      }, 0);

      var children = (0, _map2.default)(this.props.columns, function (column, index) {
        return _react2.default.createElement(
          'div',
          { key: index, className: 'data-editor__header__cell', style: { width: _this3.props.columnWidths[index] + '%' } },
          _react2.default.createElement(
            'span',
            { className: 'data-editor__header__cell__title' },
            column.header
          ),
          index !== _this3.props.columns.length - 1 && column.resize && _react2.default.createElement(
            _reactDraggable.DraggableCore,
            {
              axis: 'x',
              onDrag: _this3.handleResize,
              onStart: _this3.handleResizeStart,
              onStop: _this3.handleResizeStop
            },
            _react2.default.createElement('div', {
              className: 'resize-handle',
              'data-index': index
            })
          )
        );
      });

      return _react2.default.createElement(
        'div',
        { className: 'data-editor__header', ref: 'DataEditorHeader' },
        !(0, _isEmpty2.default)(this.initial) && _react2.default.createElement('div', {
          className: 'resize-preview',
          style: {
            left: resizePreviewWidth + '%'
          }
        }),
        this.props.renderers.header(children)
      );
    }
  }]);

  return Header;
}(_react.Component);

exports.default = Header;

/***/ }),

/***/ 5039:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = __webpack_require__(1);

var _react2 = _interopRequireDefault(_react);

var _map = __webpack_require__(1505);

var _map2 = _interopRequireDefault(_map);

var _times = __webpack_require__(5040);

var _times2 = _interopRequireDefault(_times);

var _filter = __webpack_require__(1611);

var _filter2 = _interopRequireDefault(_filter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ListRenderer = function (_PureComponent) {
  _inherits(ListRenderer, _PureComponent);

  function ListRenderer(props, context) {
    _classCallCheck(this, ListRenderer);

    var _this = _possibleConstructorReturn(this, (ListRenderer.__proto__ || Object.getPrototypeOf(ListRenderer)).call(this, props));

    _this.state = {
      height: props.config.height,
      overscanColumnCount: 0,
      overscanRowCount: 5,
      rowHeight: 30
    };

    _this.renderColumn = _this.renderColumn.bind(_this);
    _this._rowRenderer = _this._rowRenderer.bind(_this);
    return _this;
  }

  _createClass(ListRenderer, [{
    key: 'renderColumn',
    value: function renderColumn(_ref) {
      var rowIndex = _ref.rowIndex,
          columnIndex = _ref.columnIndex,
          style = _ref.style;

      return _react2.default.createElement(
        'div',
        {
          className: 'data-editor__cell',
          key: rowIndex + '-' + columnIndex,
          style: style,
          onClick: this.props.onColumnClick.bind(this, rowIndex, columnIndex)
        },
        this.props.cellRenderer({ rowIndex: rowIndex, columnIndex: columnIndex })
      );
    }

    /*
      renderGrid ({rowIndex, columnIndex, colWidth, onScroll, scrollLeft, key}) {
        const {
          rowHeight,
        } = this.state;
    
        return (
            <Grid
              key={key}
              onScroll={onScroll}
              scrollLeft={scrollLeft}
              className='data-editor__row__grid'
              columnWidth={this.props.config.cellWidth}
              columnCount={1}
              height={rowHeight}
              overscanColumnCount={1}
              overscanRowCount={1}
              cellRenderer={this._renderGridCell.bind(this, { rowIndex, columnIndex })}
              rowHeight={rowHeight}
              rowCount={1}
              width={colWidth}
            />
          )
      }
      _renderGridCell({ rowIndex, columnIndex }, {style}) {
        return this.renderColumn({rowIndex, columnIndex, style});
      } */

  }, {
    key: '_rowRenderer',
    value: function _rowRenderer(index) {
      var _this2 = this;

      var renderedRows = (0, _filter2.default)(this.props.config.widths, function (width, index) {
        return index < _this2.props.columnCount;
      });
      var children = (0, _map2.default)(renderedRows, function (width, columnIndex) {
        // let colWidth = (width / 100) * rowWidth;
        /*
        if (columnIndex === this.props.config.scrollingColumn) {
          return this.renderGrid({rowIndex: index, columnIndex, colWidth, onScroll, scrollLeft, key})
        }
        */
        return _this2.renderColumn({ rowIndex: index, columnIndex: columnIndex, style: { width: width + '%' } });
      });

      return _react2.default.createElement(
        'div',
        { className: 'data-editor__row', key: '' + index },
        this.props.rowRenderer && this.props.rowRenderer(children, index, {})
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var classes = ['data-editor__rows'];

      if (this.props.className) {
        classes.push(this.props.className);
      }

      return _react2.default.createElement(
        'div',
        { className: classes },
        (0, _times2.default)(this.props.rowCount, function (index) {
          return _this3._rowRenderer(index);
        })
      );
    }
  }]);

  return ListRenderer;
}(_react.PureComponent);

exports.default = ListRenderer;

/***/ }),

/***/ 5040:
/***/ (function(module, exports, __webpack_require__) {

var baseTimes = __webpack_require__(369),
    castFunction = __webpack_require__(1506),
    toInteger = __webpack_require__(4014);

/** Used as references for various `Number` constants. */
var MAX_SAFE_INTEGER = 9007199254740991;

/** Used as references for the maximum length and index of an array. */
var MAX_ARRAY_LENGTH = 4294967295;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeMin = Math.min;

/**
 * Invokes the iteratee `n` times, returning an array of the results of
 * each invocation. The iteratee is invoked with one argument; (index).
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Util
 * @param {number} n The number of times to invoke `iteratee`.
 * @param {Function} [iteratee=_.identity] The function invoked per iteration.
 * @returns {Array} Returns the array of results.
 * @example
 *
 * _.times(3, String);
 * // => ['0', '1', '2']
 *
 *  _.times(4, _.constant(0));
 * // => [0, 0, 0, 0]
 */
function times(n, iteratee) {
  n = toInteger(n);
  if (n < 1 || n > MAX_SAFE_INTEGER) {
    return [];
  }
  var index = MAX_ARRAY_LENGTH,
      length = nativeMin(n, MAX_ARRAY_LENGTH);

  iteratee = castFunction(iteratee);
  n -= MAX_ARRAY_LENGTH;

  var result = baseTimes(length, iteratee);
  while (++index < n) {
    iteratee(index);
  }
  return result;
}

module.exports = times;


/***/ }),

/***/ 5041:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CreateNewMockModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_base_Tabs__ = __webpack_require__(103);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__services_VersionTagService__ = __webpack_require__(984);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__utils_util__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__components_new_button_CreateNewMockModal__ = __webpack_require__(5042);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__modules_model_event__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__modules_services_SyncChangesetEventService__ = __webpack_require__(1529);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__modules_controllers_CollectionController__ = __webpack_require__(34);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__components_base_Icons_SuccessIcon__ = __webpack_require__(312);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__components_base_XPaths_XPath__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__modules_controllers_UserController__ = __webpack_require__(39);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _class;



















let initialState = {
  isOpen: false,
  isLoading: false,
  activeStep: 1,
  activeSource: 'new',
  errorFetchingVersions: false,
  ownCollections: [],
  ownEnvironments: [],
  ownVersions: [],
  selectedOptions: {
    name: '',
    requests: [],
    isPrivate: false,
    collectionId: '',
    ownerId: '',
    environmentId: '',
    mockUrl: '',
    versionId: '',
    createEnvironment: true },

  from: 'create_new_x',
  mockStatus: {
    loading: true,
    error: false },

  collectionStatus: {
    loading: true,
    error: false },

  environmentStatus: {
    loading: true,
    error: false },

  userStatus: {},
  saveToActivity: false,
  workspaceId: null,
  startStep: 1 };let



CreateNewMockModalContainer = Object(__WEBPACK_IMPORTED_MODULE_2_mobx_react__["a" /* observer */])(_class = class CreateNewMockModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = initialState;

    this.loadWorkspaceCollections = this.loadWorkspaceCollections.bind(this);
    this.loadOwnEnvironments = this.loadOwnEnvironments.bind(this);
    this.loadOwnVersions = this.loadOwnVersions.bind(this);
    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleChangeSource = this.handleChangeSource.bind(this);

    this.handleSelectCollection = this.handleSelectCollection.bind(this);
    this.handleSelectEnvironment = this.handleSelectEnvironment.bind(this);
    this.handleSelectVersion = this.handleSelectVersion.bind(this);
    this.handleRequestChange = this.handleRequestChange.bind(this);
    this.handleMockNameChange = this.handleMockNameChange.bind(this);
    this.handlePrivateChange = this.handlePrivateChange.bind(this);
    this.handleCreateEnvironmentChange = this.handleCreateEnvironmentChange.bind(this);
    this.handleCreate = this.handleCreate.bind(this);
    this.handleRetry = this.handleRetry.bind(this);
    this.handleVersionFetchRetry = this.handleVersionFetchRetry.bind(this);
    this.handleOfflineRetry = this.handleOfflineRetry.bind(this);
    this.handleBack = this.handleBack.bind(this);

    this.constructCollection = this.constructCollection.bind(this);
    this.constructMock = this.constructMock.bind(this);
    this.constructEnvironment = this.constructEnvironment.bind(this);
  }

  componentDidMount() {
    pm.mediator.on('openCreateNewMockModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('openCreateNewMockModal', this.handleOpen);
  }

  getStyles() {
    return {
      marginTop: '10vh',
      height: '75vh',
      minWidth: '900px',
      width: '80vw' };

  }

  loadWorkspaceCollections() {
    let editableCollections = Object(__WEBPACK_IMPORTED_MODULE_12__stores_get_store__["getStore"])('ActiveWorkspaceStore').editableCollections;
    this.setState({ ownCollections: editableCollections });
  }

  loadOwnEnvironments() {
    let ownEnvironments = Object(__WEBPACK_IMPORTED_MODULE_12__stores_get_store__["getStore"])('ActiveWorkspaceStore').environments,
    sortedEnvironments = _.sortBy(ownEnvironments, environment => {
      return environment.name.toLowerCase();
    }),
    allEnvironments = _.concat({ id: null, name: 'No Environment' }, sortedEnvironments);

    this.setState({ ownEnvironments: allEnvironments });
  }

  loadOwnVersions(criteria) {
    return Object(__WEBPACK_IMPORTED_MODULE_7__services_VersionTagService__["a" /* fetchAllTags */])(criteria);
  }

  handleClose() {
    this.handleSaveToActivity();
    this.setState(_extends({},
    initialState, {
      isOpen: false }));

    this.onSuccess = null;
    this.disposer && this.disposer();
  }

  handleSaveToActivity() {
    if (!this.state.saveToActivity) {
      return;
    }
    let metaObj = _.pick(this.state,
    [
    'activeSource',
    'selectedOptions',
    'mockStatus',
    'collectionStatus',
    'environmentStatus']);


    pm.mediator.trigger('saveXFlowActivity', 'mock', metaObj);
  }

  handleOpen(openState = {}, onSuccess) {
    if (this.state.isOpen) {
      return;
    }

    let shouldLoadVersions = _.get(openState, 'selectedOptions.collectionId');

    this.setState(_extends({},
    initialState,
    openState, {
      selectedOptions: _extends({},
      initialState.selectedOptions,
      openState.selectedOptions),

      isOpen: true,
      isLoading: shouldLoadVersions,
      startStep: _.get(openState, 'activeStep', 1) }),
    () => {
      __WEBPACK_IMPORTED_MODULE_6__modules_services_AnalyticsService__["a" /* default */].addEvent('mock', 'initiate_create', this.state.from);
    });

    if (shouldLoadVersions) {
      this.loadOwnVersions({
        collectionUid: `${_.get(openState, 'selectedOptions.ownerId')}-${_.get(openState, 'selectedOptions.collectionId')}` }).

      then(versions => {
        this.setState({
          ownVersions: versions,
          isLoading: false,
          selectedOptions: _extends({},
          this.state.selectedOptions, {
            versionId: _.get(versions, '0.id') }) });


      }).
      catch(err => {
        this.setState({ isLoading: false, errorFetchingVersions: true });
        pm.toasts.error(_.get(err, 'message') || 'Error occured while fetching versions');
      });
    }

    this.onSuccess = onSuccess;
  }

  handleChangeSource(activeSource) {
    this.setState({ activeSource }, () => {
      if (this.state.activeSource === 'workspace') {
        this.loadWorkspaceCollections();
      }
    });
  }

  handleSelectCollection(collection) {
    let newState = {};

    switch (this.state.activeSource) {
      case 'new':
        newState = {
          selectedOptions: _extends({},
          this.state.selectedOptions, {
            collectionId: '' }) };


        break;
      case 'workspace':
        newState = {
          selectedOptions: _extends({},
          this.state.selectedOptions, {
            name: collection.name,
            collectionId: collection.id,
            ownerId: collection.owner,
            createEnvironment: false }) };


        break;}


    this.loadOwnEnvironments();

    /**
                                 * If block is run if we choose a collection to create a mock
                                 * else block is run if we use requests to create a mock
                                 */
    if (collection.uid) {
      this.setState(_extends({
        activeStep: 2,
        isLoading: true },
      newState));

      this.loadOwnVersions({ collectionUid: collection.uid }).
      then(versions => {
        this.setState({
          selectedOptions: _extends({},
          this.state.selectedOptions, {
            versionId: _.get(versions, '0.id') }),

          isLoading: false,
          ownVersions: versions },
        () => {
          this.refs.content.onCollectionSelect && this.refs.content.onCollectionSelect();
        });
      }).
      catch(err => {
        this.setState({ isLoading: false, errorFetchingVersions: true });
        pm.toasts.error(_.get(err, 'message') || 'Error occured while fetching versions');
      });
    } else
    {
      this.setState(_extends({},
      newState, {
        activeStep: 2,
        isLoading: false }),
      () => {
        this.refs.content.onCollectionSelect && this.refs.content.onCollectionSelect();
      });
    }
  }

  handleSelectEnvironment(environmentId) {
    this.setState(state => {
      return {
        selectedOptions: _extends({},
        state.selectedOptions, {
          environmentId: _.isEqual(environmentId, 'no-environment') ? '' : environmentId }) };


    });
  }

  handleSelectVersion(versionId) {
    this.setState(state => {
      return {
        selectedOptions: _extends({},
        state.selectedOptions, {
          versionId }) };


    });
  }

  handleRequestChange(requests) {
    this.setState(state => {
      return {
        selectedOptions: _extends({},
        state.selectedOptions, {
          requests: _.map(requests, request => {
            return {
              method: request.method,
              url: request.url,
              code: parseInt(request.code),
              response: request.response,
              description: request.description,
              requestBody: request.requestBody };

          }) }) };


    });
  }

  handleMockNameChange(name) {
    this.setState(state => {
      return {
        selectedOptions: _extends({},
        state.selectedOptions, {
          name }) };


    });
  }

  handlePrivateChange(isPrivate) {
    this.setState(state => {
      return {
        selectedOptions: _extends({},
        state.selectedOptions, {
          isPrivate }) };


    });
  }

  handleCreateEnvironmentChange(createEnvironment) {
    this.setState(prevState => {
      return {
        selectedOptions: _extends({},
        prevState.selectedOptions, {
          createEnvironment }) };


    });
  }

  handleCreate() {
    if (!Object(__WEBPACK_IMPORTED_MODULE_12__stores_get_store__["getStore"])('SyncStatusStore').isSocketConnected) {
      pm.toasts.error('Unable to create mock');
      return;
    }

    if (this.state.activeSource === 'new' && _.isEmpty(this.state.selectedOptions.name)) {
      return;
    }

    if (_.isEmpty(this.state.selectedOptions.collectionId)) {
      this.constructCollection(collectionId => {
        this.disposer = Object(__WEBPACK_IMPORTED_MODULE_13__modules_services_SyncChangesetEventService__["a" /* onChangesetResponse */])({
          model: 'collection',
          action: 'import',
          modelId: collectionId },
        err => {
          this.disposer();
          if (err) {
            return;
          }

          this.constructMock(error => {
            !error && this.state.selectedOptions.createEnvironment && this.constructEnvironment();
          });
        });
      });
    } else
    {
      this.constructMock(err => {
        !err && this.state.selectedOptions.createEnvironment && this.constructEnvironment();
      });
    }

    this.setState({ activeStep: 3 });
  }

  handleVersionFetchRetry() {
    this.setState({ isLoading: true, errorFetchingVersions: false }, () => {
      this.loadOwnVersions({
        collectionUid: `${_.get(this.state, 'selectedOptions.ownerId')}-${_.get(this.state, 'selectedOptions.collectionId')}` }).

      then(versions => {
        this.setState({
          ownVersions: versions,
          isLoading: false,
          selectedOptions: _extends({},
          this.state.selectedOptions, {
            versionId: _.get(versions, '0.id') }) });


      }).
      catch(err => {
        this.setState({ isLoading: false, errorFetchingVersions: true });
        pm.toasts.error(_.get(err, 'message') || 'Error occured while fetching versions');
      });
    });
  }

  handleRetry() {
    if (!Object(__WEBPACK_IMPORTED_MODULE_12__stores_get_store__["getStore"])('SyncStatusStore').isSocketConnected) {
      return;
    }

    if (this.state.collectionStatus.error) {
      this.setState({
        collectionStatus: {
          error: false,
          loading: true },

        mockStatus: {
          error: false,
          loading: true } },

      () => {
        this.constructCollection(collectionId => {
          this.disposer = Object(__WEBPACK_IMPORTED_MODULE_13__modules_services_SyncChangesetEventService__["a" /* onChangesetResponse */])({
            model: 'collection',
            action: 'import',
            modelId: collectionId },
          err => {
            this.disposer();
            if (err) {
              return;
            }

            this.constructMock();
          });
        });
      });
    } else
    if (this.state.mockStatus.error) {
      this.setState({
        mockStatus: {
          error: false,
          loading: true } },

      () => {
        this.constructMock();
      });
    }
  }

  handleBack(activeStep) {
    if (activeStep === 0) {
      this.handleClose();
      return pm.mediator.trigger('openCreateNewXModal');
    }

    this.setState({
      activeStep,
      startStep: activeStep,
      selectedOptions: _extends({},
      this.state.selectedOptions, {
        createEnvironment: true,
        name: '' }) });


  }

  handleOfflineRetry() {
    if (!Object(__WEBPACK_IMPORTED_MODULE_12__stores_get_store__["getStore"])('SyncStatusStore').isSocketConnected) {
      return;
    }

    if (this.state.activeStep === 2) {
      this.handleCreate();
    }
  }

  async constructCollection(callback) {
    let { id: ownerId } = await __WEBPACK_IMPORTED_MODULE_17__modules_controllers_UserController__["a" /* default */].get(),
    collection = {
      name: this.state.selectedOptions.name,
      id: __WEBPACK_IMPORTED_MODULE_8__utils_util__["a" /* default */].guid(),
      owner: ownerId },

    isOriginRequests = this.state.startStep === 1,
    requests = _.map(this.state.selectedOptions.requests,
    request => {
      let requestObject = {
        url: isOriginRequests ? '{{url}}/' + request.url : request.url,
        method: request.method || 'GET',
        data: request.requestBody,
        dataMode: 'raw' };

      return _extends({},
      requestObject, {
        id: __WEBPACK_IMPORTED_MODULE_8__utils_util__["a" /* default */].guid(),
        collectionId: collection.id,
        name: request.url,
        isFromCollection: true,
        time: new Date().getTime(),
        description: request.description || '',
        responses: [
        {
          id: __WEBPACK_IMPORTED_MODULE_8__utils_util__["a" /* default */].guid(),
          name: 'Default',
          status: request.code,
          text: request.response,
          responseCode: {
            code: parseInt(request.code),
            name: _.join(_.drop(_.split(request.code, ' '), 1), ' ') },

          requestObject }] });



    }),
    order = _.map(requests, 'id');

    _.assign(collection, { requests, order });

    let getOriginMeta = from => {
      if (from.startsWith('history')) {
        return 'history/mock';
      }

      return from === 'create_new_x' ? 'cnx' : from;
    },
    collectionEvent = Object(__WEBPACK_IMPORTED_MODULE_10__modules_model_event__["a" /* createEvent */])(
    'create_deep',
    'collection',
    { collection },
    null,
    { origin: getOriginMeta(this.state.from) });


    try {
      let response = await Object(__WEBPACK_IMPORTED_MODULE_11__modules_pipelines_user_action__["a" /* default */])(collectionEvent);
      if (!_.isEmpty(_.get(response, 'error'))) {
        pm.logger.error('Error in creating mock', response.error);
        return;
      }

      this.setState(state => {
        return {
          selectedOptions: _extends({},
          state.selectedOptions, {
            collectionId: collection.id,
            ownerId: collection.owner }),

          collectionStatus: _extends({},
          state.collectionStatus, {
            loading: false,
            error: false }) };


      }, () => {
        callback && callback(collection.id);
      });
    }
    catch (err) {
      pm.logger.error('Error in pipeline for creating mock', err);
    }
  }

  constructMock(callback) {
    let selectedOptions = this.state.selectedOptions,
    selectedEnvironment = null;

    return __WEBPACK_IMPORTED_MODULE_14__modules_controllers_CollectionController__["a" /* default */].getCollection({ id: selectedOptions.collectionId }).
    then(({ id, owner }) => {
      let uuid = `${owner}-${id}`,
      mockData;

      if (!_.isEmpty(selectedOptions.environmentId)) {
        let environment = Object(__WEBPACK_IMPORTED_MODULE_12__stores_get_store__["getStore"])('EnvironmentStore').find(selectedOptions.environmentId);
        selectedEnvironment = environment.uid;
      }

      mockData = {
        collection: uuid,
        private: selectedOptions.isPrivate,
        name: selectedOptions.name,
        versionTag: selectedOptions.versionId };


      if (selectedEnvironment) {
        mockData.environment = selectedEnvironment;
      }

      let mockCreateEvent = Object(__WEBPACK_IMPORTED_MODULE_10__modules_model_event__["a" /* createEvent */])('create', 'mock', mockData);

      Object(__WEBPACK_IMPORTED_MODULE_11__modules_pipelines_user_action__["a" /* default */])(mockCreateEvent).then(mockEventResponse => {
        let mockEvent = Object(__WEBPACK_IMPORTED_MODULE_10__modules_model_event__["b" /* findEvents */])(mockEventResponse.response, { name: 'created', namespace: 'mock' }),
        mockData = Object(__WEBPACK_IMPORTED_MODULE_10__modules_model_event__["d" /* getEventData */])(_.head(mockEvent));
        this.setState(state => {
          return {
            selectedOptions: _extends({},
            state.selectedOptions, {
              mockUrl: mockData && mockData.url }),

            mockStatus: _extends({},
            state.mockStatus, {
              loading: false,
              error: false }),

            saveToActivity: true };

        }, () => {
          __WEBPACK_IMPORTED_MODULE_6__modules_services_AnalyticsService__["a" /* default */].addEventV2({
            category: 'mock',
            action: 'confirm_create',
            label: this.state.from,
            entityId: mockData && mockData.id });

          pm.mediator.trigger('focusCollectionInSideBar', selectedOptions.collectionId, 'Mocks');
          this.onSuccess && this.onSuccess();
          _.isFunction(callback) && callback();
        });
      }).catch(() => {
        this.setState(state => {
          return {
            mockStatus: _extends({},
            state.mockStatus, {
              loading: false,
              error: true }) };


        }, () => {
          _.isFunction(callback) && callback(true);
        });
      });
    });
  }

  constructEnvironment(callback) {
    let id = __WEBPACK_IMPORTED_MODULE_8__utils_util__["a" /* default */].guid(),
    currentUser = Object(__WEBPACK_IMPORTED_MODULE_12__stores_get_store__["getStore"])('CurrentUserStore');
    let createEnvironmentEvent = {
      name: 'create',
      namespace: 'environment',
      data: {
        id: id,
        name: this.state.selectedOptions.name,
        values: [{
          enabled: true,
          key: 'url',
          value: this.state.selectedOptions.mockUrl,
          type: 'text' }],

        owner: currentUser.id } };



    Object(__WEBPACK_IMPORTED_MODULE_11__modules_pipelines_user_action__["a" /* default */])(createEnvironmentEvent);
    this.setState(state => {
      return {
        selectedOptions: _extends({},
        state.selectedOptions, {
          environmentId: id }),

        environmentStatus: _extends({},
        state.environmentStatus, {
          loading: false,
          error: false }) };


    }, () => {
      _.isFunction(callback) && callback();
    });
  }

  getStepClasses(step) {
    return __WEBPACK_IMPORTED_MODULE_1_classnames___default()({ 'is-done': this.state.activeStep > step });
  }

  render() {
    let currentUser = Object(__WEBPACK_IMPORTED_MODULE_12__stores_get_store__["getStore"])('CurrentUserStore'),
    isLoggedIn = currentUser && currentUser.isLoggedIn,
    isSyncEnabled = Object(__WEBPACK_IMPORTED_MODULE_12__stores_get_store__["getStore"])('GateKeeperStore').isSyncEnabled,
    isOffline = !Object(__WEBPACK_IMPORTED_MODULE_12__stores_get_store__["getStore"])('SyncStatusStore').isSocketConnected;

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_16__components_base_XPaths_XPath__["a" /* default */], { identifier: 'createMockModal', isVisible: this.state.isOpen },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_Modals__["a" /* Modal */], {
            className: 'create-new-mock-modal',
            isOpen: this.state.isOpen,
            onRequestClose: this.handleClose,
            customStyles: this.getStyles() },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_Modals__["d" /* ModalHeader */], null,
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Tabs__["b" /* Tabs */], {
                type: 'primary',
                defaultActive: 1,
                activeRef: this.state.activeStep },

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Tabs__["a" /* Tab */], {
                  className: this.getStepClasses(1),
                  refKey: 1 },

                this.state.activeStep <= 1 ? '1.' : __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_15__components_base_Icons_SuccessIcon__["a" /* default */], { size: 'xs' }),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, '\xA0Select a collection to mock')),

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Tabs__["a" /* Tab */], {
                  className: this.getStepClasses(2),
                  refKey: 2 },

                this.state.activeStep <= 2 ? '2.' : __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_15__components_base_Icons_SuccessIcon__["a" /* default */], { size: 'xs' }),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, '\xA0Set up the mock server')),

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Tabs__["a" /* Tab */], {
                  className: this.getStepClasses(3),
                  refKey: 3 },

                this.state.activeStep <= 3 ? '3.' : __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_15__components_base_Icons_SuccessIcon__["a" /* default */], { size: 'xs' }),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, '\xA0Next steps')))),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_Modals__["b" /* ModalContent */], { className: `step${this.state.activeStep}` },

            isLoggedIn && isSyncEnabled &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_9__components_new_button_CreateNewMockModal__["a" /* default */], {
              ref: 'content',
              activeStep: this.state.activeStep,
              activeSource: this.state.activeSource,
              errorFetchingVersions: this.state.errorFetchingVersions,
              isOffline: isOffline,
              isLoading: this.state.isLoading,
              onChangeSource: this.handleChangeSource,
              onOfflineRetry: this.handleOfflineRetry,
              ownCollections: this.state.ownCollections,
              ownEnvironments: this.state.ownEnvironments,
              ownVersions: this.state.ownVersions,
              onSelectCollection: this.handleSelectCollection,
              onSelectEnvironment: this.handleSelectEnvironment,
              onSelectVersion: this.handleSelectVersion,
              selectedOptions: this.state.selectedOptions,

              onRequestChange: this.handleRequestChange,
              onMockNameChange: this.handleMockNameChange,
              onMockPrivateChange: this.handlePrivateChange,
              onCreateMock: this.handleCreate,
              onRetry: this.handleRetry,
              onVersionFetchRetry: this.handleVersionFetchRetry,
              onClose: this.handleClose,
              onCreateEnvironmentChange: this.handleCreateEnvironmentChange,

              mockStatus: this.state.mockStatus,
              collectionStatus: this.state.collectionStatus,
              environmentStatus: this.state.environmentStatus })),




          isLoggedIn &&
          isSyncEnabled &&
          !this.state.isLoading &&
          !this.state.errorFetchingVersions &&
          !this.state.collectionStatus.error &&
          !this.state.mockStatus.error &&
          !isOffline && (
          this.state.activeStep === 1 || this.state.activeStep === 2 || this.state.activeStep === 3) &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_Modals__["c" /* ModalFooter */], { className: `step${this.state.activeStep}` },

            this.state.activeStep === 1 &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__footer' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_16__components_base_XPaths_XPath__["a" /* default */], { identifier: 'next' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_Buttons__["a" /* Button */], {
                    type: 'primary',
                    disabled: _.isEmpty(this.state.selectedOptions.requests) || this.state.activeSource !== 'new',
                    onClick: this.handleSelectCollection }, 'Next')),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_16__components_base_XPaths_XPath__["a" /* default */], { identifier: 'back' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_Buttons__["a" /* Button */], {
                    type: 'secondary',
                    onClick: this.handleBack.bind(this, 0) }, 'Back'))),






            this.state.activeStep === 2 &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__footer' },

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_16__components_base_XPaths_XPath__["a" /* default */], { identifier: 'back' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_Buttons__["a" /* Button */], {
                      type: 'secondary',
                      onClick: this.handleBack.bind(this, 1) }, 'Back')),


                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_16__components_base_XPaths_XPath__["a" /* default */], { identifier: 'create' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_Buttons__["a" /* Button */], {
                      type: 'primary',
                      disabled: !this.state.selectedOptions.name,
                      onClick: this.handleCreate }, 'Create Mock Server')))),









            this.state.activeStep === 3 &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__footer' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_16__components_base_XPaths_XPath__["a" /* default */], { identifier: 'close' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_Buttons__["a" /* Button */], {
                    type: 'primary',
                    onClick: this.handleClose }, 'Close')))))));











  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5042:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CreateNewMockModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_uuid_v4__ = __webpack_require__(47);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_uuid_v4___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_uuid_v4__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Tabs__ = __webpack_require__(103);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_Dropdowns__ = __webpack_require__(31);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__base_LoadingIndicator__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__base_Icons_MockIcon__ = __webpack_require__(960);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__base_Icons_CollectionIcon__ = __webpack_require__(958);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__CreationError__ = __webpack_require__(963);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__empty_states_CollectionsEmpty__ = __webpack_require__(3671);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__models_services_DashboardService__ = __webpack_require__(309);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__base_XPaths_XPath__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__services_EditorService__ = __webpack_require__(66);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__utils_EditorUtils__ = __webpack_require__(113);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__utils_EditorUtils___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_16__utils_EditorUtils__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__modules_model_event__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__external_navigation_ExternalNavigationService__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_20__constants_AppUrlConstants__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_21__collections_CollectionMetaIcons__ = __webpack_require__(1492);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_22__collections_CollectionForkLabel__ = __webpack_require__(656);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_23__postman_data_editor__ = __webpack_require__(3623);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_23__postman_data_editor___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_23__postman_data_editor__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_24__base_data_editor_RowRenderer__ = __webpack_require__(3770);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_25__base_data_editor_components_DEInputs__ = __webpack_require__(3771);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_26__base_data_editor_components_HeaderActions__ = __webpack_require__(3772);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_27__utils_PluralizeHelper__ = __webpack_require__(533);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_28__utils_httpstatuscodes__ = __webpack_require__(974);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_29__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_30__DataEditorRequestMethods__ = __webpack_require__(3773);
var _class;



































let getAllStatusList = () => {
  return _.reduce(__WEBPACK_IMPORTED_MODULE_28__utils_httpstatuscodes__["a" /* default */], (acc, obj, key) => {
    acc.push({ value: `${key} ${obj.name}` });
    return acc;
  }, []);
};let


CreateNewMockModal = Object(__WEBPACK_IMPORTED_MODULE_1_mobx_react__["a" /* observer */])(_class = class CreateNewMockModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    let DEConfig = {
      columns: [{
        name: 'method',
        type: 'string',
        label: 'Method',
        width: 17,
        resize: true,
        default: 'GET',
        renderer: (value, onAction, { isCollapsed, subColumnIndex }, style, cellInfo) => {
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_30__DataEditorRequestMethods__["a" /* default */], { value: value, onChange: value => onAction('edit', { value }) }));

        } },

      {
        name: 'url',
        type: 'string',
        label: 'Request Path',
        width: 33,
        resize: true,
        default: '',
        renderer: (value, onAction, { isCollapsed, subColumnIndex }, style, cellInfo) => {
          let handleChange = value => {
            onAction && onAction(
            'edit',
            { value: value });

          };
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_14__base_XPaths_XPath__["a" /* default */], { identifier: 'url', key: 'url' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'data-editor__cell--path' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'prefix' }, '{{url}}/'),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_25__base_data_editor_components_DEInputs__["a" /* default */], {
                  value: value,
                  onAction: handleChange,
                  cellInfo: cellInfo,
                  placeholder: 'Path' }))));




        } },
      {
        name: 'requestBody',
        type: 'string',
        label: 'Request Body',
        width: 15,
        resize: true,
        hidden: true,
        default: '',
        renderer: (value, onAction, { isCollapsed, subColumnIndex }, style, cellInfo) => {
          let handleChange = value => {
            onAction && onAction(
            'edit',
            { value: value });

          };

          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_14__base_XPaths_XPath__["a" /* default */], { identifier: 'requestBody', key: 'requestBody' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_25__base_data_editor_components_DEInputs__["a" /* default */], {
                value: value,
                onAction: handleChange,
                cellInfo: cellInfo,
                placeholder: 'Request Body' })));



        } },
      {
        name: 'description',
        type: 'string',
        label: 'Description',
        width: 15,
        resize: true,
        hidden: true,
        default: '',
        renderer: (value, onAction, { isCollapsed, subColumnIndex }, style, cellInfo) => {
          let handleChange = value => {
            onAction && onAction(
            'edit',
            { value: value });

          };

          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_14__base_XPaths_XPath__["a" /* default */], { identifier: 'description', key: 'description' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_25__base_data_editor_components_DEInputs__["a" /* default */], {
                value: value,
                onAction: handleChange,
                cellInfo: cellInfo,
                placeholder: 'Description' })));



        } },
      {
        name: 'code',
        type: 'string',
        label: 'Response Code',
        width: 17,
        resize: true,
        default: 200,
        renderer: (value, onAction, { isCollapsed, subColumnIndex }, style, cellInfo) => {
          let handleChange = value => {
            onAction && onAction(
            'edit',
            { value: value });

          };

          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_14__base_XPaths_XPath__["a" /* default */], { identifier: 'code', key: 'code' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_25__base_data_editor_components_DEInputs__["a" /* default */], {
                type: 'number',
                value: value,
                onAction: handleChange,
                cellInfo: cellInfo,
                placeholder: value,
                suggestions: getAllStatusList() })));



        } },
      {
        name: 'response',
        type: 'string',
        label: 'Response Body',
        width: 33,
        resize: true,
        default: '',
        renderer: (value, onAction, { isCollapsed, subColumnIndex }, style, cellInfo) => {
          let handleChange = value => {
            onAction && onAction(
            'edit',
            { value: value });

          };

          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_14__base_XPaths_XPath__["a" /* default */], { identifier: 'response', key: 'response' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_25__base_data_editor_components_DEInputs__["a" /* default */], {
                value: value,
                onAction: handleChange,
                cellInfo: cellInfo,
                placeholder: 'Response Body' })));



        } }],

      renderers: {
        row: ({ children, index, nodeId }, onAction, { isCollapsed, subColumnIndex }, style) => {
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_24__base_data_editor_RowRenderer__["a" /* default */], {
                index: index,
                style: style,
                nodeId: nodeId,
                onAction: onAction },

              children));


        },
        header: children => {
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'data-editor__custom-header' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'data-editor__header-offset' }),
              children,
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'data-editor__header__controls' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_26__base_data_editor_components_HeaderActions__["a" /* default */], {
                  onColumnToggle: this.handleColumnToggle,
                  config: this.state.config }))));




        } },

      height: 300 };


    this.state = {
      values: [],
      config: DEConfig };


    this.handleChange = this.handleChange.bind(this);
    this.handleColumnToggle = this.handleColumnToggle.bind(this);
    this.getSelectedOptionName = this.getSelectedOptionName.bind(this);
    this.openLink = this.openLink.bind(this);
    this.openRequestInTab = this.openRequestInTab.bind(this);
  }

  getClasses() {
    return __WEBPACK_IMPORTED_MODULE_2_classnames___default()({
      'create-new-monitor-modal__content': true,
      [`step${this.props.activeStep}`]: true });

  }

  getSelectedOptionName(list, selectedItem, defaultValue) {
    let item = _.find(list, ['id', selectedItem]);

    if (!item) {
      return defaultValue;
    }

    return item.name;
  }

  openLink(link) {
    link && Object(__WEBPACK_IMPORTED_MODULE_19__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(link);
  }

  openRequestInTab() {
    let activeWorkspaceSessionId = Object(__WEBPACK_IMPORTED_MODULE_29__stores_get_store__["getStore"])('ActiveWorkspaceSessionStore').id;

    this.props.onClose && this.props.onClose();

    // open the mock as a request with Url prefilled
    __WEBPACK_IMPORTED_MODULE_15__services_EditorService__["a" /* default */].open(Object(__WEBPACK_IMPORTED_MODULE_16__utils_EditorUtils__["requestResourceId"])({ id: __WEBPACK_IMPORTED_MODULE_3_uuid_v4___default()() }), {
      initialValue: { url: this.props.selectedOptions.mockUrl } });


    Object(__WEBPACK_IMPORTED_MODULE_17__modules_pipelines_user_action__["a" /* default */])(Object(__WEBPACK_IMPORTED_MODULE_18__modules_model_event__["a" /* createEvent */])(
    'setActiveEnvironment',
    'workspacesession',
    {
      workspaceSession: { id: activeWorkspaceSessionId },
      activeEnvironment: this.props.selectedOptions.environmentId }));


  }

  focusUrl(requestIndex) {
    this.refs[`request-${requestIndex}-url`] && this.refs[`request-${requestIndex}-url`].focus();
  }

  onCollectionSelect() {
    this.refs.mockName && this.refs.mockName.focus();
  }

  handleChange(values) {
    this.setState({ values });

    let requests = _.dropRight(__WEBPACK_IMPORTED_MODULE_23__postman_data_editor__["utils"].unflattenNodes(values));
    this.props.onRequestChange(requests);
  }

  handleColumnToggle(newConfig) {
    this.setState({ config: newConfig });
  }

  renderStep1() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__body step1' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Tabs__["b" /* Tabs */], {
            type: 'primary',
            defaultActive: 'new',
            activeRef: this.props.activeSource,
            onChange: this.props.onChangeSource },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_14__base_XPaths_XPath__["a" /* default */], { identifier: 'createNewTab' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Tabs__["a" /* Tab */], {
                refKey: 'new',
                className: 'create-new-monitor-modal__body__tab-content' }, 'Create a new collection')),




          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_14__base_XPaths_XPath__["a" /* default */], { identifier: 'chooseCollectionTab' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Tabs__["a" /* Tab */], { refKey: 'workspace' }, 'Select an existing collection'))),



        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__right__intro' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'create-new-monitor-modal__right__intro__heading' }, 'Mock servers let you simulate your API endpoints without having to set up a backend.'),


            this.props.activeSource === 'new' &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_0_react__["Fragment"], null,
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Enter request paths for your API endpoints and then the expected response code and response body to create an'),



              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_Buttons__["a" /* Button */], {
                  type: 'text',
                  className: 'learn-more-link',
                  onClick: () => {
                    Object(__WEBPACK_IMPORTED_MODULE_19__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_20__constants_AppUrlConstants__["D" /* EXAMPLE_DOCS */]);
                  } }, 'example.'),



              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'To add a body or header to the request, click the (\u2022\u2022\u2022) icon.')),


            this.props.activeSource === 'workspace' &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Select a collection from this workspace to mock.'))),



        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__right' },

          this.props.activeSource === 'new' &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_14__base_XPaths_XPath__["a" /* default */], { identifier: 'createNew' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__right__table' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__data-editor' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_23__postman_data_editor__["DataEditor"], {
                  input: this.state.values,
                  config: this.state.config,
                  onChange: this.handleChange })))),







          this.props.activeSource === 'workspace' && _.isEmpty(this.props.ownCollections) &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_12__empty_states_CollectionsEmpty__["a" /* default */], {
            isMember: true,
            workspaceId: Object(__WEBPACK_IMPORTED_MODULE_29__stores_get_store__["getStore"])('ActiveWorkspaceStore').id,
            onClose: this.props.onClose }),




          this.props.activeSource === 'workspace' && !_.isEmpty(this.props.ownCollections) &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_14__base_XPaths_XPath__["a" /* default */], { identifier: 'chooseCollection' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__right__collections' },

              _.map(this.props.ownCollections, c => {
                return (
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_14__base_XPaths_XPath__["a" /* default */], { identifier: c.id },
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__card', key: c.id, onClick: this.props.onSelectCollection.bind(this, c) },
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__base_Icons_CollectionIcon__["a" /* default */], { className: 'create-new-monitor-modal__card__icon' }),
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__card__content' },
                        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__card__title' },
                          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, c.name),
                          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_21__collections_CollectionMetaIcons__["a" /* default */], { collection: c })),

                        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__card__subtitle' },
                          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'create-new-monitor-modal__card__requests' },
                            c.requestCount, ' ', __WEBPACK_IMPORTED_MODULE_27__utils_PluralizeHelper__["a" /* default */].pluralize({
                              count: c.requestCount,
                              singular: 'request',
                              plural: 'requests' })),


                          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_22__collections_CollectionForkLabel__["a" /* default */], { forkInfo: _.get(c, 'forkInfo') }))))));





              })))),





        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__footer__helptext' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Learn how mock servers and examples can '),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_Buttons__["a" /* Button */], {
              type: 'text',
              className: 'learn-more-link',
              onClick: () => {
                Object(__WEBPACK_IMPORTED_MODULE_19__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_20__constants_AppUrlConstants__["R" /* MOCKING_WITH_EXAMPLES */]);
              } }, 'speed up your API development.'))));






  }

  renderStep2() {
    if (this.props.isLoading) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__body step2 is-loading' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__base_LoadingIndicator__["a" /* default */], null)));


    }

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__body step2' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input-group create-new-monitor__body__input-group--name' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__label' }, 'Name the mock server'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__field' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_14__base_XPaths_XPath__["a" /* default */], { identifier: 'mockName' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Inputs__["b" /* Input */], {
                  ref: 'mockName',
                  inputStyle: 'box',
                  value: this.props.selectedOptions.name,
                  onChange: this.props.onMockNameChange,
                  onEnter: this.props.onCreateMock }))))),





        this.props.selectedOptions.collectionId &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input-group create-new-monitor__body__input-group--environment' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__label' }, 'Select a version tag'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__field' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_14__base_XPaths_XPath__["a" /* default */], { identifier: 'mockVersion' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Dropdowns__["a" /* Dropdown */], {
                    allowScroll: true,
                    fullWidth: true,
                    onSelect: this.props.onSelectVersion,
                    className: 'version-dropdown' },

                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Dropdowns__["b" /* DropdownButton */], {
                      size: 'small',
                      type: 'secondary' },

                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_Buttons__["a" /* Button */], null,
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'version-dropdown__button-label' },
                        this.getSelectedOptionName(this.props.ownVersions, this.props.selectedOptions.versionId, '')))),



                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Dropdowns__["c" /* DropdownMenu */], { fluid: true },

                    _.map(this.props.ownVersions, version => {
                      return (
                        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Dropdowns__["d" /* MenuItem */], {
                            key: version.id,
                            refKey: version.id },

                          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, version.name)));


                    }))))),





            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input__helptext' }, 'Version tags allow you to link the mock server to a specific API version.'))),





        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input-group create-new-monitor__body__input-group--environment' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__label' }, 'Select an environment (optional)'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__field' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_14__base_XPaths_XPath__["a" /* default */], { identifier: 'environment' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Dropdowns__["a" /* Dropdown */], {
                    allowScroll: true,
                    fullWidth: true,
                    onSelect: this.props.onSelectEnvironment },

                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Dropdowns__["b" /* DropdownButton */], {
                      size: 'small',
                      type: 'secondary' },

                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_Buttons__["a" /* Button */], null, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, this.getSelectedOptionName(this.props.ownEnvironments, this.props.selectedOptions.environmentId, 'No Environment')))),

                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Dropdowns__["c" /* DropdownMenu */], { fluid: true },

                    _.isEmpty(this.props.ownEnvironments) ?
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Dropdowns__["d" /* MenuItem */], { refKey: '' }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'No Environment')) :
                    _.map(this.props.ownEnvironments, obj => {
                      return (
                        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Dropdowns__["d" /* MenuItem */], {
                            key: obj.id,
                            refKey: obj.id },

                          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, obj.name)));


                    }))))),





            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input__helptext' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Environments are groups of variables. The mock server will use the variable values from the selected environment in the request and response.')))),







        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input-group create-new-monitor__body__input-group--private' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__field' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Inputs__["a" /* Checkbox */], {
                checked: this.props.selectedOptions.isPrivate,
                onChange: this.props.onMockPrivateChange }),

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', {
                  onClick: this.props.onMockPrivateChange.bind(this, !this.props.selectedOptions.isPrivate),
                  className: 'create-new-monitor__body__input__label--checkbox' }, 'Make this mock server private')),




            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input__helptext' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Note: To call a private mock server, you\'ll need to add an '),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('code', { className: 'create-new-monitor__body__input__helptext__markdown' }, 'x-api-key'),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, ' header to your requests. See how to '),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_Buttons__["a" /* Button */], {
                  type: 'text',
                  onClick: this.openLink.bind(this, __WEBPACK_IMPORTED_MODULE_20__constants_AppUrlConstants__["Z" /* PRO_API_INTRO */]),
                  className: 'learn-more-link create-new-monitor__body__input__helptext__link' }, 'generate a Postman API key.')))),






        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input-group create-new-monitor__body__input-group--create-environment' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__field' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Inputs__["a" /* Checkbox */], {
                checked: this.props.selectedOptions.createEnvironment,
                onChange: this.props.onCreateEnvironmentChange }),

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', {
                  onClick: this.props.onCreateEnvironmentChange.bind(this, !this.props.selectedOptions.createEnvironment),
                  className: 'create-new-monitor__body__input__label--checkbox' }, 'Save the mock server URL as an environment variable')),




            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input__helptext' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Note: This will create a new environment containing the URL.'))))));






  }

  renderStep3() {
    if (_.isEqual(this.props.activeSource, 'new') && this.props.collectionStatus.loading || this.props.mockStatus.loading) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__body step3' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__base_LoadingIndicator__["a" /* default */], null)));


    }

    let heading,
    subHeading;

    if (_.isEqual(this.props.activeSource, 'new') && this.props.selectedOptions.createEnvironment) {
      heading = 'Mock server, collection and environment created';
      subHeading =
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__content__header__helper-text' }, 'To keep things easy, they\'re all named\xA0',

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'create-new-monitor-modal__content__header__helper-text__entity-name' },
          this.props.selectedOptions.name), '.');




    } else
    if (_.isEqual(this.props.activeSource, 'new')) {
      heading = 'Mock server and collection created';
      subHeading =
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__content__header__helper-text' }, 'To keep things easy, they\'re both named\xA0',

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'create-new-monitor-modal__content__header__helper-text__entity-name' },
          this.props.selectedOptions.name), '.');




    } else
    if (_.isEqual(this.props.activeSource, 'workspace') && this.props.selectedOptions.createEnvironment) {
      heading = 'Mock server and environment created';
      subHeading =
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__content__header__helper-text' }, 'To keep things easy, they\'re both named\xA0',

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'create-new-monitor-modal__content__header__helper-text__entity-name' },
          this.props.selectedOptions.name), '.');




    } else
    {
      heading = 'Mock server created';
      subHeading =
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__content__header__helper-text' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'create-new-monitor-modal__content__header__helper-text__entity-name' },
          this.props.selectedOptions.name), '\xA0has been created for\xA0',


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'create-new-monitor-modal__content__header__helper-text__entity-name' },
          _.get(Object(__WEBPACK_IMPORTED_MODULE_29__stores_get_store__["getStore"])('CollectionStore').find(this.props.selectedOptions.collectionId), 'name')), '\xA0collection.');




    }

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__body step3' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__card__center' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__content__header' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__content__header__icon' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_9__base_Icons_MockIcon__["a" /* default */], {
                className: 'create-new-monitor-modal__content__header__icon__mock',
                size: 'lg' })),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__content__header__text' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__content__header__text__title' },
                heading),

              subHeading)),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'separator' }, 'Try it out:',

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'separator-line' })),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__content__footer' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__content__footer__title' }, 'To call the mock server:'),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__step' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__step__text' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Add examples responses to each request that the mock server will return.'),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_Buttons__["a" /* Button */], {
                    className: 'learn-more-link',
                    onClick: this.openLink.bind(this, __WEBPACK_IMPORTED_MODULE_20__constants_AppUrlConstants__["D" /* EXAMPLE_DOCS */]),
                    type: 'text' }, 'Learn what examples are and how to use them'))),




            this.props.selectedOptions.isPrivate &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__step' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__step__text' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Add an '),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('code', { className: 'create-new-monitor-modal__step__text__markdown' }, 'x-api-key'),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, ' header to your requests. '),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_Buttons__["a" /* Button */], {
                    className: 'learn-more-link',
                    type: 'text',
                    onClick: this.openLink.bind(this, __WEBPACK_IMPORTED_MODULE_20__constants_AppUrlConstants__["_0" /* PRO_API_KEYS_LINK */]) }, 'Generate Postman API key'))),




            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__step' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__step__text' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Then just send a request to the following URL, followed by the request path: '),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_Buttons__["a" /* Button */], {
                    onClick: this.openRequestInTab,
                    type: 'text',
                    className: 'learn-more-link' },

                  this.props.selectedOptions.mockUrl + '/'),

                this.props.selectedOptions.createEnvironment &&
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, 'Or select the\xA0',

                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'create-new-monitor-modal__step__text__bold' }, this.props.selectedOptions.name), '\xA0environment and enter\xA0',

                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'create-new-monitor-modal__step__text__bold' }, '{{url}}'), '\xA0followed by the request path.'))),





            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__footer__helptext' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Note: Calls to a mock server count against your plan\'s monthly call limits. Be sure to check your '),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_Buttons__["a" /* Button */], {
                  type: 'text',
                  className: 'learn-more-link',
                  onClick: __WEBPACK_IMPORTED_MODULE_13__models_services_DashboardService__["q" /* openPostmanUsages */] }, 'usage limits'), '.')))));








  }

  render() {
    if (this.props.collectionStatus.error || this.props.mockStatus.error) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__error' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_11__CreationError__["a" /* default */], {
            subtitle: 'Something went wrong while creating this mock. You can try again later.',
            onRetry: this.props.onRetry })));



    }

    if (this.props.isOffline && this.props.activeStep !== 3) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__error' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_11__CreationError__["a" /* default */], {
            subtitle: 'Please check your internet connection and try again.',
            onRetry: this.props.onOfflineRetry })));



    }

    if (this.props.errorFetchingVersions) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__error' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_11__CreationError__["a" /* default */], {
            subtitle: 'Please check your internet connection and try again.',
            onRetry: this.props.onVersionFetchRetry })));



    }

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: this.getClasses() },

        this.props.activeStep === 1 && this.renderStep1(),


        this.props.activeStep === 2 && this.renderStep2(),


        this.props.activeStep === 3 && this.renderStep3()));




  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5043:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CreateNewDocumentationModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_base_Tabs__ = __webpack_require__(103);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_base_Icons_SuccessIcon__ = __webpack_require__(312);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__utils_util__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_new_button_CreateNewDocumentationModal__ = __webpack_require__(5044);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__modules_services_CollectionPermissionService__ = __webpack_require__(1000);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__modules_model_event__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__modules_controllers_UserController__ = __webpack_require__(39);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__models_services_DocumenterService__ = __webpack_require__(3619);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15_mobx_react__ = __webpack_require__(11);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _class;
















let initialState = {
  isOpen: false,
  activeStep: 1,
  activeSource: 'new',
  ownCollections: [],
  ownEnvironments: [],
  selectedOptions: {
    name: '',
    description: '# Introduction\nWhat does your API do?\n\n# Overview\nThings that the developers should know about\n\n# Authentication\nWhat is the preferred way of using the API?\n\n# Error Codes\nWhat errors and status codes can a user expect?\n\n# Rate limit\nIs there a limit to the number of requests an user can send?',
    requests: [],
    collectionId: '',
    environmentId: '',
    docsUrl: '' },

  from: 'create_new_x',
  collectionStatus: {
    loading: true,
    error: false },

  userStatus: {},
  saveToActivity: false,
  workspaceId: null };let



CreateNewDocumentationModalContainer = Object(__WEBPACK_IMPORTED_MODULE_15_mobx_react__["a" /* observer */])(_class = class CreateNewDocumentationModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = initialState;

    this.loadWorkspaceCollections = this.loadWorkspaceCollections.bind(this);
    this.loadOwnEnvironments = this.loadOwnEnvironments.bind(this);
    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleChangeSource = this.handleChangeSource.bind(this);

    this.handleSelectCollection = this.handleSelectCollection.bind(this);
    this.handleSelectEnvironment = this.handleSelectEnvironment.bind(this);
    this.handleRequestChange = this.handleRequestChange.bind(this);

    this.handleCollectionNameChange = this.handleCollectionNameChange.bind(this);
    this.handleCollectionDescriptionChange = this.handleCollectionDescriptionChange.bind(this);
    this.handleCreate = this.handleCreate.bind(this);
    this.handleRetry = this.handleRetry.bind(this);
    this.handleBack = this.handleBack.bind(this);

    this.constructCollection = this.constructCollection.bind(this);
    this.constructDocumentation = this.constructDocumentation.bind(this);
  }

  componentDidMount() {
    pm.mediator.on('openCreateNewDocumentationModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('openCreateNewDocumentationModal', this.handleOpen);
  }

  getStyles() {
    return {
      marginTop: '10vh',
      height: '75vh',
      minWidth: '900px',
      width: '80vw' };

  }

  loadWorkspaceCollections() {
    let ownCollections = Object(__WEBPACK_IMPORTED_MODULE_13__stores_get_store__["getStore"])('ActiveWorkspaceStore').collections,
    accessibleCollections = _.filter(ownCollections, collection => {
      return Object(__WEBPACK_IMPORTED_MODULE_13__stores_get_store__["getStore"])('PermissionStore').can('edit', 'collection', collection.id);
    });

    this.setState({ ownCollections: accessibleCollections });
  }

  loadOwnEnvironments() {
    let ownEnvironments = Object(__WEBPACK_IMPORTED_MODULE_13__stores_get_store__["getStore"])('ActiveWorkspaceStore').environments,
    sortedEnvironments = _.sortBy(ownEnvironments, environment => {
      return environment.name.toLowerCase();
    }),
    allEnvironments = _.concat({ id: null, name: 'No Environment' }, sortedEnvironments);

    this.setState({ ownEnvironments: allEnvironments });
  }

  handleClose() {
    this.handleSaveToActivity();
    this.setState(_extends({},
    initialState, {
      isOpen: false }));

  }

  handleSaveToActivity() {
    if (!this.state.saveToActivity) {
      return;
    }
    let options = _.pick(this.state.selectedOptions, ['name', 'collectionId', 'environmentId', 'docsUrl']);
    let metaObj = {
      activeSource: this.state.activeSource,
      collectionStatus: this.state.collectionStatus,
      selectedOptions: options };

    pm.mediator.trigger('saveXFlowActivity', 'documentation', metaObj);
  }

  handleOpen(openState = {}) {
    this.setState(_extends({},
    initialState,
    openState, {
      selectedOptions: _extends({},
      initialState.selectedOptions,
      openState.selectedOptions),

      isOpen: true }),
    () => {
      __WEBPACK_IMPORTED_MODULE_8__modules_services_AnalyticsService__["a" /* default */].addEvent('documenter', 'initiate_add', this.state.from);
    });
  }

  handleChangeSource(activeSource) {
    this.setState({ activeSource }, () => {
      if (this.state.activeSource === 'workspace') {
        this.loadWorkspaceCollections();
      }
    });
  }

  handleSelectCollection(collection) {
    let newState = {};
    switch (this.state.activeSource) {
      case 'new':
        newState = {
          selectedOptions: _extends({},
          this.state.selectedOptions, {
            collectionId: '' }) };


        break;
      case 'workspace':
        newState = {
          selectedOptions: _extends({},
          this.state.selectedOptions, {
            collectionId: collection.id,
            name: collection.name,
            description: _.isEmpty(collection.description) ? initialState.selectedOptions.description : collection.description }) };


        if (!_.isEmpty(collection.description)) {
          newState.selectedOptions.description = collection.description;
        }
        break;}


    this.loadOwnEnvironments();
    this.setState(_extends({},
    newState, {
      activeStep: 2 }),
    () => {
      this.refs.content.onCollectionSelect && this.refs.content.onCollectionSelect();
    });
  }

  handleSelectEnvironment(environmentId) {
    this.setState(state => {
      return {
        selectedOptions: _extends({},
        state.selectedOptions, {
          environmentId }) };


    });
  }

  handleRequestChange(requests) {
    this.setState(state => {
      return {
        selectedOptions: _extends({},
        state.selectedOptions, {
          requests: _.map(requests, request => {
            return {
              url: request.url,
              method: request.method,
              description: request.description,
              code: request.code,
              response: request.response,
              requestBody: request.requestBody };

          }) }) };


    });
  }

  handleCollectionNameChange(name) {
    this.setState(state => {
      return {
        selectedOptions: _extends({},
        state.selectedOptions, {
          name }) };


    });
  }

  handleCollectionDescriptionChange(description) {
    this.setState(state => {
      return {
        selectedOptions: _extends({},
        state.selectedOptions, {
          description }) };


    });
  }

  handleCreate() {
    if (_.isEmpty(this.state.selectedOptions.name)) {
      return;
    }

    if (_.isEmpty(this.state.selectedOptions.collectionId)) {
      this.constructCollection(() => {
        this.constructDocumentation();
      });
    } else
    {
      this.updateCollection(() => {
        this.constructDocumentation();
      });
    }

    this.setState({ activeStep: 3 });
  }

  handleRetry() {
    if (this.state.collectionStatus.error) {
      this.setState({
        collectionStatus: {
          error: false,
          loading: true } },

      () => {
        this.constructCollection(() => {
          this.constructDocumentation();
        });
      });
    }
  }

  handleBack(activeStep) {
    if (activeStep === 0) {
      this.handleClose();
      return pm.mediator.trigger('openCreateNewXModal');
    }

    this.setState({ activeStep });
  }

  async constructCollection(callback) {
    let { id: ownerId } = await __WEBPACK_IMPORTED_MODULE_12__modules_controllers_UserController__["a" /* default */].get(),
    collection = {
      id: __WEBPACK_IMPORTED_MODULE_6__utils_util__["a" /* default */].guid(),
      name: this.state.selectedOptions.name,
      description: this.state.selectedOptions.description,
      owner: ownerId },

    requests = _.map(this.state.selectedOptions.requests,
    request => {
      let requestObject = {
        url: request.url,
        method: request.method || 'GET',
        data: request.requestBody,
        dataMode: 'raw' };

      return _extends({},
      requestObject, {
        id: __WEBPACK_IMPORTED_MODULE_6__utils_util__["a" /* default */].guid(),
        collection: collection.id,
        name: request.url,
        isFromCollection: true,
        time: new Date().getTime(),
        description: request.description || '',
        responses: [
        {
          id: __WEBPACK_IMPORTED_MODULE_6__utils_util__["a" /* default */].guid(),
          name: 'Default',
          status: request.code,
          text: request.response,
          responseCode: {
            code: parseInt(request.code),
            name: _.join(_.drop(_.split(request.code, ' '), 1), ' ') },

          requestObject }] });



    }),
    order = _.map(requests, 'id');

    _.assign(collection, { requests, order });

    let getOriginMeta = from => {
      if (from.startsWith('history')) {
        return 'history/document';
      }

      return from === 'create_new_x' ? 'cnx' : from;
    },
    collectionEvent = Object(__WEBPACK_IMPORTED_MODULE_10__modules_model_event__["a" /* createEvent */])(
    'create_deep',
    'collection',
    { collection },
    null,
    { origin: getOriginMeta(this.state.from) });


    try {
      let response = await Object(__WEBPACK_IMPORTED_MODULE_11__modules_pipelines_user_action__["a" /* default */])(collectionEvent);
      if (!_.isEmpty(_.get(response, 'error'))) {
        pm.logger.error('Error in creating documenter', response.error);
        return;
      }

      this.setState(state => {
        return {
          selectedOptions: _extends({},
          state.selectedOptions, {
            collectionId: collection.id }),

          collectionStatus: _extends({},
          state.collectionStatus, {
            loading: false,
            error: false }) };


      }, () => {
        callback && callback();
      });
    }
    catch (err) {
      pm.logger.error('Error in pipeline for creating documenter', err);
    }
  }

  updateCollection(callback) {
    let updateCollectionEvent = {
      name: 'update',
      namespace: 'collection',
      data: {
        id: _.get(this, 'state.selectedOptions.collectionId'),
        description: _.get(this, 'state.selectedOptions.description') } };



    Object(__WEBPACK_IMPORTED_MODULE_11__modules_pipelines_user_action__["a" /* default */])(updateCollectionEvent).
    then(response => {
      if (!_.isEmpty(_.get(response, 'error'))) {
        pm.logger.error('Error in updataing collection description', response.error);
        return;
      }
      _.isFunction(callback) && callback();
    }).
    catch(err => {
      _.isFunction(callback) && callback();
      pm.logger.error('Error in pipeline while updataing collection description', err);
    });
  }

  constructDocumentation(callback) {
    let selectedOptions = this.state.selectedOptions;

    __WEBPACK_IMPORTED_MODULE_14__models_services_DocumenterService__["a" /* default */].getDocumentationURL(selectedOptions.collectionId, (e, docsUrl) => {
      if (e) {
        return;
      }

      this.setState(state => {
        return {
          selectedOptions: _extends({},
          state.selectedOptions, {
            docsUrl }),

          collectionStatus: _extends({},
          state.collectionStatus, {
            loading: false,
            error: false }),

          saveToActivity: true };

      }, () => {
        __WEBPACK_IMPORTED_MODULE_8__modules_services_AnalyticsService__["a" /* default */].addEvent('documenter', 'confirm_add', this.state.from);
        pm.mediator.trigger('focusCollectionInSideBar', selectedOptions.collectionId, 'Documentation');
        callback && callback();
      });
    });
  }

  getStepClasses(step) {
    return __WEBPACK_IMPORTED_MODULE_1_classnames___default()({ 'is-done': this.state.activeStep > step });
  }

  render() {
    let currentUser = Object(__WEBPACK_IMPORTED_MODULE_13__stores_get_store__["getStore"])('CurrentUserStore'),
    isLoggedIn = currentUser && currentUser.isLoggedIn,
    isSyncEnabled = Object(__WEBPACK_IMPORTED_MODULE_13__stores_get_store__["getStore"])('GateKeeperStore').isSyncEnabled;

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Modals__["a" /* Modal */], {
          className: 'create-new-documentation-modal',
          isOpen: this.state.isOpen,
          onRequestClose: this.handleClose,
          customStyles: this.getStyles() },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Modals__["d" /* ModalHeader */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Tabs__["b" /* Tabs */], {
              type: 'primary',
              defaultActive: 1,
              activeRef: this.state.activeStep },

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Tabs__["a" /* Tab */], { className: this.getStepClasses(1), refKey: 1 }, this.state.activeStep <= 1 ? '1.' : __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_Icons_SuccessIcon__["a" /* default */], { size: 'xs' }), __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, '\xA0Select a collection to document')),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Tabs__["a" /* Tab */], { className: this.getStepClasses(2), refKey: 2 }, this.state.activeStep <= 2 ? '2.' : __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_Icons_SuccessIcon__["a" /* default */], { size: 'xs' }), __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, '\xA0Write documentation')),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Tabs__["a" /* Tab */], { className: this.getStepClasses(3), refKey: 3 }, this.state.activeStep <= 3 ? '3.' : __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_Icons_SuccessIcon__["a" /* default */], { size: 'xs' }), __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, '\xA0Next steps')))),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Modals__["b" /* ModalContent */], { className: `step${this.state.activeStep}` },

          isLoggedIn && isSyncEnabled &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__components_new_button_CreateNewDocumentationModal__["a" /* default */], {
            ref: 'content',
            activeStep: this.state.activeStep,
            activeSource: this.state.activeSource,
            onChangeSource: this.handleChangeSource,
            ownCollections: this.state.ownCollections,
            ownEnvironments: this.state.ownEnvironments,
            onSelectCollection: this.handleSelectCollection,
            onSelectEnvironment: this.handleSelectEnvironment,
            selectedOptions: this.state.selectedOptions,

            onRequestChange: this.handleRequestChange,
            onRequestCreate: this.handleRequestCreate,
            onRequestDelete: this.handleRequestDelete,
            onCollectionNameChange: this.handleCollectionNameChange,
            onCollectionDescriptionChange: this.handleCollectionDescriptionChange,
            onCreateCollection: this.handleCreate,
            onRetry: this.handleRetry,
            onClose: this.handleClose,

            collectionStatus: this.state.collectionStatus })),




        isLoggedIn &&
        isSyncEnabled &&
        !this.state.collectionStatus.error && (
        this.state.activeStep === 1 || this.state.activeStep === 2 || this.state.activeStep === 3) &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Modals__["c" /* ModalFooter */], { className: `step${this.state.activeStep}` },

          this.state.activeStep === 1 &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__footer' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_Buttons__["a" /* Button */], {
                type: 'primary',
                disabled: _.isEmpty(this.state.selectedOptions.requests) || this.state.activeSource !== 'new',
                onClick: this.handleSelectCollection }, 'Next'),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_Buttons__["a" /* Button */], {
                type: 'secondary',
                onClick: this.handleBack.bind(this, 0) }, 'Back')),





          this.state.activeStep === 2 &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__footer' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_Buttons__["a" /* Button */], {
                  type: 'secondary',
                  onClick: this.handleBack.bind(this, 1) }, 'Back'),

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_Buttons__["a" /* Button */], {
                  type: 'primary',
                  disabled: _.isEmpty(this.state.selectedOptions.name),
                  onClick: this.handleCreate }, 'Save'))),






          this.state.activeStep === 3 &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__footer' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_Buttons__["a" /* Button */], {
                type: 'primary',
                onClick: this.handleClose }, 'Close')))));







  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5044:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CreateNewDocumentationModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Tabs__ = __webpack_require__(103);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_Dropdowns__ = __webpack_require__(31);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__base_TextEditor__ = __webpack_require__(311);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__base_LoadingIndicator__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__base_Icons_PublishIcon__ = __webpack_require__(961);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__base_Icons_CollectionIcon__ = __webpack_require__(958);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__CreationError__ = __webpack_require__(963);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__empty_states_CollectionsEmpty__ = __webpack_require__(3671);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__collections_CollectionMetaIcons__ = __webpack_require__(1492);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__collections_CollectionForkLabel__ = __webpack_require__(656);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__constants_AppUrlConstants__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__postman_data_editor__ = __webpack_require__(3623);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__postman_data_editor___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_16__postman_data_editor__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__base_data_editor_RowRenderer__ = __webpack_require__(3770);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__base_data_editor_components_DEInputs__ = __webpack_require__(3771);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__base_data_editor_components_HeaderActions__ = __webpack_require__(3772);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_20__external_navigation_ExternalNavigationService__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_21__utils_PluralizeHelper__ = __webpack_require__(533);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_22__utils_httpstatuscodes__ = __webpack_require__(974);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_23__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_24__DataEditorRequestMethods__ = __webpack_require__(3773);
var _class;


























let getAllStatusList = () => {
  return _.reduce(__WEBPACK_IMPORTED_MODULE_22__utils_httpstatuscodes__["a" /* default */], (acc, obj, key) => {
    acc.push({ value: `${key} ${obj.name}` });
    return acc;
  }, []);
};let


CreateNewDocumentationModal = Object(__WEBPACK_IMPORTED_MODULE_1_mobx_react__["a" /* observer */])(_class = class CreateNewDocumentationModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    let DEConfig = {
      columns: [{
        name: 'method',
        type: 'string',
        label: 'Method',
        width: 20,
        resize: true,
        default: 'GET',
        renderer: (value, onAction, { isCollapsed, subColumnIndex }, style, cellInfo) => {
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_24__DataEditorRequestMethods__["a" /* default */], { value: value, onChange: value => onAction('edit', { value }) }));

        } },

      {
        name: 'url',
        type: 'string',
        label: 'Request URL',
        width: 40,
        resize: true,
        default: '',
        renderer: (value, onAction, { isCollapsed, subColumnIndex }, style, cellInfo) => {
          let handleChange = value => {
            onAction && onAction(
            'edit',
            { value: value });

          };

          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_18__base_data_editor_components_DEInputs__["a" /* default */], {
              value: value,
              onAction: handleChange,
              cellInfo: cellInfo,
              placeholder: 'URL' }));


        } },
      {
        name: 'requestBody',
        type: 'string',
        label: 'Request Body',
        width: 20,
        resize: true,
        hidden: true,
        default: '',
        renderer: (value, onAction, { isCollapsed, subColumnIndex }, style, cellInfo) => {
          let handleChange = value => {
            onAction && onAction(
            'edit',
            { value: value });

          };

          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_18__base_data_editor_components_DEInputs__["a" /* default */], {
              value: value,
              onAction: handleChange,
              cellInfo: cellInfo,
              placeholder: 'Body' }));


        } },
      {
        name: 'description',
        type: 'string',
        label: 'Description',
        width: 40,
        resize: true,
        default: '',
        renderer: (value, onAction, { isCollapsed, subColumnIndex }, style, cellInfo) => {
          let handleChange = value => {
            onAction && onAction(
            'edit',
            { value: value });

          };

          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_18__base_data_editor_components_DEInputs__["a" /* default */], {
              value: value,
              onAction: handleChange,
              cellInfo: cellInfo,
              placeholder: 'Description' }));


        } },
      {
        name: 'code',
        type: 'string',
        label: 'Response Code',
        width: 23,
        resize: true,
        hidden: true,
        renderer: (value, onAction, { isCollapsed, subColumnIndex }, style, cellInfo) => {
          let handleChange = value => {
            onAction && onAction(
            'edit',
            { value: value });

          };

          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_18__base_data_editor_components_DEInputs__["a" /* default */], {
              type: 'number',
              value: value,
              onAction: handleChange,
              cellInfo: cellInfo,
              placeholder: 'Code',
              suggestions: getAllStatusList() }));


        } },
      {
        name: 'response',
        type: 'string',
        label: 'Response Body',
        width: 36,
        resize: true,
        hidden: true,
        default: '' }],

      renderers: {
        string: (value, onAction, { isCollapsed, subColumnIndex }, style, cellInfo) => {
          let handleChange = value => {
            onAction && onAction(
            'edit',
            { value: value });

          };
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_18__base_data_editor_components_DEInputs__["a" /* default */], {
              value: value,
              onAction: handleChange,
              cellInfo: cellInfo }));


        },
        row: ({ children, index, nodeId }, onAction, { isCollapsed, subColumnIndex }, style) => {
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_17__base_data_editor_RowRenderer__["a" /* default */], {
                index: index,
                style: style,
                nodeId: nodeId,
                onAction: onAction },

              children));


        },
        header: children => {
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'data-editor__custom-header' },
              children,
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'data-editor__header__controls' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_19__base_data_editor_components_HeaderActions__["a" /* default */], {
                  onColumnToggle: this.handleColumnToggle,
                  config: this.state.config }))));




        } },

      height: 300 };


    this.state = {
      values: [],
      config: DEConfig };

    this.getSelectedOptionName = this.getSelectedOptionName.bind(this);
    this.openLink = this.openLink.bind(this);
    this.handleChange = this.handleChange.bind(this);
    this.handleColumnToggle = this.handleColumnToggle.bind(this);
  }

  getClasses() {
    return __WEBPACK_IMPORTED_MODULE_2_classnames___default()({
      'create-new-monitor-modal__content': true,
      [`step${this.props.activeStep}`]: true });

  }

  getSelectedOptionName(list, selectedItem, defaultValue) {
    let item = _.find(list, ['id', selectedItem]);

    if (!item) {
      return defaultValue;
    }

    return item.name;
  }

  openLink(link) {
    link && Object(__WEBPACK_IMPORTED_MODULE_20__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(link);
  }

  onCollectionSelect() {
    this.refs.collectionName && this.refs.collectionName.focus();
  }

  getDocumentationLinkShortened(link) {
    return _.truncate(link, { length: 60 });
  }

  handleChange(values) {
    this.setState({ values });

    let requests = _.dropRight(__WEBPACK_IMPORTED_MODULE_16__postman_data_editor__["utils"].unflattenNodes(values));
    this.props.onRequestChange(requests);
  }

  handleColumnToggle(newConfig) {
    this.setState({ config: newConfig });
  }

  renderStep1() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__body step1' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Tabs__["b" /* Tabs */], {
            type: 'primary',
            defaultActive: 'new',
            activeRef: this.props.activeSource,
            onChange: this.props.onChangeSource,
            className: 'tabs-container' },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Tabs__["a" /* Tab */], { refKey: 'new' }, 'Create a new collection'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Tabs__["a" /* Tab */], { refKey: 'workspace' }, 'Select an existing collection')),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__right__intro' },
          this.props.activeSource === 'new' ?
          'Create a new collection by adding individual requests. Use the "Description" column to document what each endpoint URL does. To add a request body or an example response body, click the (•••) icon.' :
          'Make your collection easier to consume by adding documentation. Select a collection to document.'),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__right' },

          this.props.activeSource === 'new' &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__right__table' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__data-editor' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_16__postman_data_editor__["DataEditor"], {
                input: this.state.values,
                config: this.state.config,
                onChange: this.handleChange }))),






          this.props.activeSource === 'workspace' && _.isEmpty(this.props.ownCollections) &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_12__empty_states_CollectionsEmpty__["a" /* default */], {
            isMember: true,
            workspaceId: Object(__WEBPACK_IMPORTED_MODULE_23__stores_get_store__["getStore"])('ActiveWorkspaceStore').id,
            onClose: this.props.onClose }),




          this.props.activeSource === 'workspace' && !_.isEmpty(this.props.ownCollections) &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__right__collections' },

            _.map(this.props.ownCollections, c => {
              return (
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__card', key: c.id, onClick: this.props.onSelectCollection.bind(this, c) },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__base_Icons_CollectionIcon__["a" /* default */], { className: 'create-new-monitor-modal__card__icon' }),
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__card__content' },
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__card__title' },
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, c.name),
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_13__collections_CollectionMetaIcons__["a" /* default */], { collection: c })),

                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__card__subtitle' },
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'create-new-monitor-modal__card__requests' },
                        c.requestCount, ' ', __WEBPACK_IMPORTED_MODULE_21__utils_PluralizeHelper__["a" /* default */].pluralize({
                          count: c.requestCount,
                          singular: 'request',
                          plural: 'requests' })),


                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_14__collections_CollectionForkLabel__["a" /* default */], { forkInfo: _.get(c, 'forkInfo') })))));




            })))));






  }

  renderStep2() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__body step2' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input-group create-new-monitor__body__input-group--name' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__label' },

            this.props.activeSource === 'new' ?
            'Name your collection' :
            'Collection Name'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__field' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Inputs__["b" /* Input */], {
                ref: 'collectionName',
                disabled: !_.isEmpty(this.props.selectedOptions.collectionId),
                inputStyle: 'box',
                value: this.props.selectedOptions.name,
                onChange: this.props.onCollectionNameChange,
                onEnter: this.props.onCreateCollection })))),




        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input-group create-new-monitor__body__input-group--description' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__label' }, 'Describe your collection'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__field' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_TextEditor__["a" /* default */], {
                height: '100%',
                hideGutter: true,
                showScrollMargin: true,
                value: this.props.selectedOptions.description,
                mode: 'markdown',
                placeholder: 'Make things easier for your teammates with a complete request description.',
                onChange: this.props.onCollectionDescriptionChange })),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor__body__input__helptext' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Give a brief description of what your collection can do and some key details such as what the collection provides and who it\'s for.',


                this.props.activeSource !== 'new' && ' Use markdown to add headings, lists, code snippets, etc.'),



              this.props.activeSource === 'new' && __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null,
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('br', null), __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('br', null),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'You can use '),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Buttons__["a" /* Button */], {
                    className: 'learn-more-link',
                    type: 'text',
                    onClick: __WEBPACK_IMPORTED_MODULE_20__external_navigation_ExternalNavigationService__["a" /* openExternalLink */].bind(this, __WEBPACK_IMPORTED_MODULE_15__constants_AppUrlConstants__["Q" /* MARKDOWN_DOCS */]) }, 'markdown'),



                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, ' for adding headings, lists, code snippets etc. in your description.')))))));







  }

  renderStep3() {
    if (this.props.collectionStatus.error) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__body is-error step3' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_11__CreationError__["a" /* default */], {
            subtitle: 'Something went wrong while creating this documentation. You can try again later.',
            onRetry: this.props.onRetry })));



    } else
    if (this.props.collectionStatus.loading) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__body step3' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__base_LoadingIndicator__["a" /* default */], null)));


    }

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__body step3' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__card__center' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__content__header' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__content__header__icon' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_9__base_Icons_PublishIcon__["a" /* default */], {
                className: 'create-new-monitor-modal__content__header__icon__documentation',
                size: 'lg' })),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__content__header__text' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__content__header__text__title' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('b', null, _.truncate(this.props.selectedOptions.name, { length: 40 }), ' '),

                this.props.activeSource === 'new' ?
                ' created and documented' :
                ' documented'),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__content__header__text__text view_documentation' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, 'Take a look at your beautiful new documentation:'),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Buttons__["a" /* Button */], {
                    onClick: this.openLink.bind(this, this.props.selectedOptions.docsUrl),
                    type: 'text' },

                  this.props.selectedOptions.docsUrl),

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, 'The documentation is private, so only people you share the collection with can view it.')))),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'separator' }, 'NEXT STEPS',

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'separator-line' })),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__content__footer' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__step' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__step__title' }, 'Add more details to your documentation'),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__step__text' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'For easy onboarding, you can also describe request params, body, and even collection folders.'),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Buttons__["a" /* Button */], {
                    onClick: this.openLink.bind(this, __WEBPACK_IMPORTED_MODULE_15__constants_AppUrlConstants__["H" /* INTRO_API_DOCUMENTATION */]),
                    type: 'text' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, ' Learn how')))),



            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__step' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__step__title' }, 'Share with your team'),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__step__text' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Share the documentation to a team workspace so your teammates can view and collaborate on it.'),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Buttons__["a" /* Button */], {
                    onClick: this.openLink.bind(this, __WEBPACK_IMPORTED_MODULE_15__constants_AppUrlConstants__["_17" /* VIEW_DOCS */]),
                    type: 'text' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, 'Learn how')))),



            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__step' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__step__title' }, 'Share with the world'),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__step__text' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Publish the documentation for people outside your team on a custom domain with your own branding.'),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Buttons__["a" /* Button */], {
                    className: 'learn-more-link',
                    onClick: this.openLink.bind(this, __WEBPACK_IMPORTED_MODULE_15__constants_AppUrlConstants__["y" /* DOCUMENTATION_PUBLISH_DOCS */]),
                    type: 'text' }, 'Learn more'))),



            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__step' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__step__title' }, 'Add sample responses'),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-monitor-modal__step__text' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Make your collection easier to consume by documenting some example responses.'),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Buttons__["a" /* Button */], {
                    onClick: this.openLink.bind(this, __WEBPACK_IMPORTED_MODULE_15__constants_AppUrlConstants__["c" /* ADD_EXAMPLE_DOCS */]),
                    type: 'text' }, 'Learn how to create examples')))))));







  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: this.getClasses() },

        this.props.activeStep === 1 && this.renderStep1(),


        this.props.activeStep === 2 && this.renderStep2(),


        this.props.activeStep === 3 && this.renderStep3()));




  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5045:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CustomizeTemplateModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__modules_controllers_TemplateController__ = __webpack_require__(1007);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_new_button_CustomizeTemplate__ = __webpack_require__(5046);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__components_new_button_FinishTemplate__ = __webpack_require__(5047);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_new_button_DisabledOperationModal__ = __webpack_require__(3675);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__stores_get_store__ = __webpack_require__(5);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _class;










let


CustomizeTemplateModalContainer = Object(__WEBPACK_IMPORTED_MODULE_9_mobx_react__["a" /* observer */])(_class = class CustomizeTemplateModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      isLoading: false,
      templateId: '',
      versionTag: '',
      selectedOptions: {},
      lifecycle: 'view', // or 'use', 'success', 'failure',
      templateStatus: {},
      userStatus: {},
      saveToActivity: false };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleBack = this.handleBack.bind(this);
    this.handleOptionValueChange = this.handleOptionValueChange.bind(this);
    this.handleCreate = this.handleCreate.bind(this);
  }

  componentDidMount() {
    pm.mediator.on('showCustomizeTemplateContainer', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showCustomizeTemplateContainer', this.handleOpen);
  }

  getClasses() {
    return __WEBPACK_IMPORTED_MODULE_1_classnames___default()({
      'customize-template-modal': true,
      'is-finished': this.state.lifecycle === 'success' });

  }

  getStyles() {
    return {
      marginTop: '10vh',
      width: '80vw',
      maxHeight: '570px',
      height: '75vh' };

  }

  checkOffline() {
    return !navigator.onLine;
  }

  handleOpen(templateId, options, versionTag) {
    if (_.isEmpty(options)) {
      let template = Object(__WEBPACK_IMPORTED_MODULE_10__stores_get_store__["getStore"])('TemplateListStore').find(templateId),
      updatedState = {
        templateId,
        versionTag,
        isOpen: true,
        selectedOptions: { name: template.name },
        lifecycle: 'view' };


      template && (updatedState.selectedOptions = template);
      this.setState(updatedState);
    } else
    {
      this.setState(_extends({
        isOpen: true },
      options));

    }
  }

  handleClose() {
    this.handleSaveToActivity();
    this.setState({
      isOpen: false,
      saveToActivity: false });

  }

  handleSaveToActivity() {
    if (!this.state.saveToActivity) {
      return;
    }
    let metaObj = _extends({},
    _.pick(this.state, ['isLoading', 'selectedOptions']), {
      lifecycle: 'success',
      templateStatus: this.state.templateStatus });

    pm.mediator.trigger('saveXFlowActivity', 'template', metaObj);
  }

  handleBack() {
    this.handleClose();
    pm.mediator.trigger('openCreateNewXModal', 'template', () => {
      pm.mediator.trigger('changeActiveTemplate', this.state.templateId);
    });
  }

  handleOptionValueChange(category, field, value) {
    if (!category || !this.state.selectedOptions || !this.state.selectedOptions[category]) {
      return;
    }

    let changedFieldIndex = _.findIndex(this.state.selectedOptions[category], ['key', field]);

    if (changedFieldIndex === -1) {
      return;
    }

    let newTemplateData = _extends({},
    this.state.selectedOptions, {
      [category]: [
      ..._.slice(this.state.selectedOptions[category], 0, changedFieldIndex), _extends({},

      this.state.selectedOptions[category][changedFieldIndex], {
        value }),

      ..._.slice(this.state.selectedOptions[category], changedFieldIndex + 1)] });



    this.setState({ selectedOptions: newTemplateData });
  }

  handleCreate() {
    if (this.checkOffline()) {
      return;
    }

    this.setState({
      lifecycle: 'use' },
    async () => {
      try {
        await __WEBPACK_IMPORTED_MODULE_4__modules_controllers_TemplateController__["b" /* default */].importTemplate(this.state.templateId, this.state.selectedOptions, this.state.versionTag);
        __WEBPACK_IMPORTED_MODULE_8__modules_services_AnalyticsService__["a" /* default */].addEvent('template', 'successful_import', _.snakeCase(this.state.templateId));
        this.setState({
          isLoading: false,
          saveToActivity: true,
          lifecycle: 'success' });

      }
      catch (e) {
        __WEBPACK_IMPORTED_MODULE_8__modules_services_AnalyticsService__["a" /* default */].addEvent('template', 'failure_import', _.snakeCase(this.state.templateId));
        this.setState({
          isLoading: false,
          lifecycle: 'failure' });

      }
    });
  }

  render() {
    let currentUser = Object(__WEBPACK_IMPORTED_MODULE_10__stores_get_store__["getStore"])('CurrentUserStore'),
    isLoggedIn = currentUser.isLoggedIn,
    isSyncEnabled = Object(__WEBPACK_IMPORTED_MODULE_10__stores_get_store__["getStore"])('GateKeeperStore').isSyncEnabled,
    isOffline = this.checkOffline();

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Modals__["a" /* Modal */], {
          className: this.getClasses(),
          isOpen: this.state.isOpen,
          onRequestClose: this.handleClose,
          customStyles: this.getStyles() },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Modals__["d" /* ModalHeader */], null,

          this.state.lifecycle === 'view' &&
          'Customization options',


          this.state.lifecycle === 'use' &&
          'Importing template...',


          this.state.lifecycle === 'success' &&
          'Success!',


          this.state.lifecycle === 'failure' &&
          'Something went wrong'),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Modals__["b" /* ModalContent */], null,

          (!isLoggedIn || !isSyncEnabled) &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__components_new_button_DisabledOperationModal__["a" /* default */], {
            isLoggedIn: isLoggedIn,
            isSyncEnabled: isSyncEnabled,
            entity: 'template' }),



          isLoggedIn && isSyncEnabled &&
          this.state.lifecycle === 'view' &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_new_button_CustomizeTemplate__["a" /* default */], {
            templateData: this.state.selectedOptions,
            isLoading: this.state.isLoading,
            isOffline: isOffline,
            onOfflineRetry: this.handleCreate,
            onOptionValueChange: this.handleOptionValueChange }),



          isLoggedIn && isSyncEnabled && (
          this.state.lifecycle === 'use' || this.state.lifecycle === 'success' || this.state.lifecycle === 'failure') &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_new_button_FinishTemplate__["a" /* default */], {
            isOffline: isOffline,
            templateData: this.state.selectedOptions,
            lifecycle: this.state.lifecycle,
            onRetry: this.handleCreate })),



        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Modals__["c" /* ModalFooter */], null,

          isLoggedIn && isSyncEnabled &&
          this.state.lifecycle === 'view' &&
          !isOffline &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Buttons__["a" /* Button */], {
                type: 'secondary',
                onClick: this.handleBack }, 'Back'),



            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Buttons__["a" /* Button */], {
                type: 'primary',
                onClick: this.handleCreate }, 'Create')),






          isLoggedIn && isSyncEnabled &&
          this.state.lifecycle === 'success' &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Buttons__["a" /* Button */], {
              type: 'primary',
              onClick: this.handleClose }, 'Okay'))));







  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5046:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CustomizeTemplate; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Icons_CollectionIcon__ = __webpack_require__(958);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_Icons_EnvironmentIcon__ = __webpack_require__(969);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_Icons_MonitorIcon__ = __webpack_require__(654);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__base_Icons_MockIcon__ = __webpack_require__(960);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__base_LoadingIndicator__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__external_navigation_ExternalNavigationService__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__monitor_MonitorScheduleSelector__ = __webpack_require__(1536);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__CreationError__ = __webpack_require__(963);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__constants_AppUrlConstants__ = __webpack_require__(64);
var _class;













let


CustomizeTemplate = Object(__WEBPACK_IMPORTED_MODULE_1_mobx_react__["a" /* observer */])(_class = class CustomizeTemplate extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.renderCollectionCard = this.renderCollectionCard.bind(this);
    this.renderEnvironmentCard = this.renderEnvironmentCard.bind(this);
    this.renderMonitorCard = this.renderMonitorCard.bind(this);
    this.renderMockCard = this.renderMockCard.bind(this);
    this._renderOption = this._renderOption.bind(this);
    this.renderOptions = this.renderOptions.bind(this);
  }

  renderCollectionCard(name) {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__card' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__card__icon' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Icons_CollectionIcon__["a" /* default */], {
            className: 'customize-template__card__icon__icon customize-template__card__icon__icon--collection',
            size: 'lg' }),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__card__icon__icon customize-template__card__icon__icon--collection' })),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__card__text' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__card__title' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('b', null, name), ' collection'),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__card__description' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'A collection is a group of requests. '),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
                className: 'learn-more-link',
                type: 'text',
                onClick: () => {Object(__WEBPACK_IMPORTED_MODULE_9__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_12__constants_AppUrlConstants__["r" /* COLLECTION_DOCS */]);} }, 'Learn more')))));







  }

  renderEnvironmentCard(name) {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__card' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__card__icon' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Icons_EnvironmentIcon__["a" /* default */], {
            className: 'customize-template__card__icon__icon customize-template__card__icon__icon--environment',
            size: 'lg' })),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__card__text' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__card__title' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('b', null, name), ' environment'),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__card__description' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, ' An environment is a group of variables. '),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
                className: 'learn-more-link',
                type: 'text',
                onClick: () => {Object(__WEBPACK_IMPORTED_MODULE_9__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_12__constants_AppUrlConstants__["B" /* ENVIRONMENT_DOCS */]);} }, 'Learn more')))));







  }

  renderMonitorCard(name) {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__card' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__card__icon' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Icons_MonitorIcon__["a" /* default */], {
            className: 'customize-template__card__icon__icon customize-template__card__icon__icon--monitor',
            size: 'lg' })),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__card__text' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__card__title' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('b', null, name), ' monitor'),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__card__description' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'A monitor runs at a schedule to check API performance. '),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
                className: 'learn-more-link',
                type: 'text',
                onClick: () => {Object(__WEBPACK_IMPORTED_MODULE_9__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_12__constants_AppUrlConstants__["T" /* MONITORING_DOCS */]);} }, 'Learn more')))));







  }

  renderMockCard(name) {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__card' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__card__icon' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_Icons_MockIcon__["a" /* default */], {
            className: 'customize-template__card__icon__icon customize-template__card__icon__icon--mock',
            size: 'lg' })),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__card__text' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__card__title' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('b', null, name), ' mock server'),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__card__description' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'A mock server responds with sample responses, without an actual backend. '),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
                className: 'learn-more-link',
                type: 'text',
                onClick: () => {Object(__WEBPACK_IMPORTED_MODULE_9__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_12__constants_AppUrlConstants__["S" /* MOCK_DOCS */]);} }, 'Learn more')))));







  }

  _renderOption(option, category) {
    let child;

    switch (option.type) {
      case 'string':
        child =
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
            className: 'customize-template__options__option',
            key: option.key },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__options__option__label' }, option.label),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__options__option__value' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Inputs__["b" /* Input */], {
              inputStyle: 'box',
              value: option.value,
              onChange: this.props.onOptionValueChange.bind(this, category, option.key) })));




        break;

      case 'boolean':
        child =
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
            className: 'customize-template__options__option',
            key: option.key },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__options__option__value' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Inputs__["a" /* Checkbox */], {
              checked: option.value,
              onChange: this.props.onOptionValueChange.bind(this, category, option.key) })),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__options__option__label' }, option.label));


        break;

      case 'cron':
        child =
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
            className: 'customize-template__options__option',
            key: option.key },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__options__option__label' }, option.label),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__options__option__value' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__monitor_MonitorScheduleSelector__["a" /* default */], {
              onChange: this.props.onOptionValueChange.bind(this, category, option.key) })));




        break;}


    return child;
  }

  renderOptions(options, category) {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__options' },

        _.map(options, option => {
          return this._renderOption(option, category);
        })));



  }

  _renderEnvironmentConfig(config) {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__options' },

        _.map(config, variable => {
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
                className: 'customize-template__options__option',
                key: variable.key },

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__options__option__label' }, variable.label || variable.key),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__options__option__value' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Inputs__["b" /* Input */], {
                  inputStyle: 'box',
                  value: variable.value || variable.default,
                  onChange: this.props.onOptionValueChange.bind(this, 'environmentTemplate', variable.key) }))));




        })));



  }

  _renderMonitorConfig(config) {
    let cronConfig = _.find(config, ['key', 'cron']);
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__options' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__options__option' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__options__option__label' }, cronConfig.label),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__options__option__value' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__monitor_MonitorScheduleSelector__["a" /* default */], { onChange: this.props.onOptionValueChange.bind(this, 'monitor', cronConfig.value) })))));




  }

  render() {
    if (this.props.isOffline) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__error' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_11__CreationError__["a" /* default */], {
              subtitle: 'Please check your internet connection and try again.',
              onRetry: this.props.onOfflineRetry }))));




    }
    let templateData = this.props.templateData;

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'customize-template__description' }, 'You are importing ', __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('b', null, templateData.name), ' template. The following things will be created for you:'),

        this.props.isLoading &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__base_LoadingIndicator__["a" /* default */], null),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__cards' },

          !this.props.isLoading &&
          templateData.collection === true &&
          this.renderCollectionCard(templateData.name),



          !this.props.isLoading &&
          templateData.environment === true &&
          this.renderEnvironmentCard(templateData.name),



          !this.props.isLoading &&
          templateData.monitor === true &&
          this.renderMonitorCard(templateData.name),



          !this.props.isLoading &&
          templateData.mock === true &&
          this.renderMockCard(templateData.name)),



        (!templateData.environmentTemplate ||
        !templateData.monitorConfig) &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__separator' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'customize-template__separator__text' }, 'CONFIGURATION OPTIONS')),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'customize-template__advanced' },

          !this.props.isLoading &&
          templateData.environmentTemplate &&
          this._renderEnvironmentConfig(templateData.environmentTemplate),



          !this.props.isLoading &&
          templateData.monitorConfig &&
          this._renderMonitorConfig(templateData.monitorConfig))));




  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5047:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return FinishTemplate; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_LoadingIndicator__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Icons_CollectionIcon__ = __webpack_require__(958);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Icons_EnvironmentIcon__ = __webpack_require__(969);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_Icons_MonitorIcon__ = __webpack_require__(654);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_Icons_MockIcon__ = __webpack_require__(960);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__CreationError__ = __webpack_require__(963);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__external_navigation_ExternalNavigationService__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__constants_AppUrlConstants__ = __webpack_require__(64);










let

FinishTemplate = class FinishTemplate extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.renderCollectionCard = this.renderCollectionCard.bind(this);
    this.renderEnvironmentCard = this.renderEnvironmentCard.bind(this);
    this.renderMonitorCard = this.renderMonitorCard.bind(this);
    this.renderMockCard = this.renderMockCard.bind(this);
  }

  openLink(url) {
    url && Object(__WEBPACK_IMPORTED_MODULE_8__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(url);
  }

  renderCollectionCard(templateData) {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__card finish-template__card--collection' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__card__left' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__card__left__icon' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Icons_CollectionIcon__["a" /* default */], {
              className: 'finish-template__card__left__icon__icon',
              size: 'lg' })),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__card__left__text' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'finish-template__card__left__text__title' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('b', null, templateData.name),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, ' collection created')),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__card__left__text__text' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'A collection is a group of requests. '),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
                  className: 'learn-more-link',
                  type: 'text',
                  onClick: this.openLink.bind(this, __WEBPACK_IMPORTED_MODULE_9__constants_AppUrlConstants__["r" /* COLLECTION_DOCS */]) }, 'Learn more'))))));








  }

  renderEnvironmentCard(templateData) {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__card finish-template__card--environment' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__card__left' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__card__left__icon' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Icons_EnvironmentIcon__["a" /* default */], {
              className: 'finish-template__card__left__icon__icon',
              size: 'lg' })),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__card__left__text' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'finish-template__card__left__text__title' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('b', null, templateData.name),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, ' environment created')),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__card__left__text__text' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'An environment is a group of variables. '),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
                  className: 'learn-more-link',
                  type: 'text',
                  onClick: this.openLink.bind(this, __WEBPACK_IMPORTED_MODULE_9__constants_AppUrlConstants__["B" /* ENVIRONMENT_DOCS */]) }, 'Learn more'))))));








  }

  renderMonitorCard(templateData) {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__card finish-template__card--monitor' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__card__left' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__card__left__icon' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Icons_MonitorIcon__["a" /* default */], {
              className: 'finish-template__card__left__icon__icon',
              size: 'lg' })),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__card__left__text' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'finish-template__card__left__text__title' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('b', null, templateData.name),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, ' monitor created')),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__card__left__text__text' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'A monitor runs at a schedule to check API performance. '),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
                  className: 'learn-more-link',
                  type: 'text',
                  onClick: this.openLink.bind(this, __WEBPACK_IMPORTED_MODULE_9__constants_AppUrlConstants__["T" /* MONITORING_DOCS */]) }, 'Learn more'))))));








  }

  renderMockCard(templateData) {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__card finish-template__card--mock' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__card__left' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__card__left__icon' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Icons_MockIcon__["a" /* default */], {
              className: 'finish-template__card__left__icon__icon',
              size: 'lg' })),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__card__left__text' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'finish-template__card__left__text__title' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('b', null, templateData.name),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, ' mock server created')),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__card__left__text__text' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'A mock server responds with sample responses, without an actual backend '),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
                  className: 'learn-more-link',
                  type: 'text',
                  onClick: this.openLink.bind(this, __WEBPACK_IMPORTED_MODULE_9__constants_AppUrlConstants__["S" /* MOCK_DOCS */]) }, 'Learn more'))))));








  }

  renderCollectionNextSteps() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__card__right' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__card__right__next' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Add more requests to this collection')),




        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__card__right__description' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Save new requests to this collection in the Postman app.\xA0'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
              type: 'text',
              onClick: this.openLink.bind(this, __WEBPACK_IMPORTED_MODULE_9__constants_AppUrlConstants__["_5" /* SAVE_REQUEST_DOCS */]) }, 'Learn how'))));






  }

  renderEnvironmentNextSteps() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__card__right' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__card__right__next' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Change the variable values')),




        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__card__right__description' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Customize the template by changing the variable values in the environment. '),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
              type: 'text',
              onClick: this.openLink.bind(this, __WEBPACK_IMPORTED_MODULE_9__constants_AppUrlConstants__["B" /* ENVIRONMENT_DOCS */]) }, 'Learn how'))));






  }

  renderMonitorNextSteps() {
    let monitorDashboardURL = `${window.postman_monitors_url}?type=private`;

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__card__right' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__card__right__next' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Check monitor results')),




        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__card__right__description' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'The result of your monitors can be seen at\xA0'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
              type: 'text',
              onClick: this.openLink.bind(this, monitorDashboardURL) },

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, window.postman_monitors_url)))));




  }

  renderMockNextSteps() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__card__right' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__card__right__next' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Send a request to this mock server')),



        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__card__right__description' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
              type: 'text',
              onClick: this.openLink.bind(this, __WEBPACK_IMPORTED_MODULE_9__constants_AppUrlConstants__["S" /* MOCK_DOCS */]) },

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Learn More')),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, '\xA0about mock servers\xA0'))));






  }

  render() {
    let { templateData } = this.props;
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__title' },

          (this.props.lifecycle === 'view' || this.props.lifecycle === 'use') &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, 'The ',
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('b', null, this.props.templateData.name), ' template is being imported. Please wait for a few seconds.'),



          this.props.lifecycle === 'success' &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, 'The ',
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('b', null, this.props.templateData.name), ' template has been imported! As part of the template, the following things have been created.')),




        this.props.lifecycle === 'use' &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_LoadingIndicator__["a" /* default */], null),


        this.props.lifecycle === 'failure' &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__CreationError__["a" /* default */], {
            subtitle: 'Something went wrong while importing this template. You can try again later.',
            onRetry: this.props.onRetry })),




        this.props.lifecycle === 'success' &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'finish-template__cards' },
          this.renderCollectionCard(this.props.templateData),
          templateData.environment && this.renderEnvironmentCard(this.props.templateData),
          templateData.monitor && this.renderMonitorCard(this.props.templateData),
          templateData.mock && this.renderMockCard(this.props.templateData),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'separator' }, 'NEXT STEPS',

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'separator-line' })),

          this.renderCollectionNextSteps(),
          templateData.environment && this.renderEnvironmentNextSteps(),
          templateData.monitor && this.renderMonitorNextSteps(),
          templateData.mock && this.renderMockNextSteps())));




  }};

/***/ }),

/***/ 5048:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ActivityFeedModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_new_button_XFlowGettingStarted__ = __webpack_require__(5049);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_new_button_XFlowActivityList__ = __webpack_require__(5050);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_base_Tabs__ = __webpack_require__(103);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__external_navigation_ExternalNavigationService__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__constants_AppUrlConstants__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__components_base_Icons_CloseIcon__ = __webpack_require__(90);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__services_EditorService__ = __webpack_require__(66);












const TABS = {
  ACTIVITY_TAB: 'activity-feed',
  DOCS_TAB: 'docs-tab' };let



ActivityFeedModalContainer = class ActivityFeedModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      activeTab: TABS.ACTIVITY_TAB,
      activityList: [] };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleTabSelect = this.handleTabSelect.bind(this);
    this.handleNewActivity = this.handleNewActivity.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('openXFlowActivityFeed', this.handleOpen);
    pm.mediator.on('saveXFlowActivity', this.handleNewActivity);
  }

  componentWillUnmount() {
    pm.mediator.off('openXFlowActivityFeed', this.handleOpen);
    pm.mediator.off('saveXFlowActivity', this.handleNewActivity);
  }

  getCustomStyles() {
    return { 'width': '900px' };
  }

  handleClose() {
    this.setState({ isOpen: false });
    pm.mediator.trigger('modalOpened', {
      name: 'xFlowActivityModal',
      isOpen: false });

  }

  handleOpen() {
    let activityString = localStorage.getItem('xFlowActivity'),
    activityList = null;

    try {
      if (!_.isEmpty(activityString)) {
        activityList = JSON.parse(activityString);
      }

    }
    catch (e) {
      pm.logger.error('Error in parsing xFlowActivity', e);
    } finally

    {
      this.setState({
        isOpen: true,
        activityList,
        activeTab: _.isEmpty(activityList) ? TABS.DOCS_TAB : TABS.ACTIVITY_TAB });

      pm.mediator.trigger('modalOpened', {
        name: 'xFlowActivityModal',
        isOpen: true });

    }
  }

  handleTabSelect(value) {
    this.setState({ activeTab: value });
  }

  handleNewActivity(type, nextStepState) {
    let activityObj = {
      type,
      nextStepState,
      createdAt: Date.now() };


    let activityString = localStorage.getItem('xFlowActivity'),
    acitivityList = null;

    try {
      if (!_.isEmpty(activityString)) {
        acitivityList = JSON.parse(activityString);
      }

    }
    catch (e) {
      pm.logger.error('Error in parsing xFlowActivity', e);
    } finally

    {
      let updatedActivity;
      if (!activityString) {
        updatedActivity = [activityObj];
      } else
      {
        updatedActivity = JSON.parse(activityString);
        updatedActivity = _.size(updatedActivity) < 20 ?
        _.concat(activityObj, updatedActivity) :
        _.concat(activityObj, _.dropRight(updatedActivity));
      }

      localStorage.setItem('xFlowActivity', JSON.stringify(updatedActivity));
    }
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Modals__["a" /* Modal */], {
          className: 'user-welcome-modal',
          isOpen: this.state.isOpen,
          customStyles: this.getCustomStyles(),
          onRequestClose: this.handleClose },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__components_base_Icons_CloseIcon__["a" /* default */], { className: 'user-welcome-modal--dismiss-icon', onClick: this.handleClose }),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'user-welcome__left-section' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'section-title' }, 'Welcome to Postman!'),



            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'section-subtext intro-text' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'section-subtext__text' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Postman is a powerful API development environment. Postman helps you design, mock, test, document, and monitor APIs.'))),



            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'section-subtext' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'section-subtext__text links-label' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'USEFUL LINKS')),

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Buttons__["a" /* Button */], {
                    type: 'text',
                    className: 'help-link',
                    onClick: () => {
                      return __WEBPACK_IMPORTED_MODULE_9__services_EditorService__["a" /* default */].open('customview://releaseNotes').
                      then(() => {
                        this.handleClose();
                      });
                    } }, 'Release notes')),




              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Buttons__["a" /* Button */], {
                    type: 'text',
                    className: 'help-link',
                    onClick: () => {
                      Object(__WEBPACK_IMPORTED_MODULE_6__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_7__constants_AppUrlConstants__["w" /* DOCS_URL */]);
                    } }, 'Documentation')),




              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Buttons__["a" /* Button */], {
                    type: 'text',
                    className: 'help-link',
                    onClick: () => {
                      Object(__WEBPACK_IMPORTED_MODULE_6__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_7__constants_AppUrlConstants__["v" /* DOCS_SECURITY_URL */]);
                    } }, 'Security')),




              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Buttons__["a" /* Button */], {
                    type: 'text',
                    className: 'help-link',
                    onClick: () => {
                      Object(__WEBPACK_IMPORTED_MODULE_6__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_7__constants_AppUrlConstants__["_8" /* SUPPORT_URL */]);
                    } }, 'Support')),




              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Buttons__["a" /* Button */], {
                    type: 'text',
                    className: 'help-link',
                    onClick: () => {
                      Object(__WEBPACK_IMPORTED_MODULE_6__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_7__constants_AppUrlConstants__["_14" /* TWITTER_URL */]);
                    } }, '@postmanclient')))),








          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'user-welcome__right-section' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_Tabs__["b" /* Tabs */], {
                type: 'primary',
                defaultActive: TABS.DOCS_TAB,
                activeRef: this.state.activeTab,
                onChange: this.handleTabSelect },

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_Tabs__["a" /* Tab */], { refKey: TABS.DOCS_TAB }, 'Create something new'),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_Tabs__["a" /* Tab */], { refKey: TABS.ACTIVITY_TAB }, 'Continue where you left off')),


            this.state.activeTab === TABS.DOCS_TAB && __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_new_button_XFlowGettingStarted__["a" /* default */], null),


            this.state.activeTab === TABS.ACTIVITY_TAB &&

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_new_button_XFlowActivityList__["a" /* default */], {
              activityList: this.state.activityList,
              onClose: this.handleClose })))));







  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5049:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return XFlowGettingStarted; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__external_navigation_ExternalNavigationService__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__constants_AppUrlConstants__ = __webpack_require__(64);





let

XFlowGettingStarted = class XFlowGettingStarted extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  handleLink(link, action) {
    Object(__WEBPACK_IMPORTED_MODULE_3__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(link);
    __WEBPACK_IMPORTED_MODULE_2__modules_services_AnalyticsService__["a" /* default */].addEvent('onboarding', 'view_documentation_' + action, 'welcome_popup');
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'section__cards' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'section__card section__card--collections' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'section__card__illustration-container' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'section__card__illustration' })),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'section__card__text' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Organize your API requests into '),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                type: 'text',
                onClick: this.handleLink.bind(this, __WEBPACK_IMPORTED_MODULE_4__constants_AppUrlConstants__["r" /* COLLECTION_DOCS */], 'collections') }, 'Collections'), '.')),







        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'section__card section__card--sharing' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'section__card__illustration-container' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'section__card__illustration' })),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'section__card__text' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                type: 'text',
                onClick: this.handleLink.bind(this, __WEBPACK_IMPORTED_MODULE_4__constants_AppUrlConstants__["_7" /* SHARING_LINK */], 'sharing') }, 'Share your API requests'),



            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, ' with your entire team.'))),



        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'section__card section__card--docs' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'section__card__illustration-container' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'section__card__illustration' })),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'section__card__text' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                type: 'text',
                onClick: this.handleLink.bind(this, __WEBPACK_IMPORTED_MODULE_4__constants_AppUrlConstants__["x" /* DOCUMENTATION_LINK */], 'intro_documentation') }, 'Add detailed documentation'),



            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, ' to your APIs and '),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                type: 'text',
                onClick: this.handleLink.bind(this, __WEBPACK_IMPORTED_MODULE_4__constants_AppUrlConstants__["_2" /* PUBLISHING_DOCS */], 'public_documentation') }, 'publish'),



            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, ' them.'))),



        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'section__card section__card--monitors' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'section__card__illustration-container' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'section__card__illustration' })),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'section__card__text' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                type: 'text',
                onClick: this.handleLink.bind(this, __WEBPACK_IMPORTED_MODULE_4__constants_AppUrlConstants__["_12" /* TESTING_DOCS */], 'intro_scripts') }, 'Write tests'),



            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, ' for individual requests and '),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                type: 'text',
                onClick: this.handleLink.bind(this, __WEBPACK_IMPORTED_MODULE_4__constants_AppUrlConstants__["T" /* MONITORING_DOCS */], 'intro_monitors') }, 'monitor'),



            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, ' their performance.'))),



        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'section__card section__card--mocks' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'section__card__illustration-container' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'section__card__illustration' })),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'section__card__text' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                type: 'text',
                onClick: this.handleLink.bind(this, __WEBPACK_IMPORTED_MODULE_4__constants_AppUrlConstants__["S" /* MOCK_DOCS */], 'intro_mock') }, 'Mock your requests'),



            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, ' to simulate endpoints and view potential responses without spinning up a back end.')))));




  }};

/***/ }),

/***/ 5050:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return XFlowActivityList; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__postman_date_helper__ = __webpack_require__(535);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__postman_date_helper___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2__postman_date_helper__);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};

let


XFlowActivityList = class XFlowActivityList extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  getTypeText(type) {
    switch (type) {
      case 'mock':
        return 'Mock created';
      case 'monitor':
        return 'Monitor created';
      case 'documentation':
        return 'Documentation created';
      case 'template':
        return 'Template imported';}

  }

  handleNextSteps(activityState) {

    switch (activityState.type) {
      case 'mock':
        pm.mediator.trigger('openCreateNewMockModal', _extends({},
        activityState.nextStepState, {
          activeStep: 3 }));

        break;
      case 'monitor':
        pm.mediator.trigger('openCreateNewMonitorModal', _extends({},
        activityState.nextStepState, {
          activeStep: 3 }));

        break;
      case 'documentation':
        pm.mediator.trigger('openCreateNewDocumentationModal', _extends({},
        activityState.nextStepState, {
          activeStep: 3 }));

        break;
      case 'template':
        pm.mediator.trigger('showCustomizeTemplateContainer', null, activityState.nextStepState);
        break;}

    this.props.onClose();
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'activity-feed-list' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'timeline' },

          _.isEmpty(this.props.activityList) ?

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'There\u2019s nothing here. '),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                type: 'text',
                size: 'small',
                className: 'learn-more-link',
                onClick: () => {
                  pm.mediator.trigger('openCreateNewXModal');
                  this.props.onClose();
                } }, 'Get started with Postman')) :





          _.map(this.props.activityList, (activity, index) => {
            return (
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { key: index, className: 'activity-feed-list-item' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'activity-feed-list-item--header' },
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'activity-feed-list-item--name' }, _.truncate(_.get(activity, 'nextStepState.selectedOptions.name'), { length: 30 })),
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, ` ${this.getTypeText(activity.type)}`)),

                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'activity-feed-list-item--date' }, _.upperFirst(__WEBPACK_IMPORTED_MODULE_2__postman_date_helper___default.a.getFormattedDate(activity.createdAt)))),

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
                    type: 'primary',
                    size: 'small',
                    onClick: this.handleNextSteps.bind(this, activity) }, 'View Next Steps')));





          }))));




  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5051:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return WorkspaceJoinModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_workspaces_WorkspaceJoinModal__ = __webpack_require__(5052);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_model_event__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__services_WorkspaceSwitchService__ = __webpack_require__(659);







const defaultState = {
  isOpen: false,
  id: null };let


WorkspaceJoinModalContainer = class WorkspaceJoinModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = defaultState;

    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleJoinWorkspace = this.handleJoinWorkspace.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('joinWorkspace', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('joinWorkspace', this.handleOpen);
  }

  handleOpen(workspaceId) {
    this.setState({
      isOpen: true,
      id: workspaceId || Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('ActiveBrowseWorkspaceStore').id });

  }

  handleClose() {
    this.setState(defaultState);
  }

  handleJoinWorkspace() {
    let joinWorkspaceEvent = Object(__WEBPACK_IMPORTED_MODULE_3__modules_model_event__["a" /* createEvent */])('join', 'workspace', { model: 'workspace', workspace: { id: this.state.id } });

    return Object(__WEBPACK_IMPORTED_MODULE_2__modules_pipelines_user_action__["a" /* default */])(joinWorkspaceEvent).
    then(() => {
      __WEBPACK_IMPORTED_MODULE_5__services_WorkspaceSwitchService__["a" /* default */].switchWorkspace(this.state.id);
      this.handleClose();
    }).
    catch(e => {
      Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('WorkspaceLifecycleStore').resetLifecycle(this.state.id);
      this.handleClose();
    });
  }


  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_workspaces_WorkspaceJoinModal__["a" /* default */], {
        isOpen: this.state.isOpen,
        onRequestClose: this.handleClose,
        onJoinWorkSpace: this.handleJoinWorkspace }));


  }};

/***/ }),

/***/ 5052:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_Icons_CloseIcon__ = __webpack_require__(90);
var _class;




let


WorkspaceJoinModal = Object(__WEBPACK_IMPORTED_MODULE_3_mobx_react__["a" /* observer */])(_class = class WorkspaceJoinModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  render() {
    let isJoining = Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('WorkspaceLifecycleStore').isJoining(Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('ActiveBrowseWorkspaceStore').id);
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["a" /* Modal */], {
          className: 'workspace-join-modal',
          isOpen: this.props.isOpen,
          onRequestClose: this.props.onRequestClose },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Icons_CloseIcon__["a" /* default */], { onClick: this.props.onRequestClose, className: 'workspace-join-modal--dismiss-icon' }),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-join-modal__wrapper' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'modal-header-close-button', onClick: this.props.onRequestClose }),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-join-thumbnail__container' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-join-thumbnail' })),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-join-modal__content' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-join-modal__header' }, 'Only members of a workspace can perform this action'),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-join-modal__subtext' }, 'You need to be a member of this workspace to perfom this action. Joining a workspace allows you to view and collaboratively work on everything inside it.'),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-join-modal__action' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
                    type: 'primary',
                    onClick: this.props.onJoinWorkSpace,
                    disabled: isJoining },


                  isJoining ?
                  'Joining this workspace' :
                  'Join this workspace')))))));








  }}) || _class;


/* harmony default export */ __webpack_exports__["a"] = (WorkspaceJoinModal);

/***/ }),

/***/ 5053:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return WorkspaceJoinedModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_workspaces_WorkspaceJoinedModal__ = __webpack_require__(5054);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__services_WorkspaceViewModeService__ = __webpack_require__(980);




const defaultState = {
  isOpen: false,
  alwaysShow: false };let


WorkspaceJoinedModalContainer = class WorkspaceJoinedModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.state = defaultState;

    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleSwitchToBuilder = this.handleSwitchToBuilder.bind(this);
    this.handleModalSetting = this.handleModalSetting.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('onJoinWorkspace', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('onJoinWorkspace', this.handleOpen);
  }

  handleOpen() {
    this.setState({
      isOpen: true,
      alwaysShow: pm.settings.getSetting('showJoinedWorkspaceModal') });

  }

  handleClose() {
    this.setState(defaultState);
  }

  handleModalSetting(value) {
    this.setState({ alwaysShow: value }, () => {
      pm.settings.setSetting('showJoinedWorkspaceModal', value);
    });
  }

  handleSwitchToBuilder() {
    __WEBPACK_IMPORTED_MODULE_2__services_WorkspaceViewModeService__["a" /* default */].openBuildMode();

    this.handleClose();
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_workspaces_WorkspaceJoinedModal__["a" /* default */], {
        isOpen: this.state.isOpen,
        onRequestClose: this.handleClose,
        onSwitchToBuilder: this.handleSwitchToBuilder,
        onChangeModalSetting: this.handleModalSetting,
        alwaysShow: this.state.alwaysShow }));


  }};

/***/ }),

/***/ 5054:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__status_bar_TypeSwitcher__ = __webpack_require__(3666);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__constants_RequesterTabConstants__ = __webpack_require__(218);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_Icons_CloseIcon__ = __webpack_require__(90);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__base_XPaths_XPath__ = __webpack_require__(24);








let
WorkspaceJoinedModal = class WorkspaceJoinedModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_XPaths_XPath__["a" /* default */], { identifier: 'startBuildModal', isVisible: this.props.isOpen },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["a" /* Modal */], {
            className: 'workspace-join-modal',
            isOpen: this.props.isOpen,
            onRequestClose: this.props.onRequestClose },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Icons_CloseIcon__["a" /* default */], { onClick: this.props.onRequestClose, className: 'workspace-join-modal--dismiss-icon' }),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["b" /* ModalContent */], null,
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-join-modal__wrapper' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'modal-header-close-button', onClick: this.props.onRequestClose }),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-join-modal__content' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-join-modal__header' }, 'You\u2019re now part of this workspace'),


                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-join-modal__subtext' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'All the collections in this workspace are now available in your sidebar. Switch to "Build" view to start working on them. You can switch back to the current view using the'),
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
                      className:
                      `workspace-join-modal__type-switcher-toggle
                      plugin__workspace-view-switcher__wrapper
                      plugin__workspace-view-switcher` },


                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__status_bar_TypeSwitcher__["a" /* default */], {
                      disabled: true,
                      activeItem: __WEBPACK_IMPORTED_MODULE_5__constants_RequesterTabConstants__["b" /* WORKSPACE_BUILDER_VIEW */],
                      items: [
                      {
                        key: __WEBPACK_IMPORTED_MODULE_5__constants_RequesterTabConstants__["b" /* WORKSPACE_BUILDER_VIEW */],
                        label: 'Build',
                        position: 'left' },

                      {
                        key: __WEBPACK_IMPORTED_MODULE_5__constants_RequesterTabConstants__["a" /* WORKSPACE_BROWSER_VIEW */],
                        label: 'Browse',
                        position: 'right' }] })),




                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'toggle on the status bar.')),

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-join-modal__action' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_XPaths_XPath__["a" /* default */], { identifier: 'startBuild' },
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
                        type: 'primary',
                        onClick: this.props.onSwitchToBuilder }, 'Start Building'))),





                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'always-show-checkbox' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Inputs__["a" /* Checkbox */], {
                    checked: this.props.alwaysShow,
                    onChange: this.props.onChangeModalSetting }),

                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'checkbox-label', onClick: this.props.onChangeModalSetting.bind(this, !this.props.alwaysShow) }, 'Always show this window on joining a workspace'))))))));









  }};


/* harmony default export */ __webpack_exports__["a"] = (WorkspaceJoinedModal);

/***/ }),

/***/ 5055:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CreateNewWorkspaceModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_mobx__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__utils_util__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_workspaces_CreateNewWorkspaceModal__ = __webpack_require__(5056);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__components_new_button_DisabledOperationModal__ = __webpack_require__(3675);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__components_base_LoadingIndicator__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__modules_services_RolesService__ = __webpack_require__(3593);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__modules_services_UserInvitationService__ = __webpack_require__(3626);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__modules_controllers_UserController__ = __webpack_require__(39);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__modules_services_PermissionsService__ = __webpack_require__(3676);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _class;

















let


CreateNewWorkspaceModalContainer = Object(__WEBPACK_IMPORTED_MODULE_11_mobx_react__["a" /* observer */])(_class = class CreateNewWorkspaceModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      type: 'team',
      name: '',
      description: '',
      members: {},
      userEmails: [],
      loading: false,
      limitVisibility: false,
      invitationError: false,
      isTrialActivating: false,
      invalidEmails: [] };


    this.workspaceId = null;

    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleChange = this.handleChange.bind(this);
    this.handleMembersChange = this.handleMembersChange.bind(this);
    this.handleCreate = this.handleCreate.bind(this);
    this.handleCancel = this.handleCancel.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('openCreateNewWorkspaceModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('openCreateNewWorkspaceModal', this.handleOpen);
  }

  handleOpen() {
    !this.state.isOpen && this.setState({ isOpen: true }, () => {
      let teamId = _.get(Object(__WEBPACK_IMPORTED_MODULE_3__stores_get_store__["getStore"])('CurrentUserStore'), 'team.id'),
      shouldFetchRoles = teamId && this.state.type === 'team';

      shouldFetchRoles && this.fetchRoles();
      this.fetchPermissions();

      this.refs.modal && this.refs.modal.nameInput && this.refs.modal.nameInput.focus();
    });
  }

  async fetchRoles() {
    try {
      this.setState({ populatingRoles: true });

      let {
        rolesList,
        userCurrentRoles,
        teamCurrentRole,
        superRoles,
        defaultRoles } =
      await Object(__WEBPACK_IMPORTED_MODULE_12__modules_services_RolesService__["a" /* fetchEntityRoles */])('workspace'),
      isPrivateWorkspace = _.isEmpty(teamCurrentRole);

      this.setState({
        allRoles: rolesList,
        userCurrentRoles,
        teamCurrentRole,
        superRoles,
        defaultRoles,
        limitVisibility: isPrivateWorkspace,
        populatingRoles: false });

    }
    catch (e) {
      pm.logger.error(e);

      this.handleClose();
    }
  }

  async fetchPermissions() {
    let permissions = await Object(__WEBPACK_IMPORTED_MODULE_16__modules_services_PermissionsService__["a" /* fetchPermissions */])(['manageTeamInvites', 'sendUnapprovedInvites']);

    this.setState({ permissions });
  }

  handleClose() {
    this.workspaceId = null;
    if (this.state.isTrialActivating) {
      pm.mediator.trigger('openSetupTeamModal');
    }

    this.state.isOpen && this.setState({
      isOpen: false,
      name: '',
      type: 'team',
      description: '',
      members: {},
      userEmails: [],
      loading: false,
      limitVisibility: false,
      invitationError: false,
      isTrialActivating: false,
      defaultRoles: {},
      allRoles: {},
      userCurrentRoles: {},
      teamCurrentRole: {},
      populatingRoles: false,
      invalidEmails: [] });

  }

  handleMembersChange({ members, userCurrentRoles }) {
    this.setState({ members, userCurrentRoles });
  }

  handleChange(field, value) {
    this.setState({ [field]: value });
  }

  handleInviteFlowsError(errorState) {
    this.setState({
      loading: false,
      isTrialActivating: false });


    let trialStatus = _.get(errorState, 'activate_trial', 0),
    workspaceStatus = _.get(errorState, 'create_workspace', 0);

    if (!trialStatus) {
      pm.toasts.error('Something went wrong while activating the trial');
      return;
    }

    if (!workspaceStatus) {
      pm.toasts.error('Something went wrong while creating the workspace');
      return;
    }

    // If invites sending failed then invitation error modal will open
    // after the workspace has been created in the DB
    //
    // @handleOpen - reaction on workspace lifecycle method
    this.setState({ invitationError: true });
    __WEBPACK_IMPORTED_MODULE_15__modules_services_AnalyticsService__["a" /* default */].addEvent('app', 'invite_users_failed', 'create_ws', null, { workspaceId: this.state.id });
  }

  async getWorkspaceData() {
    this.workspaceId = __WEBPACK_IMPORTED_MODULE_4__utils_util__["a" /* default */].guid();

    let teamId = _.get(Object(__WEBPACK_IMPORTED_MODULE_3__stores_get_store__["getStore"])('CurrentUserStore'), 'team.id'),
    { roles } = await Object(__WEBPACK_IMPORTED_MODULE_12__modules_services_RolesService__["b" /* getRolesData */])(
    this.state.userCurrentRoles,
    !this.state.limitVisibility ? _.get(this.state.teamCurrentRole, teamId) : {},
    'workspace',
    this.workspaceId),

    sendRoles = this.state.type === 'team' && teamId;

    let workspace = _extends({
      id: this.workspaceId,
      name: this.state.name,
      type: this.state.type,
      description: this.state.description },


    sendRoles ? { roles } : {});


    return workspace;
  }

  // Will be called for Free user who wants to create
  // activate trial by creating a team workspace and invite users
  async activateTrialAndInviteUsers() {
    this.setState({ isTrialActivating: true });
    let workspace = await this.getWorkspaceData(),
    data = {
      workspace,
      emails: this.state.userEmails };


    Object(__WEBPACK_IMPORTED_MODULE_13__modules_services_UserInvitationService__["a" /* activateTrialAndInviteUsers */])(data, 'createWS', (err, response) => {
      if (err) {
        // Get this checked - This is the error when the API fails
        pm.toasts.error(_.get(err, 'message', 'Something went wrong while creating this workspace'));
        this.setState({
          loading: false,
          isTrialActivating: false });

      }

      // The error state contains the status of the steps
      // whichever succeeded and failed while activating the trial
      // and inviting users to the workspace
      let errorState = _.get(response, 'error.state', null);

      if (errorState) {
        return this.handleInviteFlowsError(errorState);
      }

      this.handleClose();
    });
    __WEBPACK_IMPORTED_MODULE_15__modules_services_AnalyticsService__["a" /* default */].addEvent('app', 'trial_invite_users', 'create_ws', null, { workspaceId: workspace.id });
  }

  // Will be called for Pro Users
  async createWorkspaceAndInviteUsers(teamId) {
    let workspace = await this.getWorkspaceData(),
    userEmails = this.state.userEmails;

    if (this.state.type === 'team') {
      let members = {};
      _.forOwn(this.state.members, (member, memberId) => {
        members[memberId] = { id: memberId };
      });
      workspace.members = { users: members };
    }

    if (this.state.limitVisibility && this.isLimitingVisibilityEnabled()) {
      workspace.visibility = {
        team: {
          [teamId]: {
            id: teamId,
            visible: false } } };



      __WEBPACK_IMPORTED_MODULE_15__modules_services_AnalyticsService__["a" /* default */].addEvent('app', 'limiting_visibility_enabled', 'create_ws', null, { workspaceId: workspace.id });
    }

    let workspaceAddEvent = {
      name: 'create',
      namespace: 'workspace',
      data: workspace };


    Object(__WEBPACK_IMPORTED_MODULE_10__modules_pipelines_user_action__["a" /* default */])(workspaceAddEvent).
    then(response => {
      if (!_.isEmpty(_.get(response, 'error'))) {
        this.setState({ loading: false });
        pm.logger.error('Error in creating workspace', response.error);
        return;
      }

      if (_.isEmpty(userEmails)) {
        this.setState({ loading: false });
        return this.handleClose();
      }

      let data = {
        workspaceId: workspace.id,
        emails: userEmails,
        teamId };


      __WEBPACK_IMPORTED_MODULE_15__modules_services_AnalyticsService__["a" /* default */].addEvent('app', 'invite_users', 'create_ws', null, { workspaceId: workspace.id });
      Object(__WEBPACK_IMPORTED_MODULE_13__modules_services_UserInvitationService__["c" /* inviteUsers */])(data, (err, response) => {
        this.setState({ loading: false });
        if (err) {
          pm.logger.error(err);

          __WEBPACK_IMPORTED_MODULE_15__modules_services_AnalyticsService__["a" /* default */].addEvent('app', 'invite_users_failed', 'create_ws', null, { workspaceId: workspace.id });
          pm.toasts.error(_.get(err, 'message', 'Something went wrong while inviting users'));
          return;
        }

        let refreshOrganizationEvent = {
          name: 'refreshOrganizations',
          namespace: 'user' };


        Object(__WEBPACK_IMPORTED_MODULE_10__modules_pipelines_user_action__["a" /* default */])(refreshOrganizationEvent).
        catch(e => {
          pm.logger.error('Error while refreshing organizations', e);
        });

        this.handleClose();
      });
    }).
    catch(err => {
      pm.toasts.error(_.get(err, 'error', 'Unable to share the workspace'));
      pm.logger.error('Error in pipeline while creating workspace', err);
    });
  }

  handleCreate() {
    this.setState({ loading: true });
    let teamId = null,
    user = Object(__WEBPACK_IMPORTED_MODULE_3__stores_get_store__["getStore"])('CurrentUserStore');

    // Invite flow for free user
    if (this.state.type === 'team' && __WEBPACK_IMPORTED_MODULE_4__utils_util__["a" /* default */].isFreeUser(user)) {
      return this.activateTrialAndInviteUsers();
    }

    if (this.state.type === 'team') {
      teamId = _.get(Object(__WEBPACK_IMPORTED_MODULE_3__stores_get_store__["getStore"])('CurrentUserStore'), 'organizations[0].id', null);
    }

    this.createWorkspaceAndInviteUsers(teamId);
  }

  handleCancel() {
    this.setState({ loading: false });
    this.handleClose();
  }

  // @todo: Move this to WorkspaceUI store
  isLimitingVisibilityEnabled() {
    let currentUsersTeam = Object(__WEBPACK_IMPORTED_MODULE_3__stores_get_store__["getStore"])('CurrentUserStore').team;
    if (!currentUsersTeam) {
      return false;
    }

    let plansKey = 'workspace.visibilityAvailablePlans',
    visibilityAvailablePlans = Object(__WEBPACK_IMPORTED_MODULE_3__stores_get_store__["getStore"])('ConfigurationStore').get(plansKey);

    return _.includes(visibilityAvailablePlans, currentUsersTeam.plan);
  }

  getCustomStyles() {
    return {
      maxHeight: '150vh',
      marginTop: '5vh',
      width: '680px' };

  }

  getTeamStats() {
    let existingStats = Object(__WEBPACK_IMPORTED_MODULE_3__stores_get_store__["getStore"])('TeamStore').teamStatsForInvites,
    invitesLeft = existingStats.invitesLeft - _.size(this.state.userEmails);

    // Safe check
    if (invitesLeft < 0) {
      invitesLeft = 0;
    }

    let updatedStats = _extends({}, existingStats, { invitesLeft });
    return updatedStats;
  }

  render() {
    let currentUser = Object(__WEBPACK_IMPORTED_MODULE_3__stores_get_store__["getStore"])('CurrentUserStore'),
    isLoggedIn = currentUser.isLoggedIn,
    isSyncEnabled = Object(__WEBPACK_IMPORTED_MODULE_3__stores_get_store__["getStore"])('GateKeeperStore').isSyncEnabled,
    isSocketConnected = Object(__WEBPACK_IMPORTED_MODULE_3__stores_get_store__["getStore"])('SyncStatusStore').isSocketConnected,
    disableButton = _.isEmpty(_.trim(this.state.name)) || _.isEmpty(this.state.type) ||
    this.state.loading || this.state.populatingRoles ||
    !isSocketConnected || !_.isEmpty(this.state.invalidEmails),
    canManageTeamInvites = _.get(this.state.permissions, 'manageTeamInvites'),
    canSendUnapprovedInvites = _.get(this.state.permissions, 'sendUnapprovedInvites'),
    canSendInvites = canManageTeamInvites || canSendUnapprovedInvites,
    buttonTooltipText = !_.isEmpty(this.state.invalidEmails) && 'You have added invalid emails, please remove them to continue.';

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_Modals__["a" /* Modal */], {
          className: 'create-new-workspace-modal',
          isOpen: this.state.isOpen,
          onRequestClose: this.handleClose,
          customStyles: this.getCustomStyles() },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_Modals__["d" /* ModalHeader */], null, 'CREATE NEW WORKSPACE'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_Modals__["b" /* ModalContent */], null,

          (!isLoggedIn || !isSyncEnabled) &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__components_new_button_DisabledOperationModal__["a" /* default */], {
            isLoggedIn: isLoggedIn,
            isSyncEnabled: isSyncEnabled,
            entity: 'workspace' }),



          isLoggedIn && isSyncEnabled &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-workspace-modal-content-wrapper' },
            !this.state.populatingRoles ?
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__components_workspaces_CreateNewWorkspaceModal__["a" /* default */], {
              ref: 'modal',
              type: this.state.type,
              name: this.state.name,
              description: this.state.description,
              members: this.state.members,
              onChange: this.handleChange,
              onAddMember: this.handleMembersChange,
              onRemoveMember: this.handleMembersChange,
              onCreate: this.handleCreate,
              teamStats: this.getTeamStats(),
              allowInvites: canSendInvites,
              limitVisibility: this.state.limitVisibility,
              isLimitingVisibilityEnabled: this.isLimitingVisibilityEnabled(),
              isTrialActivating: this.state.isTrialActivating,
              allRoles: this.state.allRoles,
              userCurrentRoles: this.state.userCurrentRoles,
              teamCurrentRole: this.state.teamCurrentRole,
              defaultRoles: this.state.defaultRoles,
              superRoles: this.state.superRoles,

              canSendUnapprovedInvites: canSendUnapprovedInvites,
              canManageTeamInvites: canManageTeamInvites }) :


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_9__components_base_LoadingIndicator__["a" /* default */], null))),





        isLoggedIn && isSyncEnabled &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_Modals__["c" /* ModalFooter */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_base_Buttons__["a" /* Button */], {
              className: 'button-large',
              type: 'primary',
              disabled: disableButton,
              onClick: this.handleCreate,
              tooltip: buttonTooltipText },


            this.state.loading ?
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_9__components_base_LoadingIndicator__["a" /* default */], {
              className: 'loading-indicator-size' }) :

            'Create Workspace'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_base_Buttons__["a" /* Button */], {
              type: 'text',
              onClick: this.handleCancel }, 'Cancel'))));







  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5056:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CreateNewWorkspaceModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Dropdowns__ = __webpack_require__(31);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_TextArea__ = __webpack_require__(962);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_InviteUsers__ = __webpack_require__(3624);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__utils_util__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__constants_AppUrlConstants__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__models_services_DashboardService__ = __webpack_require__(309);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__components_status_bar_TypeSwitcher__ = __webpack_require__(3666);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__WorkspaceVisibility__ = __webpack_require__(3774);
var _class;












let


CreateNewWorkspaceModal = Object(__WEBPACK_IMPORTED_MODULE_8_mobx_react__["a" /* observer */])(_class = class CreateNewWorkspaceModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isTooltipVisible: false,
      showInviteDeniedError: false };


    this.handleChange = this.handleChange.bind(this);
    this.handleActiveItem = this.handleActiveItem.bind(this);
    this.handleEmailError = this.handleEmailError.bind(this);

    this.showTooltip = this.showTooltip.bind(this);
    this.hideTooltip = this.hideTooltip.bind(this);
  }

  handleChange(field, value) {
    this.props.onChange && this.props.onChange(field, value);
  }

  handleActiveItem(value) {
    this.props.onChange && this.props.onChange('type', value);
    this.setState({ showInviteDeniedError: false });
  }

  getTeamSize() {
    let teamMembers = _.get(this.props, 'teamStats.teamSize', 0) - _.get(this.props, 'teamStats.invitesLeft', 0);
    return `${teamMembers}/${_.get(this.props, 'teamStats.teamSize', 0)}`;
  }

  showTooltip() {
    this.setState({ isTooltipVisible: true });
  }

  hideTooltip() {
    this.setState({ isTooltipVisible: false });
  }

  getSwitcherClasses(currentUser) {
    return __WEBPACK_IMPORTED_MODULE_1_classnames___default()({
      'plugin__workspace-view-switcher__wrapper': true,
      'plugin__workspace-view-switcher': true });

  }

  handleEmailError({ showInviteDeniedError }) {
    this.setState({ showInviteDeniedError });
  }

  getSubText(user) {
    if (this.props.isTrialActivating) {
      return '';
    }

    if (this.state.showInviteDeniedError) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-workspace__email-privileges-denied' }, 'You can only add team members to this workspace. To add other users, contact your team admin to add them to the team.'));




    } else
    if (!__WEBPACK_IMPORTED_MODULE_7__utils_util__["a" /* default */].isFreeUser(user)) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-workspace__team_info' }, 'Inviting users to this workspace will add them to your Postman team, if they\u2019re not already members.'));



    } else
    if (__WEBPACK_IMPORTED_MODULE_7__utils_util__["a" /* default */].isFreeUser(user)) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-workspace__team_info' }, 'People who are not in your team will be invited to join your team'));



    }
  }

  render() {
    let currentUser = Object(__WEBPACK_IMPORTED_MODULE_9__stores_get_store__["getStore"])('CurrentUserStore');

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-workspace-modal__contents' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-workspace__input-group' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-workspace__input-group__label' }, 'Name'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-workspace__input-group__input' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Inputs__["b" /* Input */], {
              inputStyle: 'box',
              value: this.props.name,
              onChange: this.handleChange.bind(this, 'name'),
              ref: input => this.nameInput = input,
              onSubmit: this.props.onCreate }))),




        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-workspace__input-group' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-workspace__input-group__label' }, 'Summary'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-workspace__input-group__input' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Inputs__["b" /* Input */], {
              inputStyle: 'box',
              value: this.props.description,
              onChange: this.handleChange.bind(this, 'description') }))),



        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-workspace__input-group' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-workspace__input-group__label' }, 'Type'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-workspace__input-group__input' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: this.getSwitcherClasses(currentUser) },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_12__components_status_bar_TypeSwitcher__["a" /* default */], {
                activeItem: this.props.type,
                onSelect: this.handleActiveItem,
                items: [
                {
                  key: 'team',
                  label: 'Team',
                  position: 'right' },

                {
                  key: 'personal',
                  label: 'Personal',
                  position: 'left' }] })))),







        this.props.type === 'team' &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-workspace__input-group' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-workspace__input-group__label' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-workspace__input-group__left-label' }, 'Invite people to join this workspace'),



            __WEBPACK_IMPORTED_MODULE_7__utils_util__["a" /* default */].isProUser(currentUser) &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-workspace__input-group__team-size' }, 'Team Size: ',
              this.getTeamSize(),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null,
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
                    className: 'create-new-workspace__input-group__add-slots',
                    type: 'text',
                    onClick: __WEBPACK_IMPORTED_MODULE_11__models_services_DashboardService__["r" /* openTeam */] }, 'Manage Team')))),







          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-workspace__input-group__input' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_InviteUsers__["a" /* default */], {
              allRoles: this.props.allRoles,
              defaultRoles: this.props.defaultRoles,
              userCurrentRoles: this.props.userCurrentRoles,
              teamCurrentRole: this.props.teamCurrentRole,
              superRoles: this.props.superRoles,
              teamStats: this.props.teamStats,
              allowInvites: this.props.allowInvites,
              handleEmailError: this.handleEmailError,
              onChange: this.handleChange,
              onAddMember: this.props.onAddMember,
              onRemoveMember: this.props.onRemoveMember,
              limitVisibility: this.props.limitVisibility,
              canManageTeamInvites: this.props.canManageTeamInvites })),


          this.getSubText(currentUser),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_13__WorkspaceVisibility__["a" /* default */], {
            allRoles: this.props.allRoles,
            teamCurrentRole: this.props.teamCurrentRole,
            hideTooltip: this.hideTooltip,
            isLimitingVisibilityEnabled: this.props.isLimitingVisibilityEnabled,
            isTooltipVisible: this.state.isTooltipVisible,
            limitVisibility: this.props.limitVisibility,
            onChange: this.handleChange,
            onVisibilityChange: this.handleChange.bind(this, 'limitVisibility'),
            showTooltip: this.showTooltip }))));





  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5057:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return RolesListItem; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Avatar__ = __webpack_require__(651);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Dropdowns__ = __webpack_require__(31);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Tooltips__ = __webpack_require__(80);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_Icons_CloseIcon__ = __webpack_require__(90);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_Icons_WarningIcon__ = __webpack_require__(657);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_7_classnames__);







let

RolesListItem = class RolesListItem extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = { isTooltipVisible: false };

    this.handleSelect = this.handleSelect.bind(this);
    this.handleRemove = this.handleRemove.bind(this);
    this.showTooltip = this.toggleTooltip.bind(this, true);
    this.hideTooltip = this.toggleTooltip.bind(this, false);
  }

  toggleTooltip(isTooltipVisible) {
    this.setState({ isTooltipVisible });
  }

  handleSelect(role) {
    this.props.onChange && this.props.onChange(this.props.member.id, 'user', role);
  }

  handleRemove() {
    this.props.onRemoveMember && this.props.onRemoveMember(this.props.member.id);
  }

  getClasses(canRemove) {
    return __WEBPACK_IMPORTED_MODULE_7_classnames___default()({
      'permissions-list-item--permissions': true,
      'permission-list-item--user': true,
      'can-remove': canRemove });

  }

  render() {
    const showRemoveIcon = this.props.canModifyMembers || _.get(this.props, 'member.canRemove');

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'permission-list-item' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Avatar__["a" /* default */], { size: 'medium', userId: this.props.member.id }),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'permission-list-item--name' }, this.props.member.name),

        this.props.warningText && !this.props.hideRoles &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
            className: 'permission-list-item--warning',
            ref: 'warning',
            onMouseEnter: this.showTooltip,
            onMouseLeave: this.hideTooltip },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Icons_WarningIcon__["a" /* default */], { className: 'permission-list-item--warning-icon' }),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Tooltips__["a" /* Tooltip */], {
              immediate: true,
              placement: 'bottom',
              target: this.refs.warning,
              show: this.state.isTooltipVisible },

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Tooltips__["b" /* TooltipBody */], null,
              this.props.warningText))),





        !this.props.hideRoles &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: this.getClasses(showRemoveIcon) },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Dropdowns__["a" /* Dropdown */], { onSelect: this.handleSelect },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Dropdowns__["b" /* DropdownButton */], {
                disabled: !this.props.canUpdateRoles,
                size: 'small',
                type: 'secondary' },

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Buttons__["a" /* Button */], null,
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'permissions-list-item--role' }, this.props.selectedRole))),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Dropdowns__["c" /* DropdownMenu */], { fluid: true },

              _.map(this.props.rolesList, role => {
                return (
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Dropdowns__["d" /* MenuItem */], { key: role.name, refKey: role.name },
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, role.displayName)));


              })))),






        showRemoveIcon &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Icons_CloseIcon__["a" /* default */], {
          className: 'permissions-list-item--delete',
          onClick: this.handleRemove })));




  }};



RolesListItem.defaultProps = {
  canUpdateRoles: true };
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5058:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_prop_types__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_prop_types___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_prop_types__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__postman_react_click_outside__ = __webpack_require__(216);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__postman_react_click_outside___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3__postman_react_click_outside__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_react_contenteditable__ = __webpack_require__(1627);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_react_contenteditable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_react_contenteditable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_EditableTag__ = __webpack_require__(1626);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_Dropdowns__ = __webpack_require__(31);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__base_Avatar__ = __webpack_require__(651);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};









const TAG_TYPE_REGULAR = 'regular',
TAG_TYPE_ERROR = 'error',
TAG_TYPE_EDITING = 'editing',
DELIMITERS = [' ', ';', ','],
DELIMITER_KEYS = [9, 13, 32, 186, 188],
KEY_CODES = {
  escape: 27,
  backSpace: 8,
  delete: 46,
  downArrow: 40,
  upArrow: 38,
  enter: 13 };


/**
                * Component displays custom tags. User can input new tags, remove or edit existing tags.
                * Data of tags is stored in parent. onTagsChange is called whenever tags are changed inside component.
                * Parent can customize content of Tag by passing renderTagContent as renderProp
                *
                */let
BulkInvite = class BulkInvite extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      activeInput: {
        value: '',
        index: 0,
        isLastNode: true },

      previousValue: '',
      containerFocused: true,
      selectedTag: null };


    this.handleActiveInputChange = this.handleActiveInputChange.bind(this);
    this.handleActiveInputClick = this.handleActiveInputClick.bind(this);
    this.handleKeyDown = this.handleKeyDown.bind(this);
    this.handleContainerClick = this.handleContainerClick.bind(this);
    this.focusActiveInput = this.focusActiveInput.bind(this);
    this.handlePaste = this.handlePaste.bind(this);
    this.handleClickOutside = this.handleClickOutside.bind(this);

    this.handleSuggestionSelect = this.handleSuggestionSelect.bind(this);
    this.handleDelimiter = this.handleDelimiter.bind(this);
    this.renderTagContent = this.renderTagContent.bind(this);
  }

  componentDidMount() {
    this.focusActiveInput();
  }

  componentDidUpdate(prevProps, prevState) {
    if (this.state.containerFocused && (prevState.activeInput.index !== this.state.activeInput.index || prevProps.tags.length !== this.props.tags.length)) {
      this.focusActiveInput();
    }
  }

  /**
     * Shifts focus back to Active Input.
     */
  focusActiveInput() {
    _.invoke(this.refs, 'contentEditable.htmlEl.focus');
  }

  getTagFromString(value) {
    return {
      value: value,
      type: this.props.tagValidator(value) ? TAG_TYPE_REGULAR : TAG_TYPE_ERROR };

  }

  /**
     * Called in render to show/hide placeholder
     */
  shouldRenderPlaceHolder() {
    // To display placeholder when the only email left in the list is being edited and input value is empty.
    if (this.props.tags.length === 1 && this.state.activeInput.index === 0 && !this.state.activeInput.value) {
      return true;
    }

    // Hide placeholder if user is typing or there are tags present in list.
    if (this.state.activeInput.value || this.props.tags.length) {
      return false;
    }

    return true;
  }

  /**
     * Checks if value passed in param already exists in the tags.
     *
     * @param {Object} [props = this.props.tags]
     * @param {string} value
     *
     * @returns {boolean} true if value already exist, false otherwise.
     */
  checkEmailExists(tags = this.props.tags, value) {
    for (let i = 0; i < tags.length; ++i) {
      // Check if the value already exists in tags and if it does, it's not being edited.
      // tags[i].type !== TAG_TYPE_EDITING is used to handle case of editing tags and escape.
      // Without this check, the tag will be deleted if user presses escape or doesn't make any changes while editing.
      if (tags[i].value === value && tags[i].type !== TAG_TYPE_EDITING) {
        return true;
      }
    }

    return false;
  }

  /**
     * This function splits the string if any one of the DELIMITERS [space, comma, semicolon] are found.
     *
     * @param {String} items
     * @returns {Array} Array with no duplicate values
     */
  splitInput(items) {
    let itemsArray = [],
    existingItems = {},
    containsDelimiter = false;

    for (let i = 0; i < DELIMITERS.length; ++i) {
      if (items.includes(DELIMITERS[i])) {
        items = items.split(DELIMITERS[i]);
        containsDelimiter = true;
        break;
      }
    }

    itemsArray = containsDelimiter ? items : [items];

    return itemsArray.filter(item => !existingItems.hasOwnProperty(item) && (existingItems[item] = true));
  }

  /**
     * Called when user pastes text in active input.
     * It adds new tags from pasted text by calling splitInput and appending the returned array to tags.
     *
     * @param {Object} event
     */
  handlePaste(event) {
    event.preventDefault();

    let pastedString = event.clipboardData.getData('Text'),
    { activeInput, previousValue } = this.state,
    { tags: existingTags } = this.props,
    existingTagsMap = existingTags.reduce((acc, tag) => {
      acc[tag.value] = true;
      return acc;
    }, {}),
    pastedEmails = this.splitInput(pastedString).
    filter(email => {
      // Should not add value to emails if it exists, has value same as active input or the previousValue.
      if (!email || existingTagsMap[email] || email === activeInput.value || email === previousValue) {
        return false;
      }

      return true;
    }).
    map(email => {
      return this.getTagFromString(email);
    }),
    newTags = [
    ...existingTags,
    ...pastedEmails];


    if (activeInput.isLastNode) {
      activeInput = _extends({},
      activeInput, {
        index: newTags.length });

    }

    this.setState({
      activeInput });


    this.props.onTagsChange(newTags);
  }


  handleClickOutside() {
    if (this.userSuggestionsRef) {
      return;
    }

    this.setState({ containerFocused: false });
    this.handleContainerClick();
  }

  /**
     * This function is called whenever user clicks inside this component and
     * is also triggered by click outside of the component, but without the event argument
     * It passes props to saveActiveBadge() and then updates parent state.
     *
     * @param {Object} event
     * @param {Object} [props=this.props]
     */
  handleContainerClick(event) {
    if (event) {
      if (!this.state.containerFocused) {
        this.setState({ containerFocused: true });
      }

      this.focusActiveInput();
    }

    let { activeInput, previousValue } = this.state,
    { tags } = this.props,
    tagsData = {
      tags,
      activeInput,
      previousValue };


    tagsData = this.saveActiveBadge(tagsData);

    this.setState({
      activeInput: tagsData.activeInput,
      previousValue: tagsData.previousValue });


    this.props.onTagsChange(tagsData.tags);
  }


  /**
     * Called when user click the remove button on email badge.
     *
     * @param {number} index
     */
  handleRemove(index, event) {
    event.stopPropagation();

    let tagsData = {
      tags: this.props.tags,
      activeInput: this.state.activeInput };


    tagsData = this.removeEmail(tagsData, index);

    this.setState({
      activeInput: tagsData.activeInput });


    this.props.onTagsChange(tagsData.tags);
  }


  /**
     * Called when user presses Backspace or Delete key
     *
     * @param {number} index
     */
  handleBackspaceAndDelete(index) {
    if (this.state.activeInput.value) {
      return;
    }

    if (this.state.selectedTag && this.state.activeInput.index) {
      let tagsData = {
        tags: this.props.tags,
        activeInput: this.state.activeInput };


      tagsData = this.removeEmail(tagsData, index - 1);

      this.setState({
        activeInput: tagsData.activeInput,
        selectedTag: null });


      this.props.onTagsChange(tagsData.tags);

      return;
    }

    if (this.state.activeInput.index) {
      this.setState({
        selectedTag: index });

    }
  }


  /**
     * Called when user presses Escape Key.
     * It reverts back the changes made by user in active input and displays the previous badge.
     *
     * @param {number} index
     */
  handleEscapeKey(index) {
    if (!this.state.previousValue) {
      return;
    }

    let { previousValue } = this.state,
    { tags } = this.props,
    newTags = [
    ...tags.slice(0, index),
    this.getTagFromString(previousValue),
    ...tags.slice(index + 1)],

    newActiveInput = {
      value: '',
      index: newTags.length,
      isLastNode: true };


    this.setState({
      activeInput: newActiveInput,
      previousValue: '' });


    this.props.onTagsChange(newTags);
  }

  /**
     * Adds the current active input value and saves it as a badge.
     * It takes object as argument and returns a new object with updated properties of the argument.
     * In some cases [ Email already exists, Active input value  is empty ],
     * it either removes that value from email list or just ignores the values and return obj without changes in email list.
     * It add a flag 'didRemove' to return obj to indicate if an email was removed by it or not.
     *
     * @param {Object} tagsData
     * @returns {Object}  Contains all the changes to be made in parent state to add new email badge
     */
  saveActiveBadge(tagsData) {
    let { tags, activeInput, previousValue } = tagsData;

    // This block is executed if active value is empty or email already exists.
    if (!activeInput.value || this.checkEmailExists(tags, activeInput.value)) {

      // This block will remove duplicate or empty active value because it is between emails, not at the end.
      if (!activeInput.isLastNode) {
        let newTags = [
        ...tags.slice(0, activeInput.index),
        ...tags.slice(activeInput.index + 1)],

        newActiveInput = {
          value: '',
          isLastNode: true,
          index: newTags.length };


        previousValue = '';

        return {
          tags: newTags,
          activeInput: newActiveInput,
          previousValue };

      }

      // If the duplicate or empty value is at the end, it just ignores it and resets the input value to empty.
      return _extends({},
      tagsData, {
        activeInput: _extends({},
        activeInput, {
          value: '' }),

        previousValue: '' });

    }

    // New email is added to the email list in both cases [ editing a badge, adding new badge ]
    let newTags = [
    ...tags.slice(0, activeInput.index),
    this.getTagFromString(activeInput.value),
    ...tags.slice(activeInput.index + 1)],

    newActiveInput = _extends({},
    activeInput, {
      value: '',
      index: newTags.length,
      isLastNode: true });


    return {
      tags: newTags,
      activeInput: newActiveInput,
      previousValue: '' };

  }

  /**
     * Changes the type of existing email to 'editing' and changes position of active input
     * Render function will place input field instead of badge.
     *
     * @param {Object} tagsData
     * @param {number} index
     *
     * @returns {Object}
     */
  editEmail(tagsData, index) {
    let { tags, activeInput } = tagsData,
    currentValue = tags[index].value,
    updatedActiveInput = _extends({},
    activeInput, {
      value: currentValue,
      index: index,
      isLastNode: tags.length - 1 === activeInput.index });


    tags[index].type = TAG_TYPE_EDITING;

    return {
      tags,
      activeInput: updatedActiveInput,
      previousValue: currentValue };

  }

  /**
     * Removes Email from saved emails
     * It also decrements the index of active input if the removed email was before the active input.
     *
     * @param {Object} tagsData
     * @param {number} index
     */
  removeEmail(tagsData, index) {
    let { activeInput, tags } = tagsData,
    newTags = [
    ...tags.slice(0, index),
    ...tags.slice(index + 1)],

    newActiveInput = _extends({},
    activeInput, {
      index: index < activeInput.index ? activeInput.index - 1 : activeInput.index });



    return {
      tags: newTags,
      activeInput: newActiveInput };

  }

  handleTagClick(index, event) {
    event.stopPropagation();

    if (event.detail === 2) {
      this.handleTagDoubleClick(index);

      return;
    }
  }

  /**
     * Called when user double clicks on an email badge.
     * It calls saveActiveBadge to save any existing value in active input,
     * then calls editEmail to convert the badge into edit field.
     *
     * @param {number} index
     */
  handleTagDoubleClick(index) {
    let tagsData = {
      tags: this.props.tags,
      activeInput: this.state.activeInput,
      previousValue: this.state.previousValue },

    initialTagLength = tagsData.tags.length;

    tagsData = this.saveActiveBadge(tagsData);

    if (tagsData.tags.length < initialTagLength && this.state.activeInput.index < index) {
      index--;
    }
    tagsData = this.editEmail(tagsData, index);

    this.setState({
      activeInput: tagsData.activeInput,
      previousValue: tagsData.previousValue });


    this.props.onTagsChange(tagsData.tags);
  }

  handleDelimiter() {
    if (!this.state.activeInput.isLastNode || this.state.activeInput.value) {
      let { activeInput, previousValue } = this.state,
      { tags } = this.props,
      tagsData = {
        tags,
        activeInput,
        previousValue };


      tagsData = this.saveActiveBadge(tagsData);

      this.setState({
        activeInput: tagsData.activeInput,
        previousValue: tagsData.previousValue });


      this.props.onTagsChange(tagsData.tags);
    }
  }

  /**
     * This function is called every time user presses a key while in active input.
     *
     * @param {Object} event
     * @param {number} index
     */
  handleKeyDown(event) {
    let keyCode = event && event.keyCode;

    if (this.userSuggestionsRef) {
      switch (keyCode) {
        case KEY_CODES.downArrow:
          _.invoke(this.userSuggestionsRef, 'focusNext');
          break;

        case KEY_CODES.upArrow:
          _.invoke(this.userSuggestionsRef, 'focusPrev');
          break;

        case KEY_CODES.enter:
          event.preventDefault();

          _.invoke(this.userSuggestionsRef, 'selectItem');

          break;}


      return;
    }

    // If Escape is pressed
    if (keyCode === KEY_CODES.escape) {
      this.handleEscapeKey(this.state.activeInput.index);
      return;
    }

    // If backspace or delete is pressed
    if (keyCode === KEY_CODES.backSpace || keyCode === KEY_CODES.delete) {
      this.handleBackspaceAndDelete(this.state.activeInput.index);
      return;
    }

    // If any of the delimiter keys is pressed, saveActiveBadge will be called to make new badge.
    if (DELIMITER_KEYS.includes(keyCode)) {
      event.preventDefault();

      this.handleDelimiter();
    }
  }

  /**
     * Called every time user changes value in active input.
     * This function updates the value of active input in parent state
     *
     * @param {Object} event
     */
  handleActiveInputChange(event) {
    let value = event.target.value,
    activeInput = _extends({},
    this.state.activeInput, {
      value }),

    suggestions = value ? _.filter(this.props.suggestions, suggestion => {
      let suggestionEmail = suggestion.email || '',
      suggestionName = suggestion.name || '';

      return _.includes(_.toLower(suggestionEmail), _.toLower(value)) || _.includes(_.toLower(suggestionName), _.toLower(value));
    }) : null;

    this.setState({ activeInput, suggestions, selectedTag: null });
  }

  handleActiveInputClick(event) {
    event.stopPropagation();
  }

  handleSuggestionSelect(value) {
    this.setState({
      activeInput: _extends({},
      this.state.activeInput, {
        value,
        isLastNode: true }) },

    this.handleDelimiter);
  }

  renderSuggestions(value) {
    if (!value || !this.props.inviteRef || _.isEmpty(this.state.suggestions)) {
      return null;
    }

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Dropdowns__["c" /* DropdownMenu */], {
          fluid: true,
          wrappedRef: connectedInstance => this.userSuggestionsRef = connectedInstance,
          targetRef: this.props.inviteRef,
          onSelect: this.handleSuggestionSelect },


        _.map(this.state.suggestions, suggestion => {
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Dropdowns__["d" /* MenuItem */], { className: 'user-suggestion', key: suggestion.email, refKey: suggestion.email },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_Avatar__["a" /* default */], { size: 'medium', userId: suggestion.id }),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'user-suggestion-details' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'user-suggestion__name' },
                  suggestion.name),

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'user-suggestion__email' },
                  suggestion.email))));




        })));



  }

  renderContentEditable(value, index) {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_0_react__["Fragment"], {
          key: index },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4_react_contenteditable___default.a, {
          ref: 'contentEditable',
          className: 'active-input',
          html: value,
          onChange: this.handleActiveInputChange,
          onClick: this.handleActiveInputClick,
          onKeyDown: this.handleKeyDown,
          onPaste: this.handlePaste }),

        !this.props.disableTeamSuggestions && this.renderSuggestions(value)));


  }

  renderTagContent(value, type) {
    return this.props.renderTagContent({ value, type });
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
          onClick: this.handleContainerClick,
          className: __WEBPACK_IMPORTED_MODULE_2_classnames___default()(
          this.props.className,
          { 'invite-component-focused': this.state.containerFocused },
          'invite-container') },



        this.shouldRenderPlaceHolder() &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'invite-placeholder soft-half' }, 'Enter an email address'),



        this.props.tags.map((tag, index) => {
          if (tag.type === TAG_TYPE_EDITING) {
            return this.renderContentEditable(this.state.activeInput.value, index);
          }

          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_EditableTag__["a" /* default */], {
              content: this.renderTagContent(tag.value, tag.type),
              isSelected: index === this.state.selectedTag - 1,
              key: index,
              name: 'tag',
              value: tag.value,
              type: tag.type,
              onClick: this.handleTagClick.bind(this, index),
              onClose: this.handleRemove.bind(this, index) }));


        }),


        this.state.activeInput.isLastNode &&
        this.renderContentEditable(this.state.activeInput.value)));



  }};


/**
       *
       */
function defaultTag(props) {
  return (
    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'tag-text' },
        props.value)));



}

BulkInvite.propTypes = {
  onTagsChange: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.func.isRequired,
  tags: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.array,
  tagValidator: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.func,
  renderTagContent: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.func };


BulkInvite.defaultProps = {
  tags: [],
  tagValidator: () => true,
  renderTagContent: defaultTag };


/* harmony default export */ __webpack_exports__["a"] = (__WEBPACK_IMPORTED_MODULE_3__postman_react_click_outside___default()(BulkInvite));
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5059:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["a"] = MailIcon;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__Icon__ = __webpack_require__(28);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};


const icon =
__WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('svg', { width: '16', height: '10', viewBox: '0 0 16 16' },
  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('defs', null,
    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('path', { id: 'mail', d: 'M14.72 3H1.28C.576 3 0 3.563  0 4.25v7.5C0 12.438.576 13 1.28 13h13.44c.704 0 1.28-.563 1.28-1.25v-7.5C16 3.562 15.424 3 14.72 3zm-7.169 7.592l-5.3-4.824a.333.333 0 0 1-.017-.476l.052-.055a.333.333 0 0 1 .466-.017l4.8 4.361a.667.667 0 0 0 .896 0l4.8-4.361a.333.333 0 0 1 .466.017l.052.055a.333.333 0 0 1-.017.476l-5.3 4.824a.667.667 0 0 1-.898 0z' })),

  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('use', { fill: '#282828', fillRule: 'evenodd', xlinkHref: '#mail' }));



function MailIcon(props) {
  return (
    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__Icon__["a" /* default */], _extends({},
    props, {
      icon: icon })));


}

/***/ }),

/***/ 5060:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["a"] = UploadIcon;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__Icon__ = __webpack_require__(28);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};


const icon =
__WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('svg', { width: '12', height: '12', viewBox: '0 0 12 12' },
  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('defs', null,
    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('path', { id: 'upload', d: 'M14.672 9.23201C14.16 9.23201 13.744 9.64801 13.744 10.16V12.8H2.24V10.16C2.24 9.64801 1.824 9.23201 1.312 9.23201C0.800001 9.23201 0.384003 9.64801 0.384003 10.16V13.712C0.384003 14.224 0.800001 14.64 1.312 14.64H14.672C15.184 14.64 15.6 14.224 15.6 13.712V10.16C15.6 9.64801 15.184 9.23201 14.672 9.23201Z', fill: '#A9A9A9' }),
    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('path', { id: 'upload1', d: 'M5.90401 5.696L7.072 4.528V10.384C7.072 10.896 7.488 11.312 8 11.312C8.512 11.312 8.928 10.896 8.928 10.384V4.496L10.128 5.696C10.496 6.064 11.072 6.064 11.44 5.696C11.808 5.328 11.808 4.752 11.44 4.384L8.688 1.632C8.512 1.456 8.272 1.36 8.032 1.36C7.792 1.36 7.552 1.456 7.376 1.632L4.62401 4.384C4.25601 4.752 4.25601 5.328 4.62401 5.696C4.96001 6.064 5.53601 6.064 5.90401 5.696Z', fill: '#A9A9A9' })),

  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('use', { fill: '#282828', fillRule: 'evenodd', transform: 'translate(-2 -2)', xlinkHref: '#upload' }),
  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('use', { fill: '#282828', fillRule: 'evenodd', transform: 'translate(-2 -2)', xlinkHref: '#upload1' }));



function UploadIcon(props) {
  return (
    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__Icon__["a" /* default */], _extends({},
    props, {
      icon: icon })));


}

/***/ }),

/***/ 5061:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__ = __webpack_require__(31);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Icons_TeamIcon__ = __webpack_require__(1491);





const TeamRoleItem = props => {
  const teamRole = _.get(props.selectedRole, `${props.teamId}.name`),
  teamRoleName = _.get(props.rolesList, `${teamRole}.displayName`, '');

  return (
    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-visibility-team' },
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Icons_TeamIcon__["a" /* default */], {
        size: 'xs' }),

      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'workspace-visibility-team--name' }, 'Everyone in your team can view and join this workspace as'),
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-visibility-team--roles' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["a" /* Dropdown */], { onSelect: props.onChange },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["b" /* DropdownButton */], {
              disabled: !props.canUpdateRoles,
              size: 'small' },

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], null,
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'workspace-visibility-team--role' }, teamRoleName))),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["c" /* DropdownMenu */], { fluid: true },

            _.map(props.rolesList, role => {
              return (
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], { key: role.name, refKey: role.name },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, role.displayName)));


            }))))));






};

/* harmony default export */ __webpack_exports__["a"] = (TeamRoleItem);
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5062:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return EditWorkspaceModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__modules_controllers_WorkspaceController__ = __webpack_require__(56);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__modules_controllers_UserController__ = __webpack_require__(39);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_base_LoadingIndicator__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__components_workspaces_EditWorkspaceModal__ = __webpack_require__(5063);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__utils_util__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__modules_services_PermissionsService__ = __webpack_require__(3676);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__modules_services_UserInvitationService__ = __webpack_require__(3626);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__modules_sync_helpers_create_workspace_members_diff__ = __webpack_require__(4024);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__modules_services_RolesService__ = __webpack_require__(3593);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15_mobx_react__ = __webpack_require__(11);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _class;


















let


EditWorkspaceModalContainer = Object(__WEBPACK_IMPORTED_MODULE_15_mobx_react__["a" /* observer */])(_class = class EditWorkspaceModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      id: '',
      type: '',
      name: '',
      description: '',
      members: {},
      oldMembers: {},
      userEmails: [],
      loading: false,
      limitVisibility: false,
      permissions: {},
      invalidEmails: [] };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleChange = this.handleChange.bind(this);
    this.handleMembersChange = this.handleMembersChange.bind(this);
    this.handleEdit = this.handleEdit.bind(this);
    this.handleCancel = this.handleCancel.bind(this);

    this.currentUserStore = Object(__WEBPACK_IMPORTED_MODULE_9__stores_get_store__["getStore"])('CurrentUserStore');
  }

  componentWillMount() {
    pm.mediator.on('openEditWorkspaceModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('openEditWorkspaceModal', this.handleOpen);
  }

  fetchUsers(userIds, cb) {
    let users = {};
    __WEBPACK_IMPORTED_MODULE_2__modules_controllers_UserController__["a" /* default */].
    get().
    then(currentUser => {
      _.forEach(userIds, u => {
        let user = __WEBPACK_IMPORTED_MODULE_8__utils_util__["a" /* default */].findUserInTeam({ id: u.id }, currentUser);
        if (!user) {
          return;
        }

        users[u.id] = user;
        return;
      });
      return cb(users);
    }).
    catch(err => {
      pm.logger.error(err);
      cb(users);
    });
  }

  checkVisibility(workspaceVisibility) {
    // bail out
    if (_.isEmpty(workspaceVisibility)) {
      return false;
    }

    let organizations = Object(__WEBPACK_IMPORTED_MODULE_9__stores_get_store__["getStore"])('CurrentUserStore').organizations;

    if (!organizations || !organizations[0]) {
      return false;
    }

    let teamId = organizations[0].id;

    if (workspaceVisibility.team && !workspaceVisibility.team[teamId].visible) {
      return true;
    }

    return false;
  }

  async handleOpen(workspaceId, emails) {
    let workspace = await __WEBPACK_IMPORTED_MODULE_1__modules_controllers_WorkspaceController__["a" /* default */].get({ id: workspaceId }),
    teamId = _.get(Object(__WEBPACK_IMPORTED_MODULE_9__stores_get_store__["getStore"])('CurrentUserStore'), 'team.id'),

    // Don't fetch roles if team does not exist or workspace type is personal
    shouldFetchRoles = !(!teamId || workspace.type === 'personal');

    this.fetchUsers(_.get(workspace, 'members.users'), users => {

      !this.state.isOpen && this.setState({
        isOpen: true,
        id: workspace.id,
        name: workspace.name,
        description: workspace.description || '',
        members: users,
        oldMembers: users,
        type: workspace.type,
        userEmails: emails || [],
        populatingRoles: shouldFetchRoles });

    });

    shouldFetchRoles && this.fetchRoles(workspaceId);
    this.fetchPermissions(workspaceId);
  }

  /**
     * Fetches permissions for Edit meta, update roles
     * add member to workspace, remove member to workspace
     */
  async fetchPermissions(workspaceId) {
    let permissions = await Object(__WEBPACK_IMPORTED_MODULE_10__modules_services_PermissionsService__["a" /* fetchPermissions */])(
    ['updateWorkspaceMeta', 'updateWorkspaceRoles', 'addMemberToWorkspace',
    'removeMemberFromWorkspace', 'manageTeamInvites', 'sendUnapprovedInvites'],
    workspaceId);


    this.setState({ permissions });
  }

  /**
     * Refer WorkspaceRoles.md for the terminology and structure
     * If Sync does not send a team role i.e teamCurrentRoles is empty
     * the workspace is assumed to be **Private**
     */
  async fetchRoles(workspaceId) {
    try {
      let {
        rolesList,
        userCurrentRoles,
        teamCurrentRole,
        superRoles,
        defaultRoles } =
      await Object(__WEBPACK_IMPORTED_MODULE_13__modules_services_RolesService__["a" /* fetchEntityRoles */])('workspace', workspaceId),
      isPrivateWorkspace = _.isEmpty(teamCurrentRole);

      this.setState({
        allRoles: rolesList,
        userCurrentRoles,
        teamCurrentRole,
        superRoles,
        defaultRoles,
        limitVisibility: isPrivateWorkspace,
        populatingRoles: false });

    }
    catch (e) {
      pm.logger.error(e);

      this.handleClose();
    }
  }

  getTeamStats() {
    let existingStats = Object(__WEBPACK_IMPORTED_MODULE_9__stores_get_store__["getStore"])('TeamStore').teamStatsForInvites,
    invitesLeft = existingStats.invitesLeft - _.size(this.state.userEmails);

    // safe check
    if (invitesLeft < 0) {
      invitesLeft = 0;
    }

    let updatedStats = _extends({}, existingStats, { invitesLeft });
    return updatedStats;
  }

  handleClose() {
    this.state.isOpen && this.setState({
      isOpen: false,
      id: '',
      type: '',
      name: '',
      description: '',
      members: {},
      oldMembers: {},
      userEmails: [],
      loading: false,
      limitVisibility: false,
      userCurrentRoles: {},
      allRoles: {},
      teamCurrentRole: {},
      defaultRoles: {},
      permissions: {},
      populatingRoles: false,
      invalidEmails: [] });

  }

  handleMembersChange({ members, userCurrentRoles }) {
    this.setState({ members, userCurrentRoles });
  }

  handleChange(field, value) {
    this.setState({ [field]: value });
  }

  /**
     * If limit visibility is disabled, assign a default team role to the team
     */
  handleVisibilityChange(value) {
    let teamCurrentRole = {};

    if (!value) {
      teamCurrentRole = Object(__WEBPACK_IMPORTED_MODULE_13__modules_services_RolesService__["c" /* getTeamDefaultRole */])(this.state.defaultRoles);
    }

    this.setState({
      limitVisibility: value,
      teamCurrentRole });

  }

  updateWorkspaceAndInviteUsers(workspace) {
    if (this.isLimitingVisibilityEnabled() && this.state.type === 'team') {
      let teamId = _.get(Object(__WEBPACK_IMPORTED_MODULE_9__stores_get_store__["getStore"])('CurrentUserStore'), 'organizations[0].id', null);
      workspace.visibility = {
        team: {
          [teamId]: {
            id: teamId,
            visible: !this.state.limitVisibility } } };




      let visibilityAction = 'limiting_visibility_enabled';
      if (!this.state.limitVisibility) {
        visibilityAction = 'limiting_visibility_disabled';
      }
      __WEBPACK_IMPORTED_MODULE_14__modules_services_AnalyticsService__["a" /* default */].addEvent('app', visibilityAction, 'edit_ws', null, { workspaceId: this.state.id });
    }

    let workspaceEditEvent = {
      name: 'update',
      namespace: 'workspace',
      data: workspace };


    Object(__WEBPACK_IMPORTED_MODULE_7__modules_pipelines_user_action__["a" /* default */])(workspaceEditEvent).
    then(response => {
      if (!_.isEmpty(_.get(response, 'error'))) {
        console.warn('Error in updating workspace', response.error);
        this.handleClose();
        return;
      }

      __WEBPACK_IMPORTED_MODULE_14__modules_services_AnalyticsService__["a" /* default */].addEvent('app', 'update_ws_info', 'edit_ws', null, { workspaceId: this.state.id });
      if (_.isEmpty(this.state.userEmails)) {
        this.handleClose();
        return;
      }

      let teamId = _.get(Object(__WEBPACK_IMPORTED_MODULE_9__stores_get_store__["getStore"])('CurrentUserStore'), 'organizations[0].id', null),
      data = {
        workspaceId: this.state.id,
        emails: this.state.userEmails,
        teamId };


      __WEBPACK_IMPORTED_MODULE_14__modules_services_AnalyticsService__["a" /* default */].addEvent('app', 'invite_users', 'edit_ws', null, { workspaceId: this.state.id });
      Object(__WEBPACK_IMPORTED_MODULE_11__modules_services_UserInvitationService__["c" /* inviteUsers */])(data, err => {
        this.setState({ loading: false });
        if (err) {
          pm.logger.error(err);

          __WEBPACK_IMPORTED_MODULE_14__modules_services_AnalyticsService__["a" /* default */].addEvent('app', 'invite_users_failed', 'edit_ws', null, { workspaceId: this.state.id });
          pm.toasts.error(_.get(err, 'message', 'Something went wrong while inviting users'));
          this.handleClose();
          return;
        }

        let refreshOrganizationEvent = {
          name: 'refreshOrganizations',
          namespace: 'user' };


        Object(__WEBPACK_IMPORTED_MODULE_7__modules_pipelines_user_action__["a" /* default */])(refreshOrganizationEvent).
        catch(e => {
          pm.logger.error('Error while refreshing organizations', e);
        });
        this.handleClose();
      });
    }).
    catch(err => {
      pm.toasts.error(_.get(err, 'message', 'Unable to edit the workspace'));
      this.handleClose();
      console.warn('Error in pipeline while updating the workspace', err);
    });
  }

  async handleEdit() {
    this.setState({ loading: true });

    let workspace = {
      id: this.state.id };


    // Only if the user has a permission to edit meta
    if (_.get(this.state.permissions, 'updateWorkspaceMeta', true)) {
      workspace.name = this.state.name;
      workspace.description = this.state.description;
    }

    // Send roles only if its a team workspace and the user has permission to update roles
    if (_.get(this.state.permissions, 'updateWorkspaceRoles') && this.state.type === 'team') {
      let teamId = _.get(Object(__WEBPACK_IMPORTED_MODULE_9__stores_get_store__["getStore"])('CurrentUserStore'), 'team.id'),
      { roles } = await Object(__WEBPACK_IMPORTED_MODULE_13__modules_services_RolesService__["b" /* getRolesData */])(
      this.state.userCurrentRoles,
      !this.state.limitVisibility ? _.get(this.state.teamCurrentRole, teamId) : {},
      'workspace',
      this.state.id);


      workspace.roles = roles;
    }

    let { diff, users } = Object(__WEBPACK_IMPORTED_MODULE_12__modules_sync_helpers_create_workspace_members_diff__["b" /* calculateDiff */])(this.state.oldMembers, this.state.members);

    if (diff) {
      Object(__WEBPACK_IMPORTED_MODULE_12__modules_sync_helpers_create_workspace_members_diff__["a" /* addMembersAsDiff */])(workspace, users.add);
      Object(__WEBPACK_IMPORTED_MODULE_12__modules_sync_helpers_create_workspace_members_diff__["c" /* removeMembersAsDiff */])(workspace, users.remove);
    }

    this.updateWorkspaceAndInviteUsers(workspace);
  }

  handleCancel() {
    this.handleClose();
  }

  // @todo: Move this to WorkspaceUI store
  isLimitingVisibilityEnabled() {
    let currentUsersTeam = Object(__WEBPACK_IMPORTED_MODULE_9__stores_get_store__["getStore"])('CurrentUserStore').team;
    if (!currentUsersTeam) {
      return false;
    }

    let plansKey = 'workspace.visibilityAvailablePlans',
    visibilityAvailablePlans = Object(__WEBPACK_IMPORTED_MODULE_9__stores_get_store__["getStore"])('ConfigurationStore').get(plansKey);

    return _.includes(visibilityAvailablePlans, currentUsersTeam.plan);
  }

  getCustomStyles() {
    return {
      maxHeight: '90vh',
      marginTop: '5vh',
      width: '680px' };

  }

  render() {
    let isSocketConnected = Object(__WEBPACK_IMPORTED_MODULE_9__stores_get_store__["getStore"])('SyncStatusStore').isSocketConnected,
    canUpdateRoles = _.get(this.state.permissions, 'updateWorkspaceRoles', true),
    canEditMeta = _.get(this.state.permissions, 'updateWorkspaceMeta', true),
    canAddMember = _.get(this.state.permissions, 'addMemberToWorkspace', true),
    canRemoveMember = _.get(this.state.permissions, 'removeMemberFromWorkspace', true),
    canManageTeamInvites = _.get(this.state.permissions, 'manageTeamInvites'),
    canSendUnapprovedInvites = _.get(this.state.permissions, 'sendUnapprovedInvites'),
    canSendInvites = canManageTeamInvites || canSendUnapprovedInvites,
    disableButton = _.isEmpty(this.state.name) || this.state.loading ||
    this.state.populatingRoles || !isSocketConnected || !_.isEmpty(this.state.invalidEmails),
    buttonTooltipText = !_.isEmpty(this.state.invalidEmails) && 'You have added invalid emails, please remove them to continue.';

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Modals__["a" /* Modal */], {
          className: 'edit-workspace-modal',
          isOpen: this.state.isOpen,
          onRequestClose: this.handleClose,
          customStyles: this.getCustomStyles() },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Modals__["d" /* ModalHeader */], null, 'EDIT WORKSPACE'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'edit-workspace-modal-content-wrapper' },
            !this.state.populatingRoles ?
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_workspaces_EditWorkspaceModal__["a" /* default */], {
              name: this.state.name,
              description: this.state.description,
              onChange: this.handleChange,
              onVisibilityChange: this.handleVisibilityChange.bind(this),
              onAddMember: this.handleMembersChange,
              onRemoveMember: this.handleMembersChange,
              type: this.state.type,
              allRoles: this.state.allRoles,
              defaultRoles: this.state.defaultRoles,
              userCurrentRoles: this.state.userCurrentRoles,
              teamCurrentRole: this.state.teamCurrentRole,
              superRoles: this.state.superRoles,
              users: this.state.members,
              userEmails: this.state.userEmails,
              teamStats: this.getTeamStats(),
              allowInvites: canSendInvites,
              limitVisibility: this.state.limitVisibility,
              isLimitingVisibilityEnabled: canUpdateRoles && this.isLimitingVisibilityEnabled(),

              canUpdateRoles: canUpdateRoles,
              canEditMeta: canEditMeta,
              canAddMember: canAddMember,
              canRemoveMember: canRemoveMember,
              canManageTeamInvites: canManageTeamInvites,
              canSendUnapprovedInvites: canSendUnapprovedInvites }) :


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_LoadingIndicator__["a" /* default */], null))),



        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Modals__["c" /* ModalFooter */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_Buttons__["a" /* Button */], {
              className: 'button-small',
              type: 'primary',
              disabled: disableButton,
              onClick: this.handleEdit,
              tooltip: buttonTooltipText },


            this.state.loading &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_LoadingIndicator__["a" /* default */], null) ||
            'Save Changes'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_Buttons__["a" /* Button */], {
              type: 'text',
              onClick: this.handleCancel }, 'Cancel'))));






  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5063:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return EditWorkspaceModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_TextArea__ = __webpack_require__(962);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_InviteUsers__ = __webpack_require__(3624);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__models_services_DashboardService__ = __webpack_require__(309);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__utils_util__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__WorkspaceVisibility__ = __webpack_require__(3774);












const isDeleteActionEnabled = user => {
  return user.id != Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('CurrentUserStore').id;
};let

EditWorkspaceModal = class EditWorkspaceModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isTooltipVisible: false,
      showInviteDeniedError: false };

    this.handleChange = this.handleChange.bind(this);
    this.showTooltip = this.showTooltip.bind(this);
    this.hideTooltip = this.hideTooltip.bind(this);
    this.handleEmailError = this.handleEmailError.bind(this);
  }

  handleChange(field, value) {
    this.props.onChange && this.props.onChange(field, value);
  }

  handleEmailError({ showInviteDeniedError }) {
    this.setState({ showInviteDeniedError });
  }

  getTeamSize() {
    let teamMembers = _.get(this.props, 'teamStats.teamSize', 0) - _.get(this.props, 'teamStats.invitesLeft', 0);
    return `${teamMembers}/${_.get(this.props, 'teamStats.teamSize', 0)}`;
  }

  getSubText() {
    if (this.state.showInviteDeniedError) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'edit-workspace__email-privileges-denied' }, 'You can only add team members to this workspace. To add other users, contact your team admin to add them to the team.'));




    }

    if (!__WEBPACK_IMPORTED_MODULE_8__utils_util__["a" /* default */].isFreeUser(Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('CurrentUserStore'))) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'edit-workspace__team_info' }, 'Inviting users to this workspace will add them to your Postman team, if they\u2019re not already members.'));



    }
  }

  showTooltip() {
    this.setState({ isTooltipVisible: true });
  }

  hideTooltip() {
    this.setState({ isTooltipVisible: false });
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'edit-workspace-modal__contents' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'edit-workspace__input-group' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'edit-workspace__input-group__label' }, 'Name'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'edit-workspace__input-group__input' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Inputs__["b" /* Input */], {
              disabled: !this.props.canEditMeta,
              inputStyle: 'box',
              value: this.props.name,
              onChange: this.handleChange.bind(this, 'name') }))),




        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'edit-workspace__input-group' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'edit-workspace__input-group__label' }, 'Summary'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'edit-workspace__input-group__input' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Inputs__["b" /* Input */], {
              disabled: !this.props.canEditMeta,
              inputStyle: 'box',
              value: this.props.description,
              onChange: this.handleChange.bind(this, 'description') })),




          this.props.type === 'team' &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'edit-workspace__input-group' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'edit-workspace__input-group__label' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'edit-workspace__input-group__left-label' }, 'Add members to this workspace'),



              __WEBPACK_IMPORTED_MODULE_8__utils_util__["a" /* default */].isProUser(Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('CurrentUserStore')) &&
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'edit-workspace__input-group__team-size' }, 'Team Size: ',
                this.getTeamSize(),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null,
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Buttons__["a" /* Button */], {
                      className: 'edit-workspace__input-group__add-slots',
                      type: 'text',
                      onClick: __WEBPACK_IMPORTED_MODULE_7__models_services_DashboardService__["r" /* openTeam */] }, 'Manage Team')))),







            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'edit-workspace__input-group__input' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_InviteUsers__["a" /* default */], {
                allRoles: this.props.allRoles,
                defaultRoles: this.props.defaultRoles,
                superRoles: this.props.superRoles,
                userCurrentRoles: this.props.userCurrentRoles,
                teamCurrentRole: this.props.teamCurrentRole,
                canAddMember: this.props.canAddMember,
                canRemoveMember: this.props.canRemoveMember,
                canUpdateRoles: this.props.canUpdateRoles,
                users: this.props.users,
                userEmails: this.props.userEmails,
                teamStats: this.props.teamStats,
                allowInvites: this.props.allowInvites,
                onChange: this.handleChange,
                onAddMember: this.props.onAddMember,
                onRemoveMember: this.props.onRemoveMember,
                handleEmailError: this.handleEmailError,
                limitVisibility: this.props.limitVisibility,
                isDeleteActionEnabled: isDeleteActionEnabled,
                canManageTeamInvites: this.props.canManageTeamInvites })),


            this.getSubText(),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_9__WorkspaceVisibility__["a" /* default */], {
              allRoles: this.props.allRoles,
              teamCurrentRole: this.props.teamCurrentRole,
              canUpdateRoles: this.props.canUpdateRoles,
              hideTooltip: this.hideTooltip,
              isLimitingVisibilityEnabled: this.props.isLimitingVisibilityEnabled,
              isTooltipVisible: this.state.isTooltipVisible,
              limitVisibility: this.props.limitVisibility,
              onChange: this.handleChange,
              onVisibilityChange: this.props.onVisibilityChange,
              showTooltip: this.showTooltip })))));






  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5064:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddToWorkspaceModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_empty_states_InviteUsersEmpty__ = __webpack_require__(4025);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_workspaces_AddToWorkspaceModal__ = __webpack_require__(5065);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__modules_services_share_entities_ShareEntitiesService__ = __webpack_require__(3594);
var _class;










const initialState = {
  modelId: '',
  modelType: '',
  isOpen: false,
  selectedWorkspace: {},
  teamPermissions: 'read',
  workspaces: [] },

entityStore = {
  collection: Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('CollectionStore'),
  environment: Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('EnvironmentStore') };let



AddToWorkspaceModalContainer = Object(__WEBPACK_IMPORTED_MODULE_1_mobx_react__["a" /* observer */])(_class = class AddToWorkspaceModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = initialState;

    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleChange = this.handleChange.bind(this);
    this.handleAdd = this.handleAdd.bind(this);
    this.handleCancel = this.handleCancel.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('openAddToWorkspaceModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('openAddToWorkspaceModal', this.handleOpen);
  }

  handleOpen(modelId, modelType, options = {}) {
    let workspaces = _.reject(_.concat(Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('WorkspaceStore').personalWorkspaces, Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('WorkspaceStore').teamWorkspaces), ['id', Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('ActiveWorkspaceStore').id]);
    this.setState({
      isOpen: true,
      modelId,
      modelType,
      origin: options.origin,
      selectedWorkspace: _.first(workspaces) && _.first(workspaces).id,
      workspaces });


    let eventLabel = options.origin;
    eventLabel === 'builder' && (eventLabel = 'modal');
    __WEBPACK_IMPORTED_MODULE_5__modules_services_AnalyticsService__["a" /* default */].addEvent(modelType, 'initiate_share', eventLabel);
  }

  handleClose() {
    this.state.isOpen && this.setState(initialState);
  }

  handleChange(field, value) {
    this.setState({ [field]: value });
  }

  share(model) {
    let entity = {
      model,
      modelId: this.state.modelId },

    origin = this.state.origin === 'builder' ? 'modal' : this.state.origin;

    Object(__WEBPACK_IMPORTED_MODULE_7__modules_services_share_entities_ShareEntitiesService__["h" /* shareEntity */])(entity, this.state.selectedWorkspace, { origin }).
    then(() => {
      __WEBPACK_IMPORTED_MODULE_5__modules_services_AnalyticsService__["a" /* default */].addEvent(model, 'share', origin);
    }).
    catch(() => {
      pm.toasts.error(`Failed to share the ${model}`);
    });
  }

  handleAdd() {
    if (this.state.modelType === 'collection') {
      this.share('collection');
    } else
    if (this.state.modelType === 'environment') {
      this.share('environment');
    }
    this.handleClose();
  }

  handleCancel() {
    this.handleClose();
  }

  getCustomStyles() {
    return {
      overflow: 'visible',
      maxHeight: '80vh',
      marginTop: '10vh' };

  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["a" /* Modal */], {
          className: 'add-to-workspace-modal',
          isOpen: this.state.isOpen,
          onRequestClose: this.handleClose,
          customStyles: this.getCustomStyles() },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["d" /* ModalHeader */], null, `SHARE ${_.toUpper(this.state.modelType)}`),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["b" /* ModalContent */], null,

          !_.isEmpty(this.state.selectedWorkspace) ?
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_workspaces_AddToWorkspaceModal__["a" /* default */], {
            modelType: this.state.modelType,
            modelId: this.state.modelId,
            workspaces: this.state.workspaces,
            selectedWorkspace: Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('WorkspaceStore').find(this.state.selectedWorkspace),
            teamPermissions: this.state.teamPermissions,
            onChange: this.handleChange,
            onCancel: this.handleCancel,
            onAdd: this.handleAdd }) :

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_empty_states_InviteUsersEmpty__["a" /* default */], {
            modelType: this.state.modelType,
            modelId: this.state.modelId,
            onInvite: this.handleClose }))));





  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5065:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AddToWorkspaceModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_prop_types__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_prop_types___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_prop_types__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Dropdowns__ = __webpack_require__(31);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Icons_TeamIcon__ = __webpack_require__(1491);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__empty_states_CreateTeamEmpty__ = __webpack_require__(4026);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__empty_states_InviteUsersEmpty__ = __webpack_require__(4025);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__base_InviteUsers__ = __webpack_require__(3624);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__messaging_Alert__ = __webpack_require__(1490);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__base_XPaths_XPath__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__services_UIEventService__ = __webpack_require__(79);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__constants_UIEventConstants__ = __webpack_require__(217);
var _class;














const MODEL_TYPES = ['collection', 'environment'];let


AddToWorkspaceModal = Object(__WEBPACK_IMPORTED_MODULE_10_mobx_react__["a" /* observer */])(_class = class AddToWorkspaceModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.handleChange = this.handleChange.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleFreeTeamWarningClick = this.handleFreeTeamWarningClick.bind(this);
  }

  handleClose() {
    this.props.onCancel && this.props.onCancel();
  }

  handleChange(field, value) {
    this.props.onChange && this.props.onChange(field, value);
  }

  handleFreeTeamWarningClick() {
    this.props.onCancel && this.props.onCancel();
    __WEBPACK_IMPORTED_MODULE_12__services_UIEventService__["a" /* default */].publish(__WEBPACK_IMPORTED_MODULE_13__constants_UIEventConstants__["g" /* SHOW_USAGE */]);
  }

  getTeamEmptyState() {
    let modelType = MODEL_TYPES.includes(this.props.modelType) ?
    this.props.modelType :
    'collection';

    let props = {
      modelType: modelType,
      modelId: this.props.modelId,
      onInvite: this.props.onClose };


    if (this.props.isCreateTeam) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-to-workspace__create-team' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__empty_states_CreateTeamEmpty__["a" /* default */], props)));


    }

    return __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__empty_states_InviteUsersEmpty__["a" /* default */], props);
  }

  render() {
    let store = this.props.modelType === 'collection' && Object(__WEBPACK_IMPORTED_MODULE_8__stores_get_store__["getStore"])('CollectionStore').find(this.props.modelId),
    showModifyPermissions = _.get(this.props.selectedWorkspace, 'type') === 'team' && store && !store.isShared,
    canModifyPermissions = store && store.isOwn,
    freeTeamWarningMessage = 'Sharing collections in team workspaces will affect the usage limit for shared requests. [Check your usage before sharing.](#)';

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_11__base_XPaths_XPath__["a" /* default */], { identifier: 'addToWorkspace' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-to-workspace-modal__contents' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-to-workspace-modal__contents-box' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-to-workspace__input-group add-to-workspace__input-group--workspace' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-to-workspace__input-group__label' }, 'Share in Workspace'),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_11__base_XPaths_XPath__["a" /* default */], { identifier: 'selectWorkspace' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-to-workspace__input-group__input' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Dropdowns__["a" /* Dropdown */], {
                      fullWidth: true,
                      className: 'add-to-workspace__input-group__input--selected-workspace',
                      onSelect: this.handleChange.bind(this, 'selectedWorkspace') },

                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Dropdowns__["b" /* DropdownButton */], {
                        size: 'small',
                        type: 'secondary' },

                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], null,
                        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'workspace-name' }, this.props.selectedWorkspace.name))),


                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Dropdowns__["c" /* DropdownMenu */], { fluid: true },

                      _.map(this.props.workspaces, workspace => {
                        return (
                          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Dropdowns__["d" /* MenuItem */], { key: workspace.id, refKey: workspace.id },
                            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, workspace.name),

                            workspace.type === 'team' &&
                            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Icons_TeamIcon__["a" /* default */], { className: 'team-icon' })));



                      }))))),





              !Object(__WEBPACK_IMPORTED_MODULE_8__stores_get_store__["getStore"])('CurrentUserStore').teamSyncEnabled && this.getTeamEmptyState(),

              Object(__WEBPACK_IMPORTED_MODULE_8__stores_get_store__["getStore"])('CurrentUserStore').teamSyncEnabled &&
              this.props.selectedWorkspace.type === 'team' &&
              !Object(__WEBPACK_IMPORTED_MODULE_8__stores_get_store__["getStore"])('CurrentUserStore').isFreeTeamUser &&
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-to-workspace__input-group__subtext' },
                `Adding the ${this.props.modelType} to a team workspace will make it visible to everyone in the team.`),



              Object(__WEBPACK_IMPORTED_MODULE_8__stores_get_store__["getStore"])('CurrentUserStore').teamSyncEnabled &&
              this.props.selectedWorkspace.type === 'team' &&
              Object(__WEBPACK_IMPORTED_MODULE_8__stores_get_store__["getStore"])('CurrentUserStore').isFreeTeamUser &&
              this.props.modelType === 'collection' &&
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_9__messaging_Alert__["a" /* default */], {
                className: 'add-to-workspace__input-group__alert',
                message: freeTeamWarningMessage,
                type: 'warn',
                isDismissable: false,
                onMessageLinkClick: this.handleFreeTeamWarningClick })),





            Object(__WEBPACK_IMPORTED_MODULE_8__stores_get_store__["getStore"])('CurrentUserStore').teamSyncEnabled && showModifyPermissions && canModifyPermissions &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-to-workspace__input-group add-to-workspace__input-group--team-permissions' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-to-workspace__input-group__label' }, 'Team Default Permissions'),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_11__base_XPaths_XPath__["a" /* default */], { identifier: 'teamPermissions' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-to-workspace__input-group__input add-to-workspace__input-group--team-permissions' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-to-workspace__input-group__label__label' }, 'Team'),


                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Dropdowns__["a" /* Dropdown */], {
                      fullWidth: true,
                      className: 'add-to-workspace__input-group__input--team-permissions',
                      onSelect: this.handleChange.bind(this, 'teamPermissions') },

                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Dropdowns__["b" /* DropdownButton */], {
                        size: 'small',
                        type: 'secondary' },

                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], null,
                        `Can ${this.props.teamPermissions === 'write' ? 'edit' : 'view'}`)),


                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Dropdowns__["c" /* DropdownMenu */], { fluid: true },
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Dropdowns__["d" /* MenuItem */], { refKey: 'read' },
                        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Can view')),

                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Dropdowns__["d" /* MenuItem */], { refKey: 'write' },
                        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Can edit'))))))),









            Object(__WEBPACK_IMPORTED_MODULE_8__stores_get_store__["getStore"])('CurrentUserStore').teamSyncEnabled && showModifyPermissions && canModifyPermissions &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-to-workspace__input-group add-to-workspace__input-group--user-permissions' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-to-workspace__input-group__label' }, 'Individual User Permissions'),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-to-workspace__input-group__input' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_InviteUsers__["a" /* default */], {
                  onChange: this.handleChange,
                  teamPermissions: this.props.teamPermissions })))),





          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-to-workspace__actions' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
                type: 'text',
                onClick: this.props.onCancel }, 'Cancel'),



            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_11__base_XPaths_XPath__["a" /* default */], { identifier: 'share' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
                  type: 'primary',
                  onClick: this.props.onAdd }, 'Share'))))));








  }}) || _class;


AddToWorkspaceModal.propTypes = {
  isCreateTeam: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.bool,
  modelId: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.string.isRequired,
  modelType: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.string.isRequired,
  onAdd: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.func,
  onCancel: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.func,
  onChange: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.func,
  onClose: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.func,
  selectedWorkspace: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.object,
  teamPermissions: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.string,
  workspaces: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.array };
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5066:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return RemoveCollectionFromWorkspaceModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_collections_DeleteConfirmationModal__ = __webpack_require__(3517);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__stores_get_store__ = __webpack_require__(5);
var _class;




let

RemoveCollectionFromWorkspaceModalContainer = __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default()(_class = class RemoveCollectionFromWorkspaceModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      id: null,
      meta: null,
      isDisabled: false };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleConfirm = this.handleConfirm.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('showRemoveCollectionFromWorkspaceModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showRemoveCollectionFromWorkspaceModal', this.handleOpen);
  }

  handleOpen(collectionId, { subscriberCount, published, origin }, callback) {
    let collection = Object(__WEBPACK_IMPORTED_MODULE_5__stores_get_store__["getStore"])('CollectionStore').find(collectionId);

    if (!collection) {
      return;
    }
    this.callback = _.isFunction(callback) && callback;
    this.setState({
      isOpen: true,
      id: collection.id,
      uid: collection.uid,
      origin: origin,
      meta: {
        name: collection.name,
        subscriberCount: subscriberCount,
        published: published } },

    () => {
      __WEBPACK_IMPORTED_MODULE_4__modules_services_AnalyticsService__["a" /* default */].addEvent('collection', 'initiate_remove_from_ws', origin);

      _.invoke(this, 'keymapRef.focus');
    });
  }

  handleClose() {
    this.callback = null;
    this.setState({
      isOpen: false,
      id: null,
      meta: null,
      isDisabled: false },
    () => {
      pm.mediator.trigger('focusSidebar');
    });
  }

  handleConfirm() {
    this.setState({ isDisabled: true });
    let removeCollectionEvent = {
      name: 'remove_dependencies',
      namespace: 'workspace',
      data: {
        dependencies: [{
          model: 'collection',
          modelId: this.state.uid }],

        model: 'workspace',
        workspace: { id: Object(__WEBPACK_IMPORTED_MODULE_5__stores_get_store__["getStore"])('ActiveWorkspaceStore').id } } };



    Object(__WEBPACK_IMPORTED_MODULE_3__modules_pipelines_user_action__["a" /* default */])(removeCollectionEvent).
    then(response => {
      if (!_.isEmpty(_.get(response, 'error'))) {
        pm.logger.error('Error in removing collection from workspace', response.error);
        return;
      }

      __WEBPACK_IMPORTED_MODULE_4__modules_services_AnalyticsService__["a" /* default */].addEvent('collection', 'remove_from_ws', this.state.origin);

      // To Close the collection browser if it is open
      pm.mediator.trigger('hideCollectionBrowser', this.handleClose);
      this.handleClose();
    }).
    catch(err => {
      this.setState({ isDisabled: false });
      pm.toasts.error('Unable to remove collection from workspace');
      pm.logger.error('Error in pipeline for deleting collection', err);
    });
  }

  getMessage() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'delete-confirmation-modal-message' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, 'Are you sure you want to remove this collection from this workspace?'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'helptext' }, 'Removing this collection will also remove any monitors, mock servers and integrations created on this collection from this workspace.')));


  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_collections_DeleteConfirmationModal__["a" /* default */], {
        preventFocusReset: true,
        isDisabled: this.state.isDisabled,
        className: 'delete-collection-confirmation-modal',
        title: 'REMOVE COLLECTION',
        primaryAction: this.state.isDisabled ? 'Removing' : 'Remove',
        message: this.getMessage(),
        isOpen: this.state.isOpen,
        keymapRef: ref => {this.keymapRef = ref;},
        meta: this.state.meta,
        onConfirm: this.handleConfirm,
        onRequestClose: this.handleClose }));


  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5067:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return WorkspaceDetailsModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_workspaces_WorkspaceDetailsModal__ = __webpack_require__(5068);



let

WorkspaceDetailsModalContainer = class WorkspaceDetailsModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      workspace: {} };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
  }

  componentDidMount() {
    pm.mediator.on('openWorkspaceDetailsModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('openWorkspaceDetailsModal', this.handleOpen);
  }

  handleOpen(workspace) {
    !this.state.isOpen && this.setState({
      isOpen: true,
      workspace });

  }

  handleClose() {
    this.state.isOpen && this.setState({
      isOpen: false,
      workspace: {} });

  }

  getCustomStyles() {
    return {
      height: '80vh',
      marginTop: '10vh',
      width: '640px' };

  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Modals__["a" /* Modal */], {
          className: 'workspace-details-modal',
          isOpen: this.state.isOpen,
          onRequestClose: this.handleClose,
          customStyles: this.getCustomStyles() },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Modals__["d" /* ModalHeader */], null),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_workspaces_WorkspaceDetailsModal__["a" /* default */], {
            workspace: this.state.workspace }))));




  }};

/***/ }),

/***/ 5068:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return WorkspaceDetailsModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__postman_date_helper__ = __webpack_require__(535);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__postman_date_helper___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1__postman_date_helper__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_SortableTable__ = __webpack_require__(5069);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Avatar__ = __webpack_require__(651);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Icons_ProfileIcon__ = __webpack_require__(3742);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_Icons_TeamIcon__ = __webpack_require__(1491);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_Icons_TimeIcon__ = __webpack_require__(5070);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__utils_PluralizeHelper__ = __webpack_require__(533);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__utils_util__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__stores_get_store__ = __webpack_require__(5);










let

WorkspaceDetailsModal = class WorkspaceDetailsModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  getUserRow(user) {
    if (!user) {
      return false;
    }

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'user__row' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Avatar__["a" /* default */], {
          userId: user.id }),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'user__row__details' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'user__row__details__name' }, user.name),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'user__row__details__email' }, user.email))));



  }

  render() {
    let workspace = this.props.workspace;

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-details' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-details__name' },
          workspace.name),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-details__summary' },
          workspace.description),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-details__owner' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Icons_ProfileIcon__["a" /* default */], { className: 'workspace-details__owner__icon' }),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-details__owner__owner' },
            __WEBPACK_IMPORTED_MODULE_8__utils_util__["a" /* default */].getUserNameForId(workspace.createdBy, Object(__WEBPACK_IMPORTED_MODULE_9__stores_get_store__["getStore"])('CurrentUserStore')) || 'Owner')),



        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-details__last-updated' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Icons_TimeIcon__["a" /* default */], { className: 'workspace-details__last-updated__icon' }),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-details__last-updated__last-updated' },
            `Last updated: ${_.upperFirst(__WEBPACK_IMPORTED_MODULE_1__postman_date_helper___default.a.getFormattedDate(workspace.updatedAt))}`)),



        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-details__member-count' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Icons_TeamIcon__["a" /* default */], { className: 'workspace-details__member-count__icon' }),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-details__member-count__member-count' },

            `${_.size(workspace.members.users)} ${__WEBPACK_IMPORTED_MODULE_7__utils_PluralizeHelper__["a" /* default */].pluralize({
              count: _.size(workspace.members.users),
              singular: 'Member',
              plural: 'Members' })
            }`)),




        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-details__members' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_SortableTable__["a" /* default */], {
            header: 'USER',
            rows: workspace.members.users,
            rowKey: 'name',
            rowRenderer: this.getUserRow }))));




  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5069:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SortableTable; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__Icons_UpSolidIcon__ = __webpack_require__(278);


let

SortableTable = class SortableTable extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = { sort: 'asc' };

    this.handleChangeSort = this.handleChangeSort.bind(this);
    this.getSortedRows = this.getSortedRows.bind(this);
  }

  handleChangeSort() {
    this.setState(state => {
      return { sort: state.sort === 'asc' ? 'desc' : 'asc' };
    });
  }

  getSortedRows() {
    return _.sortBy(this.props.rows, row => _.toLower(_.get(row, this.props.rowKey, '')));
  }

  getClasses() {
    return __WEBPACK_IMPORTED_MODULE_1_classnames___default()({ 'sortable-table': true }, this.props.className);
  }

  getSortClasses() {
    return __WEBPACK_IMPORTED_MODULE_1_classnames___default()({
      'sortable-table__header__sort': true,
      'sortable-table__header__sort--desc': this.state.sort === 'desc',
      'sortable-table__header__sort--asc': this.state.sort === 'asc' });

  }

  render() {
    let sortedRows = this.getSortedRows();
    if (this.state.sort === 'desc') {
      _.reverse(sortedRows);
    }

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: this.getClasses() },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sortable-table__header' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sortable-table__header__title' }, this.props.header),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__Icons_UpSolidIcon__["a" /* default */], {
            className: this.getSortClasses(),
            size: 'xs',
            onClick: this.handleChangeSort })),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sortable-table__rows' },

          _.map(sortedRows, (row, index) => {
            return (
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
                  className: 'sortable-table__row',
                  key: index },


                this.props.rowRenderer ?
                this.props.rowRenderer(row) :
                _.get(row, this.props.rowKey, '')));



          }))));




  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5070:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["a"] = TimeIcon;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__Icon__ = __webpack_require__(28);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};


const icon =
__WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('svg', { width: '16', height: '16', viewBox: '0 0 16 16' },
  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('defs', null,
    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('path', { id: 'time', d: 'M8 0C3.583 0 0 3.583 0 8s3.583 8 8 8 8-3.583 8-8-3.583-8-8-8zm-.35 1.802h.679v.678H7.65v-.678zM2.48 8.349h-.678v-.678h.678v.678zm5.87 5.85H7.67v-.679h.678v.678zm1.897-3.041l-3.177-2.5V3.68h1.124v4.436l2.75 2.15-.697.892zm3.951-2.809h-.678v-.678h.678v.678z' })),

  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('use', { fill: '#282828', fillRule: 'evenodd', xlinkHref: '#time' }));



function TimeIcon(props) {
  return (
    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__Icon__["a" /* default */], _extends({},
    props, {
      icon: icon })));


}

/***/ }),

/***/ 5071:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return BulkAddToWorkspaceModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_workspaces_BulkAddToWorkspaceModal__ = __webpack_require__(5072);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_empty_states_AddToWorkspaceEmpty__ = __webpack_require__(4027);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__modules_services_share_entities_ShareEntitiesService__ = __webpack_require__(3594);
var _class;











const initialState = {
  isOpen: false,
  selectedWorkspace: {},
  selectedCollections: [],
  selectedEnvironments: [],
  activeTab: 'collections',
  workspaces: [] },

entityStore = {
  collection: Object(__WEBPACK_IMPORTED_MODULE_5__stores_get_store__["getStore"])('CollectionStore'),
  environment: Object(__WEBPACK_IMPORTED_MODULE_5__stores_get_store__["getStore"])('EnvironmentStore') };let



BulkAddToWorkspaceModalContainer = Object(__WEBPACK_IMPORTED_MODULE_1_mobx_react__["a" /* observer */])(_class = class BulkAddToWorkspaceModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = initialState;

    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleChange = this.handleChange.bind(this);
    this.handleAdd = this.handleAdd.bind(this);
    this.handleCancel = this.handleCancel.bind(this);
    this.handleSelectCollection = this.handleSelectCollection.bind(this);
    this.handleSelectEnvironment = this.handleSelectEnvironment.bind(this);
    this.handleTabSelect = this.handleTabSelect.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('openBulkAddToWorkspaceModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('openBulkAddToWorkspaceModal', this.handleOpen);
  }

  handleOpen(workspaceId, activeTab = 'collections') {
    let workspaces = _.reject(_.concat(Object(__WEBPACK_IMPORTED_MODULE_5__stores_get_store__["getStore"])('WorkspaceStore').personalWorkspaces, Object(__WEBPACK_IMPORTED_MODULE_5__stores_get_store__["getStore"])('WorkspaceStore').teamWorkspaces), ['id', workspaceId]);

    this.setState({
      isOpen: true,
      selectedWorkspace: _.first(workspaces) && _.first(workspaces).id,
      workspaceId: workspaceId,
      activeTab: activeTab,
      workspaces });

  }

  handleClose() {
    this.state.isOpen && this.setState(initialState);
  }

  handleChange(field, value) {
    if (field === 'selectedWorkspace') {
      this.handleSelectEnvironment([]);
      this.handleSelectCollection([]);
    }
    this.setState({ [field]: value });
  }

  handleTabSelect(activeTab) {
    this.setState({ activeTab });
  }

  handleAdd() {
    let getModelIdMap = (m, e) => _.map(e, entityId => {
      let uid = _.get(entityStore[m].find(entityId), 'uid', '');
      return { model: m, modelId: uid };
    }),
    collectionsToAdd = getModelIdMap('collection', this.state.selectedCollections),
    environmentsToAdd = getModelIdMap('environment', this.state.selectedEnvironments);

    Object(__WEBPACK_IMPORTED_MODULE_8__modules_services_share_entities_ShareEntitiesService__["g" /* shareEntities */])(
    _.concat(collectionsToAdd, environmentsToAdd),
    this.state.workspaceId,
    { origin: 'browse/add_to_ws' });


    this.handleClose();
  }

  handleCancel() {
    this.handleClose();
  }

  getCustomStyles() {
    return {
      overflowY: 'auto',
      maxHeight: '90vh',
      marginTop: '10vh' };

  }

  handleSelectEnvironment(selectedEnvironments) {
    this.setState({ selectedEnvironments });
  }

  handleSelectCollection(selectedCollections) {
    this.setState({ selectedCollections });
  }

  getFreeTeamWarningMessage() {
    return 'Sharing collections in team workspaces will affect the usage limit for shared requests. [Check your usage before sharing.](#)';
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["a" /* Modal */], {
          className: 'add-to-workspace-modal',
          isOpen: this.state.isOpen,
          onRequestClose: this.handleClose,
          customStyles: this.getCustomStyles() },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["d" /* ModalHeader */], null, 'ADD TO THIS WORKSPACE'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["b" /* ModalContent */], null,

          !_.isEmpty(this.state.selectedWorkspace) ?
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_workspaces_BulkAddToWorkspaceModal__["a" /* default */], {
            workspaces: this.state.workspaces,
            selectedCollections: this.state.selectedCollections,
            selectedWorkspace: Object(__WEBPACK_IMPORTED_MODULE_5__stores_get_store__["getStore"])('WorkspaceStore').find(this.state.selectedWorkspace),
            selectedEnvironments: this.state.selectedEnvironments,
            onChange: this.handleChange,
            onSelectEnvironment: this.handleSelectEnvironment,
            onSelectCollection: this.handleSelectCollection,
            onTabSelect: this.handleTabSelect,
            activeTab: this.state.activeTab,
            freeTeamWarningMessage: this.getFreeTeamWarningMessage(),
            onWarningMessageLinkClick: this.handleClose }) :

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__components_empty_states_AddToWorkspaceEmpty__["a" /* default */], { onCreateWorkspace: this.handleClose })),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["c" /* ModalFooter */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Buttons__["a" /* Button */], {
              type: 'primary',
              disabled: _.isEmpty(this.state.selectedCollections) && _.isEmpty(this.state.selectedEnvironments),
              onClick: this.handleAdd }, 'Add to this Workspace'),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Buttons__["a" /* Button */], {
              type: 'text',
              onClick: this.handleCancel }, 'Cancel'))));






  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5072:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return BulkAddToWorkspaceModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__ = __webpack_require__(31);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Icons_TeamIcon__ = __webpack_require__(1491);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Tabs__ = __webpack_require__(103);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_MultiSelectEntity__ = __webpack_require__(3768);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__utils_PluralizeHelper__ = __webpack_require__(533);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__utils_uid_helper__ = __webpack_require__(85);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__messaging_Alert__ = __webpack_require__(1490);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__services_UIEventService__ = __webpack_require__(79);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__constants_UIEventConstants__ = __webpack_require__(217);
var _class;













let

BulkAddToWorkspaceModal = Object(__WEBPACK_IMPORTED_MODULE_10_mobx_react__["a" /* observer */])(_class = class BulkAddToWorkspaceModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.handleChange = this.handleChange.bind(this);
    this.handleFreeTeamWarningClick = this.handleFreeTeamWarningClick.bind(this);
  }

  handleChange(field, value) {
    this.props.onChange && this.props.onChange(field, value);
  }

  getWorkspaceCollections() {
    let store = this.props.selectedWorkspace,
    collectionIds = store && store.dependencies.collections || [];
    return _.chain(collectionIds)

    // workspace dependency ids are uids
    .map(uid => Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('CollectionStore').find(Object(__WEBPACK_IMPORTED_MODULE_8__utils_uid_helper__["a" /* decomposeUID */])(uid).modelId)).
    compact().
    value();
  }

  getWorkspaceEnvironments() {
    let store = this.props.selectedWorkspace,
    environmentIds = store && store.dependencies.environments || [];
    return _.chain(environmentIds)

    // workspace dependency ids are uids
    .map(uid => Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('EnvironmentStore').find(Object(__WEBPACK_IMPORTED_MODULE_8__utils_uid_helper__["a" /* decomposeUID */])(uid).modelId)).
    compact().
    value();
  }

  getSelectedCountText() {
    let collectionsSize = _.size(this.props.selectedCollections),
    environmentsSize = _.size(this.props.selectedEnvironments),
    pluralizeCollection = __WEBPACK_IMPORTED_MODULE_7__utils_PluralizeHelper__["a" /* default */].pluralize({
      count: collectionsSize,
      singular: 'collection',
      plural: 'collections' }),

    pluralizeEnvironment = __WEBPACK_IMPORTED_MODULE_7__utils_PluralizeHelper__["a" /* default */].pluralize({
      count: environmentsSize,
      singular: 'environment',
      plural: 'environments' });


    return `${collectionsSize} ${pluralizeCollection} and ${environmentsSize} ${pluralizeEnvironment} selected`;
  }

  handleFreeTeamWarningClick() {
    this.props.onWarningMessageLinkClick && this.props.onWarningMessageLinkClick();
    __WEBPACK_IMPORTED_MODULE_11__services_UIEventService__["a" /* default */].publish(__WEBPACK_IMPORTED_MODULE_12__constants_UIEventConstants__["g" /* SHOW_USAGE */]);
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-to-workspace-modal__contents' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-to-workspace__input-group add-to-workspace__input-group--workspace' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-to-workspace--helptext' }, 'Select a workspace from which you want to add collections or environments to this workspace.'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-to-workspace__input-group__label' }, 'Source workspace'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-to-workspace__input-group__input' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["a" /* Dropdown */], {
                fullWidth: true,
                className: 'add-to-workspace__input-group__input--selected-workspace',
                onSelect: this.handleChange.bind(this, 'selectedWorkspace') },

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["b" /* DropdownButton */], {
                  size: 'small',
                  type: 'secondary' },

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], null,
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'workspace-name' }, this.props.selectedWorkspace.name))),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["c" /* DropdownMenu */], { fluid: true },

                _.map(this.props.workspaces, workspace => {
                  return (
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], { key: workspace.id, refKey: workspace.id },
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, workspace.name),

                      workspace.type === 'team' &&
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Icons_TeamIcon__["a" /* default */], { className: 'team-icon' })));



                }))))),





        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-to-workspace-modal__choose-entities' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Tabs__["b" /* Tabs */], {
              type: 'primary',
              defaultActive: 'collections',
              activeRef: this.props.activeTab,
              onChange: this.props.onTabSelect,
              className: 'add-to-workspace__tabs' },

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Tabs__["a" /* Tab */], { refKey: 'collections', className: '' }, 'Collections'),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Tabs__["a" /* Tab */], { refKey: 'environments', className: '' }, 'Environments')),


          this.props.activeTab === 'collections' &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_MultiSelectEntity__["a" /* default */], {
            type: 'collections',
            items: this.getWorkspaceCollections(),
            selectedEntities: this.props.selectedCollections,
            onSelectEntity: this.props.onSelectCollection }),



          this.props.activeTab === 'environments' &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_MultiSelectEntity__["a" /* default */], {
            type: 'environments',
            items: this.getWorkspaceEnvironments(),
            selectedEntities: this.props.selectedEnvironments,
            onSelectEntity: this.props.onSelectEnvironment }),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-to-workspace-modal__entities-count' }, this.getSelectedCountText()),

          Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('ActiveWorkspaceStore').type === 'team' &&
          Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('CurrentUserStore').isFreeTeamUser &&
          this.props.activeTab === 'collections' &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'add-to-workspace-modal__alert-wrapper' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_9__messaging_Alert__["a" /* default */], {
              message: this.props.freeTeamWarningMessage,
              type: 'warn',
              isDismissable: false,
              onMessageLinkClick: this.handleFreeTeamWarningClick })))));






  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5073:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return DeleteEnvironmentContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_collections_DeleteConfirmationModal__ = __webpack_require__(3517);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__modules_model_event__ = __webpack_require__(2);
var _class;





let


DeleteEnvironmentContainer = __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default()(_class = class DeleteEnvironmentContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      id: null,
      meta: null,
      isDisabled: false };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleConfirm = this.handleConfirm.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('showEnvironmentDeleteModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showEnvironmentDeleteModal', this.handleOpen);
  }

  handleOpen(environmentId, { origin }, callback) {
    let environment = Object(__WEBPACK_IMPORTED_MODULE_5__stores_get_store__["getStore"])('EnvironmentStore').find(environmentId);

    if (!environment) {
      return;
    }

    this.callback = _.isFunction(callback) && callback;
    this.setState({
      isOpen: true,
      id: environment.id,
      uid: environment.uid,
      origin: origin,
      meta: { name: environment.name } },
    () => {
      let eventLabel = origin;
      eventLabel === 'builder' && (eventLabel = 'modal');
      __WEBPACK_IMPORTED_MODULE_4__modules_services_AnalyticsService__["a" /* default */].addEvent('environment', 'initiate_delete', eventLabel);

      _.invoke(this, 'keymapRef.focus');
    });
  }

  handleClose() {
    this.callback = null;
    this.setState({
      isOpen: false,
      id: null,
      meta: null,
      isDisabled: false });

  }

  handleConfirm() {
    this.setState({ isDisabled: true });
    let deleteEnvironmentEvent = {
      name: 'delete',
      namespace: 'environment',
      data: { id: this.state.id } };


    Object(__WEBPACK_IMPORTED_MODULE_3__modules_pipelines_user_action__["a" /* default */])(deleteEnvironmentEvent).then(response => {
      if (!_.isEmpty(_.get(response, 'error'))) {
        pm.logger.error('Error in deleting environment from workspace', response.error);
        return;
      }

      let eventLabel = this.state.origin;
      eventLabel === 'builder' && (eventLabel = 'modal');
      __WEBPACK_IMPORTED_MODULE_4__modules_services_AnalyticsService__["a" /* default */].addEvent('environment', 'delete', eventLabel);
      Object(__WEBPACK_IMPORTED_MODULE_6__modules_model_event__["b" /* findEvents */])(response.response, { name: 'deleted', namespace: 'variablesession' })[0] &&
      __WEBPACK_IMPORTED_MODULE_4__modules_services_AnalyticsService__["a" /* default */].addEvent('session', 'user_delete', 'environment');

      this.handleClose();
    }).
    catch(err => {
      this.setState({ isDisabled: false });
      pm.toasts.error('Unable to delete environment');
      pm.logger.error('Error in pipeline for deleting environment', err);
    });
  }

  getMessage() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'delete-confirmation-modal-message' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, 'Are you sure you want to delete this environment from this workspace?'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'helptext' }, 'Deleting this environment will also delete any monitors, mock servers and integrations using this environment from this workspace.')));


  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_collections_DeleteConfirmationModal__["a" /* default */], {
        preventFocusReset: true,
        isDisabled: this.state.isDisabled,
        className: 'delete-collection-confirmation-modal',
        title: 'DELETE ENVIRONMENT',
        primaryAction: this.state.isDisabled ? 'Deleting' : 'Delete',
        message: this.getMessage(),
        isOpen: this.state.isOpen,
        keymapRef: ref => {this.keymapRef = ref;},
        meta: this.state.meta,
        onConfirm: this.handleConfirm,
        onRequestClose: this.handleClose }));


  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5074:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return RemoveEnvironmentFromWorkspaceModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_collections_DeleteConfirmationModal__ = __webpack_require__(3517);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__modules_services_AnalyticsService__ = __webpack_require__(16);
var _class;




let


RemoveEnvironmentFromWorkspaceModalContainer = __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default()(_class = class RemoveEnvironmentFromWorkspaceModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      id: null,
      meta: null,
      isDisabled: false };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleConfirm = this.handleConfirm.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('showRemoveEnvironmentWorkspaceModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showRemoveEnvironmentWorkspaceModal', this.handleOpen);
  }

  handleOpen(environmentId, { origin }, callback) {
    let environment = Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('EnvironmentStore').find(environmentId);

    if (!environment) {
      return;
    }

    this.callback = _.isFunction(callback) && callback;
    this.setState({
      isOpen: true,
      id: environment.id,
      uid: environment.uid,
      origin: origin,
      meta: { name: environment.name } },
    () => {
      __WEBPACK_IMPORTED_MODULE_5__modules_services_AnalyticsService__["a" /* default */].addEvent('environment', 'initiate_remove_from_ws', origin === 'builder' ? 'modal' : origin);

      _.invoke(this, 'keymapRef.focus');
    });
  }

  handleClose() {
    this.callback = null;
    this.setState({
      isOpen: false,
      id: null,
      uid: null,
      meta: null,
      isDisabled: false });

  }

  handleConfirm() {
    this.setState({ isDisabled: true });
    let removeEnvironmentEvent = {
      name: 'remove_dependencies',
      namespace: 'workspace',
      data: {
        dependencies: [{
          model: 'environment',
          modelId: this.state.uid }],

        model: 'workspace',
        workspace: { id: Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('ActiveWorkspaceStore').id } } };



    Object(__WEBPACK_IMPORTED_MODULE_3__modules_pipelines_user_action__["a" /* default */])(removeEnvironmentEvent).then(response => {
      if (!_.isEmpty(_.get(response, 'error'))) {
        pm.logger.error('Error in removing environment from workspace', response.error);
        return;
      }

      __WEBPACK_IMPORTED_MODULE_5__modules_services_AnalyticsService__["a" /* default */].addEvent('environment', 'remove_from_ws', this.state.origin === 'builder' ? 'modal' : this.state.origin);
      this.handleClose();
    }).
    catch(err => {
      this.setState({ isDisabled: false });
      pm.toasts.error('Unable to remove environment from workspace');
      pm.logger.error('Error in pipeline for removing environment', err);
    });
  }

  getMessage() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'delete-confirmation-modal-message' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, 'Are you sure you want to remove this environment from this workspace?'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'helptext' }, 'Removing this environment will also remove any monitors, mock servers and integrations using this environment from this workspace.')));


  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_collections_DeleteConfirmationModal__["a" /* default */], {
        preventFocusReset: true,
        isDisabled: this.state.isDisabled,
        className: 'delete-collection-confirmation-modal',
        title: 'REMOVE ENVIRONMENT',
        primaryAction: this.state.isDisabled ? 'Removing' : 'Remove',
        message: this.getMessage(),
        isOpen: this.state.isOpen,
        keymapRef: ref => {this.keymapRef = ref;},
        meta: this.state.meta,
        onConfirm: this.handleConfirm,
        onRequestClose: this.handleClose }));


  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5075:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return DeleteWorkspaceContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_mobx__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_collections_DeleteConfirmationModal__ = __webpack_require__(3517);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__modules_model_event__ = __webpack_require__(2);
var _class;





let


DeleteWorkspaceContainer = Object(__WEBPACK_IMPORTED_MODULE_2_mobx_react__["a" /* observer */])(_class = class DeleteWorkspaceContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      id: null,
      meta: null };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleConfirm = this.handleConfirm.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('showWorkspaceDeleteModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showWorkspaceDeleteModal', this.handleOpen);
  }

  handleOpen(workspaceId, callback) {
    let workspace = Object(__WEBPACK_IMPORTED_MODULE_5__stores_get_store__["getStore"])('WorkspaceStore').find(workspaceId);

    if (!workspace) {
      return;
    }

    this.callback = _.isFunction(callback) && callback;
    this.setState({
      isOpen: true,
      id: workspace.id,
      meta: { name: workspace.name } },
    () => {
      this.onLifecycleChange = Object(__WEBPACK_IMPORTED_MODULE_1_mobx__["q" /* reaction */])(() => Object(__WEBPACK_IMPORTED_MODULE_5__stores_get_store__["getStore"])('WorkspaceLifecycleStore').workspaceLifecycles[this.state.id], workspaceLifecycles => {
        if (this.state.id && !Object(__WEBPACK_IMPORTED_MODULE_5__stores_get_store__["getStore"])('WorkspaceLifecycleStore').isDeleting(this.state.id)) {
          this.handleClose();
        }
      });
      _.invoke(this, 'keymapRef.focus');
    });
  }

  handleClose() {
    this.callback = null;
    _.isFunction(this.onLifecycleChange) && this.onLifecycleChange();
    this.setState({
      isOpen: false,
      id: null,
      meta: null });

  }

  handleConfirm() {
    let deleteWorkspaceEvent = Object(__WEBPACK_IMPORTED_MODULE_6__modules_model_event__["a" /* createEvent */])(
    'delete',
    'workspace',
    { id: this.state.id });


    Object(__WEBPACK_IMPORTED_MODULE_4__modules_pipelines_user_action__["a" /* default */])(deleteWorkspaceEvent).then(response => {
      if (!_.isEmpty(_.get(response, 'error'))) {
        pm.logger.error('Error in deleting workspace', response.error);
        pm.toasts.error('Error in deleting workspace: ' + response.message);
      }
    }).
    catch(err => {
      Object(__WEBPACK_IMPORTED_MODULE_5__stores_get_store__["getStore"])('WorkspaceLifecycleStore').resetLifecycle(this.state.id);
      pm.toasts.error('Error in deleting workspace: ' + err.message);
    });
  }

  getMessage() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'delete-confirmation-modal-message' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, 'Are you sure you want to delete this workspace?'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'helptext' }, 'Members of this workspace might lose access to the collections and environments in this workspace.')));


  }

  render() {
    let isDeletingWorkspace = Object(__WEBPACK_IMPORTED_MODULE_5__stores_get_store__["getStore"])('WorkspaceLifecycleStore').isDeleting(this.state.id);
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_collections_DeleteConfirmationModal__["a" /* default */], {
        preventFocusReset: true,
        className: 'delete-collection-confirmation-modal',
        title: 'DELETE WORKSPACE',
        primaryAction: isDeletingWorkspace && 'Deleting' || 'Delete',
        isDisabled: isDeletingWorkspace,
        message: this.getMessage(),
        isOpen: this.state.isOpen,
        keymapRef: ref => {this.keymapRef = ref;},
        meta: this.state.meta,
        onConfirm: this.handleConfirm,
        onRequestClose: this.handleClose }));


  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5076:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return LeaveWorkspaceContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_mobx__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_collections_DeleteConfirmationModal__ = __webpack_require__(3517);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__modules_model_event__ = __webpack_require__(2);
var _class;





let


LeaveWorkspaceContainer = Object(__WEBPACK_IMPORTED_MODULE_2_mobx_react__["a" /* observer */])(_class = class LeaveWorkspaceContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      id: null,
      meta: null };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleConfirm = this.handleConfirm.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('showWorkspaceLeaveModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showWorkspaceLeaveModal', this.handleOpen);
  }

  handleOpen(workspaceId, callback) {
    let workspace = Object(__WEBPACK_IMPORTED_MODULE_5__stores_get_store__["getStore"])('WorkspaceStore').find(workspaceId);

    if (!workspace) {
      return;
    }

    this.callback = _.isFunction(callback) && callback;
    this.setState({
      isOpen: true,
      id: workspace.id,
      meta: { name: workspace.name } },
    () => {
      this.onLifecycleChange = Object(__WEBPACK_IMPORTED_MODULE_1_mobx__["q" /* reaction */])(() => Object(__WEBPACK_IMPORTED_MODULE_5__stores_get_store__["getStore"])('WorkspaceLifecycleStore').workspaceLifecycles[this.state.id], () => {
        if (this.state.id && !Object(__WEBPACK_IMPORTED_MODULE_5__stores_get_store__["getStore"])('WorkspaceLifecycleStore').isLeaving(this.state.id)) {
          this.handleClose();
        }
      });
      _.invoke(this, 'keymapRef.focus');
    });
  }

  handleClose() {
    this.callback = null;
    _.isFunction(this.onLifecycleChange) && this.onLifecycleChange();
    this.setState({
      isOpen: false,
      id: null,
      meta: null });

  }

  handleConfirm() {
    let leaveWorkspaceEvent = Object(__WEBPACK_IMPORTED_MODULE_6__modules_model_event__["a" /* createEvent */])(
    'leave',
    'workspace',
    {
      model: 'workspace',
      workspace: { id: this.state.id } });


    Object(__WEBPACK_IMPORTED_MODULE_4__modules_pipelines_user_action__["a" /* default */])(leaveWorkspaceEvent).then(response => {
      if (!_.isEmpty(_.get(response, 'error'))) {
        pm.toasts.error('Something went wrong while leaving the workspace.');
        return;
      }
    }).
    catch(err => {
      Object(__WEBPACK_IMPORTED_MODULE_5__stores_get_store__["getStore"])('WorkspaceLifecycleStore').resetLifecycle(this.state.id);
      pm.toasts.error(err && err.message || 'Something went wrong while leaving the workspace.');
    });
  }

  getMessage() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'delete-confirmation-modal-message' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, 'Are you sure you want to leave this workspace?'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'helptext' }, 'You will no longer be able to collaborate on the collections and environments within this workspace.')));


  }

  render() {
    let isLeavingWorkspace = Object(__WEBPACK_IMPORTED_MODULE_5__stores_get_store__["getStore"])('WorkspaceLifecycleStore').isLeaving(this.state.id);
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_collections_DeleteConfirmationModal__["a" /* default */], {
        preventFocusReset: true,
        className: 'delete-collection-confirmation-modal',
        title: 'LEAVE WORKSPACE',
        primaryAction: isLeavingWorkspace && 'Leaving' || 'Leave',
        isDisabled: isLeavingWorkspace,
        message: this.getMessage(),
        isOpen: this.state.isOpen,
        keymapRef: ref => {this.keymapRef = ref;},
        meta: this.state.meta,
        onConfirm: this.handleConfirm,
        onRequestClose: this.handleClose }));


  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5077:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ShareWorkspaceModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__modules_controllers_WorkspaceController__ = __webpack_require__(56);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_new_button_DisabledOperationModal__ = __webpack_require__(3675);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__components_base_LoadingIndicator__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__components_workspaces_ShareWorkspaceModal__ = __webpack_require__(5078);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__utils_util__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__modules_sync_helpers_create_workspace_members_diff__ = __webpack_require__(4024);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__utils_default_workspace__ = __webpack_require__(136);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__modules_services_UserInvitationService__ = __webpack_require__(3626);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__constants_InviteLinkStateConstants__ = __webpack_require__(3776);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__modules_services_PermissionsService__ = __webpack_require__(3676);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__modules_services_RolesService__ = __webpack_require__(3593);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__components_base_XPaths_XPath__ = __webpack_require__(24);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _class;























const defaultState = {
  isOpen: false,
  id: '',
  name: '',
  type: 'personal',
  members: {},
  userEmails: [],
  inviteLinkState: __WEBPACK_IMPORTED_MODULE_15__constants_InviteLinkStateConstants__["a" /* EMPTY */],
  inviteErrorMessage: '',
  buttonDisabled: false,
  isLoading: false,
  limitVisibility: false,
  invitationError: false,
  isDefaultTeamWorkspace: false,
  userCurrentRoles: {},
  allRoles: {},
  teamCurrentRole: {},
  defaultRoles: {},
  populatingRoles: false,
  permissions: {},
  invalidEmails: [] };let



ShareWorkspaceModalContainer = Object(__WEBPACK_IMPORTED_MODULE_11_mobx_react__["a" /* observer */])(_class = class ShareWorkspaceModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = _extends({},
    defaultState, {
      inviteLink: null });


    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleChange = this.handleChange.bind(this);
    this.handleMembersChange = this.handleMembersChange.bind(this);
    this.handleShare = this.handleShare.bind(this);
    this.handleContinue = this.handleContinue.bind(this);
    this.handleCancel = this.handleClose.bind(this);

    this.handleGetInviteLink = this.handleGetInviteLink.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('openShareWorkspaceModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('openShareWorkspaceModal', this.handleOpen);
  }

  checkVisibility(workspaceVisibility) {
    // bail out
    if (_.isEmpty(workspaceVisibility)) {
      return false;
    }

    let organizations = Object(__WEBPACK_IMPORTED_MODULE_10__stores_get_store__["getStore"])('CurrentUserStore').organizations;

    if (!organizations || !organizations[0]) {
      return false;
    }

    let teamId = organizations[0].id;

    if (workspaceVisibility.team && !workspaceVisibility.team[teamId].visible) {
      return true;
    }

    return false;
  }

  async handleOpen(workspaceId) {
    if (this.state.isOpen) return;

    let teamId = _.get(Object(__WEBPACK_IMPORTED_MODULE_10__stores_get_store__["getStore"])('CurrentUserStore'), 'team.id'),

    // Don't fetch roles if team does not exist or workspace type is personal
    shouldFetchRoles = !!teamId,
    workspace = await __WEBPACK_IMPORTED_MODULE_2__modules_controllers_WorkspaceController__["a" /* default */].get({ id: workspaceId }),
    defaultTeamWorkspaceID = await Object(__WEBPACK_IMPORTED_MODULE_13__utils_default_workspace__["b" /* defaultTeamWorkspaceId */])(),
    data = {
      isOpen: true,
      name: _.get(workspace, 'name', 'Team Workspace').toUpperCase(),
      id: workspaceId,
      limitVisibility: this.checkVisibility(workspace.visibility),
      type: workspace.type || 'personal' };


    this.setState(_extends({},
    data, {
      populatingRoles: shouldFetchRoles,
      isDefaultTeamWorkspace: defaultTeamWorkspaceID === data.id }));


    shouldFetchRoles && this.fetchRoles(workspaceId);
    this.fetchPermissions(workspaceId);
  }

  /**
     * Refer WorkspaceRoles.md for terminology and structure
     * If the user is trying to share a personal workspace, we need to
     * show the team role dropdown, hence we assign the default role initially
     *
     * If its a team workspace, we rely on Sync to return us an already assigned team role
     * If Sync returns no team role, the workspace is assumed to be private and we set limitVisibility to true
     *
     */
  async fetchRoles(workspaceId) {
    try {
      let {
        rolesList,
        userCurrentRoles,
        teamCurrentRole,
        superRoles,
        defaultRoles } =
      await Object(__WEBPACK_IMPORTED_MODULE_18__modules_services_RolesService__["a" /* fetchEntityRoles */])('workspace', workspaceId),

      // Assign a default role to the team if personal workspace is being shared
      teamRole = this.state.type === 'personal' ? Object(__WEBPACK_IMPORTED_MODULE_18__modules_services_RolesService__["c" /* getTeamDefaultRole */])(defaultRoles) : teamCurrentRole,
      isPrivateWorkspace = _.isEmpty(teamRole);

      this.setState({
        allRoles: rolesList,
        userCurrentRoles,
        teamCurrentRole: teamRole,
        superRoles,
        defaultRoles,
        limitVisibility: isPrivateWorkspace,
        populatingRoles: false });

    }
    catch (e) {
      pm.logger.error(e);

      this.handleClose();
    }
  }

  handleClose() {
    this.state.isOpen && this.setState(defaultState);
  }

  handleMembersChange({ members, userCurrentRoles }) {
    this.setState({ members, userCurrentRoles });
  }

  handleChange(field, value) {
    this.setState({ [field]: value });
  }

  /**
     * If limit visibility is disabled, assign a default team role to the team
     */
  handleVisibilityChange(value) {
    let teamCurrentRole = {};

    if (!value) {
      teamCurrentRole = Object(__WEBPACK_IMPORTED_MODULE_18__modules_services_RolesService__["c" /* getTeamDefaultRole */])(this.state.defaultRoles);
    }

    this.setState({
      limitVisibility: value,
      teamCurrentRole });

  }

  handleInviteFlowsError(errorState) {
    let trialStatus = _.get(errorState, 'activate_trial', 0),
    workspaceStatus = _.get(errorState, 'create_workspace', 0);

    if (!trialStatus) {
      this.setState({ loading: false });
      pm.toasts.error('Something went wrong while activating the trial');
      return;
    }

    if (!workspaceStatus) {
      this.setState({ loading: false });
      pm.toasts.error('Something went wrong while creating the workspace');
      return;
    }

    this.setState({ invitationError: true });
    __WEBPACK_IMPORTED_MODULE_17__modules_services_AnalyticsService__["a" /* default */].addEvent('app', 'invite_users_failed', 'share_ws', null, { workspaceId: this.state.id });
  }

  activateTrialAndInvite() {
    let workspace = {
      id: this.state.id,
      type: 'team' },

    data = {
      workspace,
      emails: this.state.userEmails };


    Object(__WEBPACK_IMPORTED_MODULE_14__modules_services_UserInvitationService__["a" /* activateTrialAndInviteUsers */])(data, 'shareWS', (err, response) => {
      if (err) {
        pm.logger.error(err);

        pm.toasts.error(_.get(err, 'message', 'Something went wrong while sharing this workspace'));
        this.handleClose();
      }

      // The error state contains the status of the steps
      // whichever succeeded and failed while activating the trial
      // and inviting users to the workspace
      let errorState = _.get(response, 'error.state', null);

      if (errorState) {
        return this.handleInviteFlowsError(errorState);
      }

      this.handleClose();
    });
    __WEBPACK_IMPORTED_MODULE_17__modules_services_AnalyticsService__["a" /* default */].addEvent('app', 'trial_invite_users', 'share_ws', null, { workspaceId: this.state.id });
  }

  sendInvitation(teamId) {
    if (_.isEmpty(this.state.userEmails)) {
      return Promise.resolve();
    }

    let data = {
      workspaceId: this.state.id,
      emails: this.state.userEmails,
      teamId };


    __WEBPACK_IMPORTED_MODULE_17__modules_services_AnalyticsService__["a" /* default */].addEvent('app', 'invite_users', 'share_ws', null, { workspaceId: this.state.id });
    return new Promise((resolve, reject) => {
      Object(__WEBPACK_IMPORTED_MODULE_14__modules_services_UserInvitationService__["c" /* inviteUsers */])(data, err => {
        if (err) {
          __WEBPACK_IMPORTED_MODULE_17__modules_services_AnalyticsService__["a" /* default */].addEvent('app', 'invite_users_failed', 'share_ws', null, { workspaceId: this.state.id });

          return reject(err);
        }

        let refreshOrganizationEvent = {
          name: 'refreshOrganizations',
          namespace: 'user' };


        Object(__WEBPACK_IMPORTED_MODULE_8__modules_pipelines_user_action__["a" /* default */])(refreshOrganizationEvent).
        catch(e => {
          pm.logger.error('Error while refreshing organizations', e);
        });

        resolve(true);
      });
    });
  }

  /**
     *
     * @param {String} [teamId] only required if inviting users
     */
  async updateWorkspace(teamId) {
    let workspace = {
      id: this.state.id };


    // Send type team only for personal -> team workspace update
    if (this.state.type === 'personal') {
      workspace.type = 'team';
    }

    // Send roles only if the user has a permission to update roles
    if (_.get(this.state.permissions, 'updateWorkspaceRoles', true)) {
      let teamId = _.get(Object(__WEBPACK_IMPORTED_MODULE_10__stores_get_store__["getStore"])('CurrentUserStore'), 'team.id'),
      { roles } = await Object(__WEBPACK_IMPORTED_MODULE_18__modules_services_RolesService__["b" /* getRolesData */])(
      this.state.userCurrentRoles,
      !this.state.limitVisibility ? _.get(this.state.teamCurrentRole, teamId) : {},
      'workspace',
      this.state.id);


      workspace.roles = roles;
    }

    if (this.isLimitingVisibilityEnabled()) {
      workspace.visibility = {
        team: {
          [teamId]: {
            id: teamId,
            visible: !this.state.limitVisibility } } };




      let visibilityAction = 'limiting_visibility_enabled';
      if (!this.state.limitVisibility) {
        visibilityAction = 'limiting_visibility_disabled';
      }
      __WEBPACK_IMPORTED_MODULE_17__modules_services_AnalyticsService__["a" /* default */].addEvent('app', visibilityAction, 'share_ws', null, { workspaceId: this.state.id });
    }

    Object(__WEBPACK_IMPORTED_MODULE_12__modules_sync_helpers_create_workspace_members_diff__["a" /* addMembersAsDiff */])(workspace, _.map(this.state.members, member => member.id));
    let workspaceUpdateEvent = {
      name: 'update',
      namespace: 'workspace',
      data: workspace };


    return Object(__WEBPACK_IMPORTED_MODULE_8__modules_pipelines_user_action__["a" /* default */])(workspaceUpdateEvent).
    then(response => {
      if (!_.isEmpty(_.get(response, 'error'))) {
        return Promise.reject();
      }

      // It's certain that the workspace is now converted to a team workspace
      this.setState({ type: 'team' });

      return Promise.resolve();
    }).
    catch(e => {
      return Promise.reject(e);
    });
  }

  // Need to update ActiveBrowseWorkspaceStore to disable the Share Workspace button
  // once the workspace has been shared
  handleShare() {
    this.setState({
      isLoading: true,
      buttonDisabled: true });


    let currentUser = Object(__WEBPACK_IMPORTED_MODULE_10__stores_get_store__["getStore"])('CurrentUserStore'),
    teamId = _.get(currentUser, 'team.id', null);

    if (__WEBPACK_IMPORTED_MODULE_9__utils_util__["a" /* default */].isFreeUser(currentUser)) {
      return this.activateTrialAndInvite();
    }

    this.updateWorkspace(teamId).
    then(() => this.sendInvitation(teamId)).
    then(() => this.handleClose()).
    catch(e => {
      console.warn(e);

      pm.toasts.error(_.get(e, 'message', 'Unable to share the workspace'));
      this.handleClose();
    });
  }

  fetchInviteLink() {
    Object(__WEBPACK_IMPORTED_MODULE_14__modules_services_UserInvitationService__["b" /* getTeamInviteLink */])((err, inviteLink) => {
      if (err || !inviteLink) {
        return this.setState({
          inviteLinkState: __WEBPACK_IMPORTED_MODULE_15__constants_InviteLinkStateConstants__["b" /* ERROR */],
          inviteErrorMessage: _.get(err, 'message', 'Something went wrong while generating the link.') });

      }

      this.setState({ inviteLink, inviteLinkState: __WEBPACK_IMPORTED_MODULE_15__constants_InviteLinkStateConstants__["d" /* GENERATED */] });
    });
  }

  handleGetInviteLink() {
    // In case the user doesn't have email invite privileges
    if (!this.canSendInvites()) {
      this.setState({
        inviteLinkState: __WEBPACK_IMPORTED_MODULE_15__constants_InviteLinkStateConstants__["b" /* ERROR */],
        inviteErrorMessage: 'You do not have admin permission to perform this action' });

      return;
    }

    if (this.state.inviteLinkState === __WEBPACK_IMPORTED_MODULE_15__constants_InviteLinkStateConstants__["e" /* LOADING */] || this.state.isLoading) {
      return;
    }

    __WEBPACK_IMPORTED_MODULE_17__modules_services_AnalyticsService__["a" /* default */].addEvent('app', 'get_invite_link', 'share_ws', null, { workspaceId: this.state.id });

    this.setState({ inviteLinkState: __WEBPACK_IMPORTED_MODULE_15__constants_InviteLinkStateConstants__["e" /* LOADING */] });

    if (this.state.type === 'team') {
      return this.fetchInviteLink();
    }

    let currentUser = Object(__WEBPACK_IMPORTED_MODULE_10__stores_get_store__["getStore"])('CurrentUserStore'),
    teamId = _.get(currentUser, 'team.id', null);

    if (__WEBPACK_IMPORTED_MODULE_9__utils_util__["a" /* default */].isFreeUser(currentUser)) {
      return this.activateTrialAndInvite();
    }

    this.updateWorkspace(teamId).
    then(() => this.fetchInviteLink()).
    catch(e => {
      pm.toasts.error(_.get(e, 'message', 'Unable to share the workspace'));
      this.handleClose();
    });
  }

  handleContinue() {
    this.setState({
      isLoading: true,
      buttonDisabled: true });


    let currentUser = Object(__WEBPACK_IMPORTED_MODULE_10__stores_get_store__["getStore"])('CurrentUserStore'),
    teamId = _.get(currentUser, 'team.id', null);

    this.sendInvitation(teamId).
    then(() => this.handleClose()).
    catch(e => {
      pm.logger.error(e);

      pm.toasts.error(e, 'message', 'Something went wrong while inviting users');
      this.handleClose();
    });
  }

  // @todo: Move this to WorkspaceUI store
  isLimitingVisibilityEnabled() {
    let currentUsersTeam = Object(__WEBPACK_IMPORTED_MODULE_10__stores_get_store__["getStore"])('CurrentUserStore').team;
    if (!currentUsersTeam) {
      return false;
    }

    let plansKey = 'workspace.visibilityAvailablePlans',
    visibilityAvailablePlans = Object(__WEBPACK_IMPORTED_MODULE_10__stores_get_store__["getStore"])('ConfigurationStore').get(plansKey);

    return _.includes(visibilityAvailablePlans, currentUsersTeam.plan);
  }

  getCustomStyles() {
    return {
      marginTop: '60px',
      maxHeight: '160vh',
      width: '680px' };

  }

  getTeamStats() {
    let existingStats = Object(__WEBPACK_IMPORTED_MODULE_10__stores_get_store__["getStore"])('TeamStore').teamStatsForInvites,
    invitesLeft = existingStats.invitesLeft - _.size(this.state.userEmails);

    // safe check
    if (invitesLeft < 0) {
      invitesLeft = 0;
    }

    let updatedStats = _extends({}, existingStats, { invitesLeft });
    return updatedStats;
  }

  getShareButtonLabel() {
    if (this.state.inviteLink && this.state.inviteLinkState === __WEBPACK_IMPORTED_MODULE_15__constants_InviteLinkStateConstants__["e" /* LOADING */]) {
      return 'Continue';
    }

    if ([__WEBPACK_IMPORTED_MODULE_15__constants_InviteLinkStateConstants__["e" /* LOADING */], __WEBPACK_IMPORTED_MODULE_15__constants_InviteLinkStateConstants__["a" /* EMPTY */], __WEBPACK_IMPORTED_MODULE_15__constants_InviteLinkStateConstants__["b" /* ERROR */]].includes(this.state.inviteLinkState)) {
      return 'Send Invitations';
    }

    return 'Continue';
  }

  getButtonClassNames(user) {
    let isFreeUser = __WEBPACK_IMPORTED_MODULE_9__utils_util__["a" /* default */].isFreeUser(user);
    return __WEBPACK_IMPORTED_MODULE_1_classnames___default()({
      'button-large': isFreeUser,
      'button-medium': !isFreeUser });

  }

  getInviteLink(canSendInvites) {
    // In case it's a personal workspace, do not show the link
    // Since the workspace needs to be converted to a team workspace
    if (!this.state.inviteLink || !canSendInvites || this.state.type === 'personal') {
      return null;
    }

    let link = this.state.inviteLink;

    if (this.state.isDefaultTeamWorkspace) {
      return link;
    }

    return `${link}&ws=${this.state.id}`;
  }

  /**
     * Fetches permissions for update roles
     * add member to workspace, remove member to workspace
     */
  async fetchPermissions(workspaceId) {
    let permissions = await Object(__WEBPACK_IMPORTED_MODULE_16__modules_services_PermissionsService__["a" /* fetchPermissions */])(
    ['updateWorkspaceRoles', 'addMemberToWorkspace', 'removeMemberFromWorkspace',
    'manageTeamInvites', 'sendUnapprovedInvites'],
    workspaceId);


    this.setState({ permissions });
  }

  canSendInvites() {
    let canManageTeamInvites = _.get(this.state.permissions, 'manageTeamInvites'),
    canSendUnapprovedInvites = _.get(this.state.permissions, 'sendUnapprovedInvites');

    return canManageTeamInvites || canSendUnapprovedInvites;
  }

  render() {
    let currentUser = Object(__WEBPACK_IMPORTED_MODULE_10__stores_get_store__["getStore"])('CurrentUserStore'),
    isLoggedIn = currentUser.isLoggedIn,
    isSyncEnabled = Object(__WEBPACK_IMPORTED_MODULE_10__stores_get_store__["getStore"])('GateKeeperStore').isSyncEnabled,
    isProUser = __WEBPACK_IMPORTED_MODULE_9__utils_util__["a" /* default */].isProUser(currentUser),
    shareButtonLabel = this.getShareButtonLabel(),
    shareButtonHandler = this.state.inviteLinkState === __WEBPACK_IMPORTED_MODULE_15__constants_InviteLinkStateConstants__["d" /* GENERATED */] ?
    this.handleContinue :
    this.handleShare,
    canSendInvites = this.canSendInvites(),
    inviteLink = this.getInviteLink(canSendInvites),
    isSocketConnected = Object(__WEBPACK_IMPORTED_MODULE_10__stores_get_store__["getStore"])('SyncStatusStore').isSocketConnected,
    canUpdateRoles = _.get(this.state.permissions, 'updateWorkspaceRoles'),
    canAddMember = _.get(this.state.permissions, 'addMemberToWorkspace'),
    canRemoveMember = _.get(this.state.permissions, 'removeMemberFromWorkspace'),
    canManageTeamInvites = _.get(this.state.permissions, 'manageTeamInvites'),
    canSendUnapprovedInvites = _.get(this.state.permissions, 'sendUnapprovedInvites'),
    disableButton = this.state.buttonDisabled || this.state.isLoading ||
    this.state.populatingRoles || !isSocketConnected || !_.isEmpty(this.state.invalidEmails),
    buttonTooltipText = !_.isEmpty(this.state.invalidEmails) && 'You have added invalid emails, please remove them to continue.';

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_19__components_base_XPaths_XPath__["a" /* default */], { identifier: 'inviteModal', isVisible: this.state.isOpen },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Modals__["a" /* Modal */], {
            className: 'create-new-workspace-modal share-workspace-modal',
            isOpen: this.state.isOpen,
            onRequestClose: this.handleClose,
            customStyles: this.getCustomStyles() },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Modals__["d" /* ModalHeader */], null, 'INVITE USERS TO ', this.state.name),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Modals__["b" /* ModalContent */], null,

            !isLoggedIn || !isSyncEnabled ?
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_new_button_DisabledOperationModal__["a" /* default */], {
              isLoggedIn: isLoggedIn,
              isSyncEnabled: isSyncEnabled,
              entity: 'workspace' }) :


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-workspace-modal-content-wrapper' },
              !this.state.populatingRoles ?
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__components_workspaces_ShareWorkspaceModal__["a" /* default */], {
                entity: 'workspace',
                users: this.state.members,
                onChange: this.handleChange,
                onVisibilityChange: this.handleVisibilityChange.bind(this),
                onAddMember: this.handleMembersChange,
                onRemoveMember: this.handleMembersChange,

                isProUser: isProUser,
                showConversionAlert: this.state.type === 'personal',
                allowInvites: canSendInvites,
                teamStats: this.getTeamStats(),
                inviteLink: inviteLink,
                inviteLinkState: this.state.inviteLinkState,
                inviteErrorMessage: this.state.inviteErrorMessage,
                onGetLink: this.handleGetInviteLink,

                limitVisibility: this.state.limitVisibility,
                isLimitingVisibilityEnabled: canUpdateRoles && this.isLimitingVisibilityEnabled(),
                allRoles: this.state.allRoles,
                teamCurrentRole: this.state.teamCurrentRole,
                userCurrentRoles: this.state.userCurrentRoles,
                defaultRoles: this.state.defaultRoles,
                superRoles: this.state.superRoles,

                canUpdateRoles: canUpdateRoles,
                canAddMember: canAddMember,
                canRemoveMember: canRemoveMember,
                canManageTeamInvites: canManageTeamInvites,
                canSendUnapprovedInvites: canSendUnapprovedInvites }) :


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_base_LoadingIndicator__["a" /* default */], null))),





          isLoggedIn && isSyncEnabled &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Modals__["c" /* ModalFooter */], null,
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_19__components_base_XPaths_XPath__["a" /* default */], { identifier: 'invite' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_Buttons__["a" /* Button */], {
                  className: this.getButtonClassNames(currentUser),
                  type: 'primary',
                  disabled: disableButton,
                  onClick: shareButtonHandler,
                  tooltip: buttonTooltipText },


                this.state.isLoading ?
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_base_LoadingIndicator__["a" /* default */], {
                  className: 'loading-indicator-size' }) :

                shareButtonLabel)),



            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_Buttons__["a" /* Button */], {
                type: 'text',
                onClick: this.handleCancel }, 'Cancel')))));








  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5078:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ShareWorkspaceModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_InviteUsers__ = __webpack_require__(3624);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__utils_util__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__constants_AppUrlConstants__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__models_services_DashboardService__ = __webpack_require__(309);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__invite_flows_InviteLink__ = __webpack_require__(4028);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__messaging_Alert__ = __webpack_require__(1490);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__external_navigation_ExternalNavigationService__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__WorkspaceVisibility__ = __webpack_require__(3774);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__constants_InviteLinkStateConstants__ = __webpack_require__(3776);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _class;















const isDeleteActionEnabled = user => {
  return user.id != Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('CurrentUserStore').id;
};let


ShareWorkspaceModal = Object(__WEBPACK_IMPORTED_MODULE_5_mobx_react__["a" /* observer */])(_class = class ShareWorkspaceModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isTooltipVisible: false,
      showInviteDeniedError: false };

    this.handleChange = this.handleChange.bind(this);
    this.handleEmailError = this.handleEmailError.bind(this);
    this.showTooltip = this.showTooltip.bind(this);
    this.hideTooltip = this.hideTooltip.bind(this);

    this.renderAlert = this.renderAlert.bind(this);
  }

  handleChange(field, value) {
    this.props.onChange && this.props.onChange(field, value);
  }

  handleEmailError({ showInviteDeniedError }) {
    this.setState({ showInviteDeniedError });
  }

  getTeamSize() {
    let teamMembers = _.get(this.props, 'teamStats.teamSize', 0) - _.get(this.props, 'teamStats.invitesLeft', 0);
    return `${teamMembers}/${_.get(this.props, 'teamStats.teamSize', 0)}`;
  }

  getSubText() {
    if (this.state.showInviteDeniedError) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-workspace__email-privileges-denied' }, 'You can only add team members to this workspace. To add other users, contact your team admin to add them to the team.'));




    }

    if (!__WEBPACK_IMPORTED_MODULE_6__utils_util__["a" /* default */].isFreeUser(Object(__WEBPACK_IMPORTED_MODULE_4__stores_get_store__["getStore"])('CurrentUserStore'))) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-workspace__team_info' }, 'Inviting users to this workspace will add them to your Postman team, if they\u2019re not already members.'));



    }

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, 'Shared workspaces are a',

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
            type: 'text',
            className: 'learn-more-link',
            onClick: () => Object(__WEBPACK_IMPORTED_MODULE_11__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_7__constants_AppUrlConstants__["X" /* POSTMAN_PRO_DOCS */]) }, '\xA0Postman Pro\xA0'), 'feature. Creating this workspace will activate your 7 day free trial of Postman Pro.'));







  }

  showTooltip() {
    this.setState({ isTooltipVisible: true });
  }

  hideTooltip() {
    this.setState({ isTooltipVisible: false });
  }

  renderAlert() {
    let alertProps = null;
    if (this.props.showConversionAlert) {
      alertProps = {
        type: 'info',
        isDismissable: false,
        message: 'This workspace will be converted to a team workspace' };

    }

    if (this.props.inviteLinkState === __WEBPACK_IMPORTED_MODULE_13__constants_InviteLinkStateConstants__["b" /* ERROR */]) {
      alertProps = {
        type: 'error',
        message: this.props.inviteErrorMessage };

    }

    if (!alertProps) {
      return;
    }

    return __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__messaging_Alert__["a" /* default */], _extends({ className: 'share-workspace-modal__alert' }, alertProps));
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-workspace-modal__contents' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-workspace__input-group' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-workspace__input-group__label' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-workspace__input-group__left-label' }, 'Enter name or email address'),



            this.props.isProUser &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-workspace__input-group__team-size' }, 'Team Size: ',
              this.getTeamSize(),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null,
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
                    className: 'create-new-workspace__input-group__add-slots',
                    type: 'text',
                    onClick: __WEBPACK_IMPORTED_MODULE_8__models_services_DashboardService__["r" /* openTeam */] }, 'Manage Team')))),








          !this.props.canManageTeamInvites &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'create-new-workspace__input-group--subtitle' }, 'Add existing members or suggest new members to your team admin'),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-workspace__input-group__input' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_InviteUsers__["a" /* default */], {
              allRoles: this.props.allRoles,
              teamCurrentRole: this.props.teamCurrentRole,
              userCurrentRoles: this.props.userCurrentRoles,
              defaultRoles: this.props.defaultRoles,
              superRoles: this.props.superRoles,
              canAddMember: this.props.canAddMember,
              canRemoveMember: this.props.canRemoveMember,
              canUpdateRoles: this.props.canUpdateRoles,
              users: this.props.users,
              onChange: this.handleChange,
              onAddMember: this.props.onAddMember,
              onRemoveMember: this.props.onRemoveMember,
              isDeleteActionEnabled: isDeleteActionEnabled,
              allowInvites: this.props.allowInvites,
              handleEmailError: this.handleEmailError,
              limitVisibility: this.props.limitVisibility,
              canManageTeamInvites: this.props.canManageTeamInvites })),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-workspace-modal__subtext' },
            this.getSubText(),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_9__invite_flows_InviteLink__["a" /* default */], {
              canManageTeamInvites: this.props.canManageTeamInvites,
              entity: this.props.entity,
              isGenerated: this.props.inviteLinkState === __WEBPACK_IMPORTED_MODULE_13__constants_InviteLinkStateConstants__["d" /* GENERATED */],
              isLoading: this.props.inviteLinkState === __WEBPACK_IMPORTED_MODULE_13__constants_InviteLinkStateConstants__["e" /* LOADING */],
              inviteLink: this.props.inviteLink,
              onGetLink: this.props.onGetLink,
              onCopyLink: this.props.onCopyLink,
              renderAlert: this.renderAlert }),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_12__WorkspaceVisibility__["a" /* default */], {
              allRoles: this.props.allRoles,
              teamCurrentRole: this.props.teamCurrentRole,
              canUpdateRoles: this.props.canUpdateRoles,
              hideTooltip: this.hideTooltip,
              isLimitingVisibilityEnabled: this.props.isLimitingVisibilityEnabled,
              isTooltipVisible: this.state.isTooltipVisible,
              limitVisibility: this.props.limitVisibility,
              onChange: this.handleChange,
              onVisibilityChange: this.props.onVisibilityChange,
              showTooltip: this.showTooltip })))));





  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5079:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__modules_controllers_WorkspaceController__ = __webpack_require__(56);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__modules_controllers_WorkspaceSessionController__ = __webpack_require__(106);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__common_controllers_WindowController__ = __webpack_require__(154);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__common_controllers_WindowController___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3__common_controllers_WindowController__);





/**
                                                                           * @description open a startup modal based on the priority
                                                                           *
                                                                           */
/* harmony default export */ __webpack_exports__["a"] = (async function openStartupModal() {
  // Workspace Intro Modal (for V6), will be removed later
  let activeWindow,
  activeSession,
  joinedWorkspace;

  try {
    activeWindow = await __WEBPACK_IMPORTED_MODULE_3__common_controllers_WindowController___default.a.getCurrentWindow();
    activeSession = await __WEBPACK_IMPORTED_MODULE_2__modules_controllers_WorkspaceSessionController__["a" /* default */].get({ id: activeWindow.activeSession });
    joinedWorkspace = await __WEBPACK_IMPORTED_MODULE_1__modules_controllers_WorkspaceController__["a" /* default */].get({ id: activeSession.workspace });
  }
  catch (e) {
    pm.logger.error('Error in StartupModalHandler', e);
    return;
  }

  // CNX Modal
  let showCNXModal = !pm.env.SKIP_STARTUP_MODELS &&
  _.isUndefined(pm.settings.getSetting('showCreateNewXModalOnStartup')) ? true : pm.settings.getSetting('showCreateNewXModalOnStartup');

  if (showCNXModal && !_.isEmpty(joinedWorkspace)) {
    pm.mediator.trigger('openCreateNewXModal');
  }
});
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5080:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return InviteModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_base_LoadingIndicator__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_base_InviteUsers__ = __webpack_require__(3624);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7_mobx__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__components_messaging_Alert__ = __webpack_require__(1490);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__utils_default_workspace__ = __webpack_require__(136);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__constants_AppUrlConstants__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__constants_UIEventConstants__ = __webpack_require__(217);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__modules_services_UserInvitationService__ = __webpack_require__(3626);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__modules_services_share_entities_ShareEntitiesService__ = __webpack_require__(3594);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__components_invite_flows_InviteLink__ = __webpack_require__(4028);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__constants_InviteLinkStateConstants__ = __webpack_require__(3776);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__components_base_XPaths_XPath__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__services_UIEventService__ = __webpack_require__(79);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_20__constants_ShareFlowConstants__ = __webpack_require__(3625);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_21__modules_services_PermissionsService__ = __webpack_require__(3676);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _class;























const entityModelActionMap = {
  'Collection': __WEBPACK_IMPORTED_MODULE_13__modules_services_share_entities_ShareEntitiesService__["c" /* createTeamAndShareCollection */],
  'Environment': __WEBPACK_IMPORTED_MODULE_13__modules_services_share_entities_ShareEntitiesService__["d" /* createTeamAndShareEnvironment */] },

defaultState = {
  isOpen: false,
  userEmails: [],
  isLoading: false,
  inviteLinkState: __WEBPACK_IMPORTED_MODULE_17__constants_InviteLinkStateConstants__["a" /* EMPTY */],
  inviteErrorMessage: '',
  collectionId: '',
  workspaceId: '',
  showInviteDeniedError: false,
  isDefaultWorkspace: false,
  defaultTeamWorkspaceId: null,
  defaultUserWorkspaceId: null,
  permissions: {},
  invalidEmails: [] };let



InviteModalContainer = Object(__WEBPACK_IMPORTED_MODULE_6_mobx_react__["a" /* observer */])(_class = class InviteModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = _extends({},
    defaultState, {
      inviteLink: null });


    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleChange = this.handleChange.bind(this);
    this.handleMembersChange = this.handleMembersChange.bind(this);
    this.handleInvite = this.handleInvite.bind(this);
    this.handleEmailError = this.handleEmailError.bind(this);

    this.handleGetInviteLink = this.handleGetInviteLink.bind(this);

    this.renderAlert = this.renderAlert.bind(this);
  }

  componentWillMount() {
    this.unsubscribeHandler = __WEBPACK_IMPORTED_MODULE_19__services_UIEventService__["a" /* default */].subscribe(__WEBPACK_IMPORTED_MODULE_11__constants_UIEventConstants__["d" /* OPEN_INVITE_MODAL */], this.handleOpen);
  }

  componentWillUnmount() {
    this.unsubscribeHandler && this.unsubscribeHandler();
  }

  async handleOpen(options = {}) {
    try {
      let currentUser = Object(__WEBPACK_IMPORTED_MODULE_1__stores_get_store__["getStore"])('CurrentUserStore');

      // Don't care if the user is a non-signedIn user
      if (!currentUser.isLoggedIn) {
        pm.mediator.trigger('openInviteSignoutModal');
        return;
      }

      __WEBPACK_IMPORTED_MODULE_14__modules_services_AnalyticsService__["a" /* default */].addEvent('app', 'invite_user_opened', options.source);

      let userDefaultWorkspaceId = await Object(__WEBPACK_IMPORTED_MODULE_9__utils_default_workspace__["c" /* defaultUserWorkspaceId */])(),
      teamDefaultWorkspaceId = null;

      if (currentUser.teamSyncEnabled) {
        teamDefaultWorkspaceId = await Object(__WEBPACK_IMPORTED_MODULE_9__utils_default_workspace__["b" /* defaultTeamWorkspaceId */])();
      }

      let workspaceId = options.workspaceId || Object(__WEBPACK_IMPORTED_MODULE_1__stores_get_store__["getStore"])('ActiveWorkspaceStore').id,
      workspaceName = _.get(Object(__WEBPACK_IMPORTED_MODULE_1__stores_get_store__["getStore"])('WorkspaceStore').find(workspaceId), 'name', ''),
      isDefaultWorkspace = [userDefaultWorkspaceId, teamDefaultWorkspaceId].includes(workspaceId);

      this.setState({
        isOpen: true,
        workspaceId,
        collectionId: options.collection || '',
        environmentId: options.environment || '',
        workspaceName: workspaceName.toUpperCase(),
        isDefaultWorkspace,
        userDefaultWorkspaceId,
        teamDefaultWorkspaceId });


      this.fetchPermissions();
    }
    catch (e) {
      pm.logger.error(e);
      pm.toasts.error('Something went wrong while inviting the users.');
    }
  }

  async fetchPermissions() {
    let permissions = await Object(__WEBPACK_IMPORTED_MODULE_21__modules_services_PermissionsService__["a" /* fetchPermissions */])(['manageTeamInvites', 'sendUnapprovedInvites']);

    this.setState({ permissions });
  }

  handleMembersChange({ members }) {
    this.setState({ members });
  }

  handleClose() {
    _.isFunction(this.onOrganizationCreate) && this.onOrganizationCreate();
    _.isFunction(this.teamWorkspaceJoinReaction) && this.teamWorkspaceJoinReaction();
    this.setState(defaultState);
  }

  handleChange(field, value) {
    this.setState({ [field]: value });
  }

  handleInviteFlowsError(errorState) {
    let trialStatus = _.get(errorState, 'activate_trial', 0),
    workspaceStatus = _.get(errorState, 'create_workspace', 0);

    if (!trialStatus) {
      this.setState({ isLoading: false });
      pm.toasts.error('Something went wrong while activating the trial');
      return;
    }

    if (!workspaceStatus) {
      this.setState({ isLoading: false });
      pm.toasts.error('Something went wrong while creating the workspace');
      return;
    }
  }

  handleShareEntities(modelType, modelIntent, entityId, attachTeamCreationReaction = true) {
    attachTeamCreationReaction && this.continue('openSetupTeamModal');

    entityModelActionMap[modelType](entityId, this.getInvitedUsers()).
    then(response => {
      const { inviteLink } = response || {};

      this.setState({
        isLoading: attachTeamCreationReaction ? true : false,
        inviteLink,
        inviteLinkState: __WEBPACK_IMPORTED_MODULE_17__constants_InviteLinkStateConstants__["c" /* FREE_COLLAB_STARTED */] });


      __WEBPACK_IMPORTED_MODULE_14__modules_services_AnalyticsService__["a" /* default */].addEvent('app', `${modelIntent}`, 'user_invite', entityId);
      pm.toasts.success(`${modelType} shared with invited users`);
    }).
    catch(e => {
      pm.logger.error(e);

      this.setState({ isLoading: false });
      pm.toasts.error(_.get(e, 'message', 'Error in inviting users'));
      __WEBPACK_IMPORTED_MODULE_14__modules_services_AnalyticsService__["a" /* default */].addEvent('app', `${modelIntent}_failed`, 'user_invite', entityId);
      return;
    });
  }

  /**
     * Continue to perform the next action
     * Either open the setup team modal
     * or
     * If it is the default workspace then open the invitation sent modal
     */
  async continue(modal = null) {
    // If no team is there, wait for team to be created
    if (!Object(__WEBPACK_IMPORTED_MODULE_1__stores_get_store__["getStore"])('CurrentUserStore').team) {
      this.onOrganizationCreate = Object(__WEBPACK_IMPORTED_MODULE_7_mobx__["q" /* reaction */])(
      () => Object(__WEBPACK_IMPORTED_MODULE_1__stores_get_store__["getStore"])('CurrentUserStore').team,
      () => this.continue(modal));

      return;
    }

    let { teamDefaultWorkspaceId } = this.state;

    if (!teamDefaultWorkspaceId) {
      teamDefaultWorkspaceId = await Object(__WEBPACK_IMPORTED_MODULE_9__utils_default_workspace__["b" /* defaultTeamWorkspaceId */])();
      this.setState({ teamDefaultWorkspaceId });
    }

    // If the team workspace hasn't been joined,
    // wait for it to be joined
    if (!Object(__WEBPACK_IMPORTED_MODULE_1__stores_get_store__["getStore"])('WorkspaceStore').find(teamDefaultWorkspaceId)) {
      this.teamWorkspaceJoinReaction = Object(__WEBPACK_IMPORTED_MODULE_7_mobx__["q" /* reaction */])(
      () => Object(__WEBPACK_IMPORTED_MODULE_1__stores_get_store__["getStore"])('WorkspaceStore').find(teamDefaultWorkspaceId),
      () => this.continue(modal));

      return;
    }

    if (modal) {
      pm.mediator.trigger(modal);
    } else
    if (this.state.collectionId || this.state.environmentId || !this.state.isDefaultWorkspace) {
      pm.mediator.trigger('openSetupTeamModal');
    } else
    if (this.state.isDefaultWorkspace) {
      pm.mediator.trigger('openInvitationSentModal');
    }

    this.handleClose();
  }

  handleContinueSendingInvites({ workspaceId = null, closeAfterSendingInvites = false } = {}) {
    let team = Object(__WEBPACK_IMPORTED_MODULE_1__stores_get_store__["getStore"])('CurrentUserStore').team;

    if (!team || _.isEmpty(this.state.userEmails)) {
      // In case the emails in the state are empty then close the modal
      closeAfterSendingInvites ? this.handleClose() : this.continue();
      return;
    }

    let data = {
      workspaceId: workspaceId || this.state.workspaceId,
      emails: this.state.userEmails,
      teamId: team.id };


    __WEBPACK_IMPORTED_MODULE_14__modules_services_AnalyticsService__["a" /* default */].addEvent('app', 'invite_users', 'share_ws', null, { workspaceId: this.state.workspaceId });
    Object(__WEBPACK_IMPORTED_MODULE_12__modules_services_UserInvitationService__["c" /* inviteUsers */])(data, err => {
      if (err) {
        pm.logger.error(err);

        this.setState({ isLoading: false });

        __WEBPACK_IMPORTED_MODULE_14__modules_services_AnalyticsService__["a" /* default */].addEvent('app', 'invite_users_failed', 'share_ws', null, { workspaceId: this.state.workspaceId });
        pm.toasts.error(_.get(err, 'message', 'Something went wrong while inviting users'));
        return;
      }

      let refreshOrganizationEvent = {
        name: 'refreshOrganizations',
        namespace: 'user' };


      Object(__WEBPACK_IMPORTED_MODULE_15__modules_pipelines_user_action__["a" /* default */])(refreshOrganizationEvent).
      catch(e => {
        pm.logger.error('Error while refreshing organizations', e);
      });

      closeAfterSendingInvites ? this.handleClose() : this.continue();
    });
  }

  getSelectedWorkspace() {
    let selectedWorkspaceId = this.state.workspaceId,
    activeWorkspace = Object(__WEBPACK_IMPORTED_MODULE_1__stores_get_store__["getStore"])('ActiveWorkspaceStore');

    return selectedWorkspaceId ? Object(__WEBPACK_IMPORTED_MODULE_1__stores_get_store__["getStore"])('WorkspaceStore').find(selectedWorkspaceId) : activeWorkspace;
  }

  getInvitedUsers() {
    return _.map(this.state.userEmails, email => {return { email };});
  }

  handleErrorResponse(err, intent, entityId) {
    pm.logger.error(err);

    let newState = {
      isLoading: false,
      inviteLinkState: __WEBPACK_IMPORTED_MODULE_17__constants_InviteLinkStateConstants__["a" /* EMPTY */] };


    // The user was trying to generate the invite link during which the error came
    if (this.state.inviteLinkState === __WEBPACK_IMPORTED_MODULE_17__constants_InviteLinkStateConstants__["e" /* LOADING */]) {
      newState = _extends({},
      newState, {
        inviteLinkState: __WEBPACK_IMPORTED_MODULE_17__constants_InviteLinkStateConstants__["b" /* ERROR */] });

    }

    this.setState(newState);

    intent && __WEBPACK_IMPORTED_MODULE_14__modules_services_AnalyticsService__["a" /* default */].addEvent('app', `${intent}_failed`, 'user_invite', entityId);
    pm.toasts.error(_.get(err, 'error.message', 'Something went wrong while inviting users'));

    // The error state contains the status of the steps
    // whichever succeeded and failed while activating the trial
    // and inviting users to the workspace
    let errorState = _.get(err, 'error.state', null);
    if (errorState) {
      this.handleInviteFlowsError(errorState);
    }
  }

  handleEmailError({ showInviteDeniedError }) {
    this.setState({ showInviteDeniedError });
  }

  handleInvite({ attachTeamCreationReaction = true }) {
    if (!this.canSendInvites()) {
      return;
    }

    // In case the free collab started just now
    // and the user decides to continue
    if (this.state.inviteLinkState === __WEBPACK_IMPORTED_MODULE_17__constants_InviteLinkStateConstants__["c" /* FREE_COLLAB_STARTED */]) {
      this.setState({ isLoading: true });
      return this.handleContinueSendingInvites();
    }

    let currentUser = Object(__WEBPACK_IMPORTED_MODULE_1__stores_get_store__["getStore"])('CurrentUserStore');

    // In case the invite link has not been generated
    // then only check if the user has entered emails or not
    if (attachTeamCreationReaction && !this.state.inviteLink && _.isEmpty(this.state.userEmails)) {
      pm.toasts.error('Please add a user');
      return;
    }

    attachTeamCreationReaction && this.setState({ isLoading: true });

    // Opens the invite modal from collection share,
    // Here, we need to invite the users and share the collection at the same time
    if (this.state.collectionId) {
      this.handleShareEntities(
      'Collection',
      'share_col',
      this.state.collectionId,
      attachTeamCreationReaction);

      return;
    }

    // Opens the invite modal from environment share,
    // Here, we need to invite the users and share the environment at the same time
    if (this.state.environmentId) {
      this.handleShareEntities(
      'Environment',
      'share_env',
      this.state.environmentId,
      attachTeamCreationReaction);

      return;
    }

    // This means the current active workspace is the default workspace,
    // so you just need to start free collaboration || invite people to team workspace
    if (this.state.isDefaultWorkspace) {

      // This is a team user trying to invite people
      if (currentUser.teamSyncEnabled) {
        this.handleInviteUsersToTeam();
        return;
      }

      // Or just start the team
      this.handleStartTeam();
      return;
    }

    // Share the workspace which will activate the collaboration
    if (this.getSelectedWorkspace().type === 'personal') {
      this.handleSharePersonalWorkspace();
      return;
    }
  }

  handleStartTeam(attachTeamCreationReaction = true) {
    attachTeamCreationReaction && this.continue('openInvitationSentModal');
    Object(__WEBPACK_IMPORTED_MODULE_12__modules_services_UserInvitationService__["e" /* startTeamWithUsers */])({ invitations: this.getInvitedUsers() }, (err, response) => {
      if (err) {
        return this.handleErrorResponse(err, 'start_team');
      }

      const { inviteLink } = response || {};

      this.setState({
        isLoading: attachTeamCreationReaction ? true : false,
        inviteLink,
        inviteLinkState: __WEBPACK_IMPORTED_MODULE_17__constants_InviteLinkStateConstants__["c" /* FREE_COLLAB_STARTED */] });


      __WEBPACK_IMPORTED_MODULE_14__modules_services_AnalyticsService__["a" /* default */].addEvent('app', 'start_team', 'user_invite');
    });
  }

  async handleInviteUsersToTeam() {
    this.handleContinueSendingInvites({
      workspaceId: this.state.defaultTeamWorkspaceId,
      closeAfterSendingInvites: true });

  }

  handleSharePersonalWorkspace(attachTeamCreationReaction = true) {
    this.handleShareWorkspace(this.getSelectedWorkspace().id, attachTeamCreationReaction);
  }

  handleShareWorkspace(id, attachTeamCreationReaction = true) {
    if (!id) {
      this.setState({ isLoading: false });
      pm.toasts.success('Kindly provide workspace information to update');
      return;
    }

    let data = {
      workspace: {
        id,
        type: 'team' },

      emails: this.state.userEmails },

    isTeamUser = Object(__WEBPACK_IMPORTED_MODULE_1__stores_get_store__["getStore"])('CurrentUserStore').team;

    // Invite link flow, do not set state for loading
    attachTeamCreationReaction && this.setState({ isLoading: true });

    // Send analytics and attach reaction only for trial activation
    if (!isTeamUser) {
      __WEBPACK_IMPORTED_MODULE_14__modules_services_AnalyticsService__["a" /* default */].addEvent('app', 'share_ws', 'user_invite');

      // Invite link flow, do not attach reaction
      attachTeamCreationReaction && this.continue('openSetupTeamModal');
    }


    Object(__WEBPACK_IMPORTED_MODULE_12__modules_services_UserInvitationService__["a" /* activateTrialAndInviteUsers */])(data, 'shareWS', (err, response) => {
      if (err) {
        return this.handleErrorResponse(err, 'share_ws', this.getSelectedWorkspace().id);
      }

      const { inviteLink } = response || {};

      this.setState({
        isLoading: attachTeamCreationReaction ? true : false,
        inviteLink,
        inviteLinkState: __WEBPACK_IMPORTED_MODULE_17__constants_InviteLinkStateConstants__["c" /* FREE_COLLAB_STARTED */] });


      pm.toasts.success('Successfully invited people to the team');

      // Close this if it is a team user. other wise reaction will take care of the rest.
      if (attachTeamCreationReaction && isTeamUser) {
        this.handleClose();
      }

      return;
    });
  }

  handleGetInviteLink() {
    // In case the user doesn't have email invite privileges
    if (!this.canSendInvites()) {
      this.setState({
        inviteLinkState: __WEBPACK_IMPORTED_MODULE_17__constants_InviteLinkStateConstants__["b" /* ERROR */],
        inviteErrorMessage: __WEBPACK_IMPORTED_MODULE_20__constants_ShareFlowConstants__["u" /* PERMISSION_DENIED_ERROR */] });

      return;
    }

    if (this.state.inviteLinkState === __WEBPACK_IMPORTED_MODULE_17__constants_InviteLinkStateConstants__["e" /* LOADING */]) {
      return;
    }

    __WEBPACK_IMPORTED_MODULE_14__modules_services_AnalyticsService__["a" /* default */].addEvent('app', 'get_invite_link', 'share_ws', null, { workspaceId: this.state.workspaceId });

    this.setState({ inviteLinkState: __WEBPACK_IMPORTED_MODULE_17__constants_InviteLinkStateConstants__["e" /* LOADING */] });

    if (!Object(__WEBPACK_IMPORTED_MODULE_1__stores_get_store__["getStore"])('CurrentUserStore').teamSyncEnabled) {
      // In case this is a share collection / environment flow
      // then share it and get the link
      if (this.state.collectionId || this.state.environmentId) {
        // Handle Invite has handling for this flow
        return this.handleInvite({ attachTeamCreationReaction: false });
      }

      return this.state.isDefaultWorkspace ?
      this.handleStartTeam(false) :
      this.handleSharePersonalWorkspace(false);
    }

    Object(__WEBPACK_IMPORTED_MODULE_12__modules_services_UserInvitationService__["b" /* getTeamInviteLink */])((err, inviteLink) => {
      if (err || !inviteLink) {
        this.setState({
          inviteLinkState: __WEBPACK_IMPORTED_MODULE_17__constants_InviteLinkStateConstants__["b" /* ERROR */],
          inviteErrorMessage: _.get(err, 'message', 'Something went wrong while generating the link.') });


        return;
      }

      this.setState({ inviteLink, inviteLinkState: __WEBPACK_IMPORTED_MODULE_17__constants_InviteLinkStateConstants__["d" /* GENERATED */] });
    });
  }

  getCustomStyles() {
    return {
      maxHeight: '150vh',
      marginTop: '60px',
      width: '500px' };

  }

  getWarningMessage() {
    if (this.state.userDefaultWorkspaceId === this.state.workspaceId) {
      return `**My workspace** is your own personal space in Postman.
        Invite users to your team to collaborate with them.
        [Learn more](${__WEBPACK_IMPORTED_MODULE_10__constants_AppUrlConstants__["J" /* INVITE_TO_WORKSPACE */]})`;
    }
    return '';
  }

  getSubText(canManageTeamInvites) {
    if (this.state.showInviteDeniedError) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'invite-user-modal__email-privileges-denied' },
          __WEBPACK_IMPORTED_MODULE_20__constants_ShareFlowConstants__["u" /* PERMISSION_DENIED_ERROR */]));


    }

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'invite-user-workspace-meta-text' }, 'Inviting users will add them to your Postman team, if they\u2019re not already members.',

        !canManageTeamInvites && ' They\'ll join your team once your admin approves.'));


  }

  renderAlert() {
    if (this.state.inviteLinkState === __WEBPACK_IMPORTED_MODULE_17__constants_InviteLinkStateConstants__["b" /* ERROR */] && this.state.inviteErrorMessage) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__components_messaging_Alert__["a" /* default */], {
          type: 'error',
          message: this.state.inviteErrorMessage,
          className: 'invite-user-modal-alert' }));


    }

    return false;
  }

  getInviteLink(canSendInvites) {
    if (!this.state.inviteLink || !canSendInvites) {
      return null;
    }

    let link = this.state.inviteLink;
    if (link && !this.state.isDefaultWorkspace) {
      link = `${link}&ws=${this.state.workspaceId}`;
    }

    return link;
  }


  getButtonText() {
    if (this.state.isLoading) {
      return __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_base_LoadingIndicator__["a" /* default */], { className: 'loading-indicator-size' });
    }

    if (this.state.inviteLink && this.state.inviteLinkState === __WEBPACK_IMPORTED_MODULE_17__constants_InviteLinkStateConstants__["e" /* LOADING */]) {
      return 'Continue';
    }

    if ([__WEBPACK_IMPORTED_MODULE_17__constants_InviteLinkStateConstants__["e" /* LOADING */], __WEBPACK_IMPORTED_MODULE_17__constants_InviteLinkStateConstants__["a" /* EMPTY */], __WEBPACK_IMPORTED_MODULE_17__constants_InviteLinkStateConstants__["b" /* ERROR */]].includes(this.state.inviteLinkState)) {
      return this.state.isDefaultWorkspace ?
      'Invite to team' :
      'Invite Users';
    }

    return 'Continue';
  }

  canSendInvites() {
    let canManageTeamInvites = _.get(this.state.permissions, 'manageTeamInvites'),
    canSendUnapprovedInvites = _.get(this.state.permissions, 'sendUnapprovedInvites');

    return canManageTeamInvites || canSendUnapprovedInvites;
  }

  render() {
    let warningMessage = this.getWarningMessage(),
    isSocketConnected = Object(__WEBPACK_IMPORTED_MODULE_1__stores_get_store__["getStore"])('SyncStatusStore').isSocketConnected,
    canSendInvites = this.canSendInvites(),
    inviteLink = this.getInviteLink(canSendInvites),
    disableButton = !canSendInvites || this.state.isLoading || !isSocketConnected || !_.isEmpty(this.state.invalidEmails),
    canManageTeamInvites = _.get(this.state.permissions, 'manageTeamInvites'),
    buttonTooltipText = !_.isEmpty(this.state.invalidEmails) && 'You have added invalid emails, please remove them to continue.';

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_18__components_base_XPaths_XPath__["a" /* default */], { identifier: 'inviteModal', isVisible: this.state.isOpen },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["a" /* Modal */], {
            className: 'invite-user-modal',
            isOpen: this.state.isOpen,
            onRequestClose: this.handleClose,
            customStyles: this.getCustomStyles() },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["d" /* ModalHeader */], { className: 'invite-user-workspace-title' }, 'INVITE TO ',
            this.state.isDefaultWorkspace ? 'TEAM' : this.state.workspaceName),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["b" /* ModalContent */], null,

            warningMessage &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'invite-user-alert-container' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__components_messaging_Alert__["a" /* default */], {
                noIcon: true,
                type: 'info',
                message: warningMessage,
                isDismissable: false })),



            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-workspace__input-group' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-new-workspace__input-group__input' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_InviteUsers__["a" /* default */], {
                  disableTeamSuggestions: true,
                  hideRoles: true,
                  entity: 'team',
                  onAddMember: this.handleMembersChange,
                  onRemoveMember: this.handleMembersChange,
                  teamStats: this.props.teamStats,
                  allowInvites: canSendInvites,
                  onChange: this.handleChange,
                  handleEmailError: this.handleEmailError,
                  canManageTeamInvites: canManageTeamInvites }))),



            this.getSubText(canManageTeamInvites),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_16__components_invite_flows_InviteLink__["a" /* default */], {
              canManageTeamInvites: canManageTeamInvites,
              entity: 'team',
              isGenerated: _.includes([__WEBPACK_IMPORTED_MODULE_17__constants_InviteLinkStateConstants__["d" /* GENERATED */], __WEBPACK_IMPORTED_MODULE_17__constants_InviteLinkStateConstants__["c" /* FREE_COLLAB_STARTED */]], this.state.inviteLinkState),
              isLoading: this.state.inviteLinkState === __WEBPACK_IMPORTED_MODULE_17__constants_InviteLinkStateConstants__["e" /* LOADING */],
              inviteLink: inviteLink,
              onGetLink: this.handleGetInviteLink,
              renderAlert: this.renderAlert })),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["c" /* ModalFooter */], null,
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_18__components_base_XPaths_XPath__["a" /* default */], { identifier: 'invite' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Buttons__["a" /* Button */], {
                  className: 'button-large invite-team-button',
                  type: 'primary',
                  onClick: this.handleInvite,
                  disabled: disableButton,
                  tooltip: buttonTooltipText },

                this.getButtonText())),



            !this.state.inviteLinkState === __WEBPACK_IMPORTED_MODULE_17__constants_InviteLinkStateConstants__["c" /* FREE_COLLAB_STARTED */] &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_base_Buttons__["a" /* Button */], {
                type: 'secondary',
                onClick: this.handleClose }, 'Cancel')))));








  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5081:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return InvitationSentModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_invite_flows_TeamShareEntities__ = __webpack_require__(5082);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_invite_flows_TeamDetailsUpdate__ = __webpack_require__(4029);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_base_Tabs__ = __webpack_require__(103);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__modules_services_APIService__ = __webpack_require__(174);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__modules_model_event__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__components_base_LoadingIndicator__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__utils_default_workspace__ = __webpack_require__(136);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__components_base_XPaths_XPath__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__services_UIEventService__ = __webpack_require__(79);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__constants_UIEventConstants__ = __webpack_require__(217);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__services_WorkspaceSwitchService__ = __webpack_require__(659);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__modules_services_share_entities_ShareEntitiesService__ = __webpack_require__(3594);
var _class;



















const entityStore = {
  collection: Object(__WEBPACK_IMPORTED_MODULE_12__stores_get_store__["getStore"])('CollectionStore'),
  environment: Object(__WEBPACK_IMPORTED_MODULE_12__stores_get_store__["getStore"])('EnvironmentStore') };let



InvitationSentModalContainer = Object(__WEBPACK_IMPORTED_MODULE_1_mobx_react__["a" /* observer */])(_class = class InvitationSentModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      loading: false,
      activeTab: 'share',
      teamName: '',
      teamUrl: '',
      collections: [],
      environments: [] };


    this.handleOpen = this.handleOpen.bind(this, false);
    this.handleClose = this.handleClose.bind(this, true);
    this.handleModalAction = this.handleModalAction.bind(this);
    this.share = this.share.bind(this);
    this.teamUpdate = this.teamUpdate.bind(this);
    this.handleCancel = this.handleCancel.bind(this);
    this.handleTeamDetailsUpdate = this.handleTeamDetailsUpdate.bind(this);
    this.handleShareEntitiesUpdate = this.handleShareEntitiesUpdate.bind(this);
    this.getModelActionText = this.getModelActionText.bind(this);
  }

  componentDidMount() {
    pm.mediator.on('openInvitationSentModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('openInvitationSentModal', this.handleOpen);
  }

  handleOpen() {
    Object(__WEBPACK_IMPORTED_MODULE_11__utils_default_workspace__["b" /* defaultTeamWorkspaceId */])().then(defaultTeamWorkspaceId => {
      this.setState({
        isOpen: true,
        defaultTeamWorkspaceId: defaultTeamWorkspaceId });

    });
  }

  handleClose() {
    this.setState({
      isOpen: false,
      defaultTeamWorkspaceId: null,
      activeTab: 'share' });

  }

  getStyles() {
    return {
      marginTop: '10vh',
      height: '80vh',
      minWidth: '760px',
      width: '60vw' };

  }

  switchToTeamWorkspace() {
    // Switch to default team workspace
    return __WEBPACK_IMPORTED_MODULE_16__services_WorkspaceSwitchService__["a" /* default */].switchWorkspace(this.state.defaultTeamWorkspaceId).
    catch(err => {
      pm.logger.error('InvitationSentModalContainer~switchToTeamWorkspace: Error in switching workspace', err);
    });
  }

  handleModalAction() {
    if (this.state.activeTab === 'share') {
      // Switch to team workspace
      this.switchToTeamWorkspace();

      this.bulkShareEntities();
      return;
    }

    this.teamUpdate();
  }

  bulkShareEntities() {
    this.setState({ loading: true });
    this.share();
  }

  share() {
    let getModelIdMap = (m, e) => _.map(e, entityId => {
      let uid = _.get(entityStore[m].find(entityId), 'uid');
      return { model: m, modelId: uid };
    }),
    collectionsToAdd = getModelIdMap('collection', this.state.collections),
    environmentsToAdd = getModelIdMap('environment', this.state.environments),
    entities = _.concat(collectionsToAdd, environmentsToAdd);

    if (_.isEmpty(entities)) {
      this.setState({ loading: false, activeTab: 'setup' });
      return;
    }

    Object(__WEBPACK_IMPORTED_MODULE_17__modules_services_share_entities_ShareEntitiesService__["g" /* shareEntities */])(
    entities,
    this.state.defaultTeamWorkspaceId,
    { origin: 'invitation_sent_modal' }).
    then(() => {
      this.onLifecycleChange && this.onLifecycleChange(); // destruct the reaction
      this.setState({ loading: false, activeTab: 'setup' });
    }).
    catch(e => {
      pm.toasts.error('Something went wrong in sharing entities');
      this.setState({ loading: false, activeTab: 'setup' });
    });
  }

  teamUpdate() {
    if (!this.state.teamName || !this.state.teamUrl) {
      pm.toasts.error('Please enter team name and team url');
      return;
    }
    this.setState({ loading: true });
    let user = Object(__WEBPACK_IMPORTED_MODULE_12__stores_get_store__["getStore"])('CurrentUserStore'),
    teamId = user.team.id,
    team_name = this.state.teamName,
    domain = this.state.teamUrl;

    Object(__WEBPACK_IMPORTED_MODULE_7__modules_services_APIService__["z" /* updateTeamDetails */])({ team_name, domain, organizationId: teamId, user: user }, err => {
      this.setState({ loading: false });
      if (err) {
        pm.toasts.error(err.message);
        return;
      }
      let refreshOrganizationEvent = Object(__WEBPACK_IMPORTED_MODULE_8__modules_model_event__["a" /* createEvent */])('refreshOrganizations', 'user');

      Object(__WEBPACK_IMPORTED_MODULE_9__modules_pipelines_user_action__["a" /* default */])(refreshOrganizationEvent);
      pm.toasts.success('Team details updated successfully');
      __WEBPACK_IMPORTED_MODULE_14__services_UIEventService__["a" /* default */].publish(__WEBPACK_IMPORTED_MODULE_15__constants_UIEventConstants__["h" /* TEAM_DETAILS_UPDATED */]);
      this.handleClose();
    });
  }

  handleCancel() {
    this.setState({ loading: false });
    if (this.state.activeTab === 'share') {
      this.setState({ activeTab: 'setup' });
      return;
    }
    this.handleClose();
  }

  handleShareEntitiesUpdate(entityObj) {
    this.setState({ collections: entityObj.collections, environments: entityObj.environments });
  }

  handleTeamDetailsUpdate(teamDetails) {
    this.setState({ teamName: teamDetails.teamName, teamUrl: teamDetails.teamUrl });
  }

  getModelActionText() {
    if (this.state.loading) {
      return __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__components_base_LoadingIndicator__["a" /* default */], { className: 'loading-indicator-size' });
    }
    if (this.state.activeTab === 'setup') {
      return 'Save';
    }
    return 'Share';
  }

  getFreeTeamWarningMessage() {
    return 'Free teams have a limit on number of requests that can be shared with the team. If you happen to go beyond this limit, your collections might get archived.';
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_13__components_base_XPaths_XPath__["a" /* default */], { identifier: 'invitationSentModal', isVisible: this.state.isOpen },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["a" /* Modal */], {
            className: 'share-entity-model',
            isOpen: this.state.isOpen,
            onRequestClose: this.handleClose,
            customStyles: this.getStyles() },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["d" /* ModalHeader */], { className: 'share-entity-model-header' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'title' }, 'INVITATION SENT')),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["b" /* ModalContent */], { className: 'share-collection-modal-container' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_Tabs__["b" /* Tabs */], {
                type: 'primary',
                defaultActive: 'share',
                activeRef: this.state.activeTab },

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_Tabs__["a" /* Tab */], { refKey: 'share' }, 'Share collections'),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_base_Tabs__["a" /* Tab */], { refKey: 'setup' }, 'Setup your team')),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-entity-tab-content' },
              this.state.activeTab === 'share' &&
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_invite_flows_TeamShareEntities__["a" /* default */], {
                onChange: this.handleShareEntitiesUpdate,
                metaText: 'While you wait for your team members to join, you can start sharing collections with them in your team workspace.',
                warningMessage: this.getFreeTeamWarningMessage() }),



              this.state.activeTab === 'setup' &&
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_invite_flows_TeamDetailsUpdate__["a" /* default */], {
                onChange: this.handleTeamDetailsUpdate,
                metaText: 'Add a dash of personality to your team' }))),




          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["c" /* ModalFooter */], null,
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_13__components_base_XPaths_XPath__["a" /* default */], { identifier: 'save' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_base_Buttons__["a" /* Button */], {
                  className: 'button-large',
                  type: 'primary',
                  onClick: this.handleModalAction,
                  disabled: this.state.loading },


                this.getModelActionText())),



            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_base_Buttons__["a" /* Button */], {
                type: 'secondary',
                onClick: this.handleCancel,
                disabled: this.state.loading },


              this.state.activeTab === 'setup' ? 'Cancel' : 'Skip')))));






  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5082:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return TeamShareEntities; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Dropdowns__ = __webpack_require__(31);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Tabs__ = __webpack_require__(103);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__utils_uid_helper__ = __webpack_require__(85);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__empty_states_AddToWorkspaceEmpty__ = __webpack_require__(4027);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__messaging_Alert__ = __webpack_require__(1490);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__base_XPaths_XPath__ = __webpack_require__(24);
var _class;









let

TeamShareEntities = Object(__WEBPACK_IMPORTED_MODULE_1_mobx_react__["a" /* observer */])(_class = class TeamShareEntities extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      loading: false,
      selectedWorkspace: '',
      selectedCollections: [],
      selectedEnvironments: [],
      activeTab: 'collections',
      isAllCollectionSelected: false,
      isAllEnvironmentSelected: false };


    this.handleWorkspaceSelect = this.handleWorkspaceSelect.bind(this);
    this.handleSelectAllCollection = this.handleSelectAllCollection.bind(this);
    this.handleSelectAllEnvironments = this.handleSelectAllEnvironments.bind(this);
    this.getCollections = this.getCollections.bind(this);
    this.getEnvironments = this.getEnvironments.bind(this);
    this.getWorkspacesList = this.getWorkspacesList.bind(this);
  }

  handleCollectionSelect(id) {
    let selectedCollections = [];
    if (_.includes(this.state.selectedCollections, id)) {
      selectedCollections = _.filter(this.state.selectedCollections, itemId => {return itemId !== id;});
    } else
    {
      selectedCollections = this.state.selectedCollections;
      selectedCollections.push(id);
    }
    this.setState({ selectedCollections });
    this.props.onChange && this.props.onChange({ collections: selectedCollections, environments: this.state.selectedEnvironments });
  }

  handleEnvironmentSelect(id) {
    let selectedEnvironments = [];
    if (_.includes(this.state.selectedEnvironments, id)) {
      selectedEnvironments = _.filter(this.state.selectedEnvironments, itemId => {return itemId !== id;});
    } else
    {
      selectedEnvironments = _.concat(this.state.selectedEnvironments, id);
    }
    this.setState({ selectedEnvironments });
    this.props.onChange && this.props.onChange({ collections: this.state.selectedCollections, environments: selectedEnvironments });
  }

  handleSelectAllCollection() {
    let selectedCollections = [],
    isAllCollectionSelected = !this.state.isAllCollectionSelected;

    if (isAllCollectionSelected) {
      selectedCollections = this.getCollections(this.state.selectedWorkspace).collectionIds;
    }
    this.setState({ selectedCollections, isAllCollectionSelected });
    this.props.onChange && this.props.onChange({ collections: selectedCollections, environments: this.state.selectedEnvironments });
  }

  handleSelectAllEnvironments() {
    let selectedEnvironments = [],
    isAllEnvironmentSelected = !this.state.isAllEnvironmentSelected;

    if (isAllEnvironmentSelected) {
      selectedEnvironments = this.getEnvironments(this.state.selectedWorkspace).environmentIds;
    }
    this.setState({ selectedEnvironments, isAllEnvironmentSelected });
    this.props.onChange && this.props.onChange({ collections: this.state.selectedCollections, environments: selectedEnvironments });
  }

  getCollections(workspace) {
    if (!workspace) {
      return [];
    }

    let uids = Object(__WEBPACK_IMPORTED_MODULE_2__stores_get_store__["getStore"])('WorkspaceStore').find(workspace).dependencies.collections || [],
    rendered = [],
    collectionIds = [];

    _.forEach(uids, uid => {
      let modelId = Object(__WEBPACK_IMPORTED_MODULE_7__utils_uid_helper__["a" /* decomposeUID */])(uid).modelId,
      collectionStore = Object(__WEBPACK_IMPORTED_MODULE_2__stores_get_store__["getStore"])('CollectionStore').find(modelId);

      if (!collectionStore) {
        return;
      }
      let name = collectionStore.name;

      collectionIds.push(modelId);

      rendered.push(
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
          key: uid,
          className: 'entity-checkbox-item-container',
          onClick: this.handleCollectionSelect.bind(this, modelId) },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Inputs__["a" /* Checkbox */], { className: 'entity-item-checkbox', checked: _.includes(this.state.selectedCollections, modelId) }),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'entity-checkbox-item-meta' }, name)));


    });

    return {
      rendered,
      collectionIds };

  }

  getEnvironments(workspace) {
    if (!workspace) {
      return [];
    }

    let uids = Object(__WEBPACK_IMPORTED_MODULE_2__stores_get_store__["getStore"])('WorkspaceStore').find(workspace).dependencies.environments || [],
    rendered = [],
    environmentIds = [];

    _.forEach(uids, uid => {
      let modelId = Object(__WEBPACK_IMPORTED_MODULE_7__utils_uid_helper__["a" /* decomposeUID */])(uid).modelId,
      environmentStore = Object(__WEBPACK_IMPORTED_MODULE_2__stores_get_store__["getStore"])('EnvironmentStore').find(modelId);

      if (!environmentStore) {
        return;
      }
      let name = environmentStore.name;

      environmentIds.push(uid);
      rendered.push(
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
          key: uid,
          className: 'entity-checkbox-item-container',
          onClick: this.handleEnvironmentSelect.bind(this, uid) },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Inputs__["a" /* Checkbox */], { className: 'entity-item-checkbox', checked: _.includes(this.state.selectedEnvironments, uid) }),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'entity-checkbox-item-meta' }, name)));


    });
    return {
      rendered,
      environmentIds };

  }

  getWorkspacesList() {
    return _.map(Object(__WEBPACK_IMPORTED_MODULE_2__stores_get_store__["getStore"])('WorkspaceStore').values, workspace => {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Dropdowns__["d" /* MenuItem */], { refKey: workspace.id, key: workspace.id },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'dropdown-menu-item__text' }, workspace.name)));


    });
  }

  handleTabChange(source, activeTab) {
    this.setState({ activeTab });
  }
  handleWorkspaceSelect(selectedWorkspace) {
    this.setState({ selectedWorkspace });
  }

  getWorkspaceName(workspace) {
    if (!workspace) {
      return 'Select a workspace';
    }
    return Object(__WEBPACK_IMPORTED_MODULE_2__stores_get_store__["getStore"])('WorkspaceStore').find(workspace).name;
  }

  render() {
    let workspaceList = Object(__WEBPACK_IMPORTED_MODULE_2__stores_get_store__["getStore"])('WorkspaceStore').values,
    selectedWorkspace = this.state.selectedWorkspace,
    collections = this.getCollections(selectedWorkspace).rendered;

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__base_XPaths_XPath__["a" /* default */], { identifier: 'shareEntities' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'tab-share-content' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'tab-share-content-meta-text' }, this.props.metaText),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-collections-content-container' },

            workspaceList.length > 0 ?
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-selector-container' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-selector' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-selector-label' }, 'Share from'),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-selector-dropdown-container' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__base_XPaths_XPath__["a" /* default */], { identifier: 'selectWorkspace' },
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-selector-value' },
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Dropdowns__["a" /* Dropdown */], { onSelect: this.handleWorkspaceSelect },
                        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Dropdowns__["b" /* DropdownButton */], { type: 'secondary', size: 'small' },
                          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Buttons__["a" /* Button */], null, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, this.getWorkspaceName(selectedWorkspace)))),

                        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Dropdowns__["c" /* DropdownMenu */], { fluid: true },

                          this.getWorkspacesList())))),





                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-selector-meta-container' },
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-selector-meta' }, 'Select a workspace to share from'))))) :




            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__empty_states_AddToWorkspaceEmpty__["a" /* default */], null),

            selectedWorkspace &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'select-workspace-entity-container' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Tabs__["b" /* Tabs */], {
                  type: 'primary',
                  defaultActive: 'collections',
                  activeRef: this.state.activeTab,
                  onChange: this.handleTabChange.bind(this, 'subTab') },

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Tabs__["a" /* Tab */], { refKey: 'collections' }, 'Collections'),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Tabs__["a" /* Tab */], { refKey: 'environments' }, 'Environments')),


              this.state.activeTab === 'collections' &&
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'tab-share-content--subtab-entity' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__base_XPaths_XPath__["a" /* default */], { identifier: 'selectEntities' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'entity-list-container-wrapper' },
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'entity-list-container' },

                      collections.length > 0 ?
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
                        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
                            key: 'all',
                            className: 'entity-checkbox-item-container',
                            onClick: this.handleSelectAllCollection },

                          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Inputs__["a" /* Checkbox */], { className: 'entity-item-checkbox', checked: this.state.isAllCollectionSelected }),
                          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'entity-checkbox-item-meta' }, 'All collections')),

                        collections) :

                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'entity-empty-text' }, 'There is no collections in this workspace')))),





                (this.state.selectedCollections.length > 0 || this.state.selectedEnvironments.length > 0) &&
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'entity-selection-meta-container' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'entity-selection-meta' }, this.state.selectedCollections.length, ' collections and ', this.state.selectedEnvironments.length, ' environments selected'))),





              this.state.activeTab === 'environments' &&
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'tab-share-content--subtab-entity' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__base_XPaths_XPath__["a" /* default */], { identifier: 'selectEntities' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'entity-list-container-wrapper' },
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'entity-list-container' },

                      this.getEnvironments(selectedWorkspace).rendered.length > 0 ?
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
                        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
                            key: 'all',
                            className: 'entity-checkbox-item-container',
                            onClick: this.handleSelectAllEnvironments },

                          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Inputs__["a" /* Checkbox */], { className: 'entity-item-checkbox', checked: this.state.isAllEnvironmentSelected }),
                          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'entity-checkbox-item-meta' }, 'All Environments')),

                        this.getEnvironments(selectedWorkspace).rendered) :

                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'entity-empty-text' }, 'There is no environments in this workspace')))),





                (this.state.selectedCollections.length > 0 || this.state.selectedEnvironments.length > 0) &&
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'entity-selection-meta-container' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'entity-selection-meta' }, this.state.selectedCollections.length, ' collections and ', this.state.selectedEnvironments.length, ' environments selected'))))),







          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-collections-content-container_warning-text' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_9__messaging_Alert__["a" /* default */], {
              message: this.props.warningMessage,
              type: 'success',
              isDismissable: false,
              onMessageLinkClick: this.props.onMessageLinkClick })))));





  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5083:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SignedOutInviteModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_invite_flows_InviteSignedOutModal__ = __webpack_require__(5084);

let

SignedOutInviteModalContainer = class SignedOutInviteModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.state = { isOpen: false };
    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('openInviteSignoutModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('openInviteSignoutModal', this.handleOpen);
  }

  handleOpen() {
    this.setState({ isOpen: true });
  }

  handleClose() {
    this.setState({ isOpen: false });
  }


  getCustomStyles() {
    return {
      maxHeight: '90vh',
      marginTop: '7vh' };

  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_invite_flows_InviteSignedOutModal__["a" /* default */], {
        isOpen: this.state.isOpen,
        onClose: this.handleClose }));


  }};

/***/ }),

/***/ 5084:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return InviteSignedOutModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_services_AuthHandlerService__ = __webpack_require__(532);



let

InviteSignedOutModal = class InviteSignedOutModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.handleSignIn = this.handleSignIn.bind(this);
    this.handleSignUp = this.handleSignUp.bind(this);
  }

  handleSignIn() {
    this.props.onClose && this.props.onClose();
    __WEBPACK_IMPORTED_MODULE_3__modules_services_AuthHandlerService__["a" /* default */].login();
  }

  handleSignUp() {
    this.props.onClose && this.props.onClose();
    __WEBPACK_IMPORTED_MODULE_3__modules_services_AuthHandlerService__["a" /* default */].login({ isSignup: true });
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["a" /* Modal */], {
          className: 'invite-signed-out-modal',
          isOpen: this.props.isOpen,
          onRequestClose: this.props.onClose },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["d" /* ModalHeader */], null, 'Sign in to invite'),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'disabled-operation-modal' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'disabled-operation-modal__icon' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'disabled-operation-modal__icon__icon' })),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'disabled-operation-modal__title' }, 'Sign in to invite'),



            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'disabled-operation-modal__subtitle' }, 'You need to be signed in to be able to invite people to collaborate with you.'),



            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'disabled-operation-modal__actions' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
                  type: 'primary',
                  onClick: this.handleSignIn }, 'Sign in'),



              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], {
                  type: 'primary',
                  onClick: this.handleSignUp }, 'Create an account'))))));








  }};

/***/ }),

/***/ 5085:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SetupTeamContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_pipelines_app_action__ = __webpack_require__(314);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__modules_model_event__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__modules_services_APIService__ = __webpack_require__(174);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__components_base_LoadingIndicator__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__components_invite_flows_TeamDetailsUpdate__ = __webpack_require__(4029);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__utils_default_workspace__ = __webpack_require__(136);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__services_WorkspaceSwitchService__ = __webpack_require__(659);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12_mobx__ = __webpack_require__(6);












let

SetupTeamContainer = class SetupTeamContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      loading: false,
      teamName: '',
      teamUrl: '' };


    this.handleToggle = this.handleToggle.bind(this);
    this.handleOpen = this.handleToggle.bind(this, false);
    this.handleClose = this.handleToggle.bind(this, true);
    this.handleCancel = this.handleCancel.bind(this, true);
    this.handleTeamDetailsUpdate = this.handleTeamDetailsUpdate.bind(this);
    this.teamUpdate = this.teamUpdate.bind(this);
    this.updateTeamDetails = this.updateTeamDetails.bind(this);
  }

  componentDidMount() {
    pm.mediator.on('openSetupTeamModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('openSetupTeamModal', this.handleOpen);
  }

  getStyles() {
    return {
      marginTop: '10vh',
      height: '70vh',
      minWidth: '760px',
      width: '60vw`' };

  }

  handleToggle(value = this.state.isOpen, activeTab = this.state.activeTab, callback) {
    !value && this.switchToTeamWorkspace();
    this.setState({
      isOpen: !value,
      activeTab },
    () => {
      _.isFunction(callback) && callback();
    });
  }

  handleCancel() {
    this.setState({ loading: false });
    this.handleClose();
  }

  switchToTeamWorkspace() {
    Object(__WEBPACK_IMPORTED_MODULE_10__utils_default_workspace__["c" /* defaultUserWorkspaceId */])().
    then(defaultWorkspaceId => {
      if (defaultWorkspaceId !== Object(__WEBPACK_IMPORTED_MODULE_8__stores_get_store__["getStore"])('ActiveWorkspaceStore').id) {
        // Do not switch to default team workspace
        // since the user shared a personal workspace
        return null;
      }

      // Switch to default team workspace
      return Object(__WEBPACK_IMPORTED_MODULE_10__utils_default_workspace__["b" /* defaultTeamWorkspaceId */])();
    }).
    then(defaultTeamWorkspaceId => {
      defaultTeamWorkspaceId &&
      __WEBPACK_IMPORTED_MODULE_11__services_WorkspaceSwitchService__["a" /* default */].switchWorkspace(defaultTeamWorkspaceId).
      catch(err => {
        pm.logger.error('SetupTeamContainer~switchToTeamWorkspace: Could not switch workspace.', err);
        return;
      });
    });
  }

  teamUpdate() {
    this.setState({ loading: true });
    let teamId = _.get(Object(__WEBPACK_IMPORTED_MODULE_8__stores_get_store__["getStore"])('CurrentUserStore'), 'team.id');

    if (!teamId) {
      let teamIdCreationDisposer = Object(__WEBPACK_IMPORTED_MODULE_12_mobx__["q" /* reaction */])(
      () => _.get(Object(__WEBPACK_IMPORTED_MODULE_8__stores_get_store__["getStore"])('CurrentUserStore'), 'team.id'),
      teamId => {
        if (teamId) {
          teamIdCreationDisposer();
          this.switchToTeamWorkspace();

          return this.updateTeamDetails(teamId);
        }
      });

    }

    return this.updateTeamDetails(teamId);
  }

  updateTeamDetails(teamId) {
    let user = Object(__WEBPACK_IMPORTED_MODULE_8__stores_get_store__["getStore"])('CurrentUserStore'),
    team_name = this.state.teamName,
    domain = this.state.teamUrl;

    Object(__WEBPACK_IMPORTED_MODULE_5__modules_services_APIService__["z" /* updateTeamDetails */])({ team_name, domain, organizationId: teamId, user: user }, (err, response) => {
      this.setState({ loading: false });
      if (err) {
        pm.toasts.error(err.message);
        return;
      }
      let refreshOrganizationEvent = Object(__WEBPACK_IMPORTED_MODULE_4__modules_model_event__["a" /* createEvent */])('refreshOrganizations', 'user');

      Object(__WEBPACK_IMPORTED_MODULE_7__modules_pipelines_user_action__["a" /* default */])(refreshOrganizationEvent);
      pm.toasts.success('Team details updated successfully');
      this.handleClose();
    });
  }

  handleTeamDetailsUpdate(teamDetails) {
    this.setState({ teamName: teamDetails.teamName, teamUrl: teamDetails.teamUrl });
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Modals__["a" /* Modal */], {
          className: 'share-entity-model',
          isOpen: this.state.isOpen,
          onRequestClose: this.handleClose,
          customStyles: this.getStyles() },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Modals__["d" /* ModalHeader */], { className: 'share-entity-model-header' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'title' }, 'Invitation sent')),



        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Modals__["b" /* ModalContent */], { className: 'share-collection-modal-container team-setup-container' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_9__components_invite_flows_TeamDetailsUpdate__["a" /* default */], {
            onChange: this.handleTeamDetailsUpdate,
            metaText: 'Add a dash of personality to your team' })),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Modals__["c" /* ModalFooter */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Buttons__["a" /* Button */], {
              className: 'button-large',
              type: 'primary',
              onClick: this.teamUpdate,
              disabled: this.state.loading || !_.trim(this.state.teamName) || !_.trim(this.state.teamUrl) },


            this.state.loading ?
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_base_LoadingIndicator__["a" /* default */], {
              className: 'loading-indicator-size' }) :
            'Save'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Buttons__["a" /* Button */], {
              type: 'text',
              onClick: this.handleCancel }, 'Cancel'))));






  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5086:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ContextualSignInModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_empty_states_ContextualSignInModal__ = __webpack_require__(5087);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__modules_services_SignInModalService__ = __webpack_require__(1499);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__modules_services_AuthHandlerService__ = __webpack_require__(532);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__modules_services_SignInEmptyStateService__ = __webpack_require__(5098);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__external_navigation_ExternalNavigationService__ = __webpack_require__(59);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _class;








const initialState = {
  type: 'invite',
  subtitle: '',
  carouselTitle: '',
  carouselData: [],
  learnMoreText: '',
  learnMoreLink: '',
  hasLargeContent: false,
  isOpen: false,
  isBackEnabled: false,
  loadingState: 'disabled',
  showDelayedError: false,
  isCloseEnabled: true,
  onBack: null,
  onLogin: null };let



ContextualSignInModalContainer = Object(__WEBPACK_IMPORTED_MODULE_3_mobx_react__["a" /* observer */])(_class = class ContextualSignInModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.state = _extends({}, initialState);

    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleBack = this.handleBack.bind(this);
    this.handleLearnMore = this.handleLearnMore.bind(this);
    this.attachEventHandlers = this.attachEventHandlers.bind(this);

    this.handleSkip = this.handleSkip.bind(this);
    this.handleSyncError = this.handleSyncError.bind(this);
    this.handleAuthenticated = this.handleAuthenticated.bind(this);
  }

  componentDidMount() {
    pm.mediator.on('showContextualSignInModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showContextualSignInModal', this.handleOpen);
  }

  /**
     * The user chose to skip the authentication flow
     * Stop the loading state
     */
  handleSkip() {
    this.setState({
      loadingState: 'disabled',
      isCloseEnabled: true });

  }

  /**
     * Called when sync connect times out
     * Sets the error state
     */
  handleSyncError() {
    this.setState({
      loadingState: 'error',
      isCloseEnabled: true });

  }

  /**
     * Called when the user signs in
     * Attaches sync event handler
     */
  handleAuthenticated() {
    this.disposeSyncEventHandler = Object(__WEBPACK_IMPORTED_MODULE_4__modules_services_SignInModalService__["b" /* attachSyncEventHandler */])({
      onSuccess: () => {
        this.state.onLogin();
        this.handleClose();
      },
      onError: this.handleSyncError });

  }

  attachEventHandlers() {
    this.disposeAuthEventHandlers = Object(__WEBPACK_IMPORTED_MODULE_4__modules_services_SignInModalService__["a" /* attachAuthEventHandler */])({
      onSignIn: this.handleAuthenticated,
      onSkipSignIn: this.handleSkip });

  }

  handleOpen(opts = {}) {
    let data = __WEBPACK_IMPORTED_MODULE_6__modules_services_SignInEmptyStateService__["a" /* getEmptyStateDataForType */](opts.type);

    this.setState(_extends({},
    data,
    opts, {
      isBackEnabled: _.isFunction(opts.onBack),
      isOpen: true }),
    this.attachEventHandlers);
  }

  handleClose() {
    // Dispose the event handlers that were attached before
    _.invoke(this, 'disposeAuthEventHandlers');
    _.invoke(this, 'disposeSyncEventHandler');


    // Reset the state back to the initial state
    this.setState(initialState);
  }

  handleBack() {
    // Call the callback if it was provided
    _.invoke(this.state, 'onBack');

    // Close the modal and get it back to initial state
    this.handleClose();
  }

  handleAuth(isSignup) {
    this.setState({
      loadingState: 'loading',
      isCloseEnabled: false });


    let action = isSignup ? 'initiate_create' : 'initiate_signin',
    label = `${this.state.from}_${this.state.type}_empty_state`;

    __WEBPACK_IMPORTED_MODULE_7__modules_services_AnalyticsService__["a" /* default */].addEvent(this.state.type, action, label);
    __WEBPACK_IMPORTED_MODULE_5__modules_services_AuthHandlerService__["a" /* default */].login({ isSignup });
  }

  handleLearnMore() {
    this.state.learnMoreLink && Object(__WEBPACK_IMPORTED_MODULE_8__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(this.state.learnMoreLink);
  }

  getStyles() {
    return {
      marginTop: '10vh',
      height: '75vh',
      minWidth: '760px',
      maxHeight: '570px',
      width: '80vw' };

  }

  getLoadingText() {
    switch (this.state.loadingState) {
      case 'loading':return 'Please Wait...';
      case 'error':
        return (
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, 'Something isn\u2019t right.', __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('br', null), 'Please close the modal and try later.'));

      default:return 'Please Wait...';}

  }

  isLoading() {
    return ['loading', 'error'].includes(this.state.loadingState);
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Modals__["a" /* Modal */], {
          className: 'contextual-sign-in-modal-container',
          isOpen: this.state.isOpen,
          onRequestClose: this.handleClose,
          customStyles: this.getStyles() },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Modals__["b" /* ModalContent */], null,

          this.isLoading() &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'contextual-sign-in-modal-container-loading' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'loader' }),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'loading-text' }, this.getLoadingText())),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_empty_states_ContextualSignInModal__["a" /* default */], _extends({},

          _.pick(this.state,
          [
          'type',
          'subtitle',
          'carouselTitle',
          'carouselData',
          'learnMoreText',
          'hasLargeContent',
          'isBackEnabled',
          'isCloseEnabled']), {



            onBack: this.handleBack,
            onClose: this.handleClose,
            onCreateAccount: this.handleAuth.bind(this, true),
            onSignIn: this.handleAuth.bind(this, false),
            onLearnMore: this.handleLearnMore })))));




  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5087:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ContextualSignInModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_prop_types__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_prop_types___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_prop_types__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Carousel__ = __webpack_require__(5088);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_Icons_LeftArrowIcon__ = __webpack_require__(1511);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_Icons_CloseIcon__ = __webpack_require__(90);






let

ContextualSignInModal = class ContextualSignInModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.state = { activeIndex: 0 };

    this.next = this.next.bind(this);
    this.previous = this.previous.bind(this);
    this.goToIndex = this.goToIndex.bind(this);
    this.onExiting = this.onExiting.bind(this);
    this.onExited = this.onExited.bind(this);

    this.handleClose = this.handleClose.bind(this);
    this.handleBack = this.handleBack.bind(this);
    this.handleCreateAccount = this.handleCreateAccount.bind(this);
    this.handleSignIn = this.handleSignIn.bind(this);
    this.handleLearnMore = this.handleLearnMore.bind(this);
  }

  onExiting() {
    this.animating = true;
  }

  onExited() {
    this.animating = false;
  }

  next() {
    if (this.animating) {
      return;
    }

    const nextIndex = this.state.activeIndex === this.props.carouselData.length - 1 ? 0 : this.state.activeIndex + 1;
    this.setState({ activeIndex: nextIndex });
  }

  previous() {
    if (this.animating) {
      return;
    }

    const nextIndex = this.state.activeIndex === 0 ? this.props.carouselData.length - 1 : this.state.activeIndex - 1;
    this.setState({ activeIndex: nextIndex });
  }

  goToIndex(newIndex) {
    if (this.animating) {
      return;
    }

    this.setState({ activeIndex: newIndex });
  }

  handleClose() {
    this.props.onClose && this.props.onClose();
  }

  handleBack() {
    this.props.onBack && this.props.onBack();
  }

  handleCreateAccount() {
    this.props.onCreateAccount && this.props.onCreateAccount();
  }

  handleSignIn() {
    this.props.onSignIn && this.props.onSignIn();
  }

  handleLearnMore() {
    this.props.onLearnMore && this.props.onLearnMore();
  }

  getLeftSectionImageClassnames() {
    return __WEBPACK_IMPORTED_MODULE_1_classnames___default()({
      'contextual-sign-in-modal__left-section--icon': true,
      [`contextual-sign-in-modal__left-section--${this.props.type}-icon`]: true });

  }

  getImageClassName(imageName) {
    return `contextual-sign-in-modal--${this.props.type}-${imageName}`;
  }

  getCarouselClasses() {
    return __WEBPACK_IMPORTED_MODULE_1_classnames___default()({
      'contextual-sign-in-modal__right-section--carousel': true,
      'is-small': !this.props.hasLargeContent });

  }

  getCloseIconClasses() {
    return __WEBPACK_IMPORTED_MODULE_1_classnames___default()({
      'contextual-sign-in-modal__right-section--close-icon': true,
      'is-enabled': this.props.isCloseEnabled });

  }

  render() {
    const { activeIndex } = this.state;

    const slides = this.props.carouselData.map(item => {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Carousel__["e" /* CarouselItem */], {
            onExiting: this.onExiting,
            onExited: this.onExited,
            key: item.imageName },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: this.getImageClassName(item.imageName) }),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Carousel__["b" /* CarouselCaption */], { captionText: item.caption })));


    });

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'contextual-sign-in-modal' },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('section', { className: 'contextual-sign-in-modal__left-section' },

          this.props.isBackEnabled &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'contextual-sign-in-modal__left-section--back-icon' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Icons_LeftArrowIcon__["a" /* default */], { onClick: this.handleBack })),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: this.getLeftSectionImageClassnames() }),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'contextual-sign-in-modal__left-section--title' }, 'Create an account to continue'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'contextual-sign-in-modal__left-section--subtitle' },
            this.props.subtitle),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Buttons__["a" /* Button */], {
              className: 'contextual-sign-in-modal__left-section--create-btn',
              type: 'primary',
              onClick: this.handleCreateAccount }, 'Create a free account'),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'contextual-sign-in-modal__separator-block' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'contextual-sign-in-modal__separator-block--separator' }),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'contextual-sign-in-modal__separator-block--separator-text' }, 'OR'),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'contextual-sign-in-modal__separator-block--separator' })),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Buttons__["a" /* Button */], {
              type: 'text',
              onClick: this.handleSignIn }, 'Sign In')),





        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('section', { className: 'contextual-sign-in-modal__right-section' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: this.getCloseIconClasses() },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Icons_CloseIcon__["a" /* default */], { onClick: this.handleClose })),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'contextual-sign-in-modal__right-section--title' },
            this.props.carouselTitle),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: this.getCarouselClasses() },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Carousel__["a" /* Carousel */], {
                activeIndex: activeIndex,
                next: this.next,
                previous: this.previous,
                interval: false },

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Carousel__["c" /* CarouselControl */], {
                direction: 'prev',
                onClickHandler: this.previous }),

              slides,
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Carousel__["c" /* CarouselControl */], {
                direction: 'next',
                onClickHandler: this.next }),

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Carousel__["d" /* CarouselIndicators */], {
                items: this.props.carouselData,
                activeIndex: activeIndex,
                onClickHandler: this.goToIndex }))),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Buttons__["a" /* Button */], {
              className: 'contextual-sign-in-modal__right-section--learn-more',
              type: 'tertiary',
              onClick: this.handleLearnMore },

            this.props.learnMoreText))));




  }};


ContextualSignInModal.propTypes = {
  type: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.oneOf(['invite', 'mock', 'monitor', 'documentation']),
  subtitle: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.string,
  carouselTitle: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.string,
  carouselData: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.array.isRequired,
  learnMoreText: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.string,
  hasLargeContent: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.bool,
  isBackEnabled: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.bool,
  isCloseEnabled: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.bool,
  onBack: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.func.isRequired,
  onClose: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.func.isRequired,
  onCreateAccount: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.func.isRequired,
  onSignIn: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.func.isRequired,
  onLearnMore: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.func };

/***/ }),

/***/ 5088:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__Carousel__ = __webpack_require__(5089);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__CarouselControl__ = __webpack_require__(4032);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__CarouselItem__ = __webpack_require__(4030);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__CarouselIndicators__ = __webpack_require__(4033);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__CarouselCaption__ = __webpack_require__(5097);
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return __WEBPACK_IMPORTED_MODULE_0__Carousel__["a"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return __WEBPACK_IMPORTED_MODULE_1__CarouselControl__["a"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "e", function() { return __WEBPACK_IMPORTED_MODULE_2__CarouselItem__["a"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "d", function() { return __WEBPACK_IMPORTED_MODULE_3__CarouselIndicators__["a"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return __WEBPACK_IMPORTED_MODULE_4__CarouselCaption__["a"]; });








/***/ }),

/***/ 5089:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_prop_types__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_prop_types___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_prop_types__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__CarouselItem__ = __webpack_require__(4030);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__CarouselControl__ = __webpack_require__(4032);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__CarouselIndicators__ = __webpack_require__(4033);





let

Carousel = class Carousel extends __WEBPACK_IMPORTED_MODULE_0_react___default.a.Component {
  constructor(props) {
    super(props);
    this.handleKeyPress = this.handleKeyPress.bind(this);
    this.renderItems = this.renderItems.bind(this);
    this.hoverStart = this.hoverStart.bind(this);
    this.hoverEnd = this.hoverEnd.bind(this);
    this.state = {
      direction: 'right',
      indicatorClicked: false };

  }

  getChildContext() {
    return { direction: this.state.direction };
  }

  componentDidMount() {
    // Set up the cycle
    if (this.props.ride === 'carousel') {
      this.setInterval();
    }

    document.addEventListener('keyup', this.handleKeyPress);
  }

  componentWillReceiveProps(nextProps) {
    this.setInterval(nextProps);

    // Calculate the direction to turn
    if (this.props.activeIndex + 1 === nextProps.activeIndex) {
      this.setState({ direction: 'right' });
    } else if (this.props.activeIndex - 1 === nextProps.activeIndex) {
      this.setState({ direction: 'left' });
    } else if (this.props.activeIndex > nextProps.activeIndex) {
      this.setState({ direction: this.state.indicatorClicked ? 'left' : 'right' });
    } else if (this.props.activeIndex !== nextProps.activeIndex) {
      this.setState({ direction: this.state.indicatorClicked ? 'right' : 'left' });
    }
    this.setState({ indicatorClicked: false });
  }

  componentWillUnmount() {
    this.clearInterval();
    document.removeEventListener('keyup', this.handleKeyPress);
  }

  setInterval(props = this.props) {
    // make sure not to have multiple intervals going...
    this.clearInterval();
    if (props.interval) {
      this.cycleInterval = setInterval(() => {
        props.next();
      }, parseInt(props.interval, 10));
    }
  }

  clearInterval() {
    clearInterval(this.cycleInterval);
  }

  hoverStart(...args) {
    if (this.props.pause === 'hover') {
      this.clearInterval();
    }
    if (this.props.mouseEnter) {
      this.props.mouseEnter(...args);
    }
  }

  hoverEnd(...args) {
    if (this.props.pause === 'hover') {
      this.setInterval();
    }
    if (this.props.mouseLeave) {
      this.props.mouseLeave(...args);
    }
  }

  handleKeyPress(evt) {
    if (this.props.keyboard) {
      if (evt.keyCode === 37) {
        this.props.previous();
      } else if (evt.keyCode === 39) {
        this.props.next();
      }
    }
  }

  renderItems(carouselItems, className) {
    const { slide } = this.props;
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { role: 'listbox', className: className },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.Children.map(carouselItems, (item, index) => {
          const isIn = index === this.props.activeIndex;
          return __WEBPACK_IMPORTED_MODULE_0_react___default.a.cloneElement(item, {
            in: isIn,
            slide: slide });

        })));



  }

  renderIndicators(indicators) {
    const wrappedOnClick = e => {
      if (typeof indicators.props.onClickHandler === 'function') {
        this.setState({ indicatorClicked: true }, () => indicators.props.onClickHandler(e));
      }
    };
    return __WEBPACK_IMPORTED_MODULE_0_react___default.a.cloneElement(indicators, { onClickHandler: wrappedOnClick });
  }

  render() {
    const { slide, className } = this.props;
    const outerClasses = __WEBPACK_IMPORTED_MODULE_2_classnames___default()(
    className,
    'carousel',
    slide && 'slide');


    const innerClasses = __WEBPACK_IMPORTED_MODULE_2_classnames___default()(
    'carousel-inner');


    let carouselItems = [],
    controlLeft = null,
    controlRight = null,
    indicators = null;

    __WEBPACK_IMPORTED_MODULE_0_react___default.a.Children.forEach(this.props.children, child => {
      switch (child.type) {
        case __WEBPACK_IMPORTED_MODULE_3__CarouselItem__["a" /* default */]:carouselItems.push(child);break;
        case __WEBPACK_IMPORTED_MODULE_4__CarouselControl__["a" /* default */]:
          child.props.direction === 'prev' ? controlLeft = child : controlRight = child;
          break;
        case __WEBPACK_IMPORTED_MODULE_5__CarouselIndicators__["a" /* default */]:indicators = child;break;}

    });

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: outerClasses, onMouseEnter: this.hoverStart, onMouseLeave: this.hoverEnd },
        indicators && this.renderIndicators(indicators),
        !_.isEmpty(carouselItems) && this.renderItems(carouselItems, innerClasses),
        controlLeft,
        controlRight));


  }};


Carousel.propTypes = {
  // the current active slide of the carousel
  activeIndex: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.number,

  // a function which should advance the carousel to the next slide (via activeIndex)
  next: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.func.isRequired,

  // a function which should advance the carousel to the previous slide (via activeIndex)
  previous: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.func.isRequired,

  // controls if the left and right arrow keys should control the carousel
  keyboard: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.bool,

  /* If set to "hover", pauses the cycling of the carousel on mouseenter and resumes the cycling of the carousel on
                             * mouseleave. If set to false, hovering over the carousel won't pause it. (default: "hover")
                             */
  pause: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.oneOf(['hover', false]),

  // Autoplays the carousel after the user manually cycles the first item. If "carousel", autoplays the carousel on load.
  // This is how bootstrap defines it... I would prefer a bool named autoplay or something...
  ride: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.oneOf(['carousel']),

  // the interval at which the carousel automatically cycles (default: 5000)
  // eslint-disable-next-line react/no-unused-prop-types
  interval: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.oneOfType([
  __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.number,
  __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.string,
  __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.bool]),

  children: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.array,

  // called when the mouse enters the Carousel
  mouseEnter: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.func,

  // called when the mouse exits the Carousel
  mouseLeave: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.func,

  // controls whether the slide animation on the Carousel works or not
  slide: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.bool,
  className: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.string };


Carousel.defaultProps = {
  interval: 5000,
  pause: 'hover',
  keyboard: true,
  slide: true };


Carousel.childContextTypes = {
  direction: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.string };


/* harmony default export */ __webpack_exports__["a"] = (Carousel);
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5090:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;
exports.default = exports.EXITING = exports.ENTERED = exports.ENTERING = exports.EXITED = exports.UNMOUNTED = void 0;

var PropTypes = _interopRequireWildcard(__webpack_require__(4031));

var _react = _interopRequireDefault(__webpack_require__(1));

var _reactDom = _interopRequireDefault(__webpack_require__(22));

var _reactLifecyclesCompat = __webpack_require__(1625);

var _PropTypes = __webpack_require__(5093);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

var UNMOUNTED = 'unmounted';
exports.UNMOUNTED = UNMOUNTED;
var EXITED = 'exited';
exports.EXITED = EXITED;
var ENTERING = 'entering';
exports.ENTERING = ENTERING;
var ENTERED = 'entered';
exports.ENTERED = ENTERED;
var EXITING = 'exiting';
/**
 * The Transition component lets you describe a transition from one component
 * state to another _over time_ with a simple declarative API. Most commonly
 * it's used to animate the mounting and unmounting of a component, but can also
 * be used to describe in-place transition states as well.
 *
 * By default the `Transition` component does not alter the behavior of the
 * component it renders, it only tracks "enter" and "exit" states for the components.
 * It's up to you to give meaning and effect to those states. For example we can
 * add styles to a component when it enters or exits:
 *
 * ```jsx
 * import Transition from 'react-transition-group/Transition';
 *
 * const duration = 300;
 *
 * const defaultStyle = {
 *   transition: `opacity ${duration}ms ease-in-out`,
 *   opacity: 0,
 * }
 *
 * const transitionStyles = {
 *   entering: { opacity: 0 },
 *   entered:  { opacity: 1 },
 * };
 *
 * const Fade = ({ in: inProp }) => (
 *   <Transition in={inProp} timeout={duration}>
 *     {(state) => (
 *       <div style={{
 *         ...defaultStyle,
 *         ...transitionStyles[state]
 *       }}>
 *         I'm a fade Transition!
 *       </div>
 *     )}
 *   </Transition>
 * );
 * ```
 *
 * As noted the `Transition` component doesn't _do_ anything by itself to its child component.
 * What it does do is track transition states over time so you can update the
 * component (such as by adding styles or classes) when it changes states.
 *
 * There are 4 main states a Transition can be in:
 *  - `'entering'`
 *  - `'entered'`
 *  - `'exiting'`
 *  - `'exited'`
 *
 * Transition state is toggled via the `in` prop. When `true` the component begins the
 * "Enter" stage. During this stage, the component will shift from its current transition state,
 * to `'entering'` for the duration of the transition and then to the `'entered'` stage once
 * it's complete. Let's take the following example:
 *
 * ```jsx
 * state = { in: false };
 *
 * toggleEnterState = () => {
 *   this.setState({ in: true });
 * }
 *
 * render() {
 *   return (
 *     <div>
 *       <Transition in={this.state.in} timeout={500} />
 *       <button onClick={this.toggleEnterState}>Click to Enter</button>
 *     </div>
 *   );
 * }
 * ```
 *
 * When the button is clicked the component will shift to the `'entering'` state and
 * stay there for 500ms (the value of `timeout`) before it finally switches to `'entered'`.
 *
 * When `in` is `false` the same thing happens except the state moves from `'exiting'` to `'exited'`.
 *
 * ## Timing
 *
 * Timing is often the trickiest part of animation, mistakes can result in slight delays
 * that are hard to pin down. A common example is when you want to add an exit transition,
 * you should set the desired final styles when the state is `'exiting'`. That's when the
 * transition to those styles will start and, if you matched the `timeout` prop with the
 * CSS Transition duration, it will end exactly when the state changes to `'exited'`.
 *
 * > **Note**: For simpler transitions the `Transition` component might be enough, but
 * > take into account that it's platform-agnostic, while the `CSSTransition` component
 * > [forces reflows](https://github.com/reactjs/react-transition-group/blob/5007303e729a74be66a21c3e2205e4916821524b/src/CSSTransition.js#L208-L215)
 * > in order to make more complex transitions more predictable. For example, even though
 * > classes `example-enter` and `example-enter-active` are applied immediately one after
 * > another, you can still transition from one to the other because of the forced reflow
 * > (read [this issue](https://github.com/reactjs/react-transition-group/issues/159#issuecomment-322761171)
 * > for more info). Take this into account when choosing between `Transition` and
 * > `CSSTransition`.
 */

exports.EXITING = EXITING;

var Transition =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(Transition, _React$Component);

  function Transition(props, context) {
    var _this;

    _this = _React$Component.call(this, props, context) || this;
    var parentGroup = context.transitionGroup; // In the context of a TransitionGroup all enters are really appears

    var appear = parentGroup && !parentGroup.isMounting ? props.enter : props.appear;
    var initialStatus;
    _this.appearStatus = null;

    if (props.in) {
      if (appear) {
        initialStatus = EXITED;
        _this.appearStatus = ENTERING;
      } else {
        initialStatus = ENTERED;
      }
    } else {
      if (props.unmountOnExit || props.mountOnEnter) {
        initialStatus = UNMOUNTED;
      } else {
        initialStatus = EXITED;
      }
    }

    _this.state = {
      status: initialStatus
    };
    _this.nextCallback = null;
    return _this;
  }

  var _proto = Transition.prototype;

  _proto.getChildContext = function getChildContext() {
    return {
      transitionGroup: null // allows for nested Transitions

    };
  };

  Transition.getDerivedStateFromProps = function getDerivedStateFromProps(_ref, prevState) {
    var nextIn = _ref.in;

    if (nextIn && prevState.status === UNMOUNTED) {
      return {
        status: EXITED
      };
    }

    return null;
  }; // getSnapshotBeforeUpdate(prevProps) {
  //   let nextStatus = null
  //   if (prevProps !== this.props) {
  //     const { status } = this.state
  //     if (this.props.in) {
  //       if (status !== ENTERING && status !== ENTERED) {
  //         nextStatus = ENTERING
  //       }
  //     } else {
  //       if (status === ENTERING || status === ENTERED) {
  //         nextStatus = EXITING
  //       }
  //     }
  //   }
  //   return { nextStatus }
  // }


  _proto.componentDidMount = function componentDidMount() {
    this.updateStatus(true, this.appearStatus);
  };

  _proto.componentDidUpdate = function componentDidUpdate(prevProps) {
    var nextStatus = null;

    if (prevProps !== this.props) {
      var status = this.state.status;

      if (this.props.in) {
        if (status !== ENTERING && status !== ENTERED) {
          nextStatus = ENTERING;
        }
      } else {
        if (status === ENTERING || status === ENTERED) {
          nextStatus = EXITING;
        }
      }
    }

    this.updateStatus(false, nextStatus);
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    this.cancelNextCallback();
  };

  _proto.getTimeouts = function getTimeouts() {
    var timeout = this.props.timeout;
    var exit, enter, appear;
    exit = enter = appear = timeout;

    if (timeout != null && typeof timeout !== 'number') {
      exit = timeout.exit;
      enter = timeout.enter;
      appear = timeout.appear;
    }

    return {
      exit: exit,
      enter: enter,
      appear: appear
    };
  };

  _proto.updateStatus = function updateStatus(mounting, nextStatus) {
    if (mounting === void 0) {
      mounting = false;
    }

    if (nextStatus !== null) {
      // nextStatus will always be ENTERING or EXITING.
      this.cancelNextCallback();

      var node = _reactDom.default.findDOMNode(this);

      if (nextStatus === ENTERING) {
        this.performEnter(node, mounting);
      } else {
        this.performExit(node);
      }
    } else if (this.props.unmountOnExit && this.state.status === EXITED) {
      this.setState({
        status: UNMOUNTED
      });
    }
  };

  _proto.performEnter = function performEnter(node, mounting) {
    var _this2 = this;

    var enter = this.props.enter;
    var appearing = this.context.transitionGroup ? this.context.transitionGroup.isMounting : mounting;
    var timeouts = this.getTimeouts(); // no enter animation skip right to ENTERED
    // if we are mounting and running this it means appear _must_ be set

    if (!mounting && !enter) {
      this.safeSetState({
        status: ENTERED
      }, function () {
        _this2.props.onEntered(node);
      });
      return;
    }

    this.props.onEnter(node, appearing);
    this.safeSetState({
      status: ENTERING
    }, function () {
      _this2.props.onEntering(node, appearing); // FIXME: appear timeout?


      _this2.onTransitionEnd(node, timeouts.enter, function () {
        _this2.safeSetState({
          status: ENTERED
        }, function () {
          _this2.props.onEntered(node, appearing);
        });
      });
    });
  };

  _proto.performExit = function performExit(node) {
    var _this3 = this;

    var exit = this.props.exit;
    var timeouts = this.getTimeouts(); // no exit animation skip right to EXITED

    if (!exit) {
      this.safeSetState({
        status: EXITED
      }, function () {
        _this3.props.onExited(node);
      });
      return;
    }

    this.props.onExit(node);
    this.safeSetState({
      status: EXITING
    }, function () {
      _this3.props.onExiting(node);

      _this3.onTransitionEnd(node, timeouts.exit, function () {
        _this3.safeSetState({
          status: EXITED
        }, function () {
          _this3.props.onExited(node);
        });
      });
    });
  };

  _proto.cancelNextCallback = function cancelNextCallback() {
    if (this.nextCallback !== null) {
      this.nextCallback.cancel();
      this.nextCallback = null;
    }
  };

  _proto.safeSetState = function safeSetState(nextState, callback) {
    // This shouldn't be necessary, but there are weird race conditions with
    // setState callbacks and unmounting in testing, so always make sure that
    // we can cancel any pending setState callbacks after we unmount.
    callback = this.setNextCallback(callback);
    this.setState(nextState, callback);
  };

  _proto.setNextCallback = function setNextCallback(callback) {
    var _this4 = this;

    var active = true;

    this.nextCallback = function (event) {
      if (active) {
        active = false;
        _this4.nextCallback = null;
        callback(event);
      }
    };

    this.nextCallback.cancel = function () {
      active = false;
    };

    return this.nextCallback;
  };

  _proto.onTransitionEnd = function onTransitionEnd(node, timeout, handler) {
    this.setNextCallback(handler);

    if (node) {
      if (this.props.addEndListener) {
        this.props.addEndListener(node, this.nextCallback);
      }

      if (timeout != null) {
        setTimeout(this.nextCallback, timeout);
      }
    } else {
      setTimeout(this.nextCallback, 0);
    }
  };

  _proto.render = function render() {
    var status = this.state.status;

    if (status === UNMOUNTED) {
      return null;
    }

    var _this$props = this.props,
        children = _this$props.children,
        childProps = _objectWithoutPropertiesLoose(_this$props, ["children"]); // filter props for Transtition


    delete childProps.in;
    delete childProps.mountOnEnter;
    delete childProps.unmountOnExit;
    delete childProps.appear;
    delete childProps.enter;
    delete childProps.exit;
    delete childProps.timeout;
    delete childProps.addEndListener;
    delete childProps.onEnter;
    delete childProps.onEntering;
    delete childProps.onEntered;
    delete childProps.onExit;
    delete childProps.onExiting;
    delete childProps.onExited;

    if (typeof children === 'function') {
      return children(status, childProps);
    }

    var child = _react.default.Children.only(children);

    return _react.default.cloneElement(child, childProps);
  };

  return Transition;
}(_react.default.Component);

Transition.contextTypes = {
  transitionGroup: PropTypes.object
};
Transition.childContextTypes = {
  transitionGroup: function transitionGroup() {}
};
Transition.propTypes =  false ? {
  /**
   * A `function` child can be used instead of a React element.
   * This function is called with the current transition status
   * ('entering', 'entered', 'exiting', 'exited', 'unmounted'), which can be used
   * to apply context specific props to a component.
   *
   * ```jsx
   * <Transition timeout={150}>
   *   {(status) => (
   *     <MyComponent className={`fade fade-${status}`} />
   *   )}
   * </Transition>
   * ```
   */
  children: PropTypes.oneOfType([PropTypes.func.isRequired, PropTypes.element.isRequired]).isRequired,

  /**
   * Show the component; triggers the enter or exit states
   */
  in: PropTypes.bool,

  /**
   * By default the child component is mounted immediately along with
   * the parent `Transition` component. If you want to "lazy mount" the component on the
   * first `in={true}` you can set `mountOnEnter`. After the first enter transition the component will stay
   * mounted, even on "exited", unless you also specify `unmountOnExit`.
   */
  mountOnEnter: PropTypes.bool,

  /**
   * By default the child component stays mounted after it reaches the `'exited'` state.
   * Set `unmountOnExit` if you'd prefer to unmount the component after it finishes exiting.
   */
  unmountOnExit: PropTypes.bool,

  /**
   * Normally a component is not transitioned if it is shown when the `<Transition>` component mounts.
   * If you want to transition on the first mount set `appear` to `true`, and the
   * component will transition in as soon as the `<Transition>` mounts.
   *
   * > Note: there are no specific "appear" states. `appear` only adds an additional `enter` transition.
   */
  appear: PropTypes.bool,

  /**
   * Enable or disable enter transitions.
   */
  enter: PropTypes.bool,

  /**
   * Enable or disable exit transitions.
   */
  exit: PropTypes.bool,

  /**
   * The duration of the transition, in milliseconds.
   * Required unless `addEndListener` is provided
   *
   * You may specify a single timeout for all transitions like: `timeout={500}`,
   * or individually like:
   *
   * ```jsx
   * timeout={{
   *  enter: 300,
   *  exit: 500,
   * }}
   * ```
   *
   * @type {number | { enter?: number, exit?: number }}
   */
  timeout: function timeout(props) {
    var pt = process.env.NODE_ENV !== "production" ? _PropTypes.timeoutsShape : {};;
    if (!props.addEndListener) pt = pt.isRequired;

    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    return pt.apply(void 0, [props].concat(args));
  },

  /**
   * Add a custom transition end trigger. Called with the transitioning
   * DOM node and a `done` callback. Allows for more fine grained transition end
   * logic. **Note:** Timeouts are still used as a fallback if provided.
   *
   * ```jsx
   * addEndListener={(node, done) => {
   *   // use the css transitionend event to mark the finish of a transition
   *   node.addEventListener('transitionend', done, false);
   * }}
   * ```
   */
  addEndListener: PropTypes.func,

  /**
   * Callback fired before the "entering" status is applied. An extra parameter
   * `isAppearing` is supplied to indicate if the enter stage is occurring on the initial mount
   *
   * @type Function(node: HtmlElement, isAppearing: bool) -> void
   */
  onEnter: PropTypes.func,

  /**
   * Callback fired after the "entering" status is applied. An extra parameter
   * `isAppearing` is supplied to indicate if the enter stage is occurring on the initial mount
   *
   * @type Function(node: HtmlElement, isAppearing: bool)
   */
  onEntering: PropTypes.func,

  /**
   * Callback fired after the "entered" status is applied. An extra parameter
   * `isAppearing` is supplied to indicate if the enter stage is occurring on the initial mount
   *
   * @type Function(node: HtmlElement, isAppearing: bool) -> void
   */
  onEntered: PropTypes.func,

  /**
   * Callback fired before the "exiting" status is applied.
   *
   * @type Function(node: HtmlElement) -> void
   */
  onExit: PropTypes.func,

  /**
   * Callback fired after the "exiting" status is applied.
   *
   * @type Function(node: HtmlElement) -> void
   */
  onExiting: PropTypes.func,

  /**
   * Callback fired after the "exited" status is applied.
   *
   * @type Function(node: HtmlElement) -> void
   */
  onExited: PropTypes.func // Name the function so it is clearer in the documentation

} : {};

function noop() {}

Transition.defaultProps = {
  in: false,
  mountOnEnter: false,
  unmountOnExit: false,
  appear: false,
  enter: true,
  exit: true,
  onEnter: noop,
  onEntering: noop,
  onEntered: noop,
  onExit: noop,
  onExiting: noop,
  onExited: noop
};
Transition.UNMOUNTED = 0;
Transition.EXITED = 1;
Transition.ENTERING = 2;
Transition.ENTERED = 3;
Transition.EXITING = 4;

var _default = (0, _reactLifecyclesCompat.polyfill)(Transition);

exports.default = _default;

/***/ }),

/***/ 5091:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */



var ReactPropTypesSecret = __webpack_require__(5092);

function emptyFunction() {}
function emptyFunctionWithReset() {}
emptyFunctionWithReset.resetWarningCache = emptyFunction;

module.exports = function() {
  function shim(props, propName, componentName, location, propFullName, secret) {
    if (secret === ReactPropTypesSecret) {
      // It is still safe when called from React.
      return;
    }
    var err = new Error(
      'Calling PropTypes validators directly is not supported by the `prop-types` package. ' +
      'Use PropTypes.checkPropTypes() to call them. ' +
      'Read more at http://fb.me/use-check-prop-types'
    );
    err.name = 'Invariant Violation';
    throw err;
  };
  shim.isRequired = shim;
  function getShim() {
    return shim;
  };
  // Important!
  // Keep this list in sync with production version in `./factoryWithTypeCheckers.js`.
  var ReactPropTypes = {
    array: shim,
    bool: shim,
    func: shim,
    number: shim,
    object: shim,
    string: shim,
    symbol: shim,

    any: shim,
    arrayOf: getShim,
    element: shim,
    elementType: shim,
    instanceOf: getShim,
    node: shim,
    objectOf: getShim,
    oneOf: getShim,
    oneOfType: getShim,
    shape: getShim,
    exact: getShim,

    checkPropTypes: emptyFunctionWithReset,
    resetWarningCache: emptyFunction
  };

  ReactPropTypes.PropTypes = ReactPropTypes;

  return ReactPropTypes;
};


/***/ }),

/***/ 5092:
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */



var ReactPropTypesSecret = 'SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED';

module.exports = ReactPropTypesSecret;


/***/ }),

/***/ 5093:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;
exports.transitionTimeout = transitionTimeout;
exports.classNamesShape = exports.timeoutsShape = void 0;

var _propTypes = _interopRequireDefault(__webpack_require__(4031));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function transitionTimeout(transitionType) {
  var timeoutPropName = 'transition' + transitionType + 'Timeout';
  var enabledPropName = 'transition' + transitionType;
  return function (props) {
    // If the transition is enabled
    if (props[enabledPropName]) {
      // If no timeout duration is provided
      if (props[timeoutPropName] == null) {
        return new Error(timeoutPropName + ' wasn\'t supplied to CSSTransitionGroup: ' + 'this can cause unreliable animations and won\'t be supported in ' + 'a future version of React. See ' + 'https://fb.me/react-animation-transition-group-timeout for more ' + 'information.'); // If the duration isn't a number
      } else if (typeof props[timeoutPropName] !== 'number') {
        return new Error(timeoutPropName + ' must be a number (in milliseconds)');
      }
    }

    return null;
  };
}

var timeoutsShape = _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.shape({
  enter: _propTypes.default.number,
  exit: _propTypes.default.number
}).isRequired]);

exports.timeoutsShape = timeoutsShape;

var classNamesShape = _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.shape({
  enter: _propTypes.default.string,
  exit: _propTypes.default.string,
  active: _propTypes.default.string
}), _propTypes.default.shape({
  enter: _propTypes.default.string,
  enterDone: _propTypes.default.string,
  enterActive: _propTypes.default.string,
  exit: _propTypes.default.string,
  exitDone: _propTypes.default.string,
  exitActive: _propTypes.default.string
})]);

exports.classNamesShape = classNamesShape;

/***/ }),

/***/ 5094:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* eslint key-spacing: ["error", { afterColon: true, align: "value" }] */
// These are all setup to match what is in the bootstrap _variables.scss
// https://github.com/twbs/bootstrap/blob/v4-dev/scss/_variables.scss
const TransitionTimeouts = {
  Fade: 150, // $transition-fade
  Collapse: 350, // $transition-collapse
  Modal: 300, // $modal-transition
  Carousel: 600 // $carousel-transition
};
/* harmony export (immutable) */ __webpack_exports__["b"] = TransitionTimeouts;


const TransitionStatuses = {
  ENTERING: 'entering',
  ENTERED: 'entered',
  EXITING: 'exiting',
  EXITED: 'exited' };
/* harmony export (immutable) */ __webpack_exports__["a"] = TransitionStatuses;


/***/ }),

/***/ 5095:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["a"] = ForwardIcon;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__Icon__ = __webpack_require__(28);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};


const icon =
__WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('svg', { xmlns: 'http://www.w3.org/2000/svg', width: '16', height: '38', viewBox: '0 0 16 38' },
  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('path', { fill: 'none', fillRule: 'nonzero', stroke: '#ECECEC', d: 'M1 0l14.308 18.758L1 37.516' }));



function ForwardIcon(props) {
  return (
    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__Icon__["a" /* default */], _extends({},
    props, {
      icon: icon })));


}

/***/ }),

/***/ 5096:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["a"] = BackIcon;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__Icon__ = __webpack_require__(28);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};


const icon =
__WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('svg', { xmlns: 'http://www.w3.org/2000/svg', width: '16', height: '38', viewBox: '0 0 16 38' },
  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('path', { fill: 'none', fillRule: 'nonzero', stroke: '#ECECEC', d: 'M15.308 0L1 18.758l14.308 18.758' }));



function BackIcon(props) {
  return (
    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__Icon__["a" /* default */], _extends({},
    props, {
      icon: icon })));


}

/***/ }),

/***/ 5097:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_prop_types__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_prop_types___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_prop_types__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_classnames__);




const CarouselCaption = props => {
  const { captionHeader, captionText, className } = props;
  const classes = __WEBPACK_IMPORTED_MODULE_2_classnames___default()(
  className,
  'carousel-caption',
  'd-none',
  'd-md-block');


  return (
    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: classes },
      captionHeader && __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('h3', null, captionHeader),
      captionText && __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('p', null, captionText)));


};

CarouselCaption.propTypes = {
  captionHeader: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.string,
  captionText: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.string.isRequired,
  className: __WEBPACK_IMPORTED_MODULE_1_prop_types___default.a.string };


/* harmony default export */ __webpack_exports__["a"] = (CarouselCaption);

/***/ }),

/***/ 5098:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* unused harmony export getType */
/* harmony export (immutable) */ __webpack_exports__["a"] = getEmptyStateDataForType;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__constants_AppUrlConstants__ = __webpack_require__(64);


const entityMap = {
  'invite': [
  {
    imageName: '1',
    caption: 'Share collections, environments, etc., in team workspaces and collaborate in real time.' },

  {
    imageName: '2',
    caption: 'Maintain a single source of truth for all your APIs, synced in real time.' },

  {
    imageName: '3',
    caption: 'Invite unlimited number of people.' }],


  'documentation': [
  {
    imageName: '1',
    caption: 'Create detailed, web-viewable documentation for your API.' },

  {
    imageName: '2',
    caption: 'Include tests, examples, descriptions, and code snippets, available in multiple languages.' },

  {
    imageName: '3',
    caption: 'Customize the look with your own logo & colors.' }],


  'monitor': [
  {
    imageName: '1',
    caption: 'Schedule your collection runs to check for their performance and response.' },

  {
    imageName: '2',
    caption: 'View all your past runs in a beautiful timeline.' },

  {
    imageName: '3',
    caption: 'Set integrations to receive alerts.' }],


  'mock': [
  {
    imageName: '1',
    caption: 'Design APIs before you start developing them.' },

  {
    imageName: '2',
    caption: 'Simulate each endpoint and its corresponding response.' },

  {
    imageName: '3',
    caption: 'Share the mock server with your teammates privately.' }] };




/**
                                                                           *
                                                                           * @param {String} type
                                                                           */
function getSubtitleText(type) {
  let genText = actionText => `You need to be signed in to ${actionText}. Go ahead and
    create an account. It is free!`;

  switch (type) {
    case 'invite':return genText('invite someone');
    case 'monitor':
    case 'mock':return genText(`${type} your collections`);
    case 'documentation':return genText('create an API documentation');}

}

/**
   *
   * @param {String} type
   */
function getLearnMoreText(type) {
  switch (type) {
    case 'invite':
    case 'monitor':
    case 'mock':return 'Learn more';
    case 'documentation':return 'See live example';}

}

/**
   * @param {String} type
   */
function getCarouselTitle(type) {
  let genTitle = text => `${text} in Postman`;

  switch (type) {
    case 'invite':return genTitle('Collaborate');
    case 'monitor':return genTitle('Monitoring APIs');
    case 'mock':return genTitle('Mock APIs');
    case 'documentation':return genTitle('API documentation');}

}

/**
   * @param {String} type
   */
function getLearnMoreLink(type) {
  switch (type) {
    case 'invite':return __WEBPACK_IMPORTED_MODULE_0__constants_AppUrlConstants__["K" /* INVITE_USER_DOCS */];
    case 'monitor':return __WEBPACK_IMPORTED_MODULE_0__constants_AppUrlConstants__["T" /* MONITORING_DOCS */];
    case 'mock':return __WEBPACK_IMPORTED_MODULE_0__constants_AppUrlConstants__["S" /* MOCK_DOCS */];
    case 'documentation':return __WEBPACK_IMPORTED_MODULE_0__constants_AppUrlConstants__["P" /* LIVE_DOCS */];}

}

/**
   *
   * @param {String} type
   */
function getType(type) {
  return entityMap[type] ? type : 'invite';
}

/**
   *
   * @param {String} type
   */
function getEmptyStateDataForType(type) {
  type = getType(type);

  return {
    type,
    subtitle: getSubtitleText(type),
    carouselTitle: getCarouselTitle(type),
    carouselData: entityMap[type],
    learnMoreText: getLearnMoreText(type),
    learnMoreLink: getLearnMoreLink(type),
    hasLargeContent: ['invite', 'mock'].includes(type) };

}

/***/ }),

/***/ 5099:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SignInModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_empty_states_SignInModal__ = __webpack_require__(5100);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_services_AuthHandlerService__ = __webpack_require__(532);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__modules_services_SignInModalService__ = __webpack_require__(1499);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};






const defaultState = {
  isOpen: false,
  origin: '',
  type: '',
  title: undefined,
  subtitle: undefined,
  renderIcon: undefined };let


SignInModalContainer = class SignInModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.state = _extends({},
    defaultState);


    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleAuthSuccess = this.handleAuthSuccess.bind(this);
  }

  componentDidMount() {
    pm.mediator.on('showSignInModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showSignInModal', this.handleOpen);
  }

  handleOpen(opts = {}) {
    if (this.state.isOpen) {
      return;
    }

    this.sendModalOpenEvent(opts.type, opts.origin);

    this.setState(_extends({},
    opts, {
      isOpen: true }),
    () => {
      _.isFunction(this.state.onAuthentication) && this.handleAuthSuccess(this.state.onAuthentication);
    });
  }

  handleAuthSuccess(onAuthentication) {
    this.disposeAuthEventHandlers = Object(__WEBPACK_IMPORTED_MODULE_5__modules_services_SignInModalService__["a" /* attachAuthEventHandler */])({
      onSignIn: () => {
        onAuthentication();
        this.handleClose();
      } });

  }

  handleClose() {
    _.invoke(this, 'disposeAuthEventHandlers');
    this.state.isOpen && this.setState(defaultState);
  }

  handleAuth(isSignup) {
    this.setState({
      loadingState: 'loading',
      isCloseEnabled: false });


    let action = isSignup ? 'initiate_create' : 'initiate_signin',
    label = `${this.state.origin || 'generic_sign_in'}_empty_state`;

    __WEBPACK_IMPORTED_MODULE_4__modules_services_AnalyticsService__["a" /* default */].addEvent(this.state.type, action, label);
    __WEBPACK_IMPORTED_MODULE_3__modules_services_AuthHandlerService__["a" /* default */].login({ isSignup });
  }

  sendModalOpenEvent(type = 'generic', origin = 'sign_in') {
    let label = `${origin}_empty_state`;
    __WEBPACK_IMPORTED_MODULE_4__modules_services_AnalyticsService__["a" /* default */].addEvent(type, 'sign_in_modal_opened', label);
  }

  getStyles() {
    return {
      marginTop: '0px',
      height: '40vh',
      width: '40vw',
      minHeight: '400px',
      minWidth: '400px',
      position: 'absolute',
      top: '50%',
      left: '50%',
      transform: 'translate(-50%, -50%)' };

  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["a" /* Modal */], {
          className: 'sign-in-modal-container',
          isOpen: this.state.isOpen,
          onRequestClose: this.handleClose,
          customStyles: this.getStyles() },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["d" /* ModalHeader */], null, 'CREATE AN ACCOUNT'),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__components_base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_empty_states_SignInModal__["a" /* default */], {
            subtitle: this.state.subtitle,
            title: this.state.title,
            renderIcon: this.state.renderIcon,
            onClose: this.handleClose,
            onCreateAccount: this.handleAuth.bind(this, true),
            onSignIn: this.handleAuth.bind(this, false) }))));




  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5100:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SignInModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_prop_types__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_prop_types___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_prop_types__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Buttons__ = __webpack_require__(13);



let

SignInModal = class SignInModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.handleClose = this.handleClose.bind(this);
    this.handleCreateAccount = this.handleCreateAccount.bind(this);
    this.handleSignIn = this.handleSignIn.bind(this);
  }

  handleClose() {
    this.props.onClose && this.props.onClose();
  }

  handleCreateAccount() {
    this.props.onCreateAccount && this.props.onCreateAccount();
  }

  handleSignIn() {
    this.props.onSignIn && this.props.onSignIn();
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sign-in-modal' },
        _.isFunction(this.props.renderIcon) && this.props.renderIcon(),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sign-in-modal__title' },
          this.props.title),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sign-in-modal__subtitle' },
          this.props.subtitle),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
            className: 'sign-in-modal__create-btn',
            type: 'primary',
            onClick: this.handleCreateAccount }, 'Create a free account'),



        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sign-in-modal__separator-block' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'sign-in-modal__separator-block--separator' }),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'sign-in-modal__separator-block--separator-text' }, 'OR'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'sign-in-modal__separator-block--separator' })),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
            type: 'text',
            onClick: this.handleSignIn }, 'Sign In')));





  }};


SignInModal.propTypes = {
  onClose: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.func.isRequired,
  onCreateAccount: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.func.isRequired,
  onSignIn: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.func.isRequired };


SignInModal.defaultProps = {
  title: 'Create an account',
  subtitle: `You need to be signed in to perform this action.
    Go ahead and create an account. It is free!`,
  renderIcon: () => __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'sign-in-modal__illustration' }) };
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5101:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return InAppModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_messaging_InAppModal__ = __webpack_require__(5102);

let
InAppModalContainer = class InAppModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handlePrimaryAction = this.handlePrimaryAction.bind(this);
    this.handleSecondaryAction = this.handleSecondaryAction.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('showInAppModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showInAppModal', this.handleOpen);
  }

  handleOpen(data = {}) {
    this.setState({
      isOpen: !!data.message, // Don't open if the message unavailable
      title: data.title,
      message: data.message,
      size: _.get(data, 'meta.size'),
      primaryAction: data.primaryAction,
      secondaryAction: data.secondaryAction,
      isDismissable: data.isDismissable,
      onDismiss: data.onDismiss || _.noop,
      dismissEvent: data.dismissEvent },
    data.onView);
  }

  resetState() {
    this.setState({
      isOpen: false,
      title: '',
      message: '',
      size: 'small',
      primaryAction: {},
      secondaryAction: {},
      isDismissable: true,
      onDismiss: _.noop,
      dismissEvent: '' });

  }

  handleClose() {
    this.state.onDismiss();
    this.resetState();
  }

  handlePrimaryAction() {
    this.state.primaryAction.onClick && this.state.primaryAction.onClick();
    this.state.isDismissable && this.resetState();
  }

  handleSecondaryAction() {
    this.state.secondaryAction.onClick && this.state.secondaryAction.onClick();
    this.state.isDismissable && this.resetState();
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_messaging_InAppModal__["a" /* default */], {
        isOpen: this.state.isOpen,
        size: this.state.size,
        title: this.state.title,
        message: this.state.message,
        isDismissable: this.state.isDismissable,
        onDismiss: this.handleClose,
        primaryActionText: _.get(this, 'state.primaryAction.label'),
        secondaryActionText: _.get(this, 'state.secondaryAction.label'),
        onPrimaryAction: this.handlePrimaryAction,
        showSecondaryAction: !!this.state.secondaryAction,
        showPrimaryAction: !!this.state.primaryAction,
        onSecondaryAction: this.handleSecondaryAction }));


  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5102:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return InAppModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_prop_types__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_prop_types___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_prop_types__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Markdown__ = __webpack_require__(173);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Modals__ = __webpack_require__(189);






const LARGE = 'large',
MEDIUM = 'medium',
SMALL = 'small',

// @todo In-app discuss with design for size
SIZE_MAP = {
  [LARGE]: '800px',
  [MEDIUM]: '600px',
  [SMALL]: '300px' };let


InAppModal = class InAppModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  getRequestClose() {
    return this.props.isDismissable ? this.props.onDismiss : false;
  }

  getCustomStyles() {
    return {
      marginTop: '20vh',
      width: SIZE_MAP[this.props.size] || SIZE_MAP[MEDIUM] };

  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Modals__["a" /* Modal */], {
          isOpen: this.props.isOpen,
          onRequestClose: this.getRequestClose(),
          customStyles: this.getCustomStyles(),
          className: 'in-app-modal' },


        this.props.title &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Modals__["d" /* ModalHeader */], null,
          this.props.title),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Modals__["b" /* ModalContent */], { className: 'in-app-modal-content' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Markdown__["a" /* default */], { source: this.props.message || '' })),


        (this.props.showPrimaryAction || this.props.showSecondaryAction) &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Modals__["c" /* ModalFooter */], null,

          this.props.showPrimaryAction &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
              type: 'primary',
              onClick: this.props.onPrimaryAction },

            this.props.primaryActionText || 'Ok'),



          this.props.showSecondaryAction &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Buttons__["a" /* Button */], {
              type: 'secondary',
              onClick: this.props.onSecondaryAction },

            this.props.secondaryActionText || 'Cancel'))));






  }};



InAppModal.defaultProps = {
  isOpen: false,
  size: MEDIUM,
  title: '',
  message: '',
  isDismissable: true,
  onDismiss: () => {},
  onPrimaryAction: () => {},
  showSecondaryAction: false,
  showPrimaryAction: false,
  onSecondaryAction: () => {} };


InAppModal.propTypes = {
  isOpen: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.bool,
  size: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.oneOf([SMALL, MEDIUM, LARGE]),
  title: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.string,
  message: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.string,
  isDismissable: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.bool,
  onDismiss: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.func,
  onPrimaryAction: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.func,
  showSecondaryAction: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.bool,
  showPrimaryAction: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.bool,
  onSecondaryAction: __WEBPACK_IMPORTED_MODULE_2_prop_types___default.a.func };

/***/ }),

/***/ 5103:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ShareEntityModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_mobx__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__components_share_ShareEntityModal__ = __webpack_require__(5104);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_permissions_ManageRoles__ = __webpack_require__(4036);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__components_base_Tabs__ = __webpack_require__(103);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__collections_sharecollection_ShareCollectionRunInPostmanSnippetCodeContainer__ = __webpack_require__(5110);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__collections_sharecollection_ShareCollectionUploadAndGetLinkContainer__ = __webpack_require__(5115);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__components_base_XPaths_XPath__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__modules_services_share_entities_ShareEntitiesService__ = __webpack_require__(3594);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__modules_services_RolesService__ = __webpack_require__(3593);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__components_base_Infobar__ = __webpack_require__(1501);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__components_base_Icons_WarningIcon__ = __webpack_require__(657);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__components_base_LoadingIndicator__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__utils_PluralizeHelper__ = __webpack_require__(533);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__components_base_Icons_SyncOfflineIcon__ = __webpack_require__(544);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_20__modules_services_PermissionRemoteFetchService__ = __webpack_require__(3775);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_21__constants_ShareFlowConstants__ = __webpack_require__(3625);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_22__modules_controllers_SyncWorkspaceController__ = __webpack_require__(658);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_23__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_24__utils_uid_helper__ = __webpack_require__(85);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _class;

























const whitelistedEntities = ['collection', 'api'],
MAX_NUMBER_OF_RECENT_WORKSPACES = 5,
SHARE = 'share',
MANAGE_ROLES = 'manage-roles',
LINK = 'link',
EMBED = 'embed',
defaultState = {
  activeStep: SHARE,
  activeTab: SHARE,
  isOpen: false,
  selectedWorkspace: {},
  workspaceMembers: {},
  entityId: '',
  entityName: '',
  alreadySharedIn: [],
  isLoading: false,
  rolesList: {},
  currentRoles: {},
  isFetchingRoles: false,
  selectedUserRoles: {},
  defaultRoles: {
    team: '',
    user: '' },

  superRoles: {},
  teamRole: {},
  error: null,
  isFetchingWorkspaces: true,
  orderedWorkspaces: [],
  isFetchingPermissions: false,
  permissions: {},
  recentWorkspaces: [],
  fetchingPermissionsOnJoin: '',
  permissionError: {} },

pluralMap = {
  collection: 'collections',
  api: 'apis' },

workspacePermissionHandler = {
  collection: __WEBPACK_IMPORTED_MODULE_20__modules_services_PermissionRemoteFetchService__["d" /* fetchAddCollectionToWorkspaces */],
  api: __WEBPACK_IMPORTED_MODULE_20__modules_services_PermissionRemoteFetchService__["c" /* fetchAddAPIToWorkspaces */] },

rolesPermissionDenied = {
  collection: __WEBPACK_IMPORTED_MODULE_21__constants_ShareFlowConstants__["g" /* COLLECTION_MANAGE_ROLES_ERROR */],
  api: __WEBPACK_IMPORTED_MODULE_21__constants_ShareFlowConstants__["b" /* API_MANAGE_ROLES_ERROR */] },

shareSuccess = {
  collection: __WEBPACK_IMPORTED_MODULE_21__constants_ShareFlowConstants__["j" /* COLLECTION_SHARE_SUCCESS */],
  api: __WEBPACK_IMPORTED_MODULE_21__constants_ShareFlowConstants__["e" /* API_SHARE_SUCCESS */] },

sharePermissionDenied = {
  collection: __WEBPACK_IMPORTED_MODULE_21__constants_ShareFlowConstants__["i" /* COLLECTION_NO_PERMISSION_ERROR */],
  api: __WEBPACK_IMPORTED_MODULE_21__constants_ShareFlowConstants__["d" /* API_NO_PERMISSION_ERROR */] },

fetchRolesFail = {
  collection: __WEBPACK_IMPORTED_MODULE_21__constants_ShareFlowConstants__["m" /* FETCH_ROLES_FAILED_COLLECTION */],
  api: __WEBPACK_IMPORTED_MODULE_21__constants_ShareFlowConstants__["l" /* FETCH_ROLES_FAILED_API */] },

updateRolesFailed = {
  collection: __WEBPACK_IMPORTED_MODULE_21__constants_ShareFlowConstants__["A" /* UPDATE_ROLES_FAILED_COLLECTION */],
  api: __WEBPACK_IMPORTED_MODULE_21__constants_ShareFlowConstants__["z" /* UPDATE_ROLES_FAILED_API */] },

shareFailed = {
  collection: __WEBPACK_IMPORTED_MODULE_21__constants_ShareFlowConstants__["w" /* SHARE_FAILED_COLLECTION */],
  api: __WEBPACK_IMPORTED_MODULE_21__constants_ShareFlowConstants__["v" /* SHARE_FAILED_API */] };let



ShareEntityModalContainer = Object(__WEBPACK_IMPORTED_MODULE_1_mobx_react__["a" /* observer */])(_class = class ShareEntityModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = defaultState;

    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleShare = this.handleShare.bind(this);
    this.handleTabChange = this.handleTabChange.bind(this);
    this.handleWorkspaceSelect = this.handleWorkspaceSelect.bind(this);
    this.handleManageRoles = this.handleManageRoles.bind(this);
    this.handleRoles = this.handleRoles.bind(this);
    this.setRoles = this.setRoles.bind(this);
    this.handleBulkEdit = this.handleBulkEdit.bind(this);
    this.handleInfobarDismiss = this.handleInfobarDismiss.bind(this);
    this.handleTeamRole = this.handleTeamRole.bind(this);
    this.handleError = this.handleError.bind(this);
    this.handleWorkspaceJoin = this.handleWorkspaceJoin.bind(this);
  }

  componentDidMount() {
    pm.mediator.on('openShareEntityModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('openShareEntityModal', this.handleOpen);
  }

  setPermissions(entityType, workspaceIds) {
    workspacePermissionHandler[entityType](workspaceIds).
    then(newPermissions => {
      this.setState(prevState => {
        return {
          permissions: _extends({},
          prevState.permissions,
          newPermissions),

          isFetchingPermissions: false,
          fetchingPermissionsOnJoin: '' };

      });
    });
  }

  handleRecentWorkspaceChange(workspaces = this.state.orderedWorkspaces) {
    // We shouldn't be showing the active workspace
    // in the list of recent workspaces since it'll come as already shared in (in the UI)
    // and whenever we share an entity, we always initiate the share action
    // from the currently active workspace
    let activeWorkspaceId = Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('ActiveWorkspaceSessionStore').workspace;

    this.disposeRecentWorkspacesReaction = Object(__WEBPACK_IMPORTED_MODULE_2_mobx__["q" /* reaction */])(
    () => Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('WorkspaceStore').workspacesSortedByRecent,
    workspacesSortedByRecent => {
      if (_.isEmpty(workspacesSortedByRecent)) {
        return;
      }

      let recentWorkspaces = _.chain(workspacesSortedByRecent).
      map(({ id }) => id !== activeWorkspaceId && _.find(workspaces, { id })).
      compact().
      take(MAX_NUMBER_OF_RECENT_WORKSPACES).
      value();

      !_.isEmpty(recentWorkspaces) && this.setState({ recentWorkspaces });

      this.disposeRecentWorkspacesReaction();
    },
    { fireImmediately: true });

  }

  setWorkspaces(entityType, entityId) {
    __WEBPACK_IMPORTED_MODULE_22__modules_controllers_SyncWorkspaceController__["a" /* default */].
    getAll({ dependencies: true }).
    then(workspaces => {
      let currentUserId = Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('CurrentUserStore').id,
      unjoinedList = [],
      joinedList = [],
      alreadySharedIn = [];

      _.forEach(workspaces, workspace => {
        let isJoined = _.get(workspace, `members.users.${currentUserId}`);

        workspace.isJoined = isJoined;

        // Creating a list of unjoined and joined workspaces
        // which will be used for sorting
        isJoined ? joinedList.push(workspace) : unjoinedList.push(workspace);


        // All the workspaces in which the entity has already been shared in
        // will be stored here
        if (_.includes(_.get(workspace, `dependencies.${pluralMap[entityType]}`, []), entityId)) {
          alreadySharedIn.push(workspace);
        }
      });

      this.setPermissions(entityType, _.map(joinedList, 'id'));
      this.handleRecentWorkspaceChange(joinedList);

      let orderedWorkspaces = _.concat(
      _.sortBy(joinedList, workspace => _.toLower(workspace.name)),
      _.sortBy(unjoinedList, workspace => _.toLower(workspace.name)));


      this.setState({
        orderedWorkspaces,
        alreadySharedIn,
        isFetchingWorkspaces: false });

    }).
    catch(e => {
      this.handleError(e, __WEBPACK_IMPORTED_MODULE_21__constants_ShareFlowConstants__["k" /* FETCH_FAILED_WORKSPACES */]);
    });
  }

  isOffline() {
    return !Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('SyncStatusStore').isSocketConnected;
  }

  handleRoles(id, type, selectedRole) {
    this.setState(prevState => {
      let selectedUserRoles = _extends({},
      prevState.selectedUserRoles, {
        [id]: { id, type, name: selectedRole } }),

      bulkEditArgs = {
        rolesList: prevState.rolesList,
        selectedUserRoles,
        workspaceMembers: prevState.workspaceMembers };


      return {
        selectedUserRoles,
        bulkEditOpts: this.getBulkEditOpts(bulkEditArgs) };

    });
  }

  handleWorkspaceJoin(workspaceId) {
    let userId = Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('CurrentUserStore').id;

    this.setState(prevState => {
      let workspaceIndex = _.findIndex(prevState.orderedWorkspaces, { id: workspaceId });

      if (workspaceIndex === -1) {
        return;
      }

      let workspace = prevState.orderedWorkspaces[workspaceIndex],
      updatedWorkspace = _extends({},
      workspace, {
        isJoined: true,
        members: {
          users: _extends({},
          workspace.members.users, {
            [userId]: { id: userId } }) } });




      return {
        orderedWorkspaces: [
        ..._.slice(prevState.orderedWorkspaces, 0, workspaceIndex),
        updatedWorkspace,
        ..._.slice(prevState.orderedWorkspaces, workspaceIndex + 1)],

        selectedWorkspace: updatedWorkspace,
        fetchingPermissionsOnJoin: updatedWorkspace.id };

    }, () => this.setPermissions(this.state.entityType, [workspaceId]));
  }

  async checkPermissionsForSharing(entityType, entityId) {
    let canShare = await Object(__WEBPACK_IMPORTED_MODULE_12__modules_services_share_entities_ShareEntitiesService__["a" /* canEntityBeShared */])(entityType, entityId),
    permissionError = {
      type: __WEBPACK_IMPORTED_MODULE_21__constants_ShareFlowConstants__["p" /* NO_PERMISSION */],
      message: sharePermissionDenied[entityType] };


    if (!canShare) {
      return Promise.reject(permissionError);
    }

    return Promise.resolve();
  }

  async handleOpen(entityType, entityId, opts = {}) {
    let currentUser = Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('CurrentUserStore'),
    isLoggedIn = currentUser && currentUser.isLoggedIn;

    if (!isLoggedIn) {
      pm.mediator.trigger('showSignInModal', {
        type: entityType,
        origin: `share_${entityType}_modal` });


      return;
    }

    if (!entityType || !entityId || !whitelistedEntities.includes(entityType)) {
      console.warn(`ShareEntityModalContainer~handleOpen:
      Unsupported entity '${entityType}' provided with ID: '${entityId}'`);
      return;
    }

    Object(__WEBPACK_IMPORTED_MODULE_12__modules_services_share_entities_ShareEntitiesService__["e" /* fetchEntityMeta */])(entityType, entityId).then(entity => {
      this.setState({ entityName: _.get(entity, 'name') });
    });

    let isOffline = this.isOffline();

    if (!isOffline) {
      this.checkPermissionsForSharing(entityType, entityId).
      then(() => {
        this.setWorkspaces(entityType, entityId);
      }).
      catch(permissionError => {
        this.setState({
          permissionError,
          isFetchingRoles: false,
          isFetchingWorkspaces: false });

      });
    }

    let origin = _.get(opts, 'origin', '');

    __WEBPACK_IMPORTED_MODULE_23__modules_services_AnalyticsService__["a" /* default */].addEvent('collection', 'initiate_share', origin);

    this.setState({
      isOpen: true,
      entityId,
      entityType,
      origin,
      isFetchingPermissions: !_.isEmpty(currentUser.team),
      isFetchingWorkspaces: !isOffline });

  }

  handleClose() {
    this.setState(defaultState);
  }

  handleTabChange(activeTab) {
    this.setState({ activeTab, error: null });
  }

  handleWorkspaceSelect(selectedWorkspace) {
    this.setState({ selectedWorkspace });
  }

  handleInfobarDismiss() {
    this.setState({ error: null });
  }

  getBulkEditOpts({ rolesList, selectedUserRoles, workspaceMembers } = this.state) {
    let lastRole = '',
    bulkEditRole = 'Mixed roles',
    areAllRolesSame = true,
    teamId = _.get(Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('CurrentUserStore'), 'team.id', '');

    _.forEach(selectedUserRoles, (role, key) => {
      if (key === teamId) {
        return;
      }

      !lastRole && (lastRole = role.name);

      if (lastRole !== role.name) {
        areAllRolesSame = false;
        return false;
      }
    });

    if (areAllRolesSame) {
      bulkEditRole = _.get(rolesList, `${lastRole}.displayName`);
    }

    let memberCount = _.keys(workspaceMembers).length,
    peopleText = __WEBPACK_IMPORTED_MODULE_18__utils_PluralizeHelper__["a" /* default */].pluralize({
      count: memberCount,
      singular: 'person',
      plural: 'people' }),

    bulkEditTitle = `${memberCount} ${peopleText} in this workspace`;

    return {
      bulkEditTitle,
      bulkEditRole,
      onBulkEdit: this.handleBulkEdit };

  }

  async checkPermissionsForManagingRoles(entityType, entityId) {
    let canManage = await Object(__WEBPACK_IMPORTED_MODULE_12__modules_services_share_entities_ShareEntitiesService__["b" /* canManageRolesOnEntity */])(entityType, entityId),
    permissionError = {
      type: __WEBPACK_IMPORTED_MODULE_21__constants_ShareFlowConstants__["o" /* NO_MANAGE_PERMISSION */],
      message: !canManage && rolesPermissionDenied[entityType] };


    if (!canManage) {
      return Promise.reject(permissionError);
    }

    return Promise.resolve();
  }

  async setRoles() {
    if (this.isOffline()) {
      return;
    }

    let { entityType, entityId } = this.state;

    try {
      await this.checkPermissionsForManagingRoles(entityType, entityId);
    }
    catch (permissionError) {
      this.setState({
        error: null,
        isLoading: false,
        activeStep: MANAGE_ROLES,
        permissionError });


      return;
    }

    this.setState({
      isFetchingRoles: true,
      activeStep: MANAGE_ROLES,
      isLoading: false });


    Object(__WEBPACK_IMPORTED_MODULE_13__modules_services_RolesService__["a" /* fetchEntityRoles */])(entityType, entityId).
    then(({ rolesList, userCurrentRoles, defaultRoles, superRoles, teamCurrentRole }) => {
      let members = _.get(this.state, 'selectedWorkspace.members.users', {}),
      selectedUserRoles = userCurrentRoles,
      teamId = _.get(Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('CurrentUserStore'), 'team.id');

      _.forEach(members, member => {
        if (!member || selectedUserRoles[member.id]) {
          return;
        }

        // if no team role is there then assign the default role
        // to the user
        selectedUserRoles[member.id] = {
          id: member.id,
          type: 'user',
          name: teamCurrentRole.name || defaultRoles.user };

      });

      this.setState({
        isFetchingRoles: false,
        rolesList,
        selectedUserRoles,
        defaultRoles,
        superRoles,
        teamRole: teamCurrentRole[teamId] || {},
        workspaceMembers: members,
        bulkEditOpts: this.getBulkEditOpts({ rolesList, selectedUserRoles, workspaceMembers: members }) });

    }).
    catch(e => {
      this.handleError(e, fetchRolesFail[entityType]);
    });
  }

  handleShare() {
    if (this.isOffline()) {
      return;
    }

    this.setState({ isLoading: true, error: null });

    let {
      selectedWorkspace: workspace,
      entityType: model,
      entityId: modelId } =
    this.state,
    modelIdMap = { model, modelId },
    {
      id: workspaceId,
      type: workspaceType } =
    workspace;

    if (!workspaceId) {
      return;
    }

    Object(__WEBPACK_IMPORTED_MODULE_12__modules_services_share_entities_ShareEntitiesService__["h" /* shareEntity */])(modelIdMap, workspaceId).
    then(async () => {
      __WEBPACK_IMPORTED_MODULE_23__modules_services_AnalyticsService__["a" /* default */].addEvent(model, 'share', this.state.origin);
      pm.toasts.success(shareSuccess[model]);

      if (workspaceType === 'personal') {
        this.handleClose();
        return;
      }

      this.setState(prevState => {
        return { alreadySharedIn: _.concat(prevState.alreadySharedIn, workspace) };
      });

      this.setRoles();
    }).
    catch(e => {
      this.handleError(e, shareFailed[model]);
    });
  }

  handleManageRoles() {
    if (this.isOffline()) {
      return;
    }

    this.setState({ isLoading: true, error: null });

    let { entityType, selectedUserRoles, teamRole, entityId, entityName } = this.state;

    Object(__WEBPACK_IMPORTED_MODULE_13__modules_services_RolesService__["e" /* updateEntityRoles */])(entityType, entityId, selectedUserRoles, teamRole).
    then(() => {
      pm.toasts.success(`Successfully updated the roles for ${_.upperFirst(entityName || entityType)}`);
      this.handleClose();
    }).
    catch(e => {
      this.handleError(e, updateRolesFailed[entityType]);
    });
  }

  handleTeamRole(role) {
    this.setState(prevState => {
      return {
        teamRole: _extends({},
        prevState.teamRole, {
          name: role }) };


    });
  }

  handleBulkEdit(newRole) {
    let teamId = _.get(Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('CurrentUserStore'), 'team.id', '');

    this.setState(prevState => {
      let newRoles = _.transform(prevState.selectedUserRoles, (acc, value, key) => {
        // Do not modify team role
        if (key === teamId) {
          acc[key] = value;
          return acc;
        }

        value.name = newRole;
        acc[key] = value;
        return acc;
      }, {}),
      bulkEditArgs = {
        rolesList: prevState.rolesList,
        selectedUserRoles: newRoles,
        workspaceMembers: prevState.workspaceMembers };


      return {
        selectedUserRoles: newRoles,
        bulkEditOpts: this.getBulkEditOpts(bulkEditArgs) };

    });
  }

  handleError(e, fallbackMessage = '') {
    let errorMessage = _.get(e, 'message');

    if (errorMessage) {
      pm.toasts.error(errorMessage);
      errorMessage = null;
    } else
    {
      errorMessage = fallbackMessage || 'Something went wrong';
    }

    this.setState({ isLoading: false, error: errorMessage });
  }

  getStyles() {
    return {
      marginTop: '10vh',
      height: '85vh',
      minWidth: '720px',
      maxHeight: '700px',
      width: '80vw' };

  }

  getClasses(activeTab) {
    return __WEBPACK_IMPORTED_MODULE_5_classnames___default()({
      'share-collection-modal-container__tab-content': true,
      'is-hidden': this.state.activeTab !== activeTab });

  }

  getFooterButton() {
    if (this.state.activeTab !== SHARE) {
      return false;
    }

    let isManageRoles = this.state.activeStep === MANAGE_ROLES,
    handler = isManageRoles ? this.handleManageRoles : this.handleShare,
    buttonText = isManageRoles ? 'Save Roles' : 'Share and Continue',
    isDisabled = this.isOffline() ||
    this.state.isFetchingWorkspaces ||
    _.isEmpty(this.state.selectedWorkspace) ||
    this.state.isLoading ||
    this.state.permissionError.message;

    if (_.get(this.state, 'selectedWorkspace.type') === 'personal') {
      buttonText = 'Share';
    }

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_base_Modals__["c" /* ModalFooter */], { separated: true },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_14__components_base_Buttons__["a" /* Button */], {
            disabled: isDisabled,
            type: 'primary',
            onClick: handler,
            className: 'share-entity-modal-container--action' },


          this.state.isLoading ?
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_17__components_base_LoadingIndicator__["a" /* default */], null) :
          buttonText),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_14__components_base_Buttons__["a" /* Button */], {
            type: 'secondary',
            onClick: this.handleClose }, 'Cancel')));





  }

  render() {
    let isOffline = this.isOffline(),
    error = isOffline ? __WEBPACK_IMPORTED_MODULE_21__constants_ShareFlowConstants__["y" /* SYNC_OFFLINE_MESSAGE_SHARE */] : this.state.error,
    isTabBarVisible = this.state.entityType === 'collection';

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_base_Modals__["a" /* Modal */], {
          className: 'share-entity-modal-container',
          isOpen: this.state.isOpen,
          onRequestClose: this.handleClose,
          customStyles: this.getStyles() },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_base_Modals__["d" /* ModalHeader */], null, 'SHARE ',
          _.toUpper(this.state.entityName || this.state.entityType)),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__components_base_Modals__["b" /* ModalContent */], null,

          isTabBarVisible &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__components_base_Tabs__["b" /* Tabs */], {
              className: 'share-entity-modal-container--tabs',
              type: 'primary',
              defaultActive: SHARE,
              activeRef: this.state.activeTab,
              onChange: this.handleTabChange },

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__components_base_Tabs__["a" /* Tab */], { refKey: SHARE }, 'To a workspace'),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__components_base_Tabs__["a" /* Tab */], { refKey: EMBED }, 'Embed'),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__components_base_Tabs__["a" /* Tab */], { refKey: LINK }, 'Get link')),



          this.state.activeTab === SHARE && error &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_15__components_base_Infobar__["a" /* default */], {
            isDismissable: false,
            message: error,
            type: isOffline ? 'warn' : 'error',
            renderIcon: () => {
              return isOffline ?
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_19__components_base_Icons_SyncOfflineIcon__["a" /* default */], { className: 'share-entity-modal-container--infobar-icon is-offline' }) :
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_16__components_base_Icons_WarningIcon__["a" /* default */], { className: 'share-entity-modal-container--infobar-icon' });
            },
            onDismiss: this.handleInfobarDismiss }),



          this.state.activeStep === SHARE && this.state.activeTab === SHARE &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__components_share_ShareEntityModal__["a" /* default */], _extends({},

          _.pick(this.state,
          [
          'entityType',
          'entityId',
          'permissions',
          'recentWorkspaces',
          'alreadySharedIn',
          'selectedWorkspace',
          'orderedWorkspaces',
          'fetchingPermissionsOnJoin',
          'isFetchingWorkspaces',
          'isFetchingPermissions',
          'permissionError']), {



            onSelect: this.handleWorkspaceSelect,
            onWorkspaceJoin: this.handleWorkspaceJoin,
            onFreeTeam: this.handleClose,
            onError: this.handleError })),



          this.state.activeStep === MANAGE_ROLES && this.state.activeTab === SHARE &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_permissions_ManageRoles__["a" /* default */], {
            permissionError: this.state.permissionError,
            members: _.map(_.get(this.state.selectedWorkspace, 'members.users', [])),
            selectedUserRoles: this.state.selectedUserRoles,
            isFetchingRoles: this.state.isFetchingRoles,
            rolesList: this.state.rolesList,
            superRoles: this.state.superRoles,
            alreadySharedIn: this.state.alreadySharedIn,
            workspace: this.state.selectedWorkspace,
            onChange: this.handleRoles,
            bulkEditOpts: this.state.bulkEditOpts,
            teamRole: this.state.teamRole,
            onTeamRoleChange: this.handleTeamRole }),



          this.state.entityType === 'collection' &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: this.getClasses(EMBED) },

            this.state.activeTab === EMBED &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_11__components_base_XPaths_XPath__["a" /* default */], { identifier: 'embedCode' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_9__collections_sharecollection_ShareCollectionRunInPostmanSnippetCodeContainer__["a" /* default */], {
                collectionId: _.get(Object(__WEBPACK_IMPORTED_MODULE_24__utils_uid_helper__["a" /* decomposeUID */])(this.state.entityId), 'modelId'),
                isVisible: this.state.activeTab === EMBED }))),






          this.state.entityType === 'collection' &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: this.getClasses(LINK) },

            this.state.activeTab === LINK &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_11__components_base_XPaths_XPath__["a" /* default */], { identifier: 'generateCollectionLink' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__collections_sharecollection_ShareCollectionUploadAndGetLinkContainer__["a" /* default */], {
                collectionId: _.get(Object(__WEBPACK_IMPORTED_MODULE_24__utils_uid_helper__["a" /* decomposeUID */])(this.state.entityId), 'modelId'),
                isVisible: this.state.activeTab === LINK })))),







        this.state.activeTab === SHARE && this.getFooterButton()));



  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5104:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ShareEntityModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__WorkspaceList__ = __webpack_require__(4034);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__WorkspaceFilterBar__ = __webpack_require__(5106);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_FuzzySearchInput__ = __webpack_require__(1500);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__empty_states_CreateTeamEmpty__ = __webpack_require__(4026);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__empty_states_ShareEntityModalEmptyShell__ = __webpack_require__(5108);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__permissions_PermissionError__ = __webpack_require__(4035);
var _class;










const defaultFilterState = {
  personal: true,
  team: true,
  members: {} },

workspaceTypes = ['personal', 'team'];let


ShareEntityModal = Object(__WEBPACK_IMPORTED_MODULE_1_mobx_react__["a" /* observer */])(_class = class ShareEntityModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      searchQuery: '',
      searchResults: [],
      isFilterActive: false,
      filter: defaultFilterState,
      filteredWorkspaces: [],
      alreadySharedIn: [] };


    this.handleChange = this.handleChange.bind(this);
    this.handleFuzzySearch = this.handleFuzzySearch.bind(this);

    this.handleWorkspaceSelect = this.handleWorkspaceSelect.bind(this);
    this.handleWorkspaceJoin = this.handleWorkspaceJoin.bind(this);

    this.handleFilter = this.handleFilter.bind(this);
  }

  componentDidMount() {
    !this.props.isFetchingWorkspaces && _.invoke(this.refs, 'fuzzySearch.focus');
  }

  handleFilter(filter, filteredWorkspaces) {
    let isFilterActive = !_.isEqual(filter, defaultFilterState);

    this.setState({ isFilterActive, filter, filteredWorkspaces });
  }

  handleFuzzySearch(searchQuery, searchResults) {
    this.setState({ searchQuery, searchResults: _.map(searchResults, 'id') });
  }

  handleChange(field, value) {
    this.setState({ [field]: value });
  }

  handleClearSearch() {
    this.setState({ searchQuery: '', searchResults: [] });
  }

  getSearchResults() {
    return _.chain(this.state.searchResults).
    map(id => _.find(this.props.orderedWorkspaces, { id })).
    compact().
    value();
  }

  getWorkspaces() {
    if (this.state.isFilterActive && !this.state.searchQuery) {
      return this.state.filteredWorkspaces;
    }

    return this.props.orderedWorkspaces;
  }

  handleWorkspaceSelect(workspace, { isUnjoined, isAlreadyShared, canShare }) {
    if (isUnjoined || isAlreadyShared || !canShare) {
      return;
    }

    this.props.onSelect(workspace);
  }

  handleWorkspaceJoin(workspaceId) {
    this.props.onWorkspaceJoin(workspaceId);
  }

  render() {
    if (this.props.isFetchingWorkspaces) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__empty_states_ShareEntityModalEmptyShell__["a" /* default */], null));

    }

    if (this.props.permissionError.message) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__permissions_PermissionError__["a" /* default */], { error: this.props.permissionError.message }));

    }

    let workspaces = this.getWorkspaces(),
    teamId = _.get(Object(__WEBPACK_IMPORTED_MODULE_2__stores_get_store__["getStore"])('CurrentUserStore'), 'team.id'),
    searchResults = this.getSearchResults();

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-entity-modal' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-entity-modal__search' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_FuzzySearchInput__["a" /* default */], {
            ref: 'fuzzySearch',
            searchQuery: this.state.searchQuery,
            placeholder: 'Search for workspaces',
            onChange: this.handleFuzzySearch,
            items: this.state.isFilterActive ? this.state.filteredWorkspaces : this.props.orderedWorkspaces,
            searchFields: ['name', 'email'] })),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-entity-modal__workspace-container' },

          teamId ?
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__WorkspaceFilterBar__["a" /* default */], {
            showClearButton: this.state.showClearButton,
            workspaceTypes: workspaceTypes,
            showClearButton: this.state.isFilterActive,
            filter: this.state.filter,
            defaultFilterState: defaultFilterState,
            onChange: this.handleFilter,
            workspaces: this.state.searchQuery ? searchResults : this.props.orderedWorkspaces }) :

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__empty_states_CreateTeamEmpty__["a" /* default */], {
            modelType: this.props.entityType,
            onInvite: this.props.onFreeTeam }),



          !this.state.searchQuery &&
          !this.state.isFilterActive &&
          !_.isEmpty(this.props.recentWorkspaces) &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-entity-modal__recent-workspaces' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-entity-modal__recent-workspaces-title' }, 'Recent workspaces'),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__WorkspaceList__["a" /* default */], {
              isFetchingPermissions: this.props.isFetchingPermissions,
              permissions: this.props.permissions,
              selectedWorkspace: this.props.selectedWorkspace.id,
              workspaces: this.props.recentWorkspaces,
              onSelect: this.handleWorkspaceSelect,
              alreadySharedIn: this.props.alreadySharedIn })),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-entity-modal__all-workspaces' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-entity-modal__all-workspaces-title' },

              this.state.searchQuery || this.state.isFilterActive ?
              'Search Results' :
              'All workspaces'),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-entity-modal__all-workspaces-list' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__WorkspaceList__["a" /* default */], {
                isFetchingPermissions: this.props.isFetchingPermissions,
                permissions: this.props.permissions,
                selectedWorkspace: this.props.selectedWorkspace.id,
                workspaces: this.state.searchQuery ? searchResults : workspaces,
                onSelect: this.handleWorkspaceSelect,
                onError: this.props.onError,
                alreadySharedIn: this.props.alreadySharedIn,
                onWorkspaceJoin: this.handleWorkspaceJoin,
                fetchingPermissionsOnJoin: this.props.fetchingPermissionsOnJoin }))))));






  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5105:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return WorkspaceListItem; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_AvatarGroup__ = __webpack_require__(1632);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__utils_PluralizeHelper__ = __webpack_require__(533);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__modules_model_event__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__base_LoadingIndicator__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__base_Tooltips__ = __webpack_require__(80);








let

WorkspaceListItem = class WorkspaceListItem extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isLoading: false,
      tooltipTarget: 'avatarGroup',
      tooltipPlacement: 'bottom' };


    this.handleSelect = this.handleSelect.bind(this);
    this.showTooltip = this.showTooltip.bind(this);
    this.hideTooltip = this.hideTooltip.bind(this);
    this.handleJoinWorkspace = this.handleJoinWorkspace.bind(this);
  }

  getItemClasses() {
    return __WEBPACK_IMPORTED_MODULE_1_classnames___default()({
      'workspace-list-item': true,
      'is-disabled': this.props.isUnjoined || this.props.isAlreadySharedIn || !this.props.canShare,
      'is-view-mode': this.props.disableActions,
      'is-selected': this.props.isSelected });

  }

  getMemberNameClasses() {
    return __WEBPACK_IMPORTED_MODULE_1_classnames___default()({
      'workspace-list-item__workspace-members': true,
      'is-view-mode': this.props.disableActions });

  }

  getWorkspaceMemberNames() {
    let { members } = this.props;
    if (!members) {
      return '';
    }

    const getName = memberIndex => _.get(members, `${[memberIndex]}.name`, '');

    switch (members.length) {
      case 0:return '';
      case 1:return getName(0);
      case 2:return `${getName(0)} and ${getName(1)}`;
      case 3:return `${getName(0)}, ${getName(1)} and ${getName(2)}`;
      default:
        let memberNames = '';

        _.times(3, i => memberNames += `${getName(i)}, `);
        memberNames = memberNames.slice(0, -2);

        let membersLeft = members.length - 3,
        otherText = __WEBPACK_IMPORTED_MODULE_4__utils_PluralizeHelper__["a" /* default */].pluralize({
          count: membersLeft,
          singular: 'other',
          plural: 'others' });


        return `${memberNames} and ${membersLeft} ${otherText}`;}

  }

  componentDidUpdate(prevProps) {
    if (prevProps.isUnjoined && !this.props.isUnjoined) {
      this.handleSelect();
    }
  }


  handleJoinWorkspace() {
    this.setState({ isLoading: true });
    let { id } = this.props.workspace,
    joinWorkspaceEvent = Object(__WEBPACK_IMPORTED_MODULE_5__modules_model_event__["a" /* createEvent */])('join', 'workspace', { model: 'workspace', workspace: { id } });

    Object(__WEBPACK_IMPORTED_MODULE_6__modules_pipelines_user_action__["a" /* default */])(joinWorkspaceEvent).
    then(() => {
      this.props.onWorkspaceJoin && this.props.onWorkspaceJoin(id);
    }).
    catch(e => {
      this.props.onError(e);
      this.setState({ isLoading: false });
    });
  }

  handleSelect() {
    if (this.props.disableActions) {
      return;
    }

    this.props.onSelect(
    this.props.workspace,
    {
      isUnjoined: this.props.isUnjoined,
      isAlreadyShared: this.props.isAlreadySharedIn,
      canShare: this.props.canShare });


  }

  showTooltip(tooltipTarget, tooltipPlacement) {
    this.setState({ isTooltipVisible: true, tooltipTarget, tooltipPlacement });
  }

  hideTooltip(tooltipTarget, tooltipPlacement) {
    this.setState({ isTooltipVisible: false, tooltipTarget, tooltipPlacement });
  }

  render() {
    let { workspace } = this.props,
    showNoPermission = !this.props.isUnjoined && !this.props.isAlreadySharedIn && !this.props.canShare;

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
          className: this.getItemClasses(),
          onClick: this.handleSelect },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
            ref: 'avatarGroup',
            onMouseEnter: this.showTooltip.bind(this, 'avatarGroup', 'bottom'),
            onMouseLeave: this.hideTooltip.bind(this, 'avatarGroup', 'bottom') },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_AvatarGroup__["a" /* default */], { iconSize: 'md', members: this.props.members }),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__base_Tooltips__["a" /* Tooltip */], {
              show: this.state.isTooltipVisible,
              target: this.refs[this.state.tooltipTarget],
              placement: this.state.tooltipPlacement },

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__base_Tooltips__["b" /* TooltipBody */], null,

              _.map(this.props.members, member => {
                if (!member) {
                  return;
                }

                return (
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { key: member.id },
                    member.name));


              })))),




        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-list-item__details-container' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-list-item__details' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-list-item__workspace-name' },
              workspace.name),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', {
                ref: 'membersText',
                className: this.getMemberNameClasses(),
                onMouseEnter: this.showTooltip.bind(this, 'membersText', 'right'),
                onMouseLeave: this.hideTooltip.bind(this, 'membersText', 'right') },


              workspace.type === 'personal' ?
              'Personal Workspace' :
              this.getWorkspaceMemberNames())),




          !this.props.disableActions &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-list-item__workspace-action' },

            this.props.isAlreadySharedIn &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: __WEBPACK_IMPORTED_MODULE_1_classnames___default()({ 'is-unjoined-and-shared': this.props.isUnjoined }) }, 'Already shared'),




            showNoPermission &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: __WEBPACK_IMPORTED_MODULE_1_classnames___default()({ 'is-unjoined-and-shared': this.props.isUnjoined }) }, 'No permission to share'),




            this.props.isUnjoined &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
                type: 'primary',
                disabled: this.state.isLoading,
                onClick: this.handleJoinWorkspace },


              this.state.isLoading ?
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_LoadingIndicator__["a" /* default */], null) :
              'Join'),




            this.props.isSelected && !this.props.isAlreadySharedIn &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'radio' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'radio-inner' }))))));







  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5106:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return WorkspaceFilterBar; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Icons_DownSolidIcon__ = __webpack_require__(73);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Icons_UpSolidIcon__ = __webpack_require__(278);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__MemberSelect__ = __webpack_require__(5107);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__base_Tag__ = __webpack_require__(4013);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _class;







let


WorkspaceFilterBar = Object(__WEBPACK_IMPORTED_MODULE_1_mobx_react__["a" /* observer */])(_class = class WorkspaceFilterBar extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = { isCollapsed: false };

    this.handleCollapse = this.handleCollapse.bind(this);
    this.handleClearFilters = this.handleClearFilters.bind(this);
  }

  handleCollapse() {
    this.setState(prevState => ({ isCollapsed: !prevState.isCollapsed }));
  }

  filterByMembers(members, workspaces) {
    let workspaceMembers = [],
    membersToFilterBy = _.map(members, member => member.id);

    return _.filter(workspaces, workspace => {
      workspaceMembers = _.map(workspace.members.users, member => member.id);

      // Checks the difference between the two arrays
      // and in case there's no difference i.e. the membersToFilterBy array
      // is a subset of the workspaceMembers array then
      // we can return true in that case
      return !_.difference(membersToFilterBy, workspaceMembers).length;
    });
  }

  getWorkspacesByType(type) {
    return _.filter(this.props.workspaces, { type });
  }

  getFilteredWorkspaces(filter) {
    let workspaces = this.props.workspaces,
    isFilteringByWorkspace = filter.personal || filter.team;

    if (filter.personal && !filter.team) {
      workspaces = this.getWorkspacesByType('personal');
    } else
    if (filter.team && !filter.personal) {
      workspaces = this.getWorkspacesByType('team');
    }

    if (!_.isEmpty(filter.members)) {
      let workspacesToBeFiltered = isFilteringByWorkspace ? workspaces : this.props.workspaces;
      workspaces = this.filterByMembers(filter.members, workspacesToBeFiltered);
    }

    return workspaces;
  }

  handleFilter(type, data) {
    let { filter } = this.props,
    newFilter = _extends({},
    filter, {
      [type]: type === 'members' ? data : !filter[type] }),

    filteredWorkspaces = this.getFilteredWorkspaces(newFilter);

    this.props.onChange(newFilter, filteredWorkspaces);
  }

  handleClearFilters() {
    this.props.onChange(this.props.defaultFilterState, []);
  }

  getClearFilterClasses() {
    let activateHighlight = this.props.showClearButton && this.state.isCollapsed;

    return __WEBPACK_IMPORTED_MODULE_2_classnames___default()({
      'workspace-filter__text-container--clear--highlight': activateHighlight },
    'workspace-filter__text-container--clear');
  }

  renderWorkspaceTypeFilters() {
    return _.map(this.props.workspaceTypes, type => {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
            key: type,
            className: `workspace-filter__filters-ws-type ${type}`,
            onClick: this.handleFilter.bind(this, type) },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Inputs__["a" /* Checkbox */], { checked: this.props.filter[type] }),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'workspace-filter__filters-ws-type-name' }, _.upperFirst(type))));


    });
  }

  renderTags() {
    return _.map(this.props.filter.members, member => {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__base_Tag__["a" /* default */], {
          key: member.id,
          className: 'workspace_filter__tag',
          type: 'success',
          tagName: member.name }));


    });
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-filter' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-filter__text-container' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
              className: 'workspace-filter__text-container--filter-by',
              onClick: this.handleCollapse },

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'workspace-filter__text-container-title' }, 'Filter by'),

            this.state.isCollapsed ?
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Icons_DownSolidIcon__["a" /* default */], { className: 'workspace-filter__text-container-title--icon' }) :
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Icons_UpSolidIcon__["a" /* default */], { className: 'workspace-filter__text-container-title--icon' })),



          this.props.showClearButton &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
              className: this.getClearFilterClasses(),
              onClick: this.handleClearFilters }, 'Clear filters')),






        !this.state.isCollapsed &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-filter__filters' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-filter__filters-ws' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-filter__filters-ws__title' }, 'Workspace type:'),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-filter__filters-ws-types' },
              this.renderWorkspaceTypeFilters())),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-filter__separator' }),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'workspace-filter__people-container' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__MemberSelect__["a" /* default */], {
              selectedMembers: this.props.filter['members'],
              members: Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('TeamStore').allTeamMembers,
              onSelect: this.handleFilter.bind(this, 'members') })),


          this.renderTags())));




  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5107:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return MemberSelect; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Avatar__ = __webpack_require__(651);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Dropdowns__ = __webpack_require__(31);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_FuzzySearchInput__ = __webpack_require__(1500);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};




let

MemberSelect = class MemberSelect extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      searchQuery: '',
      searchResults: [] };


    this.handleFuzzySearch = this.handleFuzzySearch.bind(this);
  }

  handleFuzzySearch(searchQuery, searchResults) {
    this.setState({ searchQuery, searchResults });
  }

  handleMemberSelect(id, isSelected) {
    let updatedSelectedMembers = {};

    if (isSelected) {
      updatedSelectedMembers = _extends({},
      this.props.selectedMembers, {
        [id]: _.find(this.props.members, { id }) });

    } else
    {
      updatedSelectedMembers = _.omitBy(this.props.selectedMembers, { id });
    }

    _.isFunction(this.props.onSelect) && this.props.onSelect(updatedSelectedMembers);
  }

  render() {
    let members = this.state.searchQuery ?
    this.state.searchResults :
    this.props.members;

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'member-select-container' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Dropdowns__["a" /* Dropdown */], { className: 'member-select-container' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Dropdowns__["b" /* DropdownButton */], null,
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Buttons__["a" /* Button */], { type: 'text', className: 'member-select-btn' }, 'Workspace members')),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Dropdowns__["c" /* DropdownMenu */], null,
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'member-select' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_FuzzySearchInput__["a" /* default */], {
                searchQuery: this.state.searchQuery,
                placeholder: 'Search for people. e.g. Cooper',
                onChange: this.handleFuzzySearch,
                items: this.props.members,
                searchFields: ['name', 'email'] }),

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'member-select-list' },

                _.map(members, member => {
                  return (
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', {
                        key: member.id,
                        className: 'member-item',
                        onClick: this.handleMemberSelect.bind(this, member.id, !this.props.selectedMembers[member.id]) },

                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Avatar__["a" /* default */], {
                        size: 'small',
                        userId: member.id }),

                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', {
                          className: 'member-item-text',
                          title: member.name },

                        member.name),

                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Inputs__["a" /* Checkbox */], {
                        onChange: this.handleMemberSelect.bind(this, member.id),
                        className: 'member-item-checkbox',
                        checked: this.props.selectedMembers[member.id] })));



                })))))));







  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5108:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);

const NUMBER_OF_WORKSPACE_ITEMS = 4;

const ShareEntityModalEmptyShell = () => {
  return (
    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-empty-shell' },
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-empty-shell--search' }),
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-empty-shell--filter' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-empty-shell--filter-title' }),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-empty-shell--filter-type' })),

      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-empty-shell--workspaces-title' }),
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-empty-shell--workspaces' },

        _.times(NUMBER_OF_WORKSPACE_ITEMS, i => {
          return (
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { key: i, className: 'share-empty-shell--workspaces-item' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-empty-shell--workspaces-item--avatar' }),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-empty-shell--workspaces-item--details' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-empty-shell--workspaces-item--details-title' }),
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-empty-shell--workspaces-item--details-members' }))));



        }))));




};

/* harmony default export */ __webpack_exports__["a"] = (ShareEntityModalEmptyShell);
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5109:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return TeamLogo; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__Icons_TeamIcon__ = __webpack_require__(1491);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_prop_types__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_prop_types___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_prop_types__);




let

TeamLogo = class TeamLogo extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = { imageNotFound: false };
    this.handleImageError = this.handleImageError.bind(this);
  }

  handleImageError() {
    this.setState({ imageNotFound: true });
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: __WEBPACK_IMPORTED_MODULE_2_classnames___default()({ 'team-logo': true }, this.props.className) },

        this.state.imageNotFound || !this.props.imageUrl ?
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__Icons_TeamIcon__["a" /* default */], { size: 'md' }) :
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('img', {
          className: 'team-logo--image',
          src: this.props.imageUrl,
          onError: this.handleImageError })));




  }};


TeamLogo.propTypes = {
  className: __WEBPACK_IMPORTED_MODULE_4_prop_types___default.a.string };

/***/ }),

/***/ 5110:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ShareCollectionRunInPostmanSnippetCodeContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__utils_util__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__utils_ClipboardHelper__ = __webpack_require__(536);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__utils_RunInPostmanHelper_js__ = __webpack_require__(5111);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__modules_services_CollectionRemoteLinkService__ = __webpack_require__(4037);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__components_collections_sharecollection_ShareCollectionRunInPostmanSnippetCode__ = __webpack_require__(5112);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__modules_controllers_EnvironmentController__ = __webpack_require__(81);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__modules_pipelines_app_action__ = __webpack_require__(314);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10_mobx_react__ = __webpack_require__(11);
var _class;











let { createEvent } = __webpack_require__(226);let


ShareCollectionRunInPostmanSnippetCodeContainer = Object(__WEBPACK_IMPORTED_MODULE_10_mobx_react__["a" /* observer */])(_class = class ShareCollectionRunInPostmanSnippetCodeContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.state = {
      generatedCode: 'Generating code snippet...',
      codeCopied: false,
      fetchingLink: false,
      activeButtonType: 'cssButton',
      selectedEnvironment: null,
      collectionLink: '' };

    this.handleCopyCodeSnippet = this.handleCopyCodeSnippet.bind(this);
    this.handleButtonTypeChange = this.handleButtonTypeChange.bind(this);
    this.handleEnvironmentSelect = this.handleEnvironmentSelect.bind(this);
    this.handleGenerateCode = this.handleGenerateCode.bind(this);
    this.handleUploadandGetLink = this.handleUploadandGetLink.bind(this);
    this.handleDeleteCollectionLink = this.handleDeleteCollectionLink.bind(this);
    this.getLinkForCollection = this.getLinkForCollection.bind(this);
    this.generateCode = this.generateCode.bind(this);
    this.generateCodeTimeout = null;
  }

  /** Public API's **/

  componentWillMount() {
    this.getLinkForCollection(this.props.collectionId);
  }

  componentWillUnmount() {
    this.setState({ generatedCode: '' });
    clearTimeout(this.timeout);
    clearTimeout(this.generateCodeTimeout);
  }

  handleEnvironmentSelect(environmentSelected) {
    this.setState({ selectedEnvironment: environmentSelected }, () => {
      this.generateEmbedcode(this.state.collectionLink);
    });
  }

  initiateRequest() {
    this.setState({
      fetchingLink: true,
      collectionLink: null });

    this.generateCodeTimeout = setTimeout(() => {
      this.setState({
        fetchingLink: false,
        collectionLink: null },
      () => {
        pm.toasts.error('Something went wrong while generating embeddable code. Try again after sometime.');
      });
    }, 20000);
  }

  generateCode() {
    this.handleUploadandGetLink();
  }

  handleGenerateCode() {
    if (this.props.newCollection && !this.props.isCollectionCreated) {
      this.props.onCollectionCreated(this.generateCode);
    } else
    {
      this.generateCode();
    }
  }

  getLinkForCollection() {
    let collectionId = this.props.collectionId;

    if (collectionId) {
      let currentUser = Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('CurrentUserStore');

      if (!(currentUser && currentUser.isLoggedIn)) {
        console.log('You need to be logged');

        // @todo vineeth for copy.
        return;
      }
      let collectionsRemoteLink = currentUser && currentUser.collections || [],
      collectionLinkObj = _.find(collectionsRemoteLink, ['id', collectionId]) || {};

      this.setState({ collectionLink: collectionLinkObj.link || '' }, () => {
        if (!_.isEmpty(this.state.collectionLink)) {
          this.generateEmbedcode(this.state.collectionLink);
        }
      });

    }
  }

  handleUploadandGetLink() {
    this.initiateRequest();
    __WEBPACK_IMPORTED_MODULE_4__modules_services_CollectionRemoteLinkService__["a" /* default */].uploadCollectionForLink(this.props.collectionId).
    then(data => {
      let link = _.get(data, 'link');
      __WEBPACK_IMPORTED_MODULE_8__modules_services_AnalyticsService__["a" /* default */].addEvent('collection', 'share', 'embed', null, {
        collection_id: this.props.collectionId,
        collection_link_id: __WEBPACK_IMPORTED_MODULE_1__utils_util__["a" /* default */].getCollectionLinkId(link) });

      this.setState({
        fetchingLink: false,
        collectionLink: link });


      if (!_.isEmpty(link)) {
        this.generateEmbedcode(link);
        clearTimeout(this.generateCodeTimeout);
      }
      Object(__WEBPACK_IMPORTED_MODULE_9__modules_pipelines_app_action__["a" /* default */])(createEvent('refreshUserCollections', 'user'));
    }).
    catch(err => {
      pm.logger.error('Error in uploading collection', err);
      clearTimeout(this.generateCodeTimeout);

      // @todo talk to vineeth for the copy to show to user
    });
  }

  handleDeleteCollectionLink() {
    __WEBPACK_IMPORTED_MODULE_4__modules_services_CollectionRemoteLinkService__["a" /* default */].deleteCollectionLink(this.props.collectionId).
    then(() => {
      this.setState({ collectionLink: '' });
      Object(__WEBPACK_IMPORTED_MODULE_9__modules_pipelines_app_action__["a" /* default */])(createEvent('refreshUserCollections', 'user'));
      pm.toasts.success('Collection Link deleted');
    }).
    catch(err => {
      console.log('Error in deleting the collection link', err);

      // @todo talk to vineeth for the copy to show to user
    });
  }

  generateEmbedcode(link) {
    console.log('link', link);
    if (!link) return;

    if (this.state.selectedEnvironment) {
      return __WEBPACK_IMPORTED_MODULE_7__modules_controllers_EnvironmentController__["a" /* default */].get({ id: this.state.selectedEnvironment }).then(env => {
        this.setState({ generatedCode: __WEBPACK_IMPORTED_MODULE_3__utils_RunInPostmanHelper_js__["a" /* default */].generateCode(this.state.activeButtonType, link, env || {}) });
      });
    }

    // With no environment selected
    this.setState({ generatedCode: __WEBPACK_IMPORTED_MODULE_3__utils_RunInPostmanHelper_js__["a" /* default */].generateCode(this.state.activeButtonType, link, {}) });
  }

  handleButtonTypeChange(buttonType) {
    this.setState({ activeButtonType: buttonType }, () => {
      this.generateEmbedcode(this.state.collectionLink);
    });
  }

  handleCopyCodeSnippet(generatedCode) {
    __WEBPACK_IMPORTED_MODULE_2__utils_ClipboardHelper__["a" /* default */].copy(generatedCode);
    this.setState({ codeCopied: true });
    this.timeout = setTimeout(() => {
      this.setState({ codeCopied: false });
    }, 1000);

    if (this.state.selectedEnvironment) {
      __WEBPACK_IMPORTED_MODULE_8__modules_services_AnalyticsService__["a" /* default */].addEvent('runinpostman', 'generate', 'env', null, null);
    } else
    {
      __WEBPACK_IMPORTED_MODULE_8__modules_services_AnalyticsService__["a" /* default */].addEvent('runinpostman', 'generate', 'no_env', null, null);
    }
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__components_collections_sharecollection_ShareCollectionRunInPostmanSnippetCode__["a" /* default */], {
        collectionLink: this.state.collectionLink,
        fetchingLink: this.state.fetchingLink,
        onCollectionLinkDelete: this.handleDeleteCollectionLink,
        onLinkUpdate: this.handleUploadandGetLink,
        onGenerateCode: this.handleGenerateCode,
        generatedCode: this.state.generatedCode,
        codeCopied: this.state.codeCopied,
        onCopyCodeSnippet: this.handleCopyCodeSnippet,
        activeButtonType: this.state.activeButtonType,
        onButtonTypeChange: this.handleButtonTypeChange,
        selectedEnvironment: this.state.selectedEnvironment,
        environmentsList: Object(__WEBPACK_IMPORTED_MODULE_6__stores_get_store__["getStore"])('ActiveWorkspaceStore').environments,
        onEnvSelect: this.handleEnvironmentSelect,
        isVisible: this.props.isVisible }));


  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5111:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {let
RunInPostmanHelper = class RunInPostmanHelper {
  constructor() {
  }

  /**
      @private
      @method generatestheruninpostman button code
      @param  buttonType, collectionLink, environment
      @returns Generated code snippet for the run in postman button
    **/

  generateCode(buttonType, collectionLink, environment) {
    let linkParts = collectionLink.split('/'),
    linkId = linkParts[linkParts.length - 1],
    environmentEncoded = '',
    codeText = '';
    try {
      if (buttonType === 'cssButton') {
        codeText = '<div class="postman-run-button"\n' +
        'data-postman-action="collection/import"\n' +
        'data-postman-var-1="' + linkId + '"';

        if (!_.isEmpty(environment)) {
          let envName = environment.name,
          templateEndString = '.template';
          if (envName.indexOf(templateEndString, envName - templateEndString.length) !== -1) {
            envName = envName.substring(0, envName.lastIndexOf(templateEndString));
          }
          let encodedName = encodeURIComponent('env[' + envName + ']');
          codeText = codeText +
          '\ndata-postman-param="' +
          encodedName + '=' +
          btoa(unescape(encodeURIComponent(JSON.stringify(environment.values)))) + '"';
        }
        codeText = codeText +
        '></div>\n' +
        '<script type="text/javascript">\n' +
        '  (function (p,o,s,t,m,a,n) {\n' +
        '    !p[s] && (p[s] = function () { (p[t] || (p[t] = [])).push(arguments); });\n' +
        '    !o.getElementById(s+t) && o.getElementsByTagName("head")[0].appendChild((\n' +
        '      (n = o.createElement("script")),\n' +
        '      (n.id = s+t), (n.async = 1), (n.src = m), n\n' +
        '    ));\n' +
        '  }(window, document, "_pm", "PostmanRunObject", "' + postman_run_btn_url + '/button.js"));\n' +
        '</script>';
      } else
      {
        codeText = '[![Run in Postman](' + postman_run_btn_url + '/button.svg)](' + postman_app_url + '/run-collection/' + linkId;
        if (!_.isEmpty(environment)) {
          let encodedName = encodeURIComponent('env[' + environment.name + ']');
          codeText = codeText +
          '#?' + encodedName + '=' +
          btoa(unescape(encodeURIComponent(JSON.stringify(environment.values))));
        }
        codeText += ')';
      }
    }
    catch (e) {
      // To show the exception in the snippet code better debuggin
      codeText = e;
    } finally
    {
      return codeText;
    }
  }};


/* harmony default export */ __webpack_exports__["a"] = (new RunInPostmanHelper());
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5112:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ShareCollectionRunInPostmanSnippetCode; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_react_radio_group__ = __webpack_require__(1503);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_react_radio_group___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_react_radio_group__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_TextArea__ = __webpack_require__(962);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_Icons_RunIcon__ = __webpack_require__(5113);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__base_Icons_DeleteIcon__ = __webpack_require__(214);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__base_Icons_SuccessIcon__ = __webpack_require__(312);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__ShareCollectionRunInPostmanEnvironmentSelector__ = __webpack_require__(5114);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__constants_AppUrlConstants__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__external_navigation_ExternalNavigationService__ = __webpack_require__(59);












let
ShareCollectionRunInPostmanSnippetCode = class ShareCollectionRunInPostmanSnippetCode extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.state = { uniqueName: this.generateUniqueId() };
    this.handleBackSelect = this.handleBackSelect.bind(this);
    this.handleCopyCodeSnippet = this.handleCopyCodeSnippet.bind(this);
    this.handleButtonTypeChange = this.handleButtonTypeChange.bind(this);
    this.handleEnvironmentSelect = this.handleEnvironmentSelect.bind(this);
  }

  generateUniqueId() {
    let uniqueId = Math.random().toString(36).substring(7);
    return `body-type-${uniqueId}`;
  }

  handleBackSelect() {
    this.props.onBackSelect && this.props.onBackSelect(false);
  }

  handleCopyCodeSnippet() {
    this.props.onCopyCodeSnippet && this.props.onCopyCodeSnippet(this.props.generatedCode);
  }

  handleButtonTypeChange(value) {
    this.props.onButtonTypeChange && this.props.onButtonTypeChange(value);
  }

  handleEnvironmentSelect(value) {
    this.props.onEnvSelect && this.props.onEnvSelect(value);
  }

  handleOpenCollectionLink(e) {
    e.preventDefault();
    Object(__WEBPACK_IMPORTED_MODULE_11__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_10__constants_AppUrlConstants__["_3" /* RIP_DOCS */]);
  }

  render() {

    let codeCopied = this.props.codeCopied,
    generatedCode = _.isEmpty(this.props.generatedCode) ? 'Generating code snippet...' : this.props.generatedCode,
    isLinkAvailable = !_.isEmpty(this.props.collectionLink);
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-collection-modal-runinpostman-container' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-collection-modal-content-wrapper' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-collection-modal-text-wrapper' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-collection-modal-header-run-in-postman-description' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Share Collections via the Embed or '),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'share-collection-modal-run-in-postman-button' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_Icons_RunIcon__["a" /* default */], {
                  className: 'share-collection-modal-run-in-postman-icon',
                  size: 'xs',
                  style: 'primary' }), ' Run in Postman'),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, ' Button. Embed your Postman Collection in your API documentation, website, or Github readme, so anyone can import and run this collection with one click. '),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null,
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('a', {
                    onClick: this.handleOpenCollectionLink,
                    className: 'share-collection-modal-header-description-link' }, 'Learn more.'))))),








        !isLinkAvailable &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-collection-modal-run-in-postman-generate-code-wrapper' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
              type: 'primary',
              size: 'small',
              onClick: this.props.onGenerateCode,
              className: 'share-collection-modal-run-in-postman-generate-code-button' },

            this.props.fetchingLink ? 'Fetching Link' : 'Generate Code'),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-collection-modal-run-in-postman-generate-code-description' }, 'The Run in Postman button shares the collection directly from Postman, so the collection is uploaded to Postman servers when you generate the embed code. You can always change this later.')),






        isLinkAvailable &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-collection-modal-run-in-postman-link-wrapper' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Inputs__["b" /* Input */], {
            type: 'text',
            inputStyle: 'box',
            disabled: true,
            value: this.props.collectionLink,
            className: 'share-collection-modal-collection-link' }),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
              type: 'primary',
              size: 'small',
              disabled: this.props.fetchingLink,
              onClick: this.props.onLinkUpdate,
              className: 'share-collection-modal-run-in-postman-generate-code-button' },

            this.props.fetchingLink ? 'Fetching Link' : 'Update Link'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
              className: 'share-collection-modal-collection-link-delete-button',
              type: 'icon',
              onClick: this.props.onCollectionLinkDelete,
              tooltip: 'Delete collection link' },

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_Icons_DeleteIcon__["a" /* default */], { className: 'share-collection-modal-collection-link-delete' }))),





        isLinkAvailable &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-collection-modal-run-in-postman-button-wrapper' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1_react_radio_group__["RadioGroup"], {
                name: this.state.uniqueName,
                selectedValue: this.props.activeButtonType,
                onChange: this.handleButtonTypeChange },

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-collection-modal-run-in-postman-radio-button-seletor' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('label', { className: 'share-collection-modal-run-in-postman-radio-button-seletor-label' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1_react_radio_group__["Radio"], {
                    value: 'cssButton',
                    className: 'share-collection-modal-run-in-postman-radio-button-seletor-button radio-button' }),

                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Dynamic button',

                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-collection-modal-run-in-postman-radio-button-seletor-button-help-text' }, '(HTML friendly)'))),




                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('label', { className: 'share-collection-modal-run-in-postman-radio-button-seletor-label' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1_react_radio_group__["Radio"], {
                    value: 'static-button',
                    className: 'share-collection-modal-run-in-postman-radio-button-seletor-button radio-button' }),

                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Static button',

                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-collection-modal-run-in-postman-radio-button-seletor-button-help-text' }, '(Markdown friendly)'))))),






            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-collection-modal-run-in-postman-environment-selector' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_9__ShareCollectionRunInPostmanEnvironmentSelector__["a" /* default */], {
                environmentsList: this.props.environmentsList,
                selectedEnvironment: this.props.selectedEnvironment,
                onSelect: this.handleEnvironmentSelect,
                ref: 'selector' }))),



          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_TextArea__["a" /* default */], {
            className: 'share-collection-modal-run-in-postman-code-snippet',
            value: generatedCode,
            readOnly: true }),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-collection-modal-run-in-postman-code-actions' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,

              !codeCopied &&
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
                  type: 'primary',
                  onClick: this.handleCopyCodeSnippet,
                  className: 'share-collection-modal-run-in-postman-copy-button' }, 'Copy to Clipboard'),





              codeCopied &&
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], { className: 'share-collection-modal-run-in-postman-copied-button' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__base_Icons_SuccessIcon__["a" /* default */], {
                  style: 'primary',
                  className: 'share-collection-modal-copied-button-icon' })))))));









  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5113:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["a"] = RunIcon;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__Icon__ = __webpack_require__(28);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};


const icon =
__WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('svg', { width: '8', height: '10', viewBox: '0 0 16 16' },
  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('defs', null,
    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('path', { id: 'run', d: 'M11.852 7.726L4.43 3.044a.264.264 0 0 0-.29-.002.319.319 0 0 0-.141.275v9.366a.319.319 0 0 0 .142.275c.09.057.2.056.289-.002l7.42-4.682A.317.317 0 0 0 12 8a.317.317 0 0 0-.148-.274z' })),

  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('use', { fill: '#282828', fillRule: 'evenodd', xlinkHref: '#run' }));



function RunIcon(props) {
  return (
    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__Icon__["a" /* default */], _extends({},
    props, {
      icon: icon })));


}

/***/ }),

/***/ 5114:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ShareCollectionRunInPostmanEnvironmentSelector; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__ = __webpack_require__(31);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__base_Buttons__ = __webpack_require__(13);



let

ShareCollectionRunInPostmanEnvironmentSelector = class ShareCollectionRunInPostmanEnvironmentSelector extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.handleEnvironmentSelect = this.handleEnvironmentSelect.bind(this);
  }

  handleEnvironmentSelect(value) {
    this.props.onSelect && this.props.onSelect(value);
  }

  render() {
    let selectedEnvironmentName = 'No environment';
    if (this.props.selectedEnvironment) {
      let selectedEnvironment = _.find(this.props.environmentsList, env => {
        return env.id === this.props.selectedEnvironment;
      });
      if (selectedEnvironment) {
        selectedEnvironmentName = selectedEnvironment.name;
      }
    }

    let filteredList = _.filter(this.props.environmentsList, environment => {
      return !environment.isDeleted;
    });

    let sortedList = _.sortBy(filteredList, environment => {
      return environment.name.toLowerCase();
    });

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-collection-modal-run-in-postman-environment-selector-container' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["a" /* Dropdown */], {
            onSelect: this.handleEnvironmentSelect,
            className: 'share-collection-modal-dropdown' },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["b" /* DropdownButton */], { type: 'secondary', size: 'small' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__base_Buttons__["a" /* Button */], null,
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-collection-modal-run-in-postman-environment-selector-selected-label' }, selectedEnvironmentName))),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["c" /* DropdownMenu */], { 'align-right': true, className: 'share-collection-modal-run-in-postman-environment-selector-dropdown-menu' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], null, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'No Environment')),

            sortedList.map(environment => {
              return (
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__base_Dropdowns__["d" /* MenuItem */], {
                    key: environment.id,
                    refKey: environment.id,
                    className: 'share-collection-modal-run-in-postman-environment-selector-dropdown-menu-item' },
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, environment.name)));

            })))));





  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5115:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ShareCollectionUploadAndGetLinkContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__utils_util__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__utils_ClipboardHelper__ = __webpack_require__(536);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__modules_services_CollectionRemoteLinkService__ = __webpack_require__(4037);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__components_collections_sharecollection_ShareCollectionUploadAndGetLink__ = __webpack_require__(5116);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__modules_pipelines_app_action__ = __webpack_require__(314);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__stores_get_store__ = __webpack_require__(5);









let { createEvent } = __webpack_require__(226);let

ShareCollectionUploadAndGetLinkContainer = class ShareCollectionUploadAndGetLinkContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
    this.state = {
      collectionLink: null,
      fetchingLink: false,
      linkCopied: false,
      updatedAt: '',
      reFetchingLink: false };

    this.handleCopyUrl = this.handleCopyUrl.bind(this);
    this.handleUploadandGetLink = this.handleUploadandGetLink.bind(this);
    this.handleUpdateCollection = this.handleUpdateCollection.bind(this);
    this.handleDeleteCollectionLink = this.handleDeleteCollectionLink.bind(this);
    this.getLinkForCollection = this.getLinkForCollection.bind(this);
    this.uploadAndGetLink = this.uploadAndGetLink.bind(this);
    this.fetchLinkTimeout = null;
  }

  componentWillMount() {
    this.getLinkForCollection(this.props.collectionId);
  }

  componentWillUnmount() {
    clearTimeout(this.timeout);
    clearTimeout(this.fetchLinkTimeout);
  }

  getLinkForCollection() {
    let collectionId = this.props.collectionId;

    if (collectionId) {

      let currentUser = Object(__WEBPACK_IMPORTED_MODULE_7__stores_get_store__["getStore"])('CurrentUserStore');

      if (!(currentUser && currentUser.isLoggedIn)) {
        console.log('You need to be logged');

        // @todo vineeth for copy.
        return;
      }
      let collectionsRemoteLink = currentUser && currentUser.collections || [],
      collectionLinkObj = _.find(collectionsRemoteLink, ['id', collectionId]) || {};

      this.setState({ collectionLink: collectionLinkObj.link || '' });
    }
  }

  handleUploadandGetLink() {
    if (this.props.newCollection && !this.props.isCollectionCreated) {
      this.props.onCollectionCreated(this.uploadAndGetLink);
    } else
    {
      this.uploadAndGetLink();
    }
  }

  initiateRequest() {
    this.setState({
      fetchingLink: true,
      collectionLink: null });

    this.fetchLinkTimeout = setTimeout(() => {
      this.setState({
        fetchingLink: false,
        collectionLink: null },
      () => {
        pm.toasts.error('Something went wrong while generating a shareable link for your collection. Try again after sometime.');
      });
    }, 20000);
  }

  uploadAndGetLink() {
    this.initiateRequest();

    __WEBPACK_IMPORTED_MODULE_3__modules_services_CollectionRemoteLinkService__["a" /* default */].uploadCollectionForLink(this.props.collectionId).
    then(data => {
      let link = _.get(data, 'link');
      __WEBPACK_IMPORTED_MODULE_6__modules_services_AnalyticsService__["a" /* default */].addEvent('collection', 'share', 'link', null, {
        collection_id: this.props.collectionId,
        collection_link_id: __WEBPACK_IMPORTED_MODULE_1__utils_util__["a" /* default */].getCollectionLinkId(link) });

      this.setState({
        fetchingLink: false,
        collectionLink: link });

      Object(__WEBPACK_IMPORTED_MODULE_5__modules_pipelines_app_action__["a" /* default */])(createEvent('refreshUserCollections', 'user'));
      clearTimeout(this.fetchLinkTimeout);
    }).
    catch(err => {
      pm.logger.error('Error in uploading collection', err);

      // @todo talk to vineeth for the copy to show to user
    });
  }

  handleDeleteCollectionLink() {
    __WEBPACK_IMPORTED_MODULE_3__modules_services_CollectionRemoteLinkService__["a" /* default */].deleteCollectionLink(this.props.collectionId).
    then(() => {
      this.setState({ collectionLink: '' });
      pm.toasts.success('Collection Link deleted');
    }).
    catch(err => {
      console.log('Error in deleting the collection link', err);

      // @todo talk to vineeth for the copy to show to user
    });
  }

  handleCopyUrl() {
    let collectionLink = this.state.collectionLink;
    __WEBPACK_IMPORTED_MODULE_2__utils_ClipboardHelper__["a" /* default */].copy(collectionLink);
    this.setState({ linkCopied: true });
    this.timeout = setTimeout(() => {
      this.setState({ linkCopied: false });
    }, 1000);
  }

  handleUpdateCollection() {
    this.setState({ reFetchingLink: true });

    __WEBPACK_IMPORTED_MODULE_3__modules_services_CollectionRemoteLinkService__["a" /* default */].uploadCollectionForLink(this.props.collectionId).
    then(data => {
      let link = _.get(data, 'link');
      this.setState({
        reFetchingLink: false,
        collectionLink: link });

      Object(__WEBPACK_IMPORTED_MODULE_5__modules_pipelines_app_action__["a" /* default */])(createEvent('refreshUserCollections', 'user'));
      clearTimeout(this.fetchLinkTimeout);
    }).
    catch(err => {
      pm.logger.error('Error in uploading collection', err);
      clearTimeout(this.fetchLinkTimeout);

      // @todo talk to vineeth for the copy to show to user
    });
  }

  render() {

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__components_collections_sharecollection_ShareCollectionUploadAndGetLink__["a" /* default */], {
        onUploadCollection: this.handleUploadandGetLink,
        onDeleteCollectionLink: this.handleDeleteCollectionLink,
        onCopyUrl: this.handleCopyUrl,
        collectionLink: this.state.collectionLink,
        fetchingLink: this.state.fetchingLink,
        linkCopied: this.state.linkCopied,
        onUpdate: this.handleUpdateCollection,
        reFetchingLink: this.state.reFetchingLink,
        isVisible: this.props.isVisible }));


  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5116:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ShareCollectionUploadAndGetLink; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_classnames___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_classnames__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__postman_date_helper__ = __webpack_require__(535);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__postman_date_helper___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2__postman_date_helper__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_Icons_DeleteIcon__ = __webpack_require__(214);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__models_services_DashboardService__ = __webpack_require__(309);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__constants_AppUrlConstants__ = __webpack_require__(64);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__base_Icons_SuccessIcon__ = __webpack_require__(312);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__external_navigation_ExternalNavigationService__ = __webpack_require__(59);











let
ShareCollectionUploadAndGetLink = class ShareCollectionUploadAndGetLink extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.handleUploadandGetLink = this.handleUploadandGetLink.bind(this);
    this.handleCopyUrl = this.handleCopyUrl.bind(this);
    this.handleUpdateCollection = this.handleUpdateCollection.bind(this);
    this.handleOpenPostmanAPILink = this.handleOpenPostmanAPILink.bind(this);
  }

  handleUploadandGetLink() {
    this.props.onUploadCollection && this.props.onUploadCollection();
  }

  handleCopyUrl() {
    this.props.onCopyUrl && this.props.onCopyUrl();
  }

  handleUpdateCollection() {
    this.props.onUpdate && this.props.onUpdate();
  }

  handleOpenCollectionLink(e) {
    e.preventDefault();
    Object(__WEBPACK_IMPORTED_MODULE_6__models_services_DashboardService__["i" /* openCollectionLink */])();
  }

  handleOpenPostmanAPILink(e) {
    e.preventDefault();
    Object(__WEBPACK_IMPORTED_MODULE_9__external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(__WEBPACK_IMPORTED_MODULE_7__constants_AppUrlConstants__["_1" /* PRO_API_LINK */]);
  }

  renderLinkButtons() {
    if (this.props.fetchingLink) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
            className: 'share-collection-modal-getlink-button share-collection-modal-fetching-link-button',
            size: 'small',
            type: 'secondary' }, 'Fetching Link'));




    }

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
          className: 'share-collection-modal-getlink-button',
          size: 'small',
          type: 'primary',
          onClick: this.handleUploadandGetLink }, 'Get Link'));




  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-collection-modal-collection-link-container' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-collection-modal-collection-link-content-wrapper' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-collection-modal-collection-link-text-wrapper' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Generate a shareable link for others to access your collections. You can manage a complete list of your collection links from your'),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('a', {
                onClick: this.handleOpenCollectionLink,
                className: 'share-collection-modal-header-description-link' }, ' Postman Dashboard'),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, '.')),

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-collection-modal-collection-link-section' },

            _.isEmpty(this.props.collectionLink) ?
            this.renderLinkButtons() :

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-collection-modal-collection-link-wrapper' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-collection-modal-collection-link-wrapper__link' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__base_Inputs__["b" /* Input */], {
                  type: 'text',
                  inputStyle: 'box',
                  disabled: true,
                  value: this.props.collectionLink,
                  className: 'share-collection-modal-collection-link' }),

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
                    type: 'primary',
                    size: 'small',
                    disabled: this.props.reFetchingLink,
                    onClick: this.handleUpdateCollection },

                  this.props.reFetchingLink ? 'Fetching Link' : 'Update Link'),

                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
                    className: 'share-collection-modal-collection-link-delete-button',
                    type: 'icon',
                    onClick: this.props.onDeleteCollectionLink,
                    tooltip: 'Delete collection link' },

                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Icons_DeleteIcon__["a" /* default */], { className: 'share-collection-modal-collection-link-delete' }))),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-collection-modal-collection-link-wrapper__clipboard' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-collection-modal-collection-link-wrapper__clipboard__button' },

                  this.props.linkCopied ?
                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
                      className: 'share-collection-modal-copied-button',
                      size: 'small' },

                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__base_Icons_SuccessIcon__["a" /* default */], { style: 'primary' })) :


                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__base_Buttons__["a" /* Button */], {
                      className: 'share-collection-modal-copy-button',
                      disabled: this.props.reFetchingLink,
                      size: 'small',
                      type: 'secondary',
                      onClick: this.handleCopyUrl }, 'Copy To Clipboard'))))),











          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'share-collection-modal-collection-link-footer-text-wrapper' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'This link does not update automatically when changes are made to the collection. Check out the '),
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('a', {
                onClick: this.handleOpenPostmanAPILink,
                className: 'share-collection-modal-header-description-link' }, 'Postman Pro API'),

            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, ' to access your synced collections.')))));




  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5117:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ManageRolesContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_mobx_react__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ManageRoles__ = __webpack_require__(4036);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__modules_services_RolesService__ = __webpack_require__(3593);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__base_LoadingIndicator__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__base_Infobar__ = __webpack_require__(1501);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__base_Icons_WarningIcon__ = __webpack_require__(657);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__base_Icons_SyncOfflineIcon__ = __webpack_require__(544);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__constants_ShareFlowConstants__ = __webpack_require__(3625);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__modules_controllers_SyncWorkspaceController__ = __webpack_require__(658);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__modules_services_share_entities_ShareEntitiesService__ = __webpack_require__(3594);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__PermissionError__ = __webpack_require__(4035);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__modules_services_ShareModalService__ = __webpack_require__(1498);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _class;
















const defaultState = {
  isOpen: false,
  entityId: '',
  entityName: '',
  rolesList: {},
  currentRoles: {},
  isFetchingRoles: true,
  selectedUserRoles: {},
  defaultRole: '',
  isLoading: false,
  alreadySharedIn: [],
  teamMembers: [],
  members: [],
  defaultRoles: {
    team: '',
    user: '' },

  superRoles: {},
  teamRole: {},
  error: null,
  isFetchingWorkspaces: true,
  permissionError: {} },

pluralMap = {
  collection: 'collections',
  api: 'apis' },

rolesPermissionDenied = {
  collection: __WEBPACK_IMPORTED_MODULE_11__constants_ShareFlowConstants__["g" /* COLLECTION_MANAGE_ROLES_ERROR */],
  api: __WEBPACK_IMPORTED_MODULE_11__constants_ShareFlowConstants__["b" /* API_MANAGE_ROLES_ERROR */] },

fetchRolesFail = {
  collection: __WEBPACK_IMPORTED_MODULE_11__constants_ShareFlowConstants__["m" /* FETCH_ROLES_FAILED_COLLECTION */],
  api: __WEBPACK_IMPORTED_MODULE_11__constants_ShareFlowConstants__["l" /* FETCH_ROLES_FAILED_API */] },

updateRolesFailed = {
  collection: __WEBPACK_IMPORTED_MODULE_11__constants_ShareFlowConstants__["A" /* UPDATE_ROLES_FAILED_COLLECTION */],
  api: __WEBPACK_IMPORTED_MODULE_11__constants_ShareFlowConstants__["z" /* UPDATE_ROLES_FAILED_API */] },

notShared = {
  collection: __WEBPACK_IMPORTED_MODULE_11__constants_ShareFlowConstants__["h" /* COLLECTION_NOT_SHARED_ERROR */],
  api: __WEBPACK_IMPORTED_MODULE_11__constants_ShareFlowConstants__["c" /* API_NOT_SHARED_ERROR */] },

shareLabel = {
  collection: 'Collection',
  api: 'API' },

shareEntityHandler = {
  collection: __WEBPACK_IMPORTED_MODULE_15__modules_services_ShareModalService__["b" /* shareCollection */],
  api: __WEBPACK_IMPORTED_MODULE_15__modules_services_ShareModalService__["a" /* shareAPI */] };let



ManageRolesContainer = Object(__WEBPACK_IMPORTED_MODULE_2_mobx_react__["a" /* observer */])(_class = class ManageRolesContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = defaultState;
    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleRoles = this.handleRoles.bind(this);
    this.handleManageRoles = this.handleManageRoles.bind(this);
    this.handleAddMember = this.handleAddMember.bind(this);
    this.handleRemoveMember = this.handleRemoveMember.bind(this);
    this.handleInfobarDismiss = this.handleInfobarDismiss.bind(this);
    this.handleTeamRole = this.handleTeamRole.bind(this);
    this.handleError = this.handleError.bind(this);
  }

  componentDidMount() {
    pm.mediator.on('manageRoles', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('manageRoles', this.handleOpen);
  }

  isOffline() {
    return !Object(__WEBPACK_IMPORTED_MODULE_1__stores_get_store__["getStore"])('SyncStatusStore').isSocketConnected;
  }

  setRoles(entityType, entityId) {
    if (this.isOffline()) {
      return;
    }

    Object(__WEBPACK_IMPORTED_MODULE_4__modules_services_RolesService__["a" /* fetchEntityRoles */])(entityType, entityId).
    then(({ rolesList, userCurrentRoles, defaultRoles, superRoles, teamCurrentRole }) => {
      let teamId = _.get(Object(__WEBPACK_IMPORTED_MODULE_1__stores_get_store__["getStore"])('CurrentUserStore'), 'team.id');

      this.setState({
        isFetchingRoles: false,
        rolesList,
        selectedUserRoles: userCurrentRoles,
        defaultRoles,
        superRoles,
        teamRole: teamCurrentRole[teamId] || {},
        members: _.map(userCurrentRoles, ({ id }) => ({ id })) });

    }).
    catch(e => {
      this.handleError(e, fetchRolesFail[entityType]);
    });
  }

  onWorkspaceJoin(id) {
    this.setState(prevState => {
      return {
        joinedWorkspaces: _extends({},
        prevState.joinedWorkspaces, {
          [id]: true }) };


    });
  }

  setAlreadySharedInWorkspaces(entityType, entityId) {
    __WEBPACK_IMPORTED_MODULE_12__modules_controllers_SyncWorkspaceController__["a" /* default */].
    getAll({ dependencies: true }).
    then(workspaces => {
      let alreadySharedIn = _.filter(workspaces, workspace => {
        return _.includes(_.get(workspace, `dependencies.${pluralMap[entityType]}`, []), entityId);
      });

      this.setState({ alreadySharedIn, isFetchingWorkspaces: false });
    });
  }

  async checkPermissions(entityType, entityId) {
    let isShared = await Object(__WEBPACK_IMPORTED_MODULE_13__modules_services_share_entities_ShareEntitiesService__["f" /* isEntityShared */])(entityType, entityId),
    canManage = isShared && (await Object(__WEBPACK_IMPORTED_MODULE_13__modules_services_share_entities_ShareEntitiesService__["b" /* canManageRolesOnEntity */])(entityType, entityId)),
    permissionError = {
      type: !isShared ? __WEBPACK_IMPORTED_MODULE_11__constants_ShareFlowConstants__["n" /* NOT_SHARED */] : __WEBPACK_IMPORTED_MODULE_11__constants_ShareFlowConstants__["p" /* NO_PERMISSION */],
      message: !isShared ? notShared[entityType] : rolesPermissionDenied[entityType] };


    if (!isShared || !canManage) {
      return Promise.reject(permissionError);
    }

    return Promise.resolve();
  }

  async handleOpen(entityType, entityId, opts = {}) {
    if (!entityType || !entityId) {
      console.warn(`ManageRolesContainer~handleOpen:
      Unsupported entity '${entityType}' provided with ID: '${entityId}'`);
      return;
    }

    Object(__WEBPACK_IMPORTED_MODULE_13__modules_services_share_entities_ShareEntitiesService__["e" /* fetchEntityMeta */])(entityType, entityId).then(entity => {
      this.setState({ entityName: entity.name });
    });


    if (!Object(__WEBPACK_IMPORTED_MODULE_1__stores_get_store__["getStore"])('CurrentUserStore').team) {
      this.setState({
        permissionError: {
          type: __WEBPACK_IMPORTED_MODULE_11__constants_ShareFlowConstants__["r" /* NO_TEAM */],
          message: __WEBPACK_IMPORTED_MODULE_11__constants_ShareFlowConstants__["s" /* NO_TEAM_FOUND_BODY */] },

        isOpen: true,
        entityId,
        entityType });

      return;
    }

    let isOffline = this.isOffline();

    if (!isOffline) {
      this.checkPermissions(entityType, entityId).
      then(() => {
        this.setRoles(entityType, entityId);
        this.setAlreadySharedInWorkspaces(entityType, entityId);
      }).
      catch(permissionError => {
        this.setState({
          permissionError,
          isFetchingRoles: false,
          isFetchingWorkspaces: false });

      });
    }

    this.setState({
      isOpen: true,
      isFetchingRoles: !isOffline,
      entityId,
      entityType,
      teamMembers: Object(__WEBPACK_IMPORTED_MODULE_1__stores_get_store__["getStore"])('TeamStore').allTeamMembers });

  }

  handleClose() {
    this.setState(defaultState);
  }

  handleError(e, fallbackMessage = '') {
    let errorMessage = _.get(e, 'message');

    if (errorMessage) {
      pm.toasts.error(errorMessage);
      errorMessage = null;
    } else
    {
      errorMessage = fallbackMessage || 'Something went wrong';
    }

    this.setState({ isLoading: false, error: errorMessage });
  }

  handleInfobarDismiss() {
    this.setState({ error: null });
  }

  handleRoles(id, type, selectedRole) {
    this.setState(prevState => {
      return {
        selectedUserRoles: _extends({},
        prevState.selectedUserRoles, {
          [id]: { id, type, name: selectedRole } }) };


    });
  }

  handleManageRoles() {
    if (this.isOffline()) {
      return;
    }

    this.setState({ isLoading: true, error: null });

    let { entityType, selectedUserRoles, teamRole, entityId, entityName } = this.state;

    Object(__WEBPACK_IMPORTED_MODULE_4__modules_services_RolesService__["e" /* updateEntityRoles */])(entityType, entityId, selectedUserRoles, teamRole).
    then(() => {
      pm.toasts.success(`Successfully updated the roles for ${_.upperFirst(entityName || entityType)}`);
      this.handleClose();
    }).
    catch(e => {
      this.handleError(e, updateRolesFailed[entityType]);
    });
  }

  handleAddMember(memberId) {
    if (_.some(this.state.members, { id: memberId })) {
      return;
    }

    this.setState(prevState => {
      return {
        members: [
        ...prevState.members,
        { id: memberId }],

        selectedUserRoles: _extends({},
        prevState.selectedUserRoles, {
          [memberId]: {
            id: memberId,
            type: 'user',
            name: prevState.teamRole.name || prevState.defaultRoles.user } }) };



    });
  }

  handleRemoveMember(memberId) {
    this.setState(prevState => {
      return {
        members: _.reject(prevState.members, { id: memberId }),
        selectedUserRoles: _.omit(prevState.selectedUserRoles, memberId) };

    });
  }

  handleTeamRole(role) {
    this.setState(prevState => {
      return {
        teamRole: _extends({},
        prevState.teamRole, {
          name: role }) };


    });
  }

  getStyles() {
    return {
      marginTop: '10vh',
      height: '85vh',
      minWidth: '720px',
      maxHeight: '700px',
      width: '80vw' };

  }

  renderNoPermissionError() {
    let action = {},
    { type } = this.state.permissionError,
    { entityType, entityId } = this.state,
    title = '';

    if (type === __WEBPACK_IMPORTED_MODULE_11__constants_ShareFlowConstants__["n" /* NOT_SHARED */]) {
      action = {
        label: `Share ${shareLabel[entityType]}`,
        onClick: () => {
          shareEntityHandler[entityType](entityId, { origin: 'manage-roles-empty' });
          this.handleClose();
        } };


      title = __WEBPACK_IMPORTED_MODULE_11__constants_ShareFlowConstants__["q" /* NO_ROLES_TO_MANAGE */];
    } else
    if (type === __WEBPACK_IMPORTED_MODULE_11__constants_ShareFlowConstants__["r" /* NO_TEAM */]) {
      title = __WEBPACK_IMPORTED_MODULE_11__constants_ShareFlowConstants__["t" /* NO_TEAM_FOUND_TITLE */];
    }

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__base_Modals__["a" /* Modal */], {
          className: 'modify-permissions-container',
          isOpen: this.state.isOpen,
          onRequestClose: this.handleClose,
          customStyles: this.getStyles() },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__base_Modals__["d" /* ModalHeader */], null, 'MANAGE ROLES ON ',
          _.toUpper(this.state.entityName || this.state.entityType)),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_14__PermissionError__["a" /* default */], {
            thumbnail: type === __WEBPACK_IMPORTED_MODULE_11__constants_ShareFlowConstants__["n" /* NOT_SHARED */] && 'team',
            title: title,
            error: this.state.permissionError.message,
            action: action }))));




  }

  render() {
    if (this.state.permissionError.message) {
      return this.renderNoPermissionError();
    }

    let isOffline = this.isOffline(),
    error = isOffline ? __WEBPACK_IMPORTED_MODULE_11__constants_ShareFlowConstants__["x" /* SYNC_OFFLINE_MESSAGE_MANAGE */] : this.state.error,
    isDisabled = isOffline || this.state.isLoading ||
    this.state.isFetchingRoles || this.state.permissionError.message;

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__base_Modals__["a" /* Modal */], {
          className: 'modify-permissions-container',
          isOpen: this.state.isOpen,
          onRequestClose: this.handleClose,
          customStyles: this.getStyles() },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__base_Modals__["d" /* ModalHeader */], null, 'MANAGE ROLES ON ',
          _.toUpper(this.state.entityName || this.state.entityType)),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__base_Modals__["b" /* ModalContent */], null,

          error &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_7__base_Infobar__["a" /* default */], {
            message: error,
            type: isOffline ? 'warn' : 'error',
            renderIcon: () => {
              return isOffline ?
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_9__base_Icons_SyncOfflineIcon__["a" /* default */], { className: 'modify-permissions-container--infobar-icon is-offline' }) :
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_8__base_Icons_WarningIcon__["a" /* default */], { className: 'modify-permissions-container--infobar-icon' });
            },
            onDismiss: this.handleInfobarDismiss }),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__ManageRoles__["a" /* default */], {
            canModifyMembers: true,
            isOffline: isOffline,
            members: this.state.members,
            allTeamMembers: this.state.teamMembers,
            selectedUserRoles: this.state.selectedUserRoles,
            isFetchingRoles: this.state.isFetchingRoles,
            isFetchingWorkspaces: this.state.isFetchingWorkspaces,
            rolesList: this.state.rolesList,
            superRoles: this.state.superRoles,
            onChange: this.handleRoles,
            alreadySharedIn: this.state.alreadySharedIn,
            onAddMember: this.handleAddMember,
            onRemoveMember: this.handleRemoveMember,
            teamRole: this.state.teamRole,
            onTeamRoleChange: this.handleTeamRole })),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__base_Modals__["c" /* ModalFooter */], { separated: true },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Buttons__["a" /* Button */], {
              disabled: isDisabled,
              type: 'primary',
              onClick: this.handleManageRoles,
              className: 'modify-permissions-container--action' },


            this.state.isLoading ?
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_6__base_LoadingIndicator__["a" /* default */], null) :
            'Save Roles'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__base_Buttons__["a" /* Button */], {
              type: 'secondary',
              onClick: this.handleClose }, 'Cancel'))));






  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5118:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return UserLoginMigrationModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_base_Modals__ = __webpack_require__(189);

let

UserLoginMigrationModalContainer = class UserLoginMigrationModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      message: 'Setting up your workspaces…' };

  }

  componentWillMount() {
    this.unsubscribe = pm.eventBus.channel('user-login').subscribe(event => {
      if (!event) {
        return;
      }

      if (event.namespace !== 'userlogin') {
        return;
      }

      // post login migration is happening
      if (event.name === 'migrationstep') {
        this.setState({
          isOpen: true });

      }

      // post login migration is complete
      else if (event.name === 'migrationcomplete') {
          this.setState({
            isOpen: false });

        }
    });
  }

  componentWillUnmount() {
    this.unsubscribe && this.unsubscribe();
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Modals__["a" /* Modal */], {
          isOpen: this.state.isOpen,
          className: 'user-login-migration-modal' },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Modals__["d" /* ModalHeader */], null, 'WAIT A MOMENT'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__components_base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'user-login-migration-modal-message' },
            this.state.message))));




  }};

/***/ }),

/***/ 5119:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SwitchDirtyVersionModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__SwitchDirtyVersionModal__ = __webpack_require__(5120);
var _class;

let


SwitchDirtyVersionModalContainer = __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default()(_class = class SwitchDirtyVersionModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      onSave: null,
      onDiscard: null };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleSave = this.handleSave.bind(this);
    this.handleDiscard = this.handleDiscard.bind(this);
    this.handleClose = this.handleClose.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('showSwitchDirtyVersionModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showSwitchDirtyVersionModal', this.handleOpen);
  }

  handleOpen(onSave, onDiscard) {
    this.setState({
      isOpen: true,
      onSave: onSave,
      onDiscard: onDiscard });

  }

  handleClose() {
    this.setState({
      isOpen: false,
      onSave: null,
      onDiscard: null });

  }

  handleSave() {
    this.state.onSave && _.isFunction(this.state.onSave) && this.state.onSave();
    this.handleClose();
  }

  handleDiscard() {
    this.state.onDiscard && _.isFunction(this.state.onDiscard) && this.state.onDiscard();
    this.handleClose();
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__SwitchDirtyVersionModal__["a" /* default */], {
        isOpen: this.state.isOpen,
        onClose: this.handleClose,
        onSave: this.handleSave,
        onDiscard: this.handleDiscard }));


  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5120:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SwitchDirtyVersionModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__js_components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__js_components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__js_components_base_keymaps_KeyMaps__ = __webpack_require__(72);





const MODAL_BUTTON_SAVE = 'save',
MODAL_BUTTON_DISCARD = 'discard',
MODAL_BUTTON_CANCEL = 'cancel';let
SwitchDirtyVersionModal = class SwitchDirtyVersionModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = { focusedButton: MODAL_BUTTON_SAVE };

    this.handleClose = this.handleClose.bind(this);
    this.handleSave = this.handleSave.bind(this);
    this.handleDiscard = this.handleDiscard.bind(this);
    this.handleSwitchFocus = this.handleSwitchFocus.bind(this);
    this.handleFocusClick = this.handleFocusClick.bind(this);
    this.getKeyMapHandlers = this.getKeyMapHandlers.bind(this);
  }

  // to initially set focus on save button each time the modal is fired up
  componentWillReceiveProps() {
    this.setState({
      focusedButton: MODAL_BUTTON_SAVE },
    () => {
      // componentDidUpdate will get called before ref get attached to any children of the modal
      // thus waiting for the whole event loop for re-rendering to finish before calling focus on ref
      requestIdleCallback(() => {
        this.keyMapsRef && this.keyMapsRef.focus();
      });
    });
  }

  handleClose() {
    this.props.onClose && this.props.onClose();
  }

  handleSave() {
    this.props.onSave && this.props.onSave();
  }

  handleDiscard() {
    this.props.onDiscard && this.props.onDiscard();
  }

  getCustomStyles() {
    return { marginTop: '35vh' };
  }

  handleSwitchFocus(e) {
    e.stopPropagation();
    e.preventDefault();

    let tabOrder = [MODAL_BUTTON_DISCARD, MODAL_BUTTON_CANCEL, MODAL_BUTTON_SAVE],
    currentFocus = _.findIndex(tabOrder, tab => {return tab === this.state.focusedButton;}),
    nextFocus = tabOrder[(currentFocus + 1) % tabOrder.length];

    this.setState({ focusedButton: nextFocus });
  }

  handleFocusClick() {
    switch (this.state.focusedButton) {
      case MODAL_BUTTON_DISCARD:
        this.handleDiscard();
        break;
      case MODAL_BUTTON_CANCEL:
        this.handleClose();
        break;
      case MODAL_BUTTON_SAVE:
        this.handleSave();
        break;
      default:
        return;}

  }

  getKeyMapHandlers() {
    return {
      quit: pm.shortcuts.handle('quit', this.props.handleClose), // cancel closing tab
      select: pm.shortcuts.handle('select', this.handleFocusClick), // save and close
      submit: pm.shortcuts.handle('submit', this.handleFocusClick), // save and close
      space: pm.shortcuts.handle('space', this.handleFocusClick), // select whichever is highlighted
      focusNext: pm.shortcuts.handle('focusNext', this.handleSwitchFocus) // focus next item
    };
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__js_components_base_Modals__["a" /* Modal */], {
          isOpen: this.props.isOpen,
          onRequestClose: this.handleClose,
          className: 'unsaved-api-version-confirmation-modal',
          customStyles: this.getCustomStyles() },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__js_components_base_Modals__["d" /* ModalHeader */], null, 'SAVE CHANGES?'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__js_components_base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, 'This version has unsaved changes. Save before switching versions to avoid losing your work.')),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__js_components_base_Modals__["c" /* ModalFooter */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__js_components_base_keymaps_KeyMaps__["a" /* default */], { keyMap: pm.shortcuts.getShortcuts(), handlers: this.getKeyMapHandlers(), ref: component => this.keyMapsRef = component },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'unsaved-api-version-confirmation-modal__footer' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'unsaved-api-version-confirmation-modal__footer__left' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__js_components_base_Buttons__["a" /* Button */], {
                    type: 'secondary',
                    onClick: this.handleDiscard,
                    focused: this.state.focusedButton === MODAL_BUTTON_DISCARD }, 'Don\'t Save')),




              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'unsaved-api-version-confirmation-modal__footer__right' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__js_components_base_Buttons__["a" /* Button */], {
                    type: 'primary',
                    onClick: this.handleSave,
                    focused: this.state.focusedButton === MODAL_BUTTON_SAVE }, 'Save Changes'),



                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__js_components_base_Buttons__["a" /* Button */], {
                    type: 'secondary',
                    onClick: this.handleClose,
                    focused: this.state.focusedButton === MODAL_BUTTON_CANCEL }, 'Cancel')))))));









  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5121:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return MockModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_uuid_v4__ = __webpack_require__(47);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_uuid_v4___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_uuid_v4__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__js_stores_get_store__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__js_components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__js_components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__js_components_base_LoadingIndicator__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__js_modules_services_AnalyticsService__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__js_services_EditorService__ = __webpack_require__(66);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__js_utils_EditorUtils__ = __webpack_require__(113);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__js_utils_EditorUtils___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_8__js_utils_EditorUtils__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__components_MockModal__ = __webpack_require__(5122);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__js_components_base_XPaths_XPath__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__js_containers_new_button_services_VersionTagService__ = __webpack_require__(984);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__js_modules_model_event__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__js_modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__js_external_navigation_ExternalNavigationService__ = __webpack_require__(59);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__constants_MockErrors__ = __webpack_require__(4038);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__constants_intents__ = __webpack_require__(3920);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__services_MockCreateService__ = __webpack_require__(5125);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__services_MockEditService__ = __webpack_require__(5126);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19_mobx_react__ = __webpack_require__(11);
var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _class;




















let initialState = {
  isOpen: false,
  activeStep: 1,
  ownEnvironments: [],
  ownVersions: [],
  from: '',
  intent: '',
  selectedOptions: {
    name: '',
    isPrivate: false,
    collectionId: '',
    ownerId: '',
    environmentId: '',
    mockUrl: '',
    versionId: '',
    collectionName: '' },

  initialMockState: {
    name: '',
    isPrivate: '',
    versionId: '',
    environmentId: '' },

  mockStatus: {
    loading: false,
    error: false },

  versionStatus: {
    loading: false,
    error: false } };let




MockModalContainer = Object(__WEBPACK_IMPORTED_MODULE_19_mobx_react__["a" /* observer */])(_class = class MockModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = initialState;

    this.loadOwnVersions = this.loadOwnVersions.bind(this);
    this.handleOpenRequestInTab = this.handleOpenRequestInTab.bind(this);
    this.handleOpen = this.handleOpen.bind(this);
    this.handleClose = this.handleClose.bind(this);
    this.handleSelectEnvironment = this.handleSelectEnvironment.bind(this);
    this.handleSelectVersion = this.handleSelectVersion.bind(this);
    this.handleMockNameChange = this.handleMockNameChange.bind(this);
    this.handleCreate = this.handleCreate.bind(this);
    this.handleEdit = this.handleEdit.bind(this);
    this.handlePrivateChange = this.handlePrivateChange.bind(this);
    this.handleRetry = this.handleRetry.bind(this);
    this.handleVersionFetchRetry = this.handleVersionFetchRetry.bind(this);
    this.handleOfflineRetry = this.handleOfflineRetry.bind(this);
    this.handleOpenLink = this.handleOpenLink.bind(this);
  }

  componentDidMount() {
    pm.mediator.on('openMockModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('openMockModal', this.handleOpen);
  }

  getStyles() {
    return {
      marginTop: '10vh',
      height: '75vh',
      minWidth: '900px',
      width: '80vw' };

  }

  handleOpenLink(link) {
    link && Object(__WEBPACK_IMPORTED_MODULE_14__js_external_navigation_ExternalNavigationService__["a" /* openExternalLink */])(link);
  }

  loadOwnVersions(criteria) {
    return Object(__WEBPACK_IMPORTED_MODULE_11__js_containers_new_button_services_VersionTagService__["a" /* fetchAllTags */])(criteria);
  }

  handleOpenRequestInTab() {
    let activeWorkspaceSessionId = Object(__WEBPACK_IMPORTED_MODULE_2__js_stores_get_store__["getStore"])('ActiveWorkspaceSessionStore').id;

    this.handleClose();

    // open the mock as a request with Url pre filled
    __WEBPACK_IMPORTED_MODULE_7__js_services_EditorService__["a" /* default */].open(Object(__WEBPACK_IMPORTED_MODULE_8__js_utils_EditorUtils__["requestResourceId"])({ id: __WEBPACK_IMPORTED_MODULE_1_uuid_v4___default()() }), {
      initialValue: { url: this.state.selectedOptions.mockUrl } });


    Object(__WEBPACK_IMPORTED_MODULE_13__js_modules_pipelines_user_action__["a" /* default */])(Object(__WEBPACK_IMPORTED_MODULE_12__js_modules_model_event__["a" /* createEvent */])(
    'setActiveEnvironment',
    'workspacesession',
    {
      workspaceSession: { id: activeWorkspaceSessionId },
      activeEnvironment: this.state.selectedOptions.environmentId }));


  }

  handleOpen(openState = {}, onSuccess, intent = __WEBPACK_IMPORTED_MODULE_16__constants_intents__["a" /* CREATE */]) {
    let environmentId = null,
    environmentStore = Object(__WEBPACK_IMPORTED_MODULE_2__js_stores_get_store__["getStore"])('EnvironmentStore'),
    activeWorkspaceStore = Object(__WEBPACK_IMPORTED_MODULE_2__js_stores_get_store__["getStore"])('ActiveWorkspaceStore'),
    environment = environmentStore.find(Object(__WEBPACK_IMPORTED_MODULE_2__js_stores_get_store__["getStore"])('ActiveEnvironmentStore').id),
    environments = activeWorkspaceStore.environments,
    sortedEnvironments = _.sortBy(environments, e => _.toLower(e.name)),
    collection = openState.collectionId && Object(__WEBPACK_IMPORTED_MODULE_2__js_stores_get_store__["getStore"])('CollectionStore').find(openState.collectionId),
    data = {};

    if (environment) {
      environmentId = environment.id;
    }

    environments = _.concat({
      id: null,
      name: 'No Environment' },
    sortedEnvironments);
    data.ownEnvironments = environments;

    if (collection) {
      data.selectedOptions = {
        environmentId,
        collectionId: collection.id,
        ownerId: collection.owner,
        collectionName: collection.name };

    }

    if (intent === __WEBPACK_IMPORTED_MODULE_16__constants_intents__["b" /* EDIT */]) {
      const { name, isPrivate, mockUrl, versionId, environmentId, mockId } = openState.mock;

      data.selectedOptions = _extends({},
      data.selectedOptions, {
        mockId,
        name,
        isPrivate,
        mockUrl,
        versionId,
        environmentId });

    }

    this.setState(_extends({},
    initialState,
    data, {
      from: openState.opts.from,
      intent, // edit or create mock
      versionStatus: _extends({},
      this.state.versionStatus, {
        loading: true }),

      isOpen: true }));


    this.loadOwnVersions({
      collectionUid: `${_.get(collection, 'owner')}-${_.get(collection, 'id')}` }).

    then(versions => {
      let selectedVersionId = this.state.intent === __WEBPACK_IMPORTED_MODULE_16__constants_intents__["a" /* CREATE */] ? _.get(versions, '0.id') :
      this.state.selectedOptions.versionId || 'latest'; // 'latest' is returned as null by mock service

      this.setState({
        ownVersions: versions,
        versionStatus: _extends({},
        this.state.versionStatus, {
          loading: false }),

        selectedOptions: _extends({},
        this.state.selectedOptions, {
          versionId: selectedVersionId }),

        initialMockState: {
          name: this.state.selectedOptions.name,
          isPrivate: this.state.selectedOptions.isPrivate,
          versionId: selectedVersionId,
          environmentId: this.state.selectedOptions.environmentId } },

      () => {
        _.invoke(this.contentRef, 'onCollectionSelect');
      });

      if (intent === __WEBPACK_IMPORTED_MODULE_16__constants_intents__["b" /* EDIT */]) {
        __WEBPACK_IMPORTED_MODULE_6__js_modules_services_AnalyticsService__["a" /* default */].addEventV2({
          category: 'mock',
          action: 'initiate_edit',
          label: this.state.from,
          entityId: _.get(openState, 'mock.mockId') });

      } else
      {
        __WEBPACK_IMPORTED_MODULE_6__js_modules_services_AnalyticsService__["a" /* default */].addEvent('mock', 'initiate_create', this.state.from);
      }
    }).
    catch(err => {
      this.setState({
        versionStatus: {
          loading: false,
          error: true } });


      pm.toasts.error(_.get(err, 'message') || __WEBPACK_IMPORTED_MODULE_15__constants_MockErrors__["a" /* ERROR_FETCHING_VERSIONS */]);
    });

    this.onSuccess = onSuccess;
  }

  handleClose() {
    this.setState(initialState);
    this.onSuccess = null;
  }

  handleCreate() {
    if (!Object(__WEBPACK_IMPORTED_MODULE_2__js_stores_get_store__["getStore"])('SyncStatusStore').isSocketConnected) {
      pm.toasts.error(__WEBPACK_IMPORTED_MODULE_15__constants_MockErrors__["c" /* MOCK_CREATION_FAILED */]);

      return;
    }

    this.setState({
      activeStep: 2,
      mockStatus: _extends({},
      this.state.mockStatus, {
        loading: true }) });



    Object(__WEBPACK_IMPORTED_MODULE_17__services_MockCreateService__["a" /* default */])(this.state.selectedOptions).then(mockData => {
      this.setState(state => {
        return {
          selectedOptions: _extends({},
          state.selectedOptions, {
            mockUrl: mockData && mockData.url }),

          mockStatus: {
            loading: false,
            error: false } };


      }, () => {
        __WEBPACK_IMPORTED_MODULE_6__js_modules_services_AnalyticsService__["a" /* default */].addEventV2({
          category: 'mock',
          action: 'confirm_create',
          label: this.state.from,
          entityId: mockData && mockData.id });

        pm.mediator.trigger('focusCollectionInSideBar', this.state.selectedOptions.collectionId, 'Mocks');
        this.onSuccess && this.onSuccess();
      });
    }).catch(() => {
      this.setState(() => {
        return {
          mockStatus: {
            loading: false,
            error: true } };


      });
    });
  }

  handleEdit() {
    if (!Object(__WEBPACK_IMPORTED_MODULE_2__js_stores_get_store__["getStore"])('SyncStatusStore').isSocketConnected) {
      pm.toasts.error(__WEBPACK_IMPORTED_MODULE_15__constants_MockErrors__["e" /* MOCK_EDIT_FAILED */]);

      return;
    }

    this.setState(prevState => ({
      mockStatus: _extends({},
      prevState.mockStatus, {
        loading: true }) }));



    Object(__WEBPACK_IMPORTED_MODULE_18__services_MockEditService__["a" /* default */])(this.state.selectedOptions).then(mockData => {
      this.setState({
        mockStatus: {
          loading: false,
          error: false } },

      () => {
        __WEBPACK_IMPORTED_MODULE_6__js_modules_services_AnalyticsService__["a" /* default */].addEventV2({
          category: 'mock',
          action: 'confirm_edit',
          label: this.state.from,
          entityId: mockData && mockData.id });

        pm.mediator.trigger('focusCollectionInSideBar', this.state.selectedOptions.collectionId, 'Mocks');
        this.onSuccess && this.onSuccess();
        pm.toasts.success(`You updated the ${_.get(this.state.selectedOptions, 'name')} Mock Server.`,
        { noIcon: false, title: 'Changes saved' });
        this.handleClose();
      });
    }).catch(() => {
      this.setState(() => {
        return {
          mockStatus: {
            loading: false,
            error: true } };


      });
      pm.toasts.error(__WEBPACK_IMPORTED_MODULE_15__constants_MockErrors__["e" /* MOCK_EDIT_FAILED */]);
    });
  }

  handleSelectEnvironment(environmentId) {
    this.setState(state => {
      return {
        selectedOptions: _extends({},
        state.selectedOptions, {
          environmentId: _.isEqual(environmentId, 'no-environment') ? '' : environmentId }) };


    });
  }

  handleMockNameChange(name) {
    this.setState(state => {
      return {
        selectedOptions: _extends({},
        state.selectedOptions, {
          name }) };


    });
  }

  handleSelectVersion(versionId) {
    this.setState(state => {
      return {
        selectedOptions: _extends({},
        state.selectedOptions, {
          versionId }) };


    });
  }

  handlePrivateChange(isPrivate) {
    this.setState(state => {
      return {
        selectedOptions: _extends({},
        state.selectedOptions, {
          isPrivate }) };


    });
  }

  handleVersionFetchRetry() {
    this.setState({
      versionStatus: {
        loading: true,
        error: false } },

    () => {
      this.loadOwnVersions({
        collectionUid: `${_.get(this.state, 'selectedOptions.ownerId')}-${_.get(this.state, 'selectedOptions.collectionId')}` }).

      then(versions => {
        let selectedVersionId = this.state.intent === __WEBPACK_IMPORTED_MODULE_16__constants_intents__["a" /* CREATE */] ? _.get(versions, '0.id') :
        this.state.selectedOptions.versionId || 'latest'; // 'latest' is returned as null by mock service

        this.setState({
          ownVersions: versions,
          versionStatus: _extends({},
          this.state.versionStatus, {
            loading: false }),

          selectedOptions: _extends({},
          this.state.selectedOptions, {
            versionId: selectedVersionId }),

          initialMockState: {
            name: this.state.selectedOptions.name,
            isPrivate: this.state.selectedOptions.isPrivate,
            versionId: selectedVersionId,
            environmentId: this.state.selectedOptions.environmentId } });


      }).
      catch(err => {
        this.setState({
          versionStatus: {
            loading: false,
            error: true } });



        pm.toasts.error(_.get(err, 'message') || __WEBPACK_IMPORTED_MODULE_15__constants_MockErrors__["a" /* ERROR_FETCHING_VERSIONS */]);
      });
    });
  }

  handleRetry() {
    if (!Object(__WEBPACK_IMPORTED_MODULE_2__js_stores_get_store__["getStore"])('SyncStatusStore').isSocketConnected) {
      return;
    }

    if (this.state.mockStatus.error) {
      this.setState({
        mockStatus: {
          error: false,
          loading: true } },

      () => {
        this.handleCreate();
      });
    }
  }

  handleOfflineRetry() {
    if (!Object(__WEBPACK_IMPORTED_MODULE_2__js_stores_get_store__["getStore"])('SyncStatusStore').isSocketConnected) {
      this.setState({
        versionStatus: _extends({},
        this.state.versionStatus, {
          error: false }) });



      return;
    }

    if (this.state.ownVersions.length === 0) {
      this.handleVersionFetchRetry();
    }
  }

  render() {
    let currentUser = Object(__WEBPACK_IMPORTED_MODULE_2__js_stores_get_store__["getStore"])('CurrentUserStore'),
    isLoggedIn = currentUser && currentUser.isLoggedIn,
    isSyncEnabled = Object(__WEBPACK_IMPORTED_MODULE_2__js_stores_get_store__["getStore"])('GateKeeperStore').isSyncEnabled,
    isOffline = !Object(__WEBPACK_IMPORTED_MODULE_2__js_stores_get_store__["getStore"])('SyncStatusStore').isSocketConnected,
    isFooterVisible = isLoggedIn &&
    isSyncEnabled &&
    !this.state.versionStatus.loading &&
    !this.state.versionStatus.error &&
    !this.state.mockStatus.error &&
    !isOffline;

    // on submitting with 'create' intent, hide the footer to display step 2
    if (this.state.intent === __WEBPACK_IMPORTED_MODULE_16__constants_intents__["a" /* CREATE */]) {
      isFooterVisible = isFooterVisible && !this.state.mockStatus.loading;
    }

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__js_components_base_XPaths_XPath__["a" /* default */], { identifier: 'createMockModal', isVisible: this.state.isOpen },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__js_components_base_Modals__["a" /* Modal */], {
            className: 'mock-modal',
            customStyles: this.getStyles(),
            isOpen: this.state.isOpen,
            onRequestClose: this.handleClose },

          this.state.intent === __WEBPACK_IMPORTED_MODULE_16__constants_intents__["a" /* CREATE */] && __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__js_components_base_Modals__["d" /* ModalHeader */], null, 'Create mock server'),
          this.state.intent === __WEBPACK_IMPORTED_MODULE_16__constants_intents__["b" /* EDIT */] && __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__js_components_base_Modals__["d" /* ModalHeader */], null, 'Edit mock server'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__js_components_base_Modals__["b" /* ModalContent */], { className: 'modal-content' },
            isLoggedIn && isSyncEnabled &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_9__components_MockModal__["a" /* default */], {
              contentRef: ref => this.contentRef = ref,
              activeStep: this.state.activeStep,
              isOffline: isOffline,
              versionStatus: this.state.versionStatus,
              onOfflineRetry: this.handleOfflineRetry,
              ownEnvironments: this.state.ownEnvironments,
              ownVersions: this.state.ownVersions,
              onSelectCollection: this.handleSelectCollection,
              onSelectEnvironment: this.handleSelectEnvironment,
              onSelectVersion: this.handleSelectVersion,
              selectedOptions: this.state.selectedOptions,
              onMockNameChange: this.handleMockNameChange,
              onMockPrivateChange: this.handlePrivateChange,
              openRequestInTab: this.handleOpenRequestInTab,
              onSubmit: this.state.intent === __WEBPACK_IMPORTED_MODULE_16__constants_intents__["a" /* CREATE */] ? this.handleCreate : this.handleEdit,
              onRetry: this.handleRetry,
              onVersionFetchRetry: this.handleVersionFetchRetry,
              onClose: this.handleClose,
              mockStatus: this.state.mockStatus,
              onOpenLink: this.handleOpenLink })),



          isFooterVisible &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__js_components_base_Modals__["c" /* ModalFooter */], { className: 'mock-modal__footer' },

            this.state.activeStep === 1 &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'mock-modal__footer__button__container' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__js_components_base_XPaths_XPath__["a" /* default */], { identifier: 'cancel' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__js_components_base_Buttons__["a" /* Button */], {
                    type: 'secondary',
                    onClick: this.handleClose }, 'Cancel')),





              this.state.intent === __WEBPACK_IMPORTED_MODULE_16__constants_intents__["a" /* CREATE */] &&
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__js_components_base_XPaths_XPath__["a" /* default */], { identifier: 'create' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__js_components_base_Buttons__["a" /* Button */], {
                    type: 'primary',
                    disabled: !_.trimStart(this.state.selectedOptions.name),
                    onClick: this.handleCreate }, 'Create mock server')),






              this.state.intent === __WEBPACK_IMPORTED_MODULE_16__constants_intents__["b" /* EDIT */] &&
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__js_components_base_XPaths_XPath__["a" /* default */], { identifier: 'edit' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__js_components_base_Buttons__["a" /* Button */], {
                    type: 'primary',
                    disabled: !_.trimStart(this.state.selectedOptions.name) || _.isEqual(this.state.initialMockState, {
                      name: this.state.selectedOptions.name,
                      isPrivate: this.state.selectedOptions.isPrivate,
                      versionId: this.state.selectedOptions.versionId,
                      environmentId: this.state.selectedOptions.environmentId }) ||
                    this.state.mockStatus.loading,
                    onClick: this.handleEdit },


                  this.state.mockStatus.loading ?

                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__js_components_base_LoadingIndicator__["a" /* default */], null) :


                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Save Changes')))),








            this.state.activeStep === 2 &&
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null,
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_10__js_components_base_XPaths_XPath__["a" /* default */], { identifier: 'close' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__js_components_base_Buttons__["a" /* Button */], {
                    type: 'primary',
                    onClick: this.handleClose }, 'Close')))))));











  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5122:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return MockModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__js_components_new_button_CreationError__ = __webpack_require__(963);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__MockForm__ = __webpack_require__(5123);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__CreateMockSuccess__ = __webpack_require__(5124);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__constants_MockErrors__ = __webpack_require__(4038);




let

MockModal = class MockModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  componentWillReceiveProps(nextProps) {
    if (this.props.isOffline && !nextProps.isOffline && _.isEmpty(nextProps.ownVersions)) {
      this.props.onVersionFetchRetry();
    }
  }

  render() {
    if (this.props.mockStatus.error) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'mock-modal__error' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__js_components_new_button_CreationError__["a" /* default */], {
            subtitle: __WEBPACK_IMPORTED_MODULE_4__constants_MockErrors__["d" /* MOCK_CREATION_TRY_AGAIN */],
            onRetry: this.props.onRetry })));



    }

    if (this.props.isOffline && this.props.activeStep !== 2) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'mock-modal__error' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__js_components_new_button_CreationError__["a" /* default */], {
            subtitle: __WEBPACK_IMPORTED_MODULE_4__constants_MockErrors__["b" /* INTERNET_ERROR */],
            onRetry: this.props.onOfflineRetry })));



    }

    if (this.props.versionStatus.error) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'mock-modal__error' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__js_components_new_button_CreationError__["a" /* default */], {
            subtitle: __WEBPACK_IMPORTED_MODULE_4__constants_MockErrors__["b" /* INTERNET_ERROR */],
            onRetry: this.props.onVersionFetchRetry })));



    }

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'mock-modal__content' },

        this.props.activeStep === 1 &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__MockForm__["a" /* default */], {
          ref: this.props.contentRef,
          versionStatus: this.props.versionStatus,
          ownEnvironments: this.props.ownEnvironments,
          ownVersions: this.props.ownVersions,
          onSelectCollection: this.props.onSelectCollection,
          onSelectEnvironment: this.props.onSelectEnvironment,
          onSelectVersion: this.props.onSelectVersion,
          selectedOptions: this.props.selectedOptions,
          onMockNameChange: this.props.onMockNameChange,
          onMockPrivateChange: this.props.onMockPrivateChange,
          onSubmit: this.props.onSubmit,
          onClose: this.props.onClose,
          onOpenLink: this.props.onOpenLink }),



        this.props.activeStep === 2 &&
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__CreateMockSuccess__["a" /* default */], {
          selectedOptions: this.props.selectedOptions,
          openRequestInTab: this.props.openRequestInTab,
          onClose: this.props.onClose,
          mockStatus: this.props.mockStatus,
          onOpenLink: this.props.onOpenLink })));




  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5123:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return MockForm; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__js_components_base_Inputs__ = __webpack_require__(55);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__js_components_base_Dropdowns__ = __webpack_require__(31);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__js_components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__js_components_base_LoadingIndicator__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__js_components_base_XPaths_XPath__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__js_constants_AppUrlConstants__ = __webpack_require__(64);







let

MockForm = class MockForm extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.handleEnter = this.handleEnter.bind(this);
  }

  getSelectedOptionName(list, selectedItem, defaultValue) {
    return _.get(_.find(list, ['id', selectedItem]), 'name', defaultValue);
  }

  onCollectionSelect() {
    _.invoke(this.refs, 'mockName.focus');
  }

  handleEnter() {
    _.trimStart(this.props.selectedOptions.name) && this.props.onSubmit();
  }

  renderMenuItems(items) {
    return _.map(items, item => {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__js_components_base_Dropdowns__["d" /* MenuItem */], {
            key: item.id,
            refKey: item.id },

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, item.name)));


    });
  }

  render() {
    if (this.props.versionStatus.loading) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-form__body step1 is-loading' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_4__js_components_base_LoadingIndicator__["a" /* default */], null)));


    }

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-form__body step1' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-form__body__input-group' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-form__body__label' }, 'Name your mock server'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-form__body__input' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-form__body__field' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__js_components_base_XPaths_XPath__["a" /* default */], { identifier: 'mockName', isVisible: !this.props.versionStatus.loading },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__js_components_base_Inputs__["b" /* Input */], {
                  ref: 'mockName',
                  inputStyle: 'box',
                  value: this.props.selectedOptions.name || '',
                  onChange: this.props.onMockNameChange,
                  onEnter: this.handleEnter }))))),





        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-form__body__input-group' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-form__body__label' }, 'Select a version tag'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-form__body__input' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-form__body__field' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__js_components_base_XPaths_XPath__["a" /* default */], { identifier: 'mockVersion' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__js_components_base_Dropdowns__["a" /* Dropdown */], {
                    allowScroll: true,
                    fullWidth: true,
                    onSelect: this.props.onSelectVersion,
                    className: 'create-mock-form__version-dropdown' },

                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__js_components_base_Dropdowns__["b" /* DropdownButton */], {
                      size: 'small',
                      type: 'secondary' },

                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__js_components_base_Buttons__["a" /* Button */], null,
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'create-mock-form__version-dropdown__button-label' },
                        this.getSelectedOptionName(this.props.ownVersions, this.props.selectedOptions.versionId, '')))),



                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__js_components_base_Dropdowns__["c" /* DropdownMenu */], { fluid: true },
                    this.renderMenuItems(this.props.ownVersions))))),




            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-form__body__input__helptext' }, 'Version tags allow you to link the mock sever to a specific API version.'))),




        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-form__body__input-group' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-form__body__label' }, 'Select an environment (optional)'),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-form__body__input' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-form__body__field' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_5__js_components_base_XPaths_XPath__["a" /* default */], { identifier: 'environment' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__js_components_base_Dropdowns__["a" /* Dropdown */], {
                    allowScroll: true,
                    fullWidth: true,
                    onSelect: this.props.onSelectEnvironment },

                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__js_components_base_Dropdowns__["b" /* DropdownButton */], {
                      size: 'small',
                      type: 'secondary' },

                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__js_components_base_Buttons__["a" /* Button */], null,
                      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'environment-dropdown__button-label' },
                        this.getSelectedOptionName(this.props.ownEnvironments, this.props.selectedOptions.environmentId, 'No Environment')))),



                  __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__js_components_base_Dropdowns__["c" /* DropdownMenu */], { fluid: true },

                    _.isEmpty(this.props.ownEnvironments) ?
                    __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__js_components_base_Dropdowns__["d" /* MenuItem */], { refKey: '' }, __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'No Environment')) :
                    this.renderMenuItems(this.props.ownEnvironments))))),





            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-form__body__input__helptext' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Environments are groups of variables. The mock server will use the variable values from the selected environment in the request and response. ')))),



        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-form__body__input-group create-mock-form__body__input-group__private' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-form__body__input' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-form__body__field' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__js_components_base_Inputs__["a" /* Checkbox */], {
                checked: this.props.selectedOptions.isPrivate,
                onChange: this.props.onMockPrivateChange }),

              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', {
                  onClick: this.props.onMockPrivateChange.bind(this, !this.props.selectedOptions.isPrivate),
                  className: 'create-new-mock__body__input__label--checkbox' }, 'Make this mock server private')),




            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-form__body__input__helptext' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Note: To call a private mock server, you\'ll need to add an '),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('code', { className: 'create-mock-form__body__input__helptext__markdown' }, 'x-api-key'),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, ' header to your requests. See how to '),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__js_components_base_Buttons__["a" /* Button */], {
                  type: 'text',
                  onClick: this.props.onOpenLink.bind(this, __WEBPACK_IMPORTED_MODULE_6__js_constants_AppUrlConstants__["Z" /* PRO_API_INTRO */]),
                  className: 'learn-more-link' }, 'generate a Postman API key.'))))));








  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5124:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CreateMockSuccess; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__js_components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__js_components_base_LoadingIndicator__ = __webpack_require__(71);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__js_components_base_Icons_MockIcon__ = __webpack_require__(960);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__js_models_services_DashboardService__ = __webpack_require__(309);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__js_constants_AppUrlConstants__ = __webpack_require__(64);






let

CreateMockSuccess = class CreateMockSuccess extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);
  }

  render() {
    if (this.props.mockStatus.loading) {
      return (
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-success__body step2' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__js_components_base_LoadingIndicator__["a" /* default */], null)));


    }

    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-success__body step2' },
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-success__content__header' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-success__content__header__icon' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__js_components_base_Icons_MockIcon__["a" /* default */], {
              className: 'create-mock-success__content__header__icon__mock',
              size: 'lg' })),


          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-success__content__header__text' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-success__content__header__text__title' }, 'Mock server created'),


            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-success__content__header__helper-text' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'create-mock-success__content__header__helper-text__entity-name' },
                this.props.selectedOptions.name), '\xA0has been created for',


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', { className: 'create-mock-success__content__header__helper-text__entity-name' }, '\xA0',
                this.props.selectedOptions.collectionName), '\xA0collection.'))),





        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'separator' }, 'Try it out:',

          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'separator-line' })),

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-success__content__footer' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-success__content__footer__title' }, 'To call the mock server:'),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-success__content__footer__step' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-success__content__footer__step__text' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Add examples responses to each request that the mock server will return.'),


              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__js_components_base_Buttons__["a" /* Button */], {
                  className: 'learn-more-link',
                  onClick: this.props.onOpenLink.bind(this, __WEBPACK_IMPORTED_MODULE_5__js_constants_AppUrlConstants__["D" /* EXAMPLE_DOCS */]),
                  type: 'text' }, '\xA0Learn what examples are and how to use them'))),






          this.props.selectedOptions.isPrivate &&
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-success__content__footer__step' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-success__content__footer__step__text' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Add an '),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('code', { className: 'create-mock-success__content__footer__step__text__markdown' }, 'x-api-key'),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, ' header to your requests. '),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__js_components_base_Buttons__["a" /* Button */], {
                  className: 'learn-more-link',
                  type: 'text',
                  onClick: this.props.onOpenLink.bind(this, __WEBPACK_IMPORTED_MODULE_5__js_constants_AppUrlConstants__["_0" /* PRO_API_KEYS_LINK */]) }, 'Generate Postman API key'))),






          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-success__content__footer__step' },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-success__content__footer__step__text' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, ' Then just send a request to the following URL, followed by the request path: '),
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__js_components_base_Buttons__["a" /* Button */], {
                  onClick: this.props.openRequestInTab,
                  type: 'text',
                  className: 'learn-more-link' },

                this.props.selectedOptions.mockUrl + '/')))),




        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'create-mock-form__body__footer__helptext' },
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('span', null, 'Note: calls to a mock server count against your plan\'s monthly call limits. Be sure to check your '),
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__js_components_base_Buttons__["a" /* Button */], {
              type: 'text',
              className: 'learn-more-link',
              onClick: __WEBPACK_IMPORTED_MODULE_4__js_models_services_DashboardService__["q" /* openPostmanUsages */] }, 'usage limits'), '.')));






  }};

/***/ }),

/***/ 5125:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (immutable) */ __webpack_exports__["a"] = createMock;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__js_modules_model_event__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__js_modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__js_stores_get_store__ = __webpack_require__(5);




function createMock(data) {
  let selectedEnvironment = null,
  uuid = `${_.get(data, 'ownerId')}-${_.get(data, 'collectionId')}`,
  mockData;

  if (!_.isEmpty(data.environmentId)) {
    let environment = Object(__WEBPACK_IMPORTED_MODULE_2__js_stores_get_store__["getStore"])('EnvironmentStore').find(data.environmentId);
    selectedEnvironment = environment.uid;
  }

  mockData = {
    collection: uuid,
    private: data.isPrivate,
    name: data.name,
    versionTag: data.versionId };


  if (selectedEnvironment) {
    mockData.environment = selectedEnvironment;
  }

  let mockCreateEvent = Object(__WEBPACK_IMPORTED_MODULE_0__js_modules_model_event__["a" /* createEvent */])('create', 'mock', mockData);

  return Object(__WEBPACK_IMPORTED_MODULE_1__js_modules_pipelines_user_action__["a" /* default */])(mockCreateEvent).then(mockEventResponse => {
    let mockEvent = Object(__WEBPACK_IMPORTED_MODULE_0__js_modules_model_event__["b" /* findEvents */])(mockEventResponse.response, {
      name: 'created',
      namespace: 'mock' }),

    mockData = Object(__WEBPACK_IMPORTED_MODULE_0__js_modules_model_event__["d" /* getEventData */])(_.head(mockEvent));

    return mockData;
  });
}
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5126:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (immutable) */ __webpack_exports__["a"] = editMock;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__js_modules_model_event__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__js_modules_pipelines_user_action__ = __webpack_require__(44);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__js_stores_get_store__ = __webpack_require__(5);




/**
                                                       * Dispatches action to edit mock
                                                       *
                                                       * @param  {object} data contains the following properties of the mock
                                                       * @param {String} data.environmentId
                                                       * @param {Boolean} data.isPrivate published status
                                                       * @param {String} data.name
                                                       * @param {String} data.versionId
                                                       * @param {String} data.mockId
                                                       * @param {String} data.collectionId
                                                       */
function editMock(data) {
  let selectedEnvironmentUID = !_.isEmpty(data.environmentId) ?
  Object(__WEBPACK_IMPORTED_MODULE_2__js_stores_get_store__["getStore"])('EnvironmentStore').find(data.environmentId).uid : null,
  collectionUID = Object(__WEBPACK_IMPORTED_MODULE_2__js_stores_get_store__["getStore"])('CollectionStore').find(data.collectionId).uid,
  mockData,
  mockEditEvent;

  mockData = {
    collection: collectionUID,
    environment: data.environmentId,
    private: data.isPrivate,
    name: data.name,
    versionTag: data.versionId,
    id: data.mockId };


  if (selectedEnvironmentUID) {
    mockData.environment = selectedEnvironmentUID;
  }

  mockEditEvent = Object(__WEBPACK_IMPORTED_MODULE_0__js_modules_model_event__["a" /* createEvent */])('update', 'mock', mockData);

  return Object(__WEBPACK_IMPORTED_MODULE_1__js_modules_pipelines_user_action__["a" /* default */])(mockEditEvent).then(mockEventResponse => {
    let mockEvent = Object(__WEBPACK_IMPORTED_MODULE_0__js_modules_model_event__["b" /* findEvents */])(mockEventResponse.response, {
      name: 'updated',
      namespace: 'mock' }),

    mockData = Object(__WEBPACK_IMPORTED_MODULE_0__js_modules_model_event__["d" /* getEventData */])(_.head(mockEvent));

    return mockData;
  });
}
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5127:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SwitchDeletedVersionModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__SwitchDeletedVersionModal__ = __webpack_require__(5128);
var _class;

let


SwitchDeletedVersionModalContainer = __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default()(_class = class SwitchDeletedVersionModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      onSave: null,
      onDiscard: null };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleSave = this.handleSave.bind(this);
    this.handleDiscard = this.handleDiscard.bind(this);
    this.handleClose = this.handleClose.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('showSwitchDeletedVersionModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showSwitchDeletedVersionModal', this.handleOpen);
  }

  handleOpen(onSave, onDiscard) {
    this.setState({
      isOpen: true,
      onSave: onSave,
      onDiscard: onDiscard });

  }

  handleClose() {
    this.setState({
      isOpen: false,
      onSave: null,
      onDiscard: null });

  }

  handleSave() {
    this.state.onSave && _.isFunction(this.state.onSave) && this.state.onSave();
    this.handleClose();
  }

  handleDiscard() {
    this.state.onDiscard && _.isFunction(this.state.onDiscard) && this.state.onDiscard();
    this.handleClose();
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__SwitchDeletedVersionModal__["a" /* default */], {
        isOpen: this.state.isOpen,
        onClose: this.handleClose,
        onSave: this.handleSave,
        onDiscard: this.handleDiscard }));


  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5128:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SwitchDeletedVersionModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__js_components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__js_components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__js_components_base_keymaps_KeyMaps__ = __webpack_require__(72);





const MODAL_BUTTON_SAVE = 'save',
MODAL_BUTTON_DISCARD = 'discard',
MODAL_BUTTON_CANCEL = 'cancel';let
SwitchDeletedVersionModal = class SwitchDeletedVersionModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = { focusedButton: MODAL_BUTTON_SAVE };

    this.handleClose = this.handleClose.bind(this);
    this.handleSave = this.handleSave.bind(this);
    this.handleDiscard = this.handleDiscard.bind(this);
    this.handleSwitchFocus = this.handleSwitchFocus.bind(this);
    this.handleFocusClick = this.handleFocusClick.bind(this);
    this.getKeyMapHandlers = this.getKeyMapHandlers.bind(this);
  }

  // to initially set focus on save button each time the modal is fired up
  componentWillReceiveProps() {
    this.setState({
      focusedButton: MODAL_BUTTON_SAVE },
    () => {
      // componentDidUpdate will get called before ref get attached to any children of the modal
      // thus waiting for the whole event loop for re-rendering to finish before calling focus on ref
      requestIdleCallback(() => {
        this.keyMapsRef && this.keyMapsRef.focus();
      });
    });
  }

  handleClose() {
    this.props.onClose && this.props.onClose();
  }

  handleSave() {
    this.props.onSave && this.props.onSave();
  }

  handleDiscard() {
    this.props.onDiscard && this.props.onDiscard();
  }

  getCustomStyles() {
    return { marginTop: '35vh' };
  }

  handleSwitchFocus(e) {
    e.stopPropagation();
    e.preventDefault();

    let tabOrder = [MODAL_BUTTON_DISCARD, MODAL_BUTTON_CANCEL, MODAL_BUTTON_SAVE],
    currentFocus = _.findIndex(tabOrder, tab => {return tab === this.state.focusedButton;}),
    nextFocus = tabOrder[(currentFocus + 1) % tabOrder.length];

    this.setState({ focusedButton: nextFocus });
  }

  handleFocusClick() {
    switch (this.state.focusedButton) {
      case MODAL_BUTTON_DISCARD:
        this.handleDiscard();
        break;
      case MODAL_BUTTON_CANCEL:
        this.handleClose();
        break;
      case MODAL_BUTTON_SAVE:
        this.handleSave();
        break;
      default:
        return;}

  }

  getKeyMapHandlers() {
    return {
      quit: pm.shortcuts.handle('quit', this.props.handleClose), // cancel closing tab
      select: pm.shortcuts.handle('select', this.handleFocusClick), // save and close
      submit: pm.shortcuts.handle('submit', this.handleFocusClick), // save and close
      space: pm.shortcuts.handle('space', this.handleFocusClick), // select whichever is highlighted
      focusNext: pm.shortcuts.handle('focusNext', this.handleSwitchFocus) // focus next item
    };
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__js_components_base_Modals__["a" /* Modal */], {
          isOpen: this.props.isOpen,
          onRequestClose: this.handleClose,
          className: 'unsaved-api-version-confirmation-modal',
          customStyles: this.getCustomStyles() },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__js_components_base_Modals__["d" /* ModalHeader */], null, 'DO YOU WANT TO SAVE?'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__js_components_base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, 'This version has unsaved changes. Save before switching versions to avoid losing your work.')),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__js_components_base_Modals__["c" /* ModalFooter */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__js_components_base_keymaps_KeyMaps__["a" /* default */], { keyMap: pm.shortcuts.getShortcuts(), handlers: this.getKeyMapHandlers(), ref: component => this.keyMapsRef = component },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'unsaved-api-version-confirmation-modal__footer' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'unsaved-api-version-confirmation-modal__footer__left' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__js_components_base_Buttons__["a" /* Button */], {
                    type: 'secondary',
                    onClick: this.handleDiscard,
                    focused: this.state.focusedButton === MODAL_BUTTON_DISCARD }, 'Don\'t Save')),




              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'unsaved-api-version-confirmation-modal__footer__right' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__js_components_base_Buttons__["a" /* Button */], {
                    type: 'primary',
                    onClick: this.handleSave,
                    focused: this.state.focusedButton === MODAL_BUTTON_SAVE }, 'Save Changes'),



                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__js_components_base_Buttons__["a" /* Button */], {
                    type: 'secondary',
                    onClick: this.handleClose,
                    focused: this.state.focusedButton === MODAL_BUTTON_CANCEL }, 'Cancel')))))));









  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5129:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SwitchConflictedVersionModalContainer; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__ = __webpack_require__(50);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_pure_render_decorator__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__SwitchConflictedVersionModal__ = __webpack_require__(5130);
var _class;

let


SwitchConflictedVersionModalContainer = __WEBPACK_IMPORTED_MODULE_1_pure_render_decorator___default()(_class = class SwitchConflictedVersionModalContainer extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
      onSave: null,
      onSaveAs: null };


    this.handleOpen = this.handleOpen.bind(this);
    this.handleSave = this.handleSave.bind(this);
    this.handleSaveAs = this.handleSaveAs.bind(this);
    this.handleClose = this.handleClose.bind(this);
  }

  componentWillMount() {
    pm.mediator.on('showSwitchConflictedVersionModal', this.handleOpen);
  }

  componentWillUnmount() {
    pm.mediator.off('showSwitchConflictedVersionModal', this.handleOpen);
  }

  handleOpen(onSave, onSaveAs) {
    this.setState({
      isOpen: true,
      onSave: onSave,
      onSaveAs: onSaveAs });

  }

  handleClose() {
    this.setState({
      isOpen: false,
      onSave: null,
      onSaveAs: null });

  }

  handleSave() {
    this.state.onSave && _.isFunction(this.state.onSave) && this.state.onSave();
    this.handleClose();
  }

  handleSaveAs() {
    this.state.onSaveAs && _.isFunction(this.state.onSaveAs) && this.state.onSaveAs();
    this.handleClose();
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__SwitchConflictedVersionModal__["a" /* default */], {
        isOpen: this.state.isOpen,
        onClose: this.handleClose,
        onSave: this.handleSave,
        onSaveAs: this.handleSaveAs }));


  }}) || _class;
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 5130:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(_) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SwitchConflictedVersionModal; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__js_components_base_Buttons__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__js_components_base_Modals__ = __webpack_require__(189);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__js_components_base_keymaps_KeyMaps__ = __webpack_require__(72);





const MODAL_BUTTON_SAVE = 'save',
MODAL_BUTTON_SAVEAS = 'saveas',
MODAL_BUTTON_CANCEL = 'cancel';let
SwitchConflictedVersionModal = class SwitchConflictedVersionModal extends __WEBPACK_IMPORTED_MODULE_0_react__["Component"] {
  constructor(props) {
    super(props);

    this.state = { focusedButton: MODAL_BUTTON_SAVE };

    this.handleClose = this.handleClose.bind(this);
    this.handleSave = this.handleSave.bind(this);
    this.handleSaveAs = this.handleSaveAs.bind(this);
    this.handleSwitchFocus = this.handleSwitchFocus.bind(this);
    this.handleFocusClick = this.handleFocusClick.bind(this);
    this.getKeyMapHandlers = this.getKeyMapHandlers.bind(this);
  }

  // to initially set focus on save button each time the modal is fired up
  componentWillReceiveProps() {
    this.setState({
      focusedButton: MODAL_BUTTON_SAVE },
    () => {
      // componentDidUpdate will get called before ref get attached to any children of the modal
      // thus waiting for the whole event loop for re-rendering to finish before calling focus on ref
      requestIdleCallback(() => {
        this.keyMapsRef && this.keyMapsRef.focus();
      });
    });
  }

  handleClose() {
    this.props.onClose && this.props.onClose();
  }

  handleSave() {
    this.props.onSave && this.props.onSave();
  }

  handleSaveAs() {
    this.props.onSaveAs && this.props.onSaveAs();
  }

  getCustomStyles() {
    return { marginTop: '35vh' };
  }

  handleSwitchFocus(e) {
    e.stopPropagation();
    e.preventDefault();

    let tabOrder = [MODAL_BUTTON_SAVEAS, MODAL_BUTTON_CANCEL, MODAL_BUTTON_SAVE],
    currentFocus = _.findIndex(tabOrder, tab => {return tab === this.state.focusedButton;}),
    nextFocus = tabOrder[(currentFocus + 1) % tabOrder.length];

    this.setState({ focusedButton: nextFocus });
  }

  handleFocusClick() {
    switch (this.state.focusedButton) {
      case MODAL_BUTTON_SAVEAS:
        this.handleSaveAs();
        break;
      case MODAL_BUTTON_CANCEL:
        this.handleClose();
        break;
      case MODAL_BUTTON_SAVE:
        this.handleSave();
        break;
      default:
        return;}

  }

  getKeyMapHandlers() {
    return {
      quit: pm.shortcuts.handle('quit', this.props.handleClose), // cancel closing tab
      select: pm.shortcuts.handle('select', this.handleFocusClick), // save and close
      submit: pm.shortcuts.handle('submit', this.handleFocusClick), // save and close
      space: pm.shortcuts.handle('space', this.handleFocusClick), // select whichever is highlighted
      focusNext: pm.shortcuts.handle('focusNext', this.handleSwitchFocus) // focus next item
    };
  }

  render() {
    return (
      __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__js_components_base_Modals__["a" /* Modal */], {
          isOpen: this.props.isOpen,
          onRequestClose: this.handleClose,
          className: 'unsaved-api-version-confirmation-modal',
          customStyles: this.getCustomStyles() },

        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__js_components_base_Modals__["d" /* ModalHeader */], null, 'DO YOU WANT TO SAVE?'),
        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__js_components_base_Modals__["b" /* ModalContent */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', null, 'This version has unsaved changes. Save before switching versions to avoid losing your work.')),


        __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2__js_components_base_Modals__["c" /* ModalFooter */], null,
          __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_3__js_components_base_keymaps_KeyMaps__["a" /* default */], { keyMap: pm.shortcuts.getShortcuts(), handlers: this.getKeyMapHandlers(), ref: component => this.keyMapsRef = component },
            __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'unsaved-api-version-confirmation-modal__footer' },
              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'unsaved-api-version-confirmation-modal__footer__left' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__js_components_base_Buttons__["a" /* Button */], {
                    type: 'secondary',
                    onClick: this.handleSaveAs,
                    focused: this.state.focusedButton === MODAL_BUTTON_SAVEAS }, 'Save as new API')),




              __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement('div', { className: 'unsaved-api-version-confirmation-modal__footer__right' },
                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__js_components_base_Buttons__["a" /* Button */], {
                    type: 'primary',
                    onClick: this.handleSave,
                    focused: this.state.focusedButton === MODAL_BUTTON_SAVE }, 'Save Changes'),



                __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_1__js_components_base_Buttons__["a" /* Button */], {
                    type: 'secondary',
                    onClick: this.handleClose,
                    focused: this.state.focusedButton === MODAL_BUTTON_CANCEL }, 'Cancel')))))));









  }};
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ }),

/***/ 537:
/***/ (function(module, exports, __webpack_require__) {

var baseMatches = __webpack_require__(1559),
    baseMatchesProperty = __webpack_require__(1575),
    identity = __webpack_require__(546),
    isArray = __webpack_require__(51),
    property = __webpack_require__(1578);

/**
 * The base implementation of `_.iteratee`.
 *
 * @private
 * @param {*} [value=_.identity] The value to convert to an iteratee.
 * @returns {Function} Returns the iteratee.
 */
function baseIteratee(value) {
  // Don't store the `typeof` result in a variable to avoid a JIT bug in Safari 9.
  // See https://bugs.webkit.org/show_bug.cgi?id=156034 for more details.
  if (typeof value == 'function') {
    return value;
  }
  if (value == null) {
    return identity;
  }
  if (typeof value == 'object') {
    return isArray(value)
      ? baseMatchesProperty(value[0], value[1])
      : baseMatches(value);
  }
  return property(value);
}

module.exports = baseIteratee;


/***/ }),

/***/ 538:
/***/ (function(module, exports, __webpack_require__) {

var assignValue = __webpack_require__(977),
    baseAssignValue = __webpack_require__(996);

/**
 * Copies properties of `source` to `object`.
 *
 * @private
 * @param {Object} source The object to copy properties from.
 * @param {Array} props The property identifiers to copy.
 * @param {Object} [object={}] The object to copy properties to.
 * @param {Function} [customizer] The function to customize copied values.
 * @returns {Object} Returns `object`.
 */
function copyObject(source, props, object, customizer) {
  var isNew = !object;
  object || (object = {});

  var index = -1,
      length = props.length;

  while (++index < length) {
    var key = props[index];

    var newValue = customizer
      ? customizer(object[key], source[key], key, object, source)
      : undefined;

    if (newValue === undefined) {
      newValue = source[key];
    }
    if (isNew) {
      baseAssignValue(object, key, newValue);
    } else {
      assignValue(object, key, newValue);
    }
  }
  return object;
}

module.exports = copyObject;


/***/ }),

/***/ 539:
/***/ (function(module, exports, __webpack_require__) {

var isSymbol = __webpack_require__(660);

/** Used as references for various `Number` constants. */
var INFINITY = 1 / 0;

/**
 * Converts `value` to a string key if it's not a string or symbol.
 *
 * @private
 * @param {*} value The value to inspect.
 * @returns {string|symbol} Returns the key.
 */
function toKey(value) {
  if (typeof value == 'string' || isSymbol(value)) {
    return value;
  }
  var result = (value + '');
  return (result == '0' && (1 / value) == -INFINITY) ? '-0' : result;
}

module.exports = toKey;


/***/ }),

/***/ 540:
/***/ (function(module, exports, __webpack_require__) {

var baseForOwn = __webpack_require__(995),
    createBaseEach = __webpack_require__(1583);

/**
 * The base implementation of `_.forEach` without support for iteratee shorthands.
 *
 * @private
 * @param {Array|Object} collection The collection to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array|Object} Returns `collection`.
 */
var baseEach = createBaseEach(baseForOwn);

module.exports = baseEach;


/***/ }),

/***/ 660:
/***/ (function(module, exports, __webpack_require__) {

var baseGetTag = __webpack_require__(105),
    isObjectLike = __webpack_require__(84);

/** `Object#toString` result references. */
var symbolTag = '[object Symbol]';

/**
 * Checks if `value` is classified as a `Symbol` primitive or object.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
 * @example
 *
 * _.isSymbol(Symbol.iterator);
 * // => true
 *
 * _.isSymbol('abc');
 * // => false
 */
function isSymbol(value) {
  return typeof value == 'symbol' ||
    (isObjectLike(value) && baseGetTag(value) == symbolTag);
}

module.exports = isSymbol;


/***/ }),

/***/ 664:
/***/ (function(module, exports, __webpack_require__) {

var isArray = __webpack_require__(51),
    isSymbol = __webpack_require__(660);

/** Used to match property names within property paths. */
var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,
    reIsPlainProp = /^\w*$/;

/**
 * Checks if `value` is a property name and not a property path.
 *
 * @private
 * @param {*} value The value to check.
 * @param {Object} [object] The object to query keys on.
 * @returns {boolean} Returns `true` if `value` is a property name, else `false`.
 */
function isKey(value, object) {
  if (isArray(value)) {
    return false;
  }
  var type = typeof value;
  if (type == 'number' || type == 'symbol' || type == 'boolean' ||
      value == null || isSymbol(value)) {
    return true;
  }
  return reIsPlainProp.test(value) || !reIsDeepProp.test(value) ||
    (object != null && value in Object(object));
}

module.exports = isKey;


/***/ }),

/***/ 665:
/***/ (function(module, exports, __webpack_require__) {

var ListCache = __webpack_require__(542),
    stackClear = __webpack_require__(1561),
    stackDelete = __webpack_require__(1562),
    stackGet = __webpack_require__(1563),
    stackHas = __webpack_require__(1564),
    stackSet = __webpack_require__(1565);

/**
 * Creates a stack cache object to store key-value pairs.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function Stack(entries) {
  var data = this.__data__ = new ListCache(entries);
  this.size = data.size;
}

// Add methods to `Stack`.
Stack.prototype.clear = stackClear;
Stack.prototype['delete'] = stackDelete;
Stack.prototype.get = stackGet;
Stack.prototype.has = stackHas;
Stack.prototype.set = stackSet;

module.exports = Stack;


/***/ }),

/***/ 666:
/***/ (function(module, exports, __webpack_require__) {

var arrayFilter = __webpack_require__(668),
    stubArray = __webpack_require__(991);

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Built-in value references. */
var propertyIsEnumerable = objectProto.propertyIsEnumerable;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeGetSymbols = Object.getOwnPropertySymbols;

/**
 * Creates an array of the own enumerable symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of symbols.
 */
var getSymbols = !nativeGetSymbols ? stubArray : function(object) {
  if (object == null) {
    return [];
  }
  object = Object(object);
  return arrayFilter(nativeGetSymbols(object), function(symbol) {
    return propertyIsEnumerable.call(object, symbol);
  });
};

module.exports = getSymbols;


/***/ }),

/***/ 667:
/***/ (function(module, exports, __webpack_require__) {

var Uint8Array = __webpack_require__(988);

/**
 * Creates a clone of `arrayBuffer`.
 *
 * @private
 * @param {ArrayBuffer} arrayBuffer The array buffer to clone.
 * @returns {ArrayBuffer} Returns the cloned array buffer.
 */
function cloneArrayBuffer(arrayBuffer) {
  var result = new arrayBuffer.constructor(arrayBuffer.byteLength);
  new Uint8Array(result).set(new Uint8Array(arrayBuffer));
  return result;
}

module.exports = cloneArrayBuffer;


/***/ }),

/***/ 672:
/***/ (function(module, exports) {

/**
 * A specialized version of `_.forEach` for arrays without support for
 * iteratee shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns `array`.
 */
function arrayEach(array, iteratee) {
  var index = -1,
      length = array == null ? 0 : array.length;

  while (++index < length) {
    if (iteratee(array[index], index, array) === false) {
      break;
    }
  }
  return array;
}

module.exports = arrayEach;


/***/ }),

/***/ 976:
/***/ (function(module, exports, __webpack_require__) {

var baseIsEqualDeep = __webpack_require__(1566),
    isObjectLike = __webpack_require__(84);

/**
 * The base implementation of `_.isEqual` which supports partial comparisons
 * and tracks traversed objects.
 *
 * @private
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @param {boolean} bitmask The bitmask flags.
 *  1 - Unordered comparison
 *  2 - Partial comparison
 * @param {Function} [customizer] The function to customize comparisons.
 * @param {Object} [stack] Tracks traversed `value` and `other` objects.
 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
 */
function baseIsEqual(value, other, bitmask, customizer, stack) {
  if (value === other) {
    return true;
  }
  if (value == null || other == null || (!isObjectLike(value) && !isObjectLike(other))) {
    return value !== value && other !== other;
  }
  return baseIsEqualDeep(value, other, bitmask, customizer, baseIsEqual, stack);
}

module.exports = baseIsEqual;


/***/ }),

/***/ 977:
/***/ (function(module, exports, __webpack_require__) {

var baseAssignValue = __webpack_require__(996),
    eq = __webpack_require__(368);

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Assigns `value` to `key` of `object` if the existing value is not equivalent
 * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
 * for equality comparisons.
 *
 * @private
 * @param {Object} object The object to modify.
 * @param {string} key The key of the property to assign.
 * @param {*} value The value to assign.
 */
function assignValue(object, key, value) {
  var objValue = object[key];
  if (!(hasOwnProperty.call(object, key) && eq(objValue, value)) ||
      (value === undefined && !(key in object))) {
    baseAssignValue(object, key, value);
  }
}

module.exports = assignValue;


/***/ }),

/***/ 985:
/***/ (function(module, exports, __webpack_require__) {

var castPath = __webpack_require__(986),
    toKey = __webpack_require__(539);

/**
 * The base implementation of `_.get` without support for default values.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Array|string} path The path of the property to get.
 * @returns {*} Returns the resolved value.
 */
function baseGet(object, path) {
  path = castPath(path, object);

  var index = 0,
      length = path.length;

  while (object != null && index < length) {
    object = object[toKey(path[index++])];
  }
  return (index && index == length) ? object : undefined;
}

module.exports = baseGet;


/***/ }),

/***/ 986:
/***/ (function(module, exports, __webpack_require__) {

var isArray = __webpack_require__(51),
    isKey = __webpack_require__(664),
    stringToPath = __webpack_require__(1555),
    toString = __webpack_require__(1557);

/**
 * Casts `value` to a path array if it's not one.
 *
 * @private
 * @param {*} value The value to inspect.
 * @param {Object} [object] The object to query keys on.
 * @returns {Array} Returns the cast property path array.
 */
function castPath(value, object) {
  if (isArray(value)) {
    return value;
  }
  return isKey(value, object) ? [value] : stringToPath(toString(value));
}

module.exports = castPath;


/***/ }),

/***/ 987:
/***/ (function(module, exports, __webpack_require__) {

var SetCache = __webpack_require__(556),
    arraySome = __webpack_require__(1567),
    cacheHas = __webpack_require__(557);

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG = 1,
    COMPARE_UNORDERED_FLAG = 2;

/**
 * A specialized version of `baseIsEqualDeep` for arrays with support for
 * partial deep comparisons.
 *
 * @private
 * @param {Array} array The array to compare.
 * @param {Array} other The other array to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} stack Tracks traversed `array` and `other` objects.
 * @returns {boolean} Returns `true` if the arrays are equivalent, else `false`.
 */
function equalArrays(array, other, bitmask, customizer, equalFunc, stack) {
  var isPartial = bitmask & COMPARE_PARTIAL_FLAG,
      arrLength = array.length,
      othLength = other.length;

  if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
    return false;
  }
  // Assume cyclic values are equal.
  var stacked = stack.get(array);
  if (stacked && stack.get(other)) {
    return stacked == other;
  }
  var index = -1,
      result = true,
      seen = (bitmask & COMPARE_UNORDERED_FLAG) ? new SetCache : undefined;

  stack.set(array, other);
  stack.set(other, array);

  // Ignore non-index properties.
  while (++index < arrLength) {
    var arrValue = array[index],
        othValue = other[index];

    if (customizer) {
      var compared = isPartial
        ? customizer(othValue, arrValue, index, other, array, stack)
        : customizer(arrValue, othValue, index, array, other, stack);
    }
    if (compared !== undefined) {
      if (compared) {
        continue;
      }
      result = false;
      break;
    }
    // Recursively compare arrays (susceptible to call stack limits).
    if (seen) {
      if (!arraySome(other, function(othValue, othIndex) {
            if (!cacheHas(seen, othIndex) &&
                (arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
              return seen.push(othIndex);
            }
          })) {
        result = false;
        break;
      }
    } else if (!(
          arrValue === othValue ||
            equalFunc(arrValue, othValue, bitmask, customizer, stack)
        )) {
      result = false;
      break;
    }
  }
  stack['delete'](array);
  stack['delete'](other);
  return result;
}

module.exports = equalArrays;


/***/ }),

/***/ 988:
/***/ (function(module, exports, __webpack_require__) {

var root = __webpack_require__(97);

/** Built-in value references. */
var Uint8Array = root.Uint8Array;

module.exports = Uint8Array;


/***/ }),

/***/ 989:
/***/ (function(module, exports, __webpack_require__) {

var baseGetAllKeys = __webpack_require__(990),
    getSymbols = __webpack_require__(666),
    keys = __webpack_require__(135);

/**
 * Creates an array of own enumerable property names and symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names and symbols.
 */
function getAllKeys(object) {
  return baseGetAllKeys(object, keys, getSymbols);
}

module.exports = getAllKeys;


/***/ }),

/***/ 990:
/***/ (function(module, exports, __webpack_require__) {

var arrayPush = __webpack_require__(669),
    isArray = __webpack_require__(51);

/**
 * The base implementation of `getAllKeys` and `getAllKeysIn` which uses
 * `keysFunc` and `symbolsFunc` to get the enumerable property names and
 * symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Function} keysFunc The function to get the keys of `object`.
 * @param {Function} symbolsFunc The function to get the symbols of `object`.
 * @returns {Array} Returns the array of property names and symbols.
 */
function baseGetAllKeys(object, keysFunc, symbolsFunc) {
  var result = keysFunc(object);
  return isArray(object) ? result : arrayPush(result, symbolsFunc(object));
}

module.exports = baseGetAllKeys;


/***/ }),

/***/ 991:
/***/ (function(module, exports) {

/**
 * This method returns a new empty array.
 *
 * @static
 * @memberOf _
 * @since 4.13.0
 * @category Util
 * @returns {Array} Returns the new empty array.
 * @example
 *
 * var arrays = _.times(2, _.stubArray);
 *
 * console.log(arrays);
 * // => [[], []]
 *
 * console.log(arrays[0] === arrays[1]);
 * // => false
 */
function stubArray() {
  return [];
}

module.exports = stubArray;


/***/ }),

/***/ 992:
/***/ (function(module, exports, __webpack_require__) {

var isObject = __webpack_require__(98);

/**
 * Checks if `value` is suitable for strict equality comparisons, i.e. `===`.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` if suitable for strict
 *  equality comparisons, else `false`.
 */
function isStrictComparable(value) {
  return value === value && !isObject(value);
}

module.exports = isStrictComparable;


/***/ }),

/***/ 993:
/***/ (function(module, exports) {

/**
 * A specialized version of `matchesProperty` for source values suitable
 * for strict equality comparisons, i.e. `===`.
 *
 * @private
 * @param {string} key The key of the property to get.
 * @param {*} srcValue The value to match.
 * @returns {Function} Returns the new spec function.
 */
function matchesStrictComparable(key, srcValue) {
  return function(object) {
    if (object == null) {
      return false;
    }
    return object[key] === srcValue &&
      (srcValue !== undefined || (key in Object(object)));
  };
}

module.exports = matchesStrictComparable;


/***/ }),

/***/ 994:
/***/ (function(module, exports) {

/**
 * The base implementation of `_.property` without support for deep paths.
 *
 * @private
 * @param {string} key The key of the property to get.
 * @returns {Function} Returns the new accessor function.
 */
function baseProperty(key) {
  return function(object) {
    return object == null ? undefined : object[key];
  };
}

module.exports = baseProperty;


/***/ }),

/***/ 995:
/***/ (function(module, exports, __webpack_require__) {

var baseFor = __webpack_require__(1581),
    keys = __webpack_require__(135);

/**
 * The base implementation of `_.forOwn` without support for iteratee shorthands.
 *
 * @private
 * @param {Object} object The object to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Object} Returns `object`.
 */
function baseForOwn(object, iteratee) {
  return object && baseFor(object, iteratee, keys);
}

module.exports = baseForOwn;


/***/ }),

/***/ 996:
/***/ (function(module, exports, __webpack_require__) {

var defineProperty = __webpack_require__(1011);

/**
 * The base implementation of `assignValue` and `assignMergeValue` without
 * value checks.
 *
 * @private
 * @param {Object} object The object to modify.
 * @param {string} key The key of the property to assign.
 * @param {*} value The value to assign.
 */
function baseAssignValue(object, key, value) {
  if (key == '__proto__' && defineProperty) {
    defineProperty(object, key, {
      'configurable': true,
      'enumerable': true,
      'value': value,
      'writable': true
    });
  } else {
    object[key] = value;
  }
}

module.exports = baseAssignValue;


/***/ }),

/***/ 997:
/***/ (function(module, exports, __webpack_require__) {

var arrayPush = __webpack_require__(669),
    getPrototype = __webpack_require__(545),
    getSymbols = __webpack_require__(666),
    stubArray = __webpack_require__(991);

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeGetSymbols = Object.getOwnPropertySymbols;

/**
 * Creates an array of the own and inherited enumerable symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of symbols.
 */
var getSymbolsIn = !nativeGetSymbols ? stubArray : function(object) {
  var result = [];
  while (object) {
    arrayPush(result, getSymbols(object));
    object = getPrototype(object);
  }
  return result;
};

module.exports = getSymbolsIn;


/***/ })

});